/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],I=0,L=te.length;I<L;I++)e[I]=oe[te[I]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const N=new Map,A=new Map,D=new Map,R=new Map;function k(c,d){c.has(d.detail)||c.set(d.detail,-d.timestamp)}function g(c,d){const p=c.get(d.detail);p&&(p>=0||c.set(d.detail,p+d.timestamp))}let C=[];typeof te=="function"&&typeof te.getStats=="function"&&(C=te.getStats().slice(0).sort((c,d)=>c.timestamp-d.timestamp));for(const c of C)switch(c.type){case 10:k(N,c);break;case 11:case 12:g(N,c);break;case 21:k(A,c);break;case 22:g(A,c);break;case 33:k(D,c);break;case 34:g(D,c);break;case 31:k(R,c);break;case 32:g(R,c);break}let E=0;D.forEach(c=>E+=c);function m(c){const d=[];return c.forEach((p,y)=>d.push([y,p])),d}return{amdLoad:m(N),amdInvoke:m(A),nodeRequire:m(D),nodeEval:m(R),nodeRequireTotal:E}}static toMarkdownTable(N,A){let D="";const R=[];return N.forEach((k,g)=>{R[g]=k.length}),A.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const E=g.toString().length;R[C]=Math.max(E,R[C])})}),N.forEach((k,g)=>{D+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),D+=`|
`,N.forEach((k,g)=>{D+=`| ${"-".repeat(R[g])} `}),D+=`|
`,A.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(D+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),D+=`|
`}),D}}e.$U=I}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function I(p,y,l){const h=L(p,y);if(h!==-1)return p[h]}e.$fb=I;function L(p,y,l=p.length-1){for(let h=l;h>=0;h--){const u=p[h];if(y(u))return h}return-1}e.$gb=L;function N(p,y){const l=A(p,y);return l===-1?void 0:p[l]}e.$hb=N;function A(p,y,l=0,h=p.length){let u=l,b=h;for(;u<b;){const S=Math.floor((u+b)/2);y(p[S])?u=S+1:b=S}return u-1}e.$ib=A;function D(p,y){const l=R(p,y);return l===p.length?void 0:p[l]}e.$jb=D;function R(p,y,l=0,h=p.length){let u=l,b=h;for(;u<b;){const S=Math.floor((u+b)/2);y(p[S])?b=S:u=S+1}return u}e.$kb=R;function k(p,y,l=0,h=p.length){const u=R(p,y,l,h);return u===p.length?-1:u}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(g.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!y(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const l=A(this.e,y,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function C(p,y){if(p.length===0)return;let l=p[0];for(let h=1;h<p.length;h++){const u=p[h];y(u,l)>0&&(l=u)}return l}e.$nb=C;function E(p,y){if(p.length===0)return;let l=p[0];for(let h=1;h<p.length;h++){const u=p[h];y(u,l)>=0&&(l=u)}return l}e.$ob=E;function m(p,y){return C(p,(l,h)=>-y(l,h))}e.$pb=m;function c(p,y){if(p.length===0)return-1;let l=0;for(let h=1;h<p.length;h++){const u=p[h];y(u,p[l])>0&&(l=h)}return l}e.$qb=c;function d(p,y){for(const l of p){const h=y(l);if(h!==void 0)return h}}e.$rb=d}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(D,R){const k=Object.create(null);for(const g of D){const C=R(g);let E=k[C];E||(E=k[C]=[]),E.push(g)}return k}e.$J=I;function L(D,R){const k=[],g=[];for(const C of D)R.has(C)||k.push(C);for(const C of R)D.has(C)||g.push(C);return{removed:k,added:g}}e.$K=L;function N(D,R){const k=[],g=[];for(const[C,E]of D)R.has(C)||k.push(E);for(const[C,E]of R)D.has(C)||g.push(E);return{removed:k,added:g}}e.$L=N;function A(D,R){const k=new Set;for(const g of R)D.has(g)&&k.add(g);return k}e.$M=A}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function I(D){return(R,k,g)=>{let C=null,E=null;if(typeof g.value=="function"?(C="value",E=g.value):typeof g.get=="function"&&(C="get",E=g.get),!E)throw new Error("not supported");g[C]=D(E,k)}}function L(D,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;k[g]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[E]}}e.$hh=L;function N(D,R,k){return I((g,C)=>{const E=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...c){this[m]||(this[m]=k?k():void 0),clearTimeout(this[E]),R&&(this[m]=R(this[m],...c),c=[this[m]]),this[E]=setTimeout(()=>{g.apply(this,c),this[m]=k?k():void 0},D)}})}e.$ih=N;function A(D,R,k){return I((g,C)=>{const E=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,c=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...p){if(this[m]||(this[m]=k?k():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...p)),this[d])return;const y=this[c]+D;y<=Date.now()?(this[c]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[c]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0},y-Date.now()))}})}e.$jh=A}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class I{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$W=I,e.$X=new I;function L(S){e.$X.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=L;function N(S){if(!S||typeof S!="object")return!1;const s=S;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Z=N;function A(S){g(S)||e.$X.onUnexpectedError(S)}e.$1=A;function D(S){g(S)||e.$X.onUnexpectedExternalError(S)}e.$2=D;function R(S){if(S instanceof Error){const{name:s,message:a}=S,n=S.stacktrace||S.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:u.isErrorNoTelemetry(S)}}return S}e.$3=R;const k="Canceled";function g(S){return S instanceof C?!0:S instanceof Error&&S.name===k&&S.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function E(){const S=new Error(k);return S.name=S.message,S}e.$6=E;function m(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.$7=m;function c(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.$8=c;class d extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function p(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.$0=p;class y extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$$=y;class l extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$_=l;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=h;class u extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof u)return s;const a=new u;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$bb=u;class b extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$cb=b}),define(oe[18],ae([0,1,8,125]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function N(M,V=0){return M[M.length-(1+V)]}e.$sb=N;function A(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.$tb=A;function D(M,V,J=(re,ce)=>re===ce){if(M===V)return!0;if(!M||!V||M.length!==V.length)return!1;for(let re=0,ce=M.length;re<ce;re++)if(!J(M[re],V[re]))return!1;return!0}e.$ub=D;function R(M,V){const J=M.length-1;V<J&&(M[V]=M[J]),M.pop()}e.$vb=R;function k(M,V,J){return g(M.length,re=>J(M[re],V))}e.$wb=k;function g(M,V){let J=0,re=M-1;for(;J<=re;){const ce=(J+re)/2|0,ue=V(ce);if(ue<0)J=ce+1;else if(ue>0)re=ce-1;else return ce}return-(J+1)}e.$xb=g;function C(M,V,J){if(M=M|0,M>=V.length)throw new TypeError("invalid index");const re=V[Math.floor(V.length*Math.random())],ce=[],ue=[],he=[];for(const $e of V){const de=J($e,re);de<0?ce.push($e):de>0?ue.push($e):he.push($e)}return M<ce.length?C(M,ce,J):M<ce.length+he.length?he[0]:C(M-(ce.length+he.length),ue,J)}e.$yb=C;function E(M,V){const J=[];let re;for(const ce of M.slice(0).sort(V))!re||V(re[0],ce)!==0?(re=[ce],J.push(re)):re.push(ce);return J}e.$zb=E;function*m(M,V){let J,re;for(const ce of M)re!==void 0&&V(re,ce)?J.push(ce):(J&&(yield J),J=[ce]),re=ce;J&&(yield J)}e.$Ab=m;function c(M,V){for(let J=0;J<=M.length;J++)V(J===0?void 0:M[J-1],J===M.length?void 0:M[J])}e.$Bb=c;function d(M,V){for(let J=0;J<M.length;J++)V(J===0?void 0:M[J-1],M[J],J+1===M.length?void 0:M[J+1])}e.$Cb=d;function p(M,V,J){const re=[];function ce($e,de,we){if(de===0&&we.length===0)return;const Ee=re[re.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=de,Ee.toInsert.push(...we)):re.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===M.length){ce(ue,0,V.slice(he));break}if(he===V.length){ce(ue,M.length-ue,[]);break}const $e=M[ue],de=V[he],we=J($e,de);we===0?(ue+=1,he+=1):we<0?(ce(ue,1,[]),ue+=1):we>0&&(ce(ue,0,[de]),he+=1)}return re}e.$Db=p;function y(M,V,J){const re=p(M,V,J),ce=[],ue=[];for(const he of re)ce.push(...M.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:ce,added:ue}}e.$Eb=y;function l(M,V,J){if(J===0)return[];const re=M.slice(0,J).sort(V);return u(M,V,re,J,M.length),re}e.top=l;function h(M,V,J,re,ce){return J===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=M.length,de=M.slice(0,J).sort(V);for(let we=J,Ee=Math.min(J+re,$e);we<$e;we=Ee,Ee=Math.min(Ee+re,$e)){if(we>J&&await new Promise(Ie=>setTimeout(Ie)),ce&&ce.isCancellationRequested)throw new I.$5;u(M,V,de,we,Ee)}return de})().then(ue,he)})}e.$Gb=h;function u(M,V,J,re,ce){for(const ue=J.length;re<ce;re++){const he=M[re];if(V(he,J[ue-1])<0){J.pop();const $e=(0,L.$kb)(J,de=>V(he,de)<0);J.splice($e,0,he)}}}function b(M){return M.filter(V=>!!V)}e.$Hb=b;function S(M){let V=0;for(let J=0;J<M.length;J++)M[J]&&(M[V]=M[J],V+=1);M.length=V}e.$Ib=S;function s(M,V,J){M.splice(J,0,M.splice(V,1)[0])}e.$Jb=s;function a(M){return!Array.isArray(M)||M.length===0}e.$Kb=a;function n(M){return Array.isArray(M)&&M.length>0}e.$Lb=n;function i(M,V=J=>J){const J=new Set;return M.filter(re=>{const ce=V(re);return J.has(ce)?!1:(J.add(ce),!0)})}e.$Mb=i;function t(M){const V=new Set;return J=>{const re=M(J);return V.has(re)?!1:(V.add(re),!0)}}e.$Nb=t;function r(M,V){return M.length>0?M[0]:V}e.$Ob=r;function o(M,V){return M.length>0?M[M.length-1]:V}e.$Pb=o;function v(M,V,J=(re,ce)=>re===ce){let re=0;for(let ce=0,ue=Math.min(M.length,V.length);ce<ue&&J(M[ce],V[ce]);ce++)re++;return re}e.$Qb=v;function w(M){return[].concat(...M)}e.$Rb=w;function f(M,V){let J=typeof V=="number"?M:0;typeof V=="number"?J=M:(J=0,V=M);const re=[];if(J<=V)for(let ce=J;ce<V;ce++)re.push(ce);else for(let ce=J;ce>V;ce--)re.push(ce);return re}e.$Sb=f;function $(M,V,J){return M.reduce((re,ce)=>(re[V(ce)]=J?J(ce):ce,re),Object.create(null))}e.$Tb=$;function j(M,V){return M.push(V),()=>F(M,V)}e.$Ub=j;function F(M,V){const J=M.indexOf(V);if(J>-1)return M.splice(J,1),V}e.$Vb=F;function z(M,V,J){const re=M.slice(0,V),ce=M.slice(V);return re.concat(J,ce)}e.$Wb=z;function U(M,V){let J;if(typeof V=="number"){let re=V;J=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else J=Math.random;for(let re=M.length-1;re>0;re-=1){const ce=Math.floor(J()*(re+1)),ue=M[re];M[re]=M[ce],M[ce]=ue}}e.$Xb=U;function q(M,V){const J=M.indexOf(V);J>-1&&(M.splice(J,1),M.unshift(V))}e.$Yb=q;function Z(M,V){const J=M.indexOf(V);J>-1&&(M.splice(J,1),M.push(V))}e.$Zb=Z;function K(M,V){for(const J of V)M.push(J)}e.$1b=K;function x(M,V){return Array.isArray(M)?M.map(V):V(M)}e.$2b=x;function H(M){return Array.isArray(M)?M:[M]}e.$3b=H;function Q(M){return M[Math.floor(Math.random()*M.length)]}e.$4b=Q;function G(M,V,J){const re=ee(M,V),ce=M.length,ue=J.length;M.length=ce+ue;for(let he=ce-1;he>=re;he--)M[he+ue]=M[he];for(let he=0;he<ue;he++)M[he+re]=J[he]}e.$5b=G;function W(M,V,J,re){const ce=ee(M,V);let ue=M.splice(ce,J);return ue===void 0&&(ue=[]),G(M,ce,re),ue}e.$6b=W;function ee(M,V){return V<0?Math.max(V+M.length,0):Math.min(V,M.length)}var ne;(function(M){function V(ue){return ue<0}M.isLessThan=V;function J(ue){return ue<=0}M.isLessThanOrEqual=J;function re(ue){return ue>0}M.isGreaterThan=re;function ce(ue){return ue===0}M.isNeitherLessOrGreaterThan=ce,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(M,V){return(J,re)=>V(M(J),M(re))}e.$7b=_;function ie(...M){return(V,J)=>{for(const re of M){const ce=re(V,J);if(!ne.isNeitherLessOrGreaterThan(ce))return ce}return ne.neitherLessOrGreaterThan}}e.$8b=ie;const X=(M,V)=>M-V;e.$9b=X;const B=(M,V)=>(0,e.$9b)(M?1:0,V?1:0);e.$0b=B;function P(M){return(V,J)=>-M(V,J)}e.$$b=P;class O{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let J=this.c;for(;J<this.g.length&&V(this.g[J]);)J++;const re=J===this.c?null:this.g.slice(this.c,J);return this.c=J,re}takeFromEndWhile(V){let J=this.d;for(;J>=0&&V(this.g[J]);)J--;const re=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,re}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const J=this.g.slice(this.c,this.c+V);return this.c+=V,J}}e.$_b=O;class T{static{this.empty=new T(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(J=>(V(J),!0))}toArray(){const V=[];return this.iterate(J=>(V.push(J),!0)),V}filter(V){return new T(J=>this.iterate(re=>V(re)?J(re):!0))}map(V){return new T(J=>this.iterate(re=>J(V(re))))}some(V){let J=!1;return this.iterate(re=>(J=V(re),!J)),J}findFirst(V){let J;return this.iterate(re=>V(re)?(J=re,!1):!0),J}findLast(V){let J;return this.iterate(re=>(V(re)&&(J=re),!0)),J}findLastMaxBy(V){let J,re=!0;return this.iterate(ce=>((re||ne.isGreaterThan(V(ce,J)))&&(re=!1,J=ce),!0)),J}}e.$ac=T}),define(oe[127],ae([0,1,8]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function L(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=L;function N(k,g="Unreachable"){throw new Error(g)}e.$4c=N;function A(k){if(!k)throw new I.$cb("Assertion Failed")}e.$5c=A;function D(k){if(!k()){debugger;k(),(0,I.$1)(new I.$cb("Assertion Failed"))}}e.$6c=D;function R(k,g){let C=0;for(;C<k.length-1;){const E=k[C],m=k[C+1];if(!g(E,m))return!1;C++}return!0}e.$7c=R}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function I(L){const N=this;let A=!1,D;return function(){return A||(A=!0,D=L.apply(N,arguments)),D}}e.$db=I}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function N(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}L.is=N;const A=Object.freeze([]);function D(){return A}L.empty=D;function*R(S){yield S}L.single=R;function k(S){return N(S)?S:R(S)}L.wrap=k;function g(S){return S||A}L.from=g;function*C(S){for(let s=S.length-1;s>=0;s--)yield S[s]}L.reverse=C;function E(S){return!S||S[Symbol.iterator]().next().done===!0}L.isEmpty=E;function m(S){return S[Symbol.iterator]().next().value}L.first=m;function c(S,s){for(const a of S)if(s(a))return!0;return!1}L.some=c;function d(S,s){for(const a of S)if(s(a))return a}L.find=d;function*p(S,s){for(const a of S)s(a)&&(yield a)}L.filter=p;function*y(S,s){let a=0;for(const n of S)yield s(n,a++)}L.map=y;function*l(...S){for(const s of S)for(const a of s)yield a}L.concat=l;function h(S,s,a){let n=a;for(const i of S)n=s(n,i);return n}L.reduce=h;function*u(S,s,a=S.length){for(s<0&&(s+=S.length),a<0?a+=S.length:a>S.length&&(a=S.length);s<a;s++)yield S[s]}L.slice=u;function b(S,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,S];const n=S[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,L.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}L.consume=b})(I||(e.Iterable=I={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var N;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function D(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function w(q){let Z=0,K=0;for(;Z<q;){const x=s.charCodeAt(n);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;n++,Z++}return Z<q&&(K=-1),K}function f(q){n=q,t="",r=0,o=16,v=0}function $(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&g(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&g(s.charCodeAt(n)))for(n++;n<s.length&&g(s.charCodeAt(n));)n++;else return v=3,s.substring(q,n);let Z=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&g(s.charCodeAt(n))){for(n++;n<s.length&&g(s.charCodeAt(n));)n++;Z=n}else v=3;return s.substring(q,Z)}function j(){let q="",Z=n;for(;;){if(n>=i){q+=s.substring(Z,n),v=2;break}const K=s.charCodeAt(n);if(K===34){q+=s.substring(Z,n),n++;break}if(K===92){if(q+=s.substring(Z,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const H=w(4);H>=0?q+=String.fromCharCode(H):v=4;break}default:v=5}Z=n;continue}if(K>=0&&K<=31)if(k(K)){q+=s.substring(Z,n),v=2;break}else v=6;n++}return q}function F(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let q=s.charCodeAt(n);if(R(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(R(q));return o=15}if(k(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(q){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=j(),o=10;case 47:{const Z=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!k(s.charCodeAt(n));)n++;return t=s.substring(Z,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const K=i-1;let x=!1;for(;n<K;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Z,n),o=13}return t+=String.fromCharCode(q),n++,o=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!g(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=$(),o=11;default:for(;n<i&&z(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(q),n++,o=16}}function z(q){if(R(q)||k(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let q;do q=F();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>n,scan:a?U:F,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Um=D;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function k(s){return s===10||s===13||s===8232||s===8233}function g(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(w,f,$,j){r.value=w,r.offset=f,r.length=$,r.type=j,r.colonOffset=void 0,t=r}try{u(s,{onObjectBegin:(w,f)=>{if(a<=w)throw i;t=void 0,o=a>w,n.push("")},onObjectProperty:(w,f,$)=>{if(a<f||(v(w,f,$,"property"),n[n.length-1]=w,a<=f+$))throw i},onObjectEnd:(w,f)=>{if(a<=w)throw i;t=void 0,n.pop()},onArrayBegin:(w,f)=>{if(a<=w)throw i;t=void 0,n.push(0)},onArrayEnd:(w,f)=>{if(a<=w)throw i;t=void 0,n.pop()},onLiteralValue:(w,f,$)=>{if(a<f||(v(w,f,$,S(w)),a<=f+$))throw i},onSeparator:(w,f,$)=>{if(a<=f)throw i;if(w===":"&&t&&t.type==="property")t.colonOffset=f,o=!1,t=void 0;else if(w===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:t,isAtPropertyKey:o,matches:w=>{let f=0;for(let $=0;f<w.length&&$<n.length;$++)if(w[f]===n[$]||w[f]==="*")f++;else if(w[f]!=="**")return!1;return f===w.length}}}e.$Vm=E;function m(s,a=[],n=A.DEFAULT){let i=null,t=[];const r=[];function o(w){Array.isArray(t)?t.push(w):i!==null&&(t[i]=w)}return u(s,{onObjectBegin:()=>{const w={};o(w),r.push(t),t=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];o(w),r.push(t),t=w,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:(w,f,$)=>{a.push({error:w,offset:f,length:$})}},n),t[0]}e.$Wm=m;function c(s,a=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function r(w){return i.children.push(w),w}u(s,{onObjectBegin:w=>{i=r({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,f,$)=>{i=r({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:f,length:$,parent:i})},onObjectEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,t(w+f)},onArrayBegin:(w,f)=>{i=r({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,t(w+f)},onLiteralValue:(w,f,$)=>{r({type:S(w),offset:f,length:$,parent:i,value:w}),t(f+$)},onSeparator:(w,f,$)=>{i.type==="property"&&(w===":"?i.colonOffset=f:w===","&&t(f))},onError:(w,f,$)=>{a.push({error:w,offset:f,length:$})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$Xm=c;function d(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Ym=d;function p(s){if(!s.parent||!s.parent.children)return[];const a=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$Zm=p;function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=y(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=y;function l(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$2m=l;function h(s,a,n=!1){if(l(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=h(i[t],a,n);if(r)return r}return s}}e.$3m=h;function u(s,a,n=A.DEFAULT){const i=D(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?ie=>_(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),w=t(a.onObjectEnd),f=t(a.onArrayBegin),$=t(a.onArrayEnd),j=r(a.onLiteralValue),F=r(a.onSeparator),z=t(a.onComment),U=r(a.onError),q=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function K(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:q?x(10):z();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,ie=[],X=[]){if(U(_),ie.length+X.length>0){let B=i.getToken();for(;B!==17;){if(ie.indexOf(B)!==-1){K();break}else if(X.indexOf(B)!==-1)break;B=K()}}}function H(_){const ie=i.getTokenValue();return _?j(ie):v(ie),K(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}j(_);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return K(),!0}function G(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(F(":"),K(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){o(),K();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),K(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);G()||x(4,[],[2,5]),_=!0}return w(),i.getToken()!==2?x(7,[2],[]):K(),!0}function ee(){f(),K();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),K(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return $(),i.getToken()!==4?x(8,[4],[]):K(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return W();case 10:return H(!0);default:return Q()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$4m=u;function b(s,a){const n=D(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$5m=b;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=S}),define(oe[41],ae([0,1,35]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=e.$1S=e.$ZS=e.$YS=void 0;function L(g,C,E){let m,c,d,p,y;if(C){for(p=C.offset,y=p+C.length,d=p;d>0&&!k(g,d-1);)d--;let o=y;for(;o<g.length&&!k(g,o);)o++;c=g.substring(d,o),m=D(c,E)}else c=g,m=0,d=0,p=0,y=g.length;const l=R(E,g);let h=!1,u=0,b;E.insertSpaces?b=A(" ",E.tabSize||4):b="	";const S=(0,I.$Um)(c,!1);let s=!1;function a(){return l+A(b,m+u)}function n(){let o=S.scan();for(h=!1;o===15||o===14;)h=h||o===14,o=S.scan();return s=o===16||S.getTokenError()!==0,o}const i=[];function t(o,v,w){!s&&v<y&&w>p&&g.substring(v,w)!==o&&i.push({offset:v,length:w-v,content:o})}let r=n();if(r!==17){const o=S.getTokenOffset()+d,v=A(b,m);t(v,d,o)}for(;r!==17;){let o=S.getTokenOffset()+S.getTokenLength()+d,v=n(),w="";for(;!h&&(v===12||v===13);){const $=S.getTokenOffset()+d;t(" ",o,$),o=S.getTokenOffset()+S.getTokenLength()+d,w=v===12?a():"",v=n()}if(v===2)r!==1&&(u--,w=a());else if(v===4)r!==3&&(u--,w=a());else{switch(r){case 3:case 1:u++,w=a();break;case 5:case 12:w=a();break;case 13:h?w=a():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}h&&(v===12||v===13)&&(w=a())}const f=S.getTokenOffset()+d;t(w,o,f),r=v}return i}e.$YS=L;function N(g,C){const E=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.$ZS=N;function A(g,C){let E="";for(let m=0;m<C;m++)E+=g;return E}function D(g,C){let E=0,m=0;const c=C.tabSize||4;for(;E<g.length;){const d=g.charAt(E);if(d===" ")m++;else if(d==="	")m+=c;else break;E++}return Math.floor(m/c)}function R(g,C){for(let E=0;E<C.length;E++){const m=C.charAt(E);if(m==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return g&&g.eol||`
`}e.$1S=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$2S=k}),define(oe[86],ae([0,1,35,41]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=e.$6S=e.$5S=e.$4S=e.$3S=void 0;function N(g,C,E){return A(g,C,void 0,E)}e.$3S=N;function A(g,C,E,m,c){const d=C.slice(),p=[],y=(0,I.$Xm)(g,p);let l,h;for(;d.length>0&&(h=d.pop(),l=(0,I.$Ym)(y,d),l===void 0&&E!==void 0);)typeof h=="string"?E={[h]:E}:E=[E];if(l)if(l.type==="object"&&typeof h=="string"&&Array.isArray(l.children)){const u=(0,I.$Ym)(l,[h]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const b=l.children.indexOf(u.parent);let S,s=u.parent.offset+u.parent.length;if(b>0){const a=l.children[b-1];S=a.offset+a.length}else S=l.offset+1,l.children.length>1&&(s=l.children[1].offset);return D(g,{offset:S,length:s-S,content:""},m)}else return D(g,{offset:u.offset,length:u.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const b=`${JSON.stringify(h)}: ${JSON.stringify(E)}`,S=c?c(l.children.map(a=>a.children[0].value)):l.children.length;let s;if(S>0){const a=l.children[S-1];s={offset:a.offset+a.length,length:0,content:","+b}}else l.children.length===0?s={offset:l.offset+1,length:0,content:b}:s={offset:l.offset+1,length:0,content:b+","};return D(g,s,m)}}else if(l.type==="array"&&typeof h=="number"&&Array.isArray(l.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let b;if(l.children.length===0||h===0)b={offset:l.offset+1,length:0,content:l.children.length===0?u:u+","};else{const S=h===-1||h>l.children.length?l.children.length:h,s=l.children[S-1];b={offset:s.offset+s.length,length:0,content:","+u}}return D(g,b,m)}else{const u=h,b=l.children[u];let S;if(l.children.length===1)S={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===u){const s=l.children[u-1],a=s.offset+s.length,n=l.offset+l.length;S={offset:a,length:n-2-a,content:""}}else S={offset:b.offset,length:l.children[u+1].offset-b.offset,content:""};return D(g,S,m)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},m)}}e.$4S=A;function D(g,C,E){let m=R(g,C),c=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;c>0&&!(0,L.$2S)(m,c-1);)c--;for(;d<m.length&&!(0,L.$2S)(m,d);)d++}const p=(0,L.$YS)(m,{offset:c,length:d-c},E);for(let l=p.length-1;l>=0;l--){const h=p[l];m=R(m,h),c=Math.min(c,h.offset),d=Math.max(d,h.offset+h.length),d+=h.content.length-h.length}const y=g.length-(m.length-d)-c;return[{offset:c,length:y,content:m.substring(c,d)}]}e.$5S=D;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$6S=R;function k(g,C){const E=C.slice(0).sort((c,d)=>{const p=c.offset-d.offset;return p===0?c.length-d.length:p});let m=g.length;for(let c=E.length-1;c>=0;c--){const d=E[c];if(d.offset+d.length<=m)g=R(g,d);else throw new Error("Overlapping edit");m=d.offset}return g}e.$7S=k}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class L{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const D=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=D}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,D){const R=new I(A);if(this.a===I.Undefined)this.a=R,this.b=R;else if(D){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$2c=L}),define(oe[34],ae([0,1]),function(te,e){"use strict";var I,L,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(h,u,b){let S=h.get(u);return S===void 0&&(S=b,h.set(u,S)),S}e.$xc=A;function D(h){const u=[];return h.forEach((b,S)=>{u.push(`${S} => ${b}`)}),`Map(${h.size}) {${u.join(", ")}}`}e.$yc=D;function R(h){const u=[];return h.forEach(b=>{u.push(b)}),`Set(${h.size}) {${u.join(", ")}}`}e.$zc=R;class k{constructor(u,b){this.uri=u,this.value=b}}function g(h){return Array.isArray(h)}class C{static{this.a=u=>u.toString()}constructor(u,b){if(this[I]="ResourceMap",u instanceof C)this.b=new Map(u.b),this.c=b??C.a;else if(g(u)){this.b=new Map,this.c=b??C.a;for(const[S,s]of u)this.set(S,s)}else this.b=new Map,this.c=u??C.a}set(u,b){return this.b.set(this.c(u),new k(u,b)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,b){typeof b<"u"&&(u=u.bind(b));for(const[S,s]of this.b)u(s.value,s.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$Ac=C;class E{constructor(u,b){this[L]="ResourceSet",!u||typeof u=="function"?this.a=new C(u):(this.a=new C(b),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,b){this.a.forEach((S,s)=>u.call(b,s,s,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var m;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class c{constructor(){this[N]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,b=0){const S=this.a.get(u);if(S)return b!==0&&this.j(S,b),S.value}set(u,b,S=0){let s=this.a.get(u);if(s)s.value=b,S!==0&&this.j(s,S);else{switch(s={key:u,value:b,next:void 0,previous:void 0},S){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(u,s),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const b=this.a.get(u);if(b)return this.a.delete(u),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,b){const S=this.e;let s=this.b;for(;s;){if(b?u.bind(b)(s.value,s.key,this):u(s.value,s.key,this),this.e!==S)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,b=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.key,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}values(){const u=this,b=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.value,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}entries(){const u=this,b=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:[S.key,S.value],done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let b=this.b,S=this.size;for(;b&&S>u;)this.a.delete(b.key),b=b.next,S--;this.b=b,this.d=S,b&&(b.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const b=u.next,S=u.previous;if(!b||!S)throw new Error("Invalid list");b.previous=S,S.next=b}u.next=void 0,u.previous=void 0,this.e++}j(u,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(u===this.b)return;const S=u.next,s=u.previous;u===this.c?(s.next=void 0,this.c=s):(S.previous=s,s.next=S),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(b===2){if(u===this.c)return;const S=u.next,s=u.previous;u===this.b?(S.previous=void 0,this.b=S):(S.previous=s,s.next=S),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((b,S)=>{u.push([S,b])}),u}fromJSON(u){this.clear();for(const[b,S]of u)this.set(b,S)}}e.$Cc=c;class d extends c{constructor(u,b=1){super(),this.k=u,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,b=2){return super.get(u,b)}peek(u){return super.get(u,0)}set(u,b){return super.set(u,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=d;class p{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let b=this.a.get(u)||0;return b===0?!1:(b--,b===0?this.a.delete(u):this.a.set(u,b),!0)}has(u){return this.a.has(u)}}e.$Ec=p;class y{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[b,S]of u)this.set(b,S)}clear(){this.a.clear(),this.b.clear()}set(u,b){this.a.set(u,b),this.b.set(b,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const b=this.a.get(u);return b===void 0?!1:(this.a.delete(u),this.b.delete(b),!0)}forEach(u,b){this.a.forEach((S,s)=>{u.call(b,S,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=y;class l{constructor(){this.a=new Map}add(u,b){let S=this.a.get(u);S||(S=new Set,this.a.set(u,S)),S.add(b)}delete(u,b){const S=this.a.get(u);S&&(S.delete(b),S.size===0&&this.a.delete(u))}forEach(u,b){const S=this.a.get(u);S&&S.forEach(b)}get(u){const b=this.a.get(u);return b||new Set}}e.$Gc=l}),define(oe[2],ae([0,1,18,126,34,85,59]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c($){let j=this.b.get($);return j||(j={parent:null,source:null,isSingleton:!1,value:$,idx:g.a++},this.b.set($,j)),j}trackDisposable($){const j=this.c($);j.source||(j.source=new Error().stack)}setParent($,j){const F=this.c($);F.parent=j}markAsDisposed($){this.b.delete($)}markAsSingleton($){this.c($).isSingleton=!0}f($,j){const F=j.get($);if(F)return F;const z=$.parent?this.f(this.c($.parent),j):$;return j.set($,z),z}getTrackedDisposables(){const $=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,$).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables($=10,j){let F;if(j)F=j;else{const K=new Map,x=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,K).isSingleton);if(x.length===0)return;const H=new Set(x.map(Q=>Q.value));if(F=x.filter(Q=>!(Q.parent&&H.has(Q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function z(K){function x(Q,G){for(;Q.length>0&&G.some(W=>typeof W=="string"?W===Q[0]:Q[0].match(W));)Q.shift()}const H=K.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return x(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const U=new N.$Gc;for(const K of F){const x=z(K);for(let H=0;H<=x.length;H++)U.add(x.slice(0,H).join(`
`),K)}F.sort((0,I.$7b)(K=>K.idx,I.$9b));let q="",Z=0;for(const K of F.slice(0,$)){Z++;const x=z(K),H=[];for(let Q=0;Q<x.length;Q++){let G=x[Q];G=`(shared with ${U.get(x.slice(0,Q+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const ee=U.get(x.slice(0,Q).join(`
`)),ne=(0,L.$J)([...ee].map(_=>z(_)[Q]),_=>_);delete ne[x[Q]];for(const[_,ie]of Object.entries(ne))H.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${_}`);H.unshift(G)}q+=`


==================== Leaking disposable ${Z}/${F.length}: ${K.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return F.length>$&&(q+=`


... and ${F.length-$} more leaking disposables

`),{leaks:F,details:q}}}e.$Hc=g;function C(f){k=f}if(e.$Ic=C,R){const f="__is_disposable_tracked__";C(new class{trackDisposable($){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[f]||console.log(j)},3e3)}setParent($,j){if($&&$!==s.None)try{$[f]=!0}catch{}}markAsDisposed($){if($&&$!==s.None)try{$[f]=!0}catch{}}markAsSingleton($){}})}function E(f){return k?.trackDisposable(f),f}e.$Jc=E;function m(f){k?.markAsDisposed(f)}e.$Kc=m;function c(f,$){k?.setParent(f,$)}function d(f,$){if(k)for(const j of f)k.setParent(j,$)}function p(f){return k?.markAsSingleton(f),f}e.$Lc=p;function y(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Mc=y;function l(f){if(D.Iterable.is(f)){const $=[];for(const j of f)if(j)try{j.dispose()}catch(F){$.push(F)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Nc=l;function h(f){for(const $ of f)y($)&&$.dispose();return[]}e.$Oc=h;function u(...f){const $=b(()=>l(f));return d(f,$),$}e.$Pc=u;function b(f){const $=E({dispose:(0,A.$db)(()=>{m($),f()})});return $}e.$Qc=b;class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return c($,this),this.g?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}delete($){if($){if($===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete($),$.dispose()}}deleteAndLeak($){$&&this.f.has($)&&(this.f.delete($),c($,null))}}e.$Rc=S;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new S,E(this),c(this.q,this)}dispose(){m(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}e.$Sc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&c($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&c($,null),$}}e.$Tc=a;class n{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set($){let j=$;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,m(this))},this}}e.$Vc=i;class t{constructor(){this.a=new Map}acquire($,...j){let F=this.a.get($);F||(F={counter:0,object:this.b($,...j)},this.a.set($,F));const{object:z}=F,U=(0,A.$db)(()=>{--F.counter===0&&(this.c($,F.object),this.a.delete($))});return F.counter++,{object:z,dispose:U}}}e.$Wc=t;class r{constructor($){this.a=$}async acquire($,...j){const F=this.a.acquire($,...j);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(z){throw F.dispose(),z}}}e.$Xc=r;class o{constructor($){this.object=$}dispose(){}}e.$Yc=o;function v(f){const $=new S;try{f($)}finally{$.dispose()}}e.$Zc=v;class w{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get size(){return this.a.size}get($){return this.a.get($)}set($,j,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get($)?.dispose(),this.a.set($,j)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=w}),define(oe[88],ae([0,1,34]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const L=new I.$Dc(1e4);function N(g){return k(g,"NFC",L)}e.$ol=N;const A=new I.$Dc(1e4);function D(g){return k(g,"NFD",A)}e.$pl=D;const R=/[^\u0000-\u0080]/;function k(g,C,E){if(!g)return g;const m=E.get(g);if(m)return m;let c;return R.test(g)?c=g.normalize(C):c=g,E.set(g,c),c}e.$ql=function(){const g=/[\u0300-\u036f]/g;return function(C){return D(C).replace(g,"")}}()}),function(){function te(N){const A=[];typeof N=="number"&&A.push("code/timeOrigin",N);function D(k){A.push(k,Date.now())}function R(){const k=[];for(let g=0;g<A.length;g+=2)k.push({name:A[g],startTime:A[g+1]});return k}return{mark:D,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(N+D.startTime)});return A}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function I(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:te)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function I(L){if(e[L])return e[L].exports;var N=e[L]={i:L,l:!1,exports:{}};return te[L].call(N.exports,N,N.exports,I),N.l=!0,N.exports}return I.m=te,I.c=e,I.d=function(L,N,A){I.o(L,N)||Object.defineProperty(L,N,{enumerable:!0,get:A})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,N){if(1&N&&(L=I(L)),8&N||4&N&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&N&&typeof L!="string")for(var D in L)I.d(A,D,function(R){return L[R]}.bind(null,D));return A},I.n=function(L){var N=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(N,"a",N),N},I.o=function(L,N){return Object.prototype.hasOwnProperty.call(L,N)},I.p="",I(I.s=0)}([function(te,e,I){(function(L){var N;e=te.exports=X,N=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var E=g++;k[E]="[0-9]+";var m=g++;k[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=g++;k[c]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var d=g++;k[d]="("+k[E]+")\\.("+k[E]+")\\.("+k[E]+")";var p=g++;k[p]="(?:"+k[C]+"|"+k[m]+")";var y=g++;k[y]="(?:"+k[E]+"|"+k[m]+")";var l=g++;k[l]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var h=g++;k[h]="(?:-?("+k[y]+"(?:\\."+k[y]+")*))";var u=g++;k[u]="[0-9A-Za-z-]+";var b=g++;k[b]="(?:\\+("+k[u]+"(?:\\."+k[u]+")*))";var S=g++,s="v?"+k[c]+k[l]+"?"+k[b]+"?";k[S]="^"+s+"$";var a="[v=\\s]*"+k[d]+k[h]+"?"+k[b]+"?",n=g++;k[n]="^"+a+"$";var i=g++;k[i]="((?:<|>)?=?)";var t=g++;k[t]=k[E]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var o=g++;k[o]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[l]+")?"+k[b]+"?)?)?";var v=g++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[h]+")?"+k[b]+"?)?)?";var w=g++;k[w]="^"+k[i]+"\\s*"+k[o]+"$";var f=g++;k[f]="^"+k[i]+"\\s*"+k[v]+"$";var $=g++;k[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=g++;k[j]="(?:~>?)";var F=g++;k[F]="(\\s*)"+k[j]+"\\s+",R[F]=new RegExp(k[F],"g");var z=g++;k[z]="^"+k[j]+k[o]+"$";var U=g++;k[U]="^"+k[j]+k[v]+"$";var q=g++;k[q]="(?:\\^)";var Z=g++;k[Z]="(\\s*)"+k[q]+"\\s+",R[Z]=new RegExp(k[Z],"g");var K=g++;k[K]="^"+k[q]+k[o]+"$";var x=g++;k[x]="^"+k[q]+k[v]+"$";var H=g++;k[H]="^"+k[i]+"\\s*("+a+")$|^$";var Q=g++;k[Q]="^"+k[i]+"\\s*("+s+")$|^$";var G=g++;k[G]="(\\s*)"+k[i]+"\\s*("+a+"|"+k[o]+")",R[G]=new RegExp(k[G],"g");var W=g++;k[W]="^\\s*("+k[o]+")\\s+-\\s+("+k[o]+")\\s*$";var ee=g++;k[ee]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var ne=g++;k[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)N(_,k[_]),R[_]||(R[_]=new RegExp(k[_]));function ie(le,ge){if(le instanceof X)return le;if(typeof le!="string"||le.length>A||!(ge?R[n]:R[S]).test(le))return null;try{return new X(le,ge)}catch{return null}}function X(le,ge){if(le instanceof X){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(le,ge);N("SemVer",le,ge),this.loose=ge;var be=le.trim().match(ge?R[n]:R[S]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<D)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ie,e.valid=function(le,ge){var be=ie(le,ge);return be?be.version:null},e.clean=function(le,ge){var be=ie(le.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(le){return N("SemVer.compare",this.version,this.loose,le),le instanceof X||(le=new X(le,this.loose)),this.compareMain(le)||this.comparePre(le)},X.prototype.compareMain=function(le){return le instanceof X||(le=new X(le,this.loose)),P(this.major,le.major)||P(this.minor,le.minor)||P(this.patch,le.patch)},X.prototype.comparePre=function(le){if(le instanceof X||(le=new X(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=le.prerelease[ge];if(N("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return P(be,ke)}while(++ge)},X.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new X(le,be).inc(ge,ke).version}catch{return null}},e.diff=function(le,ge){if(V(le,ge))return null;var be=ie(le),ke=ie(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=P;var B=/^[0-9]+$/;function P(le,ge){var be=B.test(le),ke=B.test(ge);return be&&ke&&(le=+le,ge=+ge),be&&!ke?-1:ke&&!be?1:le<ge?-1:le>ge?1:0}function O(le,ge,be){return new X(le,be).compare(new X(ge,be))}function T(le,ge,be){return O(le,ge,be)>0}function M(le,ge,be){return O(le,ge,be)<0}function V(le,ge,be){return O(le,ge,be)===0}function J(le,ge,be){return O(le,ge,be)!==0}function re(le,ge,be){return O(le,ge,be)>=0}function ce(le,ge,be){return O(le,ge,be)<=0}function ue(le,ge,be,ke){var Pe;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le!==be;break;case"":case"=":case"==":Pe=V(le,be,ke);break;case"!=":Pe=J(le,be,ke);break;case">":Pe=T(le,be,ke);break;case">=":Pe=re(le,be,ke);break;case"<":Pe=M(le,be,ke);break;case"<=":Pe=ce(le,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(le,ge){if(le instanceof he){if(le.loose===ge)return le;le=le.value}if(!(this instanceof he))return new he(le,ge);N("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(le,ge){return P(ge,le)},e.major=function(le,ge){return new X(le,ge).major},e.minor=function(le,ge){return new X(le,ge).minor},e.patch=function(le,ge){return new X(le,ge).patch},e.compare=O,e.compareLoose=function(le,ge){return O(le,ge,!0)},e.rcompare=function(le,ge,be){return O(ge,le,be)},e.sort=function(le,ge){return le.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(le,ge){return le.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=T,e.lt=M,e.eq=V,e.neq=J,e.gte=re,e.lte=ce,e.cmp=ue,e.Comparator=he;var $e={};function de(le,ge){if(le instanceof de)return le.loose===ge?le:new de(le.raw,ge);if(le instanceof he)return new de(le.value,ge);if(!(this instanceof de))return new de(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function Ee(le,ge,be,ke,Pe,ze,je,Ue,Me,se,fe,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(Ue=we(Me)?"":we(se)?"<"+(+Me+1)+".0.0":we(fe)?"<"+Me+"."+(+se+1)+".0":me?"<="+Me+"."+se+"."+fe+"-"+me:"<="+Ue)).trim()}function Ie(le,ge){for(var be=0;be<le.length;be++)if(!le[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<le.length;be++)if(N(le[be].semver),le[be].semver!==$e&&le[be].semver.prerelease.length>0){var ke=le[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Le(le,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(le)}function Te(le,ge,be,ke){var Pe,ze,je,Ue,Me;switch(le=new X(le,ke),ge=new de(ge,ke),be){case">":Pe=T,ze=ce,je=M,Ue=">",Me=">=";break;case"<":Pe=M,ze=re,je=T,Ue="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(le,ge,ke))return!1;for(var se=0;se<ge.set.length;++se){var fe=ge.set[se],me=null,pe=null;if(fe.forEach(function(Se){Se.semver===$e&&(Se=new he(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:je(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===Ue||me.operator===Me||(!pe.operator||pe.operator===Ue)&&ze(le,pe.semver)||pe.operator===Me&&je(le,pe.semver))return!1}return!0}he.prototype.parse=function(le){var ge=this.loose?R[H]:R[Q],be=le.match(ge);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new X(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return N("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new X(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,ge){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,ge),Le(this.value,be,ge);if(le.operator==="")return be=new de(this.value,ge),Le(le.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),ze=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ue=ue(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=ue(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return ke||Pe||ze&&je||Ue||Me},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),N("range",le,ge);var be=ge?R[ee]:R[W];le=le.replace(be,Ee),N("hyphen replace",le),le=le.replace(R[G],"$1$2$3"),N("comparator trim",le,R[G]),le=(le=(le=le.replace(R[F],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var ke=ge?R[H]:R[Q],Pe=le.split(" ").map(function(ze){return function(je,Ue){return N("comp",je),je=function(Me,se){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){N("caret",me,pe);var Se=pe?R[x]:R[K];return me.replace(Se,function(Re,Ce,De,Oe,Ae){var Fe;return N("caret",me,Re,Ce,De,Oe,Ae),we(Ce)?Fe="":we(De)?Fe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Fe=Ce==="0"?">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+".0 <"+(+Ce+1)+".0.0":Ae?(N("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+Ae+" <"+(+Ce+1)+".0.0"):(N("no pr"),Fe=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+" <"+(+Ce+1)+".0.0"),N("caret return",Fe),Fe})}(fe,se)}).join(" ")}(je,Ue),N("caret",je),je=function(Me,se){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){var Se=pe?R[U]:R[z];return me.replace(Se,function(Re,Ce,De,Oe,Ae){var Fe;return N("tilde",me,Re,Ce,De,Oe,Ae),we(Ce)?Fe="":we(De)?Fe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Fe=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":Ae?(N("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+(+De+1)+".0"):Fe=">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0",N("tilde return",Fe),Fe})}(fe,se)}).join(" ")}(je,Ue),N("tildes",je),je=function(Me,se){return N("replaceXRanges",Me,se),Me.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var Se=pe?R[f]:R[w];return me.replace(Se,function(Re,Ce,De,Oe,Ae,Fe){N("xRange",me,Re,Ce,De,Oe,Ae,Fe);var Be=we(De),qe=Be||we(Oe),Ve=qe||we(Ae);return Ce==="="&&Ve&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(qe&&(Oe=0),Ve&&(Ae=0),Ce===">"?(Ce=">=",qe?(De=+De+1,Oe=0,Ae=0):Ve&&(Oe=+Oe+1,Ae=0)):Ce==="<="&&(Ce="<",qe?De=+De+1:Oe=+Oe+1),Re=Ce+De+"."+Oe+"."+Ae):qe?Re=">="+De+".0.0 <"+(+De+1)+".0.0":Ve&&(Re=">="+De+"."+Oe+".0 <"+De+"."+(+Oe+1)+".0"),N("xRange return",Re),Re})}(fe,se)}).join(" ")}(je,Ue),N("xrange",je),je=function(Me,se){return N("replaceStars",Me,se),Me.trim().replace(R[ne],"")}(je,Ue),N("stars",je),je}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(ke)})),Pe=Pe.map(function(ze){return new he(ze,ge)})},de.prototype.intersects=function(le,ge){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return le.set.some(function(Pe){return Pe.every(function(ze){return ke.intersects(ze,ge)})})})})},e.toComparators=function(le,ge){return new de(le,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new X(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],le))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(le,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(ke&&Pe.compare(je)!==-1||(Pe=new X(ke=je,be)))}),ke},e.minSatisfying=function(le,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(ke&&Pe.compare(je)!==1||(Pe=new X(ke=je,be)))}),ke},e.validRange=function(le,ge){try{return new de(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,be){return Te(le,ge,"<",be)},e.gtr=function(le,ge,be){return Te(le,ge,">",be)},e.outside=Te,e.prerelease=function(le,ge){var be=ie(le,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,ge,be){return le=new de(le,be),ge=new de(ge,be),le.intersects(ge)},e.coerce=function(le){if(le instanceof X)return le;if(typeof le!="string")return null;var ge=le.match(R[$]);return ge==null?null:ie((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(te,e){var I,L,N=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(y){if(I===setTimeout)return setTimeout(y,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(y,0);try{return I(y,0)}catch{try{return I.call(null,y,0)}catch{return I.call(this,y,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{L=typeof clearTimeout=="function"?clearTimeout:D}catch{L=D}})();var k,g=[],C=!1,E=-1;function m(){C&&k&&(C=!1,k.length?g=k.concat(g):E=-1,g.length&&c())}function c(){if(!C){var y=R(m);C=!0;for(var l=g.length;l;){for(k=g,g=[];++E<l;)k&&k[E].run();E=-1,l=g.length}k=null,C=!1,function(h){if(L===clearTimeout)return clearTimeout(h);if((L===D||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(h);try{L(h)}catch{try{return L.call(null,h)}catch{return L.call(this,h)}}}(y)}}function d(y,l){this.fun=y,this.array=l}function p(){}N.nextTick=function(y){var l=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)l[h-1]=arguments[h];g.push(new d(y,l)),g.length!==1||C||R(c)},d.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=p,N.addListener=p,N.once=p,N.off=p,N.removeListener=p,N.removeAllListeners=p,N.emit=p,N.prependListener=p,N.prependOnceListener=p,N.listeners=function(y){return[]},N.binding=function(y){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(y){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class L{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const N=void 0;class A{constructor(R,k=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new L(this.c,N,N)}get size(){return this.f}clear(){this.e=new L(this.c,N,N),this.f=0}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,k){return A.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=A.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let E=R.d-1;E>=0;E--)for(;C.forward[E]&&g(C.forward[E].key,k)<0;)C=C.forward[E];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const E=[];let m=R.e;for(let c=R.d-1;c>=0;c--){for(;m.forward[c]&&C(m.forward[c].key,k)<0;)m=m.forward[c];E[c]=m}if(m=m.forward[0],m&&C(m.key,k)===0)return m.value=g,!1;{const c=A.j(R);if(c>R.d){for(let d=R.d;d<c;d++)E[d]=R.e;R.d=c}m=new L(c,k,g);for(let d=0;d<c;d++)m.forward[d]=E[d].forward[d],E[d].forward[d]=m;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let E=R.e;for(let m=R.d-1;m>=0;m--){for(;E.forward[m]&&g(E.forward[m].key,k)<0;)E=E.forward[m];C[m]=E}if(E=E.forward[0],!E||g(E.key,k)!==0)return!1;for(let m=0;m<R.d&&C[m].forward[m]===E;m++)C[m].forward[m]=E.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===N;)R.d-=1;return!0}}e.$yr=A}),define(oe[61],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=L}),define(oe[3],ae([0,1,8,85,2,87,61]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const R=!1,k=!1;var g;(function(w){w.None=()=>N.$Sc.None;function f(ue){if(k){const{onDidAddListener:he}=ue,$e=d.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function $(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}w.defer=$;function j(ue){return(he,$e=null,de)=>{let we=!1,Ee;return Ee=ue(Ie=>{if(!we)return Ee?Ee.dispose():we=!0,he.call($e,Ie)},null,de),we&&Ee.dispose(),Ee}}w.once=j;function F(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>de.call(we,he(Ie)),null,Ee),$e)}w.map=F;function z(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,Ee),$e)}w.forEach=z;function U(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,Ee),$e)}w.filter=U;function q(ue){return ue}w.signal=q;function Z(...ue){return(he,$e=null,de)=>{const we=(0,N.$Pc)(...ue.map(Ee=>Ee(Ie=>he.call($e,Ie))));return H(we,de)}}w.any=Z;function K(ue,he,$e,de){let we=$e;return F(ue,Ee=>(we=he(we,Ee),we),de)}w.reduce=K;function x(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||f(de);const we=new u(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,$e=100,de=!1,we=!1,Ee,Ie){let Le,Te,le,ge=0,be;const ke={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=ue(ze=>{ge++,Te=he(Te,ze),de&&!le&&(Pe.fire(Te),Te=void 0),be=()=>{const je=Te;Te=void 0,le=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(le),le=setTimeout(be,$e)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Ie||f(ke);const Pe=new u(ke);return Ie?.add(Pe),Pe.event}w.debounce=Q;function G(ue,he=0,$e){return w.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}w.accumulate=G;function W(ue,he=(de,we)=>de===we,$e){let de=!0,we;return U(ue,Ee=>{const Ie=de||!he(Ee,we);return de=!1,we=Ee,Ie},$e)}w.latch=W;function ee(ue,he,$e){return[w.filter(ue,he,$e),w.filter(ue,de=>!he(de),$e)]}w.split=ee;function ne(ue,he=!1,$e=[],de){let we=$e.slice(),Ee=ue(Te=>{we?we.push(Te):Le.fire(Te)});de&&de.add(Ee);const Ie=()=>{we?.forEach(Te=>Le.fire(Te)),we=null},Le=new u({onWillAddFirstListener(){Ee||(Ee=ue(Te=>Le.fire(Te)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}w.buffer=ne;function _(ue,he){return(de,we,Ee)=>{const Ie=he(new X);return ue(function(Le){const Te=Ie.evaluate(Le);Te!==ie&&de.call(we,Te)},void 0,Ee)}}w.chain=_;const ie=Symbol("HaltChainable");class X{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:ie),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!he(we,de);return $e=!1,de=we,Ee?we:ie}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===ie)break;return he}}function B(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.on(he,de),Ee=()=>ue.removeListener(he,de),Ie=new u({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}w.fromNodeEventEmitter=B;function P(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.addEventListener(he,de),Ee=()=>ue.removeEventListener(he,de),Ie=new u({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}w.fromDOMEventEmitter=P;function O(ue){return new Promise(he=>j(ue)(he))}w.toPromise=O;function T(ue){const he=new u;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}w.fromPromise=T;function M(ue,he){return he(void 0),ue($e=>he($e))}w.runAndSubscribe=M;function V(ue,he){let $e=null;function de(Ee){$e?.dispose(),$e=new N.$Rc,he(Ee,$e)}de(void 0);const we=ue(Ee=>de(Ee));return(0,N.$Qc)(()=>{we.dispose(),$e?.dispose()})}w.runAndSubscribeWithStore=V;class J{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||f(de),this.emitter=new u(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(ue,he){return new J(ue,he).emitter.event}w.fromObservable=re;function ce(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}w.fromObservableLight=ce})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${C.f++}`,C.all.add(this)}start(f){this.g=new D.$Jd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Ld=C;let E=-1;function m(w){const f=E;return E=w,{dispose(){E=f}}}e.$Md=m;class c{constructor(f,$=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=$,this.g=0}dispose(){this.f?.clear()}check(f,$){const j=this.threshold;if(j<=0||$<j)return;this.f||(this.f=new Map);const F=this.f.get(f.value)||0;if(this.f.set(f.value,F+1),this.g-=1,this.g<=0){this.g=j*.5;let z,U=0;for(const[q,Z]of this.f)(!z||U<Z)&&(z=q,U=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${$} listeners already. MOST frequent listener (${U}):`),console.warn(z)}return()=>{const z=this.f.get(f.value)||0;this.f.set(f.value,z-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class y{constructor(f){this.value=f,this.id=p++}}const l=2,h=(w,f)=>{if(w instanceof y)f(w);else for(let $=0;$<w.length;$++){const j=w[$];j&&f(j)}};class u{constructor(f){this.w=0,this.f=f,this.g=E>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const f=this.t;queueMicrotask(()=>{h(f,$=>$.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,$,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),N.$Sc.None;if(this.m)return N.$Sc.None;$&&(f=f.bind($));const F=new y(f);let z,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=d.create(),z=this.g.check(F.stack,this.w+1)),R&&(F.stack=U??d.create()),this.t?this.t instanceof y?(this.u??=new S,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,N.$Qc)(()=>{z?.(),this.x(F)});return j instanceof N.$Rc?j.add(q):Array.isArray(j)&&j.push(q),q},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const $=this.t,j=$.indexOf(f);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,$[j]=void 0;const F=this.u.current===this;if(this.w*l<=$.length){let z=0;for(let U=0;U<$.length;U++)$[U]?$[z++]=$[U]:F&&(this.u.end--,z<this.u.i&&this.u.i--);$.length=z}}y(f,$){if(!f)return;const j=this.f?.onListenerError||I.$1;if(!j){f.value($);return}try{f.value($)}catch(F){j(F)}}z(f){const $=f.current.t;for(;f.i<f.end;)this.y($[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof y)this.y(this.t,f);else{const $=this.u;$.enqueue(this,f,this.t.length),this.z($)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=u;const b=()=>new S;e.$Od=b;class S{constructor(){this.i=-1,this.end=0}enqueue(f,$,j){this.i=0,this.end=j,this.current=f,this.value=$}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends u{async fireAsync(f,$,j){if(this.t)for(this.h||(this.h=new A.$2c),h(this.t,F=>this.h.push([F.value,f]));this.h.size>0&&!$.isCancellationRequested;){const[F,z]=this.h.shift(),U=[],q={...z,token:$,waitUntil:Z=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");j&&(Z=j(Z,F)),U.push(Z)}};try{F(q)}catch(Z){(0,I.$1)(Z);continue}Object.freeze(U),await Promise.allSettled(U).then(Z=>{for(const K of Z)K.status==="rejected"&&(0,I.$1)(K.reason)})}}}e.$Pd=s;class a extends u{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new A.$2c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Qd=a;class n extends a{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Rd=n;class i extends u{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach($=>super.fire($)),this.h=[]}))}}e.$Sd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const $={event:f,listener:null};this.h.push($),this.g&&this.m($);const j=()=>{this.g&&this.o($);const F=this.h.indexOf($);this.h.splice(F,1)};return(0,N.$Qc)((0,L.$db)(j))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event($=>this.f.fire($))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Td=t;class r{constructor(f,$,j,F){this.f=new N.$Rc;const z=this.f.add(new t),U=this.f.add(new N.$1c);function q(Z){U.set(Z,z.add(F(Z)))}for(const Z of f)q(Z);this.f.add($(Z=>{q(Z)})),this.f.add(j(Z=>{U.deleteAndDispose(Z)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Ud=r;class o{constructor(){this.f=[]}wrapEvent(f){return($,j,F)=>f(z=>{const U=this.f[this.f.length-1];U?U.push(()=>$.call(j,z)):$.call(j,z)},void 0,F)}bufferEvents(f){const $=[];this.f.push($);const j=f();return this.f.pop(),$.forEach(F=>F()),j}}e.$Vd=o;class v{constructor(){this.f=!1,this.g=g.None,this.h=N.$Sc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=v}),define(oe[26],ae([0,1,3]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const L=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var N;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(N||(e.CancellationToken=N={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new I.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=N.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=N.None}}e.$Xd=D}),define(oe[129],ae([0,1,26]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class L{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$Xd,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$we=L;class N{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$xe=N;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$ye=A}),define(oe[46],ae([0,1,8,2]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function N(b){const S=b;return S?typeof S.read=="function":!1}e.$Yd=N;function A(b){const S=b;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$Zd=A;function D(b){const S=b;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$1d=D;function R(b,S){return new k(b,S)}e.$2d=R;class k{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,I.$1)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let a;switch(S){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(b,S){const s=[];let a;for(;(a=b.read())!==null;)s.push(a);return S(s)}e.$3d=g;function C(b,S,s){const a=[];let n;for(;(n=b.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?S(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return b.read()}}}e.$4d=C;function E(b,S){return new Promise((s,a)=>{const n=[];m(b,{onData:i=>{S&&n.push(i)},onError:i=>{S?a(i):s(void 0)},onEnd:()=>{s(S?S(n):void 0)}})})}e.$5d=E;function m(b,S,s){b.on("error",a=>{s?.isCancellationRequested||S.onError(a)}),b.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),b.on("data",a=>{s?.isCancellationRequested||S.onData(a)})}e.$6d=m;function c(b,S){return new Promise((s,a)=>{const n=new L.$Rc,i=[],t=v=>{if(i.push(v),i.length>S)return n.dispose(),b.pause(),s({stream:b,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:b,buffer:i,ended:!0}));n.add((0,L.$Qc)(()=>b.removeListener("error",r))),b.on("error",r),n.add((0,L.$Qc)(()=>b.removeListener("end",o))),b.on("end",o),n.add((0,L.$Qc)(()=>b.removeListener("data",t))),b.on("data",t)})}e.$7d=c;function d(b,S){const s=R(S);return s.end(b),s}e.$8d=d;function p(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.$9d=p;function y(b){let S=!1;return{read:()=>S?null:(S=!0,b)}}e.$0d=y;function l(b,S,s){const a=R(s);return m(b,{onData:n=>a.write(S.data(n)),onError:n=>a.error(S.error?S.error(n):n),onEnd:()=>a.end()}),a}e.$$d=l;function h(b,S,s){let a=!1;return{read:()=>{const n=S.read();return a?n:(a=!0,n!==null?s([b,n]):b)}}}e.$_d=h;function u(b,S,s){let a=!1;const n=R(s);return m(S,{onData:i=>a?n.write(i):(a=!0,n.write(s([b,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(b)),n.end()}}),n}e.$ae=u}),define(oe[15],ae([0,1,60,46]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const N=typeof Buffer<"u",A=new I.$V(()=>new Uint8Array(256));let D,R;class k{static alloc($){return N?new k(Buffer.allocUnsafe($)):new k(new Uint8Array($))}static wrap($){return N&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new k($)}static fromString($,j){return!(j?.dontUseNodeBuffer||!1)&&N?new k(Buffer.from($)):(D||(D=new TextEncoder),new k(D.encode($)))}static fromByteArray($){const j=k.alloc($.length);for(let F=0,z=$.length;F<z;F++)j.buffer[F]=$[F];return j}static concat($,j){if(typeof j>"u"){j=0;for(let U=0,q=$.length;U<q;U++)j+=$[U].byteLength}const F=k.alloc(j);let z=0;for(let U=0,q=$.length;U<q;U++){const Z=$[U];F.set(Z,z),z+=Z.byteLength}return F}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=k.alloc(this.byteLength);return $.set(this),$}toString(){return N?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice($,j){return new k(this.buffer.subarray($,j))}set($,j){if($ instanceof k)this.buffer.set($.buffer,j);else if($ instanceof Uint8Array)this.buffer.set($,j);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),j);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return m(this.buffer,$)}writeUInt32BE($,j){c(this.buffer,$,j)}readUInt32LE($){return d(this.buffer,$)}writeUInt32LE($,j){p(this.buffer,$,j)}readUInt8($){return y(this.buffer,$)}writeUInt8($,j){l(this.buffer,$,j)}indexOf($,j=0){return g(this.buffer,$ instanceof k?$.buffer:$,j)}}e.$be=k;function g(f,$,j=0){const F=$.byteLength,z=f.byteLength;if(F===0)return 0;if(F===1)return f.indexOf($[0]);if(F>z-j)return-1;const U=A.value;U.fill($.length);for(let x=0;x<$.length;x++)U[$[x]]=$.length-x-1;let q=j+$.length-1,Z=q,K=-1;for(;q<z;)if(f[q]===$[Z]){if(Z===0){K=q;break}q--,Z--}else q+=Math.max($.length-Z,U[f[q]]),Z=$.length-1;return K}e.$ce=g;function C(f,$){return f[$+0]<<0>>>0|f[$+1]<<8>>>0}e.$de=C;function E(f,$,j){f[j+0]=$&255,$=$>>>8,f[j+1]=$&255}e.$ee=E;function m(f,$){return f[$]*2**24+f[$+1]*2**16+f[$+2]*2**8+f[$+3]}e.$fe=m;function c(f,$,j){f[j+3]=$,$=$>>>8,f[j+2]=$,$=$>>>8,f[j+1]=$,$=$>>>8,f[j]=$}e.$ge=c;function d(f,$){return f[$+0]<<0>>>0|f[$+1]<<8>>>0|f[$+2]<<16>>>0|f[$+3]<<24>>>0}e.$he=d;function p(f,$,j){f[j+0]=$&255,$=$>>>8,f[j+1]=$&255,$=$>>>8,f[j+2]=$&255,$=$>>>8,f[j+3]=$&255}e.$ie=p;function y(f,$){return f[$]}e.$je=y;function l(f,$,j){f[j]=$}e.$ke=l;function h(f){return L.$3d(f,$=>k.concat($))}e.$le=h;function u(f){return L.$0d(f)}e.$me=u;function b(f){return L.$5d(f,$=>k.concat($))}e.$ne=b;async function S(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await b(f.stream)])}e.$oe=S;function s(f){return L.$8d(f,$=>k.concat($))}e.$pe=s;function a(f){return L.$$d(f,{data:$=>typeof $=="string"?k.fromString($):k.wrap($)},$=>k.concat($))}e.$qe=a;function n(f){return L.$2d($=>k.concat($),f)}e.$re=n;function i(f,$){return L.$_d(f,$,j=>k.concat(j))}e.$se=i;function t(f,$){return L.$ae(f,$,j=>k.concat(j))}e.$te=t;function r(f){let $=0,j=0,F=0;const z=new Uint8Array(Math.floor(f.length/4*3)),U=Z=>{switch(j){case 3:z[F++]=$|Z,j=0;break;case 2:z[F++]=$|Z>>>2,$=Z<<6,j=3;break;case 1:z[F++]=$|Z>>>4,$=Z<<4,j=2;break;default:$=Z<<2,j=1}};for(let Z=0;Z<f.length;Z++){const K=f.charCodeAt(Z);if(K>=65&&K<=90)U(K-65);else if(K>=97&&K<=122)U(K-97+26);else if(K>=48&&K<=57)U(K-48+52);else if(K===43||K===45)U(62);else if(K===47||K===95)U(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Z]}`)}}const q=F;for(;j>0;)U(0);return k.wrap(z).slice(0,q)}e.$ue=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:f},$=!0,j=!1){const F=j?v:o;let z="";const U=f.byteLength%3;let q=0;for(;q<f.byteLength-U;q+=3){const Z=f[q+0],K=f[q+1],x=f[q+2];z+=F[Z>>>2],z+=F[(Z<<4|K>>>4)&63],z+=F[(K<<2|x>>>6)&63],z+=F[x&63]}if(U===1){const Z=f[q+0];z+=F[Z>>>2],z+=F[Z<<4&63],$&&(z+="==")}else if(U===2){const Z=f[q+0],K=f[q+1];z+=F[Z>>>2],z+=F[(Z<<4|K>>>4)&63],z+=F[K<<2&63],$&&(z+="=")}return z}e.$ve=w}),define(oe[27],ae([0,1,129,60]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function N(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$Be=N;const A=/{(\d+)}/g;function D(se,...fe){return fe.length===0?se:se.replace(A,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=fe.length?me:fe[Se]})}e.$Ce=D;const R=/{([^}]+)}/g;function k(se,fe){return se.replace(R,(me,pe)=>fe[pe]??me)}e.$De=k;function g(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ee=g;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=C;function E(se,fe){let me=0;const pe=fe.charCodeAt(0);for(let Se=se.length-1;Se>=0;Se--)se.charCodeAt(Se)===pe&&me++;return me}e.$Ge=E;function m(se,fe,me="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${me}`}e.$He=m;function c(se,fe=" "){const me=d(se,fe);return p(me,fe)}e.$Ie=c;function d(se,fe){if(!se||!fe)return se;const me=fe.length;if(me===0||se.length===0)return se;let pe=0;for(;se.indexOf(fe,pe)===pe;)pe=pe+me;return se.substring(pe)}e.$Je=d;function p(se,fe){if(!se||!fe)return se;const me=fe.length,pe=se.length;if(me===0||pe===0)return se;let Se=pe,Re=-1;for(;Re=se.lastIndexOf(fe,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return se.substring(0,Se)}e.$Ke=p;function y(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=y;function l(se){return se.replace(/\*/g,"")}e.$Me=l;function h(se,fe,me={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=C(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(se,pe)}e.$Ne=h;function u(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$Oe=u;function b(se){return se.split(/\r\n|\r|\n/)}e.$Pe=b;function S(se){for(let fe=0,me=se.length;fe<me;fe++){const pe=se.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Qe=S;function s(se,fe=0,me=se.length){for(let pe=fe;pe<me;pe++){const Se=se.charCodeAt(pe);if(Se!==32&&Se!==9)return se.substring(fe,pe)}return se.substring(fe,me)}e.$Re=s;function a(se,fe=se.length-1){for(let me=fe;me>=0;me--){const pe=se.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Se=a;function n(se,fe,me){const pe=[];let Se=0;for(const Re of se.matchAll(fe)){if(pe.push(se.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,se,Re.groups))}return pe.push(se.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$Te=n;function i(se,fe){return se<fe?-1:se>fe?1:0}e.$Ue=i;function t(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){const Oe=se.charCodeAt(me),Ae=fe.charCodeAt(Se);if(Oe<Ae)return-1;if(Oe>Ae)return 1}const Ce=pe-me,De=Re-Se;return Ce<De?-1:Ce>De?1:0}e.$Ve=t;function r(se,fe){return o(se,fe,0,se.length,0,fe.length)}e.$We=r;function o(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){let Oe=se.charCodeAt(me),Ae=fe.charCodeAt(Se);if(Oe===Ae)continue;if(Oe>=128||Ae>=128)return t(se.toLowerCase(),fe.toLowerCase(),me,pe,Se,Re);w(Oe)&&(Oe-=32),w(Ae)&&(Ae-=32);const Fe=Oe-Ae;if(Fe!==0)return Fe}const Ce=pe-me,De=Re-Se;return Ce<De?-1:Ce>De?1:0}e.$Xe=o;function v(se){return se>=48&&se<=57}e.$Ye=v;function w(se){return se>=97&&se<=122}e.$Ze=w;function f(se){return se>=65&&se<=90}e.$1e=f;function $(se,fe){return se.length===fe.length&&o(se,fe)===0}e.$2e=$;function j(se,fe){const me=fe.length;return fe.length>se.length?!1:o(se,fe,0,me)===0}e.$3e=j;function F(se,fe){const me=Math.min(se.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(se.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$4e=F;function z(se,fe){const me=Math.min(se.length,fe.length);let pe;const Se=se.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(se.charCodeAt(Se-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$5e=z;function U(se){return 55296<=se&&se<=56319}e.$6e=U;function q(se){return 56320<=se&&se<=57343}e.$7e=q;function Z(se,fe){return(se-55296<<10)+(fe-56320)+65536}e.$8e=Z;function K(se,fe,me){const pe=se.charCodeAt(me);if(U(pe)&&me+1<fe){const Se=se.charCodeAt(me+1);if(q(Se))return Z(pe,Se)}return pe}e.$9e=K;function x(se,fe){const me=se.charCodeAt(fe-1);if(q(me)&&fe>1){const pe=se.charCodeAt(fe-2);if(U(pe))return Z(pe,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$0e=H;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$$e=Q;function G(se,fe){return new Q(se,fe).nextGraphemeLength()}e.$_e=G;function W(se,fe){return new Q(se,fe).prevGraphemeLength()}e.$af=W;function ee(se,fe){fe>0&&q(se.charCodeAt(fe))&&fe--;const me=fe+G(se,fe);return[me-W(se,me),me]}e.$bf=ee;function ne(se){const fe=new Q(se);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$cf=ne;let _;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(se){return _||(_=ie()),_.test(se)}e.$df=X;const B=/^[\t\n\r\x20-\x7E]*$/;function P(se){return B.test(se)}e.$ef=P,e.$ff=/[\u2028\u2029]/;function O(se){return e.$ff.test(se)}e.$gf=O;function T(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$hf=T;function M(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$if=M;function V(se,fe){if(se.length<fe)return se;const me=/\b/g;let pe=0;for(;me.test(se)&&!(se.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return se.substring(pe).replace(/^\s/,"")}e.$jf=V;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ce(se){return se&&(se=se.replace(J,"").replace(re,"")),se}e.$kf=ce,e.$lf=String.fromCharCode(65279);function ue(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$mf=ue;function he(se){return ue(se)?se.substr(1):se}e.$nf=he;function $e(se,fe){if(!se||!fe||se.length<fe.length)return!1;const me=fe.length,pe=se.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(fe[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$of=$e;function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$pf=de;function we(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$qf=we;function Ee(se,fe=1){if(fe===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.$rf=Ee;function Ie(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$sf=Ie;function Le(se){return ge.getInstance().getGraphemeBreakType(se)}e.$tf=Le;function Te(se,fe){return se===0?fe!==5&&fe!==7:se===2&&fe===3?!1:se===4||se===2||se===3||fe===4||fe===2||fe===3?!0:!(se===8&&(fe===8||fe===9||fe===11||fe===12)||(se===11||se===9)&&(fe===9||fe===10)||(se===12||se===10)&&fe===10||fe===5||fe===13||fe===7||se===1||se===13&&fe===14||se===6&&fe===6)}var le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(fe<me[3*Se])Se=2*Se;else if(fe>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(se,fe){if(se===0)return 0;const me=Pe(se,fe);if(me!==void 0)return me;const pe=new H(fe,se);return pe.prevCodePoint(),pe.offset}e.$uf=ke;function Pe(se,fe){const me=new H(fe,se);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!M(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function ze(se){return 127995<=se&&se<=127999}var je;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$vf="\xA0";class Ue{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$xe(fe=>{function me(Fe){const Be=new Map;for(let qe=0;qe<Fe.length;qe+=2)Be.set(Fe[qe],Fe[qe+1]);return Be}function pe(Fe,Be){const qe=new Map(Fe);for(const[Ve,_e]of Be)qe.set(Ve,_e);return qe}function Se(Fe,Be){if(!Fe)return Be;const qe=new Map;for(const[Ve,_e]of Fe)Be.has(Ve)&&qe.set(Ve,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Re);Ce.length===0&&(Ce=["_default"]);let De;for(const Fe of Ce){const Be=me(Re[Fe]);De=Se(De,Be)}const Oe=me(Re._common),Ae=pe(Oe,De);return new Ue(Ae)})}static getInstance(fe){return Ue.d.get(Array.from(fe))}static{this.e=new L.$V(()=>Object.keys(Ue.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=Ue;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(fe){return Me.e().has(fe)}static get codePoints(){return Me.e()}}e.$xf=Me}),define(oe[52],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function L(l){return N(l,0)}e.$Di=L;function N(l,h){switch(typeof l){case"object":return l===null?A(349,h):Array.isArray(l)?k(l,h):g(l,h);case"string":return R(l,h);case"boolean":return D(l,h);case"number":return A(l,h);case"undefined":return A(937,h);default:return A(617,h)}}e.$Ei=N;function A(l,h){return(h<<5)-h+l|0}e.$Fi=A;function D(l,h){return A(l?433:863,h)}function R(l,h){h=A(149417,h);for(let u=0,b=l.length;u<b;u++)h=A(l.charCodeAt(u),h);return h}e.$Gi=R;function k(l,h){return h=A(104579,h),l.reduce((u,b)=>N(b,u),h)}function g(l,h){return h=A(181387,h),Object.keys(l).sort().reduce((u,b)=>(u=R(b,u),N(l[b],u)),h)}class C{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=N(h,this.g),this.g}}e.$Hi=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(l,h,u=32){const b=u-h,S=~((1<<b)-1);return(l<<h|(S&l)>>>b)>>>0}function c(l,h=0,u=l.byteLength,b=0){for(let S=0;S<u;S++)l[h+S]=b}function d(l,h,u="0"){for(;l.length<h;)l=u+l;return l}function p(l,h=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((l>>>0).toString(16),h/4)}e.$Ii=p;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const u=h.length;if(u===0)return;const b=this.p;let S=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=h.charCodeAt(0),n=0);;){let i=a;if(I.$6e(a))if(n+1<u){const t=h.charCodeAt(n+1);I.$7e(t)?(n++,i=I.$8e(a,t)):i=65533}else{s=a;break}else I.$7e(a)&&(i=65533);if(S=this.w(b,S,i),n++,n<u)a=h.charCodeAt(n);else break}this.r=S,this.u=s}w(h,u,b){return b<128?h[u++]=b:b<2048?(h[u++]=192|(b&1984)>>>6,h[u++]=128|(b&63)>>>0):b<65536?(h[u++]=224|(b&61440)>>>12,h[u++]=128|(b&4032)>>>6,h[u++]=128|(b&63)>>>0):(h[u++]=240|(b&1835008)>>>18,h[u++]=128|(b&258048)>>>12,h[u++]=128|(b&4032)>>>6,h[u++]=128|(b&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=y.g,u=this.q;for(let o=0;o<64;o+=4)h.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)h.setUint32(o,m(h.getUint32(o-12,!1)^h.getUint32(o-32,!1)^h.getUint32(o-56,!1)^h.getUint32(o-64,!1),1),!1);let b=this.h,S=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=S&s|~S&a,t=1518500249):o<40?(i=S^s^a,t=1859775393):o<60?(i=S&s|S&a|s&a,t=2400959708):(i=S^s^a,t=3395469782),r=m(b,5)+i+n+t+h.getUint32(o*4,!1)&4294967295,n=a,a=s,s=m(S,30),S=b,b=r;this.h=this.h+b&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Ji=y}),define(oe[89],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(L||(L={})),function(N){const A="error",D="warning",R="warn",k="info",g="ignore";function C(m){return m?I.$2e(A,m)?N.Error:I.$2e(D,m)||I.$2e(R,m)?N.Warning:I.$2e(k,m)?N.Info:N.Ignore:N.Ignore}N.fromValue=C;function E(m){switch(m){case N.Error:return A;case N.Warning:return D;case N.Info:return k;default:return g}}N.toString=E}(L||(L={})),e.default=L}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class N{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const d=c.charCodeAt(0),p=this.b.charCodeAt(this.c);return d-p}value(){return this.b[this.c]}}e.$Rh=N;class A{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,L.$Ve)(c,this.b,0,c.length,this.c,this.d):(0,L.$Xe)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=A;class D{constructor(c=!0,d=!0){this.f=c,this.g=d}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let d=c.length-1;d>=0;d--,this.c--){const p=this.b.charCodeAt(d);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,L.$Ve)(c,this.b,0,c.length,this.d,this.e):(0,L.$Xe)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=D;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(c,d){this.f=c,this.g=d,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,L.$We)(c,this.c.scheme);if(this.d[this.e]===2)return(0,L.$We)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,L.$Ue)(c,this.c.query);if(this.d[this.e]===5)return(0,L.$Ue)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class E{static forUris(c=()=>!1,d=()=>!1){return new E(new k(c,d))}static forPaths(c=!1){return new E(new D(void 0,!c))}static forStrings(){return new E(new N)}static forConfigKeys(){return new E(new A)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,d){if(d){const p=d.slice(0);(0,I.$Xb)(p);for(const y of p)this.set(y,c)}else{const p=c.slice(0);(0,I.$Xb)(p);for(const y of p)this.set(y[0],y[1])}}set(c,d){const p=this.b.reset(c);let y;this.c||(this.c=new g,this.c.segment=p.value());const l=[];for(y=this.c;;){const u=p.cmp(y.segment);if(u>0)y.left||(y.left=new g,y.left.segment=p.value()),l.push([-1,y]),y=y.left;else if(u<0)y.right||(y.right=new g,y.right.segment=p.value()),l.push([1,y]),y=y.right;else if(p.hasNext())p.next(),y.mid||(y.mid=new g,y.mid.segment=p.value()),l.push([0,y]),y=y.mid;else break}const h=y.value;y.value=d,y.key=c;for(let u=l.length-1;u>=0;u--){const b=l[u][1];b.updateHeight();const S=b.balanceFactor();if(S<-1||S>1){const s=l[u][0],a=l[u+1][0];if(s===1&&a===1)l[u][1]=b.rotateLeft();else if(s===-1&&a===-1)l[u][1]=b.rotateRight();else if(s===1&&a===-1)b.right=l[u+1][1]=l[u+1][1].rotateRight(),l[u][1]=b.rotateLeft();else if(s===-1&&a===1)b.left=l[u+1][1]=l[u+1][1].rotateLeft(),l[u][1]=b.rotateRight();else throw new Error;if(u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this.c=l[0][1]}}return h}get(c){return this.d(c)?.value}d(c){const d=this.b.reset(c);let p=this.c;for(;p;){const y=d.cmp(p.segment);if(y>0)p=p.left;else if(y<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else break}return p}has(c){const d=this.d(c);return!(d?.value===void 0&&d?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,d){const p=this.b.reset(c),y=[];let l=this.c;for(;l;){const h=p.cmp(l.segment);if(h>0)y.push([-1,l]),l=l.left;else if(h<0)y.push([1,l]),l=l.right;else if(p.hasNext())p.next(),y.push([0,l]),l=l.mid;else break}if(l){if(d?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const h=this.f(l.right);if(h.key){const{key:u,value:b,segment:S}=h;this.e(h.key,!1),l.key=u,l.value=b,l.segment=S}}else{const h=l.left??l.right;if(y.length>0){const[u,b]=y[y.length-1];switch(u){case-1:b.left=h;break;case 0:b.mid=h;break;case 1:b.right=h;break}}else this.c=h}for(let h=y.length-1;h>=0;h--){const u=y[h][1];u.updateHeight();const b=u.balanceFactor();if(b>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),y[h][1]=u.rotateLeft()):b<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),y[h][1]=u.rotateRight()),h>0)switch(y[h-1][0]){case-1:y[h-1][1].left=y[h][1];break;case 1:y[h-1][1].right=y[h][1];break;case 0:y[h-1][1].mid=y[h][1];break}else this.c=y[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const d=this.b.reset(c);let p=this.c,y;for(;p;){const l=d.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(d.hasNext())d.next(),y=p.value||y,p=p.mid;else break}return p&&p.value||y}findSuperstr(c){return this.g(c,!1)}g(c,d){const p=this.b.reset(c);let y=this.c;for(;y;){const l=p.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(p.hasNext())p.next(),y=y.mid;else return y.mid?this.h(y.mid):d?y.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[d,p]of this)c(p,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const d=[];return this.j(c,d),d[Symbol.iterator]()}j(c,d){c&&(c.left&&this.j(c.left,d),c.value&&d.push([c.key,c.value]),c.mid&&this.j(c.mid,d),c.right&&this.j(c.right,d))}_isBalanced(){const c=d=>{if(!d)return!0;const p=d.balanceFactor();return p<-1||p>1?!1:c(d.left)&&c(d.right)};return c(this.c)}}e.$Vh=E}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function I(S){return typeof S=="string"}e.$yf=I;function L(S){return Array.isArray(S)&&S.every(s=>I(s))}e.$zf=L;function N(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}e.$Af=N;function A(S){const s=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof s}e.$Bf=A;function D(S){return typeof S=="number"&&!isNaN(S)}e.$Cf=D;function R(S){return!!S&&typeof S[Symbol.iterator]=="function"}e.$Df=R;function k(S){return S===!0||S===!1}e.$Ef=k;function g(S){return typeof S>"u"}e.$Ff=g;function C(S){return!E(S)}e.$Gf=C;function E(S){return g(S)||S===null}e.$Hf=E;function m(S,s){if(!S)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$If=m;function c(S){if(E(S))throw new Error("Assertion Failed: argument is undefined or null");return S}e.$Jf=c;function d(...S){const s=[];for(let a=0;a<S.length;a++){const n=S[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Kf=d;const p=Object.prototype.hasOwnProperty;function y(S){if(!N(S))return!1;for(const s in S)if(p.call(S,s))return!1;return!0}e.$Lf=y;function l(S){return typeof S=="function"}e.$Mf=l;function h(...S){return S.length>0&&S.every(l)}e.$Nf=h;function u(S,s){const a=Math.min(S.length,s.length);for(let n=0;n<a;n++)b(S[n],s[n])}e.$Of=u;function b(S,s){if(I(s)){if(typeof S!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(l(s)){try{if(S instanceof s)return}catch{}if(!E(S)&&S.constructor===s||s.length===1&&s.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=b}),define(oe[30],ae([0,1,12]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function L(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const h=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([u,b])=>{h[u]=b&&typeof b=="object"?L(b):b}),h}e.$7m=L;function N(l){if(!l||typeof l!="object")return l;const h=[l];for(;h.length>0;){const u=h.shift();Object.freeze(u);for(const b in u)if(A.call(u,b)){const S=u[b];typeof S=="object"&&!Object.isFrozen(S)&&!(0,I.$Bf)(S)&&h.push(S)}}return l}e.$8m=N;const A=Object.prototype.hasOwnProperty;function D(l,h){return R(l,h,new Set)}e.$9m=D;function R(l,h,u){if((0,I.$Hf)(l))return l;const b=h(l);if(typeof b<"u")return b;if(Array.isArray(l)){const S=[];for(const s of l)S.push(R(s,h,u));return S}if((0,I.$Af)(l)){if(u.has(l))throw new Error("Cannot clone recursive data-structure");u.add(l);const S={};for(const s in l)A.call(l,s)&&(S[s]=R(l[s],h,u));return u.delete(l),S}return l}function k(l,h,u=!0){return(0,I.$Af)(l)?((0,I.$Af)(h)&&Object.keys(h).forEach(b=>{b in l?u&&((0,I.$Af)(l[b])&&(0,I.$Af)(h[b])?k(l[b],h[b],u):l[b]=h[b]):l[b]=h[b]}),l):h}e.$0m=k;function g(l,h){if(l===h)return!0;if(l==null||h===null||h===void 0||typeof l!=typeof h||typeof l!="object"||Array.isArray(l)!==Array.isArray(h))return!1;let u,b;if(Array.isArray(l)){if(l.length!==h.length)return!1;for(u=0;u<l.length;u++)if(!g(l[u],h[u]))return!1}else{const S=[];for(b in l)S.push(b);S.sort();const s=[];for(b in h)s.push(b);if(s.sort(),!g(S,s))return!1;for(u=0;u<S.length;u++)if(!g(l[S[u]],h[S[u]]))return!1}return!0}e.$$m=g;function C(l){const h=new Set;return JSON.stringify(l,(u,b)=>{if((0,I.$Af)(b)||Array.isArray(b)){if(h.has(b))return"[Circular]";h.add(b)}return b})}e.$_m=C;function E(l,h){const u=Object.create(null);return!l||!h||Object.keys(h).forEach(S=>{const s=l[S],a=h[S];g(s,a)||(u[S]=a)}),u}e.$an=E;function m(l,h){const u=h.toLowerCase(),b=Object.keys(l).find(S=>S.toLowerCase()===u);return b?l[b]:l[h]}e.$bn=m;function c(l,h){const u=Object.create(null);for(const[b,S]of Object.entries(l))h(b,S)&&(u[b]=S);return u}e.$cn=c;function d(l){let h=[];for(;Object.prototype!==l;)h=h.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return h}e.$dn=d;function p(l){const h=[];for(const u of d(l))typeof l[u]=="function"&&h.push(u);return h}e.$en=p;function y(l,h){const u=S=>function(){const s=Array.prototype.slice.call(arguments,0);return h(S,s)},b={};for(const S of l)b[S]=u(S);return b}e.$fn=y}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(N){return I.test(N)}e.$dg=L,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),D=[];for(let R=0;R<256;R++)D.push(R.toString(16).padStart(2,"0"));return function(){N(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let k=0,g="";return g+=D[A[k++]],g+=D[A[k++]],g+=D[A[k++]],g+=D[A[k++]],g+="-",g+=D[A[k++]],g+=D[A[k++]],g+="-",g+=D[A[k++]],g+=D[A[k++]],g+="-",g+=D[A[k++]],g+=D[A[k++]],g+="-",g+=D[A[k++]],g+=D[A[k++]],g+=D[A[k++]],g+=D[A[k++]],g+=D[A[k++]],g+=D[A[k++]],g}}()}),define(oe[131],ae([0,1,36]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(D){const R=D.replace(/\-/g,":").toLowerCase();return!L.has(R)}function A(){const D=(0,I.networkInterfaces)();for(const R in D){const k=D[R];if(k){for(const{mac:g}of k)if(N(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=A}),define(oe[132],ae([0,1,268,15]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fT=void 0;class N extends I.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const R=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(D,R,k){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,L.$ce)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(D){this.a&&this.push(this.a),D()}}e.$fT=N}),define(oe[133],ae([0,1,62]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function L(R,k,g,C=1){let E=!1;return new Promise(m=>{const c=setTimeout(()=>{if(!E)return E=!0,m(0)},g);N(R,k,C,d=>{if(!E)return E=!0,clearTimeout(c),m(d)})})}e.$gg=L;function N(R,k,g,C){if(k===0)return C(0);const E=new I.Socket;E.once("connect",()=>(D(E),N(R+g,k-1,g,C))),E.once("data",()=>{}),E.once("error",m=>(D(E),m.code!=="ECONNREFUSED"?N(R+g,k-1,g,C):C(R))),E.connect(R,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,k,g,C="127.0.0.1"){let E=!1,m,c=1;const d=I.createServer({pauseOnConnect:!0});function p(y,l){E||(E=!0,d.removeAllListeners(),d.close(),m&&clearTimeout(m),l(y))}return new Promise(y=>{m=setTimeout(()=>{p(0,y)},g),d.on("listening",()=>{p(R,y)}),d.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&c<k?(R++,c++,d.listen(R,C)):p(0,y)}),d.on("close",()=>{p(0,y)}),d.listen(R,C)})}e.$ig=A;function D(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(oe[134],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=void 0;function I(L){return!!L.parentPort}e.$vT=I}),define(oe[135],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[63],ae([0,1,135]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const L=60,N=L*60,A=N*24,D=A*7,R=A*30,k=A*365;function g(E,m,c,d){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,I.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(!d&&p<30)return(0,I.localize)(1,null);let y;return p<L?(y=p,m?y===1?c?(0,I.localize)(2,null,y):(0,I.localize)(3,null,y):c?(0,I.localize)(4,null,y):(0,I.localize)(5,null,y):y===1?c?(0,I.localize)(6,null,y):(0,I.localize)(7,null,y):c?(0,I.localize)(8,null,y):(0,I.localize)(9,null,y)):p<N?(y=Math.floor(p/L),m?y===1?c?(0,I.localize)(10,null,y):(0,I.localize)(11,null,y):c?(0,I.localize)(12,null,y):(0,I.localize)(13,null,y):y===1?c?(0,I.localize)(14,null,y):(0,I.localize)(15,null,y):c?(0,I.localize)(16,null,y):(0,I.localize)(17,null,y)):p<A?(y=Math.floor(p/N),m?y===1?c?(0,I.localize)(18,null,y):(0,I.localize)(19,null,y):c?(0,I.localize)(20,null,y):(0,I.localize)(21,null,y):y===1?c?(0,I.localize)(22,null,y):(0,I.localize)(23,null,y):c?(0,I.localize)(24,null,y):(0,I.localize)(25,null,y)):p<D?(y=Math.floor(p/A),m?y===1?(0,I.localize)(26,null,y):(0,I.localize)(27,null,y):y===1?(0,I.localize)(28,null,y):(0,I.localize)(29,null,y)):p<R?(y=Math.floor(p/D),m?y===1?c?(0,I.localize)(30,null,y):(0,I.localize)(31,null,y):c?(0,I.localize)(32,null,y):(0,I.localize)(33,null,y):y===1?c?(0,I.localize)(34,null,y):(0,I.localize)(35,null,y):c?(0,I.localize)(36,null,y):(0,I.localize)(37,null,y)):p<k?(y=Math.floor(p/R),m?y===1?c?(0,I.localize)(38,null,y):(0,I.localize)(39,null,y):c?(0,I.localize)(40,null,y):(0,I.localize)(41,null,y):y===1?c?(0,I.localize)(42,null,y):(0,I.localize)(43,null,y):c?(0,I.localize)(44,null,y):(0,I.localize)(45,null,y)):(y=Math.floor(p/k),m?y===1?c?(0,I.localize)(46,null,y):(0,I.localize)(47,null,y):c?(0,I.localize)(48,null,y):(0,I.localize)(49,null,y):y===1?c?(0,I.localize)(50,null,y):(0,I.localize)(51,null,y):c?(0,I.localize)(52,null,y):(0,I.localize)(53,null,y))}e.$dm=g;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=C}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,136]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function A(E,m){return m&&(E.stack||E.stacktrace)?N.localize(0,null,R(E),D(E.stack)||D(E.stacktrace)):R(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?N.localize(1,null,E.message):E.message||N.localize(2,null)}function k(E=null,m=!1){if(!E)return N.localize(3,null);if(Array.isArray(E)){const c=I.$Hb(E),d=k(c[0],m);return c.length>1?N.localize(4,null,d,c.length):d}if(L.$yf(E))return E;if(E.detail){const c=E.detail;if(c.error)return A(c.error,m);if(c.exception)return A(c.exception,m)}return E.stack?A(E,m):E.message?E.message:N.localize(5,null)}e.$Ai=k;function g(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.$Bi=g;function C(E,m){let c;return typeof E=="string"?c=new Error(E):c=E,c.actions=m,c}e.$Ci=C}),define(oe[137],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[138],ae([0,1,137]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;function L(N){switch(N){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$wp=L}),define(oe[139],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,139]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let L=!1,N=!1,A=!1,D=!1,R=!1,k=!1,g=!1,C=!1,E=!1,m=!1,c,d=e.$g,p=e.$g,y,l;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?h=e.$h.vscode.process:typeof process<"u"&&(h=process);const u=typeof h?.versions?.electron=="string",b=u&&h?.type==="renderer";if(typeof navigator=="object"&&!b)l=navigator.userAgent,L=l.indexOf("Windows")>=0,N=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=l.indexOf("Linux")>=0,m=l?.indexOf("Mobi")>=0,k=!0,c=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,d=c,p=navigator.language;else if(typeof h=="object"){L=h.platform==="win32",N=h.platform==="darwin",A=h.platform==="linux",D=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,g=u,E=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,d=e.$g;const v=h.env.VSCODE_NLS_CONFIG;if(v)try{const w=JSON.parse(v),f=w.availableLanguages["*"];c=w.locale,p=w.osLocale,d=f||e.$g,y=w._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var S;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(S||(e.Platform=S={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let a=0;N?a=1:L?a=3:A&&(a=2),e.$j=L,e.$k=N,e.$l=A,e.$m=D,e.$n=R,e.$o=g,e.$p=k,e.$q=k&&typeof e.$h.importScripts=="function",e.$r=C,e.$s=m,e.$t=E,e.$u=a,e.$v=l,e.$w=d;var n;(function(v){function w(){return e.$w}v.value=w;function f(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=f;function $(){return e.$w==="en"}v.isDefault=$})(n||(e.Language=n={})),e.$x=c,e.$y=p,e.$z=y,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let $=0,j=v.length;$<j;$++){const F=v[$];if(F.id===f.data.vscodeScheduleAsyncWork){v.splice($,1),F.callback();return}}});let w=0;return f=>{const $=++w;v.push({id:$,callback:f}),e.$h.postMessage({vscodeScheduleAsyncWork:$},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=N||C?2:L?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=o,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.process<"u"){const N=I.$h.vscode.process;L={get platform(){return N.platform},get arch(){return N.arch},get env(){return N.env},cwd(){return N.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(oe[16],ae([0,1,37]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,N=97,A=90,D=122,R=46,k=47,g=92,C=58,E=63;class m extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,a){if(s===null||typeof s!="object")throw new m(a,"Object",s)}function d(s,a){if(typeof s!="string")throw new m(a,"string",s)}const p=I.$dc==="win32";function y(s){return s===k||s===g}function l(s){return s===k}function h(s){return s>=L&&s<=A||s>=N&&s<=D}function u(s,a,n,i){let t="",r=0,o=-1,v=0,w=0;for(let f=0;f<=s.length;++f){if(f<s.length)w=s.charCodeAt(f);else{if(i(w))break;w=k}if(i(w)){if(!(o===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const $=t.lastIndexOf(n);$===-1?(t="",r=0):(t=t.slice(0,$),r=t.length-1-t.lastIndexOf(n)),o=f,v=0;continue}else if(t.length!==0){t="",r=0,o=f,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,f)}`:t=s.slice(o+1,f),r=f-o-1;o=f,v=0}else w===R&&v!==-1?++v:v=-1}return t}function b(s,a){c(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$fc={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],d(r,"path"),r.length===0)continue}else a.length===0?r=I.cwd():(r=I.env[`=${a}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${a}\\`));const o=r.length;let v=0,w="",f=!1;const $=r.charCodeAt(0);if(o===1)y($)&&(v=1,f=!0);else if(y($))if(f=!0,y(r.charCodeAt(1))){let j=2,F=j;for(;j<o&&!y(r.charCodeAt(j));)j++;if(j<o&&j!==F){const z=r.slice(F,j);for(F=j;j<o&&y(r.charCodeAt(j));)j++;if(j<o&&j!==F){for(F=j;j<o&&!y(r.charCodeAt(j));)j++;(j===o||j!==F)&&(w=`\\\\${z}\\${r.slice(F,j)}`,v=j)}}}else v=1;else h($)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,o>2&&y(r.charCodeAt(2))&&(f=!0,v=3));if(w.length>0)if(a.length>0){if(w.toLowerCase()!==a.toLowerCase())continue}else a=w;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=f,f&&a.length>0)break}return n=u(n,!i,"\\",y),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){d(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return l(r)?"\\":s;if(y(r))if(t=!0,y(s.charCodeAt(1))){let v=2,w=v;for(;v<a&&!y(s.charCodeAt(v));)v++;if(v<a&&v!==w){const f=s.slice(w,v);for(w=v;v<a&&y(s.charCodeAt(v));)v++;if(v<a&&v!==w){for(w=v;v<a&&!y(s.charCodeAt(v));)v++;if(v===a)return`\\\\${f}\\${s.slice(w)}\\`;v!==w&&(i=`\\\\${f}\\${s.slice(w,v)}`,n=v)}}}else n=1;else h(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,a>2&&y(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?u(s.slice(n),!t,"\\",y):"";return o.length===0&&!t&&(o="."),o.length>0&&y(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){d(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return y(n)||a>2&&h(n)&&s.charCodeAt(1)===C&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];d(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++t;const r=n.length;r>1&&y(n.charCodeAt(1))&&(++t,r>2&&(y(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&y(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$fc.normalize(a)},relative(s,a){if(d(s,"from"),d(a,"to"),s===a)return"";const n=e.$fc.resolve(s),i=e.$fc.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===g;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===g;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===g;)v++;let w=a.length;for(;w-1>v&&a.charCodeAt(w-1)===g;)w--;const f=w-v,$=o<f?o:f;let j=-1,F=0;for(;F<$;F++){const U=s.charCodeAt(t+F);if(U!==a.charCodeAt(v+F))break;U===g&&(j=F)}if(F!==$){if(j===-1)return i}else{if(f>$){if(a.charCodeAt(v+F)===g)return i.slice(v+F+1);if(F===2)return i.slice(v+F)}o>$&&(s.charCodeAt(t+F)===g?j=F:F===2&&(j=3)),j===-1&&(j=0)}let z="";for(F=t+j+1;F<=r;++F)(F===r||s.charCodeAt(F)===g)&&(z+=z.length===0?"..":"\\..");return v+=j,z.length>0?`${z}${i.slice(v,w)}`:(i.charCodeAt(v)===g&&++v,i.slice(v,w))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$fc.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const n=a.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(h(a.charCodeAt(0))&&a.charCodeAt(1)===C&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return s},dirname(s){d(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return y(t)?s:".";if(y(t)){if(n=i=1,y(s.charCodeAt(1))){let v=2,w=v;for(;v<a&&!y(s.charCodeAt(v));)v++;if(v<a&&v!==w){for(w=v;v<a&&y(s.charCodeAt(v));)v++;if(v<a&&v!==w){for(w=v;v<a&&!y(s.charCodeAt(v));)v++;if(v===a)return s;v!==w&&(n=i=v+1)}}}}else h(t)&&s.charCodeAt(1)===C&&(n=a>2&&y(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(y(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&d(a,"ext"),d(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&h(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const w=s.charCodeAt(r);if(y(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(w===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(y(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){d(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===C&&h(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const w=s.charCodeAt(v);if(y(w)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:b.bind(null,"\\"),parse(s){d(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return y(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(y(t)){if(i=1,y(s.charCodeAt(1))){let j=2,F=j;for(;j<n&&!y(s.charCodeAt(j));)j++;if(j<n&&j!==F){for(F=j;j<n&&y(s.charCodeAt(j));)j++;if(j<n&&j!==F){for(F=j;j<n&&!y(s.charCodeAt(j));)j++;j===n?i=j:j!==F&&(i=j+1)}}}}else if(h(t)&&s.charCodeAt(1)===C){if(n<=2)return a.root=a.dir=s,a;if(i=2,y(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,w=!0,f=s.length-1,$=0;for(;f>=i;--f){if(t=s.charCodeAt(f),y(t)){if(!w){o=f+1;break}continue}v===-1&&(w=!1,v=f+1),t===R?r===-1?r=f:$!==1&&($=1):r!==-1&&($=-1)}return v!==-1&&(r===-1||$===0||$===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(p){const s=/\\/g;return()=>{const a=I.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:S();d(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===k)}return a=u(a,!n,"/",l),n?`/${a}`:a.length>0?a:"."},normalize(s){if(d(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===k,n=s.charCodeAt(s.length-1)===k;return s=u(s,!a,"/",l),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return d(s,"path"),s.length>0&&s.charCodeAt(0)===k},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];d(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$gc.normalize(a)},relative(s,a){if(d(s,"from"),d(a,"to"),s===a||(s=e.$gc.resolve(s),a=e.$gc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let w=-1,f=0;for(;f<v;f++){const j=s.charCodeAt(n+f);if(j!==a.charCodeAt(r+f))break;j===k&&(w=f)}if(f===v)if(o>v){if(a.charCodeAt(r+f)===k)return a.slice(r+f+1);if(f===0)return a.slice(r+f)}else t>v&&(s.charCodeAt(n+f)===k?w=f:f===0&&(w=0));let $="";for(f=n+w+1;f<=i;++f)(f===i||s.charCodeAt(f)===k)&&($+=$.length===0?"..":"/..");return`${$}${a.slice(r+w)}`},toNamespacedPath(s){return s},dirname(s){if(d(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===k;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===k){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&d(a,"ext"),d(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const w=s.charCodeAt(r);if(w===k){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(w===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===k){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){d(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===k){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===R?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:b.bind(null,"/"),parse(s){d(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===k;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,w=s.length-1,f=0;for(;w>=i;--w){const $=s.charCodeAt(w);if($===k){if(!v){r=w+1;break}continue}o===-1&&(v=!1,o=w+1),$===R?t===-1?t=w:f!==1&&(f=1):t!==-1&&(f=-1)}if(o!==-1){const $=r===0&&n?1:r;t===-1||f===0||f===1&&t===o-1&&t===r+1?a.base=a.name=s.slice($,o):(a.name=s.slice($,t),a.base=s.slice($,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(oe[48],ae([0,1,16,5,27,12]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function D(r){return r===47||r===92}e.$Qf=D;function R(r){return r.replace(/[\\/]/g,I.$gc.sep)}e.$Rf=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=k;function g(r,o=I.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(D(w)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let $=3;const j=$;for(;$<v&&!D(r.charCodeAt($));$++);if(j!==$&&!D(r.charCodeAt($+1))){for($+=1;$<v;$++)if(D(r.charCodeAt($)))return r.slice(0,$+1).replace(/[\\/]/g,o)}}return o}else if(l(w)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(D(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Tf=g;function C(r){if(!L.$j||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const w=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(w===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Uf=C;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,o=L.$j){const v=o?E:m;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&c.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Vf=d;function p(r,o,v){const w=r===o;return!v||w?w:!r||!o?!1:(0,N.$2e)(r,o)}e.$Wf=p;function y(r,o,v,w=I.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,N.$3e)(r,o))return!1;if(o.length===r.length)return!0;let $=o.length;return o.charAt(o.length-1)===w&&$--,r.charAt($)===w}return o.charAt(o.length-1)!==w&&(o+=w),r.indexOf(o)===0}e.$Xf=y;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=l;function h(r,o){return L.$j&&r.endsWith(":")&&(r+=I.sep),(0,I.$ic)(r)||(r=(0,I.$jc)(o,r)),r=(0,I.$hc)(r),L.$j?(r=(0,N.$Ke)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,N.$Ke)(r,I.sep),r||(r=I.sep)),r}e.$Zf=h;function u(r){const o=(0,I.$hc)(r);return L.$j?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===I.$gc.sep}e.$1f=u;function b(r,o=L.$j){return o?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=b;function S(r,o=L.$j){return b(r,o)?r[0]:void 0}e.$3f=S;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$4f=s;function a(r){const o=r.split(":");let v,w,f;for(const $ of o){const j=Number($);(0,A.$Cf)(j)?w===void 0?w=j:f===void 0&&(f=j):v=v?[v,$].join(":"):$}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.$5f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let w="";for(let $=0;$<v;$++){let j;$===0&&L.$j&&!o&&(v===3||v===4)?j=i:j=n,w+=j.charAt(Math.floor(Math.random()*j.length))}let f;return o?f=`${o}-${w}`:f=w,r?(0,I.$jc)(r,f):f}e.$6f=t}),define(oe[140],ae([0,1,16]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0,e.$Pr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const E=(0,I.$oc)(C),m=L[E.toLowerCase()];return m!==void 0?m:D(C)}e.$Qr=A;function D(C){const E=(0,I.$oc)(C);return N[E.toLowerCase()]}e.$Rr=D;function R(C){for(const E in N)if(N[E]===C)return E}e.$Sr=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,E){const m=k.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:C}e.$Tr=g}),define(oe[90],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L||(e.Source=L={}));var N;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function A(R,...k){const g=k.reduce((m,c)=>(m[c]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!g[m]).forEach(m=>{for(let c=0;c<C.length;c++)if(m.search(C[c])!==-1){delete R[m];break}})}e.$zl=A;function D(R){R&&(delete R.DEBUG,I.$k&&delete R.DYLD_LIBRARY_PATH,I.$l&&delete R.LD_PRELOAD)}e.$Al=D}),define(oe[10],ae([0,1,16,5]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const N=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!N.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,t){return!i&&!t?"file":i}function g(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const C="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,w,f=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,f),this.authority=r||C,this.path=g(this.scheme,o||C),this.query=v||C,this.fragment=w||C,R(this,f))}get fsPath(){return b(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:w,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=C),o===void 0?o=this.authority:o===null&&(o=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),f===void 0?f=this.fragment:f===null&&(f=C),r===this.scheme&&o===this.authority&&v===this.path&&w===this.query&&f===this.fragment?this:new y(r,o,v,w,f)}static parse(t,r=!1){const o=m.exec(t);return o?new y(o[2]||C,n(o[4]||C),n(o[5]||C),n(o[7]||C),n(o[9]||C),r):new y(C,C,C,C,C)}static file(t){let r=C;if(L.$j&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new y("file",r,t,C,C)}static from(t,r){return new y(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return L.$j&&t.scheme==="file"?o=c.file(I.$fc.join(b(t,!0),...r)).path:o=I.$gc.join(t.path,...r),t.with({path:o})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new y(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=c;function d(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=d;const p=L.$j?1:void 0;class y extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,t,r){let o,v=-1;for(let w=0;w<i.length;w++){const f=i.charCodeAt(w);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,w)),v=-1),o!==void 0&&(o+=i.charAt(w));else{o===void 0&&(o=i.substr(0,w));const $=l[f];$!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,w)),v=-1),o+=$):v===-1&&(v=w)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function u(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=l[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function b(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,L.$j&&(r=r.replace(/\//g,"\\")),r}e.$wc=b;function S(i,t){const r=t?u:h;let o="",{scheme:v,authority:w,path:f,query:$,fragment:j}=i;if(v&&(o+=v,o+=":"),(w||v==="file")&&(o+=E,o+=E),w){let F=w.indexOf("@");if(F!==-1){const z=w.substr(0,F);w=w.substr(F+1),F=z.lastIndexOf(":"),F===-1?o+=r(z,!1,!1):(o+=r(z.substr(0,F),!1,!1),o+=":",o+=r(z.substr(F+1),!1,!0)),o+="@"}w=w.toLowerCase(),F=w.lastIndexOf(":"),F===-1?o+=r(w,!1,!0):(o+=r(w.substr(0,F),!1,!0),o+=w.substr(F))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const F=f.charCodeAt(1);F>=65&&F<=90&&(f=`/${String.fromCharCode(F+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const F=f.charCodeAt(0);F>=65&&F<=90&&(f=`${String.fromCharCode(F+32)}:${f.substr(2)}`)}o+=r(f,!0,!1)}return $&&(o+="?",o+=r($,!1,!1)),j&&(o+="#",o+=t?j:h(j,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(oe[141],ae([0,1,10]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Zp=e.$Yp=e.$Xp=void 0;function L(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Xp=L;function N(g){const C=[];let E;try{const m=JSON.parse(g.arguments),c=m[m.length-1];c&&c.__$stack&&(m.pop(),E=c.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:E}}e.$Yp=N;function A(g){if(typeof g!="string")return A(N(g).stack);const C=g;if(C){const E=D(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:I.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Zp=A;function D(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:E,stack:m}=N(g),c=typeof E[0]=="string"&&E.length===1;let d=D(m);d&&(d=`(${d.trim()})`);let p=[];if(typeof E[0]=="string"?d&&c?p=[`%c[${C}] %c${E[0]} %c${d}`,k("blue"),k(""),k("grey")]:p=[`%c[${C}] %c${E[0]}`,k("blue"),k(""),...E.slice(1)]:p=[`%c[${C}]%`,k("blue"),...E],d&&!c&&p.push(d),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=R;function k(g){return`color: ${g}`}}),define(oe[64],ae([0,1,15,10]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function N(k){return JSON.stringify(k,D)}e.$kh=N;function A(k){let g=JSON.parse(k);return g=R(g),g}e.$lh=A;function D(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return L.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof I.$be||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$mh=R}),define(oe[23],ae([0,1,8,5,10]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var A;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$7f="vscode-tkn",e.$8f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${A.vscodeRemoteResource}`}set(C,E,m){this.a[C]=E,this.b[C]=m}setConnectionToken(C,E){this.c[C]=E}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(y){return I.$1(y),C}const E=C.authority;let m=this.a[E];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const c=this.b[E],d=this.c[E];let p=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(p+=`&${e.$8f}=${encodeURIComponent(d)}`),N.URI.from({scheme:L.$p?this.d:A.vscodeRemoteResource,authority:`${m}:${c}`,path:this.f,query:p})}}e.$9f=new D,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class R{static{this.a=e.$bg}asBrowserUri(C){const E=this.b(C,te);return this.uriToBrowserUri(E)}uriToBrowserUri(C){return C.scheme===A.vscodeRemote?e.$9f.rewrite(C):C.scheme===A.file&&(L.$n||L.$q&&L.$h.origin===`${A.vscodeFileResource}://${R.a}`)?C.with({scheme:A.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const E=this.b(C,te);return this.uriToFileUri(E)}uriToFileUri(C){return C.scheme===A.vscodeFileResource?C.with({scheme:A.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,E){return N.URI.isUri(C)?C:N.URI.parse(E.toUrl(C))}}e.$cg=new R;var k;(function(g){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(C.get("3"));const E="vscode-coi";function m(d){let p;typeof d=="string"?p=new URL(d).searchParams:d instanceof URL?p=d.searchParams:N.URI.isUri(d)&&(p=new URL(d.toString(!0)).searchParams);const y=p?.get(E);if(y)return C.get(y)}g.getHeadersFromQuery=m;function c(d,p,y){if(!globalThis.crossOriginIsolated)return;const l=p&&y?"3":y?"2":"1";d instanceof URLSearchParams?d.set(E,l):d[E]=l}g.addSearchParam=c})(k||(e.COI=k={}))}),define(oe[142],ae([0,1,124,23,5,10]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=void 0;class D{constructor(m,c,d){this.id=m,this.dependencies=c,this.callback=d}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,c,d)=>{typeof m!="string"&&(d=c,c=m,m=null),(typeof c!="object"||!Array.isArray(c))&&(d=c,c=null),this.c.push(new D(m,c,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const c=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!c)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(m){return new Promise((c,d)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const y=()=>{p.removeEventListener("load",l),p.removeEventListener("error",h)},l=u=>{y(),c(this.c.pop())},h=u=>{y(),d(u)};p.addEventListener("load",l),p.addEventListener("error",h),this.f&&(m=this.f.createScriptURL(m)),p.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(p)})}i(m){return new Promise((c,d)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),c(this.c.pop())}catch(p){d(p)}})}async j(m){try{const c=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,y=A.URI.parse(m).fsPath,l=c.readFileSync(y).toString(),h=p.wrap(l.replace(/^#!.*/,""));return new d.Script(h).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(E,m,c){if(I.$T){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[E]&&(E=g[E]);const d=`${E}/${m}`;if(k.has(d))return k.get(d);let p;if(/^\w[\w\d+.-]*:\/\//.test(d))p=d;else{const u=`${c&&!N.$p?L.$_f:L.$$f}/${d}`;p=L.$cg.asBrowserUri(u).toString(!0)}const y=R.INSTANCE.load(p);return k.set(d,y),y}else return await new Promise((d,p)=>{te([E],d,p)})}e.$mC=C}),define(oe[19],ae([0,1,48,23,16,5,27,10]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function k(c){return(0,R.$wc)(c,!0)}e.$jg=k;class g{constructor(d){this.a=d}compare(d,p,y=!1){return d===p?0:(0,D.$Ue)(this.getComparisonKey(d,y),this.getComparisonKey(p,y))}isEqual(d,p,y=!1){return d===p?!0:!d||!p?!1:this.getComparisonKey(d,y)===this.getComparisonKey(p,y)}getComparisonKey(d,p=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,p,y=!1){if(d.scheme===p.scheme){if(d.scheme===L.Schemas.file)return I.$Xf(k(d),k(p),this.a(d))&&d.query===p.query&&(y||d.fragment===p.fragment);if((0,e.$Ag)(d.authority,p.authority))return I.$Xf(d.path,p.path,this.a(d),"/")&&d.query===p.query&&(y||d.fragment===p.fragment)}return!1}joinPath(d,...p){return R.URI.joinPath(d,...p)}basenameOrAuthority(d){return(0,e.$sg)(d)||d.authority}basename(d){return N.$gc.basename(d.path)}extname(d){return N.$gc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let p;return d.scheme===L.Schemas.file?p=R.URI.file(N.$mc(k(d))).path:(p=N.$gc.dirname(d.path),d.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),p="/")),d.with({path:p})}normalizePath(d){if(!d.path.length)return d;let p;return d.scheme===L.Schemas.file?p=R.URI.file(N.$hc(k(d))).path:p=N.$gc.normalize(d.path),d.with({path:p})}relativePath(d,p){if(d.scheme!==p.scheme||!(0,e.$Ag)(d.authority,p.authority))return;if(d.scheme===L.Schemas.file){const h=N.$lc(k(d),k(p));return A.$j?I.$Rf(h):h}let y=d.path||"/";const l=p.path||"/";if(this.a(d)){let h=0;for(const u=Math.min(y.length,l.length);h<u&&!(y.charCodeAt(h)!==l.charCodeAt(h)&&y.charAt(h).toLowerCase()!==l.charAt(h).toLowerCase());h++);y=l.substr(0,h)+y.substr(h)}return N.$gc.relative(y,l)}resolvePath(d,p){if(d.scheme===L.Schemas.file){const y=R.URI.file(N.$kc(k(d),p));return d.with({authority:y.authority,path:y.path})}return p=I.$Sf(p),d.with({path:N.$gc.resolve(d.path,p)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,p){return d===p||d!==void 0&&p!==void 0&&(0,D.$2e)(d,p)}hasTrailingPathSeparator(d,p=N.sep){if(d.scheme===L.Schemas.file){const y=k(d);return y.length>I.$Tf(y).length&&y[y.length-1]===p}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,p=N.sep){return(0,e.$Bg)(d,p)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,p=N.sep){let y=!1;if(d.scheme===L.Schemas.file){const l=k(d);y=l!==void 0&&l.length===I.$Tf(l).length&&l[l.length-1]===p}else{p="/";const l=d.path;y=l.length===1&&l.charCodeAt(l.length-1)===47}return!y&&!(0,e.$Bg)(d,p)?d.with({path:d.path+"/"}):d}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(c=>c.scheme===L.Schemas.file?!A.$l:!0),e.$ng=new g(c=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function C(c,d){const p=[];for(let y=0;y<c.length;y++){const l=d(c[y]);c.some((h,u)=>u===y?!1:(0,e.$pg)(l,d(h)))||p.push(c[y])}return p}e.$Eg=C;var E;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function d(p){const y=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(u=>{const[b,S]=u.split(":");b&&S&&y.set(b,S)});const h=p.path.substring(0,p.path.indexOf(";"));return h&&y.set(c.META_DATA_MIME,h),y}c.parseMetaData=d})(E||(e.DataUri=E={}));function m(c,d,p){if(d){let y=c.path;return y&&y[0]!==N.$gc.sep&&(y=N.$gc.sep+y),c.with({scheme:p,authority:d,path:y})}return c.with({scheme:p})}e.$Fg=m}),define(oe[6],ae([0,1,26,8,3,2,19,5,130]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(O){return!!O&&typeof O.then=="function"}e.$Gg=g;function C(O){const T=new I.$Xd,M=O(T.token),V=new Promise((J,re)=>{const ce=T.token.onCancellationRequested(()=>{ce.dispose(),T.dispose(),re(new L.$5)});Promise.resolve(M).then(ue=>{ce.dispose(),T.dispose(),J(ue)},ue=>{ce.dispose(),T.dispose(),re(ue)})});return new class{cancel(){T.cancel()}then(J,re){return V.then(J,re)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.$Hg=C;function E(O,T,M){return new Promise((V,J)=>{const re=T.onCancellationRequested(()=>{re.dispose(),V(M)});O.then(V,J).finally(()=>re.dispose())})}e.$Ig=E;function m(O,T){return new Promise((M,V)=>{const J=T.onCancellationRequested(()=>{J.dispose(),V(new L.$5)});O.then(M,V).finally(()=>J.dispose())})}e.$Jg=m;async function c(O){let T=-1;const M=O.map((V,J)=>V.then(re=>(T=J,re)));try{return await Promise.race(M)}finally{O.forEach((V,J)=>{J!==T&&V.cancel()})}}e.$Kg=c;function d(O,T,M){let V;const J=setTimeout(()=>{V?.(void 0),M?.()},T);return Promise.race([O.finally(()=>clearTimeout(J)),new Promise(re=>V=re)])}e.$Lg=d;function p(O){return new Promise((T,M)=>{const V=O();g(V)?V.then(T,M):T(V)})}e.$Mg=p;class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const M=()=>{if(this.b=null,this.f)return;const V=this.queue(this.d);return this.d=null,V};this.b=new Promise(V=>{this.a.then(M,M).then(V)})}return new Promise((M,V)=>{this.b.then(M,V)})}return this.a=T(),new Promise((M,V)=>{this.a.then(J=>{this.a=null,M(J)},J=>{this.a=null,V(J)})})}dispose(){this.f=!0}}e.$Ng=y;class l{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$Og=l;class h{constructor(){this.a=new Map}queue(T,M){const J=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(T)===J&&this.a.delete(T)});return this.a.set(T,J),J}}e.$Pg=h;const u=(O,T)=>{let M=!0;const V=setTimeout(()=>{M=!1,T()},O);return{isTriggered:()=>M,dispose:()=>{clearTimeout(V),M=!1}}},b=O=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,O())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class S{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,M=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((J,re)=>{this.d=J,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const V=()=>{this.a=null,this.d?.(null)};return this.a=M===k.$Kd?b(V):u(M,V),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=S;class s{constructor(T){this.a=new S(T),this.b=new y}trigger(T,M){return this.a.trigger(()=>this.b.queue(T),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=s;class a{constructor(){this.a=!1,this.b=new Promise((T,M)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=a;class n extends a{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Tg=n;function i(O,T){return T?new Promise((M,V)=>{const J=setTimeout(()=>{re.dispose(),M()},O),re=T.onCancellationRequested(()=>{clearTimeout(J),re.dispose(),V(new L.$5)})}):C(M=>i(O,M))}e.$Ug=i;function t(O,T=0,M){const V=setTimeout(()=>{O(),M&&J.dispose()},T),J=(0,A.$Qc)(()=>{clearTimeout(V),M?.deleteAndLeak(J)});return M?.add(J),J}e.$Vg=t;function r(O){const T=[];let M=0;const V=O.length;function J(){return M<V?O[M++]():null}function re(ce){ce!=null&&T.push(ce);const ue=J();return ue?ue.then(re):Promise.resolve(T)}return Promise.resolve(null).then(re)}e.$Wg=r;function o(O,T=V=>!!V,M=null){let V=0;const J=O.length,re=()=>{if(V>=J)return Promise.resolve(M);const ce=O[V++];return Promise.resolve(ce()).then(he=>T(he)?Promise.resolve(he):re())};return re()}e.$Xg=o;function v(O,T=V=>!!V,M=null){if(O.length===0)return Promise.resolve(M);let V=O.length;const J=()=>{V=-1;for(const re of O)re.cancel?.()};return new Promise((re,ce)=>{for(const ue of O)ue.then(he=>{--V>=0&&T(he)?(J(),re(he)):V===0&&re(M)}).catch(he=>{--V>=0&&(J(),ce(he))})})}e.$Yg=v;class w{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new N.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((M,V)=>{this.f.push({factory:T,c:M,e:V}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const M=T.factory();M.then(T.c,T.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=w;class f extends w{constructor(){super(1)}}e.$1g=f;class ${constructor(){this.a=new Q,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$2g=$;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new ee;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,M=D.$lg){const V=M.getComparisonKey(T);let J=this.a.get(V);if(!J){J=new f;const re=this.f++,ce=N.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(V),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$1c),this.d.set(re,ce),this.a.set(V,J)}return J}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=j;class F{constructor(T,M){this.a=-1,typeof T=="function"&&typeof M=="number"&&this.setIfNotSet(T,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},M)}setIfNotSet(T,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},M))}}e.$4g=F;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,M){this.cancel(),this.a=setInterval(()=>{T()},M)}}e.$5g=z;class U{constructor(T,M){this.b=-1,this.a=T,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=U;class q{constructor(T,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=T,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=q;class Z extends U{constructor(T,M){super(T,M),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$8g=Z;class K extends A.$Sc{constructor(T,M){super(),this.g=T,this.h=M,this.a=[],this.b=this.B(new A.$Tc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of T)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=K,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=O=>{(0,R.$B)(()=>{if(T)return;const M=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$0g=(O,T)=>{const M=requestIdleCallback(O,typeof T=="number"?{timeout:T}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(M))}}}}();class x{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=x;async function H(O,T,M){let V;for(let J=0;J<M;J++)try{return await O()}catch(re){V=re,await i(T)}throw V}e.$_g=H;class Q{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,M,V){return this.a={taskId:T,cancel:()=>V?.(),promise:M},M.then(()=>this.d(T),()=>this.d(T)),M}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let M,V;const J=new Promise((re,ce)=>{M=re,V=ce});this.b={run:T,promise:J,promiseResolve:M,promiseReject:V}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Q;class G{constructor(T,M=()=>Date.now()){this.d=T,this.f=M,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$bh=G;var W;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(W||(W={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,M)=>{this.a=T,this.b=M})}complete(T){return new Promise(M=>{this.a(T),this.d={outcome:0,value:T},M()})}error(T){return new Promise(M=>{this.b(T),this.d={outcome:1,value:T},M()})}cancel(){return this.error(new L.$5)}}e.$ch=ee;var ne;(function(O){async function T(V){let J;const re=await Promise.all(V.map(ce=>ce.then(ue=>ue,ue=>{J||(J=ue)})));if(typeof J<"u")throw J;return re}O.settled=T;function M(V){return new Promise(async(J,re)=>{try{await V(J,re)}catch(ce){re(ce)}})}O.withAsyncBody=M})(ne||(e.Promises=ne={}));var _;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(_||(_={}));class ie{static fromArray(T){return new ie(M=>{M.emitMany(T)})}static fromPromise(T){return new ie(async M=>{M.emitMany(await T)})}static fromPromises(T){return new ie(async M=>{await Promise.all(T.map(async V=>M.emitOne(await V)))})}static merge(T){return new ie(async M=>{await Promise.all(T.map(async V=>{for await(const J of V)M.emitOne(J)}))})}static{this.EMPTY=ie.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new N.$Nd,queueMicrotask(async()=>{const M={emitOne:V=>this.g(V),emitMany:V=>this.h(V),reject:V=>this.k(V)};try{await Promise.resolve(T(M)),this.j()}catch(V){this.k(V)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await N.Event.toPromise(this.f.event)}while(!0)}}}static map(T,M){return new ie(async V=>{for await(const J of T)V.emitOne(M(J))})}map(T){return ie.map(this,T)}static filter(T,M){return new ie(async V=>{for await(const J of T)M(J)&&V.emitOne(J)})}filter(T){return ie.filter(this,T)}static coalesce(T){return ie.filter(T,M=>!!M)}coalesce(){return ie.coalesce(this)}static async toPromise(T){const M=[];for await(const V of T)M.push(V);return M}toPromise(){return ie.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$dh=ie;class X extends ie{constructor(T,M){super(M),this.l=T}cancel(){this.l.cancel()}}e.$eh=X;function B(O){const T=new I.$Xd,M=O(T.token);return new X(T,async V=>{const J=T.token.onCancellationRequested(()=>{J.dispose(),T.dispose(),V.reject(new L.$5)});try{for await(const re of M){if(T.token.isCancellationRequested)return;V.emitOne(re)}J.dispose(),T.dispose()}catch(re){J.dispose(),T.dispose(),V.reject(re)}})}e.$fh=B;class P{constructor(){this.a=new ee,this.b=new ie(V=>{if(T){V.reject(T);return}return M&&V.emitMany(M),this.d=J=>V.reject(J),this.f=J=>V.emitOne(J),this.a.p});let T,M;this.f=V=>{M||(M=[]),M.push(V)},this.d=V=>{T||(T=V)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(T){this.d(T),this.a.complete()}emit(T){this.f(T)}}e.$gh=P}),define(oe[91],ae([0,1,18,6,48,34,16,5,27]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function g(){return Object.create(null)}e.$rj=g,e.$sj="**",e.$tj="/";const C="[/\\\\]",E="[^/\\\\]",m=/\//g;function c(Q,G){switch(Q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${G?`|${C}${E}+`:""})*?`}}function d(Q,G){if(!Q)return[];const W=[];let ee=!1,ne=!1,_="";for(const ie of Q){switch(ie){case G:if(!ee&&!ne){W.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=ie}return _&&W.push(_),W}e.$uj=d;function p(Q){if(!Q)return"";let G="";const W=d(Q,e.$tj);if(W.every(ee=>ee===e.$sj))G=".*";else{let ee=!1;W.forEach((ne,_)=>{if(ne===e.$sj){if(ee)return;G+=c(2,_===W.length-1)}else{let ie=!1,X="",B=!1,P="";for(const O of ne){if(O!=="}"&&ie){X+=O;continue}if(B&&(O!=="]"||!P)){let T;O==="-"?T=O:(O==="^"||O==="!")&&!P?T="^":O===e.$tj?T="":T=(0,k.$Fe)(O),P+=T;continue}switch(O){case"{":ie=!0;continue;case"[":B=!0;continue;case"}":{const M=`(?:${d(X,",").map(V=>p(V)).join("|")})`;G+=M,ie=!1,X="";break}case"]":{G+="["+P+"]",B=!1,P="";break}case"?":G+=E;continue;case"*":G+=c(1);continue;default:G+=(0,k.$Fe)(O)}}_<W.length-1&&(W[_+1]!==e.$sj||_+2<W.length)&&(G+=C)}ee=ne===e.$sj})}return G}const y=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.$Dc(1e4),a=function(){return!1},n=function(){return null};function i(Q,G){if(!Q)return n;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const ee=`${W}_${!!G.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Q);let _;return y.test(W)?ne=o(W.substr(4),W):(_=l.exec(r(W,G)))?ne=v(_[1],W):(G.trimForExclusions?u:h).test(W)?ne=w(W,G):(_=b.exec(r(W,G)))?ne=f(_[1].substr(1),W,!0):(_=S.exec(r(W,G)))?ne=f(_[1],W,!1):ne=$(W),s.set(ee,ne),t(ne,Q)}function t(Q,G){if(typeof G=="string")return Q;const W=function(ee,ne){return(0,N.$Xf)(ee,G.base,!R.$l)?Q((0,k.$Je)(ee.substr(G.base.length),D.sep),ne):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function r(Q,G){return G.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function o(Q,G){return function(W,ee){return typeof W=="string"&&W.endsWith(Q)?G:null}}function v(Q,G){const W=`/${Q}`,ee=`\\${Q}`,ne=function(ie,X){return typeof ie!="string"?null:X?X===Q?G:null:ie===Q||ie.endsWith(W)||ie.endsWith(ee)?G:null},_=[Q];return ne.basenames=_,ne.patterns=[G],ne.allBasenames=_,ne}function w(Q,G){const W=x(Q.slice(1,-1).split(",").map(X=>i(X,G)).filter(X=>X!==n),Q),ee=W.length;if(!ee)return n;if(ee===1)return W[0];const ne=function(X,B){for(let P=0,O=W.length;P<O;P++)if(W[P](X,B))return Q;return null},_=W.find(X=>!!X.allBasenames);_&&(ne.allBasenames=_.allBasenames);const ie=W.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return ie.length&&(ne.allPaths=ie),ne}function f(Q,G,W){const ee=D.sep===D.$gc.sep,ne=ee?Q:Q.replace(m,D.sep),_=D.sep+ne,ie=D.$gc.sep+Q;let X;return W?X=function(B,P){return typeof B=="string"&&(B===ne||B.endsWith(_)||!ee&&(B===Q||B.endsWith(ie)))?G:null}:X=function(B,P){return typeof B=="string"&&(B===ne||!ee&&B===Q)?G:null},X.allPaths=[(W?"*/":"./")+Q],X}function $(Q){try{const G=new RegExp(`^${p(Q)}$`);return function(W){return G.lastIndex=0,typeof W=="string"&&G.test(W)?Q:null}}catch{return n}}function j(Q,G,W){return!Q||typeof G!="string"?!1:F(Q)(G,void 0,W)}e.$vj=j;function F(Q,G={}){if(!Q)return a;if(typeof Q=="string"||z(Q)){const W=i(Q,G);if(W===n)return a;const ee=function(ne,_){return!!W(ne,_)};return W.allBasenames&&(ee.allBasenames=W.allBasenames),W.allPaths&&(ee.allPaths=W.allPaths),ee}return Z(Q,G)}e.$wj=F;function z(Q){const G=Q;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$xj=z;function U(Q){return Q.allBasenames||[]}e.$yj=U;function q(Q){return Q.allPaths||[]}e.$zj=q;function Z(Q,G){const W=x(Object.getOwnPropertyNames(Q).map(X=>K(X,Q[X],G)).filter(X=>X!==n)),ee=W.length;if(!ee)return n;if(!W.some(X=>!!X.requiresSiblings)){if(ee===1)return W[0];const X=function(O,T){let M;for(let V=0,J=W.length;V<J;V++){const re=W[V](O,T);if(typeof re=="string")return re;(0,L.$Gg)(re)&&(M||(M=[]),M.push(re))}return M?(async()=>{for(const V of M){const J=await V;if(typeof J=="string")return J}return null})():null},B=W.find(O=>!!O.allBasenames);B&&(X.allBasenames=B.allBasenames);const P=W.reduce((O,T)=>T.allPaths?O.concat(T.allPaths):O,[]);return P.length&&(X.allPaths=P),X}const ne=function(X,B,P){let O,T;for(let M=0,V=W.length;M<V;M++){const J=W[M];J.requiresSiblings&&P&&(B||(B=(0,D.$nc)(X)),O||(O=B.substr(0,B.length-(0,D.$oc)(X).length)));const re=J(X,B,O,P);if(typeof re=="string")return re;(0,L.$Gg)(re)&&(T||(T=[]),T.push(re))}return T?(async()=>{for(const M of T){const V=await M;if(typeof V=="string")return V}return null})():null},_=W.find(X=>!!X.allBasenames);_&&(ne.allBasenames=_.allBasenames);const ie=W.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return ie.length&&(ne.allPaths=ie),ne}function K(Q,G,W){if(G===!1)return n;const ee=i(Q,W);if(ee===n)return n;if(typeof G=="boolean")return ee;if(G){const ne=G.when;if(typeof ne=="string"){const _=(ie,X,B,P)=>{if(!P||!ee(ie,X))return null;const O=ne.replace("$(basename)",()=>B),T=P(O);return(0,L.$Gg)(T)?T.then(M=>M?Q:null):T?Q:null};return _.requiresSiblings=!0,_}}return ee}function x(Q,G){const W=Q.filter(X=>!!X.basenames);if(W.length<2)return Q;const ee=W.reduce((X,B)=>{const P=B.basenames;return P?X.concat(P):X},[]);let ne;if(G){ne=[];for(let X=0,B=ee.length;X<B;X++)ne.push(G)}else ne=W.reduce((X,B)=>{const P=B.patterns;return P?X.concat(P):X},[]);const _=function(X,B){if(typeof X!="string")return null;if(!B){let O;for(O=X.length;O>0;O--){const T=X.charCodeAt(O-1);if(T===47||T===92)break}B=X.substr(O)}const P=ee.indexOf(B);return P!==-1?ne[P]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const ie=Q.filter(X=>!X.basenames);return ie.push(_),ie}function H(Q,G){return(0,I.$ub)(Q,G,(W,ee)=>typeof W=="string"&&typeof ee=="string"?W===ee:typeof W!="string"&&typeof ee!="string"?W.base===ee.base&&W.pattern===ee.pattern:!1)}e.$Aj=H}),define(oe[92],ae([0,1,15,10]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function N(E){return E.toJSON()}class A{constructor(m){this.a=m}transformIncoming(m){const c=this.a.transformIncoming(m);return c===m?m:N(L.URI.from(c))}transformOutgoing(m){const c=this.a.transformOutgoing(m);return c===m?m:N(L.URI.from(c))}transformOutgoingURI(m){const c=this.a.transformOutgoing(m);return c===m?m:L.URI.from(c)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$Lm=A,e.$Mm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function D(E,m,c){if(!E||c>200)return null;if(typeof E=="object"){if(E instanceof L.URI)return m.transformOutgoing(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const p=D(E[d],m,c+1);p!==null&&(E[d]=p)}}return null}function R(E,m){const c=D(E,m,0);return c===null?E:c}e.$Nm=R;function k(E,m,c,d){if(!E||d>200)return null;if(typeof E=="object"){if(E.$mid===1)return c?L.URI.revive(m.transformIncoming(E)):m.transformIncoming(E);if(E instanceof I.$be)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const y=k(E[p],m,c,d+1);y!==null&&(E[p]=y)}}return null}function g(E,m){const c=k(E,m,!1,0);return c===null?E:c}e.$Om=g;function C(E,m){const c=k(E,m,!0,0);return c===null?E:c}e.$Pm=C}),define(oe[143],ae([0,1,36,47,32,131,5]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(m){return this.a||(this.a=L.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,c=0;const d=(0,I.networkInterfaces)();for(const p in d){const y=d[p];if(y)for(const{mac:l,internal:h}of y)h||(c+=1,this.c(l.toUpperCase())&&(m+=1))}this.b=c>0?m/c:0}return this.b}};let R;async function k(m){return R||(R=(async()=>await g(m)||N.$eg())()),R}e.$Sm=k;async function g(m){try{const c=await new Promise((p,y)=>{te(["crypto"],p,y)}),d=(0,A.$Qm)();return c.createHash("sha256").update(d,"utf8").digest("hex")}catch(c){m(c);return}}const C="Software\\Microsoft\\SQMClient";async function E(m){if(D.$j){const c=await new Promise((d,p)=>{te(["@vscode/windows-registry"],d,p)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(d){return m(d),""}}return""}e.$Tm=E}),define(oe[31],ae([0,1,53,36,269,6,48,88,16,5,19,10]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function c(K,x=m.UNLINK,H){if((0,D.$1f)(K))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?p(K):d(K,H)}async function d(K,x=(0,D.$6f)((0,L.tmpdir)())){try{try{await I.promises.rename(K,x)}catch(H){return H.code==="ENOENT"?void 0:p(K)}p(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(K){return(0,N.promisify)(I.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function y(K){if((0,D.$1f)(K))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function l(K,x){return b(await(x?h(K):(0,N.promisify)(I.readdir)(K)))}async function h(K){try{return await(0,N.promisify)(I.readdir)(K,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],H=await l(K);for(const Q of H){let G=!1,W=!1,ee=!1;try{const ne=await e.Promises.lstat((0,k.$jc)(K,Q));G=ne.isFile(),W=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Q,isFile:()=>G,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function u(K){return b(I.readdirSync(K))}e.readdirSync=u;function b(K){return K.map(x=>typeof x=="string"?g.$k?(0,R.$ol)(x):x:(x.name=g.$k?(0,R.$ol)(x.name):x.name,x))}async function S(K){const x=await l(K),H=[];for(const Q of x)await a.existsDirectory((0,k.$jc)(K,Q))&&H.push(Q);return H}function s(K,x=1e3){return new Promise(H=>{let Q=!1;const G=setInterval(()=>{Q||(Q=!0,I.access(K,W=>{Q=!1,W&&(clearInterval(G),H(void 0))}))},x)})}e.whenDeleted=s;var a;(function(K){async function x(G){let W;try{if(W=await e.Promises.lstat(G),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(g.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw ee}}K.stat=x;async function H(G){try{const{stat:W,symbolicLink:ee}=await K.stat(G);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=H;async function Q(G){try{const{stat:W,symbolicLink:ee}=await K.stat(G);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=Q})(a||(e.SymlinkSupport=a={}));const n=new A.$3g;function i(K,x,H){return n.queueFor(E.URI.file(K),C.$mg).queue(()=>{const Q=w(H);return new Promise((G,W)=>o(K,x,Q,ee=>ee?W(ee):G()))})}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function o(K,x,H,Q){if(!t)return I.writeFile(K,x,{mode:H.mode,flag:H.flag},Q);I.open(K,H.flag,H.mode,(G,W)=>{if(G)return Q(G);I.writeFile(W,x,ee=>{if(ee)return I.close(W,()=>Q(ee));I.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(W,_=>Q(_))))})})}function v(K,x,H){const Q=w(H);if(!t)return I.writeFileSync(K,x,{mode:Q.mode,flag:Q.flag});const G=I.openSync(K,Q.flag,Q.mode);try{I.writeFileSync(G,x);try{I.fdatasyncSync(G)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{I.closeSync(G)}}e.writeFileSync=v;function w(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function f(K,x,H=6e4){if(K!==x)try{g.$j&&typeof H=="number"?await $(K,x,Date.now(),H):await(0,N.promisify)(I.rename)(K,x)}catch(Q){if(K.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||K.endsWith("."))await j(K,x,{preserveSymlinks:!1}),await c(K,m.MOVE);else throw Q}}async function $(K,x,H,Q,G=0){try{return await(0,N.promisify)(I.rename)(K,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=Q)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${W}`),W;if(G===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,A.$Ug)(Math.min(100,G*10)),$(K,x,H,Q,G+1)}}async function j(K,x,H){return z(K,x,{root:{source:K,target:x},options:H,handledSourcePaths:new Set})}const F=511;async function z(K,x,H){if(H.handledSourcePaths.has(K))return;H.handledSourcePaths.add(K);const{stat:Q,symbolicLink:G}=await a.stat(K);if(G){if(H.options.preserveSymlinks)try{return await Z(K,x,H)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(G.dangling)return}return Q.isDirectory()?U(K,x,Q.mode&F,H):q(K,x,Q.mode&F)}async function U(K,x,H,Q){await e.Promises.mkdir(x,{recursive:!0,mode:H});const G=await l(K);for(const W of G)await z((0,k.$jc)(K,W),(0,k.$jc)(x,W),Q)}async function q(K,x,H){await e.Promises.copyFile(K,x),await e.Promises.chmod(x,H)}async function Z(K,x,H){let Q=await e.Promises.readlink(K);(0,D.$Xf)(Q,H.root.source,!g.$l)&&(Q=(0,k.$jc)(H.root.target,Q.substr(H.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,N.promisify)(I.access)}get stat(){return(0,N.promisify)(I.stat)}get lstat(){return(0,N.promisify)(I.lstat)}get utimes(){return(0,N.promisify)(I.utimes)}get read(){return(K,x,H,Q,G)=>new Promise((W,ee)=>{I.read(K,x,H,Q,G,(ne,_,ie)=>ne?ee(ne):W({bytesRead:_,buffer:ie}))})}get readFile(){return(0,N.promisify)(I.readFile)}get write(){return(K,x,H,Q,G)=>new Promise((W,ee)=>{I.write(K,x,H,Q,G,(ne,_,ie)=>ne?ee(ne):W({bytesWritten:_,buffer:ie}))})}get appendFile(){return(0,N.promisify)(I.appendFile)}get fdatasync(){return(0,N.promisify)(I.fdatasync)}get truncate(){return(0,N.promisify)(I.truncate)}get copyFile(){return(0,N.promisify)(I.copyFile)}get open(){return(0,N.promisify)(I.open)}get close(){return(0,N.promisify)(I.close)}get symlink(){return(0,N.promisify)(I.symlink)}get readlink(){return(0,N.promisify)(I.readlink)}get chmod(){return(0,N.promisify)(I.chmod)}get mkdir(){return(0,N.promisify)(I.mkdir)}get unlink(){return(0,N.promisify)(I.unlink)}get rmdir(){return(0,N.promisify)(I.rmdir)}get realpath(){return(0,N.promisify)(I.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return S}get writeFile(){return i}get rm(){return c}get rename(){return f}get copy(){return j}}}),define(oe[144],ae([0,1,53,16,5,27,31]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=void 0;function R(m){if(N.$l)return m;const c=(0,L.$mc)(m);if(m===c)return m;const d=((0,L.$nc)(m)||m).toLowerCase();try{const y=(0,D.readdirSync)(c).filter(l=>l.toLowerCase()===d);if(y.length===1){const l=R(c);if(l)return(0,L.$jc)(l,y[0])}else if(y.length>1){const l=y.indexOf(d);if(l>=0){const h=R(c);if(h)return(0,L.$jc)(h,y[l])}}}catch{}return null}e.$5p=R;async function k(m){if(N.$l)return m;const c=(0,L.$mc)(m);if(m===c)return m;const d=((0,L.$nc)(m)||m).toLowerCase();try{const y=(await D.Promises.readdir(c)).filter(l=>l.toLowerCase()===d);if(y.length===1){const l=await k(c);if(l)return(0,L.$jc)(l,y[0])}else if(y.length>1){const l=y.indexOf(d);if(l>=0){const h=await k(c);if(h)return(0,L.$jc)(h,y[l])}}}catch{}return null}e.$6p=k;async function g(m){try{return await D.Promises.realpath(m)}catch{const d=E(m);return await D.Promises.access(d,I.constants.R_OK),d}}e.$7p=g;function C(m){try{return I.realpathSync(m)}catch{const d=E(m);return I.accessSync(d,I.constants.R_OK),d}}e.$8p=C;function E(m){return(0,A.$Ke)((0,L.$hc)(m),L.sep)}}),define(oe[145],ae([0,1,16,5,37,90,12,31]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function k(E=N.env){return E.comspec||"cmd.exe"}e.$Bl=k;function g(E){let m=[],c=!1;const d=function(p){if(c){m.push(p);return}(!E.send(p,l=>{if(l&&console.error(l),c=!1,m.length>0){const h=m.slice(0);m=[],h.forEach(u=>d(u))}})||L.$j)&&(c=!0)};return{send:d}}e.$Cl=g;var C;(function(E){async function m(c,d,p){if(I.$ic(c))return c;if(d===void 0&&(d=N.cwd()),I.$mc(c)!=="."||(p===void 0&&D.$yf(N.env.PATH)&&(p=N.env.PATH.split(I.$tc)),p===void 0||p.length===0))return I.$jc(d,c);async function l(h){if(await R.Promises.exists(h)){let u;try{u=await R.Promises.stat(h)}catch(b){b.message.startsWith("EACCES")&&(u=await R.Promises.lstat(h))}return u?!u.isDirectory():!1}return!1}for(const h of p){let u;if(I.$ic(h)?u=I.$jc(h,c):u=I.$jc(d,h,c),await l(u))return u;let b=u+".com";if(await l(b)||(b=u+".exe",await l(b)))return b}return I.$jc(d,c)}E.findExecutable=m})(C||(e.win32=C={}))}),define(oe[146],ae([0,1,65,23]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;function N(D){return new Promise((R,k)=>{let g;const C=new Map;function E(c,d,p,y,l){const h=C.get(d);if(c===D||h){const u={name:m(p),cmd:p,pid:c,ppid:d,load:y,mem:l};C.set(c,u),c===D&&(g=u),h&&(h.children||(h.children=[]),h.children.push(u),h.children.length>1&&(h.children=h.children.sort((b,S)=>b.pid-S.pid)))}}function m(c){const d=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,y=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(y.exec(c))return"electron-crash-reporter";if(l.exec(c))return"winpty-agent";if(h.exec(c))return"conpty-agent";let b=u.exec(c);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?d.exec(c)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const S=/[a-zA-Z-]+\.js/g;let s="";do b=S.exec(c),b&&(s+=b+" ");while(b);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,p)=>{te(["@vscode/windows-process-tree"],d,p)}).then(d=>{d.getProcessList(D,p=>{if(!p){k(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(p,y=>{const l=new Map;y.forEach(h=>{const u=c(h.commandLine||"");l.set(h.pid,{name:m(u),cmd:u,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),g=l.get(D),g?(l.forEach(h=>{const u=l.get(h.ppid);u&&(u.children||(u.children=[]),u.children.push(h))}),l.forEach(h=>{h.children&&(h.children=h.children.sort((u,b)=>u.pid-b.pid))}),R(g)):k(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let c=function(){let d=[g];const p=[];for(;d.length;){const l=d.shift();l&&(p.push(l.pid),l.children&&(d=d.concat(l.children)))}let y=JSON.stringify(L.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+p.join(" "),(0,I.exec)(y,{},(l,h,u)=>{if(l||u)k(l||new Error(u.toString()));else{const b=h.toString().split(`
`);for(let S=0;S<p.length;S++){const s=C.get(p[S]);s.load=parseFloat(b[S])}if(!g){k(new Error(`Root process ${D} not found`));return}R(g)}})};(0,I.exec)("which ps",{},(d,p,y)=>{if(d||y)if(process.platform!=="linux")k(d||new Error(y.toString()));else{const l=JSON.stringify(L.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(l,{},(h,u,b)=>{h||b?k(h||new Error(b.toString())):(A(u,E),c())})}else{const l=p.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${l} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,b,S)=>{u||S&&!S.includes("screen size is bogus")?k(u||new Error(S.toString())):(A(b,E),process.platform==="linux"?c():g?R(g):k(new Error(`Root process ${D} not found`)))})}})}})}e.$Cr=N;function A(D,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=D.toString().split(`
`);for(const C of g){const E=k.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,I,L){var N=arguments.length,A=N<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,I,L);else for(var R=te.length-1;R>=0;R--)(D=te[R])&&(A=(N<3?D(A):N>3?D(e,I,A):D(e,I))||A);return N>3&&A&&Object.defineProperty(e,I,A),A};define(oe[42],ae([0,1,18,6,15,26,84,8,3,2,64,27,12]),function(te,e,I,L,N,A,D,R,k,g,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var c;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(c||(c={}));function d(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(p||(p={}));function y(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(l||(l={}));function h(G){let W=0;for(let ee=0;;ee+=7){const ne=G.read(1);if(W|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return W}}const u=n(0);function b(G,W){if(W===0){G.write(u);return}let ee=0;for(let _=W;_!==0;_=_>>>7)ee++;const ne=N.$be.alloc(ee);for(let _=0;W!==0;_++)ne.buffer[_]=W&127,W=W>>>7,W>0&&(ne.buffer[_]|=128);G.write(ne)}class S{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$nh=S;class s{constructor(){this.a=[]}get buffer(){return N.$be.concat(this.a)}write(W){this.a.push(W)}}e.$oh=s;var a;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(a||(a={}));function n(G){const W=N.$be.alloc(1);return W.writeUInt8(G,0),W}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(G,W){if(typeof W>"u")G.write(i.Undefined);else if(typeof W=="string"){const ee=N.$be.fromString(W);G.write(i.String),b(G,ee.byteLength),G.write(ee)}else if(t&&Buffer.isBuffer(W)){const ee=N.$be.wrap(W);G.write(i.Buffer),b(G,ee.byteLength),G.write(ee)}else if(W instanceof N.$be)G.write(i.VSBuffer),b(G,W.byteLength),G.write(W);else if(Array.isArray(W)){G.write(i.Array),b(G,W.length);for(const ee of W)r(G,ee)}else if(typeof W=="number"&&(W|0)===W)G.write(i.Uint),b(G,W);else{const ee=N.$be.fromString(JSON.stringify(W));G.write(i.Object),b(G,ee.byteLength),G.write(ee)}}e.$ph=r;function o(G){switch(G.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return G.read(h(G)).toString();case a.Buffer:return G.read(h(G)).buffer;case a.VSBuffer:return G.read(h(G));case a.Array:{const ee=h(G),ne=[];for(let _=0;_<ee;_++)ne.push(o(G));return ne}case a.Object:return JSON.parse(G.read(h(G)).toString());case a.Int:return h(G)}}e.$qh=o;class v{constructor(W,ee,ne=null,_=1e3){this.h=W,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,1,y(W.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,1,y(W.type),W.data);return}}}o(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new S(W),ne=o(ee),_=o(ee),ie=ne[0];switch(ie){case 100:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}: ${ne[2]}.${ne[3]}`,_),this.s({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}: ${ne[2]}.${ne[3]}`,_),this.t({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}`),this.u({type:ie,id:ne[1]});case 103:return this.k?.logIncoming(W.byteLength,ne[1],1,`${d(ie)}`),this.u({type:ie,id:ne[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=new A.$Xd;let _;try{_=ee.call(this.j,W.name,W.arg,ne.token)}catch(B){_=Promise.reject(B)}const ie=W.id;_.then(B=>{this.m({id:ie,data:B,type:201})},B=>{B instanceof Error?this.m({id:ie,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:ie,data:B,type:203})}).finally(()=>{X.dispose(),this.d.delete(W.id)});const X=(0,g.$Qc)(()=>ne.cancel());this.d.set(W.id,X)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=W.id,ie=ee.listen(this.j,W.name,W.arg)(X=>this.m({id:ne,data:X,type:204}));this.d.set(W.id,ie)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:W,timeoutTimer:ne})}w(W){const ee=this.g.get(W);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Nc)(this.d.values()),this.d.clear()}}e.$rh=v;var w;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class f{constructor(W,ee=null){this.l=W,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(W){const ee=this;return{call(ne,_,ie){return ee.a?Promise.reject(new R.$5):ee.m(W,ne,_,ie)},listen(ne,_){return ee.a?k.Event.None:ee.o(W,ne,_)}}}m(W,ee,ne,_=A.CancellationToken.None){const ie=this.g++,B={id:ie,type:100,channelName:W,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new R.$5);let P;return new Promise((T,M)=>{if(_.isCancellationRequested)return M(new R.$5);const V=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(ie),T(he.data);break;case 202:{this.f.delete(ie);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,M($e);break}case 203:this.f.delete(ie),M(he.data);break}};this.f.set(ie,ue),this.p(B)};let J=null;this.b===l.Idle?V():(J=(0,L.$Hg)(ue=>this.u()),J.then(()=>{J=null,V()}));const re=()=>{J?(J.cancel(),J=null):this.p({id:ie,type:101}),M(new R.$5)},ce=_.onCancellationRequested(re);P=(0,g.$Pc)((0,g.$Qc)(re),ce),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(W,ee,ne){const _=this.g++,X={id:_,type:102,channelName:W,name:ee,arg:ne};let B=null;const P=new k.$Nd({onWillAddFirstListener:()=>{B=(0,L.$Hg)(T=>this.u()),B.then(()=>{B=null,this.d.add(P),this.p(X)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(P),this.p({id:_,type:103}))}}),O=T=>P.fire(T.data);return this.f.set(_,O),P.event}p(W){switch(W.type){case 100:case 102:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,0,d(W.type));return}}}q(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new S(W),ne=o(ee),_=o(ee),ie=ne[0];switch(ie){case 200:return this.j?.logIncoming(W.byteLength,0,0,y(ie)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ne[1],0,y(ie),_),this.t({type:ne[0],id:ne[1],data:_})}}t(W){if(W.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Nc)(this.d.values()),this.d.clear()}}e.$sh=f,ye([D.$hh],f.prototype,"onDidInitializePromise",null);class ${get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new k.$Nd,this.onDidAddConnection=this.g.event,this.h=new k.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Rc,this.j.add(W(({protocol:ee,onDidClientDisconnect:ne})=>{const _=k.Event.once(ee.onMessage);this.j.add(_(ie=>{const X=new S(ie),B=o(X),P=new v(ee,B),O=new f(ee);this.a.forEach((M,V)=>P.registerChannel(V,M));const T={channelServer:P,channelClient:O,ctx:B};this.f.add(T),this.g.fire(T),this.j.add(ne(()=>{P.dispose(),O.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(W,ee){const ne=this;return{call(_,ie,X){let B;if((0,m.$Mf)(ee)){const O=(0,I.$4b)(ne.connections.filter(ee));B=O?Promise.resolve(O):k.Event.toPromise(k.Event.filter(ne.onDidAddConnection,ee))}else B=ee.routeCall(ne,_,ie);const P=B.then(O=>O.channelClient.getChannel(W));return F(P).call(_,ie,X)},listen(_,ie){if((0,m.$Mf)(ee))return ne.k(W,ee,_,ie);const X=ee.routeEvent(ne,_,ie).then(B=>B.channelClient.getChannel(W));return F(X).listen(_,ie)}}}k(W,ee,ne,_){const ie=this;let X;const B=new k.$Nd({onWillAddFirstListener:()=>{X=new g.$Rc;const P=new k.$Td,O=new Map,T=V=>{const re=V.channelClient.getChannel(W).listen(ne,_),ce=P.add(re);O.set(V,ce)},M=V=>{const J=O.get(V);J&&(J.dispose(),O.delete(V))};ie.connections.filter(ee).forEach(T),k.Event.filter(ie.onDidAddConnection,ee)(T,void 0,X),ie.onDidRemoveConnection(M,void 0,X),P.event(B.fire,B,X),X.add(P)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return B.event}registerChannel(W,ee){this.a.set(W,ee);for(const ne of this.f)ne.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=$;class j{constructor(W,ee,ne=null){const _=new s;r(_,ee),W.send(_.buffer),this.a=new f(W,ne),this.d=new v(W,ee,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=j;function F(G){return{call(W,ee,ne){return G.then(_=>_.call(W,ee,ne))},listen(W,ee){const ne=new k.$Wd;return G.then(_=>ne.input=_.listen(W,ee)),ne.event}}}e.$vh=F;function z(G){let W=!1;return{call(ee,ne,_){return W?G.call(ee,ne,_):(0,L.$Ug)(0).then(()=>W=!0).then(()=>G.call(ee,ne,_))},listen(ee,ne){if(W)return G.listen(ee,ne);const _=new k.$Wd;return(0,L.$Ug)(0).then(()=>W=!0).then(()=>_.input=G.listen(ee,ne)),_.event}}}e.$wh=z;class U{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await k.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$xh=U;var q;(function(G){function W(ie,X,B){const P=ie,O=B&&B.disableMarshalling,T=new Map;for(const M in P)ne(M)&&T.set(M,k.Event.buffer(P[M],!0,void 0,X));return new class{listen(M,V,J){const re=T.get(V);if(re)return re;if(_(V)){const ce=P[V];if(typeof ce=="function")return ce.call(P,J)}throw new R.$bb(`Event not found: ${V}`)}call(M,V,J){const re=P[V];if(typeof re=="function"){if(!O&&Array.isArray(J))for(let ue=0;ue<J.length;ue++)J[ue]=(0,C.$mh)(J[ue]);let ce=re.apply(P,J);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new R.$bb(`Method not found: ${V}`)}}}G.fromService=W;function ee(ie,X){const B=X&&X.disableMarshalling;return new Proxy({},{get(P,O){if(typeof O=="string")return X?.properties?.has(O)?X.properties.get(O):_(O)?function(T){return ie.listen(O,T)}:ne(O)?ie.listen(O):async function(...T){let M;X&&!(0,m.$Hf)(X.context)?M=[X.context,...T]:M=T;const V=await ie.call(O,M);return B?V:(0,C.$mh)(V)};throw new R.$bb(`Property not found: ${String(O)}`)}})}G.toService=ee;function ne(ie){return ie[0]==="o"&&ie[1]==="n"&&E.$1e(ie.charCodeAt(2))}function _(ie){return/^onDynamic/.test(ie)&&E.$1e(ie.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const W=G.toString();if(W!=="[object Object]")return W}return G}function x(G){return Array.isArray(G)?G.map(K):K(G)}function H(G,W,ee,ne,_,ie,X){X=x(X);const B=Z[_],P=B[ne%B.length];let O=[`%c[${G}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(ie)?(O=O.concat(X),O.push(")")):O.push(X),console.log.apply(console,O)}class Q{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ne,_,ie){this.b+=W,H(this.d,this.b,W,ee,ne,_,ie)}logIncoming(W,ee,ne,_,ie){this.a+=W,H(this.f,this.a,W,ee,ne,_,ie)}}e.$yh=Q}),define(oe[66],ae([0,1,15,3,2,42]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o(w,f){if(!t.has(w)){const $=String(++r);t.set(w,$)}return t.get(w)}function v(w,f,$,j){if(!i.enableDiagnostics)return;const F=o(w,f);if(j instanceof I.$be||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=I.$be.alloc(j.byteLength);z.set(j),i.records.push({timestamp:Date.now(),id:F,label:f,type:$,buff:z})}else i.records.push({timestamp:Date.now(),id:F,label:f,type:$,data:j})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=I.$be.alloc(0)),g}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const o=I.$be.alloc(t);let v=0,w=0;for(;t>0;){const f=this.a[w];if(f.byteLength>t){const $=f.slice(0,t);o.set($,v),v+=t,r&&(this.a[w]=f.slice(t),this.b-=t),t-=t}else o.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):w++,t-=f.byteLength}return o}}e.$zh=E;var m;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(m||(m={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class p{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends N.$Sc{constructor(t){super(),this.f=this.B(new L.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(o,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$be.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=I.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class h extends N.$Sc{constructor(t){super(),this.f=new L.$Nd,this.onMessage=this.f.event,this.g=new L.$Nd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Ah=h;class u extends A.$uh{static fromSocket(t,r){return new u(new h(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Bh=u;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Ch=b;class S{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new S(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Rc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,C());this.p.write(t)}sendResume(){const t=new p(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new N.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new p(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const w=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,C());this.p.write(t)}}e.$Dh=n}),define(oe[93],ae([0,1,65,6,15,26,141,8,3,2,30,145,90,42]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class d extends c.$rh{constructor(l){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",h=>N.$be.wrap(Buffer.from(h,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$2p=d;class p{constructor(l,h){this.i=l,this.j=h,this.c=new Set,this.g=new Map,this.h=new k.$Nd,this.onDidProcessExit=this.h.event;const u=h&&h.timeout?h.timeout:6e4;this.b=new L.$Qg(u),this.d=null,this.f=null}getChannel(l){const h=this;return{call(u,b,S){return h.k(l,u,b,S)},listen(u,b){return h.l(l,u,b)}}}k(l,h,u,b=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const S=this.n(l),s=(0,L.$Hg)(i=>S.call(h,u,i)),a=b.onCancellationRequested(()=>s.cancel()),n=(0,g.$Qc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,h,u){if(!this.b)return k.Event.None;this.b.cancel();let b;const S=new k.$Nd({onWillAddFirstListener:()=>{b=this.n(l).listen(h,u)(S.fire,S),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,C.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,m.$Al)(h.env),this.d=(0,I.fork)(this.i,l,h);const u=new k.$Nd;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,D.$Xp)(t)){(0,D.log)(t,`IPC Library: ${this.j.serverName}`);return}u.fire(N.$be.wrap(Buffer.from(t,"base64")))});const S=this.j.useQueue?(0,E.$Cl)(this.d):this.d,s=t=>this.d&&this.d.connected&&S.send(t.buffer.toString("base64")),a=u.event,n={send:s,onMessage:a};this.f=new c.$sh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,g.$Nc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let h=this.g.get(l);return h||(h=this.m.getChannel(l),this.g.set(l,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$3p=p}),define(oe[147],ae([0,1,134,15,42,3,12,18]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=e.$wT=void 0;class k{constructor(m){this.a=m,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",c=>L.$be.wrap(c.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class g extends N.$th{static b(m){(0,D.$If)((0,I.$vT)(process),"Electron Utility Process");const c=new A.$Nd;return process.parentPort.on("message",d=>{if(m?.handledClientConnection(d))return;const p=(0,R.$Ob)(d.ports);p&&c.fire(p)}),A.Event.map(c.event,d=>({protocol:new k(d),onDidClientDisconnect:A.Event.fromNodeEventEmitter(d,"close")}))}constructor(m){super(g.b(m))}}e.$wT=g;function C(E,m,c){const d=p=>{p.data===m&&(E.removeListener("message",d),c())};E.on("message",d)}e.$xT=C}),define(oe[67],ae([0,1,6,3,2,64,12]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.StorageState=e.$1o=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(m){const c=m;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$1o=k;var g;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends N.$Sc{static{this.a=100}constructor(c,d=Object.create(null)){super(),this.r=c,this.s=d,this.b=this.B(new L.$Qd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$Rg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach((d,p)=>this.w(p,d)),c.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(c,d){if(this.c===g.Closed)return;let p=!1;(0,D.$Hf)(d)?p=this.f.delete(c):this.f.get(c)!==d&&(this.f.set(c,d),p=!0),p&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,d){const p=this.f.get(c);return(0,D.$Hf)(p)?d:p}getBoolean(c,d){const p=this.get(c);return(0,D.$Hf)(p)?d:p==="true"}getNumber(c,d){const p=this.get(c);return(0,D.$Hf)(p)?d:parseInt(p,10)}getObject(c,d){const p=this.get(c);return(0,D.$Hf)(p)?d:(0,A.$lh)(p)}async set(c,d,p=!1){if(this.c===g.Closed)return;if((0,D.$Hf)(d))return this.delete(c,p);const y=(0,D.$Af)(d)||Array.isArray(d)?(0,A.$kh)(d):String(d);if(this.f.get(c)!==y)return this.f.set(c,y),this.j.set(c,y),this.h.delete(c),this.b.fire({key:c,external:p}),this.D()}async delete(c,d=!1){if(!(this.c===g.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:d}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$2o=C;class E{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach((d,p)=>this.a.set(p,d)),c.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$3o=E}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var N;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(N||(e.TokenType=N={}));function A(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const D=(0,L.localize)(3,null),R=(0,L.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,m=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:m};this.g.push({offset:E,lexeme:m,additionalInfo:C}),this.f.push(c)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),m=k.b.get(E);m?this.k(m):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,m=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const d=this.c.charCodeAt(C);if(E)E=!1;else if(d===47&&!m){C++;break}else d===91?m=!0:d===92?E=!0:d===93&&(m=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=k}),define(oe[180],ae([0,1,63,84,23,16,37,19,10]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,A.$mc)(N.$cg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,I.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",c)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$vg)(k.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=D.env.VSCODE_PORTABLE;return c?k.URI.file((0,A.$jc)(c,"argv.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,A.$kc)(c):(0,A.$hc)((0,A.$jc)(N.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?k.URI.file((0,A.$kc)(c)):k.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,A.$kc)(c);const d=D.env.VSCODE_EXTENSIONS;if(d)return d;const p=D.env.VSCODE_PORTABLE;return p?(0,A.$jc)(p,"extensions"):(0,R.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(d=>/^[^:/?#]+?:\/\//.test(d)?k.URI.parse(d):k.URI.file((0,A.$hc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?k.URI.parse(c):k.URI.file((0,A.$hc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$fm.test(c))}get extensionLogLevel(){const c=[];for(const d of this.args.log||[]){const p=e.$fm.exec(d);p&&p[1]&&p[2]&&c.push([p[1],p[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.$vg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=D.env.VSCODE_PORTABLE;return c?k.URI.file((0,A.$jc)(c,"policy.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,d,p){this.a=c,this.b=d,this.c=p,this.editSessionId=this.args.editSessionId}}e.$gm=g,ye([L.$hh],g.prototype,"appRoot",null),ye([L.$hh],g.prototype,"userHome",null),ye([L.$hh],g.prototype,"userDataPath",null),ye([L.$hh],g.prototype,"appSettingsHome",null),ye([L.$hh],g.prototype,"tmpDir",null),ye([L.$hh],g.prototype,"cacheHome",null),ye([L.$hh],g.prototype,"stateResource",null),ye([L.$hh],g.prototype,"userRoamingDataHome",null),ye([L.$hh],g.prototype,"userDataSyncHome",null),ye([L.$hh],g.prototype,"sync",null),ye([L.$hh],g.prototype,"machineSettingsResource",null),ye([L.$hh],g.prototype,"workspaceStorageHome",null),ye([L.$hh],g.prototype,"localHistoryHome",null),ye([L.$hh],g.prototype,"keyboardLayoutResource",null),ye([L.$hh],g.prototype,"argvResource",null),ye([L.$hh],g.prototype,"isExtensionDevelopment",null),ye([L.$hh],g.prototype,"untitledWorkspacesHome",null),ye([L.$hh],g.prototype,"builtinExtensionsPath",null),ye([L.$hh],g.prototype,"extensionsPath",null),ye([L.$hh],g.prototype,"extensionDevelopmentLocationURI",null),ye([L.$hh],g.prototype,"extensionDevelopmentKind",null),ye([L.$hh],g.prototype,"extensionTestsLocationURI",null),ye([L.$hh],g.prototype,"debugExtensionHost",null),ye([L.$hh],g.prototype,"logLevel",null),ye([L.$hh],g.prototype,"extensionLogLevel",null),ye([L.$hh],g.prototype,"serviceMachineIdResource",null),ye([L.$hh],g.prototype,"disableTelemetry",null),ye([L.$hh],g.prototype,"disableWorkspaceTrust",null),ye([L.$hh],g.prototype,"useInMemorySecretStorage",null),ye([L.$hh],g.prototype,"policyFile",null);function C(m,c){return E(m["inspect-extensions"],m["inspect-brk-extensions"],5870,c,m.debugId,m.extensionEnvironment)}e.$hm=C;function E(m,c,d,p,y,l){const u=Number(c||m)||(p?null:d),b=u?!!c:!1;let S;if(l)try{S=JSON.parse(l)}catch{}return{port:u,break:b,debugId:y,env:S}}e.$im=E}),function(){"use strict";function te(e,I,L){function N(D,R){const k=A(D,R),g=[k];return e.isAbsolute(k)||g.unshift(L),e.resolve(...g)}function A(D,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=D["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(E,"AppData","Roaming")}break;case"darwin":g=e.join(I.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:N}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,I,L){return te(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=te(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class A extends L.$gm{constructor(g,C){super(g,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,N.getUserDataPath)(g,C.nameShort)},C)}}e.$jm=A;function D(k,g){return(0,L.$im)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$km=D;function R(k,g){return(0,L.$im)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$lm=R}),define(oe[183],ae([0,1,12,154]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function N(D,R,k,g){try{A(D,R,k,g)}catch(C){D.error(C?.message??C)}return R}e.$xp=N;function A(D,R,k,g){const C=(E,m,c)=>{const d=E[m];if((0,I.$yf)(d)){const p=d,y=p.length;if(y>1&&p[0]==="%"&&p[y-1]==="%"){const l=p.substr(1,y-2);let h=k[l];h===void 0&&g&&(h=g[l]);const u=typeof h=="string"?h:h?.message,b=g?.[l],S=typeof b=="string"?b:b?.message;if(!u){S||D.warn(`[${R.name}]: ${(0,L.localize)(0,null,l)}`);return}if(c&&(m==="title"||m==="category")&&S&&S!==u){const s={value:u,original:S};E[m]=s}else E[m]=u}}else if((0,I.$Af)(d))for(const p in d)d.hasOwnProperty(p)&&(p==="commands"?C(d,p,!0):C(d,p,c));else if(Array.isArray(d))for(let p=0;p<d.length;p++)C(d,p,c)};for(const E in R)R.hasOwnProperty(E)&&C(R,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d9b=e.$c9b=void 0;class I{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$c9b=I;class L{constructor(A){this.a=A}listen(A,D){throw new Error(`Event not found: ${D}`)}call(A,D,R){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${D}`)}}e.$d9b=L}),define(oe[68],ae([0,1,19,89,158,54]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(l){return l=l.trim(),l==="*"||D.test(l)}e.$Lo=k;function g(l){if(!k(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=l.match(D);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Mo=g;function C(l){if(!l)return null;const h=l.majorBase,u=l.majorMustEqual,b=l.minorBase;let S=l.minorMustEqual;const s=l.patchBase;let a=l.patchMustEqual;l.hasCaret&&(h===0||(S=!1),a=!1);let n=0;if(l.preRelease){const i=R.exec(l.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:h,majorMustEqual:u,minorBase:b,minorMustEqual:S,patchBase:s,patchMustEqual:a,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$No=C;function E(l,h,u){let b;typeof l=="string"?b=C(g(l)):b=l;let S;h instanceof Date?S=h.getTime():typeof h=="string"&&(S=new Date(h).getTime());let s;if(typeof u=="string"?s=C(g(u)):s=u,!b||!s)return!1;const a=b.majorBase,n=b.minorBase,i=b.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let w=s.majorMustEqual,f=s.minorMustEqual,$=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||S&&S<v?!1:i>=o:(a===1&&t===0&&(!w||!f||!$)&&(t=1,r=0,o=0,w=!0,f=!1,$=!1),a<t?!1:a>t?!w:n<r?!1:n>r?!f:i<o?!1:i>o?!$:!(S&&S<v))}e.$Oo=E;function m(l,h,u,b,S){const s=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return s.push([L.default.Error,N.localize(0,null)]),s;if(typeof b.name!="string")return s.push([L.default.Error,N.localize(1,null,"name")]),s;if(typeof b.version!="string")return s.push([L.default.Error,N.localize(2,null,"version")]),s;if(!b.engines)return s.push([L.default.Error,N.localize(3,null,"engines")]),s;if(typeof b.engines.vscode!="string")return s.push([L.default.Error,N.localize(4,null,"engines.vscode")]),s;if(typeof b.extensionDependencies<"u"&&!y(b.extensionDependencies))return s.push([L.default.Error,N.localize(5,null,"extensionDependencies")]),s;if(typeof b.activationEvents<"u"){if(!y(b.activationEvents))return s.push([L.default.Error,N.localize(6,null,"activationEvents")]),s;if(typeof b.main>"u"&&typeof b.browser>"u")return s.push([L.default.Error,N.localize(7,null,"activationEvents","main","browser")]),s}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&s.push([L.default.Warning,N.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return s.push([L.default.Error,N.localize(9,null,"main")]),s;{const i=(0,I.$vg)(u,b.main);(0,I.$pg)(i,u)||s.push([L.default.Warning,N.localize(10,null,i.path,u.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return s.push([L.default.Error,N.localize(11,null,"browser")]),s;{const i=(0,I.$vg)(u,b.browser);(0,I.$pg)(i,u)||s.push([L.default.Warning,N.localize(12,null,i.path,u.path)])}}if(!A.valid(b.version))return s.push([L.default.Error,N.localize(13,null)]),s;const a=[];if(!c(l,h,b,S,a))for(const i of a)s.push([L.default.Error,i]);return s}e.$Po=m;function c(l,h,u,b,S){return b||typeof u.main>"u"&&typeof u.browser>"u"?!0:p(l,h,u.engines.vscode,S)}e.$Qo=c;function d(l,h,u){return l==="*"||p(h,u,l)}e.$Ro=d;function p(l,h,u,b=[]){const S=C(g(u));if(!S)return b.push(N.localize(14,null,u)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return b.push(N.localize(15,null,u)),!1}else if(!S.majorMustEqual)return b.push(N.localize(16,null,u)),!1;return E(l,h,S)?!0:(b.push(N.localize(17,null,l,u)),!1)}function y(l){if(!Array.isArray(l))return!1;for(let h=0,u=l.length;h<u;h++)if(typeof l[h]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;async function N(A,D,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await D.readFile(A.serviceMachineIdResource)).value.toString();k=(0,L.$dg)(C)?C:null}catch{k=null}if(!k){k=(0,L.$eg)();try{await D.writeFile(A.serviceMachineIdResource,I.$be.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$_o=N}),define(oe[69],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class I{constructor(N,A=[],D=!1){this.ctor=N,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.$Mh=I}),define(oe[185],ae([0,1,69]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const L=[];var N;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function A(R,k,g){k instanceof I.$Mh||(k=new I.$Mh(k,[],!!g)),L.push([R,k])}e.$wr=A;function D(){return L}e.$xr=D}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class I{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$bq=I;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const R=this.lookupOrInsertNode(A),k=this.lookupOrInsertNode(D);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const R of this.a.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let R=this.a.get(D);return R||(R=new I(D,A),this.a.set(D,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,R]of this.a)A.push(`${D}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const R=new Set([A]),k=this.c(D,R);if(k)return k}}c(A,D){for(const[R,k]of A.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const g=this.c(k,D);if(g)return g;D.delete(R)}}}e.$cq=L}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=R})(I||(e._util=I={})),e.$Oh=N("instantiationService");function L(D,R,k){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:D,index:k}):(R[I.DI_DEPENDENCIES]=[{id:D,index:k}],R[I.DI_TARGET]=R)}function N(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(R,k,C)};return R.toString=()=>D,I.serviceIds.set(D,R),R}e.$Ph=N;function A(D){return D}e.$Qh=A}),define(oe[187],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L8b=void 0,e.$L8b=(0,I.$Ph)("checksumService")}),define(oe[20],ae([0,1,12,10,4]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,N.$Ph)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof L.URI)}e.$ki=A;function D(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof L.URI)}e.$li=D;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=k;function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$ni=g;function C(l,h){const u=Object.create(null);for(const b in l)E(u,b,l[b],h);return u}e.$oi=C;function E(l,h,u,b){const S=h.split("."),s=S.pop();let a=l;for(let n=0;n<S.length;n++){const i=S[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${h} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=u}catch{b(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(a)}`)}else b(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(a)}`)}e.$pi=E;function m(l,h){const u=h.split(".");c(l,u)}e.$qi=m;function c(l,h){const u=h.shift();if(h.length===0){delete l[u];return}if(Object.keys(l).indexOf(u)!==-1){const b=l[u];typeof b=="object"&&!Array.isArray(b)&&(c(b,h),Object.keys(b).length===0&&delete l[u])}}function d(l,h,u){function b(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const S=h.split("."),s=b(l,S);return typeof s>"u"?u:s}e.$ri=d;function p(l,h,u){Object.keys(h).forEach(b=>{b!=="__proto__"&&(b in l?I.$Af(l[b])&&I.$Af(h[b])?p(l[b],h[b],u):u&&(l[b]=h[b]):l[b]=h[b])})}e.$si=p;function y(l){return l.replace(/[\[\]]/g,"")}e.$ti=y}),define(oe[94],ae([0,1,5,27,179,4,150,8]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",I.$k),k.set("isLinux",I.$l),k.set("isWindows",I.$j),k.set("isWeb",I.$p),k.set("isMacNative",I.$k&&!I.$p),k.set("isEdge",I.$H),k.set("isFirefox",I.$F),k.set("isChrome",I.$E),k.set("isSafari",I.$G);function g(B,P){if(k.get(B)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(B,P)}e.$Li=g;const C=Object.prototype.hasOwnProperty;var E;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const m={regexParsingWithErrorRecovery:!0},c=(0,D.localize)(0,null),d=(0,D.localize)(1,null),p=(0,D.localize)(2,null),y=(0,D.localize)(3,null),l=(0,D.localize)(4,null),h=(0,D.localize)(5,null),u=(0,D.localize)(6,null),b=(0,D.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=m){this.k=P,this.d=new N.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const O=this.l();if(!this.E()){const T=this.D(),M=T.type===17?h:void 0;throw this.h.push({message:l,offset:T.offset,lexeme:N.$Ki.getLexeme(T),additionalInfo:M}),S.c}return O}catch(O){if(O!==S.c)throw O;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const O=this.o();P.push(O)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const O=this.s();P.push(O)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const O=this.l();return this.A(1,y),O?.negate()}case 17:return this.z(),j.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const O=this.l();return this.A(1,y),O}case 17:{const O=P.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const V=M.lexeme,J=V.lastIndexOf("/"),re=J===V.length-1?void 0:this.w(V.substring(J+1));let ce;try{ce=new RegExp(V.substring(1,J),re)}catch{throw this.B("REGEX",M)}return K.create(O,ce)}switch(M.type){case 10:case 19:{const V=[M.lexeme];this.z();let J=this.D(),re=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?re++:M.lexeme.charCodeAt(de)===41&&re--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===40?re++:M.lexeme.charCodeAt(de)===41&&re--}if(re<0)break;V.push(N.$Ki.getLexeme(J)),this.z(),J=this.D()}const ce=V.join(""),ue=ce.lastIndexOf("/"),he=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let $e;try{$e=new RegExp(ce.substring(1,ue),he)}catch{throw this.B("REGEX",M)}return s.regex(O,$e)}case 18:{const V=M.lexeme;this.z();let J=null;if(!(0,L.$Be)(V)){const re=V.indexOf("/"),ce=V.lastIndexOf("/");if(re!==ce&&re>=0){const ue=V.slice(re+1,ce),he=V[ce+1]==="i"?"i":"";try{J=new RegExp(ue,he)}catch{throw this.B("REGEX",M)}}}if(J===null)throw this.B("REGEX",M);return K.create(O,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const M=this.u();return s.notIn(O,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return s.equals(O,M);switch(M){case"true":return s.has(O);case"false":return s.not(O);default:return s.equals(O,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return s.notEquals(O,M);switch(M){case"true":return s.not(O);case"false":return s.has(O);default:return s.notEquals(O,M)}}case 5:return this.z(),q.create(O,this.u());case 6:return this.z(),Z.create(O,this.u());case 7:return this.z(),z.create(O,this.u());case 8:return this.z(),U.create(O,this.u());case 13:return this.z(),s.in(O,this.u());default:return s.has(O)}}case 20:throw this.h.push({message:u,offset:P.offset,lexeme:"",additionalInfo:b}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,O){if(this.C(P))return this.z();throw this.B(O,this.D())}B(P,O,T){const M=(0,D.localize)(8,null,P,N.$Ki.getLexeme(O)),V=O.offset,J=N.$Ki.getLexeme(O);return this.h.push({message:M,offset:V,lexeme:J,additionalInfo:T}),S.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=S;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return o.create(P)}static equals(P,O){return v.create(P,O)}static notEquals(P,O){return $.create(P,O)}static regex(P,O){return K.create(P,O)}static in(P,O){return w.create(P,O)}static notIn(P,O){return f.create(P,O)}static not(P){return j.create(P)}static and(...P){return Q.create(P,null,!0)}static or(...P){return G.create(P,null,!0)}static greater(P,O){return z.create(P,O)}static greaterEquals(P,O){return U.create(P,O)}static smaller(P,O){return q.create(P,O)}static smallerEquals(P,O){return Z.create(P,O)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Ni=s;function a(B){const P=new S({regexParsingWithErrorRecovery:!1});return B.map(O=>(P.parse(O),P.lexingErrors.length>0?P.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,D.localize)(9,null,T.additionalInfo):(0,D.localize)(10,null),offset:T.offset,length:T.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$Oi=a;function n(B,P){const O=B?B.substituteConstants():void 0,T=P?P.substituteConstants():void 0;return!O&&!T?!0:!O||!T?!1:O.equals(T)}e.$Pi=n;function i(B,P){return B.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$Qi=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$Ri=r;class o{static create(P,O=null){const T=k.get(P);return typeof T=="boolean"?T?r.INSTANCE:t.INSTANCE:new o(P,O)}constructor(P,O){this.key=P,this.c=O,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Si=o;class v{static create(P,O,T=null){if(typeof O=="boolean")return O?o.create(P,T):j.create(P,T);const M=k.get(P);return typeof M=="boolean"?O===(M?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,O,T)}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const O=P?"true":"false";return this.d===O?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.$Ti=v;class w{static create(P,O){return new w(P,O)}constructor(P,O){this.d=P,this.f=O,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.f),T=P.getValue(this.d);return Array.isArray(O)?O.includes(T):typeof T=="string"&&typeof O=="object"&&O!==null?C.call(O,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ui=w;class f{static create(P,O){return new f(P,O)}constructor(P,O){this.d=P,this.f=O,this.type=11,this.c=w.create(P,O)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=f;class ${static create(P,O,T=null){if(typeof O=="boolean")return O?j.create(P,T):o.create(P,T);const M=k.get(P);return typeof M=="boolean"?O===(M?"true":"false")?t.INSTANCE:r.INSTANCE:new $(P,O,T)}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const O=P?"true":"false";return this.d===O?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Wi=$;class j{static create(P,O=null){const T=k.get(P);return typeof T=="boolean"?T?t.INSTANCE:r.INSTANCE:new j(P,O)}constructor(P,O){this.c=P,this.d=O,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=k.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$Xi=j;function F(B,P){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?P(B):t.INSTANCE}class z{static create(P,O,T=null){return F(O,M=>new z(P,M,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Yi=z;class U{static create(P,O,T=null){return F(O,M=>new U(P,M,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Zi=U;class q{static create(P,O,T=null){return F(O,M=>new q(P,M,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$1i=q;class Z{static create(P,O,T=null){return F(O,M=>new Z(P,M,T))}constructor(P,O,T){this.c=P,this.d=O,this.f=T,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$2i=Z;class K{static create(P,O){return new K(P,O)}constructor(P,O){this.d=P,this.f=O,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const O=this.f?this.f.source:"",T=P.f?P.f.source:"";return O<T?-1:O>T?1:0}equals(P){if(P.type===this.type){const O=this.f?this.f.source:"",T=P.f?P.f.source:"";return this.d===P.d&&O===T}return!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$3i=K;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$4i=x;function H(B){let P=null;for(let O=0,T=B.length;O<T;O++){const M=B[O].substituteConstants();if(B[O]!==M&&P===null){P=[];for(let V=0;V<O;V++)P[V]=B[V]}P!==null&&(P[O]=M)}return P===null?B:P}class Q{static create(P,O,T){return Q.d(P,O,T)}constructor(P,O){this.expr=P,this.c=O,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,T=this.expr.length;O<T;O++){const M=i(this.expr[O],P.expr[O]);if(M!==0)return M}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,T=this.expr.length;O<T;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:Q.create(P,this.c,!1)}evaluate(P){for(let O=0,T=this.expr.length;O<T;O++)if(!this.expr[O].evaluate(P))return!1;return!0}static d(P,O,T){const M=[];let V=!1;for(const J of P)if(J){if(J.type===1){V=!0;continue}if(J.type===0)return t.INSTANCE;if(J.type===6){M.push(...J.expr);continue}M.push(J)}if(M.length===0&&V)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let J=1;J<M.length;J++)M[J-1].equals(M[J])&&(M.splice(J,1),J--);if(M.length===1)return M[0];for(;M.length>1;){const J=M[M.length-1];if(J.type!==9)break;M.pop();const re=M.pop(),ce=M.length===0,ue=G.create(J.expr.map(he=>Q.create([he,re],null,T)),null,ce);ue&&(M.push(ue),M.sort(i))}if(M.length===1)return M[0];if(T){for(let J=0;J<M.length;J++)for(let re=J+1;re<M.length;re++)if(M[J].negate().equals(M[re]))return t.INSTANCE;if(M.length===1)return M[0]}return new Q(M,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new Q(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.c){const P=[];for(const O of this.expr)P.push(O.negate());this.c=G.create(P,this,!0)}return this.c}}e.$5i=Q;class G{static create(P,O,T){return G.d(P,O,T)}constructor(P,O){this.expr=P,this.c=O,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,T=this.expr.length;O<T;O++){const M=i(this.expr[O],P.expr[O]);if(M!==0)return M}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,T=this.expr.length;O<T;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:G.create(P,this.c,!1)}evaluate(P){for(let O=0,T=this.expr.length;O<T;O++)if(this.expr[O].evaluate(P))return!0;return!1}static d(P,O,T){let M=[],V=!1;if(P){for(let J=0,re=P.length;J<re;J++){const ce=P[J];if(ce){if(ce.type===0){V=!0;continue}if(ce.type===1)return r.INSTANCE;if(ce.type===9){M=M.concat(ce.expr);continue}M.push(ce)}}if(M.length===0&&V)return t.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let J=1;J<M.length;J++)M[J-1].equals(M[J])&&(M.splice(J,1),J--);if(M.length===1)return M[0];if(T){for(let J=0;J<M.length;J++)for(let re=J+1;re<M.length;re++)if(M[J].negate().equals(M[re]))return r.INSTANCE;if(M.length===1)return M[0]}return new G(M,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new G(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.c){const P=[];for(const O of this.expr)P.push(O.negate());for(;P.length>1;){const O=P.shift(),T=P.shift(),M=[];for(const V of X(O))for(const J of X(T))M.push(Q.create([V,J],null,!1));P.unshift(G.create(M,null,!1))}this.c=G.create(P,this,!0)}return this.c}}e.$6i=G;class W extends o{static{this.d=[]}static all(){return W.d.values()}constructor(P,O,T){super(P,null),this.f=O,typeof T=="object"?W.d.push({...T,key:P}):T!==!0&&W.d.push({key:P,description:T,type:O!=null?typeof O:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return $.create(this.key,P)}}e.$7i=W,e.$8i=(0,A.$Ph)("contextKeyService");function ee(B,P){return B<P?-1:B>P?1:0}function ne(B,P,O,T){return B<O?-1:B>O?1:P<T?-1:P>T?1:0}function _(B,P){if(B.type===0||P.type===1)return!0;if(B.type===9)return P.type===9?ie(B.expr,P.expr):!1;if(P.type===9){for(const O of P.expr)if(_(B,O))return!0;return!1}if(B.type===6){if(P.type===6)return ie(P.expr,B.expr);for(const O of B.expr)if(_(O,P))return!0;return!1}return B.equals(P)}e.$9i=_;function ie(B,P){let O=0,T=0;for(;O<B.length&&T<P.length;){const M=B[O].cmp(P[T]);if(M<0)return!1;M===0&&O++,T++}return O===B.length}function X(B){return B.type===9?B.expr:[B]}}),define(oe[95],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.ID=void 0,e.ID="diagnosticsService",e.$qm=(0,I.$Ph)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.$rm=L;class N{async getPerformanceInfo(D,R){return{}}async getSystemInfo(D,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,R){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$sm=N}),define(oe[96],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$On=(0,I.$Ph)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,I.$Ph)("environmentService"),e.$Xh=(0,I.$Qh)(e.$Wh)}),define(oe[29],ae([0,1,153,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function N(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=N;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=A;function D(l,h){switch(l){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=D;function R(l,h){return h==="web"&&!l.includes("web")}e.$7n=R;function k(l,h,u){return R(h,u)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===u}e.$8n=k;function g(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$9n=g;var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var E;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$0n=(0,L.$Ph)("extensionGalleryService");var d;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var p;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class y extends Error{constructor(h,u){super(h),this.code=u,this.name=u}}e.$$n=y,e.$_n=(0,L.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,L.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,L.$Ph)("IExtensionTipsService"),e.$eo=(0,I.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,I.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,10,92,29]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=void 0;function k(y,l){return y?A.URI.revive(l?l.transformIncoming(y):y):void 0}function g(y,l){return l?l.transformOutgoingURI(y):y}function C(y,l){l=l||D.$Mm;const h=y.manifest;return{...(0,D.$Pm)({...y,manifest:void 0},l),manifest:h}}function E(y,l){return y?.profileLocation?(0,D.$Pm)(y,l??D.$Mm):y}function m(y,l){return l?(0,N.$9m)(y,h=>h instanceof A.URI?l.transformOutgoingURI(h):void 0):y}class c{constructor(l,h){this.a=l,this.b=h,this.onInstallExtension=I.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,h){const u=this.b(l);switch(h){case"onInstallExtension":return I.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?g(b.profileLocation,u):b.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,b=>b.map(S=>({...S,local:S.local?m(S.local,u):S.local,profileLocation:S.profileLocation?g(S.profileLocation,u):S.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?g(b.profileLocation,u):b.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?g(b.profileLocation,u):b.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,b=>m(b,u))}throw new Error("Invalid listen")}async call(l,h,u){const b=this.b(l);switch(h){case"zip":{const S=C(u[0],b),s=await this.a.zip(S);return g(s,b)}case"unzip":return this.a.unzip(k(u[0],b));case"install":return this.a.install(k(u[0],b),E(u[1],b));case"installFromLocation":return this.a.installFromLocation(k(u[0],b),k(u[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],k(u[1],b),k(u[2],b));case"getManifest":return this.a.getManifest(k(u[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],E(u[1],b));case"installGalleryExtensions":{const S=u[0];return this.a.installGalleryExtensions(S.map(({extension:s,options:a})=>({extension:s,options:E(a,b)??{}})))}case"uninstall":return this.a.uninstall(C(u[0],b),E(u[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(u[0],b));case"getInstalled":return(await this.a.getInstalled(u[0],k(u[1],b))).map(s=>m(s,b));case"toggleAppliationScope":{const S=await this.a.toggleAppliationScope(C(u[0],b),k(u[1],b));return m(S,b)}case"copyExtensions":return this.a.copyExtensions(k(u[0],b),k(u[1],b));case"updateMetadata":{const S=await this.a.updateMetadata(C(u[0],b),u[1],k(u[2],b));return m(S,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$hp=c;class d extends L.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new I.$Nd),this.f=this.B(new I.$Nd),this.g=this.B(new I.$Nd),this.h=this.B(new I.$Nd),this.j=this.B(new I.$Nd),this.B(this.m.listen("onInstallExtension")(h=>this.n(this.c,{...h,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(h=>this.n(this.f,h.map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(h=>this.n(this.g,{...h,profileLocation:A.URI.revive(h.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(h=>this.n(this.h,{...h,profileLocation:A.URI.revive(h.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(C(h,null))))}n(l,h){l.fire(h)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const h=await this.getTargetPlatform();return l.allTargetPlatforms.some(u=>(0,R.$8n)(u,l.allTargetPlatforms,h))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(h=>A.URI.revive(h)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,h){return Promise.resolve(this.m.call("install",[l,h])).then(u=>C(u,null))}installFromLocation(l,h){return Promise.resolve(this.m.call("installFromLocation",[l,h])).then(u=>C(u,null))}async installExtensionsFromProfile(l,h,u){return(await this.m.call("installExtensionsFromProfile",[l,h,u])).map(S=>C(S,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,h){return Promise.resolve(this.m.call("installFromGallery",[l,h])).then(u=>C(u,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))}uninstall(l,h){return Promise.resolve(this.m.call("uninstall",[l,h]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(h=>C(h,null))}getInstalled(l=null,h){return Promise.resolve(this.m.call("getInstalled",[l,h])).then(u=>u.map(b=>C(b,null)))}updateMetadata(l,h,u){return Promise.resolve(this.m.call("updateMetadata",[l,h,u])).then(b=>C(b,null))}toggleAppliationScope(l,h){return this.m.call("toggleAppliationScope",[l,h]).then(u=>C(u,null))}copyExtensions(l,h){return this.m.call("copyExtensions",[l,h])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,h,u){const b=await this.m.call("download",[l,h,u]);return A.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$ip=d;class p{constructor(l){this.a=l}listen(l,h){throw new Error("Invalid listen")}call(l,h,u){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$jp=p}),define(oe[97],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=void 0,e.$ep=(0,I.$Ph)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((A,D)=>te(["node-vsce-sign"],async R=>A(R),D))),this.a}async verify(A,D,R){let k;try{k=await this.b()}catch{return!1}return k.verify(A,D,R)}}e.$fp=L}),define(oe[98],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IVb=e.RecommendationsNotificationResult=e.$HVb=e.RecommendationSource=void 0;var L;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function N(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$HVb=N;var A;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$IVb=(0,I.$Ph)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,160,4,5,23,60]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,k.$Ph)("fileService");function m(_){return _.create===!0}e.$_j=m;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var d;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function p(_){const ie=_;return!!ie&&typeof ie.onDidChange=="function"}e.$ak=p;var y;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function l(_){return!!(_.capabilities&2)}e.$bk=l;function h(_){return!!(_.capabilities&8)}e.$ck=h;function u(_){return!!(_.capabilities&131072)}e.$dk=u;function b(_){return!!(_.capabilities&4)}e.$ek=b;function S(_){return!!(_.capabilities&16)}e.$fk=S;function s(_){return l(_)?!!(_.capabilities&16384):!1}e.$gk=s;function a(_){return l(_)?!!(_.capabilities&32768):!1}e.$hk=a;function n(_){return!!(_.capabilities&65536)}e.$ik=n;function i(_){return!!(_.capabilities&2048)}e.$jk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ie,X){const B=new r(ie.toString(),X);return w(B,X),B}constructor(ie,X){super(ie),this.code=X}}e.$kk=r;function o(_,ie){return r.create(_,ie)}e.$lk=o;function v(_){return _||o((0,R.localize)(0,null),t.Unknown)}e.$mk=v;function w(_,ie){return _.name=ie?`${ie} (FileSystemError)`:"FileSystemError",_}e.$nk=w;function f(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const ie=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ie)return t.Unknown;switch(ie[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$ok=f;function $(_){if(_ instanceof Z)return _.fileOperationResult;switch(f(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$pk=$;var j;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class F{constructor(ie,X,B){this.resource=ie,this.operation=X,this.target=B}isOperation(ie){return this.operation===ie}}e.$qk=F;var z;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class U{static{this.a=null}constructor(ie,X){this.c=X,this.b=void 0,this.d=new E.$V(()=>{const B=I.$Vh.forUris(()=>this.c);return B.fill(this.rawAdded.map(P=>[P,!0])),B}),this.f=new E.$V(()=>{const B=I.$Vh.forUris(()=>this.c);return B.fill(this.rawUpdated.map(P=>[P,!0])),B}),this.g=new E.$V(()=>{const B=I.$Vh.forUris(()=>this.c);return B.fill(this.rawDeleted.map(P=>[P,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of ie){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==U.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(ie,...X){return this.h(ie,{includeChildren:!1},...X)}affects(ie,...X){return this.h(ie,{includeChildren:!0},...X)}h(ie,X,...B){if(!ie)return!1;const P=B.length>0;return!!((!P||B.includes(1))&&(this.d.value.get(ie)||X.includeChildren&&this.d.value.findSuperstr(ie))||(!P||B.includes(0))&&(this.f.value.get(ie)||X.includeChildren&&this.f.value.findSuperstr(ie))||(!P||B.includes(2))&&(this.g.value.findSubstr(ie)||X.includeChildren&&this.g.value.findSuperstr(ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ie){return this.b===ie}hasCorrelation(){return typeof this.b=="number"}}e.$rk=U;function q(_,ie,X){return!_||!ie||_===ie||ie.length>_.length?!1:(ie.charAt(ie.length-1)!==L.sep&&(ie+=L.sep),X?(0,N.$3e)(_,ie):_.indexOf(ie)===0)}e.$sk=q;class Z extends Error{constructor(ie,X,B){super(ie),this.fileOperationResult=X,this.options=B}}e.$tk=Z;class K extends Z{constructor(ie,X,B,P){super(ie,X,P),this.fileOperationResult=X,this.size=B}}e.$uk=K;class x extends Z{constructor(ie,X,B){super(ie,2,B),this.stat=X}}e.$vk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Dk="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Ek=G;async function W(_,ie){if(!ie.hasProvider(D.URI.from({scheme:_.scheme})))return new Promise(X=>{const B=ie.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(B.dispose(),X())})})}e.$Fk=W;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ie){return(0,A.$Cf)(ie)||(ie=0),ie<ee.KB?(0,R.localize)(1,null,ie.toFixed(0)):ie<ee.MB?(0,R.localize)(2,null,(ie/ee.KB).toFixed(2)):ie<ee.GB?(0,R.localize)(3,null,(ie/ee.MB).toFixed(2)):ie<ee.TB?(0,R.localize)(4,null,(ie/ee.GB).toFixed(2)):(0,R.localize)(5,null,(ie/ee.TB).toFixed(2))}}e.$Gk=ee;function ne(_){const ie=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*ee.MB:ie?10*ee.MB:g.$p?50*ee.MB:1024*ee.MB}e.$Hk=ne});var Y=this&&this.__param||function(te,e){return function(I,L){e(I,L,te)}};define(oe[189],ae([0,1,70,46,11]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const E=(0,I.createHash)("md5");(0,L.$6d)(k,{onData:m=>E.update(m.buffer),onError:m=>C(m),onEnd:()=>g(E.digest("base64").replace(/=+$/,""))})})}};e.$M8b=A,e.$M8b=A=ye([Y(0,N.$$j)],A)}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function D(C,E,m,c,d,p){let y;try{await R(C,E,m,c,d,p)}catch(l){y=l}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y<"u"&&m.error(y),m.end()}}e.$Mp=D;async function R(C,E,m,c,d,p){k(p);const y=await C.open(E,{create:!1});try{k(p);let l=0,h=0,u=d&&typeof d.length=="number"?d.length:void 0,b=I.$be.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),S=d&&typeof d.position=="number"?d.position:0,s=0;do h=await C.read(y,S,b.buffer,s,b.byteLength-s),S+=h,s+=h,l+=h,typeof u=="number"&&(u-=h),s===b.byteLength&&(await m.write(c(b)),b=I.$be.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),s=0);while(h>0&&(typeof u!="number"||u>0)&&k(p)&&g(l,d));if(s>0){let a=s;typeof u=="number"&&(a=Math.min(s,u)),m.write(c(b.slice(0,a)))}}catch(l){throw(0,A.$mk)(l)}finally{await C.close(y)}}function k(C){if(C.isCancellationRequested)throw(0,L.$6)();return!0}function g(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,A.$lk)((0,N.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[49],ae([0,1,91,2,16,5,10,11]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=void 0;function k(l){return l.recursive===!0}e.$Op=k;class g extends L.$Sc{static{this.a=5}constructor(h,u,b,S){super(),this.h=h,this.j=u,this.m=b,this.n=S,this.c=this.B(new L.$Tc),this.f=void 0,this.g=0}s(){const h=new L.$Rc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(u=>this.h(u))),h.add(this.b.onDidLogMessage(u=>this.j(u))),h.add(this.b.onDidError(u=>this.t(u)))}t(h){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pp=g;class C extends g{constructor(h,u,b){super(h,u,b,{type:"node.js",restartOnError:!1})}}e.$Qp=C;class E extends g{constructor(h,u,b){super(h,u,b,{type:"universal",restartOnError:!0})}}e.$Rp=E;function m(l){return l.map(h=>({type:h.type,resource:D.URI.revive(h.resource),cId:h.cId}))}e.$Sp=m;function c(l){const h=new y;for(const u of l)h.processEvent(u);return h.coalesce()}e.$Tp=c;function d(l,h){return typeof h=="string"&&!h.startsWith(I.$sj)&&!(0,N.$ic)(h)?{base:l,pattern:h}:h}e.$Up=d;function p(l,h){const u=[];for(const b of h)u.push((0,I.$wj)(d(l,b)));return u}e.$Vp=p;class y{constructor(){this.a=new Set,this.b=new Map}c(h){return A.$l?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const u=this.b.get(this.c(h));let b=!1;if(u){const S=u.type,s=h.type;u.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?b=!0:S===1&&s===2?(this.b.delete(this.c(h)),this.a.delete(u)):S===2&&s===1?u.type=0:S===1&&s===0||(u.type=s)}else b=!0;b&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],u=[];return Array.from(this.a).filter(b=>b.type!==2?(h.push(b),!1):!0).sort((b,S)=>b.resource.fsPath.length-S.resource.fsPath.length).filter(b=>u.some(S=>(0,R.$sk)(b.resource.fsPath,S,!A.$l))?!1:(u.push(b.resource.fsPath),!0)).concat(h)}}}),define(oe[190],ae([0,1,15,38,8,3,2,46,32,11,49]),function(te,e,I,L,N,A,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN="localFilesystem";class E extends D.$Sc{constructor(c,d){super(),this.a=c,this.b=d,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.h=(0,k.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,d){const{buffer:p}=await this.a.call("readFile",[c,d]);return p}readFileStream(c,d,p){const y=(0,R.$2d)(h=>I.$be.concat(h.map(u=>I.$be.wrap(u))).buffer),l=new D.$Rc;return l.add(this.a.listen("readFileStream",[c,d])(h=>{if(h instanceof I.$be)y.write(h.buffer);else{if(h==="end")y.end();else{let u;if(h instanceof Error)u=h;else{const b=h;u=(0,g.$lk)(b.message??(0,L.$Ai)(b),b.code??g.FileSystemProviderErrorCode.Unknown)}y.error(u),y.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{y.error((0,N.$6)()),y.end(),l.dispose()})),y}writeFile(c,d,p){return this.a.call("writeFile",[c,I.$be.wrap(d),p])}open(c,d){return this.a.call("open",[c,d])}close(c){return this.a.call("close",[c])}async read(c,d,p,y,l){const[h,u]=await this.a.call("read",[c,d,l]);return p.set(h.buffer.slice(0,u),y),u}write(c,d,p,y,l){return this.a.call("write",[c,d,I.$be.wrap(p),y,l])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,d){return this.a.call("delete",[c,d])}rename(c,d,p){return this.a.call("rename",[c,d,p])}copy(c,d,p){return this.a.call("copy",[c,d,p])}cloneFile(c,d){return this.a.call("cloneFile",[c,d])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const d=c;this.f.fire((0,C.$Sp)(d))}else{const d=c;this.g.fire(d)}}))}watch(c,d){const p=(0,k.$eg)();return this.a.call("watch",[this.h,p,c,d]),(0,D.$Qc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$nN=E}),define(oe[191],ae([0,1,53,6,26,48,2,88,16,5,19,10,144,31,49]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;class p extends D.$Sc{static{this.a=100}static{this.b=75}constructor(h,u,b,S){super(),this.m=h,this.n=u,this.r=b,this.s=S,this.c=this.B(new L.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new L.$8g(s=>this.z(s),p.b)),this.g=(0,d.$Vp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Vp)(this.m.path,this.m.includes):void 0,this.j=new N.$Xd,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const u=await c.Promises.stat(h);this.B(await this.w(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let u=h.path;try{u=await c.Promises.realpath(h.path),h.path===u&&(u=await(0,m.$6p)(h.path)??h.path),h.path!==u&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async w(h,u){if(g.$k&&(0,A.$Xf)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Sc.None;const b=new N.$Xd(this.j.token),S=new D.$Rc;try{const s=E.URI.file(this.m.path),a=(0,k.$nc)(h),n=(0,I.watch)(h);S.add((0,D.$Qc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${h}'`);const i=new Set;if(u)try{for(const r of await c.Promises.readdir(h))i.add(r)}catch(r){this.D(r)}const t=new Map;S.add((0,D.$Qc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(b.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),g.$k&&(v=(0,R.$ol)(v))),!(!v||r!=="change"&&r!=="rename"))if(u)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===a&&!await c.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,k.$jc)(h,v));if(b.token.isCancellationRequested)return;let $;f?i.has(v)?$=0:($=1,i.add(v)):(i.delete(v),$=2),this.y({resource:(0,C.$vg)(s,v),type:$,cId:this.m.correlationId})},p.a);t.set(v,(0,D.$Qc)(()=>clearTimeout(w)))}else{let w;i.has(v)?w=0:(w=1,i.add(v)),this.y({resource:(0,C.$vg)(s,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const w=setTimeout(async()=>{const f=await c.Promises.exists(h);b.token.isCancellationRequested||(f?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),S.add(await this.w(h,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);S.clear(),S.add((0,D.$Qc)(()=>clearTimeout(w)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await c.Promises.exists(h)&&!b.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${s.toString()})`)}return(0,D.$Qc)(()=>{b.dispose(!0),S.dispose()})}y(h,u=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!u&&this.g.some(b=>b(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(b=>b(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const u=(0,d.$Tp)(h);if(u.length>0){if(this.s)for(const S of u)this.G(` >> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(g.$l)return c.Promises.exists(h);try{const u=(0,k.$nc)(h);return(await c.Promises.readdir((0,k.$mc)(h))).some(S=>S===u)}catch(u){return this.G(u),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$9p=p;async function y(l,h,u,b,S=512){const s=await c.Promises.open(l,"r"),a=Buffer.allocUnsafe(S),n=new N.$Xd(b);let i,t=!1;const r={path:l,excludes:[],recursive:!1},o=new p(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await c.Promises.read(s,a,0,S,null);if(!f||n.token.isCancellationRequested)break;h(a.slice(0,f))}}catch(f){i=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,u(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await c.Promises.close(s)}catch(f){i=new Error(f)}i?w(i):v()})})}e.$0p=y}),define(oe[192],ae([0,1,3,91,2,5,191]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class R extends N.$Sc{constructor(){super(...arguments),this.a=this.B(new I.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),E=C.filter(c=>{const d=this.c.get(c.path);return d?!(0,L.$Aj)(d.request.excludes,c.excludes)||!(0,L.$Aj)(d.request.includes,c.includes):!0}),m=Array.from(this.c.values()).filter(({request:c})=>!C.find(d=>d.path===c.path&&(0,L.$Aj)(d.excludes,c.excludes)&&(0,L.$Aj)(d.includes,c.includes))).map(({request:c})=>c.path);E.length&&this.m(`Request to start watching: ${E.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const c of m)this.h(c);for(const c of E)this.g(c)}g(g){const C=new D.$9p(g,m=>this.a.fire(m),m=>this.b.fire(m),this.f),E={request:g,instance:C};this.c.set(g.path,E)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const E of g){const m=A.$l?E.path:E.path.toLowerCase();let c=C.get(E.correlationId);c||(c=new Map,C.set(E.correlationId,c)),c.set(m,E)}return Array.from(C.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$$p=R}),define(oe[193],ae([0,1,49,192]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class N extends I.$Qp{constructor(D,R,k){super(D,R,k),this.s()}r(D){return D.add(new L.$$p)}}e.$_p=N}),define(oe[194],ae([0,1,23,42,93,49]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class D extends A.$Rp{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new N.$3p(I.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:E})=>this.t(`terminated by itself with code ${C}, signal: ${E}`))),L.ProxyChannel.toService((0,L.$wh)(g.getChannel("watcher")))}}e.$4p=D}),define(oe[71],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class I{constructor(...N){this.a=new Map;for(const[A,D]of N)this.set(A,D)}set(N,A){const D=this.a.get(N);return this.a.set(N,A),D}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Nh=I}),define(oe[195],ae([0,1,6,8,2,69,186,4,71,87]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const C=!1;class E extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class m{constructor(y=new k.$Nh,l=!1,h,u=C){this.f=y,this.g=l,this.h=h,this.i=u,this.o=new Set,this.f.set(R.$Oh,this),this._globalGraph=u?h?._globalGraph??new D.$cq(b=>b):void 0}createChild(y){return new m(y,this.g,this,this.i)}invokeFunction(y,...l){const h=d.traceInvocation(this.i,y);let u=!1;try{return y({get:S=>{if(u)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(S,h);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...l)}finally{u=!0,h.stop()}}createInstance(y,...l){let h,u;return y instanceof A.$Mh?(h=d.traceCreation(this.i,y.ctor),u=this.j(y.ctor,y.staticArguments.concat(l),h)):(h=d.traceCreation(this.i,y),u=this.j(y,l,h)),h.stop(),u}j(y,l=[],h){const u=R._util.getServiceDependencies(y).sort((s,a)=>s.index-a.index),b=[];for(const s of u){const a=this.m(s.id,h);a||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${s.id}.`,!1),b.push(a)}const S=u.length>0?u[0].index:l.length;if(l.length!==S){console.trace(`[createInstance] First service dependency of ${y.name} at position ${S+1} conflicts with ${l.length} static arguments`);const s=S-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,S)}return Reflect.construct(y,l.concat(b))}k(y,l){if(this.f.get(y)instanceof A.$Mh)this.f.set(y,l);else if(this.h)this.h.k(y,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const l=this.f.get(y);return!l&&this.h?this.h.l(y):l}m(y,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const h=this.l(y);return h instanceof A.$Mh?this.q(y,h,l.branch(y,!0)):(l.branch(y,!1),h)}q(y,l,h){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,l,h)}finally{this.o.delete(y)}}r(y,l,h){const u=new D.$cq(s=>s.id.toString());let b=0;const S=[{id:y,desc:l,_trace:h}];for(;S.length;){const s=S.pop();if(u.lookupOrInsertNode(s),b++>1e3)throw new E(u);for(const a of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${y} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof A.$Mh){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};u.insertEdge(s,i),S.push(i)}}}for(;;){const s=u.roots();if(s.length===0){if(!u.isEmpty())throw new E(u);break}for(const{data:a}of s){if(this.l(a.id)instanceof A.$Mh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}u.removeNode(a)}}return this.l(y)}s(y,l,h=[],u,b){if(this.f.get(y)instanceof A.$Mh)return this.t(y,l,h,u,b);if(this.h)return this.h.s(y,l,h,u,b);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(y,l,h=[],u,b){if(u){const S=new m(void 0,this.g,this,this.i);S.c=String(y);const s=new Map,a=new I.$$g(()=>{const n=S.j(l,h,b);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new g.$2c,s.set(i,o)),(w,f,$)=>{const j=o.push([w,f,$]);return(0,N.$Qc)(j)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,h,b)}u(y,l){if(l&&console.warn(y),this.g)throw new Error(y)}}e.$dq=m;var c;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(c||(c={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(y,l){return y?new d(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(y,l){return y?new d(1,l.name):d.c}static{this.f=0}constructor(y,l){this.type=y,this.name=l,this.g=Date.now(),this.h=[]}branch(y,l){const h=new d(3,y.toString());return this.h.push([y,l,h]),h}stop(){const y=Date.now()-this.g;d.f+=y;let l=!1;function h(b,S){const s=[],a=new Array(b+1).join("	");for(const[n,i,t]of S.h)if(i&&t){l=!0,s.push(`${a}CREATES -> ${n}`);const r=h(b+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(y>2||l)&&d.all.add(u.join(`
`))}}e.$eq=d}),define(oe[72],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=void 0,e.$j8b=(0,I.$Ph)("mainProcessService");class L{constructor(A,D){this.a=A,this.b=D}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,D){this.a.registerChannel(A,D)}}e.$k8b=L}),define(oe[73],ae([0,1,26,2,5,163,29,4]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0;function k(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Rq=k,e.$Sq=(0,R.$Ph)("languagePackService");let g=class extends L.$Sc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new I.$Xd;setTimeout(()=>E.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const d=m.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(y=>y.startsWith("lp-"))).map(p=>{const y=p.properties.localizedLanguages?.[0],l=k(p);return{...this.f(l,y,p),extensionId:p.identifier.id,galleryExtension:p}});return d.push(this.f("en","English")),d}f(E,m,c){const d=m??E;let p;if(d!==E&&(p=`(${E})`),E.toLowerCase()===N.$w.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),c?.installCount){p??="";const y=c.installCount;let l;y>1e6?l=`${Math.floor(y/1e5)/10}M`:y>1e3?l=`${Math.floor(y/1e3)}K`:l=String(y),p+=` $(cloud-download) ${l}`}return{id:E,label:d,description:p}}};e.$Tq=g,e.$Tq=g=ye([Y(0,D.$0n)],g)}),define(oe[196],ae([0,1,2,73]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=void 0;let N=class extends I.$Sc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$I8b=N,e.$I8b=N=ye([Y(0,L.$Sq)],N)}),define(oe[7],ae([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(te,e,I,L,N,A,D,R,k,g,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,m.$Ph)("logService"),e.$$i=(0,m.$Ph)("loggerService");function c(){return new Date().toISOString()}function d(w){return(0,g.$Cf)(w)}e.$_i=d;var p;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$aj=p.Info;function y(w,f,$){switch(f){case p.Trace:w.trace($);break;case p.Debug:w.debug($);break;case p.Info:w.info($);break;case p.Warning:w.warn($);break;case p.Error:w.error($);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=y;function l(w,f=!1){let $="";for(let j=0;j<w.length;j++){let F=w[j];if(F instanceof Error&&(F=(0,I.$Ai)(F,f)),typeof F=="object")try{F=JSON.stringify(F)}catch{}$+=(j>0?" ":"")+F}return $}class h extends A.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new L.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$cj=h;class u extends h{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...$){this.f(p.Trace)&&this.g(p.Trace,l([f,...$],!0))}debug(f,...$){this.f(p.Debug)&&this.g(p.Debug,l([f,...$]))}info(f,...$){this.f(p.Info)&&this.g(p.Info,l([f,...$]))}warn(f,...$){this.f(p.Warning)&&this.g(p.Warning,l([f,...$]))}error(f,...$){if(this.f(p.Error))if(f instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=f.stack,this.g(p.Error,l(j))}else this.g(p.Error,l([f,...$]))}flush(){}}e.$dj=u;class b extends h{constructor(f=e.$aj){super(),this.setLevel(f),this.g=!R.$j}trace(f,...$){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...$):console.log(`[main ${c()}]`,f,...$))}debug(f,...$){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...$):console.log(`[main ${c()}]`,f,...$))}info(f,...$){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...$):console.log(`[main ${c()}]`,f,...$))}warn(f,...$){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,f,...$):console.warn(`[main ${c()}]`,f,...$))}error(f,...$){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,f,...$):console.error(`[main ${c()}]`,f,...$))}dispose(){}flush(){}}e.$ej=b;class S extends h{constructor(f=e.$aj,$=!0){super(),this.g=$,this.setLevel(f)}trace(f,...$){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...$):console.log(f,...$))}debug(f,...$){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...$):console.log(f,...$))}info(f,...$){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...$):console.log(f,...$))}warn(f,...$){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...$):console.log(f,...$))}error(f,...$){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...$):console.error(f,...$))}dispose(){}flush(){}}e.$fj=S;class s extends h{constructor(f,$=e.$aj){super(),this.g=f,this.setLevel($)}trace(f,...$){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...$])}debug(f,...$){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...$])}info(f,...$){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...$])}warn(f,...$){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...$])}error(f,...$){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...$])}h(f){return typeof f=="string"?f:(0,I.$Ai)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$gj=s;class a extends h{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const $ of this.g)$.setLevel(f);super.setLevel(f)}trace(f,...$){for(const j of this.g)j.trace(f,...$)}debug(f,...$){for(const j of this.g)j.debug(f,...$)}info(f,...$){for(const j of this.g)j.info(f,...$)}warn(f,...$){for(const j of this.g)j.warn(f,...$)}error(f,...$){for(const j of this.g)j.error(f,...$)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$hj=a;class n extends A.$Sc{constructor(f,$,j){if(super(),this.h=f,this.j=$,this.b=new D.$Ac,this.c=this.B(new L.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Nd),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}m(f){return(0,g.$yf)(f)?[...this.b.values()].find($=>$.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,$){const j=this.n(f),F=(0,g.$yf)(f)?f:$?.id??(0,N.$Di)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const U=$?.logLevel==="always"?p.Trace:$?.logLevel;z||(z=this.s(j,U??this.getLogLevel(j)??this.h,{...$,id:F}));const q={logger:z,info:{resource:j,id:F,logLevel:U,name:$?.name,hidden:$?.hidden,extensionId:$?.extensionId,when:$?.when}};return this.registerLogger(q.info),this.b.set(j,q),z}n(f){return(0,g.$yf)(f)?(0,k.$vg)(this.j,`${f}.log`):f}setLogLevel(f,$){if(C.URI.isUri(f)){const j=f,F=$,z=this.b.get(j);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([j,F]))}else{this.h=f;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,$){const j=this.m(f);j&&$!==!j.info.hidden&&(j.info.hidden=!$,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,$]))}getLogLevel(f){let $;return f&&($=this.b.get(f)?.info.logLevel),$??this.h}registerLogger(f){const $=this.b.get(f.resource);$?$.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const $=this.b.get(f);$&&($.logger&&$.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[$.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=n;class i{constructor(){this.onDidChangeLogLevel=new L.$Nd().event}setLevel(f){}getLevel(){return p.Info}trace(f,...$){}debug(f,...$){}info(f,...$){}warn(f,...$){}error(f,...$){}critical(f,...$){}dispose(){}flush(){}}e.$jj=i;class t extends i{}e.$kj=t;function r(w){if(w.verbose)return p.Trace;if(typeof w.logLevel=="string"){const f=v(w.logLevel.toLowerCase());if(f!==void 0)return f}return e.$aj}e.$lj=r;function o(w){switch(w){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$mj=o;function v(w){switch(w){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$nj=v,e.$oj=new E.$7i("logLevel",o(p.Info))}),define(oe[197],ae([0,1,6,8,2,23,16,19,31,14,7]),function(te,e,I,L,N,A,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;let E=class extends N.$Sc{constructor(c,d){super(),this.a=c,this.b=d,this.B(new I.$6g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.$sg)(this.a.logsHome),d=(0,R.$ug)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,l=(await k.Promises.readdir(d)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),h=l.slice(0,Math.max(0,l.length-9));h.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>k.Promises.rm((0,D.$jc)(d,u)))))}catch(c){(0,L.$1)(c)}}};e.$J8b=E,e.$J8b=E=ye([Y(0,g.$Wh),Y(1,C.$0i)],E)}),define(oe[198],ae([0,1,18,6,8,3,2,16,49,7]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class C extends D.$Sc{constructor(m,c){super(),this.a=m,this.b=c,this.c=this.B(new A.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$Rg(0)),this.w=[],this.y=this.B(new L.$Rg(0))}watch(m,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(m,c):this.z(m,c)}n(m,c){const d={path:this.H(m),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},p=(0,I.$Ub)(this.j,d);return this.r(),(0,D.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,N.$1)(m))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,k.$Sp)(c)),c=>this.G(c),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const c of this.j)(0,k.$Op)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const c of this.j)(0,k.$Op)(c)&&m.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,c){const d={path:this.H(m),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},p=(0,I.$Ub)(this.w,d);return this.C(),(0,D.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,N.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,k.$Sp)(m)),m=>this.G(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,R.$hc)(m.fsPath)}}e.$Wp=C}),define(oe[199],ae([0,1,18,6,15,26,3,52,59,2,47,23,100,19,46,159,11,99,7,8]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;let S=class extends g.$Sc{static{b=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new D.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Nd),this.Y=this.B(new D.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$3g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${a}`);const i=new g.$Rc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new y.$rk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,g.$Qc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,g.$Nc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await L.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,c.$zg)(a))throw new y.$tk((0,p.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new u.$bb;throw i.message=(0,p.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,y.$ek)(n)||(0,y.$bk)(n)||(0,y.$fk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,y.$ek)(n)||(0,y.$bk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,y.$ok)(i)===y.FileSystemProviderErrorCode.FileNotFound?new y.$tk((0,p.localize)(2,null,this.sb(a)),1):(0,y.$mk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await i.stat(a);let f;return this.t(i,a,w,void 0,!!v,($,j)=>(f||(f=C.$Vh.forUris(()=>!t),f.set(a,!0),r&&f.fill(!0,r)),f.get($.resource)||f.findSuperstr($.resource.with({query:null,fragment:null}))?!0:$.isDirectory&&o?j===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),w={resource:n,name:v.basename(n),isFile:(i.type&y.FileType.File)!==0,isDirectory:(i.type&y.FileType.Directory)!==0,isSymbolicLink:(i.type&y.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&y.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Ek)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&o(w,t)){try{const f=await a.readdir(n),$=await L.Promises.settled(f.map(async([j,F])=>{try{const z=v.joinPath(n,j),U=r?await a.stat(z):{type:F};return await this.t(a,z,U,f.length,r,o)}catch(z){return this.b.trace(z),null}}));w.children=(0,I.$Hb)($)}catch(f){this.b.trace(f),w.children=[]}return w}return w}async resolveAll(a){return L.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new y.$tk((0,p.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=N.$be.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new y.$qk(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,y.$hk)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let w;if((0,y.$bk)(t)&&!(n instanceof N.$be))if((0,d.$Zd)(n)){const f=await(0,d.$7d)(n,3);f.ended?w=N.$be.concat(f.buffer):w=f}else w=(0,d.$4d)(n,f=>N.$be.concat(f),3);else w=n;!(0,y.$ek)(t)||(0,y.$bk)(t)&&w instanceof N.$be||(0,y.$bk)(t)&&(0,y.$hk)(t)&&o?.atomic?await this.hb(t,a,o,w):await this.db(t,a,o,w instanceof N.$be?(0,N.$me)(w):w),this.r.fire(new y.$qk(a,4))}catch(v){throw new y.$tk((0,p.localize)(4,null,this.sb(a),(0,y.$mk)(v).toString()),(0,y.$pk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&y.FileType.Directory)throw new y.$tk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==y.$Dk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,y.$Ek)({mtime:i.mtime,size:o.size}))throw new y.$tk((0,p.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,N.$ne)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new A.$Xd(t);let o=i;(0,y.$gk)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(f=>f,f=>{throw r.dispose(!0),f});let w;try{return typeof o?.etag=="string"&&o.etag!==y.$Dk&&await v,o?.atomic&&(0,y.$gk)(a)||!((0,y.$ek)(a)||(0,y.$fk)(a))||(0,y.$bk)(a)&&o?.preferUnbuffered?w=this.I(a,n,o):(0,y.$fk)(a)?w=this.G(a,n,r.token,o):w=this.H(a,n,r.token,o),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(f){throw w&&await(0,d.$5d)(w),this.F(f,n,o)}}F(a,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,y.$mk)(a).toString());return a instanceof y.$vk?new y.$vk(t,a.stat,i):a instanceof y.$uk?new y.$uk(t,a.fileOperationResult,a.size,a.options):new y.$tk(t,(0,y.$pk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,d.$$d)(r,{data:o=>o instanceof N.$be?o:N.$be.wrap(o),error:o=>this.F(o,n,t)},o=>N.$be.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,N.$re)();return(0,l.$Mp)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,d.$2d)(r=>N.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,y.$gk)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(N.$be.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new y.$tk((0,p.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.$Dk&&n.etag===i.etag)throw new y.$vk((0,p.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new y.$uk((0,p.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$qk(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$qk(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(a,n,i,t,r,o);if(v&&!w&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,y.$ck)(a))await a.copy(n,t,{overwrite:o});else{const f=await this.resolve(n);f.isDirectory?await this.P(a,f,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,y.$ek)(a)&&(0,y.$ek)(i))return this.jb(a,n,i,t);if((0,y.$ek)(a)&&(0,y.$bk)(i))return this.pb(a,n,i,t);if((0,y.$bk)(a)&&(0,y.$ek)(i))return this.nb(a,n,i,t);if((0,y.$bk)(a)&&(0,y.$bk)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:f,isPathCaseSensitive:$}=this.R(a);if($||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!o)throw new y.$tk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:f}=this.R(a);if(f.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?c.$lg:c.$ng,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new y.$qk(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&y.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,y.$ok)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,y.$ok)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new y.$tk((0,p.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const w=await this.resolve(a);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,y.$ik)(i)&&!t?.atomic){const w=i.enforceAtomicDelete?.(a);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new y.$qk(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,y.$dk)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,y.$ck)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:b.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new g.$Rc;let t=!1,r=()=>{t=!0};i.add((0,g.$Qc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,g.$Nc)(v):r=()=>(0,g.$Nc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new D.$Nd);return i.add(this.X.event(f=>{f.correlates(o)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,R.$Di)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,g.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Nc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,g.$Nc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,d.$Zd)(t)||(0,d.$1d)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,y.$mk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,d.$1d)(i)){if(i.buffer.length>0){const o=N.$be.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,d.$6d)(r,{onData:async w=>{r.pause();try{await this.gb(a,n,w,w.byteLength,t,0)}catch(f){return v(f)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const w=await a.write(n,r+v,i.buffer,o+v,t-v);v+=w}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof N.$be?r=t:(0,d.$Zd)(t)?r=await(0,N.$ne)(t):(0,d.$1d)(t)?r=await(0,N.$oe)(t):r=(0,N.$le)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=N.$be.alloc(this.a);let w=0,f=0,$=0;do $=await a.read(r,w,v.buffer,f,v.byteLength-f),await this.gb(i,o,v,$,w,f),w+=$,f+=$,f===v.byteLength&&(f=0);while($>0)}catch(v){throw(0,y.$mk)(v)}finally{await L.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,N.$be.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.$mk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,N.$ne)(this.H(a,n,A.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new y.$tk((0,p.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.$tk((0,p.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Np=S,e.$Np=S=b=ye([Y(0,h.$0i)],S)}),define(oe[200],ae([0,1,53,271,6,34,15,3,48,2,16,5,19,46,31,162,11,99,198,38,194,193]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.$Ai)(a)}`)}})();class s extends h.$Wp{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new A.$Ac(t=>m.$mg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await d.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:y.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await d.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,m.$vg)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=y.FileType.Unknown:n.isFile()?t=y.FileType.File:n.isDirectory()?t=y.FileType.Directory:t=y.FileType.Unknown,i&&(t|=y.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new N.$Sg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await d.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,c.$2d)(o=>D.$be.concat(o.map(v=>D.$be.wrap(v))).buffer);return(0,l.$Mp)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,m.$vg)((0,m.$ug)(n),`${(0,m.$sg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await d.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new g.$Rc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await d.Promises.exists(v)){if(!t.overwrite)throw(0,y.$lk)((0,p.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,y.$lk)((0,p.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,y.$_j)(i)&&!t&&(o=await this.O(n));let v;try{if((0,y.$_j)(i)&&i.unlock)try{const{stat:f}=await d.SymlinkSupport.stat(r);f.mode&128||await d.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let w;if((0,y.$_j)(i)){if(E.$j)try{await d.Promises.truncate(r,0),w="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}w||(w="w")}else w="r";v=await d.Promises.open(r,w)}catch(w){throw o?.dispose(),(0,y.$_j)(i)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,y.$_j)(i)&&this.X.set(v,n),o){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await d.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await d.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let w=null;try{w=(await d.Promises.read(n,t,r,o,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,w)}return w}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,N.$_g)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let w=null;try{w=(await d.Promises.write(n,t,r,o,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await d.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${i.atomic.postfix}`)),await d.Promises.rm(t,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:w}=await d.SymlinkSupport.stat(t);o=v.isDirectory()&&!w}catch{}if(o)await d.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await d.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await d.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$Wf)(o,v,!0)),w){if(t==="copy")throw(0,y.$lk)((0,p.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const $=await this.L(n);if(!$)throw(0,y.$lk)((0,p.localize)(5,null),y.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!r)throw(0,y.$lk)((0,p.localize)(6,null),y.FileSystemProviderErrorCode.FileExists);$.type&y.FileType.File&&j.type&y.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,k.$Wf)(r,o,!v))return;const w=new g.$Rc;try{w.add(await this.O(n)),w.add(await this.O(i)),t&&await d.Promises.mkdir((0,C.$mc)(o),{recursive:!0}),await d.Promises.copyFile(r,o)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(f)}finally{w.dispose()}}t(n,i,t){return new b.$4p(r=>n(r),r=>i(r),t)}F(n,i,t){return new S.$_p(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof y.$kk)return n;let i=n,t;switch(n.code){case"ENOENT":t=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=y.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=y.FileSystemProviderErrorCode.Unknown;break;default:t=y.FileSystemProviderErrorCode.Unknown}return(0,y.$lk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,y.$lk)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$aq=s}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=e.$_8b=void 0,e.$_8b=(0,N.$Ph)("sharedProcessLifecycleService");let D=class extends L.$Sc{constructor(k){super(),this.b=k,this.a=this.B(new I.$Nd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$a9b=D,e.$a9b=D=ye([Y(0,A.$0i)],D)}),define(oe[201],ae([0,1,10,3,7,2]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=void 0;class D extends N.$ij{constructor(E,m,c,d,p){super(m,c,d),this.r=E,this.t=p,this.B(p.listen("onDidChangeLogLevel",E)(y=>{(0,N.$_i)(y)?super.setLogLevel(y):super.setLogLevel(I.URI.revive(y[0]),y[1])})),this.B(p.listen("onDidChangeVisibility",E)(([y,l])=>super.setVisibility(I.URI.revive(y),l))),this.B(p.listen("onDidChangeLoggers",E)(({added:y,removed:l})=>{for(const h of y)super.registerLogger({...h,resource:I.URI.revive(h.resource)});for(const h of l)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new N.$gj({log:(E,m)=>{this.t.call("consoleLog",[E,m])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,m){super.setLogLevel(E,m),this.t.call("setLogLevel",[E,m])}setVisibility(E,m){super.setVisibility(E,m),this.t.call("setVisibility",[this.n(E),m])}s(E,m,c){return new R(this.t,E,m,c,this.r)}static setLogLevel(E,m,c){return E.call("setLogLevel",[m,c])}}e.$$q=D;class R extends N.$dj{constructor(E,m,c,d,p){super(d?.logLevel==="always"),this.r=E,this.s=m,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[m,d,p]).then(()=>{this.u(this.n),this.m=!0})}g(E,m){const c=[[E,m]];this.m?this.u(c):this.n.push(...c)}u(E){this.r.call("log",[this.s,E])}}class k{constructor(E,m){this.a=E,this.b=m}listen(E,m){const c=this.b(E);switch(m){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(p=>this.c(p,c)),removed:[...d.removed].map(p=>this.c(p,c))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,d=>[c.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,d=>(0,N.$_i)(d)?d:[c.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${m}`)}async call(E,m,c){const d=this.b(E);switch(m){case"setLogLevel":return(0,N.$_i)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(I.URI.revive(d.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,d)))}throw new Error(`Call not found: ${m}`)}c(E,m){return{...E,resource:m.transformOutgoingURI(E.resource)}}}e.$_q=k;class g extends A.$Sc{constructor(E,m){super(),m.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(c=>m.call("setLogLevel",[c]))),m.call("getRegisteredLoggers").then(c=>{for(const d of c)E.registerLogger({...d,resource:I.URI.revive(d.resource)})}),this.B(m.listen("onDidChangeVisibility")(([c,d])=>E.setVisibility(I.URI.revive(c),d))),this.B(m.listen("onDidChangeLoggers")(({added:c,removed:d})=>{for(const p of c)E.registerLogger({...p,resource:I.URI.revive(p.resource)});for(const p of d)E.deregisterLogger(p.resource)}))}}e.$ar=g}),define(oe[202],ae([0,1,2,7]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class N extends I.$Sc{constructor(D,R=[]){super(),this.a=new L.$hj([D,...R]),this.B(D.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...R){this.a.trace(D,...R)}debug(D,...R){this.a.debug(D,...R)}info(D,...R){this.a.info(D,...R)}warn(D,...R){this.a.warn(D,...R)}error(D,...R){this.a.error(D,...R)}flush(){this.a.flush()}}e.$EN=N}),define(oe[55],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0,e.$86b=(0,I.$Ph)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,A.$Ph)("policy");class D extends N.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),L.Iterable.reduce(this.g.entries(),(E,[m,c])=>({...E,[m]:c}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(g,[C,E])=>({...g,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$jn=D;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$kn=R}),define(oe[203],ae([0,1,3,2,56]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=e.$R7b=void 0;class A{constructor(k){this.b=k,this.a=new L.$Rc}listen(k,g){switch(g){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((E,m)=>({...E,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$R7b=A;class D extends N.$jn{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:E,value:m}=k[C];this.f[C]=E,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const E in C){const m=C[E];m===null?this.g.delete(E):this.g.set(E,m)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$S7b=D}),define(oe[102],ae([0,1,5,37]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.context<"u"){const A=I.$h.vscode.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(oe[24],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,I.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,6,8,2,16,31,7,24]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;let g=class extends N.$Sc{constructor(E,m,c){super(),this.b=m,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new I.$6g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),c=(0,A.$mc)(E),d=(0,A.$nc)(E),p=await D.Promises.readdir(c);await Promise.all(p.map(async y=>{if(y===d)return;const l=(0,A.$jc)(c,y),h=await D.Promises.stat(l);if(h.isDirectory()&&m-h.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),D.Promises.rm(l)}))}catch(m){(0,L.$1)(m)}}};e.$G8b=g,e.$G8b=g=ye([Y(1,k.$pj),Y(2,R.$0i)],g)}),define(oe[205],ae([0,1,6,8,2,16,31,14,7,24]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;let C=class extends N.$Sc{constructor(m,c,d){super(),this.b=m,this.c=c,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$6g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),c=JSON.parse(await D.Promises.readFile((0,A.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(c)){const u=c[h];m[`${u.hash}.${h}`]=!0}const d=(0,A.$jc)(this.b.userDataPath,"clp");if(!await D.Promises.exists(d))return;const y=await D.Promises.readdir(d);for(const h of y){if(m[h]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await D.Promises.rm((0,A.$jc)(d,h))}const l=Date.now();for(const h of Object.keys(m)){const u=(0,A.$jc)(d,h),b=await D.Promises.readdir(u);for(const S of b){if(S==="tcf.json")continue;const s=(0,A.$jc)(u,S),a=await D.Promises.stat(s);a.isDirectory()&&l-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$jc)(h,S)}`),await D.Promises.rm(s))}}}catch(m){(0,L.$1)(m)}}};e.$H8b=C,e.$H8b=C=ye([Y(0,R.$Xh),Y(1,k.$0i),Y(2,g.$pj)],C)}),define(oe[206],ae([0,1,16,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$WE=void 0,e.$WE=(0,L.$Ph)("IV8InspectProfilingService");var N;(function(A){function D(k){return!!(k.samples&&k.timeDeltas)}A.isValidProfile=D;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,I.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$jc)(g,(0,I.$nc)(C.callFrame.url)));return k}A.rewriteAbsolutePaths=R})(N||(e.Utils=N={}))}),define(oe[207],ae([0,1,32]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$28b=void 0;class L{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((g,C)=>{te(["v8-inspect-profiler"],g,C)})).startProfiling({port:A.port,checkForPaused:!0}),k=(0,I.$eg)();return this.a.set(k,R),k}async stopProfiling(A){const D=this.a.get(A);if(!D)throw new Error(`UNKNOWN session '${A}'`);const R=await D.stop();return this.a.delete(A),R.profile}}e.$28b=L}),define(oe[40],ae([0,1,127,12]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class N{constructor(){this.a=new Map}add(D,R){I.ok(L.$yf(D)),I.ok(L.$Af(R)),I.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,R)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$gn=new N}),define(oe[103],ae([0,1,3,40]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function N(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new I.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[N(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;L.$gn.add(e.$hn.JSONContribution,D)}),define(oe[50],ae([0,1,18,3,12,149,20,103,40]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var g;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$ln={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const E=k.$gn.as(R.$hn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new L.$Nd,this.onDidSchemaChange=this.i.event,this.j=new L.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$vn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const j of Object.keys(i[r]))v.set(j,t);const w={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const f=(0,D.$ti)(r),$={type:"object",default:w,description:A.localize(1,null,f),$ref:e.$sn,defaultDefaultValue:w,source:N.$yf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=$,this.b.properties[r]=$}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=N.$yf(i)?i:i?.id,v=N.$yf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$vn.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=N.$Hf(s.scope)?t:s.scope;const o=s.properties;if(o)for(const w in o){const f=o[w];if(a&&u(w,f)){delete o[w];continue}if(f.source=n,f.defaultDefaultValue=o[w].default,this.w(w,f),e.$vn.test(w)?f.scope=void 0:(f.scope=N.$Hf(f.scope)?t:f.scope,f.restricted=N.$Hf(f.restricted)?!!i?.includes(w):f.restricted),o[w].hasOwnProperty("included")&&!o[w].included){this.f[w]=o[w],delete o[w];continue}else this.d[w]=o[w],o[w].policy?.name&&this.e.set(o[w].policy.name,w);!o[w].deprecationMessage&&o[w].markdownDeprecationMessage&&(o[w].deprecationMessage=o[w].markdownDeprecationMessage),r.add(w)}const v=s.allOf;if(v)for(const w of v)this.p(w,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$mn.properties[s]=a,a.scope){case 1:e.$nn.properties[s]=a;break;case 2:e.$on.properties[s]=a;break;case 6:e.$pn.properties[s]=a;break;case 3:e.$qn.properties[s]=a;break;case 4:e.$rn.properties[s]=a;break;case 5:e.$rn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$mn.properties[s],a.scope){case 1:delete e.$nn.properties[s];break;case 2:delete e.$on.properties[s];break;case 6:delete e.$pn.properties[s];break;case 3:delete e.$qn.properties[s];break;case 4:case 5:delete e.$rn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$sn};this.w(a,n),e.$mn.properties[a]=n,e.$nn.properties[a]=n,e.$on.properties[a]=n,e.$pn.properties[a]=n,e.$qn.properties[a]=n,e.$rn.properties[a]=n}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=s,e.$nn.patternProperties[e.$un]=s,e.$on.patternProperties[e.$un]=s,e.$pn.patternProperties[e.$un]=s,e.$qn.patternProperties[e.$un]=s,e.$rn.patternProperties[e.$un]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;N.$Ff(i)&&(i=a.defaultDefaultValue,t=void 0),N.$Ff(i)&&(i=l(a.type)),a.default=i,a.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",d=new RegExp(c,"g");e.$un=`^(${c})+$`,e.$vn=new RegExp(e.$un);function p(S){const s=[];if(e.$vn.test(S)){let a=d.exec(S);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=d.exec(S)}}return(0,I.$Mb)(s)}e.$wn=p;function y(S){return S.reduce((s,a)=>`${s}[${a}]`,"")}e.$xn=y;function l(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=l;const h=new m;k.$gn.add(e.$ln.Configuration,h);function u(S,s){return S.trim()?e.$vn.test(S)?A.localize(7,null,S):h.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):s.policy?.name&&h.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,S,s.policy?.name,h.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$zn=u;function b(){const S=[],s=h.getConfigurationProperties();for(const a of Object.keys(s))S.push([a,s[a].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$An=b}),define(oe[74],ae([0,1,18,3,35,2,34,30,12,10,20,50,40]),function(te,e,I,L,N,A,D,R,k,g,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function c(a){return Object.isFrozen(a)?a:R.$8m(a)}class d{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof d)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$ri)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$ri)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return I.$Mb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return I.$Mb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$7m(this.contents),t=R.$7m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const w of v.overrides){const[f]=t.filter($=>I.$ub($.identifiers,w.identifiers));f?(this.h(f.contents,w.contents),f.keys.push(...w.keys),f.keys=I.$Mb(f.keys)):t.push(R.$7m(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new d(i,r,t,o.every(v=>v instanceof d)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=R.$7m(o),this.h(o,v)):o=v),t[r]=o}return new d(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&k.$Af(n[t])&&k.$Af(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$7m(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=R.$7m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$qi)(this.contents,n),E.$vn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,E.$wn)(n))),1))}j(n,i,t){(0,C.$pi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$vn.test(n)&&this.overrides.push({identifiers:(0,E.$wn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$oi)(this.contents[n],r=>console.error(r))})}}e.$Bn=d;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!k.$Hf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:w}=this.h(n,i);this.b=new d(t,r,o,w?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function w($){Array.isArray(r)?r.push($):t!==null&&(r[t]=$)}const f={onObjectBegin:()=>{const $={};w($),o.push(r),r=$,t=null},onObjectProperty:$=>{t=$},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const $=[];w($),o.push(r),r=$,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:w,onError:($,j,F)=>{v.push({error:$,offset:j,length:F})}};if(n)try{N.$4m(n,f),i=r[0]||{}}catch($){console.error(`Error while parsing settings file ${this.f}: ${$}`),this.d=[$]}return i}h(n,i){const t=m.$gn.as(E.$ln.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,C.$oi)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),w=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:o,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},w=[];for(const f in n)if(E.$vn.test(f)&&t){const $=this.i(n[f],i,!1,r);v[f]=$.raw,o=o||$.hasExcludedProperties,w.push(...$.restricted)}else{const $=i[f],j=$?typeof $.scope<"u"?$.scope:3:void 0;$?.restricted&&w.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&$?.restricted))?v[f]=n[f]:o=!0}return{raw:v,restricted:w,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$vn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$wn)(r),keys:Object.keys(o),contents:(0,C.$oi)(o,i)})}return t}}e.$Cn=p;class y extends A.$Sc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new L.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=y;class l{constructor(n,i,t,r,o,v,w,f,$,j,F,z,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=w,this.h=f,this.i=$,this.j=j,this.k=F,this.l=z,this.m=U}get value(){return c(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(n,i,t,r,o=new d,v=new d,w=new D.$Ac,f=new d,$=new D.$Ac){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=w,this.l=f,this.m=$,this.a=null,this.b=new D.$Ac,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new d,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),o=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const f of r.overrides)for(const $ of f.identifiers)r.getOverrideValue(n,$)!==void 0&&w.add($);return new l(n,i,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=S(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$wn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),w=n.getKeysForOverrideIdentifier(o),f=[...w.filter($=>v.indexOf($)===-1),...v.filter($=>w.indexOf($)===-1),...v.filter($=>!R.$$m(this.c.override(o).getValue($),n.override(o).getValue($)))];t.push([o,f])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=S(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:o,removed:v,overrides:w}=S(t,i),f=[...r,...o,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,i),{keys:f,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=S(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),o=this.x(n.user),v=this.x(n.workspace),w=n.folders.reduce((f,$)=>(f.set(g.URI.revive($[0]),this.x($[1])),f),new D.$Ac);return new h(i,t,r,o,new d,v,w,new d,new D.$Ac)}static x(n){return new d(n.contents,n.keys,n.overrides)}}e.$En=h;function u(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const w=(0,D.$xc)(i,o,new Set);v.forEach(f=>w.add(f))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Fn=u;class b{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,f=this.g.getValue(n,i,this.h);return!R.$$m(w,f)}return!0}}e.$Gn=b;function S(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const f=w.filter($=>!v.includes($));for(const $ of f)o.push([$,n.getKeysForOverrideIdentifier($)])}if(a){const f=v.filter($=>!w.includes($));for(const $ of f)o.push([$,a.getKeysForOverrideIdentifier($)])}if(n&&a){for(const f of v)if(w.includes(f)){const $=s({contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});o.push([f,[...$.added,...$.removed,...$.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,C.$ri)(n.contents,o),w=(0,C.$ri)(a.contents,o);R.$$m(v,w)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,74,50,7,56,40]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=void 0;class m extends N.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Bn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$gn.as(k.$ln.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:l})=>this.c(Array.from(y),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(y,l){this.h(y,E.$gn.as(k.$ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}f(){return{}}g(){this.b=new R.$Bn;const y=E.$gn.as(k.$ln.Configuration).getConfigurationProperties();this.h(Object.keys(y),y)}h(y,l){const h=this.f();for(const u of y){const b=h[u],S=l[u];b!==void 0?this.b.addValue(u,b):S?this.b.addValue(u,S.default):this.b.removeValue(u)}}}e.$Hn=m;class c{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new R.$Bn}async initialize(){return this.configurationModel}}e.$In=c;let d=class extends N.$Sc{get configurationModel(){return this.b}constructor(y,l,h){super(),this.c=y,this.f=l,this.g=h,this.a=this.B(new L.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Bn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const l={},h=[],u=E.$gn.as(k.$ln.Configuration).getConfigurationProperties();for(const b of y){const S=u[b];if(!S){h.push(b);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}h.push(b),l[S.policy.name]={type:S.type}}}return(0,D.$Lf)(l)||await this.f.updatePolicyDefinitions(l),h}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const l=E.$gn.as(k.$ln.Configuration).getPolicyConfigurations(),h=(0,I.$Hb)(y.map(u=>l.get(u)));this.m(h,!0)}m(y,l){this.g.trace("PolicyConfiguration#update",y);const h=E.$gn.as(k.$ln.Configuration).getConfigurationProperties(),u=[],b=this.b.isEmpty();for(const S of y){const s=h[S]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(b?a!==void 0:!(0,A.$$m)(this.b.getValue(S),a))&&u.push([S,a])}else this.b.getValue(S)!==void 0&&u.push([S,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const S=this.b;this.b=new R.$Bn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,a]of u)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);l&&this.a.fire(this.b)}}};e.$Jn=d,e.$Jn=d=ye([Y(1,C.$in),Y(2,g.$0i)],d)}),define(oe[209],ae([0,1,6,3,2,19,20,74,208,56]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class C extends N.$Sc{constructor(m,c,d,p){super(),this.j=m,this.h=this.B(new L.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$Hn),this.c=d instanceof g.$kn?new k.$In:this.B(new k.$Jn(this.b,d,p)),this.f=this.B(new R.$Dn(this.j,{},A.$mg,c)),this.a=new R.$En(this.b.configurationModel,this.c.configurationModel,new R.$Bn,new R.$Bn),this.g=this.B(new I.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:y,properties:l})=>this.n(y,l))),this.B(this.c.onDidChangeConfiguration(y=>this.r(y))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,c,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$En(m,c,new R.$Bn,d)}getConfigurationData(){return this.a.toData()}getValue(m,c){const d=typeof m=="string"?m:void 0,p=(0,D.$ki)(m)?m:(0,D.$ki)(c)?c:{};return this.a.getValue(d,p,void 0)}updateValue(m,c,d,p){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.m(m)}m(m){const c=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(m);this.s(d,c,2)}n(m,c){const d=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(m,c);this.s(p,d,7)}r(m){const c=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(m);this.s(d,c,7)}s(m,c,d){const p=new R.$Gn(m,{data:c},this.a);p.source=d,p.sourceConfig=this.t(d),this.h.fire(p)}t(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Kn=C}),define(oe[210],ae([0,1,15,3,2,66]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkb=e.$Akb=e.$zkb=e.$ykb=void 0;const D=(g,C,E)=>{const m=new Uint8Array(16);for(let p=0;p<16;p++)m[p]=Math.round(Math.random()*256);const c=(0,I.$ve)(I.$be.wrap(m));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$ykb=D,e.$zkb=I.$be.fromString(`\r
\r
`);async function R(g,C,E,m,c){g.write(I.$be.fromString((0,e.$ykb)(C,E,m)));const d=new N.$Rc;try{return await new Promise((p,y)=>{let l;d.add(g.onData(h=>{l?l=I.$be.concat([l,h],l.byteLength+h.byteLength):l=h;const u=l.indexOf(e.$zkb);if(u===-1)return;p(g),g.pauseData();const b=l.slice(u+e.$zkb.byteLength);b.byteLength&&c.onData.fire(b)})),d.add(g.onClose(h=>y(h??new Error("socket closed")))),d.add(g.onEnd(()=>y(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{d.dispose()}}e.$Akb=R;class k extends N.$Sc{constructor(C,E){super(),this.g=C,this.a=this.B(new L.$Qd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new L.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(m=>this.a.fire(m))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,E){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Bkb=k}),define(oe[211],ae([0,1,8,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,L.$Ph)("remoteAuthorityResolverService");var N;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class A{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=A;class D{constructor(E,m){this.host=E,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=D;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends I.$bb{static isNotAvailable(E){return E instanceof k&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof k&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof k&&E.isHandled}constructor(E,m=R.Unknown,c){super(E),this._message=E,this._code=m,this._detail=c,this.isHandled=m===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Sk=k;function g(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$Tk=g}),define(oe[75],ae([0,1,23]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function L(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}e.$Uk=L;function N(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$Vk=N;function A(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Wk=A;function D(g){const{host:C,port:E}=k(g);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.$Xk=D;function R(g,C){let{host:E,port:m}=k(g);return typeof m>"u"&&(m=C),{host:E,port:m}}e.$Yk=R;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=g.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(oe[44],ae([0,1,27,4,75]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$4l=A,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(D||(e.ExtensionType=D={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,l){if(typeof y>"u"||y===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof y=="string"||typeof l=="string"){const h=typeof y=="string"?y:y.value,u=typeof l=="string"?l:l.value;return I.$2e(h,u)}return y._lower===l._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.$6l=k;class g{get size(){return this.c.size}constructor(y){if(this.c=new Set,y)for(const l of y)this.add(l)}add(y){this.c.add(k.toKey(y))}delete(y){return this.c.delete(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}}e.$7l=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(y){this.c.delete(k.toKey(y))}get(y){return this.c.get(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}set(y,l){this.c.set(k.toKey(y),l)}values(){return this.c.values()}forEach(y){this.c.forEach(y)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=C;function E(p){return m(p)}e.$9l=E;function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$0l=m;function c(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$$l=c;function d(p,y){if(y){const l=`onResolveRemoteAuthority:${(0,N.$Vk)(y)}`;return!!p.activationEvents?.includes(l)}return!1}e.$_l=d,e.$am=(0,L.$Ph)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;class A extends I.$Sc{constructor(R,k,g,C,E){super(),this.a=R,this.b=k,this.c=g,this.f=E,this.B(C.onDidInstallExtensions(m=>this.g(m))),this.B(C.onDidUninstallExtension(m=>this.h(m)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,L.$Zl))}catch(k){(0,N.$pk)(k)!==1&&this.f.error(k)}}}e.$Gp=A}),define(oe[213],ae([0,1,6,15,26,8,3,2,100,61,32,66,211,75]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const d=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function y(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(B){const P=new N.$Xd;return setTimeout(()=>P.cancel(),B),P.token}function h(B,P){if(B.isCancellationRequested||P.isCancellationRequested)return N.CancellationToken.Cancelled;const O=new N.$Xd;return B.onCancellationRequested(()=>O.cancel()),P.onCancellationRequested(()=>O.cancel()),O.token}class u{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Rc,this.promise=new Promise((O,T)=>{this.f=O,this.g=T}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function b(B,P){const O=new u(P);return O.registerDisposable(B.onControlMessage(T=>{const M=JSON.parse(T.toString()),V=W(M);V?O.reject(V):O.resolve(M)})),O.promise}function S(B,P,O,T,M,V,J,re){const ce=new u(re),ue=g.$Jd.create(!1);return B.info(`Creating a socket (${J})...`),k.mark(`code/willCreateSocket/${V}`),P.connect(O,T,M,J).then(he=>{ce.didTimeout?(k.mark(`code/didCreateSocketError/${V}`),B.info(`Creating a socket (${J}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(k.mark(`code/didCreateSocketOK/${V}`),B.info(`Creating a socket (${J}) was successful after ${ue.elapsed()} ms.`),ce.resolve(he))},he=>{k.mark(`code/didCreateSocketError/${V}`),B.info(`Creating a socket (${J}) returned an error after ${ue.elapsed()} ms.`),B.error(he),ce.reject(he)}),ce.promise}function s(B,P){const O=new u(P);return B.then(T=>{O.didTimeout||O.resolve(T)},T=>{O.didTimeout||O.reject(T)}),O.promise}async function a(B,P,O,T){const M=ie(B,P);B.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let V;try{V=await S(B.logService,B.remoteSocketFactoryService,B.connectTo,(0,c.$Wk)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,y(P),`renderer-${y(P)}-${B.reconnectionToken}`,T)}catch(he){throw B.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),B.logService.error(he),he}B.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let J,re;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),J=B.reconnectionProtocol,re=!1):(J=new E.$Dh({socket:V}),re=!0),B.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const ce=await s(B.signService.createNewMessage((0,C.$eg)()),T),ue={type:"auth",auth:B.connectionToken||"00000000000000000000",data:ce.data};J.sendControl(L.$be.fromString(JSON.stringify(ue)));try{const he=await b(J,h(T,l(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(B.logService.trace(`${M} 4/6. received SignRequest control message.`),!await s(B.signService.validate(ce,he.signedData),T)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await s(B.signService.sign(he.data),T),we={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:P};return O&&(we.args=O),B.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(L.$be.fromString(JSON.stringify(we))),{protocol:J,ownsProtocol:re}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(B.logService.error(`${M} the handshake timed out. Error:`),B.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${M} received error control message when negotiating connection. Error:`),B.logService.error(he)),re&&G(J),he}}async function n(B,P,O,T){const M=Date.now(),V=ie(B,P),{protocol:J,ownsProtocol:re}=await a(B,P,O,T),ce=new u(T);return ce.registerDisposable(J.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=W(he);$e?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error($e),re&&G(J),ce.reject($e)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${X(M)}!`),ce.resolve({protocol:J,firstMessage:he}))})),ce.promise}async function i(B,P){const{protocol:O}=await n(B,1,void 0,P);return{protocol:O}}async function t(B,P,O){const{protocol:T,firstMessage:M}=await n(B,2,P,O),V=M&&M.debugPort;return{protocol:T,debugPort:V}}async function r(B,P,O){const T=Date.now(),M=ie(B,3),{protocol:V}=await a(B,3,P,O);return B.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${X(T)}!`),V}async function o(B,P,O){const{connectTo:T,connectionToken:M}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,connectTo:T,connectionToken:M,reconnectionToken:P,reconnectionProtocol:O,remoteSocketFactoryService:B.remoteSocketFactoryService,signService:B.signService,logService:B.logService}}async function v(B,P,O){return f(B,async T=>{const{protocol:M}=await i(T,N.CancellationToken.None);return new H(B,P,O,T.reconnectionToken,M)})}e.$4k=v;async function w(B,P){return f(B,async O=>{const{protocol:T,debugPort:M}=await t(O,P,N.CancellationToken.None);return new Q(B,P,O.reconnectionToken,T,M)})}e.$5k=w;async function f(B,P){for(let T=1;;T++)try{const M=(0,C.$eg)(),V=await o(B,M,null);return await P(V)}catch(M){if(T<5)B.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(M);else throw B.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(M),x.triggerPermanentFailure(0,0,m.$Sk.isHandled(M)),M}}async function $(B,P,O){const T=await o(B,(0,C.$eg)(),null);return await r(T,{host:P,port:O},N.CancellationToken.None)}e.$6k=$;function j(B){return(0,I.$Hg)(P=>new Promise((O,T)=>{const M=setTimeout(O,B*1e3);P.onCancellationRequested(()=>{clearTimeout(M),O()})}))}var F;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(P,O){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.type=0}}e.$7k=z;class U{constructor(P,O,T,M){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.durationSeconds=T,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$8k=U;class q{constructor(P,O,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=T,this.type=2}}e.$9k=q;class Z{constructor(P,O,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=T,this.type=4}}e.$0k=Z;class K{constructor(P,O,T,M){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=T,this.handled=M,this.type=3}}e.$$k=K;class x extends R.$Sc{static triggerPermanentFailure(P,O,T){this._permanentFailure=!0,this.f=P,this.g=O,this.h=T,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,O,T,M,V){super(),this.t=P,this.u=O,this.reconnectionToken=T,this.protocol=M,this.w=V,this.m=this.B(new D.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(M.onSocketClose(J=>{const re=_(this.t,this.reconnectionToken,!0);J?J.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(J=>{const re=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Qc)(()=>{const J=x.j.indexOf(this);J>=0&&x.j.splice(J,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const M=T<O.length?O[T]:O[O.length-1];try{if(M>0){const J=j(M);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,J)),this.u.logService.info(`${P} waiting for ${M} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this.u.logService.info(`${P} resolving connection...`);const V=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${V.connectTo}...`),await this.G(V,l(d)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(m.$Sk.isTemporarilyNotAvailable(V)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((0,A.$4)(V)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if(V instanceof m.$Sk){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,m.$Sk.isHandled(V));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this.n&&!this.s)}C(P,O,T){this.w?x.triggerPermanentFailure(P,O,T):this.D(P,O,T)}D(P,O,T){this.m.fire(new K(this.reconnectionToken,P,O,T)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=x;class H extends x{constructor(P,O,T,M,V){super(1,P,M,V,!0),this.client=this.B(new E.$Bh(V,{remoteAuthority:O,clientId:T},P.ipcLogger))}async G(P,O){await i(P,O)}}e.$al=H;class Q extends x{constructor(P,O,T,M,V){super(2,P,T,M,!1),this.H=O,this.debugPort=V}async G(P,O){await t(P,this.H,O)}}e.$bl=Q;function G(B){try{B.acceptDisconnect();const P=B.getSocket();B.dispose(),P.dispose()}catch(P){(0,A.$1)(P)}}function W(B){if(B&&B.type==="error"){const P=new Error(`Connection error: ${B.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function ee(B,P){for(;B.length<P;)B+=" ";return B}function ne(B,P){return`[remote-connection][${ee(y(B),13)}][${P.substr(0,5)}\u2026]`}function _(B,P,O){return`${ne(B,P)}[${O?"reconnect":"initial"}]`}function ie(B,P){return`${_(P,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.connectTo}]`}function X(B){return`${Date.now()-B} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,L.$Ph)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(D,R){return this.a[D]??=[],this.a[D].push(R),(0,I.$Qc)(()=>{const k=this.a[D]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[D]?.splice(k,1)})}b(D){return(this.a[D.type]||[]).find(k=>k.supports(D))}connect(D,R,k,g){const C=this.b(D);if(!C)throw new Error(`No socket factory found for ${D}`);return C.connect(D,R,k,g)}}e.$1k=N}),define(oe[214],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=e.$Y8b=void 0,e.$Y8b=(0,I.$Ph)("sharedProcessTunnelService"),e.$Z8b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=e.$88b=e.$78b=e.$68b=e.TunnelStates=e.$58b=e.$48b=void 0,e.$48b=(0,I.$Ph)("IRemoteTunnelService"),e.$58b={active:!1};var N;(function(A){A.disconnected=D=>({type:"disconnected",onTokenFailed:D}),A.connected=(D,R)=>({type:"connected",info:D,serviceInstallFailed:R}),A.connecting=D=>({type:"connecting",progress:D}),A.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$68b="remote.tunnels.access",e.$78b=e.$68b+".hostNameOverride",e.$88b=e.$68b+".preventSleep",e.$98b="remoteTunnelService",e.$08b=(0,L.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,50,4,7,40]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$So=(0,R.$Ph)("requestService");class C{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class E extends N.$Sc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,A.localize)(0,null),when:k.$oj.isEqualTo((0,k.$mj)(k.LogLevel.Trace)).serialize()})}async c(S,s,a){const n=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,L.$0)(i)),i}}}e.$To=E;function m(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.$Uo=m;function c(b){return b.res.statusCode===204}e.$Vo=c;async function d(b){return c(b)?null:(await(0,I.$ne)(b.stream)).toString()}e.$Wo=d;async function p(b){if(!m(b))throw new Error("Server returned "+b.res.statusCode);return d(b)}e.$Xo=p;async function y(b){if(!m(b))throw new Error("Server returned "+b.res.statusCode);if(c(b))return null;const s=(await(0,I.$ne)(b.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$Yo=y;function l(b){u(b)}e.$Zo=l;let h;function u(b){const S=g.$gn.as(D.$ln.Configuration),s=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[h],remove:s?[s]:[]})}u(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;let D=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=I.CancellationToken.None){if(k.scheme===L.Schemas.file||k.scheme===L.Schemas.vscodeRemote){await this.b.copy(k,g);return}const E={type:"GET",url:k.toString(!0)},m=await this.a.request(E,C);if(m.res.statusCode===200)await this.b.writeFile(g,m.stream);else{const c=await(0,A.$Xo)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${c}`)}}};e.$TN=D,e.$TN=D=ye([Y(0,A.$So),Y(1,N.$$j)],D)}),define(oe[216],ae([0,1,15,26]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;class N{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=L.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:E,stream:m})=>{const c=await(0,I.$ne)(m);return[{statusCode:E.statusCode,headers:E.headers},c]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.$Vq=N;class A{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,I.$pe)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Wq=A}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=e.$q7b=e.$p7b=void 0,e.$p7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$q7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$r7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k3b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const A=await this.c();if(A){const D=String(I.a++);return this.b.set(D,A),{id:D,data:A.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,A){if(!N.id)return!0;const D=this.b.get(N.id);if(!D)return!1;this.b.delete(N.id);try{return D.validate(A)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$k3b=I}),define(oe[106],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,I.$Ph)(e.$2k)}),define(oe[219],ae([0,1,218]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;class L extends I.$k3b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(D=>new D.signer().sign(A))}h(){return new Promise((A,D)=>te(["vsda"],A,D))}}e.$f8b=L}),define(oe[76],ae([0,1,3,2]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Cb=e.$$Cb=e.$0Cb=e.$9Cb=void 0;class N extends L.$Sc{constructor(E,m,c){super(),this.a=E,this.b=m,this.c=c}async getItems(){const E={profile:this.b,workspace:this.c},m=await this.a.call("getItems",E);return new Map(m)}updateItems(E){const m={profile:this.b,workspace:this.c};return E.insert&&(m.insert=Array.from(E.insert.entries())),E.delete&&(m.delete=Array.from(E.delete.values())),this.a.call("updateItems",m)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class A extends N{constructor(E,m){super(E,m,void 0),this.f=this.B(new I.$Nd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class D extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$9Cb=D;class R extends A{constructor(E,m){super(E,m)}async close(){this.dispose()}}e.$0Cb=R;class k extends N{constructor(E,m){super(E,void 0,m),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$$Cb=k;class g{constructor(E){this.a=E}isUsed(E){const m={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$_Cb=g}),define(oe[107],ae([0,1,5,37,32]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function A(k){if(I.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function D(k,g,C,E,m,c,d,p,y){const l=Object.create(null);l["common.machineId"]=c,l["common.sqmId"]=d,l.sessionID=(0,N.$eg)()+Date.now(),l.commitHash=E,l.version=m,l["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,I.$i)(I.$u),l["common.nodePlatform"]=L.$dc,l["common.nodeArch"]=C,l["common.product"]=y||"desktop",p&&(l["common.msftInternal"]=p);let h=0;const u=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),I.$m&&(l["common.snap"]="true");const b=A(g);return b&&(l["common.platformDetail"]=b),l}e.$ho=D;function R(k){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(E=>C===E)}e.$io=R}),define(oe[22],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,I.$Ph)("telemetryService"),e.$dl=(0,I.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var N;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(oe[220],ae([0,1,36,6,35,23,16,5,10,143,31,146,95,11,24,22]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=e.$Er=e.$Dr=void 0;const y=new Map;async function l(s,a){const n=`${s}::${a.join(":")}`,i=y.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function w($,j,F,z){const U=j.substring($.length+1);return L.Promises.withAsyncBody(async q=>{let Z;try{Z=await C.Promises.readdir(j,{withFileTypes:!0})}catch{q();return}if(z.count>=v){z.count+=Z.length,z.maxReached=!0,q();return}let K=Z.length;if(K===0){q();return}let x=Z;z.count+Z.length>v&&(z.maxReached=!0,K=v-z.count,x=Z.slice(0,K)),z.count+=Z.length;for(const H of x)if(H.isDirectory()){if(F.includes(H.name)||await w($,(0,D.$jc)(j,H.name),F,z),--K===0){q();return}}else{const Q=H.name.lastIndexOf(".");if(Q>=0){const G=H.name.substring(Q+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of t)G.relativePathPattern?.test(U)!==!1&&G.filePattern.test(H.name)&&o.set(G.tag,(o.get(G.tag)??0)+1);if(--K===0){q();return}}})}const f=L.Promises.withAsyncBody(async $=>{const j={count:0,maxReached:!1};await w(s,s,a,j);const F=await b(s);$({configFiles:h(o),fileTypes:h(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F})});return y.set(n,f),f}e.$Dr=l;function h(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function u(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/c.$Gk.GB).toFixed(2)}GB (${(I.freemem()/c.$Gk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$Rm.value()*100)}%`},a=I.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Er=u;async function b(s){try{const a=new Map,n=(0,D.$jc)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,N.$Wm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,N.$6m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return h(a)}catch{return[]}}e.$Fr=b;let S=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/c.$Gk.GB).toFixed(2)}GB (${(I.freemem()/c.$Gk.GB).toFixed(2)}GB free)`),R.$j||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$Rm.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$Cr)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,m.$rm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[w];let $=`${f.fileCount} files`;f.maxFilesReached&&($=`more than ${$}`),r+=`|    Folder (${w}): ${$}`,r+=this.h(f)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=u(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return R.$j||(v.load=`${I.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$Cr)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,m.$rm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${o}): ${w}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(f,$)=>{const j=` ${f}(${$})`;t+j.length>60?(n.push(o),o="|                 ",t=o.length):t+=j.length,o+=j};let o="|      File types:";const v=10,w=a.fileTypes.length>v?v:a.fileTypes.length;for(let f=0;f<w;f++){const $=a.fileTypes[f];r($.name,$.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(o)),a.launchConfigFiles.length>0){let f="|      Launch Configs:";a.launchConfigFiles.forEach($=>{const j=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`;f+=j}),n.push(f)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=k.URI.revive(r);if(o.scheme===A.Schemas.file){const v=o.fsPath;i.push(l(v,["node_modules",".git"]).then(w=>{let f=`${w.fileCount} files`;w.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,D.$nc)(v)}): ${f}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/c.$Gk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(a,n,i,f,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=k.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=k.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const t=i.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Gr=S,e.$Gr=S=ye([Y(0,p.$cl),Y(1,d.$pj)],S)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=e.$u7b=void 0;class I{constructor(A){this.b=A}listen(A,D){throw new Error(`Event not found: ${D}`)}call(A,D,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$u7b=I;class L{constructor(A){this.b=A}log(A,D){return this.b.call("log",{eventName:A,data:D}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$v7b=L}),define(oe[45],ae([0,1,30,12,3,20,75,107,22]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$jo=g;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=C,e.$lo=new C;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$mo=E,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,t){return N.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const w=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:w}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$mi)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$qo=m;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$ro=c;function d(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$so=d;function p(i){const t=i.getValue(k.$kl),r=i.getValue(k.$ll);if(i.getValue(k.$ml)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=p;function y(i){const t={},r={},o={};u(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const w=o[v];typeof w=="number"?r[v]=w:typeof w=="boolean"?r[v]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${w.length}`),t[v]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(t[v]=w)}return{properties:t,measurements:r}}e.$uo=y;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const t=(0,D.$Vk)(i);return l.has(t)?t:"other"}e.$vo=h;function u(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const w=i[v],f=o?o+v:v;Array.isArray(w)?t[f]=(0,I.$_m)(w):w instanceof Date?t[f]=w.toISOString():(0,L.$Af)(w)?r<2?u(w,t,r+1,f+"."):t[f]=(0,I.$_m)(w):t[f]=w}}function b(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,R.$io)(r)||o}e.$wo=b;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$xo=S;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const $ of t)for(;;){const j=$.exec(i);if(!j)break;o.push([j.index,$.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const $=w.exec(i);if(!$)break;const j=o.some(([F,z])=>$.index<z&&F<w.lastIndex);!v.test($[0])&&!j&&(r+=i.substring(f,$.index)+"<REDACTED: user-file-path>",f=w.lastIndex)}return f<i.length&&(r+=i.substr(f)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,I.$9m)(i,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$yo=n}),define(oe[33],ae([0,1,27,29,44,5,10,8,37,45]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,I.$We)(n.id,i.id)===0}e.$zo=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Ao=m;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const i=c.exec(n);return i&&i[1]?[y(i[1]),i[2]]:[y(n),void 0]}e.$Bo=d;function p(n,i){return`${n}.${i}`}e.$Co=p;function y(n){return n.toLowerCase()}e.$Do=y;function l(n,i){return y(p(n??N.$2l,i))}e.$Eo=l;function h(n,i){const t=[],r=o=>{for(const v of t)if(v.some(w=>C(i(w),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Fo=h;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Go=u;function b(n){return{id:new g.$jo(n.identifier.id),name:new g.$jo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Ho=b,e.$Io=new N.$6l("pprice.better-merge");function S(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!C(v.identifier,{id:o}))){const v=n.filter(w=>C(w.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Jo=S;async function s(n,i){if(!A.$l)return!1;let t;try{t=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,R.$0)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,L.$6n)(t?"alpine":A.$u,k.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Ko=a}),define(oe[221],ae([0,1,18,2,19,10,11,24,6,3,16,5,37,33]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q5b=e.$p5b=void 0;let d=class extends L.$Sc{constructor(u,b){super(),this.b=u,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,S])=>this.a.set(S.configPath,S))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const b=[];for(const[S,s]of this.a)if(!(s.configScheme&&s.configScheme!==u.scheme))try{const a=(await this.b.readFile((0,N.$vg)(u,S))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&b.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return b}};e.$p5b=d,e.$p5b=d=ye([Y(0,D.$$j),Y(1,R.$pj)],d);const p="extensionTips/promptedExecutableTips",y="extensionTips/lastPromptedMediumImpExeTime";class l extends d{constructor(u,b,S,s,a,n,i,t){super(i,t),this.r=u,this.s=b,this.t=S,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],w=[],f=[];Object.entries(o.recommendations).forEach(([$,j])=>{j.important?o.important?v.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):w.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):f.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:w}),f.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:f})}),(0,k.$Vg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),b=await this.O(this.h);return[...u,...b]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),b=await this.O(this.h),S=await this.u.getInstalled();this.m=this.D(u,S),this.n=this.D(b,S)}D(u,b){const S=new Map;u.forEach(t=>S.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...S.keys()],b);for(const t of s){const r=S.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=S.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=S.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[u,b]=[...this.m.entries()][0];this.H(b).then(S=>{switch(S){case"reacted":this.M(b[0].exeName,b);break;case"ignored":this.m.delete(u);break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new L.$Tc);s.value=(0,k.$Vg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),b=Date.now()-u,S=7*24*60*60*1e3;if(b<S){const n=this.B(new L.$Tc);n.value=(0,k.$Vg)(()=>{n.dispose(),this.G()},S-b);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new L.$Tc);i.value=(0,k.$Vg)(()=>{i.dispose(),this.G()},S);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new L.$Tc);i.value=(0,k.$Vg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const b=await this.u.getInstalled(1),S=u.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>b.every(n=>!(0,c.$zo)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:S,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(y,-1);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(y,u,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(u,b){const S=this.L();S[u]=b.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(S),-1,0)}N(u,b){const S=[],s=[],a=b.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return u.forEach(n=>{a.has(n.toLowerCase())?S.push(n):s.push(n)}),{installed:S,uninstalled:s}}async O(u){const b=[],S=new Map;for(const s of u.keys()){const a=u.get(s);if(!a||!(0,I.$Lb)(a.recommendations))continue;const n=[];E.$j?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",s)),n.push((0,C.$jc)("/usr/bin",s)),n.push((0,C.$jc)(this.r.fsPath,s)));for(const i of n){let t=S.get(i);if(t===void 0&&(t=await this.b.exists(A.URI.file(i)),S.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:w}of a.recommendations)b.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:w})}}return b}}e.$q5b=l}),define(oe[222],ae([0,1,26,33]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YVb=void 0;async function N(A,D,R,k,g){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const E=await A.getInstalled(1);for(const[m,c]of Object.entries(C.deprecated)){if(!c?.extension)continue;const{id:d,autoMigrate:p,preRelease:y}=c.extension;if(!p)continue;const l=E.find(u=>(0,L.$zo)(u.identifier,{id:m}));if(!l)continue;const h=(await D.getExtensions([{id:d,preRelease:y}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!h){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${d}' extension...`);const u=!k.getDisabledExtensions().some(S=>(0,L.$zo)(S,l.identifier));await A.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let b=E.find(S=>(0,L.$zo)(S.identifier,{id:d}));(!b||!b.isPreReleaseVersion&&u)&&(b=await A.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${b.identifier.id}'`),u||(await k.disableExtension(b.identifier),g.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,L.$Co)(l.manifest.publisher,l.manifest.name),(0,L.$Co)(b.manifest.publisher,b.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${d}' extension.`)}catch(u){g.error(u)}}}catch(C){g.error(C)}}e.$YVb=N}),define(oe[223],ae([0,1,3,2,34,33,44]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;class R extends L.$Sc{constructor(g,C,E,m,c,d,p){super(),this.f=g,this.g=C,this.h=E,this.j=m,this.m=c,this.n=d,this.r=p,this.a=this.B(new I.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$1c),this.s().then(null,y=>p.error(y))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,L.$Pc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const E=this.L(C.identifier,C.version);g.error?this.J(E,g.profileLocation):this.I(E,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],E=[];for(const m of g.extensions){const c=this.L(m.identifier,m.version);g.error?this.I(c,g.profileLocation):(this.J(c,g.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),E.push(this.f.scanInstalledExtensionAtLocation(m.location).then(d=>{d?C.push(d):this.r.info("Extension not found at the location",m.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(E),C.length&&await this.H(C)}catch(m){this.r.error(m)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],E=[],m=await this.j.scanProfileExtensions(g),c=new Set,d=new Set;for(const[p,y]of this.b)y.has(g)&&d.add(p);for(const p of m){const y=this.L(p.identifier,p.version);c.add(y),d.has(y)||(C.push(p.identifier),this.I(y,g))}for(const p of d)if(!c.has(p)){const y=this.M(p);y&&(E.push(y.identifier),this.J(p,g))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:E.length?{extensions:E,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const E of C)this.I(this.L(E.identifier,E.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let E=this.b.get(g);E||this.b.set(g,E=new N.$Bc(m=>this.m.extUri.getComparisonKey(m))),E.add(C)}J(g,C){const E=this.b.get(g);E&&E.delete(C),E?.size||this.b.delete(g)}L(g,C){return`${D.$6l.toKey(g.id)}@${C}`}M(g){const[C,E]=(0,A.$Bo)(g);return E?{identifier:{id:C},version:E}:void 0}}e.$Hp=R}),define(oe[224],ae([0,1,43,45]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function N(A,D,R,k,g,C,E){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${D.nameShort})`};if((0,L.$ro)(D,R)&&(0,L.$to)(k)===3){const c=await(0,I.$_o)(R,g,C);m["X-Market-User-Id"]=c,m["VSCode-SessionId"]=E.machineId||c}return m}e.$ap=N}),define(oe[225],ae([0,1,70,18,6,2,23,16,31,14,29,33,7,73,10]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;let p=class extends c.$Tq{constructor(u,b,S,s){super(S),this.h=u,this.j=s,this.g=this.B(new y(b,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(u,b){const s=(await this.g.getLanguagePacks())[b];if(!s){this.j.warn(`No language pack found for ${b}`);return}const a=s.translations[u];return a?d.URI.file(a):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),b=Object.keys(u).map(S=>{const s=u[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((S,s)=>S.label.localeCompare(s.label)),b}async m(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",u.identifier.id),await this.update())}async n(u){const b=await this.g.getLanguagePacks();Object.keys(b).some(S=>b[S]&&b[S].extensions.some(s=>(0,E.$zo)(s.extensionIdentifier,u.identifier)))&&(this.j.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(b);return!(0,L.$ub)(Object.keys(u),Object.keys(S))}};e.$Uq=p,e.$Uq=p=ye([Y(0,C.$_n),Y(1,g.$Xh),Y(2,C.$0n),Y(3,m.$0i)],p);let y=class extends A.$Sc{constructor(u,b){super(),this.j=b,this.c={},this.f=(0,R.$jc)(u.userDataPath,"languagepacks.json"),this.g=new N.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.s(b=>{Object.keys(b).forEach(S=>delete b[S]),this.m(b,...u)}).then(()=>this.c)}m(u,...b){for(const S of b)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(u,S);Object.keys(u).forEach(S=>this.r(u[S]))}n(u,b){const S=b.identifier,s=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of s)if(b.location.scheme===D.Schemas.file&&l(a)){let n=u[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},u[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$zo)(t.extensionIdentifier,S))[0];i?i.version=b.manifest.version:n.extensions.push({extensionIdentifier:S,version:b.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,R.$jc)(b.location.fsPath,t.path)}}r(u){if(u){const b=(0,I.createHash)("md5");for(const S of u.extensions)b.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);u.hash=b.digest("hex")}}s(u=()=>null){return this.g.queue(()=>{let b=null;return k.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(b=u(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),k.Promises.writeFile(this.f,s)}).then(()=>b,S=>this.j.error(S))})}};y=ye([Y(0,g.$Xh),Y(1,m.$0i)],y);function l(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const u of h.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,142,8,30,45]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,E,m){const c=await(0,I.$mC)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,I.$mC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new c.AppInsightsCore,y=new d.PostChannel,l={instrumentationKey:C,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(m){l.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:m};l.extensionConfig[y.identifier]=h}return p.initialize(l,[]),p.addTelemetryInitializer(h=>{E&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),p}class g{constructor(E,m,c,d,p){this.e=E,this.f=m,this.g=c,this.h=p,this.c=D,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(m=>{E(m)},m=>{(0,L.$1)(m),console.error(m)})}}log(E,m){if(!this.a)return;m=(0,N.$0m)(m,this.g),m=(0,A.$uo)(m);const c=this.f+"/"+E;try{this.i(d=>{d.pluginVersionString=m?.properties.version??"Unknown",d.track({name:c,baseData:{name:c,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$rN=g}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q4b=void 0;let k=class extends I.$Sc{constructor(C,E,m,c,d=""){super(),this.b=d;const p=E.getLogger(R.$no);if(p)this.a=this.B(p);else{const l=(0,R.$so)(c,m)?" (Not Sent)":"",h=()=>(0,R.$ro)(c,m)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(E.createLogger(R.$no,{name:(0,L.localize)(0,null,l),hidden:!h()})),this.B(C.onDidChangeLogLevel(()=>E.setVisibility(R.$no,h()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,E){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$uo)(E))}};e.$Q4b=k,e.$Q4b=k=ye([Y(0,A.$0i),Y(1,A.$$i),Y(2,N.$Wh),Y(3,D.$pj)],k)}),define(oe[110],ae([0,1,2,30,5,27,168,20,50,102,24,40,22,45]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,h,u){this.k=h,this.l=u,this.d={},this.i=new I.$Rc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,A.$Fe)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Fe)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(m.$kl)||b.affectsConfiguration(m.$ml)||b.affectsConfiguration(m.$ll))&&this.m()}))}setExperimentProperty(l,h){this.d[l]=h}m(){let l=(0,c.$to)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const u=h.usage?3:h.error?2:0;l=Math.min(l,u)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,h,u){this.g<h||(u=(0,L.$0m)(u,this.d),u=(0,c.$yo)(u,this.j),u=(0,L.$0m)(u,this.c),this.b.forEach(b=>b.log(l,u)))}publicLog(l,h){this.n(l,3,h)}publicLog2(l,h){this.publicLog(l,h)}publicLogError(l,h){this.h&&this.n(l,2,h)}publicLogError2(l,h){this.publicLogError(l,h)}};e.$1q=d,e.$1q=d=ye([Y(1,R.$ji),Y(2,C.$pj)],d);function p(){const y=(0,D.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=N.$p?"":(0,D.localize)(3,null),u=(0,D.localize)(4,null),b=(0,D.localize)(5,null),S=(0,D.localize)(6,null),s=(0,D.localize)(7,null),a=`
|       | ${u} | ${b} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${y} ${l} ${h}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$gn.as(k.$ln.Configuration).registerConfiguration({id:m.$jl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[m.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$gn.as(k.$ln.Configuration).registerConfiguration({id:m.$jl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[m.$ml]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,D.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,D.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${m.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;async function D(C,E){const m=await E.request(C,L.CancellationToken.None),c=(await(0,I.$ne)(m.stream)).toString(),d=m.res.statusCode??200;return{headers:m.res.headers,statusCode:d,responseData:c}}async function R(C){const E={method:C.type,headers:C.headers};return new Promise((c,d)=>{const p=N.request(C.url??"",E,y=>{y.on("data",function(l){c({headers:y.headers,statusCode:y.statusCode??200,responseData:l.toString()})}),y.on("error",function(l){d(l)})});p.write(C.data,y=>{y&&d(y)}),p.end()})}async function k(C,E,m){const c=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),d={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:c};try{const p=C?await D(d,C):await R(d);m(p.statusCode,p.headers,p.responseData)}catch{m(0,{})}}class g extends A.$rN{constructor(E,m,c,d,p){const y={sendPOST:(l,h)=>{k(E,l,h)}};super(m,c,d,p,y)}}e.$sN=g}),define(oe[228],ae([0,1,23,93,20,14,7,24,22,108,109,110]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;let m=class{constructor(d,p,y,l,h,u){this.b=d,this.c=p,this.d=y,this.e=l,this.f=h,this.g=u,this.a=new Map}h(d){if(!this.a.has(d.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const y=[d.id,JSON.stringify(p),d.aiKey],h=new L.$3p(I.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new g.$v7b(h),new C.$Q4b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new E.$1q({appenders:u,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,p,y){this.h(d).publicLog(p,y)}publicLogError(d,p,y){this.h(d).publicLogError(p,y)}};e.$N8b=m,e.$N8b=m=ye([Y(0,N.$ji),Y(1,k.$cl),Y(2,D.$0i),Y(3,D.$$i),Y(4,A.$Wh),Y(5,R.$pj)],m)}),define(oe[77],ae([0,1,3,20,4,7]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,N.$Ph)("tunnelService"),e.$$u=(0,N.$Ph)("sharedTunnelsService");var D;(function(y){y.Http="http",y.Https="https"})(D||(e.TunnelProtocol=D={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(y){return!!y.forwardPort}e.$_u=k;var g;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(l)return{address:l[1],port:+l[2]}}e.$av=C,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(y){return e.$bv.indexOf(y)>=0}e.$cv=E,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(y){return e.$dv.indexOf(y)>=0}e.$ev=m;function c(y,l,h,u){if(h===1)return!1;if(h===2&&m(l)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(b?.length===4&&parseInt(b[1])>=18)return!1}return y<1024}e.$fv=c;class d{constructor(l,h,u){this.remoteAddress=l,this.localAddress=h,this.b=u,this.a=new I.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=d;let p=class{constructor(l,h){this.j=l,this.k=h,this.a=new I.$Nd,this.onTunnelOpened=this.a.event,this.b=new I.$Nd,this.onTunnelClosed=this.b.event,this.c=new I.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const l=this.k.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.h=l.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const l=[],h=Array.from(this.e.values());for(const u of h){const b=Array.from(u.values());for(const S of b){const s=await S.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:h}of l.values())await h.then(u=>typeof u!="string"?u?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,h,u,b,S){this.p(l,h,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:h,localAddress:u,privacy:b,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,h){(m(l)||E(l))&&(l=e.$bv[0]);const u=this.r(l,h);if(u)return++u.refcount,u.value}openTunnel(l,h,u,b,S,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${S}.`);const i=this.f??l;if(!i)return;if(h||(h="localhost"),b||(b=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,h,u,b,S,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,u),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==h||r.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const h=this.e.get(l.tunnelRemoteHost);if(h){const u=h.get(l.tunnelRemotePort);u&&(u.refcount--,await this.o(l.tunnelRemoteHost,l.tunnelRemotePort,u))}}}}async o(l,h,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${h}.`);const b=u.value.then(async S=>{S&&typeof S!="string"&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(h),b}}async closeTunnel(l,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${h} `);const u=this.e.get(l);if(u&&u.has(h)){const b=u.get(h);b.refcount=0,await this.o(l,h,b)}}p(l,h,u){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(h,{refcount:1,value:u})}async q(l,h){const u=this.e.get(l);if(u){const b=u.get(h),S=b?await b.value:void 0;(!S||typeof S=="string")&&u.delete(h),u.size===0&&this.e.delete(l)}}r(l,h){const u=[l];E(l)?(u.push(...e.$bv),u.push(...e.$dv)):m(l)&&u.push(...e.$dv);const b=u.map(S=>this.e.get(S));for(const S of b){const s=S?.get(h);if(s)return s}}canTunnel(l){return!!C(l)}t(l,h,u,b,S,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${b}.`);const n=u;this.i.add(n);const i=b===void 0?u:b,t={elevationRequired:S?this.isPortPrivileged(i):!1},r={remoteAddress:{host:h,port:u},localAddressPort:b,privacy:s,public:s?s!==R.Private:void 0,protocol:a},o=l.forwardPort(r,t);return o?(this.p(h,u,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$hv=p,e.$hv=p=ye([Y(0,A.$0i),Y(1,L.$ji)],p)}),define(oe[229],ae([0,1,7,77,2,8,6]),function(te,e,I,L,N,A,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=void 0;class k extends N.$Sc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$ch),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let g=class extends N.$Sc{static{R=this}static{this.a=0}constructor(E,m){super(),this.f=E,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(E,m,c,d,p,y,l){const h=new k,u=await Promise.resolve(this.f.openTunnel(E,h,c,d,p,y,l));if(!u||typeof u=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${d} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),h.dispose(),await u.dispose(),(0,A.$6)();return h.setTunnel(u),this.b.set(m,h),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${u.localAddress} (local) to ${c}:${d} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(E,m){const c=this.b.get(E);c&&c.setAddress(m)}async destroyTunnel(E){const m=this.b.get(E);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await m.dispose();return}this.c.add(E)}};e.$18b=g,e.$18b=g=R=ye([Y(0,L.$$u),Y(1,I.$0i)],g)}),define(oe[28],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,I.$Ph)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,19,128,3,2]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class g{static{this._clock=0}constructor(m){this.uri=m,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(m){this.g=m,this.c=new k.$Rc,this.f=2**16;const c=new Map,d=p=>{let y=c.get(p.scheme);return y===void 0&&(y=m.hasProvider(p)&&!this.g.hasCapability(p,1024),c.set(p.scheme,y)),y};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(p=>{c.delete(p.scheme)})),this.extUri=new A.$kg(d),this.d=new D.$yr((p,y)=>this.extUri.compare(p,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$wg)(m));const c=this.d.get(m);return c?c.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new g(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((d,p)=>d[1].time<p[1].time?1:d[1].time>p[1].time?-1:0);g._clock=0,this.d.clear();const c=this.f*.5;for(let d=0;d<c;d++)this.d.set(m[d][0],m[d][1].touch())}};e.$zr=C,e.$zr=C=ye([Y(0,N.$$j)],C),(0,L.$wr)(I.$Ik,C,1)}),define(oe[231],ae([0,1,3,2,11,47,34]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=void 0;class R extends L.$Sc{constructor(g,C,E,m,c,d){super(),this.f=g,this.g=C,this.h=E,this.j=m,this.m=c,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$Nd),this.onDidChangeFile=this.a.event,this.b=A.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,E,m,c){return this.g.read(g,C,E,m,c)}write(g,C,E,m,c){return this.g.write(g,C,E,m,c)}watch(g,C){this.b.set(g,g);const E=this.g.watch(this.t(g),C);return(0,L.$Qc)(()=>{this.b.delete(g),E.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,E){return this.g.rename(this.t(g),this.t(C),E)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,E){return this.g.readFileStream(this.t(g),C,E)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,E){return this.g.writeFile(this.t(g),C,E)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,E){if((0,N.$ck)(this.g))return this.g.copy(this.t(g),this.t(C),E);throw new Error("copy not supported")}cloneFile(g,C){if((0,N.$dk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const E of g){if(E.resource.scheme!==this.f)continue;const m=this.u(E.resource);this.b.findSubstr(m)&&C.push({resource:m,type:E.type,cId:E.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$i8b=R}),define(oe[78],ae([0,1,86]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PCb=e.$OCb=e.edit=void 0;function L(D,R,k,g){const C=(0,I.$4S)(D,R,k,g)[0];return C&&(D=D.substring(0,C.offset)+C.content+D.substring(C.offset+C.length)),D}e.edit=L;function N(D,R,k){let g=k;for(;g>=0;){if(D.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&D.charAt(g)===R.charAt(0))return g+2}return 0}e.$OCb=N;function A(D,R,k){let g=k;for(;g>=0;)if(D.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&D.charAt(g)===R.charAt(1)))return g;return D.length-1}e.$PCb=A}),define(oe[232],ae([0,1,30,54,12]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y3b=void 0;function A(c,d,p,y,l,h){const u=[],b=[],S=[];if(!d){const q=c.filter(({identifier:Z})=>l.every(K=>K.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:u,removed:b,updated:S},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}c=c.map(E),d=d.map(E),p=p?p.map(E):null;const s=new Map,a=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};c.forEach(({identifier:q})=>a(q)),d.forEach(({identifier:q})=>a(q)),p?.forEach(({identifier:q})=>a(q)),y?.forEach(({identifier:q})=>a(q)),h?.forEach(q=>a(q));const n=q=>{const Z=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Z)=>(q.set(n(Z),Z),q),t=c.reduce(i,new Map),r=d.reduce(i,new Map),o=d.reduce((q,Z)=>i(q,(0,I.$7m)(Z)),new Map),v=p?p.reduce(i,new Map):null,w=y.reduce(i,new Map),f=l.reduce((q,Z)=>{const K=s.get(Z.toLowerCase());return q.add(K?`uuid:${K}`:`id:${Z.toLowerCase()}`)},new Set),$=h?h.reduce((q,{id:Z,uuid:K})=>(K=K??s.get(Z.toLowerCase()),q.add(K?`uuid:${K}`:`id:${Z.toLowerCase()}`)),new Set):null,j=D(t,r,f,!1);if(j.added.size>0||j.removed.size>0||j.updated.size>0){const q=D(v,t,f,!1),Z=D(v,r,f,!0),K=(x,H,Q,G)=>{let W,ee,ne;return H.installed?(W=G.pinned,ne=G.preRelease,W&&(ee=G.version)):(W=Q.pinned,ne=Q.preRelease,W&&(ee=Q.version)),W===void 0&&(W=H.pinned,W&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...G,installed:H.installed||Q.installed,pinned:W,preRelease:ne,version:ee??(Q.version&&(!H.installed||L.gt(Q.version,H.version))?Q.version:H.version),state:k(H,Q,v?.get(x))}};for(const x of Z.removed.values()){const H=t.get(x);if(!H)continue;const Q=(0,N.$Jf)(v?.get(x)),G=$&&!$.has(x)&&Q.installed;H.installed&&G?b.push(H.identifier):o.set(x,H)}for(const x of Z.added.values()){const H=(0,N.$Jf)(r.get(x)),Q=t.get(x);if(Q){if(j.updated.has(x)){const G=K(x,Q,H,H);R(Q,H,!1,!1)||S.push(m(G,x)),o.set(x,G)}}else H.installed&&u.push(m(H,x))}for(const x of Z.updated.values()){const H=(0,N.$Jf)(r.get(x)),Q=(0,N.$Jf)(v?.get(x)),G=t.get(x);if(G)if($&&!$.has(x)&&Q.installed&&G.installed&&!H.installed)b.push(G.identifier);else{const ee=K(x,G,H,H);S.push(m(ee,x)),o.set(x,ee)}else H.installed&&u.push(m(H,x))}for(const x of q.added.values())Z.added.has(x)||o.set(x,(0,N.$Jf)(t.get(x)));for(const x of q.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const H=(0,N.$Jf)(t.get(x)),Q=(0,N.$Jf)(r.get(x));o.set(x,K(x,H,Q,H))}for(const x of q.removed.values())Z.updated.has(x)||Z.removed.has(x)||w.has(x)||(0,N.$Jf)(r.get(x)).installed&&$&&($.has(x)||!(0,N.$Jf)(v?.get(x)).installed||o.delete(x))}const F=[],z=D(r,o,new Set,!0),U=z.added.size>0||z.updated.size>0||z.removed.size>0;return U&&o.forEach((q,Z)=>F.push(m(q,Z))),{local:{added:u,removed:b,updated:S},remote:U?{added:[...z.added].map(q=>o.get(q)),updated:[...z.updated].map(q=>o.get(q)),removed:[...z.removed].map(q=>r.get(q)),all:F}:null}}e.$y3b=A;function D(c,d,p,y){const l=c?[...c.keys()].filter(s=>!p.has(s)):[],h=[...d.keys()].filter(s=>!p.has(s)),u=h.filter(s=>!l.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),b=l.filter(s=>!h.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),S=new Set;for(const s of l){if(b.has(s))continue;const a=c.get(s),n=d.get(s);(!n||!R(a,n,y,!0))&&S.add(s)}return{added:u,removed:b,updated:S}}function R(c,d,p,y){return!(c.disabled!==d.disabled||!!c.isApplicationScoped!=!!d.isApplicationScoped||y&&c.installed!==d.installed||c.installed&&d.installed&&(c.preRelease!==d.preRelease||c.pinned!==d.pinned||d.pinned&&c.version!==d.version)||!C(c.state,d.state)||p&&c.version!==d.version)}function k(c,d,p){const y=c.state,l=d.state,h=p?.state;if(!d.version||y&&L.gt(c.version,d.version))return y;if(l&&L.gt(d.version,c.version)||!y)return l;if(!l)return y;const u=(0,I.$7m)(y),b=h?g(h,l):{added:Object.keys(l).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},S=h?g(h,y):{added:Object.keys(y).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...b.added.values(),...b.updated.values()])u[s]=l[s];for(const s of b.removed.values())S.updated.has(s)||delete u[s];return u}function g(c,d){const p=Object.keys(c),y=Object.keys(d),l=y.filter(b=>!p.includes(b)).reduce((b,S)=>(b.add(S),b),new Set),h=p.filter(b=>!y.includes(b)).reduce((b,S)=>(b.add(S),b),new Set),u=new Set;for(const b of p){if(h.has(b))continue;const S=c[b],s=d[b];(0,I.$$m)(S,s)||u.add(b)}return{added:l,removed:h,updated:u}}function C(c={},d={}){const{added:p,removed:y,updated:l}=g(c,d);return p.size===0&&y.size===0&&l.size===0}function E(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function m(c,d){const p={...c,identifier:{id:c.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete p.disabled,c.installed||delete p.installed,c.state||delete p.state,c.isApplicationScoped||delete p.isApplicationScoped,p}}),define(oe[111],ae([0,1,18,20,4]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MEb=e.$LEb=void 0,e.$LEb=(0,N.$Ph)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),g=this.b().map(m=>m.toLowerCase()),C=[],E=[];if(Array.isArray(g))for(const m of g)m.startsWith("-")?E.push(m.substring(1)):C.push(m);return(0,I.$Mb)([...k,...C].filter(m=>!E.includes(m)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$MEb=A,e.$MEb=A=ye([Y(0,L.$ji)],A)}),define(oe[233],ae([0,1,18,35,30,94,78]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3b=void 0;function R(b){return(0,L.$Wm)(b)||[]}async function k(b,S,s,a,n){const i=R(b),t=R(S),r=s?R(s):null,o=[...i,...t,...r||[]].map(K=>K.key),v=await n.resolveUserBindings(o),w=C(i,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const f=m(i),$=m(t),j=r?m(r):null,F=d(f,$,v),z=j?d(j,f,v):{added:[...f.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},U=j?d(j,$,v):{added:[...$.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},q=g(F,z,U);let Z=b;for(const K of q.removed.values())q.conflicts.has(K)||(Z=h(Z,K,a));for(const K of q.added.values()){if(q.conflicts.has(K))continue;const x=$.get(K);if(x.some(H=>H.command!==`-${K}`&&w.conflicts.has(v[H.key]))){q.conflicts.add(K);continue}Z=l(Z,x,a)}for(const K of q.updated.values()){if(q.conflicts.has(K))continue;const x=$.get(K);if(x.some(H=>H.command!==`-${K}`&&w.conflicts.has(v[H.key]))){q.conflicts.add(K);continue}Z=u(Z,K,x,a)}return{mergeContent:Z,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$E3b=k;function g(b,S,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of S.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(S.updated.has(r)?t.add(r):n.add(r));for(const r of S.added.values())t.has(r)||s.added.has(r)&&b.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(S.added.has(r)?b.updated.has(r)&&t.add(r):a.add(r));for(const r of S.updated.values())t.has(r)||s.updated.has(r)&&b.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(S.updated.has(r)?b.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function C(b,S,s,a){const n=new Set,i=E(b,a),t=E(S,a),r=s?E(s,a):null,o=c(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?c(r,i):{added:[...i.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,t):{added:[...t.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:$,updated:j,conflicts:F}=g(o,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:$,updated:j,conflicts:F}}function E(b,S){const s=new Map;for(const a of b){const n=S[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function m(b){const S=new Map;for(const s of b){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=S.get(a);n||(n=[],S.set(a,n)),n.push(s)}return S}function c(b,S){const s=[...b.keys()],a=[...S.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=b.get(r).map(w=>({...w,key:r})),v=S.get(r).map(w=>({...w,key:r}));(0,I.$ub)(o,v,(w,f)=>y(w,f))||t.add(r)}return{added:n,removed:i,updated:t}}function d(b,S,s){const a=[...b.keys()],n=[...S.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=b.get(o).map(f=>({...f,key:s[f.key]})),w=S.get(o).map(f=>({...f,key:s[f.key]}));p(v,w)||r.add(o)}return{added:i,removed:t,updated:r}}function p(b,S){return!(!(0,I.$ub)(b.filter(({command:s})=>s[0]!=="-"),S.filter(({command:s})=>s[0]!=="-"),(s,a)=>y(s,a))||!(0,I.$ub)(b.filter(({command:s})=>s[0]==="-"),S.filter(({command:s})=>s[0]==="-"),(s,a)=>y(s,a)))}function y(b,S){if(b.command!==S.command||b.key!==S.key)return!1;const s=A.$Ni.deserialize(b.when),a=A.$Ni.deserialize(S.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!N.$$m(b.args,S.args))}function l(b,S,s){for(const a of S)b=D.edit(b,[-1],a,s);return b}function h(b,S,s){const a=R(b);for(let n=a.length-1;n>=0;n--)(a[n].command===S||a[n].command===`-${S}`)&&(b=D.edit(b,[n],void 0,s));return b}function u(b,S,s,a){const n=R(b),i=n.findIndex(t=>t.command===S||t.command===`-${S}`);for(let t=n.length-1;t>=0;t--)(n[t].command===S||n[t].command===`-${S}`)&&(b=D.edit(b,[t],void 0,a));for(let t=s.length-1;t>=0;t--)b=D.edit(b,[i],s[t],a);return b}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M3b=e.$L3b=void 0;function I(A,D,R){const k={},g={},C=new Set;if(!D)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=L(A,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(R,A),c=L(R,D),d={},p={},y=new Set,l=new Set;for(const h of m.removed.values())c.updated.has(h)?k[h]=D[h]:y.add(h);for(const h of c.removed.values())l.has(h)||(m.updated.has(h)?l.add(h):C.add(h));for(const h of m.updated.values())l.has(h)||(c.updated.has(h)?E.updated.has(h)&&l.add(h):p[h]=A[h]);for(const h of c.updated.values())l.has(h)||(m.updated.has(h)?E.updated.has(h)&&l.add(h):A[h]!==void 0&&(g[h]=D[h]));for(const h of m.added.values())l.has(h)||(c.added.has(h)?E.updated.has(h)&&l.add(h):d[h]=A[h]);for(const h of c.added.values())l.has(h)||(m.added.has(h)?E.updated.has(h)&&l.add(h):k[h]=D[h]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:d,removed:[...y.values()],updated:p},conflicts:[...l.values()]}}e.$L3b=I;function L(A,D){const R=A?Object.keys(A):[],k=D?Object.keys(D):[],g=k.filter(m=>!R.includes(m)).reduce((m,c)=>(m.add(c),m),new Set),C=R.filter(m=>!k.includes(m)).reduce((m,c)=>(m.add(c),m),new Set),E=new Set;for(const m of R){if(C.has(m))continue;const c=A[m],d=D[m];c!==d&&E.add(m)}return{added:g,removed:C,updated:E}}function N(A,D){const{added:R,removed:k,updated:g}=L(A,D);return R.size===0&&k.size===0&&g.size===0}e.$M3b=N}),define(oe[235],ae([0,1,30]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5b=void 0;function L(A,D,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!D){const m=A.filter(({id:c})=>!k.includes(c));return m.length?C.added=m:C=null,{local:g,remote:C}}const E=N(A,D,k);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const m=N(R,A,k),c=N(R,D,k);for(const d of c.removed){const p=A.find(y=>y.id===d);p&&g.removed.push(p)}for(const d of c.added){const p=D.find(y=>y.id===d);m.added.includes(d)?E.updated.includes(d)&&g.updated.push(p):g.added.push(p)}for(const d of c.updated)g.updated.push(D.find(p=>p.id===d));for(const d of m.added)c.added.includes(d)||C.added.push(A.find(p=>p.id===d));for(const d of m.updated)c.removed.includes(d)||c.updated.includes(d)||C.updated.push(A.find(p=>p.id===d));for(const d of m.removed){const p=D.find(y=>y.id===d);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$t5b=L;function N(A,D,R){A=A?A.filter(({id:c})=>!R.includes(c)):[],D=D.filter(({id:c})=>!R.includes(c));const k=A.map(({id:c})=>c),g=D.map(({id:c})=>c),C=g.filter(c=>!k.includes(c)),E=k.filter(c=>!g.includes(c)),m=[];for(const{id:c,name:d,shortName:p,icon:y,useDefaultFlags:l}of A){if(E.includes(c))continue;const h=D.find(u=>u.id===c);(!h||h.name!==d||h.shortName!==p||h.icon!==y||!(0,I.$$m)(h.useDefaultFlags,l))&&m.push(c)}return{added:C,removed:E,updated:m}}}),define(oe[25],ae([0,1,18,12,174,50,29,4,103,40]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgb=e.$Wgb=e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.MergeState=e.Change=e.SyncStatus=e.$Mgb=e.$Lgb=e.$Kgb=e.UserDataSyncErrorCode=e.$Jgb=e.$Igb=e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.$Cgb=e.$Bgb=e.SyncResource=e.$Agb=e.$zgb=e.$ygb=e.$xgb=e.$wgb=e.$vgb=void 0;function C(){const t=g.$gn.as(A.$ln.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$vgb=C;function E(){const t=g.$gn.as(A.$ln.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),o=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,I.$Mb)([...r,...o,...v])}e.$wgb=E,e.$xgb="settingsSync",e.$ygb="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=g.$gn.as(A.$ln.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$ygb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:D.$Xn,errorMessage:(0,N.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=g.$gn.as(k.$hn.JSONContribution),v=()=>{const w=C(),f=E(),$=Object.keys(A.$mn.properties).filter(z=>!f.includes(z)),j=f.filter(z=>!w.includes(z)),F={items:{type:"string",enum:[...$,...j.map(z=>`-${z}`)]}};o.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$zgb=m;function c(t){return t&&(0,L.$Af)(t)&&(0,L.$yf)(t.id)&&Array.isArray(t.scopes)}e.$Agb=c;var d;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$Bgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$Cgb=p;function y(t,r,o,v){return v.joinPath(o.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$Dgb=y,e.$Egb=(0,R.$Ph)("IUserDataSyncStoreManagementService"),e.$Fgb=(0,R.$Ph)("IUserDataSyncStoreService"),e.$Ggb=(0,R.$Ph)("IUserDataSyncLocalStoreService"),e.$Hgb="x-operation-id",e.$Igb="X-Execution-Id";function l(t){const r={};return r[e.$Igb]=t,r}e.$Jgb=l;var h;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(h||(e.UserDataSyncErrorCode=h={}));class u extends Error{constructor(r,o,v,w){super(r),this.code=o,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Kgb=u;class b extends u{constructor(r,o,v,w,f){super(r,v,void 0,f),this.url=o,this.serverCode=w}}e.$Lgb=b;class S extends u{constructor(r,o){super(r,o)}}e.$Mgb=S,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],w,f)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(u||(e.$Kgb=u={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Ngb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$Ogb=i,e.$Pgb=(0,R.$Ph)("IUserDataSyncEnablementService"),e.$Qgb=(0,R.$Ph)("IUserDataSyncService"),e.$Rgb=(0,R.$Ph)("IUserDataSyncResourceProviderService"),e.$Sgb=(0,R.$Ph)("IUserDataAutoSyncService"),e.$Tgb=(0,R.$Ph)("IUserDataSyncUtilService"),e.$Ugb=(0,R.$Ph)("IUserDataSyncLogService"),e.$Vgb="userDataSync",e.$Wgb="vscode-userdata-sync",e.$Xgb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Db=void 0;function N(D,R,k,g,C){if(!R)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const E=A(D,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=k?A(k,R):{added:Object.keys(R).reduce((h,u)=>(h.add(u),h),new Set),removed:new Set,updated:new Set},c=k?A(k,D):{added:Object.keys(D).reduce((h,u)=>(h.add(u),h),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},p=I.$7m(R),y=!k;for(const h of c.added.values())h!==L.$Ngb&&y&&m.added.has(h)||(p[h]=D[h]);for(const h of c.updated.values())p[h]=D[h];for(const h of c.removed.values())g.unregistered.includes(h)||delete p[h];for(const h of m.added.values()){const u=R[h];if(g.machine.includes(h)){C.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(k&&c.added.has(h))continue;const b=D[h];b&&b.value===u.value||h===L.$Ngb&&y&&c.added.has(h)||(b?d.updated[h]=u:d.added[h]=u)}for(const h of m.updated.values()){const u=R[h];if(g.machine.includes(h)){C.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(h)||c.removed.has(h))continue;const b=D[h];b&&b.value===u.value||(d.updated[h]=u)}for(const h of m.removed.values()){if(g.machine.includes(h)){C.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}c.updated.has(h)||c.removed.has(h)||d.removed.push(h)}const l=A(R,p);return{local:d,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}e.$8Db=N;function A(D,R){const k=Object.keys(D),g=Object.keys(R),C=g.filter(c=>!k.includes(c)).reduce((c,d)=>(c.add(d),c),new Set),E=k.filter(c=>!g.includes(c)).reduce((c,d)=>(c.add(d),c),new Set),m=new Set;for(const c of k){if(E.has(c))continue;const d=D[c],p=R[c];I.$$m(d,p)||m.add(c)}return{added:C,removed:E,updated:m}}}),define(oe[237],ae([0,1,18,35,86,41,30,78,25]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VCb=e.$UCb=e.$TCb=e.$SCb=e.$RCb=e.$QCb=void 0;function g(o,v,w){let f=[];w?f=E(w):f=C(v);const $=[],j=[...(0,k.$vgb)()];if(Array.isArray(f))for(const F of f)F.startsWith("-")?j.push(F.substring(1)):$.push(F);return(0,I.$Mb)([...o,...$].filter(F=>!j.includes(F)))}e.$QCb=g;function C(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,L.$Wm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function m(o,v){const w=(0,L.$Wm)(o)||{};let f="{}";for(const $ of Object.keys(w)){const j=(0,N.$4S)(f,[$],w[$],v);f=(0,N.$7S)(f,j)}return f}e.$RCb=m;function c(o,v,w,f){if(w.length){const $=r(v),j=(0,L.$Wm)(v)||{},F=(0,L.$Wm)(o);if(!F)return o;const z=[];for(const U of w){const q=j[U],Z=F[U];q===void 0?o=R.edit(o,[U],void 0,f):Z!==void 0?o=R.edit(o,[U],q,f):z.push(s(U,$))}z.sort((U,q)=>U.startOffset-q.startOffset),z.forEach(U=>o=h(U.setting.key,v,o,f))}return o}e.$SCb=c;function d(o,v,w,f,$,j){const F=c(o,v,f,j),z=w!==F,U=w!==v;if(!z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(U&&!z)return{conflictsSettings:[],localContent:c(v,o,f,j),remoteContent:null,hasConflicts:!1};if(w===null&&y(o)){const O=p(o,v,f)?null:c(v,o,f,j);return{conflictsSettings:[],localContent:O,remoteContent:null,hasConflicts:!1}}let q=o,Z=v;const K=(0,L.$Wm)(o),x=(0,L.$Wm)(v),H=w?(0,L.$Wm)(w):null,Q=f.reduce((O,T)=>(O.add(T),O),new Set),G=l(K,x,Q),W=l(H,K,Q),ee=l(H,x,Q),ne=new Map,_=new Set,ie=O=>{_.add(O);const T=$.filter(({key:M})=>M===O)[0];T?(q=R.edit(q,[O],T.value,j),Z=R.edit(Z,[O],T.value,j)):ne.set(O,{key:O,localValue:K[O],remoteValue:x[O]})};for(const O of W.removed.values())ee.updated.has(O)?ie(O):Z=R.edit(Z,[O],void 0,j);for(const O of ee.removed.values())_.has(O)||(W.updated.has(O)?ie(O):q=R.edit(q,[O],void 0,j));for(const O of W.updated.values())_.has(O)||(ee.updated.has(O)?G.updated.has(O)&&ie(O):Z=R.edit(Z,[O],K[O],j));for(const O of ee.updated.values())_.has(O)||(W.updated.has(O)?G.updated.has(O)&&ie(O):q=R.edit(q,[O],x[O],j));for(const O of W.added.values())_.has(O)||(ee.added.has(O)?G.updated.has(O)&&ie(O):Z=h(O,q,Z,j));for(const O of ee.added.values())_.has(O)||(W.added.has(O)?G.updated.has(O)&&ie(O):q=h(O,Z,q,j));const X=ne.size>0||!p(q,Z,f),B=X||!p(q,o,[]),P=X||!p(Z,v,[]);return{localContent:B?q:null,remoteContent:P?Z:null,conflictsSettings:[...ne.values()],hasConflicts:X}}e.$TCb=d;function p(o,v,w){if(o===v)return!0;const f=(0,L.$Wm)(o),$=(0,L.$Wm)(v),j=w.reduce((U,q)=>(U.add(q),U),new Set),F=r(o).filter(U=>!(U.setting&&j.has(U.setting.key))),z=r(v).filter(U=>!(U.setting&&j.has(U.setting.key)));if(F.length!==z.length)return!1;for(let U=0;U<F.length;U++){const q=F[U],Z=z[U];if(q.setting&&Z.setting){if(q.setting.key!==Z.setting.key||!D.$$m(f[q.setting.key],$[q.setting.key]))return!1}else if(!q.setting&&!Z.setting){if(q.value!==Z.value)return!1}else return!1}return!0}function y(o){return o?r(o).length===0:!0}e.$UCb=y;function l(o,v,w){const f=o?Object.keys(o).filter(U=>!w.has(U)):[],$=Object.keys(v).filter(U=>!w.has(U)),j=$.filter(U=>!f.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),F=f.filter(U=>!$.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),z=new Set;if(o)for(const U of f){if(F.has(U))continue;const q=o[U],Z=v[U];D.$$m(q,Z)||z.add(U)}return{added:j,removed:F,updated:z}}function h(o,v,w,f){const $=(0,L.$Wm)(v),j=r(v),F=r(w),z=u(o,j,F);return b(w,o,$[o],z,F,f)}e.$VCb=h;function u(o,v,w){const f=v.findIndex(j=>j.setting?.key===o),$=v[f-1];if($){if($.setting){const F=s($.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!0}}else{const F=a(f,v);if(F){const z=s(F.setting.key,w);if(z){const U=n(w.indexOf(z),w),q=i(v,F,v[f]);if(U){const Z=i(w,z,U),K=t(q,Z);return K?{index:w.indexOf(K),insertAfter:!0}:{index:w.indexOf(U),insertAfter:!1}}else{const Z=i(w,z,w[w.length-1]),K=t(q,Z);return K?{index:w.indexOf(K),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const j=v[f+1];if(j)if(j.setting){const F=s(j.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!1}}else{const F=n(f,v);if(F){const z=s(F.setting.key,w);if(z){const U=a(w.indexOf(z),w),q=i(v,v[f],F);if(U){const Z=i(w,U,z),K=t(q.reverse(),Z.reverse());return K?{index:w.indexOf(K),insertAfter:!1}:{index:w.indexOf(U),insertAfter:!0}}else{const Z=i(w,w[0],z),K=t(q.reverse(),Z.reverse());return K?{index:w.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function b(o,v,w,f,$,j){let F;return f.index===-1?F=(0,N.$4S)(o,[v],w,j):F=S(o,v,w,f,$,j).map(z=>(0,N.$5S)(o,z,j)[0]),(0,N.$7S)(o,F)}function S(o,v,w,f,$,j){const F=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,z=(0,A.$1S)(j,o),U=$[f.index];if(f.insertAfter){const q=[];if(U.setting)q.push({offset:U.endOffset,length:0,content:","+F});else{const Z=n(f.index,$),K=a(f.index,$),x=K?.setting?.commaOffset;K&&x===void 0&&q.push({offset:K.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;q.push({offset:H?x+1:U.endOffset,length:0,content:Z?z+F+",":z+F})}return q}else{if(U.setting)return[{offset:U.startOffset,length:0,content:F+","}];const q=($[f.index-1]&&!$[f.index-1].setting?z:"")+F+(n(f.index,$)?",":"")+z;return[{offset:U.startOffset,length:0,content:q}]}}function s(o,v){return v.filter(w=>w.setting?.key===o)[0]}function a(o,v){for(let w=o-1;w>=0;w--)if(v[w].setting)return v[w]}function n(o,v){for(let w=o+1;w<v.length;w++)if(v[w].setting)return v[w]}function i(o,v,w){const f=o.indexOf(v),$=o.indexOf(w);return o.filter((j,F)=>f<F&&F<$)}function t(o,v){if(o.length&&v.length){let w=0;for(;w<v.length&&w<o.length;w++)if(o[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(o){const v=[];let w=-1,f,$;const j={onObjectBegin:F=>{w++},onObjectProperty:(F,z,U)=>{w===0&&(f=z,$=F)},onObjectEnd:(F,z)=>{w--,w===0&&v.push({startOffset:f,endOffset:F+z,value:o.substring(f,F+z),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(F,z)=>{w++},onArrayEnd:(F,z)=>{w--,w===0&&v.push({startOffset:f,endOffset:F+z,value:o.substring(f,F+z),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(F,z,U)=>{w===0&&v.push({startOffset:f,endOffset:z+U,value:o.substring(f,z+U),setting:{key:$,commaOffset:void 0}})},onSeparator:(F,z,U)=>{if(w===0&&F===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Z=v[q];Z&&v.splice(q,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:z}})}},onComment:(F,z)=>{w===0&&v.push({startOffset:F,endOffset:F+z,value:o.substring(F,F+z)})}};return(0,L.$4m)(o,j),v}}),define(oe[79],ae([0,1,3,2,4,25]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BCb=e.$ACb=void 0,e.$ACb=(0,N.$Ph)("IUserDataSyncAccountService");let D=class extends L.$Sc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new I.$Nd),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$Nd),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$BCb=D,e.$BCb=D=ye([Y(0,A.$Fgb),Y(1,A.$Ugb)],D)}),define(oe[238],ae([0,1,2,10]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=e.$T8b=e.$S8b=e.$R8b=e.$Q8b=e.$P8b=e.$O8b=void 0;class N{constructor(m){this.a=m}listen(m,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call(m,c,d){switch(c){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$O8b=N;class A{constructor(m){this.a=m}listen(m,c){throw new Error(`Event not found: ${c}`)}call(m,c,d){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(L.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$P8b=A;class D{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.$Q8b=D;class R{constructor(m){this.a=m}listen(m,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call(m,c,d){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$R8b=R;class k{constructor(m){this.a=m}listen(m,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(m,c,d){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$S8b=k;class g{constructor(m){this.a=m}listen(m,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(m,c,d){switch(c){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$T8b=g;class C extends I.$Sc{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:L.URI.revive(m.url),type:m.type,defaultUrl:L.URI.revive(m.defaultUrl),insidersUrl:L.URI.revive(m.insidersUrl),stableUrl:L.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.$U8b=C}),define(oe[239],ae([0,1,19,175,14,7,25]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NEb=void 0;let R=class extends A.$cj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,I.$vg)(C.logsHome,`${D.$Vgb}.log`),{id:D.$Vgb,name:(0,L.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$NEb=R,e.$NEb=R=ye([Y(0,A.$$i),Y(1,N.$Wh)],R)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=e.$i9b=void 0,e.$i9b=(0,L.$Ph)("voiceRecognitionService");let A=class{constructor(R,k){this.a=R,this.b=k}async transcribe(R,k){const g=process.env.VSCODE_VOICE_MODULE_PATH;if(!g||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const C=Date.now();try{const E=te.__$__nodeRequire(g),m=new AbortController;k.onCancellationRequested(()=>m.abort());const c=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",signal:m.signal});return this.a.info(`[voice] transcribe(${R.length}): Text "${c}", took ${Date.now()-C}ms)`),c}catch(E){throw this.a.error(`[voice] transcribe(${R.length}): Failed width "${E}", took ${Date.now()-C}ms)`),E}}};e.$j9b=A,e.$j9b=A=ye([Y(0,I.$0i),Y(1,N.$pj)],A)}),define(oe[240],ae([0,1,2,112,7,26,6]),function(te,e,I,L,N,A,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=void 0;let k=class extends I.$Sc{static{R=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(c,d,p){super(),this.b=c,this.c=d,this.f=p,this.g()}g(){this.B(this.b(c=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${R.a})`),R.a?this.B(new C(c,this.c,this.f)):this.B(new E(c,this.c,this.f))}))}};e.$k9b=k,e.$k9b=k=R=ye([Y(1,L.$i9b),Y(2,N.$0i)],k);class g extends I.$Sc{static{this.a=30*16e3*16*1/8}constructor(c,d,p){super(),this.b=c,this.c=d,this.f=p,this.g()}g(){const c=new A.$Xd;this.B((0,I.$Qc)(()=>c.dispose(!0)));const d=y=>{y.data instanceof Float32Array&&this.h(y.data,c.token)};this.b.on("message",d),this.B((0,I.$Qc)(()=>this.b.off("message",d))),this.b.start();let p=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),p=!0,this.dispose()}),this.B((0,I.$Qc)(()=>{p||this.b.close()}))}j(c){const d=new Float32Array(c.reduce((y,l)=>y+l.length,0));let p=0;for(const y of c)d.set(y,p),p+=y.length;return d}}class C extends g{constructor(){super(...arguments),this.m=this.B(new D.$1g),this.n=[],this.r=new Float32Array(0)}async h(c,d){if(c.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,c]):c;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const p=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(p,d))}}async t(c,d){if(!d.isCancellationRequested){if(c.length>g.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(c.length!==0){const p=await this.c.transcribe(c,d);p&&this.n.push(p)}d.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends g{constructor(){super(...arguments),this.m=new D.$2g,this.n=void 0,this.r=0,this.s=""}async h(c,d){const p=this.n?this.j([this.n,c]):c;if(p.length>g.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=p,this.m.queue(()=>this.u(d))}async u(c){if(c.isCancellationRequested)return;const d=this.n?.slice(0);if(!d)return;let p;d.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),p=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),p=await this.c.transcribe(d,c)),this.s=p,this.r=d.length,!c.isCancellationRequested&&this.b.postMessage(p)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,6,3,2]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;class A extends N.$Sc{constructor({onDidOpenWindow:R,onDidFocusWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new N.$Rc),L.Event.latch(L.Event.any(R,k))(this.f,this,this.a),this.b=(0,I.$Hg)(()=>g()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$P7b=A}),define(oe[113],ae([0,1,178,16,47,19,10,4,23]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,R.$Ph)("contextService");function g(i){const t=i;return typeof t?.id=="string"&&D.URI.isUri(t.uri)}e.$Zh=g;function C(i){return typeof i?.id=="string"&&!g(i)&&!m(i)}e.$1h=C,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.$nc)(i)}:t?e.$2h:e.$3h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=E;function m(i){const t=i;return typeof t?.id=="string"&&D.URI.isUri(t.configPath)}e.$5h=m;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:D.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$6h=c;var d;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$7h=p;function y(i){const t=i;return!!(t&&typeof t=="object"&&D.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$8h=y;class l{constructor(t,r,o,v,w){this.h=t,this.j=o,this.k=v,this.l=w,this.c=N.$Vh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=N.$Vh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=l;class h{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$vg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=h;function u(i){return new h({uri:i,index:0,name:(0,A.$rg)(i)},{uri:i.toString()})}e.$$h=u,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,I.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function b(i,t){return A.$mg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$di=b;function S(i){let t;return D.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===k.Schemas.tmp}e.$ei=S,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$fi}e.$gi=s;function a(i,t){return!b(i,t)&&!S(i)}e.$hi=a;function n(i){return(typeof i=="string"?(0,L.$oc)(i):(0,A.$tg)(i))===e.$ai}e.$ii=n}),define(oe[17],ae([0,1,52,3,2,19,10,169,14,11,4,7,113,34,28,6,32,27,12]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var u;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function b(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&D.URI.isUri(t.location)&&D.URI.isUri(t.globalStorageHome)&&D.URI.isUri(t.settingsResource)&&D.URI.isUri(t.keybindingsResource)&&D.URI.isUri(t.tasksResource)&&D.URI.isUri(t.snippetsHome)&&D.URI.isUri(t.extensionsResource))}e.$Jk=b,e.$Kk=(0,C.$Ph)("IUserDataProfilesService");function S(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:t}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=S;function s(i,t,r,o,v,w){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,A.$vg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,A.$vg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,A.$vg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,A.$vg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,A.$vg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,A.$vg)(r,"extensions.json"),cacheHome:(0,A.$vg)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Mk=s;let a=class extends N.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new L.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,h.$yf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(s((0,A.$sg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const o=new c.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[f,$]of Object.entries(w.workspaces)){const j=D.URI.parse(f),F=r.find(z=>z.id===$);F&&o.set(j,F)}if(w.emptyWindows)for(const[f,$]of Object.entries(w.emptyWindows)){const j=r.find(F=>F.id===$);j&&v.set(f,j)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,l.$Fe)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const $=o.exec(f.name),j=$?parseInt($[1]):0;v=j>v?j:v}const w=`${r} ${v+1}`;return this.createProfile((0,I.$Di)((0,y.$eg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,I.$Di)((0,y.$eg)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,o){if(!(0,h.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(j=>j.name===r||j.id===t);if(w)return w;const f=s(t,r,(0,A.$vg)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(f.location);const $=[];return this.j.fire({profile:f,join(j){$.push(j)}}),await p.Promises.settled($),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$pk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$Zh)(t)?t.uri:(0,m.$5h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some($=>f.id===$.id)||(f=o.find($=>f.id===$.id)??f,f.isTransient?this.s.profiles.push(f):w.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),w=o?this.s:this.C;D.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[w,f]of Object.entries(t.workspaces)){const $=D.URI.parse(f);r[w]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}const v={};if(t.emptyWindows)for(const[w,f]of Object.entries(t.emptyWindows)){const $=D.URI.parse(f);v[w]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Nk=a,e.$Nk=a=ye([Y(0,k.$Wh),Y(1,g.$$j),Y(2,d.$Ik),Y(3,E.$0i)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Ok=n}),define(oe[242],ae([0,1,6,2,17]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=void 0;let A=class extends L.$Sc{constructor(R){super(),this.B(new I.$6g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$38b=A,e.$38b=A=ye([Y(0,N.$Kk)],A)}),define(oe[243],ae([0,1,18,6,26,8,3,2,5,12,10,152,29,33,44,7,24,22,28,17]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=void 0;let b=class extends R.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,w,f){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=w,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$Nd),this.s=this.B(new D.$Nd),this.t=this.B(new D.$Nd),this.u=this.B(new D.$Nd),this.w=this.B(new D.$Nd),this.y=[],this.B((0,R.$Qc)(()=>{this.j.forEach(({task:$})=>$.cancel()),this.m.forEach($=>$.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,m.$8n)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,c.$zo)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$$n(E.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const f=await this.O(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);o.push({...f,options:w})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,c.$Ho)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,d.$9l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,c.$zo)(f.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o);r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Eo)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o}){const v=o.isApplicationScoped||o.isBuiltin||(0,d.$9l)(t),w={...o,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},f=q=>`${c.$Ao.create(q).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const q=this.j.get(f(r));if(q)return this.F.info("Extensions is already requested to install",r.identifier.id),await q.task.waitUntilTaskIsFinished(),[]}const $=[],j=[],F=[],z=this.Z(t,r,w);C.URI.isUri(r)||this.j.set(f(r),{task:z,waitingTasks:[]}),this.n.fire({identifier:z.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",z.identifier.id),$.push({task:z,manifest:t});let U=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const Z=await this.N(z.identifier,t,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),K=await this.getInstalled(void 0,w.profileLocation),x={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[m.$3n]:!0}};for(const{gallery:H,manifest:Q}of(0,I.$Mb)(Z,({gallery:G})=>G.identifier.id)){U=U||!!Q.extensionDependencies?.some(ee=>(0,c.$zo)({id:ee},z.identifier));const G=f(H),W=this.j.get(G);if(W){if(this.L(z,W.task)){const ee=W.task.identifier;this.F.info("Waiting for already requested installing extension",ee.id,z.identifier.id),W.waitingTasks.push(z),j.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ne=>ne.some(_=>(0,c.$zo)(_.identifier,ee)))).then(ne=>{if(this.F.info("Finished waiting for already requested installing extension",ee.id,z.identifier.id),!ne.find(ie=>(0,c.$zo)(ie.identifier,ee))?.local)throw new Error(`Extension ${ee.id} is not installed`)}))}}else if(!K.some(({identifier:ee})=>(0,c.$zo)(ee,H.identifier))){const ee=this.Z(Q,H,x);this.j.set(G,{task:ee,waitingTasks:[z]}),this.n.fire({identifier:ee.identifier,source:H,profileLocation:w.profileLocation}),this.F.info("Installing extension:",ee.identifier.id,z.identifier.id),$.push({task:ee,manifest:Q})}}}catch(Z){if(C.URI.isUri(z.source))(0,I.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,Z.message),(0,I.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,Z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),Z}const q=$.reduce((Z,{task:K,manifest:x})=>(Z.set(K.identifier.id.toLowerCase(),{task:K,manifest:x}),Z),new Map);for(;q.size;){let Z;const K=[...q.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(H=>q.has(H.toLowerCase())));K.length?Z=q.size===1?K:K.filter(({task:x})=>!(x===z&&!U)):(this.F.info("Found extensions with circular dependencies",K.map(({task:x})=>x.identifier.id)),Z=[...q.values()]),await this.M(Z.map(async({task:x})=>{const H=new Date().getTime();try{const Q=await x.run();if(await this.M(this.y.map(G=>G.postInstall(Q,x.source,w,N.CancellationToken.None))),!C.URI.isUri(x.source)){const G=x.operation===3,W=G?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(a(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Ho)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:W}),k.$p&&x.operation!==3)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}F.push({local:Q,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw C.URI.isUri(x.source)||a(this.C,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Ho)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-H,error:Q}),this.F.error("Error while installing the extension:",x.identifier.id),Q}finally{q.delete(x.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),F.forEach(({identifier:Z})=>this.F.info("Extension installed successfully:",Z.id)),F}catch(q){if($.forEach(({task:Z})=>Z.cancel()),F.length)try{const Z=await Promise.allSettled(F.map(({local:K})=>this.$(K,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let K=0;K<Z.length;K++){const x=Z[K],{identifier:H}=F[K];x.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",H.id):this.F.warn("Rollback: Error while uninstalling extension",H.id,(0,A.$0)(x.reason))}}catch(Z){this.F.warn("Error while rolling back extensions",(0,A.$0)(Z),F.map(({identifier:K})=>K.id))}return $.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:w.context,profileLocation:w.profileLocation,error:q}))}finally{for(const{task:q}of $)q.source&&!C.URI.isUri(q.source)&&this.j.delete(f(q.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some(w=>this.L(w,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):o.push(w.reason);if(o.length)throw S(o);return r}async N(t,r,o,v,w){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,w),$=[],j=[],F=async(z,U)=>{$.push(z);const q=U.extensionDependencies||[],Z=[...q];if(U.extensionPack){const K=o?f.find(x=>(0,c.$zo)(x.identifier,z)):void 0;for(const x of U.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(H=>(0,c.$zo)({id:H},{id:x}))||Z.every(H=>!(0,c.$zo)({id:H},{id:x}))&&Z.push(x)}if(Z.length){const K=Z.filter(x=>$.every(H=>!(0,c.$zo)(H,{id:x})));if(K.length){const x=await this.z.getExtensions(K.map(H=>({id:H,preRelease:v})),N.CancellationToken.None);for(const H of x){if($.find(W=>(0,c.$zo)(W,H.identifier)))continue;const Q=q.some(W=>(0,c.$zo)({id:W},H.identifier));let G;try{G=await this.O(H,!1,v)}catch(W){if(Q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,A.$0)(W));continue}j.push({gallery:G.extension,manifest:G.manifest}),await F(G.extension.identifier,G.manifest)}}}};return await F(t,r),j}async O(t,r,o){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(j=>(0,c.$zo)(t.identifier,j)))throw new m.$$n(E.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const f=w.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},N.CancellationToken.None))[0],!v)throw new m.$$n(E.localize(2,null,t.identifier.id,f.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const j=await this.getTargetPlatform();throw new m.$$n(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$4n)(j)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],N.CancellationToken.None))[0]?new m.$$n(E.localize(4,null,t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$$n(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const $=await this.z.getManifest(v,N.CancellationToken.None);if($===null)throw new m.$$n(`Missing manifest for extension ${v.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if($.version!==v.version)throw new m.$$n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:$}}async P(t,r,o){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},N.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,o,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},N.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,o,v)),w}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=z=>`${z.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const f=z=>{const U=this.$(z,o);return this.m.set(v(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${z.identifier.id}@${z.manifest.version}`),this.t.fire({identifier:z.identifier,profileLocation:o.profileLocation,applicationScoped:z.isApplicationScoped}),U},$=(z,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${z.identifier.id}@${z.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${z.identifier.id}@${z.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${z.identifier.id}@${z.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Go)(z),error:U}),this.u.fire({identifier:z.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:z.isApplicationScoped})},j=[],F=[];try{j.push(f(t));const z=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,z);for(const q of U)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):j.push(f(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(j.map(U=>U.extension),z,t),await this.M(j.map(async U=>{try{if(await U.run(),await this.M(this.y.map(q=>q.postUninstall(U.extension,o,N.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}$(U.extension)}catch(q){const Z=q instanceof m.$$n?q:new m.$$n((0,A.$0)(q),m.ExtensionManagementErrorCode.Internal);throw $(U.extension,Z),Z}finally{F.push(U)}}))}catch(z){const U=z instanceof m.$$n?z:new m.$$n((0,A.$0)(z),m.ExtensionManagementErrorCode.Internal);for(const q of j){try{q.cancel()}catch{}F.includes(q)||$(q.extension,U)}throw U}finally{for(const z of j)this.m.delete(v(z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",z.extension.identifier.id)}}R(t,r,o){for(const v of t){const w=this.W(v,r);if(w.length){const f=w.filter($=>!t.some(j=>(0,c.$zo)(j.identifier,$.identifier)));if(f.length)throw new Error(this.S(v,f,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter($=>!$.isBuiltin&&v.some(j=>(0,c.$zo)({id:j},$.identifier))),f=[];for(const $ of w)f.push(...this.U($,r,o));return[...w,...f]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,c.$zo)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$pp=b,e.$pp=b=ye([Y(0,m.$0n),Y(1,l.$cl),Y(2,h.$Ik),Y(3,p.$0i),Y(4,y.$pj),Y(5,u.$Kk)],b);function S(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$qp=S;function s(i){if(i instanceof m.$$n)return i;const t=new m.$$n(i.message,m.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$rp=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:w,durationSinceUpdate:f}){let $,j;(0,g.$Gf)(o)&&(o===!0?o="Verified":(o===!1||($=m.ExtensionManagementErrorCode.Signature,j=o),o="Unverified")),w&&(w instanceof m.$$n?($=w.code,w.code===m.ExtensionManagementErrorCode.Signature&&(j=w.message)):$=m.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!w,duration:v,errorcode:$,errorcodeDetail:j,durationSinceUpdate:f})}class n{constructor(){this.d=new L.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.$Hg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$Hg)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$sp=n}),define(oe[51],ae([0,1,6,15,2,3,34,10,29,33,11,4,7,17,28,12,8,22]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class u extends Error{constructor(n,i){super(n),this.code=i}}e.$tp=u,e.$up=(0,E.$Ph)("IExtensionsProfileScannerService");let b=class extends N.$Sc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new A.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const w of o)n.some(([f])=>(0,g.$zo)(f.identifier,w.identifier)&&f.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,f]of n){const $=v.findIndex(F=>(0,g.$zo)(F.identifier,w.identifier)&&F.version===w.manifest.version),j={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:f};$===-1?(r.push(j),v.push(j)):v.splice($,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const w=n.find(([f])=>(0,g.$zo)(f.identifier,v.identifier)&&f.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,g.$zo)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$pk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new u((0,y.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const w of o){S(w)||this.w(n);let f;if((0,p.$yf)(w.relativeLocation)&&w.relativeLocation)f=this.z(w.relativeLocation);else if((0,p.$yf)(w.location))f=this.z(w.location),v=!0,w.relativeLocation=w.location,w.location=f.toJSON();else{f=R.URI.revive(w.location);const $=this.y(f);$&&(v=!0,w.relativeLocation=$)}r.push({identifier:w.identifier,location:f,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,L.$be.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,L.$be.fromString(JSON.stringify(v)))}return r})}w(n){const i=new u(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,C.$pk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>S(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,C.$pk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,C.$pk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,C.$pk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new I.$1g,this.h.set(n,i)),i}};e.$vp=b,e.$vp=b=ye([Y(1,C.$$j),Y(2,c.$Kk),Y(3,d.$Ik),Y(4,l.$cl),Y(5,m.$0i)],b);function S(a){return(0,p.$Af)(a)&&(0,k.$9n)(a.identifier)&&(s(a.location)||(0,p.$yf)(a.location)&&a.location)&&((0,p.$Ff)(a.relativeLocation)||(0,p.$yf)(a.relativeLocation))&&a.version&&(0,p.$yf)(a.version)}function s(a){return a?(0,p.$yf)(a.path)&&(0,p.$yf)(a.scheme):!1}}),define(oe[80],ae([0,1,18,6,30,15,8,35,138,2,23,16,5,19,54,89,12,10,155,14,33,44,68,11,4,7,24,3,64,51,17,28,183]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s,a,n,i,t,r,o,v,w,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.Translations=void 0;var j;(function(x){function H(Q,G){if(Q===G)return!0;const W=Object.keys(Q),ee=new Set;for(const ne of Object.keys(G))ee.add(ne);if(W.length!==ee.size)return!1;for(const ne of W){if(Q[ne]!==G[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(j||(e.Translations=j={})),e.$yp=(0,n.$Ph)("IExtensionsScannerService");let F=class extends g.$Sc{constructor(H,Q,G,W,ee,ne,_,ie,X,B,P,O){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Q,this.r=G,this.s=W,this.t=ee,this.u=ne,this.w=_,this.y=ie,this.z=X,this.C=B,this.D=P,this.F=O,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,c.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,b.$Ko)(this.w,this.y)),this.G}async scanAllExtensions(H,Q,G){const[W,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Q)]),ne=G?await this.scanExtensionsUnderDevelopment(H,[...W,...ee]):[];return this.L(W,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Q=[];Q.push(this.M(!!H.useCache,H.language)),Q.push(this.N(H.language,!!H.checkControlFile));const[G,W]=await Promise.all(Q);return this.J([...G,...W],0,H,!1)}async scanUserExtensions(H){const Q=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const G=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Q,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G),ee=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(W)}catch(_){if(_ instanceof v.$tp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(W);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const ee=await this.P(W,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Q.find(ie=>(0,b.$zo)(ie.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(G,"development",H,!0)}return[]}async scanExistingExtension(H,Q,G){const W=await this.P(H,!1,Q,!0,G.language,!0,void 0),ee=await this.n.scanExtension(W);return!ee||!G.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,Q,G){const W=await this.P(H,!1,Q,!0,G.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,Q,G,!0)}async scanMetadata(H){const Q=(0,c.$vg)(H,"package.json"),G=(await this.w.readFile(Q)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,Q){const G=(0,c.$vg)(H,"package.json"),W=(await this.w.readFile(G)).value.toString(),ee=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ee.__metadata={...ee.__metadata,...Q},await this.w.writeFile((0,c.$vg)(H,"package.json"),A.$be.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$tp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$be.fromString(JSON.stringify([])))}catch(Q){(0,a.$pk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Q,G,W){return G.includeAllVersions||(H=this.L(Q===0?H:void 0,Q===1?H:void 0,Q==="development"?H:void 0,await this.getTargetPlatform(),W)),G.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=E.$nc(ee.location.fsPath),ie=E.$nc(ne.location.fsPath);return _<ie?-1:_>ie?1:0})}L(H,Q,G,W,ee){const ne=(ie,X,B)=>{if(ie.isValid&&!X.isValid)return!1;if(ie.isValid===X.isValid){if(ee&&d.gt(ie.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(d.eq(ie.manifest.version,X.manifest.version)){if(ie.type===0)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===W)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${ie.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${X.location.path}.`),!0},_=new S.$8l;return H?.forEach(ie=>{const X=_.get(ie.identifier.id);(!X||ne(X,ie,!1))&&_.set(ie.identifier.id,ie)}),Q?.forEach(ie=>{const X=_.get(ie.identifier.id);if(!X&&H&&ie.type===0){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!X||ne(X,ie,!1))&&_.set(ie.identifier.id,ie)}),G?.forEach(ie=>{const X=_.get(ie.identifier.id);(!X||ne(X,ie,!0))&&_.set(ie.identifier.id,ie),_.set(ie.identifier.id,ie)}),[..._.values()]}async M(H,Q){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),ee=await(H&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,Q){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Q?await this.O():{},ee=[],ne=l.URI.file(E.$hc(E.$jc(C.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of G){const X=W[ie.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":ee.push((0,c.$vg)(ne,ie.name));break;default:ee.push(l.URI.file(X));break}}const _=await Promise.all(ee.map(async ie=>this.n.scanExtension(await this.P(ie,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,I.$Hb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Q,G,W,ee,ne,_){const ie=await this.f(ee??m.$w),X=await this.Q(H),B=Q&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=B?await this.Q(B):void 0;return new z(H,X,B,P,Q,_,G,W,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,ie)}async Q(H){try{const Q=await this.w.stat(H);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$zp=F,e.$zp=F=ye([Y(4,w.$Kk),Y(5,v.$up),Y(6,a.$$j),Y(7,i.$0i),Y(8,u.$Wh),Y(9,t.$pj),Y(10,f.$Ik),Y(11,n.$Oh)],F);class z{constructor(H,Q,G,W,ee,ne,_,ie,X,B,P,O,T,M,V){this.location=H,this.mtime=Q,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=ie,this.validate=X,this.productVersion=B,this.productDate=P,this.productCommit=O,this.devMode=T,this.language=M,this.translations=V}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Q){return(0,c.$og)(H.location,Q.location)&&H.mtime===Q.mtime&&(0,c.$og)(H.applicationExtensionslocation,Q.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&H.profile===Q.profile&&N.$$m(H.profileScanOptions,Q.profileScanOptions)&&H.type===Q.type&&H.excludeObsolete===Q.excludeObsolete&&H.validate===Q.validate&&H.productVersion===Q.productVersion&&H.productDate===Q.productDate&&H.productCommit===Q.productCommit&&H.devMode===Q.devMode&&H.language===Q.language&&j.equals(H.translations,Q.translations)}}e.$Ap=z;let U=class extends g.$Sc{constructor(H,Q,G,W,ee){super(),this.f=H,this.g=Q,this.h=G,this.j=W,this.m=ee}async scanExtensions(H){const Q=H.profile?await this.r(H):await this.n(H);let G={};if(H.excludeObsolete&&H.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(W)}catch{}return(0,y.$Lf)(G)?Q:Q.filter(W=>!G[b.$Ao.create(W).toString()])}async n(H){const Q=await this.j.resolve(H.location);if(!Q.children?.length)return[];const G=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||H.type===1&&(0,c.$sg)(W.resource).indexOf(".")===0)return null;const ee=new z(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,I.$Hb)(G).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(H){let Q=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const G=await this.s(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);Q.push(...G)}return Q}async s(H,Q,G){const W=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ne=>{if(Q(ne)){const _=new z(ne.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,I.$Hb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,c.$vg)(H.location,"package.json"))){const Q=await this.scanExtension(H);return Q?[Q]:[]}else return await this.scanExtensions(H)}catch(Q){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,D.$0)(Q)),[]}}async scanExtension(H,Q){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=S.$2l),Q=Q??G.__metadata,delete G.__metadata;const W=(0,b.$Eo)(G.publisher,G.name),ee=Q?.id?{id:W,uuid:Q.id}:{id:W},ne=Q?.isSystem?0:H.type,_=ne===0||!!Q?.isBuiltin;G=await this.t(H.location,G,z.createNlsConfiguration(H));const ie={type:ne,identifier:ee,manifest:G,location:H.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return H.validate?this.validate(ie,H):ie}}catch(G){H.type!==0&&this.m.error(G)}return null}validate(H,Q){let G=!0;const W=(0,s.$Po)(Q.productVersion,Q.productDate,Q.location,H.manifest,H.isBuiltin);for(const[ee,ne]of W)ee===p.default.Error&&(G=!1,this.m.error(this.z(Q.location,ne)));return H.isValid=G,H.validations=W,H}async scanExtensionManifest(H){const Q=(0,c.$vg)(H,"package.json");let G;try{G=(await this.j.readFile(Q)).value.toString()}catch(ee){return(0,a.$pk)(ee)!==1&&this.m.error(this.z(H,(0,h.localize)(0,null,Q.path,ee.message))),null}let W;try{W=JSON.parse(G)}catch{const ne=[];(0,R.$Wm)(G,ne);for(const _ of ne)this.m.error(this.z(H,(0,h.localize)(1,null,Q.path,_.offset,_.length,(0,k.$wp)(_.error))));return null}return(0,R.$6m)(W)!=="object"?(this.m.error(this.z(H,(0,h.localize)(2,null,Q.path))),null):W}async t(H,Q,G){const W=await this.u(H,Q,G);if(W)try{const ee=[],ne=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(ie=>{this.m.error(this.z(H,(0,h.localize)(3,null,W.default?.path,(0,k.$wp)(ie.error))))}),Q;if((0,R.$6m)(W)!=="object")return this.m.error(this.z(H,(0,h.localize)(4,null,W.default?.path))),Q;const _=W.values||Object.create(null);return(0,$.$xp)(this.m,Q,_,ne)}catch{}return Q}async u(H,Q,G){const W=(0,c.$vg)(H,"package.nls.json"),ee=(X,B)=>{B.forEach(P=>{this.m.error(this.z(H,(0,h.localize)(5,null,X?.path,(0,k.$wp)(P.error))))})},ne=X=>{this.m.error(this.z(H,(0,h.localize)(6,null,X?.path)))},_=`${Q.publisher}.${Q.name}`,ie=G.translations[_];if(ie)try{const X=l.URI.file(ie),B=(await this.j.readFile(X)).value.toString(),P=[],O=(0,R.$Wm)(B,P);return P.length>0?(ee(X,P),{values:void 0,default:W}):(0,R.$6m)(O)!=="object"?(ne(X),{values:void 0,default:W}):{values:O.contents?O.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let B;try{B=await this.y(H,G)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const P=(await this.j.readFile(B.localized)).value.toString(),O=[],T=(0,R.$Wm)(P,O);return O.length>0?(ee(B.localized,O),{values:void 0,default:B.original}):(0,R.$6m)(T)!=="object"?(ne(B.localized),{values:void 0,default:B.original}):{values:T,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(H,Q){if(H)try{const G=(await this.j.readFile(H)).value.toString();return(0,R.$Wm)(G,Q)}catch{}}y(H,Q){return new Promise((G,W)=>{const ee=ne=>{const _=(0,c.$vg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(ie=>{ie&&G({localized:_,original:(0,c.$vg)(H,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?G({localized:(0,c.$vg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,X),ee(ne))})};if(Q.devMode||Q.pseudo||!Q.language)return G({localized:(0,c.$vg)(H,"package.nls.json"),original:null});ee(Q.language)})}z(H,Q){return`[${H.path}]: ${Q}`}};U=ye([Y(1,v.$up),Y(2,f.$Ik),Y(3,a.$$j),Y(4,i.$0i)],U);let q=class extends U{constructor(H,Q,G,W,ee,ne,_){super(Q,W,ee,ne,_),this.G=H,this.H=G,this.D=this.B(new L.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Q=this.M(H),G=await this.I(Q);if(this.C=H,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),G.result.map(ee=>(ee.location=l.URI.revive(ee.location),ee));const W=await super.scanExtensions(H);return await this.J(Q,{input:H,result:W}),W}async I(H){try{const Q=await this.j.readFile(H),G=JSON.parse(Q.value.toString());return{result:G.result,input:(0,o.$mh)(G.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",H.path,(0,D.$0)(Q))}return null}async J(H,Q){try{await this.j.writeFile(H,A.$be.fromString(JSON.stringify(Q)))}catch(G){this.m.debug("Error while writing the extension cache file:",H.path,(0,D.$0)(G))}}async L(){if(!this.C)return;const H=this.M(this.C),Q=await this.I(H);if(!Q)return;const G=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$$m(W,G))try{this.m.info("Invalidating Cache",G,W),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const Q=this.N(H);return this.h.extUri.joinPath(Q.cacheHome,H.type===0?S.$1l:S.$Zl)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(H.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([Y(2,w.$Kk),Y(3,v.$up),Y(4,f.$Ik),Y(5,a.$$j),Y(6,i.$0i)],q);function Z(x,H){const Q=(0,b.$Co)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new S.$6l(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Bp=Z;class K extends F{constructor(H,Q,G,W,ee,ne,_,ie,X,B,P,O){super(H,Q,(0,c.$vg)(G,".vscode-oss-dev","extensions","control.json"),W,ee,ne,_,ie,X,B,P,O),this.R=(async()=>{if(m.$z)try{const T=await this.w.readFile(l.URI.file(m.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Cp=K}),define(oe[244],ae([0,1,65,6,38,3,2,23,16,31,7,17]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let m=class extends D.$Sc{constructor(d,p){super(),this.b=d,this.f=p,this.a=new L.$Zg(5)}async postUninstall(d){const p=this.g(d,"uninstall");p&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(y){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(y)}}));try{await g.Promises.rm(this.m(d))}catch(y){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(y)}}g(d,p){const y=`vscode:${p}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[y]=="string"){const l=d.manifest.scripts[y].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${y} should be a node script`),null):{script:(0,k.$jc)(d.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(d,p,y,l,h){return new Promise((u,b)=>{const S=this.j(d,p,y,h);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?b(n):u(void 0)};S.on("error",n=>{a((0,N.$Ai)(n)||"Unknown")}),S.on("exit",(n,i)=>{a(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(s=setTimeout(()=>{s=null,S.kill(),b("timed out")},5e3))})}j(d,p,y,l){const h={silent:!0,execArgv:void 0},u=(0,I.fork)(d,[`--type=extension-post-${p}`,...y],h);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const b=A.Event.fromNodeEventEmitter(u.stdout,"data"),S=A.Event.fromNodeEventEmitter(u.stderr,"data");b(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),S(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const s=A.Event.any(A.Event.map(b,n=>({data:`%c${n}`,format:[""]})),A.Event.map(S,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}m(d){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$Ep=m,e.$Ep=m=ye([Y(0,E.$Kk),Y(1,C.$0i)],m)}),define(oe[245],ae([0,1,7,17,28,22,51,11,14,10]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;let C=class extends D.$vp{constructor(m,c,d,p,y,l){super(g.URI.file(m.extensionsPath),c,d,p,y,l)}};e.$DN=C,e.$DN=C=ye([Y(0,k.$Xh),Y(1,R.$$j),Y(2,L.$Kk),Y(3,N.$Ik),Y(4,A.$cl),Y(5,I.$0i)],C)}),define(oe[246],ae([0,1,10,14,51,80,11,4,7,24,28,17]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=void 0;let m=class extends A.$Cp{constructor(d,p,y,l,h,u,b,S){super(I.URI.file(h.builtinExtensionsPath),I.URI.file(h.extensionsPath),h.userHome,d.defaultProfile,d,p,y,l,h,u,b,S)}};e.$T7b=m,e.$T7b=m=ye([Y(0,E.$Kk),Y(1,N.$up),Y(2,D.$$j),Y(3,k.$0i),Y(4,L.$Xh),Y(5,g.$pj),Y(6,C.$Ik),Y(7,R.$Oh)],m)}),define(oe[21],ae([0,1,6,3,2,100,12,67,4,17]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$6o=e.$5o=e.$4o=void 0,e.$4o="__$__isNewStorageMarker",e.$5o="__$__targetStorageMarker",e.$6o=(0,k.$Ph)("storageService");var C;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var m;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function c(h){const u=h.get(e.$5o);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$7o=c;class d extends N.$Sc{static{this.a=60*1e3}constructor(u={flushInterval:d.a}){super(),this.m=u,this.b=this.B(new L.$Qd),this.c=this.B(new L.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new I.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,b,S){return L.Event.filter(this.b.event,s=>s.scope===u&&(b===void 0||s.key===b),S)}n(){this.j.value=(0,I.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,b){const{key:S,external:s}=b;if(S===e.$5o){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:S,target:this.J(u)[S],external:s})}w(u){this.f.fire({reason:u})}get(u,b,S){return this.P(b)?.get(u,S)}getBoolean(u,b,S){return this.P(b)?.getBoolean(u,S)}getNumber(u,b,S){return this.P(b)?.getNumber(u,S)}getObject(u,b,S){return this.P(b)?.getObject(u,S)}storeAll(u,b){this.y(()=>{for(const S of u)this.store(S.key,S.value,S.scope,S.target,b)})}store(u,b,S,s,a=!1){if((0,D.$Hf)(b)){this.remove(u,S,a);return}this.y(()=>{this.z(u,S,s),this.P(S)?.set(u,b,a)})}remove(u,b,S=!1){this.y(()=>{this.z(u,b,void 0),this.P(b)?.delete(u,S)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,b){const S=[],s=this.J(u);for(const a of Object.keys(s))s[a]===b&&S.push(a);return S}z(u,b,S,s=!1){const a=this.J(b);typeof S=="number"?a[u]!==S&&(a[u]=S,this.P(b)?.set(e.$5o,JSON.stringify(a),s)):typeof a[u]=="number"&&(delete a[u],this.P(b)?.set(e.$5o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const b=this.P(u);return b?c(b):Object.create(null)}isNew(u){return this.getBoolean(e.$4o,u)===!0}async flush(u=C.NONE){this.f.fire({reason:u});const b=this.P(-1),S=this.P(0),s=this.P(1);switch(u){case C.NONE:await I.Promises.settled([b?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([b?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,b=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return l(u,b,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,b){return this.w(C.NONE),(0,g.$Jk)(u)?this.R(u,b):this.S(u,b)}M(u,b){return!(u.id===b.id||p(b)&&p(u))}N(u,b,S){this.y(()=>{const s=new Set;for(const[a,n]of u)s.add(a),b.get(a)!==n&&this.u(S,{key:a,external:!0});for(const[a]of b.items)s.has(a)||this.u(S,{key:a,external:!0})})}}e.$8o=d;function p(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$9o=p;class y extends d{constructor(){super(),this.U=this.B(new R.$2o(new R.$3o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$2o(new R.$3o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$2o(new R.$3o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$0o=y;async function l(h,u,b,S,s,a){const n=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,t=new Map;h.forEach((j,F)=>{i.set(F,j),t.set(F,n(j))});const r=new Map,o=new Map;u.forEach((j,F)=>{r.set(F,j),o.set(F,n(j))});const v=new Map,w=new Map;b.forEach((j,F)=>{v.set(F,j),w.set(F,n(j))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const f=[];if(i.forEach((j,F)=>{f.push({key:F,value:j})}),console.table(f),console.groupEnd(),console.log(t),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const j=[];r.forEach((F,z)=>{j.push({key:z,value:F})}),console.table(j),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const $=[];v.forEach((j,F)=>{$.push({key:F,value:j})}),console.table($),console.groupEnd(),console.log(w)}e.$$o=l}),define(oe[114],ae([0,1,3,2,12,29,33,21]),function(te,e,I,L,N,A,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zCb=e.$yCb=void 0;let k=class extends L.$Sc{constructor(E,m){super(),this.a=new I.$Nd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(E)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B(m.onDidInstallExtensions(c=>c.forEach(({local:d,operation:p})=>{d&&p===4&&this.f(d.identifier)})))}async enableExtension(E,m){return this.f(E)?(this.a.fire({extensions:[E],source:m}),!0):!1}async disableExtension(E,m){return this.c(E)?(this.a.fire({extensions:[E],source:m}),!0):!1}getDisabledExtensions(){return this.h(A.$ao)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const m=this.getDisabledExtensions();return m.every(c=>!(0,D.$zo)(c,E))?(m.push(E),this.g(m),!0):!1}f(E){const m=this.getDisabledExtensions();for(let c=0;c<m.length;c++){const d=m[c];if((0,D.$zo)(d,E))return m.splice(c,1),this.g(m),!0}return!1}g(E){this.j(A.$ao,E)}h(E){return this.b.get(E,0)}j(E,m){this.b.set(E,m,0)}};e.$yCb=k,e.$yCb=k=ye([Y(0,R.$6o),Y(1,A.$_n)],k);class g extends L.$Sc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new I.$Nd),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new L.$Rc))(m=>this.f(m)))}get(E,m){let c;return m===0?((0,N.$Hf)(this.a[E])&&(this.a[E]=this.g(E,m)),c=this.a[E]):c=this.g(E,m),JSON.parse(c)}set(E,m,c){const d=JSON.stringify(m.map(({id:y,uuid:l})=>({id:y,uuid:l})));this.g(E,c)!==d&&(c===0&&(m.length?this.a[E]=d:delete this.a[E]),this.h(E,m.length?d:void 0,c))}f(E){if(!(0,N.$Hf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const c=this.get(E.key,E.scope);delete this.a[E.key];const d=this.get(E.key,E.scope),p=c.filter(l=>!d.some(h=>(0,D.$zo)(l,h))),y=d.filter(l=>!c.some(h=>(0,D.$zo)(h,l)));(p.length||y.length)&&this.b.fire([...p,...y])}}g(E,m){return this.c.get(E,m,"[]")}h(E,m,c){m?this.c.store(E,m,c,1):this.c.remove(E,c)}}e.$zCb=g}),define(oe[247],ae([0,1,18,26,8,5,37,12,10,20,14,29,33,68,11,7,24,57,224,21,22,61]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=void 0;const s=A.$p?"web":(0,E.$6n)(A.$u,D.$ec),a="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((O,T)=>O|T,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(O=w){this.d=O}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(O,T=this.d.pageSize){return new f({...this.d,pageNumber:O,pageSize:T})}withFilter(O,...T){const M=[...this.d.criteria,...T.length?T.map(V=>({filterType:O,value:V})):[{filterType:O}]];return new f({...this.d,criteria:M})}withSortBy(O){return new f({...this.d,sortBy:O})}withSortOrder(O){return new f({...this.d,sortOrder:O})}withFlags(...O){return new f({...this.d,flags:O.reduce((T,M)=>T|M,0)})}withAssetTypes(...O){return new f({...this.d,assetTypes:O})}withSource(O){return new f({...this.d,source:O})}get raw(){const{criteria:O,pageNumber:T,pageSize:M,sortBy:V,sortOrder:J,flags:re,assetTypes:ce}=this.d;return{filters:[{criteria:O,pageNumber:T,pageSize:M,sortBy:V,sortOrder:J}],assetTypes:ce,flags:re}}get searchText(){const O=this.d.criteria.filter(T=>T.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(O=>String(O.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function $(P,O){const T=(P||[]).filter(M=>M.statisticName===O)[0];return T?T.value:0}function j(P){const O="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(M=>M.assetType.indexOf(O)===0).reduce((M,V)=>{const J=U(P,V.assetType);return J&&M.push([V.assetType.substring(O.length),J]),M},[])}function F(P){if(P.properties){const O=P.properties.filter(V=>V.key===r.Repository),T=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=O.filter(V=>T.test(V.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return U(P,r.Repository)}function z(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function U(P,O){return P.files.filter(M=>M.assetType===O)[0]?{uri:`${P.assetUri}/${O}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${O}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function q(P,O){const T=P.properties?P.properties.filter(V=>V.key===O):[],M=T.length>0&&T[0].value;return M?M.split(",").map(V=>(0,m.$Do)(V)):[]}function Z(P){const O=P.properties?P.properties.filter(T=>T.key===o.Engine):[];return O.length>0&&O[0].value||""}function K(P){const O=P.properties?P.properties.filter(T=>T.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function x(P){const O=P.properties?P.properties.filter(M=>M.key===o.LocalizedLanguages):[],T=O.length>0&&O[0].value||"";return T?T.split(","):[]}function H(P){return P.properties?.find(O=>O.key===o.SponsorLink)?.value}function Q(P){return P.indexOf("preview")!==-1}function G(P){return P.targetPlatform?(0,E.$5n)(P.targetPlatform):"undefined"}function W(P){const O=(0,I.$Mb)(P.versions.map(G)),T=!!P.tags?.includes(E.$Zn),M=O.indexOf("web");return T?M===-1&&O.push("web"):M!==-1&&O.splice(M,1),O}function ee(P,O){for(let T=0;T<P.length;T++){const M=P[T];if(M.version===P[T-1]?.version){let V=T;if(G(M)===O)for(;V>0&&P[V-1].version===M.version;)V--;V!==T&&(P.splice(T,1),P.splice(V,0,M))}}return P}e.$bp=ee;function ne(P,O,T){P.telemetryData={index:O,querySource:T,queryActivityId:P.queryContext?.[a]}}function _(P,O,T,M){const V=P.versions[0],J={manifest:U(O,r.Manifest),readme:U(O,r.Details),changelog:U(O,r.Changelog),license:U(O,r.License),repository:F(O),download:z(O),icon:U(O,r.Icon),signature:U(O,r.Signature),coreTranslations:j(O)};return{identifier:{id:(0,m.$Eo)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:O.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(V),description:P.shortDescription||"",installCount:$(P.statistics,"install"),rating:$(P.statistics,"averagerating"),ratingCount:$(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:T,assets:J,properties:{dependencies:q(O,o.Dependency),extensionPack:q(O,o.ExtensionPack),engine:Z(O),localizedLanguages:x(O),targetPlatform:G(O),isPreReleaseVersion:K(O)},hasPreReleaseVersion:K(V),hasReleaseVersion:!0,preview:Q(P.flags),isSigned:!!J.signature,queryContext:M}}let ie=class{constructor(O,T,M,V,J,re,ce,ue){this.k=T,this.l=M,this.n=V,this.o=J,this.q=re,this.u=ce,this.w=ue;const he=ce.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,h.$ap)(ce.version,ce,this.n,this.w,this.q,O,this.o)}x(O=""){return`${this.d}${O}`}isEnabled(){return!!this.d}async getExtensions(O,T,M){const V=L.CancellationToken.isCancellationToken(T)?{}:T,J=L.CancellationToken.isCancellationToken(T)?T:M,re=[],ce=[],ue=[],he=[];let $e=!0;for(const Ee of O){Ee.uuid?ce.push(Ee.uuid):re.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);ue.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!Ie}if(!ce.length&&!re.length)return[];let de=new f().withPage(1,O.length);ce.length&&(de=de.withFilter(t.ExtensionId,...ce)),re.length&&(de=de.withFilter(t.ExtensionName,...re)),(V.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),V.source&&(de=de.withSource(V.source));const{extensions:we}=await this.z(de,{targetPlatform:V.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!V.compatible},J);return V.source&&we.forEach((Ee,Ie)=>ne(Ee,Ie,V.source)),we}async getCompatibleExtension(O,T,M){if((0,E.$7n)(O.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(O,T,M))return O;const V=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:J}=await this.z(V,{targetPlatform:M,compatible:!0,includePreRelease:T},L.CancellationToken.None);return J[0]||null}async isExtensionCompatible(O,T,M){if(!(0,E.$8n)(O.properties.targetPlatform,O.allTargetPlatforms,M)||!T&&O.properties.isPreReleaseVersion)return!1;let V=O.properties.engine;if(!V){const J=await this.getManifest(O,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");V=J.engines.vscode}return(0,c.$Ro)(V,this.u.version,this.u.date)}async y(O,T,M,V,J){if(!(0,E.$8n)(G(O),V,J)||T!=="any"&&K(O)!==(T==="prerelease"))return!1;if(M)try{const re=await this.E(O);if(!(0,c.$Ro)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${O.version}.`,(0,N.$0)(re)),!1}return!0}async query(O,T){let M=O.text||"";const V=O.pageSize??50;let J=new f().withPage(1,V);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(J=J.withFilter(t.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(J=J.withFilter(t.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(t.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),J=J.withFilter(t.SearchText,M)),J=J.withSortBy(0)):O.ids?J=J.withFilter(t.ExtensionId,...O.ids):O.names?J=J.withFilter(t.ExtensionName,...O.names):J=J.withSortBy(4),typeof O.sortBy=="number"&&(J=J.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(J=J.withSortOrder(O.sortOrder)),O.source&&(J=J.withSource(O.source));const re=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},de);return we.forEach((Ie,Le)=>ne(Ie,($e.pageNumber-1)*$e.pageSize+Le,O.source)),{extensions:we,total:Ee}},{extensions:ce,total:ue}=await re(J,T),he=async($e,de)=>{if(de.isCancellationRequested)throw new N.$5;const{extensions:we}=await re(J.withPage($e+1),de);return we};return{firstPage:ce,total:ue,pageSize:J.pageSize,getPage:he}}async z(O,T,M){const V=O.flags;O.flags&n.IncludeLatestVersionOnly&&O.flags&n.IncludeVersions&&(O=O.withFlags(O.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(O.flags&n.IncludeLatestVersionOnly)&&!(O.flags&n.IncludeVersions)&&(O=O.withFlags(O.flags,n.IncludeLatestVersionOnly)),T.versions?.length&&(O=O.withFlags(O.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),O=O.withFlags(O.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:J,total:re,context:ce}=await this.B(O,M);if(!(O.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of J){const Ee=await this.A(we,T,ce);Ee&&de.push(Ee)}return{extensions:de,total:re}}const he=[],$e=new Map;for(let de=0;de<J.length;de++){const we=J[de],Ee={id:(0,m.$Eo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,R.$Ef)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(Te=>(0,m.$zo)(Te,Ee))?.includePreRelease;if(T.compatible&&(0,E.$7n)(W(we),T.targetPlatform))continue;const Le=await this.A(we,T,ce);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==T.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Le])}if($e.size){const de=new S.$Jd,we=new f().withFlags(V&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,T,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of Ee){const Le=$e.get(Ie.identifier.uuid);he.push([Le,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:re}}async A(O,T,M){const V={id:(0,m.$Eo)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},J=T.versions?.find(he=>(0,m.$zo)(he,V))?.version,re=(0,R.$Ef)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(he=>(0,m.$zo)(he,V))?.includePreRelease,ce=W(O),ue=ee(O.versions,T.targetPlatform);if(T.compatible&&(0,E.$7n)(ce,T.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(J&&$e.version!==J)){if(await this.y($e,re?"any":"release",T.compatible,ce,T.targetPlatform))return _(O,$e,ce,M);if(J&&$e.version===J)return null}}return J||T.compatible?null:_(O,O.versions[0],ce)}async B(O,T){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const M=await this.j,V=JSON.stringify(O.raw),J={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},re=new S.$Jd;let ce,ue,he=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&O.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:J},T),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,l.$Yo)(ce);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(V.length),duration:re.elapsed(),success:!!ce&&(0,l.$Uo)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ue?(0,N.$4)(ue)?"canceled":(0,N.$0)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(O,T,M,V){if(!this.isEnabled())return;const J=A.$p?this.x(`/itemName/${O}.${T}/version/${M}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${O}/extensions/${T}/${M}/stats?statType=${V}`),re=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:J,headers:ue},L.CancellationToken.None)}catch{}}async download(O,T,M){this.l.trace("ExtensionGalleryService#download",O.identifier.id);const V=(0,m.$Ho)(O),J=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:de}),ce=M===2?"install":M===3?"update":"",ue=ce?{uri:`${O.assets.download.uri}${k.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${k.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,he=O.queryContext?.[a]?{[a]:O.queryContext[a]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(T,$e.stream),re(new Date().getTime()-J)}async downloadSignatureArchive(O,T){if(!O.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",O.identifier.id);const M=await this.D(O.assets.signature);await this.q.writeFile(T,M.stream)}async getReadme(O,T){if(O.assets.readme){const M=await this.D(O.assets.readme,{},T);return await(0,l.$Xo)(M)||""}return""}async getManifest(O,T){if(O.assets.manifest){const M=await this.D(O.assets.manifest,{},T),V=await(0,l.$Xo)(M);return V?JSON.parse(V):null}return null}async C(O,T){const M=U(O,r.Manifest);if(!M)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},J=await this.D(M,{headers:V});return await(0,l.$Yo)(J)}async getCoreTranslation(O,T){const M=O.assets.coreTranslations.filter(V=>V[0]===T.toUpperCase())[0];if(M){const V=await this.D(M[1]),J=await(0,l.$Xo)(V);return J?JSON.parse(J):null}return null}async getChangelog(O,T){if(O.assets.changelog){const M=await this.D(O.assets.changelog,{},T);return await(0,l.$Xo)(M)||""}return""}async getAllCompatibleVersions(O,T,M){let V=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?V=V.withFilter(t.ExtensionId,O.identifier.uuid):V=V.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:J}=await this.B(V,L.CancellationToken.None);if(!J.length)return[];const re=W(J[0]);if((0,E.$7n)(re,M))return[];const ce=[];await Promise.all(J[0].versions.map(async $e=>{try{await this.y($e,T?"any":"release",!0,re,M)&&ce.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of ee(ce,M))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:K($e)}));return ue}async D(O,T={},M=L.CancellationToken.None){const V=await this.j,J={type:"GET"},re={...V,...T.headers||{}};T={...T,...J,headers:re};const ce=O.uri,ue=O.fallbackUri,he={...T,url:ce};try{const $e=await this.k.request(he,M);if($e.res.statusCode===200)return $e;const de=await(0,l.$Xo)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,N.$4)($e))throw $e;const de=(0,N.$0)($e);this.o.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const we={...T,url:ue};return this.k.request(we,M)}}async E(O){let T=Z(O);if(!T){const M=await this.C(O,L.CancellationToken.None);if(!M)throw new Error("Manifest was not found");T=M.engines.vscode}return T}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const O=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const T=await(0,l.$Yo)(O),M=[],V={},J=[];if(T){for(const re of T.malicious)M.push({id:re});if(T.migrateToPreRelease)for(const[re,ce]of Object.entries(T.migrateToPreRelease))(!ce.engine||(0,c.$Ro)(ce.engine,this.u.version,this.u.date))&&(V[re.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(T.deprecated)for(const[re,ce]of Object.entries(T.deprecated))ce&&(V[re.toLowerCase()]=(0,R.$Ef)(ce)?{}:ce);if(T.search)for(const re of T.search)J.push(re)}return{malicious:M,deprecated:V,search:J}}};ie=ye([Y(1,l.$So),Y(2,p.$0i),Y(3,C.$Wh),Y(4,b.$cl),Y(5,d.$$j),Y(6,y.$pj),Y(7,g.$ji)],ie);let X=class extends ie{constructor(O,T,M,V,J,re,ce,ue){super(O,T,M,V,J,re,ce,ue)}};e.$cp=X,e.$cp=X=ye([Y(0,u.$6o),Y(1,l.$So),Y(2,p.$0i),Y(3,C.$Wh),Y(4,b.$cl),Y(5,d.$$j),Y(6,y.$pj),Y(7,g.$ji)],X);let B=class extends ie{constructor(O,T,M,V,J,re,ce){super(void 0,O,T,M,V,J,re,ce)}};e.$dp=B,e.$dp=B=ye([Y(0,l.$So),Y(1,p.$0i),Y(2,C.$Wh),Y(3,b.$cl),Y(4,d.$$j),Y(5,y.$pj),Y(6,g.$ji)],B)}),define(oe[81],ae([0,1,4,3,2,21,33,24,18,7,12]),function(te,e,I,L,N,A,D,R,k,g,C){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=void 0,e.$Wu=(0,I.$Ph)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends N.$Sc{static{E=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,D.$Do)(p.id)}@${p.version}`}static c(p){const y=m.exec(p);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(p,y){const l=await p.getInstalled(),h=[];for(const[u,b]of E.f(y)){const S=l.find(s=>(0,D.$zo)(s.identifier,{id:u}))?.manifest.version;for(const s of b)S!==s&&h.push(E.b({id:u,version:s}))}for(const u of h)y.remove(u,0)}static f(p){const y=new Map,l=p.keys(0,1);for(const h of l){const u=E.c(h);if(u){let b=y.get(u.id.toLowerCase());b||y.set(u.id.toLowerCase(),b=[]),b.push(u.version)}}return y}constructor(p,y,l){super(),this.j=p,this.m=y,this.n=l,this.g=this.B(new L.$Nd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new N.$Rc))(h=>this.r(h)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const y=E.c(p.key);if(y){if(this.j.get(p.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let l=this.h.get(y.id.toLowerCase());l||this.h.set(y.id.toLowerCase(),l=[]),l.push(y.version),this.g.fire()}return}}s(p){if((0,C.$yf)(p))return p;const y=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,D.$Co)(y,l)}getExtensionState(p,y){const l=this.s(p),h=this.getExtensionStateRaw(p,y);if(h)try{return JSON.parse(h)}catch(u){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${y}): ${u}`)}}getExtensionStateRaw(p,y){const l=this.s(p),h=this.j.get(l,y?0:1);return h&&h?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${y}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(p,y,l){const h=this.s(p);y===void 0?this.j.remove(h,l?0:1):this.j.store(h,JSON.stringify(y),l?0:1,1)}setKeysForSync(p,y){this.j.store(E.b(p),JSON.stringify(y),0,1)}getKeysForSync(p){const y=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(E.b(p),0),h=l?JSON.parse(l):void 0;return h&&y?(0,k.$Mb)([...h,...y]):h||y}addToMigrationList(p,y){if(p!==y){const l=this.t.filter(h=>!h.includes(p)&&!h.includes(y));l.push([p,y]),this.t=l}}getSourceExtensionToMigrate(p){const y=this.t.find(([,l])=>p===l);return y?y[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(p);if(Array.isArray(y))return y}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Xu=c,e.$Xu=c=E=ye([Y(0,A.$6o),Y(1,R.$pj),Y(2,g.$0i)],c)}),define(oe[248],ae([0,1,29,11,24,14,98,55,21,22,221]),function(te,e,I,L,N,A,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f9b=void 0;let E=class extends C.$q5b{constructor(c,d,p,y,l,h,u,b){super(c.userHome,l,d,p,y,h,u,b)}};e.$f9b=E,e.$f9b=E=ye([Y(0,A.$Xh),Y(1,g.$cl),Y(2,I.$_n),Y(3,k.$6o),Y(4,R.$86b),Y(5,D.$IVb),Y(6,L.$$j),Y(7,N.$pj)],E)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,65,24,5,6,101,20,165,36,21,12,132,19]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=void 0;const S=[I.$78b,I.$88b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends D.$Sc{constructor(o,v,w,f,$,j,F){super(),this.y=o,this.z=v,this.C=w,this.D=j,this.F=F,this.f=new L.$Nd,this.onDidTokenFailed=this.f.event,this.g=new L.$Nd,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$Nd,this.onDidChangeMode=this.h.event,this.n=I.$58b,this.w=!1,this.I=(z,U)=>{U?this.j.error(z):this.j.info(z)},this.j=this.B(f.createLogger((0,b.$vg)(w.logsHome,`${I.$98b}.log`),{id:I.$98b,name:I.$08b})),this.t=new m.$Qg(100),this.B(this.j.onDidChangeLogLevel(z=>this.j.info("Log level changed to "+(0,R.$mj)(z)))),this.B($.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(j.onDidChangeConfiguration(z=>{S.some(U=>z.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$k?o=this.C.appRoot:o=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(o,"bin",`${this.z.tunnelApplicationName}${E.$j?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(I.$58b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const w=(U,q)=>{q?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],w);this.r=f;try{if(await f,this.r!==f)return;const U=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")));if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(I.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const $=this.n.active?this.n.session:void 0;if($&&$.token){const U=$.token;this.G(I.TunnelStates.connecting((0,p.localize)(1,null,$.accountLabel,$.providerId)));const q=(K,x)=>{K=K.replaceAll(U,"*".repeat(4)),w(K,x)},Z=this.O("login",["user","login","--provider",$.providerId,"--access-token",U,"--log",(0,R.$mj)(this.j.getLevel())],q);this.r=Z;try{if(await Z,this.r!==Z)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire($),this.G(I.TunnelStates.disconnected($));return}}const j=this.Q();j?this.G(I.TunnelStates.connecting((0,p.localize)(2,null,j))):this.G(I.TunnelStates.connecting((0,p.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,R.$mj)(this.j.getLevel())];j?F.push("--name",j):F.push("--random-name");let z=!1;return this.n.active&&this.n.asService&&!v&&(z=await this.M(F)===!1),this.N($,F,z)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,p.localize)(4,null);return this.j.warn(w),this.G(I.TunnelStates.connecting(w)),!1}return!0}async N(o,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const $=this.O("tunnel",v,(j,F)=>{F?this.j.error(j):this.j.info(j),j.includes("Connected to an existing tunnel process")&&(f=!0);const z=j.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(z){const U={link:z[1],domain:z[2],tunnelName:z[4],isAttached:f};this.G(I.TunnelStates.connected(U,w))}else j.match(/error refreshing token/)&&($.cancel(),this.f.fire(o),this.G(I.TunnelStates.disconnected(o)))});this.r=$,$.finally(()=>{$===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$58b,this.G(I.TunnelStates.disconnected()))})}O(o,v,w=this.I){return(0,m.$Hg)(f=>new Promise(($,j)=>{f.isCancellationRequested&&$(-1);let F;const z=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{F&&(this.j.info(`${o} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:z});else{w(`Running tunnel CLI
`,!1);const U=this.J();w(`${o} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),F=(0,g.spawn)(U,["tunnel",...v],{cwd:(0,y.homedir)(),stdio:z})}F.stdout.pipe(new u.$fT(`
`)).on("data",U=>{if(F){const q=U.toString();w(q,!1)}}),F.stderr.pipe(new u.$fT(`
`)).on("data",U=>{if(F){const q=U.toString();w(q,!0)}}),F.on("exit",U=>{F&&(w(`${o} exit(${F.pid}): + ${U} `,!1),F=void 0,$(U||0))}),F.on("error",U=>{F&&(w(`${o} error(${F.pid}): + ${U} `,!0),F=void 0,j())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$88b)}Q(){let o=this.D.getValue(I.$78b)||(0,y.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const w=JSON.parse(o);if(w&&(0,h.$yf)(w.accountLabel)&&(0,h.$yf)(w.sessionId)&&(0,h.$yf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(o){this.j.error("Problems restoring session from storage",o)}return I.$58b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$b9b=n,e.$b9b=n=ye([Y(0,N.$cl),Y(1,C.$pj),Y(2,A.$Xh),Y(3,R.$$i),Y(4,c.$_8b),Y(5,d.$ji),Y(6,l.$6o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(oe[250],ae([0,1,6,2,23,19,67,21,76,17]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=void 0;class C extends R.$8o{constructor(m,c,d,p){super(),this.bb=m,this.cb=c,this.db=d,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Rc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Rc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new k.$9Cb(this.db.getChannel("storage"))),c=this.B(new D.$2o(m));return this.B(c.onDidChangeStorage(d=>this.u(-1,d))),c}gb(m){this.X.clear(),this.W=m;let c;if((0,R.$9o)(m))c=this.U;else{const d=this.X.add(new k.$0Cb(this.db.getChannel("storage"),m));c=this.X.add(new D.$2o(d))}return this.X.add(c.onDidChangeStorage(d=>this.u(0,d))),c}hb(m){this.$.clear(),this.Z=m?.id;let c;if(m){const d=this.$.add(new k.$$Cb(this.db.getChannel("storage"),m));c=this.$.add(new D.$2o(d)),this.$.add(c.onDidChangeStorage(p=>this.u(1,p)))}return c}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$vg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const c=this.Y,d=c.items;c!==this.U&&await c.close(),this.Y=this.gb(m),await this.Y.init(),this.N(d,this.Y,0)}async S(m,c){const d=this.ab,p=d?.items??new Map;await d?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(p,this.ab,1)}hasScope(m){return(0,g.$Jk)(m)?this.W.id===m.id:this.Z===m.id}}e.$g9b=C}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=void 0;class D{constructor(g,C){this.a=g,this.b=C}listen(g,C){const E=this.b(g);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(c=>(0,A.$Nm)({...c},E)),added:m.added.map(c=>(0,A.$Nm)({...c},E)),removed:m.removed.map(c=>(0,A.$Nm)({...c},E)),updated:m.updated.map(c=>(0,A.$Nm)({...c},E))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,E){const m=this.b(g);switch(C){case"createProfile":{const c=await this.a.createProfile(E[0],E[1],E[2]);return(0,A.$Nm)({...c},m)}case"updateProfile":{let c=(0,N.$Lk)((0,A.$Om)(E[0],m),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,E[1]),(0,A.$Nm)({...c},m)}case"removeProfile":{const c=(0,N.$Lk)((0,A.$Om)(E[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${C}`)}}e.$KN=D;class R extends L.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new I.$Nd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(m=>(0,N.$Lk)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const c=m.added.map(y=>(0,N.$Lk)(y,this.profilesHome.scheme)),d=m.removed.map(y=>(0,N.$Lk)(y,this.profilesHome.scheme)),p=m.updated.map(y=>(0,N.$Lk)(y,this.profilesHome.scheme));this.a=m.all.map(y=>(0,N.$Lk)(y,this.profilesHome.scheme)),this.b.fire({added:c,removed:d,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,E){const m=await this.f.call("createNamedProfile",[g,C,E]);return(0,N.$Lk)(m,this.profilesHome.scheme)}async createProfile(g,C,E,m){const c=await this.f.call("createProfile",[g,C,E,m]);return(0,N.$Lk)(c,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,N.$Lk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const E=await this.f.call("updateProfile",[g,C]);return(0,N.$Lk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$LN=R}),define(oe[58],ae([0,1,2,67,4,21,3,76,17]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cDb=e.$bDb=e.$aDb=void 0,e.$aDb=(0,N.$Ph)("IUserDataProfileStorageService");let g=class extends I.$Sc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async d=>this.b(d))}async updateStorageData(c,d,p){return this.withProfileScopedStorageService(c,async y=>this.c(y,d,p))}async withProfileScopedStorageService(c,d){if(this.a.hasScope(c))return d(this.a);const p=await this.g(c),y=new E(p);try{await y.initialize();const l=await d(y);return await y.flush(),l}finally{y.dispose(),await this.f(p)}}b(c){const d=new Map,p=y=>{for(const l of c.keys(0,y))d.set(l,{value:c.get(l,0),target:y})};return p(0),p(1),d}c(c,d,p){c.storeAll(Array.from(d.entries()).map(([y,l])=>({key:y,value:l,scope:0,target:p})),!0)}async f(c){try{await c.close()}finally{(0,I.$Mc)(c)&&c.dispose()}}};e.$bDb=g,e.$bDb=g=ye([Y(0,A.$6o)],g);class C extends g{constructor(c,d,p,y){super(p),this.j=c;const l=c.getChannel("profileStorageListener"),h=this.B(new I.$Tc);this.h=this.B(new D.$Nd({onWillAddFirstListener:()=>{h.value=l.listen("onDidChange")(u=>{y.trace("profile storage changes",u),this.h.fire({targetChanges:u.targetChanges.map(b=>(0,k.$Lk)(b,d.profilesHome.scheme)),valueChanges:u.valueChanges.map(b=>({...b,profile:(0,k.$Lk)(b.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this.h.event}async g(c){const d=this.j.getChannel("storage");return(0,A.$9o)(c)?new R.$9Cb(d):new R.$0Cb(d,c)}}e.$cDb=C;class E extends A.$8o{constructor(c){super({flushInterval:100}),this.s=this.B(new L.$2o(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,21,7,17,72,58]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=void 0;let R=class extends D.$cDb{constructor(g,C,E,m){super(g,C,E,m)}};e.$X8b=R,e.$X8b=R=ye([Y(0,A.$j8b),Y(1,N.$Kk),Y(2,I.$6o),Y(3,L.$0i)],R)}),define(oe[39],ae([0,1,18,6,15,26,3,35,2,27,12,170,20,14,11,7,43,21,22,28,25,17]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Db=e.$6Db=e.$5Db=e.$4Db=e.$3Db=e.$2Db=e.$1Db=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$1Db=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$2Db=a;function n(v,w){return`${(0,g.$qf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$3Db=n;let i=class extends k.$Sc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,f,$,j,F,z,U,q,Z,K,x,H){super(),this.syncResource=w,this.collection=f,this.G=$,this.H=j,this.I=F,this.J=z,this.L=U,this.M=q,this.N=Z,this.O=K,this.P=x,this.c=null,this.m="idle",this.n=this.B(new D.$Nd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$Nd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$Rg(50)),this.w=this.B(new D.$Nd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=H.extUri,this.f=this.h.joinPath(j.userDataSyncHome,...(0,b.$Cgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,b.$Xgb),this.y=(0,b.$Dgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,j,this.h),this.j=(0,y.$_o)(j,$,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const f=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,f={}){await this.U(w,!0,this.ob(),f)}async preview(w,f,$={}){return this.U(w,!1,f,$)}async apply(w,f={}){try{this.F={...f};const $=await this.ab(w);return this.S($),this.c}finally{this.F={}}}async U(w,f,$,j){try{if(this.F={...j},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const z=await this.getLastSyncUserData(),U=await this.X(w,z);return F=await this.Y(U,z,f,$),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(w){const f=this.kb(w);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const $=await this.getLastSyncUserData(),j=await this.X(null,$),F=await this.W(j),z=await this.qb({ref:j.ref,syncData:f},$,F,this.ob(),A.CancellationToken.None),U=[];for(const q of z){const Z=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:K}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);U.push([q,{...Z,remoteChange:K!==0?K:2}])}await this.tb(j,$,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const f=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===f}async X(w,f){if(f){const $=w?w[this.resource]:void 0;if(f.ref===$||$===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(w,f,$,j){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new b.$Kgb((0,E.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,f,$,j)}catch(F){if(F instanceof b.$Kgb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,f,$,j);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(w,f,$,j)}throw F}}async Z(w,f,$,j){try{const F=await this.W(w),z=!F&&f===null&&this.gb()!==void 0,U=$&&!z;this.c||(this.c=(0,L.$Hg)(Z=>this.eb(w,f,F,U,j,Z)));let q=await this.c;if($&&z){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of q.resourcePreviews)q=await this.accept(Z.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":$?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(w){return await this.$(w,async f=>{const $=await this.rb(f,A.CancellationToken.None);await this.G.writeFile(f.previewResource,N.$be.fromString($?.content||""));const j=$&&!$.hasConflicts?await this.sb(f,f.previewResource,void 0,A.CancellationToken.None):void 0;return f.acceptResult=j,f.mergeState=$.hasConflicts?"conflict":j?"accepted":"preview",f.localChange=j?j.localChange:$.localChange,f.remoteChange=j?j.remoteChange:$.remoteChange,f}),this.c}async accept(w,f){return await this.$(w,async $=>{const j=await this.sb($,w,f,A.CancellationToken.None);return $.acceptResult=j,$.mergeState="accepted",$.localChange=j.localChange,$.remoteChange=j.remoteChange,$}),this.c}async discard(w){return await this.$(w,async f=>{const $=await this.rb(f,A.CancellationToken.None);return await this.G.writeFile(f.previewResource,N.$be.fromString($.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=$.localChange,f.remoteChange=$.remoteChange,f}),this.c}async $(w,f){if(!this.c)return;let $=await this.c;const j=$.resourcePreviews.findIndex(({localResource:F,remoteResource:z,previewResource:U})=>this.h.isEqual(F,w)||this.h.isEqual(z,w)||this.h.isEqual(U,w));j!==-1&&(this.c=(0,L.$Hg)(async F=>{const z=[...$.resourcePreviews];return z[j]=await f(z[j]),{...$,resourcePreviews:z}}),$=await this.c,this.cb($.resourcePreviews),$.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:$})=>$!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map($=>[$,$.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const f=w.filter(({mergeState:$})=>$==="conflict");(0,I.$ub)(this.s,f,($,j)=>this.h.isEqual($.previewResource,j.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const f=this.c?await this.c:null;if(f)for(const $ of f.resourcePreviews){if(this.h.isEqual($.acceptedResource,w))return $.acceptResult?$.acceptResult.content:null;if(this.h.isEqual($.remoteResource,w))return $.remoteContent;if(this.h.isEqual($.localResource,w))return $.localContent;if(this.h.isEqual($.baseResource,w))return $.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,d.$pk)(w)!==1&&this.O.error(w)}}async eb(w,f,$,j,F,z){const U=await this.qb(w,f,$,F,z),q=[];for(const Z of U){const K=Z.previewResource.with({scheme:b.$Wgb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)q.push({...Z,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=j?await this.rb(Z,z):void 0;if(z.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,N.$be.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,z):void 0;q.push({...Z,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Z.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:$}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(w),$=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!$&&f.version!==$,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${$}.`),await this.resetLocal(),null;let j,F=1;for(;j===void 0&&F++<6;)try{const z=await this.hb();z&&(z.ref===f.ref?j=z.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof d.$tk&&z.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(z instanceof b.$Kgb)throw z;this.O.error(z,F)}}if(j===void 0)try{const z=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);j=z===null?null:this.kb(z),await this.ib({ref:f.ref,syncData:j})}catch(z){if(z instanceof b.$Kgb&&z.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw z}return j===void 0?null:{...f,syncData:j}}async fb(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const $=this.M.getResourceSyncStateVersion(this.resource),j={ref:w.ref,version:$,...f};this.I.store(this.z,JSON.stringify(j),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const f=w?JSON.parse(w):void 0;if(s(f))return f}catch(f){this.O.error(f)}}async ib(w){await this.G.writeFile(this.y,N.$be.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),f=JSON.parse(w.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(w){w instanceof d.$tk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:f,content:$}=await this.lb(w);let j=null;return $!==null&&(j=this.kb($)),{ref:f,syncData:j}}kb(w){try{const f=JSON.parse(w);if(a(f))return f}catch(f){this.O.error(f)}throw new b.$Kgb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const f=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(w,f){const $=await this.j,j={version:this.pb,machineId:$,content:w};try{return f=await this.J.writeResource(this.resource,JSON.stringify(j),f,this.collection,this.F),{ref:f,syncData:j}}catch(F){throw F instanceof b.$Kgb&&F.code==="TooLarge"&&(F=new b.$Kgb(F.message,F.code,this.resource)),F}}async nb(w){const f={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(b.$xgb)}};e.$4Db=i,e.$4Db=i=ye([Y(2,d.$$j),Y(3,c.$Wh),Y(4,l.$6o),Y(5,b.$Fgb),Y(6,b.$Ggb),Y(7,b.$Pgb),Y(8,h.$cl),Y(9,b.$Ugb),Y(10,m.$ji),Y(11,u.$Ik)],i);let t=class extends i{constructor(w,f,$,j,F,z,U,q,Z,K,x,H,Q){super(f,$,j,F,z,U,q,Z,K,x,H,Q),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,f,$){try{f?await this.G.writeFile(this.r,N.$be.fromString(w),$?void 0:f):await this.G.createFile(this.r,N.$be.fromString(w),{overwrite:$})}catch(j){throw j instanceof d.$tk&&j.fileOperationResult===1||j instanceof d.$tk&&j.fileOperationResult===3?new b.$Kgb(j.message,"LocalPreconditionFailed"):j}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof d.$tk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$5Db=t,e.$5Db=t=ye([Y(3,d.$$j),Y(4,c.$Wh),Y(5,l.$6o),Y(6,b.$Fgb),Y(7,b.$Ggb),Y(8,b.$Pgb),Y(9,h.$cl),Y(10,b.$Ugb),Y(11,m.$ji),Y(12,u.$Ik)],t);let r=class extends t{constructor(w,f,$,j,F,z,U,q,Z,K,x,H,Q,G){super(w,f,$,j,F,z,U,q,Z,K,x,Q,G),this.zb=H,this.Bb=void 0}Ab(w,f){const $=[],j=(0,R.$Wm)(w,$,{allowEmptyContent:!0,allowTrailingComma:!0});return $.length>0||!(0,C.$Ff)(j)&&f!==Array.isArray(j)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$6Db=r,e.$6Db=r=ye([Y(3,d.$$j),Y(4,c.$Wh),Y(5,l.$6o),Y(6,b.$Fgb),Y(7,b.$Ggb),Y(8,b.$Pgb),Y(9,h.$cl),Y(10,b.$Ugb),Y(11,b.$Tgb),Y(12,m.$ji),Y(13,u.$Ik)],r);let o=class{constructor(w,f,$,j,F,z,U){this.resource=w,this.g=f,this.h=$,this.j=j,this.k=F,this.l=z,this.d=U.extUri,this.f=(0,b.$Dgb)(void 0,this.resource,$,this.d)}async initialize({ref:w,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const $=this.m(f);if($)try{await this.o({ref:w,syncData:$})}catch(j){this.j.error(j)}}m(w){try{const f=JSON.parse(w);if(a(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const $={ref:w.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify($),-1,1),await this.k.writeFile(this.f,N.$be.fromString(JSON.stringify(w)))}};e.$7Db=o,e.$7Db=o=ye([Y(1,S.$Kk),Y(2,c.$Wh),Y(3,p.$0i),Y(4,d.$$j),Y(5,l.$6o),Y(6,u.$Ik)],o)}),define(oe[115],ae([0,1,6,26,8,3,41,2,27,20,14,114,29,33,81,44,11,4,71,7,21,22,28,17,39,232,111,25,58]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D3b=e.$C3b=e.$B3b=e.$A3b=e.$z3b=void 0;async function v(z,U){const q=JSON.parse(z.content);if(z.version===1||z.version===2){const Z=(await U.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of q)z.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),z.version===2&&Z.every(x=>!(0,c.$zo)(x.identifier,K.identifier))&&(K.installed=!0)}return q}function w(z){return JSON.parse(z.content)}e.$z3b=w;function f(z,U){return z.sort((q,Z)=>!q.identifier.uuid&&Z.identifier.uuid?-1:q.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$Ue)(q.identifier.id,Z.identifier.id)),U?(0,D.$ZS)(z,{}):JSON.stringify(z)}e.$A3b=f;let $=class extends n.$4Db{constructor(U,q,Z,K,x,H,Q,G,W,ee,ne,_,ie,X,B,P,O){super({syncResource:"extensions",profile:U},q,K,Z,x,H,Q,_,ie,ee,ne,B),this.Cb=G,this.Db=W,this.Eb=O,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Wgb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Wgb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Wgb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Wgb,authority:"accepted"}),this.Bb=this.Eb.createInstance(j),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,T=>T.some(({local:M})=>!!M)),A.Event.filter(this.Cb.onDidUninstallExtension,T=>!T.error),A.Event.filter(P.onDidChange,T=>T.valueChanges.some(({profile:M,changes:V})=>this.syncResource.profile.id===M.id&&V.some(J=>J.key===m.$ao))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,q){const Z=U.syncData?await v(U.syncData,this.Cb):null,K=q?.skippedExtensions??[],x=q?.builtinExtensions??null,H=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$y3b)(Q,Z,H,K,G,x),ne={local:W,remote:ee,content:this.Hb(Q,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:K,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const q=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$y3b)(Z,q,q,U.skippedExtensions||[],K,U.builtinExtensions||[]);return x!==null}Hb(U,q,Z,K){const x=[...q,...Z],H=new Set,Q=G=>{H.add(G.id.toLowerCase()),G.uuid&&H.add(G.uuid)};x.forEach(({identifier:G})=>Q(G)),K.forEach(Q);for(const G of U)H.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&H.has(G.identifier.uuid)||x.push(G);return this.Ob(x,!1)}async rb(U,q){return{...U.previewResult,hasConflicts:!1}}async sb(U,q,Z,K){if(this.h.isEqual(q,this.yb))return this.Kb(U);if(this.h.isEqual(q,this.zb))return this.Lb(U);if(this.h.isEqual(q,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(q),K=(0,i.$y3b)(U.localExtensions,null,null,U.skippedExtensions,Z,U.builtinExtensions),{local:x,remote:H}=K;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(q),K=U.remoteContent?JSON.parse(U.remoteContent):null;if(K!==null){const x=(0,i.$y3b)(U.localExtensions,K,U.localExtensions,[],Z,U.builtinExtensions),{local:H,remote:Q}=x;return{content:U.remoteContent,local:H,remote:Q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,q,Z,K){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Q}=Z[0][0];const{local:G,remote:W,localChange:ee,remoteChange:ne}=Z[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(W.all);U=await this.mb(_,K?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ie=>ie.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ie=>ie.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ie=>ie.identifier.id))}.`:""}`)}q?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Q,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,q){const Z=new Set,K=[];for(const x of U)Z.add(x.identifier.id.toLowerCase()),x.installed||K.push(x.identifier);if(q)for(const x of q)Z.has(x.id.toLowerCase())||K.push(x);return K}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const q=await this.db(U);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(U,q){return f(U,q)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$B3b=$,e.$B3b=$=ye([Y(2,C.$Wh),Y(3,y.$$j),Y(4,b.$6o),Y(5,r.$Fgb),Y(6,r.$Ggb),Y(7,m.$_n),Y(8,t.$LEb),Y(9,r.$Ugb),Y(10,g.$ji),Y(11,r.$Pgb),Y(12,S.$cl),Y(13,d.$Wu),Y(14,s.$Ik),Y(15,o.$aDb),Y(16,l.$Oh)],$);let j=class{constructor(U,q,Z,K,x,H){this.a=U,this.b=q,this.c=Z,this.d=K,this.f=x,this.g=H}async getLocalExtensions(U){const q=await this.a.getInstalled(void 0,U.extensionsResource),Z=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(U,async(x,H)=>{const Q=x.getDisabledExtensions();return q.map(G=>{const{identifier:W,isBuiltin:ee,manifest:ne,preRelease:_,pinned:ie,isApplicationScoped:X}=G,B={identifier:W,preRelease:_,version:ne.version,pinned:!!ie};X&&!(0,p.$9l)(ne)&&(B.isApplicationScoped=X),Q.some(P=>(0,c.$zo)(P,W))&&(B.disabled=!0),ee||(B.installed=!0);try{const P=H.getKeysForSync({id:W.id,version:ne.version});if(P){const O=H.getExtensionState(G,!0)||{};B.state=Object.keys(O).reduce((T,M)=>(P.includes(M)&&(T[M]=O[M]),T),{})}}catch(P){this.g.info(`${(0,n.$3Db)("extensions",U)}: Error while parsing extension state`,(0,N.$0)(P))}return B})}),ignoredExtensions:Z}}async updateLocalExtensions(U,q,Z,K,x){const H=(0,n.$3Db)("extensions",x),Q=[],G=new Map,W=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Z.length)&&await this.j(x,async(X,B)=>{await I.Promises.settled([...U,...Z].map(async P=>{const O=ne.find(V=>(0,c.$zo)(V.identifier,P.identifier));if(O&&O.isBuiltin){P.state&&O.manifest.version===P.version&&this.h(P.state,O,O.manifest.version,B),X.getDisabledExtensions().some(J=>(0,c.$zo)(J,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id),await X.disableExtension(P.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id),await X.enableExtension(P.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id))),W.push(P.identifier);return}const T=P.pinned?P.version:void 0,M=(await this.c.getExtensions([{...P.identifier,version:T,preRelease:T?void 0:P.preRelease}],L.CancellationToken.None))[0];if(P.state&&(O?O.manifest.version===P.version:M)&&this.h(P.state,O||M,O?.manifest.version,B),M)try{X.getDisabledExtensions().some(J=>(0,c.$zo)(J,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id,M.version),await X.disableExtension(M.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id,M.version)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id,M.version),await X.enableExtension(M.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id,M.version))),(!O||O.preRelease!==P.preRelease||O.pinned!==P.pinned||T&&O.manifest.version!==T)&&(await this.a.canInstall(M)?(Q.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[m.$1n]:!0,[m.$2n]:!0}}}),G.set(M.identifier.id.toLowerCase(),P)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),ee.push(P)))}catch(V){ee.push(P),this.g.error(V),this.g.info(`${H}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else ee.push(P),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),q.length){const X=ne.filter(({identifier:B,isBuiltin:P})=>!P&&q.some(O=>(0,c.$zo)(B,O)));await I.Promises.settled(X.map(async B=>{this.g.trace(`${H}: Uninstalling local extension...`,B.identifier.id),await this.a.uninstall(B,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,B.identifier.id),W.push(B.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:X,local:B,error:P,source:O}of _){const T=O;if(B)this.g.info(`${H}: Installed extension.`,X.id,T.version),W.push(X);else{const M=G.get(X.id.toLowerCase());M&&(ee.push(M),this.g.info(`${H}: Skipped synchronizing extension`,T.displayName||T.identifier.id)),P instanceof m.$$n&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,T.displayName||T.identifier.id):P&&this.g.error(P)}}const ie=[];for(const X of K)W.some(B=>(0,c.$zo)(B,X.identifier))||ie.push(X);for(const X of ee)ie.some(B=>(0,c.$zo)(B.identifier,X.identifier))||ie.push(X);return ie}h(U,q,Z,K){const x=K.getExtensionState(q,!0)||{},H=Z?K.getKeysForSync({id:q.identifier.id,version:Z}):void 0;H?H.forEach(Q=>{x[Q]=U[Q]}):Object.keys(U).forEach(Q=>x[Q]=U[Q]),K.setExtensionState(q,x,!0)}async j(U,q){return this.b.withProfileScopedStorageService(U,async Z=>{const K=new R.$Rc,x=this.f.createChild(new h.$Nh([b.$6o,Z])),H=K.add(x.createInstance(E.$yCb)),Q=K.add(x.createInstance(d.$Xu));try{return await q(H,Q)}finally{K.dispose()}})}};e.$C3b=j,e.$C3b=j=ye([Y(0,m.$_n),Y(1,o.$aDb),Y(2,m.$0n),Y(3,t.$LEb),Y(4,l.$Oh),Y(5,r.$Ugb)],j);let F=class extends n.$7Db{constructor(U,q,Z,K,x,H,Q,G){super("extensions",K,x,H,Z,Q,G),this.p=U,this.q=q}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,q){const Z=[],K=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Q=q.find(G=>(0,c.$zo)(G.identifier,H.identifier));Q?(Z.push(Q),H.disabled&&x.push(H.identifier)):H.installed&&(K.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Z,newExtensions:K,disabledExtensions:x,remoteExtensions:U}}};e.$D3b=F,e.$D3b=F=ye([Y(0,m.$_n),Y(1,t.$LEb),Y(2,y.$$j),Y(3,a.$Kk),Y(4,C.$Wh),Y(5,u.$0i),Y(6,b.$6o),Y(7,s.$Ik)],F)}),define(oe[116],ae([0,1,15,8,3,35,41,5,32,20,14,11,7,43,21,22,28,39,78,236,25,17,58,4]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aEb=e.$_Db=e.$$Db=e.$0Db=e.$9Db=void 0;const n="globalState.argv.",i=["locale"];function t($,j){const F=$.storage?Object.keys($.storage).sort():[],z={};return F.forEach(U=>z[U]=$.storage[U]),$.storage=z,j?(0,D.$ZS)($,{}):JSON.stringify($)}e.$9Db=t;const r=1;let o=class extends l.$4Db{constructor(j,F,z,U,q,Z,K,x,H,Q,G,W,ee,ne){super({syncResource:"globalState",profile:j},F,U,x,W,q,Z,H,Q,K,G,ee),this.Bb=z,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:b.$Wgb,authority:"base"}),this.xb=this.vb.with({scheme:b.$Wgb,authority:"local"}),this.yb=this.vb.with({scheme:b.$Wgb,authority:"remote"}),this.zb=this.vb.with({scheme:b.$Wgb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),N.Event.filter(z.onDidChange,_=>!!(_.targetChanges.some(ie=>this.syncResource.profile.id===ie.id)||_.valueChanges.some(({profile:ie,changes:X})=>this.syncResource.profile.id===ie.id&&X.some(B=>B.target===0)))))(()=>this.Q()))}async qb(j,F,z){const U=j.syncData?JSON.parse(j.syncData.content):null;F=F===null&&z?j:F;const q=F&&F.syncData?JSON.parse(F.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(q),{local:x,remote:H}=(0,u.$8Db)(Z.storage,U?U.storage:null,q?q.storage:null,K,this.O),Q={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},G=t(Z,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):G,localResource:this.xb,localContent:G,localUserData:Z,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(j){const F=j.syncData?JSON.parse(j.syncData.content):null;if(F===null)return!0;const z=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(F),{remote:q}=(0,u.$8Db)(z.storage,F.storage,F.storage,U,this.O);return q.all!==null}async rb(j,F){return{...j.previewResult,hasConflicts:!1}}async sb(j,F,z,U){if(this.h.isEqual(F,this.xb))return this.Gb(j);if(this.h.isEqual(F,this.yb))return this.Hb(j);if(this.h.isEqual(F,this.vb))return j.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(j){return{content:j.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(j.localUserData.storage),removed:[],updated:[],all:j.localUserData.storage},localChange:0,remoteChange:2}}async Hb(j){if(j.remoteContent!==null){const F=JSON.parse(j.remoteContent),{local:z,remote:U}=(0,u.$8Db)(j.localUserData.storage,F.storage,null,j.storageKeys,this.O);return{content:j.remoteContent,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:j.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(j,F,z,U){const{localUserData:q}=z[0][0],{local:Z,remote:K,localChange:x,remoteChange:H}=z[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:K.all});j=await this.mb(Q,U?null:j.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}F?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(j),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(j){if(this.h.isEqual(this.yb,j)||this.h.isEqual(this.wb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.zb,j)){const F=await this.db(j);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:j}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(j).length>1||j[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(j){const F=await this.Bb.readStorageData(this.syncResource.profile),z=[],U=[];for(const[K,x]of F)x.target===0?z.push(K):x.target===1&&U.push(K);const q=[...z,...U],Z=j?.storage?Object.keys(j.storage).filter(K=>!K.startsWith(n)&&!q.includes(K)&&F.get(K)!==void 0):[];if(!R.$p){const K=[...b.$Bgb.map(x=>(0,b.$Ogb)(x)),b.$Ngb];Z.push(...K),U.push(...K)}return{user:z,machine:U,unregistered:Z}}};e.$0Db=o,e.$0Db=o=ye([Y(2,s.$aDb),Y(3,E.$$j),Y(4,b.$Fgb),Y(5,b.$Ggb),Y(6,b.$Ugb),Y(7,C.$Wh),Y(8,b.$Pgb),Y(9,p.$cl),Y(10,g.$ji),Y(11,d.$6o),Y(12,y.$Ik),Y(13,a.$Oh)],o);let v=class{constructor(j,F,z,U){this.a=j,this.b=F,this.c=z,this.d=U}async getLocalGlobalState(j){const F={};if(j.isDefault){const U=await this.f(),q=(0,A.$Wm)(U);for(const Z of i)q[Z]!==void 0&&(F[`${n}${Z}`]={version:1,value:q[Z]})}const z=await this.c.readStorageData(j);for(const[U,q]of z)q.value&&q.target===0&&(F[U]={version:1,value:q.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const j=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),j.value.toString()}catch(j){this.d.debug((0,L.$0)(j))}return"{}"}async writeLocalGlobalState({added:j,removed:F,updated:z},U){const q=(0,l.$3Db)("globalState",U),Z={},K=new Map,x=await this.c.readStorageData(U),H=(Q,G)=>{for(const W of Q){if(W.startsWith(n)){Z[W.substring(n.length)]=G?G[W].value:void 0;continue}if(G){const ee=G[W];ee.value!==x.get(W)?.value&&K.set(W,ee.value)}else x.get(W)!==void 0&&K.set(W,void 0)}};if(H(Object.keys(j),j),H(Object.keys(z),z),H(F),Object.keys(Z).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let G=Q;for(const W of Object.keys(Z))G=(0,h.edit)(G,[W],Z[W],{});Q!==G&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$be.fromString(G)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}K.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(U,K,0),this.d.info(`${q}: Updated global state`,[...K.keys()]))}};e.$$Db=v,e.$$Db=v=ye([Y(0,E.$$j),Y(1,C.$Wh),Y(2,s.$aDb),Y(3,b.$Ugb)],v);let w=class extends l.$7Db{constructor(j,F,z,U,q,Z){super("globalState",z,U,q,F,j,Z)}async o(j){const F=j.syncData?JSON.parse(j.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},U={};for(const q of Object.keys(F.storage))q.startsWith(n)?z[q.substring(n.length)]=F.storage[q].value:this.l.get(q,0)===void 0&&(U[q]=F.storage[q].value);if(Object.keys(z).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(z))q=(0,h.edit)(q,[Z],z[Z],{});await this.k.writeFile(this.h.argvResource,I.$be.fromString(q))}if(Object.keys(U).length){const q=[];for(const Z of Object.keys(U))q.push({key:Z,value:U[Z],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$_Db=w,e.$_Db=w=ye([Y(0,d.$6o),Y(1,E.$$j),Y(2,S.$Kk),Y(3,C.$Wh),Y(4,b.$Ugb),Y(5,y.$Ik)],w);let f=class{constructor(j,F,z,U,q){this.a=j,this.b=F,this.c=z,this.d=U,this.f=q}getSyncStoreType(j){return this.h(j)?.storage[b.$Ngb]?.value}async sync(j){const F=(0,b.$Jgb)((0,k.$eg)());try{return await this.g(j,F)}catch(z){if(z instanceof b.$Kgb)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(j,F)}throw z}}async g(j,F){const z=await this.a.readResource("globalState",null,void 0,F),U=this.h(z)||{storage:{}};U.storage[b.$Ngb]={value:j,version:r};const q=await(0,c.$_o)(this.c,this.d,this.b),Z={version:r,machineId:q,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),z.ref,void 0,F)}h({content:j}){if(!j)return null;const F=JSON.parse(j);if((0,l.$2Db)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$aEb=f,e.$aEb=f=ye([Y(1,d.$6o),Y(2,C.$Wh),Y(3,E.$$j),Y(4,m.$0i)],f)}),define(oe[117],ae([0,1,18,15,3,35,5,12,171,20,14,11,21,22,28,17,39,233,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H3b=e.$G3b=e.$F3b=void 0;function u(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,R.$Ff)(i.all)?null:i.all;switch(D.OS){case 2:return(0,R.$Ff)(i.mac)?null:i.mac;case 3:return(0,R.$Ff)(i.linux)?null:i.linux;case 1:return(0,R.$Ff)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$F3b=u;let b=class extends y.$6Db{constructor(a,n,i,t,r,o,v,w,f,$,j,F,z){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,w,f,$,i,t,v,F,r,j,o,z),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:h.$Wgb,authority:"base"}),this.Gb=this.Eb.with({scheme:h.$Wgb,authority:"local"}),this.Hb=this.Eb.with({scheme:h.$Wgb,authority:"remote"}),this.Ib=this.Eb.with({scheme:h.$Wgb,authority:"accepted"}),this.B(N.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?u(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let f=null,$=!1,j=!1,F=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new h.$Kgb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,l.$E3b)(q,r,o,w,this.zb);Z.hasChanges&&(f=Z.mergeContent,F=Z.hasConflicts,$=F||Z.mergeContent!==q,j=F||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),j=!0);const z={content:F?o:f,localChange:$?v?2:1:0,remoteChange:j?2:0,hasConflicts:F},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:z.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:z.remoteChange,previewResource:this.Eb,previewResult:z,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,l.$E3b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:w}=i[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new h.$Kgb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(f,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,A.$Wm)(a.value.toString());if((0,I.$Lb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:u(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,D.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(h.$ygb)}};e.$G3b=b,e.$G3b=b=ye([Y(2,h.$Fgb),Y(3,h.$Ggb),Y(4,h.$Ugb),Y(5,g.$ji),Y(6,h.$Pgb),Y(7,E.$$j),Y(8,C.$Wh),Y(9,m.$6o),Y(10,h.$Tgb),Y(11,c.$cl),Y(12,d.$Ik)],b);let S=class extends y.$7Db{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$be.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Wm)(a.value.toString());return!(0,I.$Lb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return u(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$H3b=S,e.$H3b=S=ye([Y(0,E.$$j),Y(1,p.$Kk),Y(2,C.$Wh),Y(3,h.$Ugb),Y(4,m.$6o),Y(5,d.$Ik)],S)}),define(oe[118],ae([0,1,15,3,172,20,74,14,29,11,21,22,28,17,39,237,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=e.$J3b=e.$I3b=void 0;function l(S){return S&&S.settings&&typeof S.settings=="string"&&Object.keys(S).length===1}function h(S){const s=JSON.parse(S);return l(s)?s:{settings:S}}e.$I3b=h;let u=class extends d.$6Db{constructor(s,a,n,i,t,r,o,v,w,f,$,j,F,z){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,$,j,v,w,f,z),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.$Wgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$Wgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$Wgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$Wgb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new D.$Cn(y.$xgb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(y.$xgb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let w=null,f=!1,$=!1,j=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,p.$TCb)(q,r.settings,o?o.settings:null,v,[],t);w=Z.localContent||Z.remoteContent,f=Z.localContent!==null,$=Z.remoteContent!==null,j=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.Qb(w),$=!0);const F=i?i.value.toString():null,z=o?.settings??null,U={content:j?z:w,localChange:f?2:0,remoteChange:$?2:0,hasConflicts:j};return[{fileContent:i,baseResource:this.baseResource,baseContent:z,localResource:this.localResource,localContent:F,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$TCb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$SCb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,p.$SCb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$SCb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$SCb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),f=this.Lb(s),$=await this.Pb(r);r=(0,p.$SCb)(r,f?f.settings:"{}",$,w),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$UCb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,p.$SCb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return h(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),L.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,p.$QCb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new y.$Kgb((0,N.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$J3b=u,e.$J3b=u=ye([Y(2,g.$$j),Y(3,R.$Wh),Y(4,C.$6o),Y(5,y.$Fgb),Y(6,y.$Ggb),Y(7,y.$Ugb),Y(8,y.$Tgb),Y(9,A.$ji),Y(10,y.$Pgb),Y(11,E.$cl),Y(12,k.$_n),Y(13,m.$Ik)],u);let b=class extends d.$7Db{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$be.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$UCb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return h(s)}catch(a){this.j.error(a)}return null}};e.$K3b=b,e.$K3b=b=ye([Y(0,g.$$j),Y(1,c.$Kk),Y(2,R.$Wh),Y(3,y.$Ugb),Y(4,C.$6o),Y(5,m.$Ik)],b)}),define(oe[119],ae([0,1,15,3,30,20,14,11,21,22,28,17,39,234,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P3b=e.$O3b=e.$N3b=void 0;function p(h){return JSON.parse(h.content)}e.$N3b=p;let y=class extends m.$4Db{constructor(u,b,S,s,a,n,i,t,r,o,v,w){super({syncResource:"snippets",profile:u},b,s,S,a,n,i,o,v,t,r,w),this.pb=1,this.vb=u.snippetsHome,this.B(this.G.watch(S.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(u,b,S){const s=await this.Hb(),a=this.Gb(s),n=u.syncData?this.Fb(u.syncData):null;b=b===null&&S?u:b;const i=b&&b.syncData?this.Fb(b.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$L3b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(u){const b=u.syncData?this.Fb(u.syncData):null;if(b===null)return!0;const S=await this.Hb(),s=this.Gb(S),a=(0,c.$L3b)(s,b,b);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(u,b){return u.previewResult}async sb(u,b,S,s){if(this.h.isEqualOrParent(b,this.g.with({scheme:d.$Wgb,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(b,this.g.with({scheme:d.$Wgb,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(b,this.g))return S===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:S,localChange:S===null?u.fileContent!==null?3:0:2,remoteChange:S===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async tb(u,b,S,s){const a=S.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(u=await this.Eb(a,u,s)),b?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(u,b,S,s){const a=new Map;for(const n of Object.keys(u.local.added)){const i={content:u.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of Object.keys(u.local.updated)){const i={content:u.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of u.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of Object.keys(u.remote.added)){const i={content:u.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of Object.keys(u.remote.updated)){const i={content:u.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of u.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of u.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:b[n]?2:1,remoteChange:S[n]?2:1},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:b[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}for(const n of Object.keys(b))if(!a.has(n)){const i={content:b[n]?b[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"local"}),fileContent:b[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:d.$Wgb,authority:"accepted"})})}return[...a.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:d.$Wgb,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:d.$Wgb,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:d.$Wgb,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:d.$Wgb,authority:"accepted"}))?this.db(u):null}async hasLocalData(){try{const u=await this.Hb();if(Object.keys(u).length)return!0}catch{}return!1}async Cb(u){const b={};for(const S of u)S.fileContent&&(b[this.h.basename(S.localResource)]=S.fileContent);await this.nb(JSON.stringify(this.Gb(b)))}async Db(u,b){for(const{fileContent:S,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of u)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$be.fromString(s.content),{overwrite:b}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$be.fromString(s.content),b?void 0:S),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(u,b,S){const s=b.syncData?this.Fb(b.syncData):{},a=(0,N.$7m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of u)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,c.$M3b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),b=await this.mb(JSON.stringify(a),S?null:b.ref),this.O.info(`${this.D}: Updated remote snippets`)),b}Fb(u){return p(u)}Gb(u){const b={};for(const S of Object.keys(u))b[S]=u[S].value.toString();return b}async Hb(){const u={};let b;try{b=await this.G.resolve(this.vb)}catch(S){if(S instanceof R.$tk&&S.fileOperationResult===1)return u;throw S}for(const S of b.children||[]){const s=S.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);u[n]=i}}return u}};e.$O3b=y,e.$O3b=y=ye([Y(2,D.$Wh),Y(3,R.$$j),Y(4,k.$6o),Y(5,d.$Fgb),Y(6,d.$Ggb),Y(7,d.$Ugb),Y(8,A.$ji),Y(9,d.$Pgb),Y(10,g.$cl),Y(11,C.$Ik)],y);let l=class extends m.$7Db{constructor(u,b,S,s,a,n){super("snippets",b,S,s,u,a,n)}async o(u){const b=u.syncData?JSON.parse(u.syncData.content):null;if(!b){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(b)){const a=b[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,I.$be.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(u)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.$P3b=l,e.$P3b=l=ye([Y(0,R.$$j),Y(1,E.$Kk),Y(2,D.$Wh),Y(3,d.$Ugb),Y(4,k.$6o),Y(5,C.$Ik)],l)}),define(oe[120],ae([0,1,15,20,14,11,21,22,28,17,39,25]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S3b=e.$R3b=e.$Q3b=void 0;function m(y,l){try{return JSON.parse(y).tasks??null}catch(h){return l.error(h),null}}e.$Q3b=m;let c=class extends C.$5Db{constructor(l,h,u,b,S,s,a,n,i,t,r,o){super(l.tasksResource,{syncResource:"tasks",profile:l},h,n,i,t,u,b,a,r,S,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Wgb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Wgb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Wgb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Wgb,authority:"accepted"})}async qb(l,h,u,b){const S=l.syncData?m(l.syncData.content,this.O):null;h=h===null&&u?l:h;const s=h?.syncData?m(h.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(l.syncData){const w=a?a.value.toString():null;if(!s||s!==w||s!==S){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(w,S,s);n=f.content,r=f.hasConflicts,i=f.hasLocalChanged,t=f.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:S,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(l){const h=l?.syncData?m(l.syncData.content,this.O):null;if(h===null)return!0;const u=await this.vb(),b=u?u.value.toString():null,S=p(b,h,h);return S.hasLocalChanged||S.hasRemoteChanged}async rb(l,h){return l.previewResult}async sb(l,h,u,b){if(this.h.isEqual(h,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(h,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(h,this.Ab))return u===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async tb(l,h,u,b){const{fileContent:S}=u[0][0],{content:s,localChange:a,remoteChange:n}=u[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),S&&await this.nb(JSON.stringify(this.Kb(S.value.toString()))),s?await this.wb(s,S,b):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));l=await this.mb(i,b?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}h?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$R3b=c,e.$R3b=c=ye([Y(2,E.$Fgb),Y(3,E.$Ggb),Y(4,E.$Ugb),Y(5,L.$ji),Y(6,E.$Pgb),Y(7,A.$$j),Y(8,N.$Wh),Y(9,D.$6o),Y(10,R.$cl),Y(11,k.$Ik)],c);let d=class extends C.$7Db{constructor(l,h,u,b,S,s){super("tasks",h,u,b,l,S,s),this.c=this.g.defaultProfile.tasksResource}async o(l){const h=l.syncData?m(l.syncData.content,this.j):null;if(!h){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$be.fromString(h)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$S3b=d,e.$S3b=d=ye([Y(0,A.$$j),Y(1,g.$Kk),Y(2,N.$Wh),Y(3,E.$Ugb),Y(4,D.$6o),Y(5,k.$Ik)],d);function p(y,l,h){if(y===null&&l===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=h!==y,b=h!==l;return!u&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!b?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!u?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,20,14,11,21,22,28,17,39,235,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=e.$v5b=e.$u5b=void 0;let c=class extends C.$4Db{constructor(l,h,u,b,S,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:l},h,b,S,s,a,n,r,o,i,t,v),this.vb=u,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$Wgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$Wgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$Wgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$Wgb,authority:"accepted"}),this.B(u.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const h=await this.getLastSyncUserData(),u=await this.X(l,h);return u?.syncData?p(u.syncData):null}async qb(l,h,u){if(!this.vb.isEnabled())throw new m.$Kgb("Cannot sync profiles because they are disabled","LocalError");const b=l.syncData?p(l.syncData):null,S=h?.syncData?p(h.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$t5b)(s,b,S,[]),i={local:a,remote:n,content:S?this.Eb(S):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=d(s,!1);return[{baseResource:this.baseResource,baseContent:S?this.Eb(S):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:b?this.Eb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const h=l?.syncData?p(l.syncData):null,u=this.Db(),{remote:b}=(0,E.$t5b)(u,h,h,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async rb(l,h){return{...l.previewResult,hasConflicts:!1}}async sb(l,h,u,b){if(this.h.isEqual(h,this.localResource))return this.Ab(l);if(this.h.isEqual(h,this.remoteResource))return this.Bb(l);if(this.h.isEqual(h,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async Ab(l){const h=this.Db(),u=(0,E.$t5b)(h,null,null,[]),{local:b,remote:S}=u;return{content:l.localContent,local:b,remote:S,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:S!==null?2:0}}async Bb(l){const h=l.remoteContent?JSON.parse(l.remoteContent):null,u=[],b=[];for(const S of this.Db()){const s=h?.find(a=>a.id===S.id);s&&(u.push({id:S.id,name:S.name,collection:s.collection}),b.push(S))}if(h!==null){const S=(0,E.$t5b)(b,h,u,[]),{local:s,remote:a}=S;return{content:l.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,h,u,b){const{local:S,remote:s,localChange:a,remoteChange:n}=u[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=u[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new m.$Kgb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(d(this.Db(),!1));const t=[];for(const r of S.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of S.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of S.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:w})=>o.id===w);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{l=await this.updateRemoteProfiles(i,b?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}h?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,h){return this.mb(this.Eb(l),h)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const h=await this.db(l);return h&&(0,I.$ZS)(JSON.parse(h),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((h,u)=>h.name.localeCompare(u.name)))}};e.$u5b=c,e.$u5b=c=ye([Y(2,g.$Kk),Y(3,A.$$j),Y(4,N.$Wh),Y(5,D.$6o),Y(6,m.$Fgb),Y(7,m.$Ggb),Y(8,m.$Ugb),Y(9,L.$ji),Y(10,m.$Pgb),Y(11,R.$cl),Y(12,k.$Ik)],c);function d(y,l){const h=[...y].sort((u,b)=>u.name.localeCompare(b.name)).map(u=>({id:u.id,name:u.name}));return l?(0,I.$ZS)(h,{}):JSON.stringify(h)}e.$v5b=d;function p(y){return JSON.parse(y.content)}e.$w5b=p}),define(oe[253],ae([0,1,3,2,5,14,21,22,25]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h5b=void 0;const g="sync.enable";let C=class extends L.$Sc{constructor(m,c,d,p){super(),this.c=m,this.f=c,this.g=d,this.h=p,this.a=new I.$Nd,this.onDidChangeEnablement=this.a.event,this.b=new I.$Nd,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new L.$Rc))(y=>this.m(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:m}),this.c.store(g,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,k.$Ogb)(m),-1,!0)}setResourceEnablement(m,c){if(this.isResourceEnabled(m)!==c){const d=(0,k.$Ogb)(m);this.j(d,c)}}getResourceSyncStateVersion(m){}j(m,c){this.c.store(m,c,-1,N.$p?0:1)}m(m){if(g===m.key){this.a.fire(this.isEnabled());return}const c=k.$Bgb.filter(d=>(0,k.$Ogb)(d)===m.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$h5b=C,e.$h5b=C=ye([Y(0,D.$6o),Y(1,R.$cl),Y(2,A.$Wh),Y(3,k.$Egb)],C)}),define(oe[254],ae([0,1,6,15,63,2,19,20,14,11,17,25]),function(te,e,I,L,N,A,D,R,k,g,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s5b=void 0;let m=class extends A.$Sc{constructor(d,p,y,l,h){super(),this.a=d,this.b=p,this.c=y,this.f=l,this.g=h,this.h()}async h(){for(const p of this.g.profiles)for(const y of E.$Bgb)try{await this.m(this.j(y,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,g.$pk)(p)!==1&&this.f.error(p);return}if(d.children){for(const p of d.children)if(p.isDirectory&&!this.g.profiles.some(y=>y.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(y){this.f.error(y)}}}async getAllResourceRefs(d,p,y){const l=this.j(d,p,y);try{const h=await this.b.resolve(l);if(h.children)return h.children.filter(b=>b.isFile&&!b.name.startsWith("lastSync")).sort().reverse().map(b=>({ref:b.name,created:this.n(b)}))}catch(h){if((0,g.$pk)(h)!==1)throw h}return[]}async resolveResourceContent(d,p,y,l){const h=this.j(d,y,l),u=(0,D.$vg)(h,p);try{return(await this.b.readFile(u)).value.toString()}catch(b){return this.f.error(b),null}}async writeResource(d,p,y,l,h){const u=this.j(d,l,h),b=(0,D.$vg)(u,`${(0,N.$em)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(b,L.$be.fromString(p))}catch(S){this.f.error(S)}}j(d,p,y=this.a.userDataSyncHome){return(0,D.$vg)(y,...p?[p,d]:[d])}async m(d){try{try{if(!await this.b.exists(d))return}catch{return}const p=await this.b.resolve(d);if(p.children){const y=p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let h=y.filter(b=>Date.now()-this.n(b)>l);const u=y.length-h.length;u<10&&(h=h.slice(10-u)),await I.Promises.settled(h.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(p){this.f.error(p)}}n(d){return new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$s5b=m,e.$s5b=m=ye([Y(0,k.$Wh),Y(1,g.$$j),Y(2,R.$ji),Y(3,E.$Ugb),Y(4,C.$Kk)],m)}),define(oe[82],ae([0,1,3,2,5,27,176,14,11,4,24,43,21,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$ugb=e.$tgb=e.$sgb=void 0,e.$sgb=(0,g.$Ph)("IUserDataSyncMachinesService");const p="sync.currentMachineName",y="Safari",l="Chrome",h="Edge",u="Firefox",b="Android";function S(n){switch(n){case y:case l:case h:case u:case b:case(0,N.$i)(0):return!0}return!1}e.$tgb=S;function s(){return N.$G?y:N.$E?l:N.$H?h:N.$F?u:N.$I?b:(0,N.$i)(N.$p?0:N.$u)}let a=class extends L.$Sc{static{d=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,w){super(),this.h=r,this.j=o,this.m=v,this.n=w,this.c=this.B(new I.$Nd),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$_o)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:w})=>w===i);if(v){v.name=t,await this.t(o);const w=await this.f;i===w&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$Fe)(r)}\\s#(\\d+)`);let v=0;for(const w of i){const f=o.exec(w.name),$=f?parseInt(f[1]):0;v=$>v?$:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==d.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(d.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[d.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(d.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:d.a,machines:[]}}};e.$ugb=a,e.$ugb=a=d=ye([Y(0,R.$Wh),Y(1,k.$$j),Y(2,m.$6o),Y(3,c.$Fgb),Y(4,c.$Ugb),Y(5,C.$pj)],a)}),define(oe[255],ae([0,1,6,63,38,8,3,2,5,19,10,173,24,21,22,25,79,82]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y5b=void 0;const h="sync.disableMachineEventually",u="sync.sessionId",b="sync.storeUrl",S="sync.productQuality";let s=class extends R.$Sc{get n(){const i=this.H.get(b,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(b,i.toString(),-1,1):this.H.remove(b,-1)}get s(){return this.H.get(S,-1)}set s(i){i?this.H.store(S,i,-1,1):this.H.remove(S,-1)}constructor(i,t,r,o,v,w,f,$,j,F){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=w,this.D=f,this.F=$,this.G=j,this.H=F,this.a=this.B(new R.$Tc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$Nd),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Rg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$og)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$em)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(u,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$Kgb.toUserDataSyncError(i);t instanceof p.$Mgb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(h,!0,-1,1),await(0,I.$Ug)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(h,-1,!1)}R(){this.H.remove(h,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$y5b=s,e.$y5b=s=ye([Y(0,m.$pj),Y(1,p.$Egb),Y(2,p.$Fgb),Y(3,p.$Pgb),Y(4,p.$Qgb),Y(5,p.$Ugb),Y(6,y.$ACb),Y(7,d.$cl),Y(8,l.$sgb),Y(9,c.$6o)],s);class a extends R.$Sc{static{this.a="Interval"}constructor(i,t,r,o,v,w,f,$,j){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=w,this.y=f,this.z=$,this.C=j,this.b=this.B(new R.$Tc),this.c=this.B(new D.$Nd),this.onDidStartSync=this.c.event,this.f=this.B(new D.$Nd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Qc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,I.$Vg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,I.$Hg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$4)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$og)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,g.$og)(t.defaultUrl,i.defaultUrl)||!(0,g.$og)(t.insidersUrl,i.insidersUrl)||!(0,g.$og)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,p.$Kgb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch(w){this.y.error(w),o=w}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$Mgb((0,E.localize)(0,null),"DefaultServiceChanged"):new p.$Mgb((0,E.localize)(1,null),"ServiceChanged"):new p.$Mgb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(u,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$Mgb((0,E.localize)(3,null),"DefaultServiceChanged"):new p.$Mgb((0,E.localize)(4,null),"ServiceChanged"):new p.$Mgb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(f=>f.isCurrent);if(v?.disabled)throw new p.$Mgb((0,E.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$Mgb((0,N.$Ai)(f),f instanceof p.$Kgb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(u,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(oe[256],ae([0,1,10,177,14,11,43,21,28,25,17,39,119,118,117,20,120,115,116,4,121,41,27]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,w,f,$,j,F,z){this.e=t,this.f=r,this.g=o,this.h=w,this.i=f,this.j=$,this.k=j,this.l=F,this.n=z,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,b.$w5b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,b.$w5b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:w,ref:f})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,D.$_o)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,w){if(t){const{content:f}=await this.M(r,v,o);return f}return this.f.resolveResourceContent(r,v,o,w)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$I3b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,d.$F3b)(t.content,!!this.l.getValue(g.$ygb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,y.$Q3b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const w=(0,m.$N3b)(v),f=[];for(const $ of Object.keys(w)){const j=this.d.joinPath(t,$),F=r?this.d.joinPath(r.snippetsHome,$):this.d.joinPath(t,a.a);f.push({resource:j,comparableResource:F})}return f}}return[]}z(t,r){return(0,m.$N3b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$A3b)((0,l.$z3b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$C3b).getLocalExtensions(t);return(0,l.$A3b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,h.$9Db)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(h.$$Db).getLocalGlobalState(t);return(0,h.$9Db)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,S.$ZS)(JSON.parse(t.content),{})}return null}async I(t){return(0,b.$v5b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$Ie)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(I.URI.from({scheme:g.$Wgb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==g.$Wgb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,w;const f=[];let $,j,F,z,U;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?w=q.substring(10):q.startsWith("syncResource:")?$=q.substring(13):q.startsWith("profile:")?j=q.substring(8):q.startsWith("collection:")?F=q.substring(11):q.startsWith("ref:")?z=q.substring(4):$?U=q:f.push(q)}return{remote:o,syncResource:$,profile:j,collection:F,ref:z,node:U,location:v&&w!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$2Db)(o))return o}catch(o){this.g.error(o)}throw new g.$Kgb((0,L.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$05b=n,e.$05b=n=a=ye([Y(0,g.$Fgb),Y(1,g.$Ggb),Y(2,g.$Ugb),Y(3,k.$Ik),Y(4,N.$Wh),Y(5,R.$6o),Y(6,A.$$j),Y(7,C.$Kk),Y(8,p.$ji),Y(9,u.$Oh)],n)}),define(oe[257],ae([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Sc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor($,j,F,z,U,q,Z,K,x,H,Q){super(),this.C=$,this.D=j,this.F=F,this.G=z,this.H=U,this.I=q,this.J=Z,this.L=K,this.M=x,this.N=H,this.O=Q,this.f="uninitialized",this.g=this.B(new D.$Nd),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$Nd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$Nd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$Nd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$Nd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$Nd),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$Nd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Qc)(()=>this.bb()))}async createSyncTask($,j){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),z=(0,C.$eg)();try{const K=(0,i.$Jgb)(z);j&&(K["Cache-Control"]="no-cache"),$=await this.D.manifest($,K)}catch(K){const x=i.$Kgb.toUserDataSyncError(K);throw w(x,z,this.F,this.I),x}const U=!1,q=this;let Z;return{manifest:$,async run(){if(U)throw new Error("Can run a task only once");Z=(0,L.$Hg)(K=>q.P($,!1,z,K)),await Z.finally(()=>Z=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),q.$()},stop(){return Z?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Kgb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const $=new Date().getTime(),j=(0,C.$eg)(),F=(0,i.$Jgb)(j);let z;try{z=await this.D.manifest(null,F)}catch(Z){const K=i.$Kgb.toUserDataSyncError(Z);throw w(K,j,this.F,this.I),K}await this.resetLocal();const U=this,q=new N.$Xd;return{id:j,async merge(){return U.P(z,!0,j,q.token)},async apply(){try{try{await U.R(z,j,q.token)}catch(Z){if(i.$Kgb.toUserDataSyncError(Z).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(z,j,q.token);else throw Z}}catch(Z){throw U.H.error(Z),Z}U.H.info(`Sync done. Took ${new Date().getTime()-$}ms`),U.$()},async stop(){q.cancel(),await U.U(),await U.resetLocal()}}}async P($,j,F,z){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,$,j,F,z));const q=U.enabled.find(Z=>Z.resource==="profiles");if(q){const Z=await q.getLastSyncedProfiles()||[];if(z.isCancellationRequested)return;await this.Q(Z,$,j,F,z)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q($,j,F,z,U){for(const q of $){if(U.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===q.id);if(!Z){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const K=this.getOrCreateActiveProfileSynchronizer(Z,q);this.n.push(...await this.S(K,j,F,z,U))}for(const[q,Z]of this.z.entries())this.M.profiles.some(K=>K.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(q))}async R($,j,F){const z=this.ab();for(const x of z){if(F.isCancellationRequested)return;await x.apply(j,F)}const U=z.find(x=>x.profile.isDefault);if(!U)return;const q=U.enabled.find(x=>x.resource==="profiles");if(!q)return;const K=(await q.getRemoteSyncedProfiles($?.latest??null)||[]).filter(x=>z.every(H=>H.profile.id!==x.id));K.length&&await this.Q(K,$,!1,j,F)}async S($,j,F,z,U){return(await $.sync(j,F,z,U)).map(([Z,K])=>({profile:$.profile,syncResource:Z,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map($=>$.stop()))}async resolveContent($){const j=await this.N.resolveContent($);if(j)return j;for(const F of this.ab())for(const z of F.enabled){const U=await z.resolveContent($);if(U)return U}return null}async replace($){this.cb();const j=this.N.resolveUserDataSyncResource($);if(!j)return;const F=await this.resolveContent($.uri);F&&await this.W(j.profile,async z=>{if(j.syncResource===z.resource)return await z.replace(F),!0})}async accept($,j,F,z){this.cb(),await this.W($.profile,async U=>{if($.syncResource===U.resource)return await U.accept(j,F),z&&await U.apply((0,g.$Ef)(z)?!1:z.force,(0,i.$Jgb)((0,C.$eg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch($){this.H.error($)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[$]of this.z.values())try{await $.resetLocal()}catch(j){this.H.error(j)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const $=await this.N.getRemoteSyncedProfiles(),j=$.map(q=>q.collection),F=await this.D.getAllCollections(),z=F.filter(q=>!j.includes(q));z.length&&(this.H.info(`Deleting ${z.length} redundant collections on server`),await Promise.allSettled(z.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const U=$.filter(q=>F.includes(q.collection));if(U.length!==$.length){const q=this.G.createInstance(n.$u5b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData($){this.cb();const j=await this.D.getActivityData();await this.C.writeFile($,j)}async extractActivityData($,j){const F=(await this.C.readFile($)).value.toString(),z=JSON.parse(F);if(z.resources)for(const U in z.resources)for(const q of z.resources[U])await this.O.writeResource(U,q.content,new Date(q.created*1e3),void 0,j);if(z.collections)for(const U in z.collections)for(const q in z.collections[U].resources)for(const Z of z.collections[U].resources?.[q]??[])await this.O.writeResource(q,Z.content,new Date(Z.created*1e3),U,j)}async W($,j){const F=new R.$Rc;try{const z=this.z.get($.id);if(z){const x=await this.X(z[0],j,F);return(0,g.$Ff)(x)?null:x}if($.isDefault){const x=F.add(this.G.createInstance(o,$,void 0)),H=await this.X(x,j,F);return(0,g.$Ff)(H)?null:H}if(this.M.isEnabled())return null;const U=F.add(this.G.createInstance(n.$u5b,$,void 0)),q=await this.D.manifest(null),K=(await U.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===$.id);if(K){const x=F.add(this.G.createInstance(o,$,K.collection)),H=await this.X(x,j,F);return(0,g.$Ff)(H)?null:H}return null}finally{F.dispose()}}async X($,j,F){const z=[...$.enabled,...$.disabled.reduce((U,q)=>(q!=="workspaceState"&&U.push(F.add($.createSynchronizer(q))),U),[])];for(const U of z){const q=await j(U);if(!(0,g.$Ff)(q))return q}}Y($){const j=this.f;this.f!==$&&(this.f=$,this.g.fire($),j==="hasConflicts"&&this.$())}Z(){const $=this.ab().map(j=>j.conflicts).flat();(0,I.$ub)(this.j,$,(j,F)=>j.profile.id===F.profile.id&&j.syncResource===F.syncResource&&(0,I.$ub)(j.conflicts,F.conflicts,(z,U)=>(0,k.$og)(z.previewResource,U.previewResource)))||(this.j=$,this.m.fire($))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer($,j){let F=this.z.get($.id);if(F&&F[0].collection!==j?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete($.id)),!F){const z=new R.$Rc,U=z.add(this.G.createInstance(o,$,j?.collection));z.add(U.onDidChangeStatus(q=>this.Y(q))),z.add(U.onDidChangeConflicts(q=>this.Z())),z.add(U.onDidChangeLocal(q=>this.h.fire(q))),this.z.set($.id,F=[U,z])}return F[0]}ab(){const $=[];for(const[j]of this.z.values())$.push(j);return $}bb(){this.z.forEach(([,$])=>$.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$x5b=r,e.$x5b=r=ye([Y(0,c.$$j),Y(1,i.$Fgb),Y(2,i.$Egb),Y(3,d.$Oh),Y(4,i.$Ugb),Y(5,y.$cl),Y(6,p.$6o),Y(7,i.$Pgb),Y(8,l.$Kk),Y(9,i.$Rgb),Y(10,i.$Ggb)],r);let o=class extends R.$Sc{get enabled(){return this.f.sort(($,j)=>$[1]-j[1]).map(([$])=>$)}get disabled(){return i.$Bgb.filter($=>!this.r.isResourceEnabled($))}get status(){return this.g}get conflicts(){return this.m}constructor($,j,F,z,U,q,Z,K,x,H){super(),this.profile=$,this.collection=j,this.r=F,this.t=z,this.u=U,this.w=q,this.y=Z,this.z=K,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new D.$Nd),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$Nd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$Nd),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([Q,G])=>this.F(Q,G))),this.B((0,R.$Qc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$Bgb)F.isResourceEnabled(Q)&&this.G(Q)}F($,j){j?this.G($):this.H($)}G($){if(this.f.some(([U])=>U.resource===$))return;if($==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if($==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||$==="workspaceState")return;if($!=="profiles"&&this.profile.useDefaultFlags?.[$]){this.z.debug(`Skipping syncing ${$} in ${this.profile.name} because it is already synced by default profile`);return}const j=new R.$Rc,F=j.add(this.createSynchronizer($));j.add(F.onDidChangeStatus(()=>this.L())),j.add(F.onDidChangeConflicts(()=>this.M())),j.add(F.onDidChangeLocal(()=>this.j.fire($)));const z=this.N($);this.f.push([F,z,j])}H($){const j=this.f.findIndex(([F])=>F.resource===$);if(j!==-1){const[[F,,z]]=this.f.splice(j,1);z.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer($){switch($){case"settings":return this.t.createInstance(S.$J3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(b.$G3b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$O3b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$R3b,this.profile,this.collection);case"globalState":return this.t.createInstance(u.$0Db,this.profile,this.collection);case"extensions":return this.t.createInstance(h.$B3b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$u5b,this.profile,this.collection)}}async sync($,j,F,z){if(z.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const q=[],Z=(0,i.$Jgb)(F),K=(this.collection?$?.collections?.[this.collection]?.latest:$?.latest)??null,x=j?await this.I(K):{};for(const H of U){if(z.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(j){const Q=await H.preview(K,x,Z);if(Q)for(const G of Q.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await H.merge(G.previewResource)}else await H.sync(K,Z)}catch(Q){const G=i.$Kgb.toUserDataSyncError(Q);if(w(G,F,this.w,this.y),v(Q))throw G;this.z.error(Q),this.z.error(`${H.resource}: ${(0,A.$Ai)(Q)}`),q.push([H.resource,G])}}return q}finally{this.L()}}async apply($,j){const F=(0,i.$Jgb)($);for(const z of this.enabled){if(j.isCancellationRequested)return;try{await z.apply(!1,F)}catch(U){const q=i.$Kgb.toUserDataSyncError(U);if(w(q,$,this.w,this.y),v(U))throw q;this.z.error(U),this.z.error(`${z.resource}: ${(0,A.$Ai)(U)}`)}}}async stop(){for(const $ of this.enabled)try{$.status!=="idle"&&await $.stop()}catch(j){this.z.error(j)}}async resetLocal(){for(const $ of this.enabled)try{await $.resetLocal()}catch(j){this.z.error(`${$.resource}: ${(0,A.$Ai)(j)}`),this.z.error(j)}}async I($){if(!this.profile.isDefault)return{};const j=this.D.getValue(i.$xgb),F=this.enabled.find(z=>z instanceof S.$J3b);if(F){const z=await F.getRemoteUserDataSyncConfiguration($);return{...j,...z}}return j}J($){this.g!==$&&(this.g=$,this.h.fire($))}L(){return this.M(),this.enabled.some($=>$.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some($=>$.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const $=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,I.$ub)(this.m,$,(j,F)=>j.syncResource===F.syncResource&&(0,I.$ub)(j.conflicts,F.conflicts,(z,U)=>(0,k.$og)(z.previewResource,U.previewResource)))||(this.m=$,this.n.fire($))}N($){switch($){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([Y(2,i.$Pgb),Y(3,d.$Oh),Y(4,m.$0n),Y(5,i.$Egb),Y(6,y.$cl),Y(7,i.$Ugb),Y(8,l.$Kk),Y(9,E.$ji)],o);function v(f){if(f instanceof i.$Kgb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(f,$,j,F){F.publicLog2("sync/error",{code:f.code,serverCode:f instanceof i.$Lgb?String(f.serverCode):void 0,url:f instanceof i.$Lgb?f.url:void 0,resource:f.resource,executionId:$,service:j.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,10,17,25]),function(te,e,I,L,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=e.$V8b=void 0;function R(m,c){return{...m,profile:(0,A.$Lk)(m.profile,c.profilesHome.scheme)}}function k(m){return{created:m.created,uri:N.URI.revive(m.uri)}}class g{constructor(c,d,p){this.c=c,this.d=d,this.f=p,this.a=new Map,this.b=new I.$Nd}listen(c,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(c,d,p){try{return await this.g(c,d,p)}catch(y){throw this.f.error(y),y}}async g(c,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),N.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(k(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(p[0]),N.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const y=d.substring(11),l=p[0],h=this.h(l);switch(p=p.slice(1),y){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.a.delete(this.j(h.id)));case"stop":return h.stop().finally(()=>this.a.delete(this.j(h.id)))}}throw new Error("Invalid call")}h(c){const d=this.a.get(this.j(c));if(!d)throw new Error(`Manual sync taks not found: ${c}`);return d}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$V8b=g;let C=class extends L.$Sc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,d){super(),this.n=d,this.b="uninitialized",this.c=this.B(new I.$Nd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$Nd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$Nd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$Nd),this.onSyncErrors=this.m.event,this.a={call(p,y,l){return c.call(p,y,l).then(null,h=>{throw D.$Kgb.toUserDataSyncError(h)})},listen(p,y){return c.listen(p,y)}},this.a.call("_getInitialData").then(([p,y,l])=>{this.s(p),this.t(y),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(h=>this.s(h))),this.B(this.a.listen("onDidChangeLastSyncTime")(h=>this.u(h)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(y=>({...y,error:D.$Kgb.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),d=this;return new E(c,{async call(y,l,h){return d.a.call(`manualSync/${y}`,[c,...Array.isArray(l)?l:[l]],h)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,d,p,y){return this.a.call("accept",[c,d,p,y])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,d){return this.a.call("extractActivityData",[c,d])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map(d=>({syncResource:d.syncResource,profile:(0,A.$Lk)(d.profile,this.n.profilesHome.scheme),conflicts:d.conflicts.map(p=>({...p,baseResource:N.URI.revive(p.baseResource),localResource:N.URI.revive(p.localResource),remoteResource:N.URI.revive(p.remoteResource),previewResource:N.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$W8b=C,e.$W8b=C=ye([Y(1,A.$Kk)],C);class E extends L.$Sc{constructor(c,d){super(),this.id=c,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,6,26,8,3,2,140,5,19,12,10,32,20,14,11,24,57,43,21,25]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZDb=e.$YDb=e.$XDb=e.$WDb=e.$VDb=void 0;const S="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends D.$Sc{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.$Ngb,-1)}set c(F){this.h.store(b.$Ngb,F,-1,k.$p?0:1)}constructor(F,z,U){super(),this.f=F,this.g=z,this.h=U,this.a=this.B(new A.$Nd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new D.$Rc);this.B(A.Event.filter(U.onDidChangeValue(-1,b.$Ngb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[S]),this.a.fire()}m(F){if(F&&(F=k.$p&&F.web?{...F,...F.web}:F,(0,C.$yf)(F.url)&&(0,C.$Af)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(z=>Array.isArray(F.authenticationProviders[z].scopes)))){const z=F,U=!!z.canSwitch,q=z.url===z.insidersUrl?"insiders":"stable",Z=(U?this.c:void 0)||q,K=Z==="insiders"?z.insidersUrl:Z==="stable"?z.stableUrl:z.url;return{url:E.URI.parse(K),type:Z,defaultType:q,defaultUrl:E.URI.parse(z.url),stableUrl:E.URI.parse(z.stableUrl),insidersUrl:E.URI.parse(z.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(z.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:z.authenticationProviders[H].scopes}),x),[])}}}};e.$VDb=o,e.$VDb=o=ye([Y(0,y.$pj),Y(1,c.$ji),Y(2,u.$6o)],o);let v=class extends o{constructor(F,z,U){super(F,z,U);const q=this.h.get(s,-1);q&&(this.n=JSON.parse(q));const Z=this.f[S];Z?this.h.store(s,JSON.stringify(Z),-1,1):this.h.remove(s,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$WDb=v,e.$WDb=v=ye([Y(0,y.$pj),Y(1,c.$ji),Y(2,u.$6o)],v);let w=class extends D.$Sc{get donotMakeRequestsUntil(){return this.j}constructor(F,z,U,q,Z,K,x){super(),this.n=U,this.r=q,this.s=x,this.g=this.B(new A.$Nd),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Nd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Nd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,h.$_o)(Z,K,x).then(H=>{const Q={"X-Client-Name":`${z.applicationName}${k.$p?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(Q["X-Client-Commit"]=z.commit),Q}),this.f=new $(t,r,this.n,this.r),this.u(),this.B((0,D.$Qc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,z){this.b={token:F,type:z}}t(F){this.a=F?(0,g.$vg)(F,"v1"):void 0}u(){const F=this.s.getNumber(a,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,I.$Hg)(z=>(0,I.$Ug)(this.j.getTime()-Date.now(),z).then(()=>this.y(void 0))),this.w.then(null,z=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$vg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const U=await this.D(z,{type:"GET",headers:F},[],L.CancellationToken.None);return(await(0,l.$Yo)(U))?.map(({id:q})=>q)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$vg)(this.a,"collection").toString();F={...F},F["Content-Type"]=R.$Pr.text;const U=await this.D(z,{type:"POST",headers:F},[],L.CancellationToken.None),q=await(0,l.$Xo)(U);if(!q)throw new b.$Lgb("Server did not return the collection id",z,"NoCollection",U.res.statusCode,U.res.headers[b.$Hgb]);return q}async deleteCollection(F,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=F?(0,g.$vg)(this.a,"collection",F).toString():(0,g.$vg)(this.a,"collection").toString();z={...z},await this.D(U,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async getAllResourceRefs(F,z){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,z,F),q={},Z=await this.D(U.toString(),{type:"GET",headers:q},[],L.CancellationToken.None);return(await(0,l.$Yo)(Z)||[]).map(({url:x,created:H})=>({ref:(0,g.$xg)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(F,z,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$vg)(this.z(this.a,U,F),z).toString();q={...q},q["Cache-Control"]="no-cache";const K=await this.D(Z,{type:"GET",headers:q},[],L.CancellationToken.None);return await(0,l.$Xo)(K)}async deleteResource(F,z,U){if(!this.a)throw new Error("No settings sync store url configured.");const q=z!==null?(0,g.$vg)(this.z(this.a,U,F),z).toString():this.z(this.a,U,F).toString(),Z={};await this.D(q,{type:"DELETE",headers:Z},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$vg)(this.a,"resource").toString(),z={"Content-Type":R.$Pr.text};await this.D(F,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async readResource(F,z,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$vg)(this.z(this.a,U,F),"latest").toString();q={...q},q["Cache-Control"]="no-cache",z&&(q["If-None-Match"]=z.ref);const K=await this.D(Z,{type:"GET",headers:q},[304],L.CancellationToken.None);let x=null;if(K.res.statusCode===304&&(x=z),x===null){const H=K.res.headers.etag;if(!H)throw new b.$Lgb("Server did not return the ref",Z,"NoRef",K.res.statusCode,K.res.headers[b.$Hgb]);const Q=await(0,l.$Xo)(K);if(!Q&&K.res.statusCode===304)throw new b.$Lgb("Empty response",Z,"EmptyResponse",K.res.statusCode,K.res.headers[b.$Hgb]);x={ref:H,content:Q}}return x}async writeResource(F,z,U,q,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,q,F).toString();Z={...Z},Z["Content-Type"]=R.$Pr.text,U&&(Z["If-Match"]=U);const x=await this.D(K,{type:"POST",data:z,headers:Z},[],L.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new b.$Lgb("Server did not return the ref",K,"NoRef",x.res.statusCode,x.res.headers[b.$Hgb]);return H}async manifest(F,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$vg)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",F&&(z["If-None-Match"]=F.ref);const q=await this.D(U,{type:"GET",headers:z},[304],L.CancellationToken.None);let Z=null;if(q.res.statusCode===304&&(Z=F),!Z){const x=q.res.headers.etag;if(!x)throw new b.$Lgb("Server did not return the ref",U,"NoRef",q.res.statusCode,q.res.headers[b.$Hgb]);const H=await(0,l.$Xo)(q);if(!H&&q.res.statusCode===304)throw new b.$Lgb("Empty response",U,"EmptyResponse",q.res.statusCode,q.res.headers[b.$Hgb]);H&&(Z={...JSON.parse(H),ref:x})}const K=this.s.get(n,-1);return K&&Z&&K!==Z.session&&this.C(),Z===null&&K&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$vg)(this.a,"download").toString(),z={},U=await this.D(F,{type:"GET",headers:z},[],L.CancellationToken.None);if(!(0,l.$Uo)(U))throw new b.$Lgb("Server returned "+U.res.statusCode,F,"EmptyResponse",U.res.statusCode,U.res.headers[b.$Hgb]);if((0,l.$Vo)(U))throw new b.$Lgb("Empty response",F,"EmptyResponse",U.res.statusCode,U.res.headers[b.$Hgb]);return U.stream}z(F,z,U){return z?(0,g.$vg)(F,"collection",z,"resource",U):(0,g.$vg)(F,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(F,z,U,q){if(!this.b)throw new b.$Lgb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new b.$Lgb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;z.headers={...z.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(z.headers),this.r.trace("Sending request to server",{url:F,type:z.type,headers:{...z.headers,authorization:void 0}});let K;try{K=await this.f.request(F,z,q)}catch(W){if(!(W instanceof b.$Lgb)){let ee="RequestFailed";const ne=(0,N.$0)(W).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,N.$4)(W)&&(ee="RequestCanceled"),W=new b.$Lgb(`Connection refused for the request '${F}'.`,F,ee,void 0,void 0)}throw this.r.info("Request failed",F),W}const x=K.res.headers[b.$Hgb],H={url:F,status:K.res.statusCode,"execution-id":z.headers[b.$Igb],"operation-id":x},Q=(0,l.$Uo)(K)||K.res.statusCode&&U.includes(K.res.statusCode);let G="";if(Q?this.r.trace("Request succeeded",H):(G=await(0,l.$Wo)(K)||"",this.r.info("Request failed",H,G)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new b.$Lgb(`${z.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",K.res.statusCode,x);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new b.$Lgb(`${z.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",K.res.statusCode,x)}if(this.h.fire(),K.res.statusCode===404)throw new b.$Lgb(`${z.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",K.res.statusCode,x);if(K.res.statusCode===405)throw new b.$Lgb(`${z.type} request '${F}' failed because the requested endpoint is not found (405). ${G}`,F,"MethodNotFound",K.res.statusCode,x);if(K.res.statusCode===409)throw new b.$Lgb(`${z.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",K.res.statusCode,x);if(K.res.statusCode===410)throw new b.$Lgb(`${z.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",K.res.statusCode,x);if(K.res.statusCode===412)throw new b.$Lgb(`${z.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",K.res.statusCode,x);if(K.res.statusCode===413)throw new b.$Lgb(`${z.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",K.res.statusCode,x);if(K.res.statusCode===426)throw new b.$Lgb(`${z.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",K.res.statusCode,x);if(K.res.statusCode===429){const W=K.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new b.$Lgb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",K.res.statusCode,x)):new b.$Lgb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",K.res.statusCode,x)}if(!Q)throw new b.$Lgb("Server returned "+K.res.statusCode,F,"Unknown",K.res.statusCode,x);return K}F(F){let z=this.s.get(i,-1);z===void 0&&(z=(0,m.$eg)(),this.s.store(i,z,-1,1)),F["X-Machine-Session-Id"]=z;const U=this.s.get(n,-1);U!==void 0&&(F["X-User-Session-Id"]=U)}};e.$XDb=w,e.$XDb=w=ye([Y(1,y.$pj),Y(2,l.$So),Y(3,b.$Ugb),Y(4,d.$Wh),Y(5,p.$$j),Y(6,u.$6o)],w);let f=class extends w{constructor(F,z,U,q,Z,K,x){super(F.userDataSyncStore?.url,z,U,q,Z,K,x),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$YDb=f,e.$YDb=f=ye([Y(0,b.$Egb),Y(1,y.$pj),Y(2,l.$So),Y(3,b.$Ugb),Y(4,d.$Wh),Y(5,p.$$j),Y(6,u.$6o)],f);class ${constructor(F,z,U,q){this.c=F,this.d=z,this.f=U,this.g=q,this.a=[],this.b=void 0}request(F,z,U){if(this.h()&&this.i(),z.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.$Lgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(z,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$ZDb=$}),define(oe[260],ae([0,1,3,55,24,21,22,255,25,79,82]),function(te,e,I,L,N,A,D,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e9b=void 0;let E=class extends R.$y5b{constructor(c,d,p,y,l,h,u,b,S,s,a){super(c,d,p,y,l,u,b,S,s,a),this.B(I.Event.debounce(I.Event.any(I.Event.map(h.onDidFocusWindow,()=>"windowFocus"),I.Event.map(h.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$e9b=E,e.$e9b=E=ye([Y(0,N.$pj),Y(1,k.$Egb),Y(2,k.$Fgb),Y(3,k.$Pgb),Y(4,k.$Qgb),Y(5,L.$86b),Y(6,k.$Ugb),Y(7,g.$ACb),Y(8,D.$cl),Y(9,C.$sgb),Y(10,A.$6o)],E)}),define(oe[261],ae([0,1,70,23,5,19]),function(te,e,I,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.$C6b=e.$B6b=e.$A6b=void 0,e.$A6b=128/4;function D(g){function C(){let E=g.scheme===L.Schemas.file?(0,A.$jg)(g):g.toString();return N.$l||(E=E.toLowerCase()),(0,I.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:g}}e.$B6b=D;function R(g,C){function E(){if(g.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let c;return N.$l?c=C.ino:N.$k?c=C.birthtime.getTime():N.$j&&(typeof C.birthtimeMs=="number"?c=Math.floor(C.birthtimeMs):c=C.birthtime.getTime()),(0,I.createHash)("md5").update(g.fsPath).update(c?String(c):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:g}}e.$C6b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$D6b=k}),define(oe[262],ae([0,1,6,8,2,16,31,14,7,76,113,261,55,72,23]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K8b=void 0;let p=class extends N.$Sc{constructor(l,h,u,b){super(),this.a=l,this.b=h,this.c=u,this.f=b,this.B(new I.$6g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,h=await D.Promises.readdir(l),u=new g.$_Cb(this.f.getChannel("storage"));await Promise.all(h.map(async b=>{const S=(0,A.$jc)(l,b);b.length===E.$A6b||b===C.$2h.id||(await this.c.getWindows()).some(n=>n.workspace?.id===b)||await u.isUsed(S)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${b} as it seems to be an unused empty workspace.`),await D.Promises.rm(S))}))}catch(l){(0,L.$1)(l)}}};e.$K8b=p,e.$K8b=p=ye([Y(0,R.$Xh),Y(1,k.$0i),Y(2,m.$86b),Y(3,c.$j8b)],p)}),define(oe[83],ae([0,1,53,6,16,12,31,148,273,274]),function(te,e,I,L,N,A,D,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.zip=e.$lp=e.$kp=void 0,e.$kp="end of central directory record signature not found";const C=new RegExp(e.$kp);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$lp=E;function m(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function c(s){if(s instanceof E)return s;let a;return C.test(s.message)&&(a="CorruptZip"),new E(a,s)}function d(s,a,n,i,t,r){const o=N.$mc(a),v=N.$jc(i,o);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,a)));const w=N.$jc(i,a);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(D.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise(($,j)=>{if(!r.isCancellationRequested)try{f=(0,I.createWriteStream)(w,{mode:n}),f.once("close",()=>$()),f.once("error",j),s.once("error",j),s.pipe(f)}catch(F){j(F)}}))}function p(s,a,n,i){let t=(0,L.$Hg)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,w)=>{const f=new L.$Og,$=j=>{j.isCancellationRequested||(r++,s.readEntry())};s.once("error",w),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():w(new E("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},w)),s.readEntry(),s.on("entry",j=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){$(i);return}const F=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const q=N.$jc(a,F);t=(0,L.$Hg)(Z=>D.Promises.mkdir(q,{recursive:!0}).then(()=>$(Z)).then(void 0,w));return}const z=l(s,j),U=m(j);t=(0,L.$Hg)(q=>f.queue(()=>z.then(Z=>d(Z,F,U,a,n,q).then(()=>$(q)))).then(null,w))})}).finally(()=>o.dispose())}function y(s,a=!1){return new Promise((n,i)=>{(0,k.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(c(t)):n((0,A.$Jf)(r))})})}function l(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(c(t)):n((0,A.$Jf)(r))})})}function h(s,a){return new Promise((n,i)=>{const t=new g.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,I.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=h;function u(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=y(s,!0);return n.overwrite&&(r=r.then(o=>D.Promises.rm(a).then(()=>o))),r.then(o=>p(o,a,{sourcePathRegex:t},i))}e.$np=u;function b(s,a){return y(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&l(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(R.localize(2,null,a))))}))}function S(s,a){return b(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$op=S}),define(oe[263],ae([0,1,6,8,2,23,19,54,12,32,31,83,20,14,29,33,97,11,7]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let b=class extends N.$Sc{static{u=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,D.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new d.$$n(r.message,d.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===h.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$$n(E.$kp,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,k.$Ef)(a)?a:!0}async u(s){await this.g;const a=(0,D.$vg)(this.extensionsDownloadDir,`${this.z(s)}${u.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await n(a);return}const i=(0,D.$vg)(this.extensionsDownloadDir,`.${(0,g.$eg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,L.$0)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(u.c))i.push(o.resource);else{const v=p.$Ao.parse(o.name);v&&n.push([v,o])}const t=(0,p.$Fo)(n,([o])=>o),r=[];for(const o of t)o.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await I.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$Ao.create(s).toString().toLowerCase():(0,g.$eg)()}};e.$Dp=b,e.$Dp=b=u=ye([Y(0,c.$Xh),Y(1,l.$$j),Y(2,d.$0n),Y(3,m.$ji),Y(4,y.$ep),Y(5,h.$0i)],b)}),define(oe[264],ae([0,1,83,157]),function(te,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;function N(A){return(0,I.$op)(A,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.$Fp=N}),define(oe[122],ae([0,1,6,15,26,38,8,3,52,2,34,23,16,19,54,12,10,32,31,83,156,96,14,243,29,33,51,80,263,244,264,212,223,68,11,4,7,24,22,28,17]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s,a,n,i,t,r,o,v,w,f,$,j,F,z,U,q,Z,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=void 0,e.$Ip=(0,z.$Qh)(n.$_n);const H=".vsctmp";let Q=class extends a.$pp{constructor(X,B,P,O,T,M,V,J,re,ce,ue,he){super(X,B,ue,P,ce,he),this.fb=T,this.gb=M,this.hb=V,this.ib=re,this.eb=new Map,this.rb=new C.$Bc;const $e=this.B(J.createInstance(v.$Ep));this.bb=this.B(J.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new f.$Gp(he,re,ue,this,this.F)),this.db=this.B(J.createInstance(o.$Dp));const de=this.B(new $.$Hp(this,this.fb,he,M,ue,re,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Ko)(this.ib,this.F)),this.jb}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const B=await this.pb(X),P=await(0,u.zip)((0,c.$vg)(this.db.extensionsDownloadDir,(0,l.$eg)()).fsPath,B);return y.URI.file(P)}async unzip(X){return this.F.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:B,cleanup:P}=await this.lb(X),O=m.$kc(B.fsPath);try{return await(0,w.$Fp)(O)}finally{await P()}}getInstalled(X,B=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(X??null,B)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.bb.scanUserExtensionAtLocation(X)}async install(X,B={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:P,cleanup:O}=await this.lb(X);try{const T=await(0,w.$Fp)(m.$kc(P.fsPath)),M=(0,i.$Eo)(T.publisher,T.name);if(T.engines&&T.engines.vscode&&!(0,j.$Ro)(T.engines.vscode,this.G.version,this.G.date))throw new Error(b.localize(0,null,M,this.G.version));const J=(await this.I([{manifest:T,extension:P,options:B}])).find(({identifier:re})=>(0,i.$zo)(re,{id:M}));if(J?.local)return J.local;throw J?.error?J.error:(0,a.$rp)(new Error(`Unknown error while installing extension ${M}`))}finally{await O()}}async installFromLocation(X,B){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const P=await this.bb.scanUserExtensionAtLocation(X);if(!P)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.ub([[P,void 0]],B),this.F.info("Successfully installed extension",P.identifier.id,B.toString()),P}async installExtensionsFromProfile(X,B,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,B.toString(),P.toString());const O=(await this.bb.scanExtensions(1,B)).filter(T=>X.some(M=>(0,i.$zo)(M,T.identifier)));if(O.length){const T=await Promise.all(O.map(M=>this.bb.scanMetadata(M,B)));await this.ub(O.map((M,V)=>[M,T[V]]),P),this.F.info("Successfully installed extensions",O.map(M=>M.identifier.id),P.toString())}return O}async updateMetadata(X,B,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped===!1&&(B.isMachineScoped=void 0),B.isBuiltin===!1&&(B.isBuiltin=void 0),B.pinned===!1&&(B.pinned=void 0),X=await this.bb.updateMetadata(X,B,P),this.cb.invalidate(P),this.w.fire(X),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(b.localize(1,null));const B=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:B,compatible:!0},N.CancellationToken.None);if(!P)throw new Error(b.localize(2,null));await this.bb.setUninstalled(X);try{await this.bb.removeUninstalledExtension(X)}catch(O){throw new Error(b.localize(3,null,(0,A.$Ai)(O)))}return this.installFromGallery(P)}ab(X,B,P,O){return this.bb.copyExtension(X,B,P,O)}copyExtensions(X,B){return this.bb.copyExtensions(X,B)}markAsUninstalled(...X){return this.bb.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(X){this.F.error(X)}}async download(X,B,P){const{location:O}=await this.db.download(X,B,!P);return O}async lb(X){if(X.scheme===E.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const B=(0,c.$vg)(this.db.extensionsDownloadDir,(0,l.$eg)());return await this.hb.download(X,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.ib.del(B)}catch(O){this.F.error(O)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(X,B,P){if(y.URI.isUri(B))return new ne(X,B,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const O=i.$Ao.create(B).toString();let T=this.eb.get(O);return T||(this.eb.set(O,T=new ee(X,B,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),T.waitUntilTaskIsFinished().finally(()=>this.eb.delete(O))),T}$(X,B){return new _(X,B.profileLocation,this.gb)}async pb(X){const B=async O=>{let T=await h.Promises.readdir(O);T=T.map(J=>m.$jc(O,J));const M=await Promise.all(T.map(J=>h.Promises.stat(J)));let V=Promise.resolve([]);return M.forEach((J,re)=>{const ce=T[re];J.isFile()&&(V=V.then(ue=>[...ue,ce])),J.isDirectory()&&(V=V.then(ue=>B(ce).then(he=>[...ue,...he])))}),V};return(await B(X.location.fsPath)).map(O=>({path:`extension/${m.$lc(X.location.fsPath,O)}`,localPath:O}))}async qb({added:X,removed:B}){if(B){const P=X&&this.D.extUri.isEqual(B.profileLocation,X.profileLocation)?B.extensions.filter(O=>X.extensions.every(T=>!(0,i.$zo)(T,O))):B.extensions;for(const O of P)this.F.info("Extensions removed from another source",O.id,B.profileLocation.toString()),this.u.fire({identifier:O,profileLocation:B.profileLocation})}if(X){const O=(await this.bb.scanExtensions(1,X.profileLocation)).filter(T=>X.extensions.some(M=>(0,i.$zo)(M,T.identifier)));this.s.fire(O.map(T=>(this.F.info("Extensions added from another source",T.identifier.id,X.profileLocation.toString()),{identifier:T.identifier,local:T,profileLocation:X.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(B=>this.rb.add(B)));const X=await this.ib.resolve(this.fb.userExtensionsLocation);for(const B of X.children??[])B.isDirectory&&this.rb.add(B.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(B=>this.tb(B)))}async tb(X){if(!X.affects(this.fb.userExtensionsLocation,1))return;const B=[];for(const P of X.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const O=await this.bb.scanUserExtensionAtLocation(P);O&&O.installedTimestamp===void 0&&(this.rb.add(P),B.push(O))}B.length&&(await this.ub(B.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(P=>P.identifier.id)))}async ub(X,B){const P=X.map(O=>O[0]);await this.vb(P),await this.gb.addExtensionsToProfile(X,B),this.s.fire(P.map(O=>({local:O,identifier:O.identifier,operation:1,profileLocation:B})))}async vb(X){const B=await this.bb.getUninstalledExtensions();for(const P of X){const O=i.$Ao.create(P);B[O.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",O.id),await this.bb.setInstalled(O),this.F.info("Removed the extension from uninstalled list:",O.id))}}};e.$Jp=Q,e.$Jp=Q=ye([Y(0,n.$0n),Y(1,Z.$cl),Y(2,U.$0i),Y(3,s.$Xh),Y(4,r.$yp),Y(5,t.$up),Y(6,S.$On),Y(7,z.$Oh),Y(8,F.$$j),Y(9,q.$pj),Y(10,K.$Ik),Y(11,x.$Kk)],Q);let G=class extends g.$Sc{constructor(X,B,P,O,T,M){super(),this.j=X,this.m=B,this.n=P,this.s=O,this.t=T,this.u=M,this.h=this.B(new R.$Nd),this.onExtract=this.h.event,this.c=(0,c.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(X,B){const P={includeInvalid:!0,profileLocation:B};let O=[];return X===null||X===0?O.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):X===1&&O.push(...await this.n.scanUserExtensions(P)),O=X!==null?O.filter(T=>T.type===X):O,Promise.all(O.map(T=>this.F(T)))}async scanAllUserExtensions(X){const B=await this.n.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(B.map(P=>this.F(P)))}async scanUserExtensionAtLocation(X){try{const B=await this.n.scanExistingExtension(X,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(X,B,P,O,T){const M=X.toString(),V=y.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$eg)()}`)),J=y.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,M));let re=await this.m.exists(J);if(re&&O){try{await this.y(X.id,J,"removeExisting")}catch{throw new n.$$n(b.localize(4,null,J.fsPath,X.id),n.ExtensionManagementErrorCode.Delete)}re=!1}if(!re)try{try{this.u.trace(`Started extracting the extension from ${B} to ${J.fsPath}`),await(0,u.$np)(B,V.fsPath,{sourcePath:"extension",overwrite:!0},T),this.u.info(`Extracted extension to ${J}:`,X.id)}catch(ce){let ue=n.ExtensionManagementErrorCode.Extract;throw ce instanceof u.$lp&&(ce.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$$n(ce.message,ue)}await this.n.updateMetadata(V,P);try{this.u.trace(`Started renaming the extension from ${V.fsPath} to ${J.fsPath}`),await this.C(V.fsPath,J.fsPath),this.u.info("Renamed to",J.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(ce)}. Deleted from extracted location`,V),ce}this.h.fire(J)}catch(ce){try{await this.m.del(V,{recursive:!0})}catch{}throw ce}return this.D(J,1)}async scanMetadata(X,B){return B?(await this.w(X,B))?.metadata:this.n.scanMetadata(X.location)}async w(X,B){return(await this.s.scanProfileExtensions(B)).find(O=>(0,i.$zo)(O.identifier,X.identifier))}async updateMetadata(X,B,P){return P?await this.s.updateMetadata([[X,B]],P):await this.n.updateMetadata(X.location,B),this.D(X.location,X.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...X){const B=X.map(P=>i.$Ao.create(P));await this.z(P=>B.forEach(O=>{P[O.toString()]=!0,this.u.info("Marked extension as uninstalled",O.toString())}))}async setInstalled(X){await this.z(B=>delete B[X.toString()])}async removeExtension(X,B){if(this.t.extUri.isEqualOrParent(X.location,this.n.userExtensionsLocation))return this.y(X.identifier.id,X.location,B)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.z(B=>delete B[i.$Ao.create(X).toString()])}async copyExtension(X,B,P,O){const T=await this.w(X,B),M=await this.w(X,P);return O={...T?.metadata,...O},M?await this.s.updateMetadata([[X,{...M.metadata,...O}]],P):await this.s.addExtensionsToProfile([[X,O]],P),this.D(X.location,X.type,P)}async copyExtensions(X,B){const P=await this.scanExtensions(1,X),O=await Promise.all(P.filter(T=>!T.isApplicationScoped).map(async T=>[T,await this.scanMetadata(T,X)]));await this.s.addExtensionsToProfile(O,B)}async y(X,B,P){this.u.trace(`Deleting ${P} extension from disk`,X,B.fsPath);const O=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,k.$Di)((0,l.$eg)()).toString(16)}${H}`);await this.C(B.fsPath,O.fsPath),await this.m.del(O,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,X,B.fsPath)}async z(X){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(O){if((0,F.$pk)(O)!==1)throw O}let P={};if(B)try{P=JSON.parse(B)}catch{}return X&&(X(P),Object.keys(P).length?await this.m.writeFile(this.c,L.$be.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(X,B){try{await h.Promises.rename(X,B,2*60*1e3)}catch(P){throw new n.$$n(P.message||b.localize(5,null,X,B),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(X,B,P){if(P){const T=(await this.n.scanUserExtensions({profileLocation:P})).find(M=>this.t.extUri.isEqual(M.location,X));if(T)return this.F(T)}else{const O=await this.n.scanExistingExtension(X,B,{includeInvalid:!0});if(O)return this.F(O)}throw new Error(b.localize(6,null,X.path))}async F(X){const B=await this.m.resolve(X.location);let P,O;return B.children&&(P=B.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T))?.resource,O=B.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:P,changelogUrl:O,publisherDisplayName:X.metadata?.publisherDisplayName||null,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned}}async G(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(X));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const T of B)X[i.$Ao.create(T).toString()]||P.add(T.identifier.id.toLowerCase());try{const T=(0,i.$Fo)(B,M=>M.identifier);await I.Promises.settled(T.map(async M=>{const V=M.sort((J,re)=>d.rcompare(J.manifest.version,re.manifest.version))[0];P.has(V.identifier.id.toLowerCase())||await this.j(await this.F(V))}))}catch(T){this.u.error(T)}const O=B.filter(T=>T.metadata&&X[i.$Ao.create(T).toString()]);await Promise.allSettled(O.map(T=>this.removeUninstalledExtension(T)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,F.$pk)(B)!==1&&this.u.error(B);return}if(X?.children)try{await Promise.allSettled(X.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(P){(0,F.$pk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Kp=G,e.$Kp=G=ye([Y(1,F.$$j),Y(2,r.$yp),Y(3,t.$up),Y(4,K.$Ik),Y(5,U.$0i)],G);class W extends a.$sp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(X,B,P,O,T,M,V,J,re){super(),this.identifier=X,this.source=B,this.options=P,this.m=O,this.n=T,this.o=M,this.p=V,this.q=J,this.s=re,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(X){const[B,P]=await this.x(X);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,P]],this.j),B}async u({zipPath:X,key:B,metadata:P},O,T){let M=await this.v(B);return M||(this.s.trace("Extracting extension...",B.id),M=await this.m.extractUserExtension(B,X,P,O,T),this.s.info("Extracting extension completed.",B.id)),M}async v(X){return await this.w(X)?(this.s.trace("Removing the extension from uninstalled list:",X.id),await this.m.setInstalled(X),this.s.info("Removed the extension from uninstalled list:",X.id),(await this.m.scanAllUserExtensions(!0)).find(O=>i.$Ao.create(O).equals(X))):void 0}async w(X){return!!(await this.m.getUninstalledExtensions())[X.toString()]}}class ee extends W{constructor(X,B,P,O,T,M,V,J,re,ce){super(B.identifier,B,P,T,M,V,J,re,ce),this.y=B,this.z=O}async x(X){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(V=>(0,i.$zo)(V.identifier,this.y.identifier));P&&(this.l=3);const O={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,O),O];const{location:T,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(T.fsPath),[await this.u({zipPath:T.fsPath,key:i.$Ao.create(this.y),metadata:O},!1,X),O]}catch(V){try{await this.z.delete(T)}catch(J){this.s.warn("Error while deleting the downloaded file",T.toString(),(0,D.$0)(J))}throw V}}async B(X){try{await(0,w.$Fp)(X)}catch(B){throw new n.$$n((0,a.$qp)(B).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Lp=ee;class ne extends W{constructor(X,B,P,O,T,M,V,J,re,ce){super({id:(0,i.$Eo)(X.publisher,X.name)},B,P,T,M,V,J,re,ce),this.y=X,this.z=B,this.A=O}async h(X){const B=await super.h(X);return this.D(B,X),B}async x(X){const B=new i.$Ao(this.identifier,this.y.version),O=(await this.m.scanExtensions(1,this.options.profileLocation)).find(V=>(0,i.$zo)(this.identifier,V.identifier)),T={isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(O)if(this.l=3,B.equals(new i.$Ao(O.identifier,O.manifest.version)))try{await this.m.removeExtension(O,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(O.manifest.version,this.y.version)&&await this.m.setUninstalled(O);else{const V=await this.v(B);if(V)try{await this.m.removeExtension(V,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:B,metadata:T},!0,X),T]}async D(X,B){try{let[P]=await this.A.getExtensions([{id:X.identifier.id,version:X.manifest.version}],B);if(P||([P]=await this.A.getExtensions([{id:X.identifier.id}],B)),P){const O={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(X,O,this.options.profileLocation)}}catch{}}}class _ extends a.$sp{constructor(X,B,P){super(),this.extension=X,this.j=B,this.k=P}async h(X){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,81,222,122,7,21]),function(te,e,I,L,N,A,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=void 0;let g=class extends I.$Sc{constructor(E,m,c,d,p,y){super(),E.cleanUp(),(0,A.$YVb)(E,m,c,d,y),N.$Xu.removeOutdatedExtensionVersions(E,p)}};e.$$8b=g,e.$$8b=g=ye([Y(0,D.$Ip),Y(1,L.$0n),Y(2,N.$Wu),Y(3,L.$co),Y(4,k.$6o),Y(5,R.$0i)],g)}),define(oe[123],ae([0,1,70,62,36,275,15,8,3,2,16,5,32,42,66]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class p{traceSocketEvent(f,$){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,$)}constructor(f,$=""){this.f=!0,this.debugLabel=$,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,R.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const $=j=>{this.traceSocketEvent("read",j),f(D.$be.wrap(j))};return this.socket.on("data",$),{dispose:()=>this.socket.off("data",$)}}onClose(f){const $=j=>{f({type:0,hadError:j,error:void 0})};return this.socket.on("close",$),{dispose:()=>this.socket.off("close",$)}}onEnd(f){const $=()=>{f()};return this.socket.on("end",$),{dispose:()=>this.socket.off("end",$)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,$=>{if($){if($.code==="EPIPE")return;(0,R.$1)($)}})}catch($){if($.code==="EPIPE")return;(0,R.$1)($)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,$)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Eh=p;var y;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var l;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(l||(l={}));class h extends g.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,$){this.socket.traceSocketEvent(f,$)}constructor(f,$,j,F){super(),this.f=this.B(new k.$Nd),this.g=this.B(new k.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:$,inflateBytesLength:j?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new u(this,$,j,F,this.f,(z,U)=>this.m(z,U))),this.B(this.a.onError(z=>{console.error(z),(0,R.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new d.$zh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let $=0;for(;$<f.byteLength;)this.a.writeMessage(f.slice($,Math.min($+262144,f.byteLength)),{compressed:!0,opcode:2}),$+=262144}m(f,{compressed:$,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let F=2;f.byteLength<126?F+=0:f.byteLength<2**16?F+=2:F+=8;const z=D.$be.alloc(F),U=$?64:0,q=j&15;if(z.writeUInt8(128|U|q,0),f.byteLength<126)z.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){z.writeUInt8(126,1);let Z=1;z.writeUInt8(f.byteLength>>>8&255,++Z),z.writeUInt8(f.byteLength>>>0&255,++Z)}else{z.writeUInt8(127,1);let Z=1;z.writeUInt8(0,++Z),z.writeUInt8(0,++Z),z.writeUInt8(0,++Z),z.writeUInt8(0,++Z),z.writeUInt8(f.byteLength>>>24&255,++Z),z.writeUInt8(f.byteLength>>>16&255,++Z),z.writeUInt8(f.byteLength>>>8&255,++Z),z.writeUInt8(f.byteLength>>>0&255,++Z)}this.socket.write(D.$be.concat([z,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const $=this.b.peek(this.j.readLen),j=$.readUInt8(0),F=(j&128)>>>7,z=(j&64)>>>6,U=j&15,q=$.readUInt8(1),Z=(q&128)>>>7,K=q&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const $=this.b.read(this.j.readLen),j=$.readUInt8(1),F=(j&128)>>>7;let z=j&127,U=1;z===126?z=$.readUInt8(++U)*2**8+$.readUInt8(++U):z===127&&(z=$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*2**24+$.readUInt8(++U)*2**16+$.readUInt8(++U)*2**8+$.readUInt8(++U));let q=0;F&&(q=$.readUInt8(++U)*2**24+$.readUInt8(++U)*2**16+$.readUInt8(++U)*2**8+$.readUInt8(++U)),this.j.state=3,this.j.readLen=z,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const $=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",$),s($,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",$),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame($,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage($,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=h;class u extends g.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$be.alloc(0)}constructor(f,$,j,F,z,U){super(),this.n=f,this.r=z,this.s=U,this.a=this.B(new k.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,$?(this.b=this.B(new b(this.n,F,j,{windowBits:15})),this.f=this.B(new S(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f,$){this.g.push({data:f,options:$}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:$}=this.g.shift();if(this.f&&$.compressed){const j=await this.w(this.f,f);this.s(j,$)}else this.s(f,{...$,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,$){return new Promise((j,F)=>{f.write($),f.flush(z=>j(z))})}acceptFrame(f,$,j){this.h.push({data:f,isCompressed:$,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const $=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire($)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,$,j){return new Promise((F,z)=>{f.write($),j&&f.write(D.$be.fromByteArray([0,0,255,255])),f.flush(U=>F(U))})}}class b extends g.$Sc{get recordedInflateBytes(){return this.j?D.$be.concat(this.f):D.$be.alloc(0)}constructor(f,$,j,F){super(),this.h=f,this.j=$,this.a=this.B(new k.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(D.$be.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const $=D.$be.concat(this.g);this.g.length=0,f($)})}}class S extends g.$Sc{constructor(f,$){super(),this.g=f,this.a=this.B(new k.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$be.wrap(j))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let $=D.$be.concat(this.f);this.f.length=0,$=$.slice(0,$.byteLength-4),f($)})}}function s(w,f){if(f===0)return;const $=w.byteLength>>>2;for(let Z=0;Z<$;Z++){const K=w.readUInt32BE(Z*4);w.writeUInt32BE(K^f,Z*4)}const j=$*4,F=w.byteLength-j,z=f>>>24&255,U=f>>>16&255,q=f>>>8&255;F>=1&&w.writeUInt8(w.readUInt8(j)^z,j),F>=2&&w.writeUInt8(w.readUInt8(j+1)^U,j+1),F>=3&&w.writeUInt8(w.readUInt8(j+2)^q,j+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const w=(0,m.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const f=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,N.tmpdir)(),$=(0,C.$jc)(f,`vscode-ipc-${w}.sock`);return t($),$}e.$Hh=n;function i(w,f,$){const j=(0,I.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${$}-${f}-sock`;const F=$.substr(0,4),z=f.substr(0,6),U=j.substr(0,8);let q;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?q=(0,C.$jc)(e.$Gh,`vscode-${U}-${F}-${z}.sock`):q=(0,C.$jc)(w,`${F}-${z}.sock`),t(q),q}e.$Ih=i;function t(w){const f=a[E.$u];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.$th{static b(f){const $=k.Event.fromNodeEventEmitter(f,"connection");return k.Event.map($,j=>({protocol:new d.$Ah(new p(j,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(j,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=r;function o(w){return new Promise((f,$)=>{const j=(0,L.createServer)();j.on("error",$),j.listen(w,()=>{j.removeListener("error",$),f(new r(j))})})}e.$Kh=o;function v(w,f){return new Promise(($,j)=>{const F=(0,L.createConnection)(w,()=>{F.removeListener("error",j),$(d.$Bh.fromSocket(new p(F,`ipc-client${f}`),f))});F.once("error",j)})}e.$Lh=v}),define(oe[266],ae([0,1,62,123,210]),function(te,e,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=void 0,e.$h9b=new class{supports(A){return!0}connect({host:A,port:D},R,k,g){return new Promise((C,E)=>{const m=I.createConnection({host:A,port:D},()=>{m.removeListener("error",E),m.write((0,N.$ykb)(R,k,g));const c=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",c),C(new L.$Eh(m,g)))};m.on("data",c)});m.setNoDelay(!0),m.once("error",E)})}}}),define(oe[267],ae([0,1,62,36,133,123,6,2,5,20,7,24,213,104,106,77,15]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=e.$c8b=e.$b8b=e.$a8b=void 0;async function l(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new h(s,a,n,i,t).waitForReady(),!(t&&N.$hg[t]||!N.$hg[r.tunnelLocalPort]));o--);return r}class h extends R.$Sc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=I.createServer(),this.c=new D.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,p.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,N.$ig)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,p.$cv)(this.tunnelRemoteHost)||(0,p.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,m.$6k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof A.$Eh?t.socket.destroy():t.end()}),t instanceof A.$Eh?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(y.$be.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$a8b=h;let u=class extends p.$hv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,p.$fv)(a,this.l,k.OS,L.release())}s(a,n,i,t,r,o,v,w){const f=this.r(n,i);if(f)return++f.refcount,f.value;if((0,p.$_u)(a))return this.t(a,n,i,r,o,v,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const $={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=l($,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,j),j}}};e.$b8b=u,e.$b8b=u=ye([Y(0,c.$Zk),Y(1,C.$0i),Y(2,d.$3k),Y(3,E.$pj),Y(4,g.$ji)],u);let b=class extends u{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$c8b=b,e.$c8b=b=ye([Y(0,c.$Zk),Y(1,C.$0i),Y(2,d.$3k),Y(3,E.$pj),Y(4,g.$ji)],b);let S=class extends R.$Sc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,w,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const $=new b(this.b,this.c,this.g,this.f,this.h);this.B($),this.a.set(a,$),$.onTunnelClosed(async()=>{(await $.tunnels).length===0&&($.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,w,f)}};e.$d8b=S,e.$d8b=S=ye([Y(0,c.$Zk),Y(1,C.$0i),Y(2,E.$pj),Y(3,d.$3k),Y(4,g.$ji)],S)}),define(oe[276],ae([0,1,36,38,8,2,23,10,18,3,42,147,204,205,196,197,262,187,189,20,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,69,4,195,71,73,225,7,201,102,24,57,21,107,22,108,109,110,45,228,81,111,25,79,254,238,239,82,253,257,258,259,58,252,241,106,219,77,267,214,229,28,230,5,231,190,207,206,80,246,17,51,203,56,251,227,242,105,256,265,9,202,101,249,245,216,184,55,260,248,72,250,104,266,182,112,240,217]),function(te,e,I,L,N,A,D,R,k,g,C,E,m,c,d,p,y,l,h,u,b,S,s,a,n,i,t,r,o,v,w,f,$,j,F,z,U,q,Z,K,x,H,Q,G,W,ee,ne,_,ie,X,B,P,O,T,M,V,J,re,ce,ue,he,$e,de,we,Ee,Ie,Le,Te,le,ge,be,ke,Pe,ze,je,Ue,Me,se,fe,me,pe,Se,Re,Ce,De,Oe,Ae,Fe,Be,qe,Ve,_e,ut,vt,Et,St,kt,ft,Ct,Pt,Rt,It,Dt,Ot,jt,dt,Nt,gt,At,Lt,$t,Ft,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Mt extends A.$Sc{constructor(ve){super(),this.f=ve,this.a=this.B(new E.$wT(this)),this.b=void 0,this.c=this.B(new g.$Nd),this.g()}g(){let ve=!1;const Ne=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,E.$xT)(process.parentPort,it.$p7b.exit,Ne)}async init(){const ve=await this.h();(0,re.$zgb)(),ve.invokeFunction(Ne=>{const Ke=Ne.get(Q.$0i),We=Ne.get(X.$cl),Xe=Ne.get(Oe.$Kk);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ne),this.m(Ke),this.n(We,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(We,Xe)))}),this.B((0,A.$Pc)(ve.createInstance(m.$G8b,this.f.codeCachePath),ve.createInstance(c.$H8b),ve.createInstance(y.$K8b),ve.createInstance(p.$J8b),ve.createInstance(d.$I8b),ve.createInstance(Et.$$8b),ve.createInstance(_e.$38b),ve.createInstance(Ft.$k9b,this.c.event)))}async h(){const ve=new K.$Nh,Ne={_serviceBrand:void 0,...W.default};ve.set(ee.$pj,Ne);const Ke=new C.$xh(He=>He==="main"),We=new dt.$k8b(this.a,Ke);ve.set(dt.$j8b,We);const Xe=this.f.policiesData?new Fe.$S7b(this.f.policiesData,We.getChannel("policy")):new Be.$kn;ve.set(Be.$in,Xe);const Ge=new Lt.$jm(this.f.args,Ne);ve.set(i.$Xh,Ge);const xe=new G.$$q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),We.getChannel("logger"));ve.set(Q.$$i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ct=this.B(new Q.$fj(st.getLevel())),Je=this.B(new kt.$EN(st,[ct]));ve.set(Q.$0i,Je),this.b=this.B(new ft.$a9b(Je)),ve.set(ft.$_8b,this.b);const Qe=this.B(new F.$Np(Je));ve.set(j.$$j,Qe);const lt=this.B(new z.$aq(Je));Qe.registerProvider(D.Schemas.file,lt);const rt=new se.$zr(Qe);ve.set(Me.$Ik,rt);const Ye=this.B(new qe.$LN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));ve.set(Oe.$Kk,Ye);const ht=this.B(new me.$i8b(D.Schemas.file,this.B(new pe.$nN(We.getChannel(pe.$mN),{pathCaseSensitive:fe.$l})),D.Schemas.vscodeUserData,Ye,rt,Je));Qe.registerProvider(D.Schemas.vscodeUserData,ht);const Ze=this.B(new b.$Kn(Ye.defaultProfile.settingsResource,Qe,Xe,Je));ve.set(u.$ji,Ze);const et=new Nt.$g9b(void 0,{defaultProfile:Ye.defaultProfile,currentProfile:Ye.defaultProfile},We,Ge);ve.set(_.$6o,et),this.B((0,A.$Qc)(()=>et.flush())),await Promise.all([Ze.initialize(),et.initialize()]);const bt=new Rt.$Wq(We.getChannel("request"));ve.set(ne.$So,bt),ve.set(l.$L8b,new U.$Mh(h.$M8b,void 0,!1)),ve.set(Re.$WE,new U.$Mh(Se.$28b,void 0,!1));const wt=C.ProxyChannel.toService(We.getChannel("nativeHost"));ve.set(Dt.$86b,wt),ve.set(a.$On,new U.$Mh(n.$TN,void 0,!0));const Tt=this.B(new ge.$P7b(wt)),zt=new C.$xh(He=>Tt.getActiveClientId().then(at=>He===at));ve.set($.$IVb,new It.$c9b(this.a.getChannel("extensionRecommendationNotification",zt)));let ot;const tt=[],yt=(0,T.$wo)(Ne,Ze);if((0,T.$ro)(Ne,Ge)){const He=new P.$Q4b(Je,xe,Ge,Ne);if(tt.push(He),!(0,T.$so)(Ne,Ge)&&Ne.aiConfig?.ariaKey){const at=new Ve.$sN(bt,yt,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,A.$Qc)(()=>at.flush())),tt.push(at)}ot=new O.$1q({appenders:tt,commonProperties:(0,ie.$ho)((0,I.release)(),(0,I.hostname)(),process.arch,Ne.commit,Ne.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,T.$xo)(Ge)},Ze,Ne)}else{ot=T.$lo;const He=T.$po;tt.push(He)}this.a.registerChannel("telemetryAppender",new B.$u7b(tt)),ve.set(X.$cl,ot);const Ut=new M.$N8b(Ze,ot,Je,xe,Ge,Ne);ve.set(X.$dl,Ut),ve.set(Ae.$up,new U.$Mh(Pt.$DN,void 0,!0)),ve.set(Ce.$yp,new U.$Mh(De.$T7b,void 0,!0)),ve.set(v.$ep,new U.$Mh(v.$fp,void 0,!0)),ve.set(f.$Ip,new U.$Mh(f.$Jp,void 0,!0)),ve.set(o.$0n,new U.$Mh(r.$cp,void 0,!0)),ve.set(o.$do,new U.$Mh(jt.$f9b,void 0,!1)),ve.set(x.$Sq,new U.$Mh(H.$Uq,void 0,!1)),ve.set(S.$qm,new U.$Mh(s.$Gr,void 0,!1)),ve.set(ce.$ACb,new U.$Mh(ce.$BCb,void 0,!0)),ve.set(re.$Ugb,new U.$Mh($e.$NEb,void 0,!0)),ve.set(re.$Tgb,new he.$Q8b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(o.$co,new U.$Mh(t.$yCb,void 0,!1)),ve.set(J.$LEb,new U.$Mh(J.$MEb,void 0,!0)),ve.set(V.$Wu,new U.$Mh(V.$Xu)),ve.set(re.$Egb,new U.$Mh(Le.$WDb,void 0,!0)),ve.set(re.$Fgb,new U.$Mh(Le.$YDb,void 0,!0)),ve.set(de.$sgb,new U.$Mh(de.$ugb,void 0,!0)),ve.set(re.$Ggb,new U.$Mh(ue.$s5b,void 0,!1)),ve.set(re.$Pgb,new U.$Mh(we.$h5b,void 0,!0)),ve.set(re.$Qgb,new U.$Mh(Ee.$x5b,void 0,!1)),ve.set(Te.$aDb,new U.$Mh(le.$X8b,void 0,!0)),ve.set(re.$Rgb,new U.$Mh(vt.$05b,void 0,!0)),ve.set(be.$3k,new U.$Mh(ke.$f8b,void 0,!1));const pt=new gt.$1k;return ve.set(gt.$Zk,pt),pt.register(0,At.$h9b),ve.set(Pe.$$u,new U.$Mh(ze.$d8b)),ve.set(je.$Y8b,new U.$Mh(Ue.$18b)),ve.set(ut.$48b,new U.$Mh(Ct.$b9b)),ve.set($t.$i9b,new U.$Mh($t.$j9b)),new Z.$dq(ve)}j(ve){const Ne=this.B(new A.$Rc),Ke=new w.$hp(ve.get(o.$_n),()=>null);this.a.registerChannel("extensions",Ke);const We=C.ProxyChannel.fromService(ve.get(x.$Sq),Ne);this.a.registerChannel("languagePacks",We);const Xe=C.ProxyChannel.fromService(ve.get(S.$qm),Ne);this.a.registerChannel("diagnostics",Xe);const Ge=new w.$jp(ve.get(o.$do));this.a.registerChannel("extensionTipsService",Ge);const xe=C.ProxyChannel.fromService(ve.get(l.$L8b),Ne);this.a.registerChannel("checksum",xe);const st=C.ProxyChannel.fromService(ve.get(Re.$WE),Ne);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$R8b(ve.get(de.$sgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(ve.get(X.$dl),Ne);this.a.registerChannel("customEndpointTelemetry",Je);const Qe=new he.$S8b(ve.get(ce.$ACb));this.a.registerChannel("userDataSyncAccount",Qe);const lt=new he.$T8b(ve.get(re.$Egb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$V8b(ve.get(re.$Qgb),ve.get(Oe.$Kk),ve.get(Q.$0i));this.a.registerChannel("userDataSync",rt);const Ye=this.B(ve.get(q.$Oh).createInstance(Ot.$e9b)),ht=new he.$O8b(Ye);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(ve.get(re.$Rgb),Ne));const Ze=C.ProxyChannel.fromService(ve.get(je.$Y8b),Ne);this.a.registerChannel(je.$Z8b,Ze);const et=C.ProxyChannel.fromService(ve.get(ut.$48b),Ne);this.a.registerChannel("remoteTunnel",et)}m(ve){process.on("uncaughtException",Ne=>(0,N.$1)(Ne)),process.on("unhandledRejection",Ne=>(0,N.$1)(Ne)),(0,N.setUnexpectedErrorHandler)(Ne=>{const Ke=(0,L.$Ai)(Ne,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(ve,Ne){ve.publicLog2("profilesInfo",{count:Ne.profiles.length})}handledClientConnection(ve){if(ve.data!==it.$r7b.response)return!1;const Ne=(0,k.$Ob)(ve.ports);return Ne?(this.c.fire(Ne),!0):!1}}async function mt(nt){const ve=new Mt(nt);process.parentPort.postMessage(it.$p7b.ipcReady),await ve.init(),process.parentPort.postMessage(it.$p7b.initDone)}e.main=mt,process.parentPort.once("message",nt=>{mt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f1c3b1dcf85e3b6ddb24b7dce0e4b122e8ce6233/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
