/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/core/range","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(we){for(var e=[],y=0,M=we.length;y<M;y++)e[y]=Ae[we[y]];return e};define(Ae[65],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function y(A){return(l,D,f)=>{let R=null,k=null;if(typeof f.value=="function"?(R="value",k=f.value):typeof f.get=="function"&&(R="get",k=f.get),!k)throw new Error("not supported");f[R]=A(k,D)}}function M(A,l,D){let f=null,R=null;if(typeof D.value=="function"?(f="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(f="get",R=D.get),!R)throw new Error("not supported");const k=`$memoize$${l}`;D[f]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,a)}),this[k]}}e.$hh=M;function C(A,l,D){return y((f,R)=>{const k=`$debounce$${R}`,a=`$debounce$result$${R}`;return function(...b){this[a]||(this[a]=D?D():void 0),clearTimeout(this[k]),l&&(this[a]=l(this[a],...b),b=[this[a]]),this[k]=setTimeout(()=>{f.apply(this,b),this[a]=D?D():void 0},A)}})}e.$ih=C;function T(A,l,D){return y((f,R)=>{const k=`$throttle$timer$${R}`,a=`$throttle$result$${R}`,b=`$throttle$lastRun$${R}`,$=`$throttle$pending$${R}`;return function(...g){if(this[a]||(this[a]=D?D():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),l&&(this[a]=l(this[a],...g)),this[$])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[a]]),this[a]=D?D():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[b]=Date.now(),f.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$jh=T}),define(Ae[88],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$mM=y,e.$nM=new y("id#")}),define(Ae[115],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(n,r=!1){let s=0;const o=n.length;let w="",d=0,I=16,S=0;function u(V){let N=0,O=0;for(;N<V;){const se=n.charCodeAt(s);if(se>=48&&se<=57)O=O*16+se-48;else if(se>=65&&se<=70)O=O*16+se-65+10;else if(se>=97&&se<=102)O=O*16+se-97+10;else break;s++,N++}return N<V&&(O=-1),O}function m(V){s=V,w="",d=0,I=16,S=0}function h(){const V=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&f(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&f(n.charCodeAt(s)))for(s++;s<n.length&&f(n.charCodeAt(s));)s++;else return S=3,n.substring(V,s);let N=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&f(n.charCodeAt(s))){for(s++;s<n.length&&f(n.charCodeAt(s));)s++;N=s}else S=3;return n.substring(V,N)}function P(){let V="",N=s;for(;;){if(s>=o){V+=n.substring(N,s),S=2;break}const O=n.charCodeAt(s);if(O===34){V+=n.substring(N,s),s++;break}if(O===92){if(V+=n.substring(N,s),s++,s>=o){S=2;break}switch(n.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const X=u(4);X>=0?V+=String.fromCharCode(X):S=4;break}default:S=5}N=s;continue}if(O>=0&&O<=31)if(D(O)){V+=n.substring(N,s),S=2;break}else S=6;s++}return V}function B(){if(w="",S=0,d=s,s>=o)return d=o,I=17;let V=n.charCodeAt(s);if(l(V)){do s++,w+=String.fromCharCode(V),V=n.charCodeAt(s);while(l(V));return I=15}if(D(V))return s++,w+=String.fromCharCode(V),V===13&&n.charCodeAt(s)===10&&(s++,w+=`
`),I=14;switch(V){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,w=P(),I=10;case 47:{const N=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!D(n.charCodeAt(s));)s++;return w=n.substring(N,s),I=12}if(n.charCodeAt(s+1)===42){s+=2;const O=o-1;let se=!1;for(;s<O;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,se=!0;break}s++}return se||(s++,S=1),w=n.substring(N,s),I=13}return w+=String.fromCharCode(V),s++,I=16}case 45:if(w+=String.fromCharCode(V),s++,s===o||!f(n.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=h(),I=11;default:for(;s<o&&z(V);)s++,V=n.charCodeAt(s);if(d!==s){switch(w=n.substring(d,s),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(V),s++,I=16}}function z(V){if(l(V)||D(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let V;do V=B();while(V>=12&&V<=15);return V}return{setPosition:m,getPosition:()=>s,scan:r?j:B,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>S}}e.$Um=A;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function k(n,r){const s=[],o=new Object;let w;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,m,h,P){d.value=u,d.offset=m,d.length=h,d.type=P,d.colonOffset=void 0,w=d}try{p(n,{onObjectBegin:(u,m)=>{if(r<=u)throw o;w=void 0,I=r>u,s.push("")},onObjectProperty:(u,m,h)=>{if(r<m||(S(u,m,h,"property"),s[s.length-1]=u,r<=m+h))throw o},onObjectEnd:(u,m)=>{if(r<=u)throw o;w=void 0,s.pop()},onArrayBegin:(u,m)=>{if(r<=u)throw o;w=void 0,s.push(0)},onArrayEnd:(u,m)=>{if(r<=u)throw o;w=void 0,s.pop()},onLiteralValue:(u,m,h)=>{if(r<m||(S(u,m,h,v(u)),r<=m+h))throw o},onSeparator:(u,m,h)=>{if(r<=m)throw o;if(u===":"&&w&&w.type==="property")w.colonOffset=m,I=!1,w=void 0;else if(u===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(I=!0,s[s.length-1]=""),w=void 0}}})}catch(u){if(u!==o)throw u}return{path:s,previousNode:w,isAtPropertyKey:I,matches:u=>{let m=0;for(let h=0;m<u.length&&h<s.length;h++)if(u[m]===s[h]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.$Vm=k;function a(n,r=[],s=T.DEFAULT){let o=null,w=[];const d=[];function I(u){Array.isArray(w)?w.push(u):o!==null&&(w[o]=u)}return p(n,{onObjectBegin:()=>{const u={};I(u),d.push(w),w=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const u=[];I(u),d.push(w),w=u,o=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:I,onError:(u,m,h)=>{r.push({error:u,offset:m,length:h})}},s),w[0]}e.$Wm=a;function b(n,r=[],s=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function d(u){return o.children.push(u),u}p(n,{onObjectBegin:u=>{o=d({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,m,h)=>{o=d({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:m,length:h,parent:o})},onObjectEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onArrayBegin:(u,m)=>{o=d({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onLiteralValue:(u,m,h)=>{d({type:v(u),offset:m,length:h,parent:o,value:u}),w(m+h)},onSeparator:(u,m,h)=>{o.type==="property"&&(u===":"?o.colonOffset=m:u===","&&w(m))},onError:(u,m,h)=>{r.push({error:u,offset:m,length:h})}},s);const S=o.children[0];return S&&delete S.parent,S}e.$Xm=b;function $(n,r){if(!n)return;let s=n;for(const o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let w=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===o){s=d.children[1],w=!0;break}if(!w)return}else{const w=o;if(s.type!=="array"||w<0||!Array.isArray(s.children)||w>=s.children.length)return;s=s.children[w]}return s}e.$Ym=$;function g(n){if(!n.parent||!n.parent.children)return[];const r=g(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;r.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&r.push(s)}return r}e.$Zm=g;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(r[s.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$1m=t;function i(n,r,s=!1){return r>=n.offset&&r<n.offset+n.length||s&&r===n.offset+n.length}e.$2m=i;function c(n,r,s=!1){if(i(n,r,s)){const o=n.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=r;w++){const d=c(o[w],r,s);if(d)return d}return n}}e.$3m=c;function p(n,r,s=T.DEFAULT){const o=A(n,!1);function w(ue){return ue?()=>ue(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(ue){return ue?ae=>ue(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=w(r.onObjectBegin),S=d(r.onObjectProperty),u=w(r.onObjectEnd),m=w(r.onArrayBegin),h=w(r.onArrayEnd),P=d(r.onLiteralValue),B=d(r.onSeparator),z=w(r.onComment),j=d(r.onError),V=s&&s.disallowComments,N=s&&s.allowTrailingComma;function O(){for(;;){const ue=o.scan();switch(o.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:V||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(ue){case 12:case 13:V?se(10):z();break;case 16:se(1);break;case 15:case 14:break;default:return ue}}}function se(ue,ae=[],ve=[]){if(j(ue),ae.length+ve.length>0){let _=o.getToken();for(;_!==17;){if(ae.indexOf(_)!==-1){O();break}else if(ve.indexOf(_)!==-1)break;_=O()}}}function X(ue){const ae=o.getTokenValue();return ue?P(ae):S(ae),O(),!0}function Ee(){switch(o.getToken()){case 11:{let ue=0;try{ue=JSON.parse(o.getTokenValue()),typeof ue!="number"&&(se(2),ue=0)}catch{se(2)}P(ue);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function Pe(){return o.getToken()!==10?(se(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(B(":"),O(),ye()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function Se(){I(),O();let ue=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ue||se(4,[],[]),B(","),O(),o.getToken()===2&&N)break}else ue&&se(6,[],[]);Pe()||se(4,[],[2,5]),ue=!0}return u(),o.getToken()!==2?se(7,[2],[]):O(),!0}function fe(){m(),O();let ue=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ue||se(4,[],[]),B(","),O(),o.getToken()===4&&N)break}else ue&&se(6,[],[]);ye()||se(4,[],[4,5]),ue=!0}return h(),o.getToken()!==4?se(8,[4],[]):O(),!0}function ye(){switch(o.getToken()){case 3:return fe();case 1:return Se();case 10:return X(!0);default:return Ee()}}return O(),o.getToken()===17?s.allowEmptyContent?!0:(se(4,[],[]),!1):ye()?(o.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.$4m=p;function E(n,r){const s=A(n),o=[];let w,d=0,I;do switch(I=s.getPosition(),w=s.scan(),w){case 12:case 13:case 17:d!==I&&o.push(n.substring(d,I)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),d=s.getPosition();break}while(w!==17);return o.join("")}e.$5m=E;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=v}),function(we,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e($e,he){for(var De=0;De<he.length;De++){var ne=he[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty($e,ne.key,ne)}}function y($e,he,De){return he&&e($e.prototype,he),De&&e($e,De),Object.defineProperty($e,"prototype",{writable:!1}),$e}function M($e,he){if($e){if(typeof $e=="string")return C($e,he);var De=Object.prototype.toString.call($e).slice(8,-1);if(De==="Object"&&$e.constructor&&(De=$e.constructor.name),De==="Map"||De==="Set")return Array.from($e);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C($e,he)}}function C($e,he){(he==null||he>$e.length)&&(he=$e.length);for(var De=0,ne=new Array(he);De<he;De++)ne[De]=$e[De];return ne}function T($e,he){var De=typeof Symbol<"u"&&$e[Symbol.iterator]||$e["@@iterator"];if(De)return(De=De.call($e)).next.bind(De);if(Array.isArray($e)||(De=M($e))||he&&$e&&typeof $e.length=="number"){De&&($e=De);var ne=0;return function(){return ne>=$e.length?{done:!0}:{done:!1,value:$e[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=A();function l($e){we.defaults=$e}var D=/[&<>"']/,f=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(he){return a[he]};function $($e,he){if(he){if(D.test($e))return $e.replace(f,b)}else if(R.test($e))return $e.replace(k,b);return $e}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t($e){return $e.replace(g,function(he,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function c($e,he){$e=typeof $e=="string"?$e:$e.source,he=he||"";var De={replace:function(le,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),$e=$e.replace(le,ie),De},getRegex:function(){return new RegExp($e,he)}};return De}var p=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v($e,he,De){if($e){var ne;try{ne=decodeURIComponent(t(De)).replace(p,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}he&&!E.test(De)&&(De=w(he,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w($e,he){n[" "+$e]||(r.test($e)?n[" "+$e]=$e+"/":n[" "+$e]=u($e,"/",!0)),$e=n[" "+$e];var De=$e.indexOf(":")===-1;return he.substring(0,2)==="//"?De?he:$e.replace(s,"$1")+he:he.charAt(0)==="/"?De?he:$e.replace(o,"$1")+he:$e+he}var d={exec:function(){}};function I($e){for(var he=1,De,ne;he<arguments.length;he++){De=arguments[he];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&($e[ne]=De[ne])}return $e}function S($e,he){var De=$e.replace(/\|/g,function(ie,oe,ge){for(var Ie=!1,F=oe;--F>=0&&ge[F]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=De.split(/ \|/),le=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>he)ne.splice(he);else for(;ne.length<he;)ne.push("");for(;le<ne.length;le++)ne[le]=ne[le].trim().replace(/\\\|/g,"|");return ne}function u($e,he,De){var ne=$e.length;if(ne===0)return"";for(var le=0;le<ne;){var ie=$e.charAt(ne-le-1);if(ie===he&&!De)le++;else if(ie!==he&&De)le++;else break}return $e.slice(0,ne-le)}function m($e,he){if($e.indexOf(he[1])===-1)return-1;for(var De=$e.length,ne=0,le=0;le<De;le++)if($e[le]==="\\")le++;else if($e[le]===he[0])ne++;else if($e[le]===he[1]&&(ne--,ne<0))return le;return-1}function h($e){$e&&$e.sanitize&&!$e.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P($e,he){if(he<1)return"";for(var De="";he>1;)he&1&&(De+=$e),he>>=1,$e+=$e;return De+$e}function B($e,he,De,ne){var le=he.href,ie=he.title?$(he.title):null,oe=$e[1].replace(/\\([\[\]])/g,"$1");if($e[0].charAt(0)!=="!"){ne.state.inLink=!0;var ge={type:"link",raw:De,href:le,title:ie,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,ge}return{type:"image",raw:De,href:le,title:ie,text:$(oe)}}function z($e,he){var De=$e.match(/^(\s+)(?:```)/);if(De===null)return he;var ne=De[1];return he.split(`
`).map(function(le){var ie=le.match(/^\s+/);if(ie===null)return le;var oe=ie[0];return oe.length>=ne.length?le.slice(ne.length):le}).join(`
`)}var j=function(){function $e(De){this.options=De||we.defaults}var he=$e.prototype;return he.space=function(ne){var le=this.rules.block.newline.exec(ne);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},he.code=function(ne){var le=this.rules.block.code.exec(ne);if(le){var ie=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:u(ie,`
`)}}},he.fences=function(ne){var le=this.rules.block.fences.exec(ne);if(le){var ie=le[0],oe=z(ie,le[3]||"");return{type:"code",raw:ie,lang:le[2]?le[2].trim():le[2],text:oe}}},he.heading=function(ne){var le=this.rules.block.heading.exec(ne);if(le){var ie=le[2].trim();if(/#$/.test(ie)){var oe=u(ie,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(ie=oe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ie,tokens:this.lexer.inline(ie)}}},he.hr=function(ne){var le=this.rules.block.hr.exec(ne);if(le)return{type:"hr",raw:le[0]}},he.blockquote=function(ne){var le=this.rules.block.blockquote.exec(ne);if(le){var ie=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},he.list=function(ne){var le=this.rules.block.list.exec(ne);if(le){var ie,oe,ge,Ie,F,K,G,J,q,x,ce,Ne,Ue=le[1].trim(),Qe=Ue.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Ne=!1,!(!(le=xe.exec(ne))||this.rules.block.hr.test(ne)));){if(ie=le[0],ne=ne.substring(ie.length),J=le[2].split(`
`,1)[0],q=ne.split(`
`,1)[0],this.options.pedantic?(Ie=2,ce=J.trimLeft()):(Ie=le[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ce=J.slice(Ie),Ie+=le[1].length),K=!1,!J&&/^ *$/.test(q)&&(ie+=q+`
`,ne=ne.substring(q.length+1),Ne=!0),!Ne)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ne&&(x=ne.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(J)||tt.test(J)||Ye.test(J)||_e.test(ne)));){if(J.search(/[^ ]/)>=Ie||!J.trim())ce+=`
`+J.slice(Ie);else if(!K)ce+=`
`+J;else break;!K&&!J.trim()&&(K=!0),ie+=x+`
`,ne=ne.substring(x.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ie)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ce),oe&&(ge=oe[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ie,task:!!oe,checked:ge,loose:!1,text:ce}),Ge.raw+=ie}Ge.items[Ge.items.length-1].raw=ie.trimRight(),Ge.items[Ge.items.length-1].text=ce.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(F=0;F<ze;F++){this.lexer.state.top=!1,Ge.items[F].tokens=this.lexer.blockTokens(Ge.items[F].text,[]);var st=Ge.items[F].tokens.filter(function(Q){return Q.type==="space"}),Y=st.every(function(Q){for(var be=Q.raw.split(""),Be=0,Oe=T(be),Xe;!(Xe=Oe()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&st.length&&Y&&(Ge.loose=!0,Ge.items[F].loose=!0)}return Ge}},he.html=function(ne){var le=this.rules.block.html.exec(ne);if(le){var ie={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]);ie.type="paragraph",ie.text=oe,ie.tokens=this.lexer.inline(oe)}return ie}},he.def=function(ne){var le=this.rules.block.def.exec(ne);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ie=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:le[0],href:le[2],title:le[3]}}},he.table=function(ne){var le=this.rules.block.table.exec(ne);if(le){var ie={type:"table",header:S(le[1]).map(function(G){return{text:G}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=le[0];var oe=ie.align.length,ge,Ie,F,K;for(ge=0;ge<oe;ge++)/^ *-+: *$/.test(ie.align[ge])?ie.align[ge]="right":/^ *:-+: *$/.test(ie.align[ge])?ie.align[ge]="center":/^ *:-+ *$/.test(ie.align[ge])?ie.align[ge]="left":ie.align[ge]=null;for(oe=ie.rows.length,ge=0;ge<oe;ge++)ie.rows[ge]=S(ie.rows[ge],ie.header.length).map(function(G){return{text:G}});for(oe=ie.header.length,Ie=0;Ie<oe;Ie++)ie.header[Ie].tokens=this.lexer.inline(ie.header[Ie].text);for(oe=ie.rows.length,Ie=0;Ie<oe;Ie++)for(K=ie.rows[Ie],F=0;F<K.length;F++)K[F].tokens=this.lexer.inline(K[F].text);return ie}}},he.lheading=function(ne){var le=this.rules.block.lheading.exec(ne);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},he.paragraph=function(ne){var le=this.rules.block.paragraph.exec(ne);if(le){var ie=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ie,tokens:this.lexer.inline(ie)}}},he.text=function(ne){var le=this.rules.block.text.exec(ne);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},he.escape=function(ne){var le=this.rules.inline.escape.exec(ne);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},he.tag=function(ne){var le=this.rules.inline.tag.exec(ne);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},he.link=function(ne){var le=this.rules.inline.link.exec(ne);if(le){var ie=le[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var oe=u(ie.slice(0,-1),"\\");if((ie.length-oe.length)%2===0)return}else{var ge=m(le[2],"()");if(ge>-1){var Ie=le[0].indexOf("!")===0?5:4,F=Ie+le[1].length+ge;le[2]=le[2].substring(0,ge),le[0]=le[0].substring(0,F).trim(),le[3]=""}}var K=le[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);J&&(K=J[1],G=J[3])}else G=le[3]?le[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(ie)?K=K.slice(1):K=K.slice(1,-1)),B(le,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},he.reflink=function(ne,le){var ie;if((ie=this.rules.inline.reflink.exec(ne))||(ie=this.rules.inline.nolink.exec(ne))){var oe=(ie[2]||ie[1]).replace(/\s+/g," ");if(oe=le[oe.toLowerCase()],!oe||!oe.href){var ge=ie[0].charAt(0);return{type:"text",raw:ge,text:ge}}return B(ie,oe,ie[0],this.lexer)}},he.emStrong=function(ne,le,ie){ie===void 0&&(ie="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=oe[1]||oe[2]||"";if(!ge||ge&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Ie=oe[0].length-1,F,K,G=Ie,J=0,q=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,le=le.slice(-1*ne.length+Ie);(oe=q.exec(le))!=null;)if(F=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!F){if(K=F.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){J+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+J),Math.min(Ie,K)%2){var x=ne.slice(1,Ie+oe.index+K);return{type:"em",raw:ne.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ce=ne.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:ne.slice(0,Ie+oe.index+K+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},he.codespan=function(ne){var le=this.rules.inline.code.exec(ne);if(le){var ie=le[2].replace(/\n/g," "),oe=/[^ ]/.test(ie),ge=/^ /.test(ie)&&/ $/.test(ie);return oe&&ge&&(ie=ie.substring(1,ie.length-1)),ie=$(ie,!0),{type:"codespan",raw:le[0],text:ie}}},he.br=function(ne){var le=this.rules.inline.br.exec(ne);if(le)return{type:"br",raw:le[0]}},he.del=function(ne){var le=this.rules.inline.del.exec(ne);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},he.autolink=function(ne,le){var ie=this.rules.inline.autolink.exec(ne);if(ie){var oe,ge;return ie[2]==="@"?(oe=$(this.options.mangle?le(ie[1]):ie[1]),ge="mailto:"+oe):(oe=$(ie[1]),ge=oe),{type:"link",raw:ie[0],text:oe,href:ge,tokens:[{type:"text",raw:oe,text:oe}]}}},he.url=function(ne,le){var ie;if(ie=this.rules.inline.url.exec(ne)){var oe,ge;if(ie[2]==="@")oe=$(this.options.mangle?le(ie[0]):ie[0]),ge="mailto:"+oe;else{var Ie;do Ie=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Ie!==ie[0]);oe=$(ie[0]),ie[1]==="www."?ge="http://"+oe:ge=oe}return{type:"link",raw:ie[0],text:oe,href:ge,tokens:[{type:"text",raw:oe,text:oe}]}}},he.inlineText=function(ne,le){var ie=this.rules.inline.text.exec(ne);if(ie){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):$(ie[0]):ie[0]:oe=$(this.options.smartypants?le(ie[0]):ie[0]),{type:"text",raw:ie[0],text:oe}}},$e}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=c(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=c(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=c(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=c(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=c(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=c(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=I({},V),V.gfm=I({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=c(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=c(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=I({},V.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:c(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=c(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=c(V._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=c(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=c(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=c(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=c(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=c(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=c(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=c(N.reflink).replace("label",N._label).replace("ref",V._label).getRegex(),N.nolink=c(N.nolink).replace("ref",V._label).getRegex(),N.reflinkSearch=c(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=I({},N),N.pedantic=I({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=I({},N.normal,{escape:c(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=c(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=I({},N.gfm,{br:c(N.br).replace("{2,}","*").getRegex(),text:c(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O($e){return $e.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function se($e){var he="",De,ne,le=$e.length;for(De=0;De<le;De++)ne=$e.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),he+="&#"+ne+";";return he}var X=function(){function $e(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||we.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:V.normal,inline:N.normal};this.options.pedantic?(ne.block=V.pedantic,ne.inline=N.pedantic):this.options.gfm&&(ne.block=V.gfm,this.options.breaks?ne.inline=N.breaks:ne.inline=N.gfm),this.tokenizer.rules=ne}$e.lex=function(ne,le){var ie=new $e(le);return ie.lex(ne)},$e.lexInline=function(ne,le){var ie=new $e(le);return ie.inlineTokens(ne)};var he=$e.prototype;return he.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},he.blockTokens=function(ne,le){var ie=this;le===void 0&&(le=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var oe,ge,Ie,F;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:ie},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):le.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=ne.slice(1),q=void 0;ie.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ie=ne.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){ge=le[le.length-1],F&&ge.type==="paragraph"?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):le.push(oe),F=Ie.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&ge.type==="text"?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):le.push(oe);continue}if(ne){var K="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,le},he.inline=function(ne,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ne,tokens:le}),le},he.inlineTokens=function(ne,le){var ie=this;le===void 0&&(le=[]);var oe,ge,Ie,F=ne,K,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)q.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,K.index)+"["+P("a",K[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,K.index)+"["+P("a",K[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,K.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(oe=ce.call({lexer:ie},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&oe.type==="text"&&ge.type==="text"?(ge.raw+=oe.raw,ge.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&oe.type==="text"&&ge.type==="text"?(ge.raw+=oe.raw,ge.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,F,J)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.autolink(ne,se)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,se))){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ne=ne.slice(1),Ue=void 0;ie.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Ne),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ie=ne.substring(0,ce+1))}(),oe=this.tokenizer.inlineText(Ie,O)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(J=oe.raw.slice(-1)),G=!0,ge=le[le.length-1],ge&&ge.type==="text"?(ge.raw+=oe.raw,ge.text+=oe.text):le.push(oe);continue}if(ne){var x="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return le},y($e,null,[{key:"rules",get:function(){return{block:V,inline:N}}}]),$e}(),Ee=function(){function $e(De){this.options=De||we.defaults}var he=$e.prototype;return he.code=function(ne,le,ie){var oe=(le||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(ne,oe);ge!=null&&ge!==ne&&(ie=!0,ne=ge)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(ie?ne:$(ne,!0))+`</code></pre>
`:"<pre><code>"+(ie?ne:$(ne,!0))+`</code></pre>
`},he.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},he.html=function(ne){return ne},he.heading=function(ne,le,ie,oe){if(this.options.headerIds){var ge=this.options.headerPrefix+oe.slug(ie);return"<h"+le+' id="'+ge+'">'+ne+"</h"+le+`>
`}return"<h"+le+">"+ne+"</h"+le+`>
`},he.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},he.list=function(ne,le,ie){var oe=le?"ol":"ul",ge=le&&ie!==1?' start="'+ie+'"':"";return"<"+oe+ge+`>
`+ne+"</"+oe+`>
`},he.listitem=function(ne){return"<li>"+ne+`</li>
`},he.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},he.paragraph=function(ne){return"<p>"+ne+`</p>
`},he.table=function(ne,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+le+`</table>
`},he.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},he.tablecell=function(ne,le){var ie=le.header?"th":"td",oe=le.align?"<"+ie+' align="'+le.align+'">':"<"+ie+">";return oe+ne+("</"+ie+`>
`)},he.strong=function(ne){return"<strong>"+ne+"</strong>"},he.em=function(ne){return"<em>"+ne+"</em>"},he.codespan=function(ne){return"<code>"+ne+"</code>"},he.br=function(){return this.options.xhtml?"<br/>":"<br>"},he.del=function(ne){return"<del>"+ne+"</del>"},he.link=function(ne,le,ie){if(ne=v(this.options.sanitize,this.options.baseUrl,ne),ne===null)return ie;var oe='<a href="'+$(ne)+'"';return le&&(oe+=' title="'+le+'"'),oe+=">"+ie+"</a>",oe},he.image=function(ne,le,ie){if(ne=v(this.options.sanitize,this.options.baseUrl,ne),ne===null)return ie;var oe='<img src="'+ne+'" alt="'+ie+'"';return le&&(oe+=' title="'+le+'"'),oe+=this.options.xhtml?"/>":">",oe},he.text=function(ne){return ne},$e}(),Pe=function(){function $e(){}var he=$e.prototype;return he.strong=function(ne){return ne},he.em=function(ne){return ne},he.codespan=function(ne){return ne},he.del=function(ne){return ne},he.html=function(ne){return ne},he.text=function(ne){return ne},he.link=function(ne,le,ie){return""+ie},he.image=function(ne,le,ie){return""+ie},he.br=function(){return""},$e}(),Se=function(){function $e(){this.seen={}}var he=$e.prototype;return he.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},he.getNextSafeSlug=function(ne,le){var ie=ne,oe=0;if(this.seen.hasOwnProperty(ie)){oe=this.seen[ne];do oe++,ie=ne+"-"+oe;while(this.seen.hasOwnProperty(ie))}return le||(this.seen[ne]=oe,this.seen[ie]=0),ie},he.slug=function(ne,le){le===void 0&&(le={});var ie=this.serialize(ne);return this.getNextSafeSlug(ie,le.dryrun)},$e}(),fe=function(){function $e(De){this.options=De||we.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Pe,this.slugger=new Se}$e.parse=function(ne,le){var ie=new $e(le);return ie.parse(ne)},$e.parseInline=function(ne,le){var ie=new $e(le);return ie.parseInline(ne)};var he=$e.prototype;return he.parse=function(ne,le){le===void 0&&(le=!0);var ie="",oe,ge,Ie,F,K,G,J,q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze=ne.length;for(oe=0;oe<ze;oe++){if(ce=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ie+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(q="",J="",F=ce.header.length,ge=0;ge<F;ge++)J+=this.renderer.tablecell(this.parseInline(ce.header[ge].tokens),{header:!0,align:ce.align[ge]});for(q+=this.renderer.tablerow(J),x="",F=ce.rows.length,ge=0;ge<F;ge++){for(G=ce.rows[ge],J="",K=G.length,Ie=0;Ie<K;Ie++)J+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ce.align[Ie]});x+=this.renderer.tablerow(J)}ie+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ce.tokens),ie+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ce.ordered,Ue=ce.start,Qe=ce.loose,F=ce.items.length,x="",ge=0;ge<F;ge++)xe=ce.items[ge],Ye=xe.checked,_e=xe.task,Ge="",xe.task&&(it=this.renderer.checkbox(Ye),Qe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=it+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=it+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(xe.tokens,Qe),x+=this.renderer.listitem(Ge,_e,Ye);ie+=this.renderer.list(x,Ne,Ue);continue}case"html":{ie+=this.renderer.html(ce.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(x=ce.tokens?this.parseInline(ce.tokens):ce.text;oe+1<ze&&ne[oe+1].type==="text";)ce=ne[++oe],x+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ie+=le?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return ie},he.parseInline=function(ne,le){le=le||this.renderer;var ie="",oe,ge,Ie,F=ne.length;for(oe=0;oe<F;oe++){if(ge=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(Ie=this.options.extensions.renderers[ge.type].call({parser:this},ge),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ge.type))){ie+=Ie||"";continue}switch(ge.type){case"escape":{ie+=le.text(ge.text);break}case"html":{ie+=le.html(ge.text);break}case"link":{ie+=le.link(ge.href,ge.title,this.parseInline(ge.tokens,le));break}case"image":{ie+=le.image(ge.href,ge.title,ge.text);break}case"strong":{ie+=le.strong(this.parseInline(ge.tokens,le));break}case"em":{ie+=le.em(this.parseInline(ge.tokens,le));break}case"codespan":{ie+=le.codespan(ge.text);break}case"br":{ie+=le.br();break}case"del":{ie+=le.del(this.parseInline(ge.tokens,le));break}case"text":{ie+=le.text(ge.text);break}default:{var K='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return ie},$e}();function ye($e,he,De){if(typeof $e>"u"||$e===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $e!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($e)+", string expected");if(typeof he=="function"&&(De=he,he=null),he=I({},ye.defaults,he||{}),h(he),De){var ne=he.highlight,le;try{le=X.lex($e,he)}catch(F){return De(F)}var ie=function(K){var G;if(!K)try{he.walkTokens&&ye.walkTokens(le,he.walkTokens),G=fe.parse(le,he)}catch(J){K=J}return he.highlight=ne,K?De(K):De(null,G)};if(!ne||ne.length<3||(delete he.highlight,!le.length))return ie();var oe=0;ye.walkTokens(le,function(F){F.type==="code"&&(oe++,setTimeout(function(){ne(F.text,F.lang,function(K,G){if(K)return ie(K);G!=null&&G!==F.text&&(F.text=G,F.escaped=!0),oe--,oe===0&&ie()})},0))}),oe===0&&ie();return}function ge(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+$(F.message+"",!0)+"</pre>";throw F}try{var Ie=X.lex($e,he);if(he.walkTokens){if(he.async)return Promise.all(ye.walkTokens(Ie,he.walkTokens)).then(function(){return fe.parse(Ie,he)}).catch(ge);ye.walkTokens(Ie,he.walkTokens)}return fe.parse(Ie,he)}catch(F){ge(F)}}ye.options=ye.setOptions=function($e){return I(ye.defaults,$e),l(ye.defaults),ye},ye.getDefaults=A,ye.defaults=we.defaults,ye.use=function(){for(var $e=arguments.length,he=new Array($e),De=0;De<$e;De++)he[De]=arguments[De];var ne=I.apply(void 0,[{}].concat(he)),le=ye.defaults.extensions||{renderers:{},childTokens:{}},ie;he.forEach(function(oe){if(oe.extensions&&(ie=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var F=le.renderers?le.renderers[Ie.name]:null;F?le.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),J=0;J<K;J++)G[J]=arguments[J];var q=Ie.renderer.apply(this,G);return q===!1&&(q=F.apply(this,G)),q}:le.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ie.level]?le[Ie.level].unshift(Ie.tokenizer):le[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?le.startBlock?le.startBlock.push(Ie.start):le.startBlock=[Ie.start]:Ie.level==="inline"&&(le.startInline?le.startInline.push(Ie.start):le.startInline=[Ie.start]))}Ie.childTokens&&(le.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ye.defaults.renderer||new Ee,F=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var Ue=oe.renderer[J].apply(Ie,ce);return Ue===!1&&(Ue=q.apply(Ie,ce)),Ue}};for(var K in oe.renderer)F(K);ne.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ye.defaults.tokenizer||new j,F=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var Ue=oe.tokenizer[J].apply(Ie,ce);return Ue===!1&&(Ue=q.apply(Ie,ce)),Ue}};for(var K in oe.tokenizer)F(K);ne.tokenizer=Ie}(),oe.walkTokens){var ge=ye.defaults.walkTokens;ne.walkTokens=function(Ie){var F=[];return F.push(oe.walkTokens.call(this,Ie)),ge&&(F=F.concat(ge.call(this,Ie))),F}}ie&&(ne.extensions=le),ye.setOptions(ne)})},ye.walkTokens=function($e,he){for(var De=[],ne=function(){var ge=ie.value;switch(De=De.concat(he.call(ye,ge)),ge.type){case"table":{for(var Ie=T(ge.header),F;!(F=Ie()).done;){var K=F.value;De=De.concat(ye.walkTokens(K.tokens,he))}for(var G=T(ge.rows),J;!(J=G()).done;)for(var q=J.value,x=T(q),ce;!(ce=x()).done;){var Ne=ce.value;De=De.concat(ye.walkTokens(Ne.tokens,he))}break}case"list":{De=De.concat(ye.walkTokens(ge.items,he));break}default:ye.defaults.extensions&&ye.defaults.extensions.childTokens&&ye.defaults.extensions.childTokens[ge.type]?ye.defaults.extensions.childTokens[ge.type].forEach(function(Ue){De=De.concat(ye.walkTokens(ge[Ue],he))}):ge.tokens&&(De=De.concat(ye.walkTokens(ge.tokens,he)))}},le=T($e),ie;!(ie=le()).done;)ne();return De},ye.parseInline=function($e,he){if(typeof $e>"u"||$e===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $e!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($e)+", string expected");he=I({},ye.defaults,he||{}),h(he);try{var De=X.lexInline($e,he);return he.walkTokens&&ye.walkTokens(De,he.walkTokens),fe.parseInline(De,he)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+$(ne.message+"",!0)+"</pre>";throw ne}},ye.Parser=fe,ye.parser=fe.parse,ye.Renderer=Ee,ye.TextRenderer=Pe,ye.Lexer=X,ye.lexer=X.lex,ye.Tokenizer=j,ye.Slugger=Se,ye.parse=ye;var ue=ye.options,ae=ye.setOptions,ve=ye.use,_=ye.walkTokens,W=ye.parseInline,Z=ye,ee=fe.parse,pe=X.lex;we.Lexer=X,we.Parser=fe,we.Renderer=Ee,we.Slugger=Se,we.TextRenderer=Pe,we.Tokenizer=j,we.getDefaults=A,we.lexer=pe,we.marked=ye,we.options=ue,we.parse=Z,we.parseInline=W,we.parser=ee,we.setOptions=ae,we.use=ve,we.walkTokens=_,Object.defineProperty(we,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function y(l,D,f){return Math.min(Math.max(l,D),f)}e.$Ol=y;function M(l,D){return(D+l%D)%D}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=C;class T{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=T;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const f=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function we(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function A(D){T.push(D,Date.now())}function l(){const D=[];for(let f=0;f<T.length;f+=2)D.push({name:T[f],startTime:T[f+1]});return D}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(C+A.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:we)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function y(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return we[M].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=we,y.c=e,y.d=function(M,C,T){y.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:T})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,C){if(1&C&&(M=y(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var T=Object.create(null);if(y.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)y.d(T,A,function(l){return M[l]}.bind(null,A));return T},y.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(C,"a",C),C},y.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},y.p="",y(y.s=0)}([function(we,e,y){(function(M){var C;e=we.exports=ve,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],D=e.src=[],f=0,R=f++;D[R]="0|[1-9]\\d*";var k=f++;D[k]="[0-9]+";var a=f++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=f++;D[b]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var $=f++;D[$]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var g=f++;D[g]="(?:"+D[R]+"|"+D[a]+")";var t=f++;D[t]="(?:"+D[k]+"|"+D[a]+")";var i=f++;D[i]="(?:-("+D[g]+"(?:\\."+D[g]+")*))";var c=f++;D[c]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var p=f++;D[p]="[0-9A-Za-z-]+";var E=f++;D[E]="(?:\\+("+D[p]+"(?:\\."+D[p]+")*))";var v=f++,n="v?"+D[b]+D[i]+"?"+D[E]+"?";D[v]="^"+n+"$";var r="[v=\\s]*"+D[$]+D[c]+"?"+D[E]+"?",s=f++;D[s]="^"+r+"$";var o=f++;D[o]="((?:<|>)?=?)";var w=f++;D[w]=D[k]+"|x|X|\\*";var d=f++;D[d]=D[R]+"|x|X|\\*";var I=f++;D[I]="[v=\\s]*("+D[d]+")(?:\\.("+D[d]+")(?:\\.("+D[d]+")(?:"+D[i]+")?"+D[E]+"?)?)?";var S=f++;D[S]="[v=\\s]*("+D[w]+")(?:\\.("+D[w]+")(?:\\.("+D[w]+")(?:"+D[c]+")?"+D[E]+"?)?)?";var u=f++;D[u]="^"+D[o]+"\\s*"+D[I]+"$";var m=f++;D[m]="^"+D[o]+"\\s*"+D[S]+"$";var h=f++;D[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=f++;D[P]="(?:~>?)";var B=f++;D[B]="(\\s*)"+D[P]+"\\s+",l[B]=new RegExp(D[B],"g");var z=f++;D[z]="^"+D[P]+D[I]+"$";var j=f++;D[j]="^"+D[P]+D[S]+"$";var V=f++;D[V]="(?:\\^)";var N=f++;D[N]="(\\s*)"+D[V]+"\\s+",l[N]=new RegExp(D[N],"g");var O=f++;D[O]="^"+D[V]+D[I]+"$";var se=f++;D[se]="^"+D[V]+D[S]+"$";var X=f++;D[X]="^"+D[o]+"\\s*("+r+")$|^$";var Ee=f++;D[Ee]="^"+D[o]+"\\s*("+n+")$|^$";var Pe=f++;D[Pe]="(\\s*)"+D[o]+"\\s*("+r+"|"+D[I]+")",l[Pe]=new RegExp(D[Pe],"g");var Se=f++;D[Se]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var fe=f++;D[fe]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var ye=f++;D[ye]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)C(ue,D[ue]),l[ue]||(l[ue]=new RegExp(D[ue]));function ae(q,x){if(q instanceof ve)return q;if(typeof q!="string"||q.length>T||!(x?l[s]:l[v]).test(q))return null;try{return new ve(q,x)}catch{return null}}function ve(q,x){if(q instanceof ve){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof ve))return new ve(q,x);C("SemVer",q,x),this.loose=x;var ce=q.trim().match(x?l[s]:l[v]);if(!ce)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Ue=+Ne;if(Ue>=0&&Ue<A)return Ue}return Ne}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(q,x){var ce=ae(q,x);return ce?ce.version:null},e.clean=function(q,x){var ce=ae(q.trim().replace(/^[=v]+/,""),x);return ce?ce.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(q){return C("SemVer.compare",this.version,this.loose,q),q instanceof ve||(q=new ve(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ve.prototype.compareMain=function(q){return q instanceof ve||(q=new ve(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},ve.prototype.comparePre=function(q){if(q instanceof ve||(q=new ve(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ce=this.prerelease[x],Ne=q.prerelease[x];if(C("prerelease compare",x,ce,Ne),ce===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ce===void 0)return-1;if(ce!==Ne)return W(ce,Ne)}while(++x)},ve.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ce,Ne){typeof ce=="string"&&(Ne=ce,ce=void 0);try{return new ve(q,ce).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if($e(q,x))return null;var ce=ae(q),Ne=ae(x);if(ce.prerelease.length||Ne.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Ne[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Ne[Ue])return Ue},e.compareIdentifiers=W;var _=/^[0-9]+$/;function W(q,x){var ce=_.test(q),Ne=_.test(x);return ce&&Ne&&(q=+q,x=+x),ce&&!Ne?-1:Ne&&!ce?1:q<x?-1:q>x?1:0}function Z(q,x,ce){return new ve(q,ce).compare(new ve(x,ce))}function ee(q,x,ce){return Z(q,x,ce)>0}function pe(q,x,ce){return Z(q,x,ce)<0}function $e(q,x,ce){return Z(q,x,ce)===0}function he(q,x,ce){return Z(q,x,ce)!==0}function De(q,x,ce){return Z(q,x,ce)>=0}function ne(q,x,ce){return Z(q,x,ce)<=0}function le(q,x,ce,Ne){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),Ue=q===ce;break;case"!==":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),Ue=q!==ce;break;case"":case"=":case"==":Ue=$e(q,ce,Ne);break;case"!=":Ue=he(q,ce,Ne);break;case">":Ue=ee(q,ce,Ne);break;case">=":Ue=De(q,ce,Ne);break;case"<":Ue=pe(q,ce,Ne);break;case"<=":Ue=ne(q,ce,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function ie(q,x){if(q instanceof ie){if(q.loose===x)return q;q=q.value}if(!(this instanceof ie))return new ie(q,x);C("comparator",q,x),this.loose=x,this.parse(q),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(q,x){return W(x,q)},e.major=function(q,x){return new ve(q,x).major},e.minor=function(q,x){return new ve(q,x).minor},e.patch=function(q,x){return new ve(q,x).patch},e.compare=Z,e.compareLoose=function(q,x){return Z(q,x,!0)},e.rcompare=function(q,x,ce){return Z(x,q,ce)},e.sort=function(q,x){return q.sort(function(ce,Ne){return e.compare(ce,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ce,Ne){return e.rcompare(ce,Ne,x)})},e.gt=ee,e.lt=pe,e.eq=$e,e.neq=he,e.gte=De,e.lte=ne,e.cmp=le,e.Comparator=ie;var oe={};function ge(q,x){if(q instanceof ge)return q.loose===x?q:new ge(q.raw,x);if(q instanceof ie)return new ge(q.value,x);if(!(this instanceof ge))return new ge(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function F(q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze){return((x=Ie(ce)?"":Ie(Ne)?">="+ce+".0.0":Ie(Ue)?">="+ce+"."+Ne+".0":">="+x)+" "+(xe=Ie(Ye)?"":Ie(_e)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+_e+1)+".0":tt?"<="+Ye+"."+_e+"."+it+"-"+tt:"<="+xe)).trim()}function K(q,x){for(var ce=0;ce<q.length;ce++)if(!q[ce].test(x))return!1;if(x.prerelease.length){for(ce=0;ce<q.length;ce++)if(C(q[ce].semver),q[ce].semver!==oe&&q[ce].semver.prerelease.length>0){var Ne=q[ce].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function G(q,x,ce){try{x=new ge(x,ce)}catch{return!1}return x.test(q)}function J(q,x,ce,Ne){var Ue,Qe,Ge,xe,Ye;switch(q=new ve(q,Ne),x=new ge(x,Ne),ce){case">":Ue=ee,Qe=ne,Ge=pe,xe=">",Ye=">=";break;case"<":Ue=pe,Qe=De,Ge=ee,xe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Ne))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new ie(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Ne)?tt=st:Ge(st.semver,ze.semver,Ne)&&(ze=st)}),tt.operator===xe||tt.operator===Ye||(!ze.operator||ze.operator===xe)&&Qe(q,ze.semver)||ze.operator===Ye&&Ge(q,ze.semver))return!1}return!0}ie.prototype.parse=function(q){var x=this.loose?l[X]:l[Ee],ce=q.match(x);if(!ce)throw new TypeError("Invalid comparator: "+q);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new ve(ce[2],this.loose):this.semver=oe},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(q){return C("Comparator.test",q,this.loose),this.semver===oe||(typeof q=="string"&&(q=new ve(q,this.loose)),le(q,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(q,x){if(!(q instanceof ie))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new ge(q.value,x),G(this.value,ce,x);if(q.operator==="")return ce=new ge(this.value,x),G(q.semver,ce,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Qe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),xe=le(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=le(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||Ue||Qe&&Ge||xe||Ye},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),C("range",q,x);var ce=x?l[fe]:l[Se];q=q.replace(ce,F),C("hyphen replace",q),q=q.replace(l[Pe],"$1$2$3"),C("comparator trim",q,l[Pe]),q=(q=(q=q.replace(l[B],"$1~")).replace(l[N],"$1^")).split(/\s+/).join(" ");var Ne=x?l[X]:l[Ee],Ue=q.split(" ").map(function(Qe){return function(Ge,xe){return C("comp",Ge),Ge=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[se]:l[O];return tt.replace(st,function(Y,Q,be,Be,Oe){var Xe;return C("caret",tt,Y,Q,be,Be,Oe),Ie(Q)?Xe="":Ie(be)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=Q==="0"?">="+Q+"."+be+".0 <"+Q+"."+(+be+1)+".0":">="+Q+"."+be+".0 <"+(+Q+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=Q==="0"?be==="0"?">="+Q+"."+be+"."+Be+Oe+" <"+Q+"."+be+"."+(+Be+1):">="+Q+"."+be+"."+Be+Oe+" <"+Q+"."+(+be+1)+".0":">="+Q+"."+be+"."+Be+Oe+" <"+(+Q+1)+".0.0"):(C("no pr"),Xe=Q==="0"?be==="0"?">="+Q+"."+be+"."+Be+" <"+Q+"."+be+"."+(+Be+1):">="+Q+"."+be+"."+Be+" <"+Q+"."+(+be+1)+".0":">="+Q+"."+be+"."+Be+" <"+(+Q+1)+".0.0"),C("caret return",Xe),Xe})}(it,_e)}).join(" ")}(Ge,xe),C("caret",Ge),Ge=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[j]:l[z];return tt.replace(st,function(Y,Q,be,Be,Oe){var Xe;return C("tilde",tt,Y,Q,be,Be,Oe),Ie(Q)?Xe="":Ie(be)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=">="+Q+"."+be+".0 <"+Q+"."+(+be+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+Q+"."+be+"."+Be+Oe+" <"+Q+"."+(+be+1)+".0"):Xe=">="+Q+"."+be+"."+Be+" <"+Q+"."+(+be+1)+".0",C("tilde return",Xe),Xe})}(it,_e)}).join(" ")}(Ge,xe),C("tildes",Ge),Ge=function(Ye,_e){return C("replaceXRanges",Ye,_e),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[m]:l[u];return tt.replace(st,function(Y,Q,be,Be,Oe,Xe){C("xRange",tt,Y,Q,be,Be,Oe,Xe);var nt=Ie(be),ft=nt||Ie(Be),wt=ft||Ie(Oe);return Q==="="&&wt&&(Q=""),nt?Y=Q===">"||Q==="<"?"<0.0.0":"*":Q&&wt?(ft&&(Be=0),wt&&(Oe=0),Q===">"?(Q=">=",ft?(be=+be+1,Be=0,Oe=0):wt&&(Be=+Be+1,Oe=0)):Q==="<="&&(Q="<",ft?be=+be+1:Be=+Be+1),Y=Q+be+"."+Be+"."+Oe):ft?Y=">="+be+".0.0 <"+(+be+1)+".0.0":wt&&(Y=">="+be+"."+Be+".0 <"+be+"."+(+Be+1)+".0"),C("xRange return",Y),Y})}(it,_e)}).join(" ")}(Ge,xe),C("xrange",Ge),Ge=function(Ye,_e){return C("replaceStars",Ye,_e),Ye.trim().replace(l[ye],"")}(Ge,xe),C("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Ne)})),Ue=Ue.map(function(Qe){return new ie(Qe,x)})},ge.prototype.intersects=function(q,x){if(!(q instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Ne){return q.set.some(function(Ue){return Ue.every(function(Qe){return Ne.intersects(Qe,x)})})})})},e.toComparators=function(q,x){return new ge(q,x).set.map(function(ce){return ce.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ve(q,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,ce){var Ne=null,Ue=null;try{var Qe=new ge(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==-1||(Ue=new ve(Ne=Ge,ce)))}),Ne},e.minSatisfying=function(q,x,ce){var Ne=null,Ue=null;try{var Qe=new ge(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==1||(Ue=new ve(Ne=Ge,ce)))}),Ne},e.validRange=function(q,x){try{return new ge(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ce){return J(q,x,"<",ce)},e.gtr=function(q,x,ce){return J(q,x,">",ce)},e.outside=J,e.prerelease=function(q,x){var ce=ae(q,x);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(q,x,ce){return q=new ge(q,ce),x=new ge(x,ce),q.intersects(x)},e.coerce=function(q){if(q instanceof ve)return q;if(typeof q!="string")return null;var x=q.match(l[h]);return x==null?null:ae((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(we,e){var y,M,C=we.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(y===setTimeout)return setTimeout(t,0);if((y===T||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:T}catch{y=T}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var D,f=[],R=!1,k=-1;function a(){R&&D&&(R=!1,D.length?f=D.concat(f):k=-1,f.length&&b())}function b(){if(!R){var t=l(a);R=!0;for(var i=f.length;i;){for(D=f,f=[];++k<i;)D&&D[k].run();k=-1,i=f.length}D=null,R=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function g(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];f.push(new $(t,i)),f.length!==1||R||l(b)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=g,C.addListener=g,C.once=g,C.off=g,C.removeListener=g,C.removeAllListeners=g,C.emit=g,C.prependListener=g,C.prependOnceListener=g,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Yd=C;function T(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(n=>typeof n=="function"):!1}e.$Zd=T;function A(E){const v=E;return v?T(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$1d=A;function l(E,v){return new D(E,v)}e.$2d=l;class D{constructor(v,n){this.e=v,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(n=>n(v))}h(v){this.c.error.length===0?(0,y.$1)(v):this.c.error.slice(0).forEach(n=>n(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,n){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(v,n){if(this.a.destroyed)return;let r;switch(v){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(n);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(E,v){const n=[];let r;for(;(r=E.read())!==null;)n.push(r);return v(n)}e.$3d=f;function R(E,v,n){const r=[];let s;for(;(s=E.read())!==null&&r.length<n;)r.push(s);return s===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return E.read()}}}e.$4d=R;function k(E,v){return new Promise((n,r)=>{const s=[];a(E,{onData:o=>{v&&s.push(o)},onError:o=>{v?r(o):n(void 0)},onEnd:()=>{n(v?v(s):void 0)}})})}e.$5d=k;function a(E,v,n){E.on("error",r=>{n?.isCancellationRequested||v.onError(r)}),E.on("end",()=>{n?.isCancellationRequested||v.onEnd()}),E.on("data",r=>{n?.isCancellationRequested||v.onData(r)})}e.$6d=a;function b(E,v){return new Promise((n,r)=>{const s=new M.$Rc,o=[],w=S=>{if(o.push(S),o.length>v)return s.dispose(),E.pause(),n({stream:E,buffer:o,ended:!1})},d=S=>(s.dispose(),r(S)),I=()=>(s.dispose(),n({stream:E,buffer:o,ended:!0}));s.add((0,M.$Qc)(()=>E.removeListener("error",d))),E.on("error",d),s.add((0,M.$Qc)(()=>E.removeListener("end",I))),E.on("end",I),s.add((0,M.$Qc)(()=>E.removeListener("data",w))),E.on("data",w)})}e.$7d=b;function $(E,v){const n=l(v);return n.end(E),n}e.$8d=$;function g(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=g;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$0d=t;function i(E,v,n){const r=l(n);return a(E,{onData:s=>r.write(v.data(s)),onError:s=>r.error(v.error?v.error(s):s),onEnd:()=>r.end()}),r}e.$$d=i;function c(E,v,n){let r=!1;return{read:()=>{const s=v.read();return r?s:(r=!0,s!==null?n([E,s]):E)}}}e.$_d=c;function p(E,v,n){let r=!1;const s=l(n);return a(v,{onData:o=>r?s.write(o):(r=!0,s.write(n([E,o]))),onError:o=>s.error(o),onEnd:()=>{r||(r=!0,s.write(E)),s.end()}}),s}e.$ae=p}),define(Ae[26],Re([1,0,42,118]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const C=typeof Buffer<"u",T=new y.$V(()=>new Uint8Array(256));let A,l;class D{static alloc(h){return C?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,P){return!(P?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(h)):(A||(A=new TextEncoder),new D(A.encode(h)))}static fromByteArray(h){const P=D.alloc(h.length);for(let B=0,z=h.length;B<z;B++)P.buffer[B]=h[B];return P}static concat(h,P){if(typeof P>"u"){P=0;for(let j=0,V=h.length;j<V;j++)P+=h[j].byteLength}const B=D.alloc(P);let z=0;for(let j=0,V=h.length;j<V;j++){const N=h[j];B.set(N,z),z+=N.byteLength}return B}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,P){return new D(this.buffer.subarray(h,P))}set(h,P){if(h instanceof D)this.buffer.set(h.buffer,P);else if(h instanceof Uint8Array)this.buffer.set(h,P);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),P);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return a(this.buffer,h)}writeUInt32BE(h,P){b(this.buffer,h,P)}readUInt32LE(h){return $(this.buffer,h)}writeUInt32LE(h,P){g(this.buffer,h,P)}readUInt8(h){return t(this.buffer,h)}writeUInt8(h,P){i(this.buffer,h,P)}indexOf(h,P=0){return f(this.buffer,h instanceof D?h.buffer:h,P)}}e.$be=D;function f(m,h,P=0){const B=h.byteLength,z=m.byteLength;if(B===0)return 0;if(B===1)return m.indexOf(h[0]);if(B>z-P)return-1;const j=T.value;j.fill(h.length);for(let se=0;se<h.length;se++)j[h[se]]=h.length-se-1;let V=P+h.length-1,N=V,O=-1;for(;V<z;)if(m[V]===h[N]){if(N===0){O=V;break}V--,N--}else V+=Math.max(h.length-N,j[m[V]]),N=h.length-1;return O}e.$ce=f;function R(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0}e.$de=R;function k(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255}e.$ee=k;function a(m,h){return m[h]*2**24+m[h+1]*2**16+m[h+2]*2**8+m[h+3]}e.$fe=a;function b(m,h,P){m[P+3]=h,h=h>>>8,m[P+2]=h,h=h>>>8,m[P+1]=h,h=h>>>8,m[P]=h}e.$ge=b;function $(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0|m[h+2]<<16>>>0|m[h+3]<<24>>>0}e.$he=$;function g(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255,h=h>>>8,m[P+2]=h&255,h=h>>>8,m[P+3]=h&255}e.$ie=g;function t(m,h){return m[h]}e.$je=t;function i(m,h,P){m[P]=h}e.$ke=i;function c(m){return M.$3d(m,h=>D.concat(h))}e.$le=c;function p(m){return M.$0d(m)}e.$me=p;function E(m){return M.$5d(m,h=>D.concat(h))}e.$ne=E;async function v(m){return m.ended?D.concat(m.buffer):D.concat([...m.buffer,await E(m.stream)])}e.$oe=v;function n(m){return M.$8d(m,h=>D.concat(h))}e.$pe=n;function r(m){return M.$$d(m,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.$qe=r;function s(m){return M.$2d(h=>D.concat(h),m)}e.$re=s;function o(m,h){return M.$_d(m,h,P=>D.concat(P))}e.$se=o;function w(m,h){return M.$ae(m,h,P=>D.concat(P))}e.$te=w;function d(m){let h=0,P=0,B=0;const z=new Uint8Array(Math.floor(m.length/4*3)),j=N=>{switch(P){case 3:z[B++]=h|N,P=0;break;case 2:z[B++]=h|N>>>2,h=N<<6,P=3;break;case 1:z[B++]=h|N>>>4,h=N<<4,P=2;break;default:h=N<<2,P=1}};for(let N=0;N<m.length;N++){const O=m.charCodeAt(N);if(O>=65&&O<=90)j(O-65);else if(O>=97&&O<=122)j(O-97+26);else if(O>=48&&O<=57)j(O-48+52);else if(O===43||O===45)j(62);else if(O===47||O===95)j(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${m[N]}`)}}const V=B;for(;P>0;)j(0);return D.wrap(z).slice(0,V)}e.$ue=d;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},h=!0,P=!1){const B=P?S:I;let z="";const j=m.byteLength%3;let V=0;for(;V<m.byteLength-j;V+=3){const N=m[V+0],O=m[V+1],se=m[V+2];z+=B[N>>>2],z+=B[(N<<4|O>>>4)&63],z+=B[(O<<2|se>>>6)&63],z+=B[se&63]}if(j===1){const N=m[V+0];z+=B[N>>>2],z+=B[N<<4&63],h&&(z+="==")}else if(j===2){const N=m[V+0],O=m[V+1];z+=B[N>>>2],z+=B[(N<<4|O>>>4)&63],z+=B[O<<2&63],h&&(z+="=")}return z}e.$ve=u}),define(Ae[119],Re([1,0,28,16]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function C(...ie){return function(oe,ge){for(let Ie=0,F=ie.length;Ie<F;Ie++){const K=ie[Ie](oe,ge);if(K)return K}return null}}e.or=C,e.$Cj=T.bind(void 0,!1),e.$Dj=T.bind(void 0,!0);function T(ie,oe,ge){if(!ge||ge.length<oe.length)return null;let Ie;return ie?Ie=M.$3e(ge,oe):Ie=ge.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(ie,oe){const ge=oe.toLowerCase().indexOf(ie.toLowerCase());return ge===-1?null:[{start:ge,end:ge+ie.length}]}e.$Ej=A;function l(ie,oe){return D(ie.toLowerCase(),oe.toLowerCase(),0,0)}e.$Fj=l;function D(ie,oe,ge,Ie){if(ge===ie.length)return[];if(Ie===oe.length)return null;if(ie[ge]===oe[Ie]){let F=null;return(F=D(ie,oe,ge+1,Ie+1))?i({start:Ie,end:Ie+1},F):null}return D(ie,oe,ge,Ie+1)}function f(ie){return 97<=ie&&ie<=122}function R(ie){return 65<=ie&&ie<=90}e.$Gj=R;function k(ie){return 48<=ie&&ie<=57}function a(ie){return ie===32||ie===9||ie===10||ie===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>b.add(ie.charCodeAt(0)));function $(ie){return a(ie)||b.has(ie)}function g(ie,oe){return ie===oe||$(ie)&&$(oe)}function t(ie){return f(ie)||R(ie)||k(ie)}function i(ie,oe){return oe.length===0?oe=[ie]:ie.end===oe[0].start?oe[0].start=ie.start:oe.unshift(ie),oe}function c(ie,oe){for(let ge=oe;ge<ie.length;ge++){const Ie=ie.charCodeAt(ge);if(R(Ie)||k(Ie)||ge>0&&!t(ie.charCodeAt(ge-1)))return ge}return ie.length}function p(ie,oe,ge,Ie){if(ge===ie.length)return[];if(Ie===oe.length)return null;if(ie[ge]!==oe[Ie].toLowerCase())return null;{let F=null,K=Ie+1;for(F=p(ie,oe,ge+1,Ie+1);!F&&(K=c(oe,K))<oe.length;)F=p(ie,oe,ge+1,K),K++;return F===null?null:i({start:Ie,end:Ie+1},F)}}function E(ie){let oe=0,ge=0,Ie=0,F=0,K=0;for(let ce=0;ce<ie.length;ce++)K=ie.charCodeAt(ce),R(K)&&oe++,f(K)&&ge++,t(K)&&Ie++,k(K)&&F++;const G=oe/ie.length,J=ge/ie.length,q=Ie/ie.length,x=F/ie.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function v(ie){const{upperPercent:oe,lowerPercent:ge}=ie;return ge===0&&oe>.6}function n(ie){const{upperPercent:oe,lowerPercent:ge,alphaPercent:Ie,numericPercent:F}=ie;return ge>.2&&oe<.8&&Ie>.6&&F<.2}function r(ie){let oe=0,ge=0,Ie=0,F=0;for(let K=0;K<ie.length;K++)Ie=ie.charCodeAt(K),R(Ie)&&oe++,f(Ie)&&ge++,a(Ie)&&F++;return(oe===0||ge===0)&&F===0?ie.length<=30:oe<=5}function s(ie,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(ie)||oe.length>60)return null;const ge=E(oe);if(!n(ge)){if(!v(ge))return null;oe=oe.toLowerCase()}let Ie=null,F=0;for(ie=ie.toLowerCase();F<oe.length&&(Ie=p(ie,oe,0,F))===null;)F=c(oe,F+1);return Ie}e.$Hj=s;function o(ie,oe,ge=!1){if(!oe||oe.length===0)return null;let Ie=null,F=0;for(ie=ie.toLowerCase(),oe=oe.toLowerCase();F<oe.length&&(Ie=w(ie,oe,0,F,ge))===null;)F=d(oe,F+1);return Ie}e.$Ij=o;function w(ie,oe,ge,Ie,F){if(ge===ie.length)return[];if(Ie===oe.length)return null;if(g(ie.charCodeAt(ge),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=w(ie,oe,ge+1,Ie+1,F),!F)for(;!K&&(G=d(oe,G))<oe.length;)K=w(ie,oe,ge+1,G,F),G++;return K?ie.charCodeAt(ge)!==oe.charCodeAt(Ie)?K:i({start:Ie,end:Ie+1},K):null}else return null}function d(ie,oe){for(let ge=oe;ge<ie.length;ge++)if($(ie.charCodeAt(ge))||ge>0&&$(ie.charCodeAt(ge-1)))return ge;return ie.length}const I=C(e.$Dj,s,A),S=C(e.$Dj,s,l),u=new y.$Dc(1e4);function m(ie,oe,ge=!1){if(typeof ie!="string"||typeof oe!="string")return null;let Ie=u.get(ie);Ie||(Ie=new RegExp(M.$Le(ie),"i"),u.set(ie,Ie));const F=Ie.exec(oe);return F?[{start:F.index,end:F.index+F[0].length}]:ge?S(ie,oe):I(ie,oe)}e.$Jj=m;function h(ie,oe){const ge=ee(ie,ie.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ge?B(ge):null}e.$Kj=h;function P(ie,oe,ge,Ie,F,K){const G=Math.min(13,ie.length);for(;ge<G;ge++){const J=ee(ie,oe,ge,Ie,F,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,K]}e.$Lj=P;function B(ie){if(typeof ie>"u")return[];const oe=[],ge=ie[1];for(let Ie=ie.length-1;Ie>1;Ie--){const F=ie[Ie]+ge,K=oe[oe.length-1];K&&K.end===F?K.end=F+1:oe.push({start:F,end:F+1})}return oe}e.$Mj=B;const z=128;function j(){const ie=[],oe=[];for(let ge=0;ge<=z;ge++)oe[ge]=0;for(let ge=0;ge<=z;ge++)ie.push(oe.slice(0));return ie}function V(ie){const oe=[];for(let ge=0;ge<=ie;ge++)oe[ge]=0;return oe}const N=V(2*z),O=V(2*z),se=j(),X=j(),Ee=j(),Pe=!1;function Se(ie,oe,ge,Ie,F){function K(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Ie.split("").map(J=>K(J,3)).join("|")}
`;for(let J=0;J<=ge;J++)J===0?G+=" |":G+=`${oe[J-1]}|`,G+=ie[J].slice(0,F+1).map(q=>K(q.toString(),3)).join("|")+`
`;return G}function fe(ie,oe,ge,Ie){ie=ie.substr(oe),ge=ge.substr(Ie),console.log(Se(X,ie,ie.length,ge,ge.length)),console.log(Se(Ee,ie,ie.length,ge,ge.length)),console.log(Se(se,ie,ie.length,ge,ge.length))}function ye(ie,oe){if(oe<0||oe>=ie.length)return!1;const ge=ie.codePointAt(oe);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$if(ge)}}function ue(ie,oe){if(oe<0||oe>=ie.length)return!1;switch(ie.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ae(ie,oe,ge){return oe[ie]!==ge[ie]}function ve(ie,oe,ge,Ie,F,K,G=!1){for(;oe<ge&&F<K;)ie[oe]===Ie[F]&&(G&&(N[oe]=F),oe+=1),F+=1;return oe===ge}e.$Nj=ve;var _;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(_||(_={}));var W;(function(ie){ie.Default=[-100,0];function oe(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}ie.isDefault=oe})(W||(e.FuzzyScore=W={}));class Z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,ge){this.firstMatchCanBeWeak=oe,this.boostFullMatch=ge}}e.$Oj=Z;function ee(ie,oe,ge,Ie,F,K,G=Z.default){const J=ie.length>z?z:ie.length,q=Ie.length>z?z:Ie.length;if(ge>=J||K>=q||J-ge>q-K||!ve(oe,ge,J,F,K,q,!0))return;pe(J,q,ge,K,oe,F);let x=1,ce=1,Ne=ge,Ue=K;const Qe=[!1];for(x=1,Ne=ge;Ne<J;x++,Ne++){const it=N[Ne],tt=O[Ne],ze=Ne+1<J?O[Ne+1]:q;for(ce=it-K+1,Ue=it;Ue<ze;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,Y=!1;Ue<=tt&&(st=$e(ie,oe,Ne,ge,Ie,F,Ue,q,K,se[x-1][ce-1]===0,Qe));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=st+X[x-1][ce-1]);const be=Ue>it,Be=be?X[x][ce-1]+(se[x][ce-1]>0?-5:0):0,Oe=Ue>it+1&&se[x][ce-1]>0,Xe=Oe?X[x][ce-2]+(se[x][ce-2]>0?-5:0):0;if(Oe&&(!be||Xe>=Be)&&(!Y||Xe>=Q))X[x][ce]=Xe,Ee[x][ce]=3,se[x][ce]=0;else if(be&&(!Y||Be>=Q))X[x][ce]=Be,Ee[x][ce]=2,se[x][ce]=0;else if(Y)X[x][ce]=Q,Ee[x][ce]=1,se[x][ce]=se[x-1][ce-1]+1;else throw new Error("not possible")}}if(Pe&&fe(ie,ge,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ce--;const Ge=[X[x][ce],K];let xe=0,Ye=0;for(;x>=1;){let it=ce;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);xe>1&&oe[ge+x-1]===F[K+ce-1]&&!ae(it+K-1,Ie,F)&&xe+1>se[x][it]&&(it=ce),it===ce?xe++:xe=1,Ye||(Ye=it),x--,ce=it-1,Ge.push(ce)}q===J&&G.boostFullMatch&&(Ge[0]+=2);const _e=Ye-J;return Ge[0]-=_e,Ge}e.$Pj=ee;function pe(ie,oe,ge,Ie,F,K){let G=ie-1,J=oe-1;for(;G>=ge&&J>=Ie;)F[G]===K[J]&&(O[G]=J,G--),J--}function $e(ie,oe,ge,Ie,F,K,G,J,q,x,ce){if(oe[ge]!==K[G])return Number.MIN_SAFE_INTEGER;let Ne=1,Ue=!1;return G===ge-Ie?Ne=ie[ge]===F[G]?7:5:ae(G,F,K)&&(G===0||!ae(G-1,F,K))?(Ne=ie[ge]===F[G]?7:5,Ue=!0):ye(K,G)&&(G===0||!ye(K,G-1))?Ne=5:(ye(K,G-1)||ue(K,G-1))&&(Ne=5,Ue=!0),Ne>1&&ge===Ie&&(ce[0]=!0),Ue||(Ue=ae(G,F,K)||ye(K,G-1)||ue(K,G-1)),ge===Ie?G>q&&(Ne-=Ue?3:5):x?Ne+=Ue?2:0:Ne+=Ue?0:1,G+1===J&&(Ne-=Ue?3:5),Ne}function he(ie,oe,ge,Ie,F,K,G){return ne(ie,oe,ge,Ie,F,K,!0,G)}e.$Qj=he;function De(ie,oe,ge,Ie,F,K,G){return ne(ie,oe,ge,Ie,F,K,!1,G)}e.$Rj=De;function ne(ie,oe,ge,Ie,F,K,G,J){let q=ee(ie,oe,ge,Ie,F,K,J);if(q&&!G)return q;if(ie.length>=3){const x=Math.min(7,ie.length-1);for(let ce=ge+1;ce<x;ce++){const Ne=le(ie,ce);if(Ne){const Ue=ee(Ne,Ne.toLowerCase(),ge,Ie,F,K,J);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function le(ie,oe){if(oe+1>=ie.length)return;const ge=ie[oe],Ie=ie[oe+1];if(ge!==Ie)return ie.slice(0,oe)+Ie+ge+ie.slice(oe+2)}}),define(Ae[29],Re([1,0,16]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const T="error",A="warning",l="warn",D="info",f="ignore";function R(a){return a?y.$2e(T,a)?C.Error:y.$2e(A,a)||y.$2e(l,a)?C.Warning:y.$2e(D,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function k(a){switch(a){case C.Error:return T;case C.Warning:return A;case C.Info:return D;default:return f}}C.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,16]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const $=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return $-g}value(){return this.b[this.c]}}e.$Rh=C;class T{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,M.$Ve)(b,this.b,0,b.length,this.c,this.d):(0,M.$Xe)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=T;class A{constructor(b=!0,$=!0){this.f=b,this.g=$}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let $=b.length-1;$>=0;$--,this.c--){const g=this.b.charCodeAt($);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,M.$Ve)(b,this.b,0,b.length,this.d,this.e):(0,M.$Xe)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var l;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(l||(l={}));class D{constructor(b,$){this.f=b,this.g=$,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,M.$We)(b,this.c.scheme);if(this.d[this.e]===2)return(0,M.$We)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,M.$Ue)(b,this.c.query);if(this.d[this.e]===5)return(0,M.$Ue)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=D;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(R||(R={}));class k{static forUris(b=()=>!1,$=()=>!1){return new k(new D(b,$))}static forPaths(b=!1){return new k(new A(void 0,!b))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new T)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,$){if($){const g=$.slice(0);(0,y.$Xb)(g);for(const t of g)this.set(t,b)}else{const g=b.slice(0);(0,y.$Xb)(g);for(const t of g)this.set(t[0],t[1])}}set(b,$){const g=this.b.reset(b);let t;this.c||(this.c=new f,this.c.segment=g.value());const i=[];for(t=this.c;;){const p=g.cmp(t.segment);if(p>0)t.left||(t.left=new f,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(p<0)t.right||(t.right=new f,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new f,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=b;for(let p=i.length-1;p>=0;p--){const E=i[p][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const n=i[p][0],r=i[p+1][0];if(n===1&&r===1)i[p][1]=E.rotateLeft();else if(n===-1&&r===-1)i[p][1]=E.rotateRight();else if(n===1&&r===-1)E.right=i[p+1][1]=i[p+1][1].rotateRight(),i[p][1]=E.rotateLeft();else if(n===-1&&r===1)E.left=i[p+1][1]=i[p+1][1].rotateLeft(),i[p][1]=E.rotateRight();else throw new Error;if(p>0)switch(i[p-1][0]){case-1:i[p-1][1].left=i[p][1];break;case 1:i[p-1][1].right=i[p][1];break;case 0:i[p-1][1].mid=i[p][1];break}else this.c=i[0][1]}}return c}get(b){return this.d(b)?.value}d(b){const $=this.b.reset(b);let g=this.c;for(;g;){const t=$.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if($.hasNext())$.next(),g=g.mid;else break}return g}has(b){const $=this.d(b);return!($?.value===void 0&&$?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,$){const g=this.b.reset(b),t=[];let i=this.c;for(;i;){const c=g.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:p,value:E,segment:v}=c;this.e(c.key,!1),i.key=p,i.value=E,i.segment=v}}else{const c=i.left??i.right;if(t.length>0){const[p,E]=t[t.length-1];switch(p){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const p=t[c][1];p.updateHeight();const E=p.balanceFactor();if(E>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),t[c][1]=p.rotateLeft()):E<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),t[c][1]=p.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const $=this.b.reset(b);let g=this.c,t;for(;g;){const i=$.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if($.hasNext())$.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(b){return this.g(b,!1)}g(b,$){const g=this.b.reset(b);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[$,g]of this)b(g,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const $=[];return this.j(b,$),$[Symbol.iterator]()}j(b,$){b&&(b.left&&this.j(b.left,$),b.value&&$.push([b.key,b.value]),b.mid&&this.j(b.mid,$),b.right&&this.j(b.right,$))}_isBalanced(){const b=$=>{if(!$)return!0;const g=$.balanceFactor();return g<-1||g>1?!1:b($.left)&&b($.right)};return b(this.c)}}e.$Vh=k}),define(Ae[43],Re([1,0,89]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var M;(function(A){function l(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Vj=C;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(c){const p=l.exec(c.id);if(!p)return D(y.$Uj.error);const[,E,v]=p,n=["codicon","codicon-"+E];return v&&n.push("codicon-modifier-"+v.substring(1)),n}A.asClassNameArray=D;function f(c){return D(c).join(" ")}A.asClassName=f;function R(c){return"."+D(c).join(".")}A.asCSSSelector=R;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}A.isThemeIcon=k;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(c){const p=a.exec(c);if(!p)return;const[,E]=p;return{id:E}}A.fromString=b;function $(c){return{id:c}}A.fromId=$;function g(c,p){let E=c.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),p&&(E=`${E}~${p}`),{id:E}}A.modify=g;function t(c){const p=c.id.lastIndexOf("~");if(p!==-1)return c.id.substring(p+1)}A.getModifier=t;function i(c,p){return c.id===p.id&&c.color?.id===p.color?.id}A.isEqual=i})(T||(e.ThemeIcon=T={}))}),define(Ae[121],Re([1,0,119,16,43]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const T="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function D(i){return i.replace(l,(c,p)=>p?c:`\\${c}`)}e.$Wj=D;const f=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace(f,c=>`\\${c}`)}e.$Xj=R;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(i){return i.indexOf(T)===-1?i:i.replace(k,(c,p,E,v)=>E?c:p||v||"")}e.$Yj=a;function b(i){return i?i.replace(/\$\((.*?)\)/g,(c,p)=>` ${p} `).trim():""}e.$Zj=b;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){$.lastIndex=0;let c="";const p=[];let E=0;for(;;){const v=$.lastIndex,n=$.exec(i),r=i.substring(v,n?.index);if(r.length>0){c+=r;for(let s=0;s<r.length;s++)p.push(E)}if(!n)break;E+=n[0].length}return{text:c,iconOffsets:p}}e.$1j=g;function t(i,c,p=!1){const{text:E,iconOffsets:v}=c;if(!v||v.length===0)return(0,y.$Jj)(i,E,p);const n=(0,M.$Je)(E," "),r=E.length-n.length,s=(0,y.$Jj)(i,n,p);if(s)for(const o of s){const w=v[o.start+r]+r;o.start+=w,o.end+=w}return s}e.$2j=t}),define(Ae[36],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return y.test(C)}e.$dg=M,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let D=0;D<l.length;D++)l[D]=Math.floor(Math.random()*256);return l};const T=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,f="";return f+=A[T[D++]],f+=A[T[D++]],f+=A[T[D++]],f+=A[T[D++]],f+="-",f+=A[T[D++]],f+=A[T[D++]],f+="-",f+=A[T[D++]],f+=A[T[D++]],f+="-",f+=A[T[D++]],f+=A[T[D++]],f+="-",f+=A[T[D++]],f+=A[T[D++]],f+=A[T[D++]],f+=A[T[D++]],f+=A[T[D++]],f+=A[T[D++]],f}}()}),define(Ae[122],Re([1,0,18,66,36]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function T(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Ys=T;function A(k,a,b){const $={id:(0,C.$eg)(),name:k,uri:a,data:b};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Zs=A;class l{constructor(){this.a=new Map}get size(){let a=0;for(const b of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const b=[...this.a.keys()];return M.Iterable.some(this,([$,g])=>g.asFile())&&b.push("files"),R(D(a),b)}get(a){return this.a.get(this.b(a))?.[0]}append(a,b){const $=this.a.get(a);$?$.push(b):this.a.set(this.b(a),[b])}replace(a,b){this.a.set(this.b(a),[b])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,b]of this.a)for(const $ of b)yield[a,$]}b(a){return D(a)}}e.$1s=l;function D(k){return k.toLowerCase()}function f(k,a){return R(D(k),a.map(D))}e.$2s=f;function R(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const b=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[$,g,t]=b;return t==="*"?a.some(i=>i.startsWith(g+"/")):!1}e.$3s=Object.freeze({create:k=>(0,y.$Mb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$3s.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0,e.$3r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let D=0,f=l.notIn.length;D<f;D++)switch(l.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,D){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(D-2),R=l.getStandardTokenType(f);return this.isOK(R)}g(l,D){for(let f=l;f<=D;f++){const R=String.fromCharCode(f);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$pt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of l)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$qt=C;function T(A,l,D){A.has(l)?A.get(l).push(D):A.set(l,[D])}}),define(Ae[125],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7=e.$L7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$L7=y;class M{constructor(T){this.identifier=T}}e.$M7=M}),define(Ae[126],Re([10,11]),function(we,e){return we.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class T extends M.$Sc{constructor(a,b="",$="",g=!0,t){super(),this.h=this.B(new y.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=b,this.u=$,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,b){this.C&&await this.C(a)}}e.$ui=T;class A extends M.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Nd),this.onWillRun=this.f.event,this.m=this.B(new y.$Nd),this.onDidRun=this.m.event}async run(a,b){if(!a.enabled)return;this.f.fire({action:a});let $;try{await this.u(a,b)}catch(g){$=g}this.m.fire({action:a,error:$})}async u(a,b){await a.run(b)}}e.$vi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let b=[];for(const $ of a)$.length&&(b.length?b=[...b,new l,...$]:b=$);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=l;class D{get actions(){return this.a}constructor(a,b,$,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=b,this.class=g,this.a=$}async run(){}}e.$xi=D;class f extends T{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,C.localize(0,null),void 0,!1)}}e.$yi=f;function R(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$zi=R}),define(Ae[128],Re([10,11]),function(we,e){return we.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const M=60,C=M*60,T=C*24,A=T*7,l=T*30,D=T*365;function f(k,a,b,$){typeof k!="number"&&(k=k.getTime());const g=Math.round((new Date().getTime()-k)/1e3);if(g<-30)return(0,y.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!$&&g<30)return(0,y.localize)(1,null);let t;return g<M?(t=g,a?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):g<C?(t=Math.floor(g/M),a?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):g<T?(t=Math.floor(g/C),a?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):g<A?(t=Math.floor(g/T),a?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):g<l?(t=Math.floor(g/A),a?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):g<D?(t=Math.floor(g/l),a?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(g/D),a?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$dm=f;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=R}),define(Ae[130],Re([10,11]),function(we,e){return we.create("vs/base/common/errorMessage",e)}),define(Ae[37],Re([1,0,18,15,130]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function T(k,a){return a&&(k.stack||k.stacktrace)?C.localize(0,null,l(k),A(k.stack)||A(k.stacktrace)):l(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function l(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function D(k=null,a=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const b=y.$Hb(k),$=D(b[0],a);return b.length>1?C.localize(4,null,$,b.length):$}if(M.$yf(k))return k;if(k.detail){const b=k.detail;if(b.error)return T(b.error,a);if(b.exception)return T(b.exception,a)}return k.stack?T(k,a):k.message?k.message:C.localize(5,null)}e.$Ai=D;function f(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$Bi=f;function R(k,a){let b;return typeof k=="string"?b=new Error(k):b=k,b.actions=a,b}e.$Ci=R}),define(Ae[131],Re([1,0,42,20]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=void 0;const C=new y.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),T=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,m=!1){const h=S||"",P=u||"",B=C.value.collator.compare(h,P);return C.value.collatorIsNumeric&&B===0&&h!==P?h<P?-1:1:B}e.$hq=l;function D(S,u){const m=T.value.collator;return S=S||"",u=u||"",E(m,S,u)}e.$iq=D;function f(S,u){const m=T.value.collator;return S=S||"",u=u||"",s(S,u)||E(m,S,u)}e.$jq=f;function R(S,u){const m=T.value.collator;return S=S||"",u=u||"",r(S,u)||E(m,S,u)}e.$kq=R;function k(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$lq=k;function a(S,u){const[m,h]=c(S),[P,B]=c(u);let z=C.value.collator.compare(h,B);if(z===0){if(C.value.collatorIsNumeric&&h!==B)return h<B?-1:1;if(z=C.value.collator.compare(m,P),C.value.collatorIsNumeric&&z===0&&m!==P)return m<P?-1:1}return z}e.$mq=a;function b(S,u){S=S||"",u=u||"";const m=p(S),h=p(u),P=T.value.collator,B=A.value.collator;return E(B,m,h)||E(P,S,u)}e.$nq=b;function $(S,u){S=S||"",u=u||"";const m=p(S),h=p(u),P=T.value.collator,B=A.value.collator;return E(B,m,h)||s(S,u)||E(P,S,u)}e.$oq=$;function g(S,u){S=S||"",u=u||"";const m=p(S),h=p(u),P=T.value.collator,B=A.value.collator;return E(B,m,h)||r(S,u)||E(P,S,u)}e.$pq=g;function t(S,u){S=S||"",u=u||"";const m=p(S).toLowerCase(),h=p(u).toLowerCase();return m!==h?m<h?-1:1:S!==u?S<u?-1:1:0}e.$qq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(S,u=!1){const m=S?i.exec(S):[];let h=[m&&m[1]||"",m&&m[3]||""];return u&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function p(S){const u=S?i.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,m){const h=S.compare(u,m);return h!==0?h:u.length!==m.length?u.length<m.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function n(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function r(S,u){return v(S)&&n(u)?-1:n(S)&&v(u)?1:0}function s(S,u){return n(S)&&v(u)?-1:v(S)&&n(u)?1:0}function o(S,u,m=!1){return m||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function w(S,u,m=!1){const h=S.split(M.sep),P=u.split(M.sep),B=h.length-1,z=P.length-1;let j,V;for(let N=0;;N++){if(j=B===N,V=z===N,j&&V)return l(h[N],P[N],m);if(j)return-1;if(V)return 1;const O=o(h[N],P[N],m);if(O!==0)return O}}e.$rq=w;function d(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),B=I(S,u,m);if(B)return B;const z=h.endsWith(m),j=P.endsWith(m);if(z!==j)return z?-1:1;const V=l(h,P);return V!==0?V:h.localeCompare(P)}e.$sq=d;function I(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),B=h.startsWith(m),z=P.startsWith(m);if(B!==z)return B?-1:1;if(B&&z){if(h.length<P.length)return-1;if(h.length>P.length)return 1}return 0}e.$tq=I}),define(Ae[44],Re([1,0,20,22,16,15]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(d){return d===47||d===92}e.$Qf=A;function l(d){return d.replace(/[\\/]/g,y.$gc.sep)}e.$Rf=l;function D(d){return d.indexOf("/")===-1&&(d=l(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Sf=D;function f(d,I=y.$gc.sep){if(!d)return"";const S=d.length,u=d.charCodeAt(0);if(A(u)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let h=3;const P=h;for(;h<S&&!A(d.charCodeAt(h));h++);if(P!==h&&!A(d.charCodeAt(h+1))){for(h+=1;h<S;h++)if(A(d.charCodeAt(h)))return d.slice(0,h+1).replace(/[\\/]/g,I)}}return I}else if(i(u)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+I:d.slice(0,2);let m=d.indexOf("://");if(m!==-1){for(m+=3;m<S;m++)if(A(d.charCodeAt(m)))return d.slice(0,m+1)}return""}e.$Tf=f;function R(d){if(!M.$j||!d||d.length<5)return!1;let I=d.charCodeAt(0);if(I!==92||(I=d.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<d.length&&(I=d.charCodeAt(S),I!==92);S++);return!(u===S||(I=d.charCodeAt(S+1),isNaN(I)||I===92))}e.$Uf=R;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(d,I=M.$j){const S=I?k:a;return!(!d||d.length===0||/^\s+$/.test(d)||(S.lastIndex=0,S.test(d))||I&&b.test(d)||d==="."||d===".."||I&&d[d.length-1]==="."||I&&d.length!==d.trim().length||d.length>255)}e.$Vf=$;function g(d,I,S){const u=d===I;return!S||u?u:!d||!I?!1:(0,C.$2e)(d,I)}e.$Wf=g;function t(d,I,S,u=y.sep){if(d===I)return!0;if(!d||!I||I.length>d.length)return!1;if(S){if(!(0,C.$3e)(d,I))return!1;if(I.length===d.length)return!0;let h=I.length;return I.charAt(I.length-1)===u&&h--,d.charAt(h)===u}return I.charAt(I.length-1)!==u&&(I+=u),d.indexOf(I)===0}e.$Xf=t;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Yf=i;function c(d,I){return M.$j&&d.endsWith(":")&&(d+=y.sep),(0,y.$ic)(d)||(d=(0,y.$jc)(I,d)),d=(0,y.$hc)(d),M.$j?(d=(0,C.$Ke)(d,y.sep),d.endsWith(":")&&(d+=y.sep)):(d=(0,C.$Ke)(d,y.sep),d||(d=y.sep)),d}e.$Zf=c;function p(d){const I=(0,y.$hc)(d);return M.$j?d.length>3?!1:E(I)&&(d.length===2||I.charCodeAt(2)===92):I===y.$gc.sep}e.$1f=p;function E(d,I=M.$j){return I?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$2f=E;function v(d,I=M.$j){return E(d,I)?d[0]:void 0}e.$3f=v;function n(d,I,S){return I.length>d.length?-1:d===I?0:(S&&(d=d.toLowerCase(),I=I.toLowerCase()),d.indexOf(I))}e.$4f=n;function r(d){const I=d.split(":");let S,u,m;for(const h of I){const P=Number(h);(0,T.$Cf)(P)?u===void 0?u=P:m===void 0&&(m=P):S=S?[S,h].join(":"):h}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.$5f=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(d,I,S=8){let u="";for(let h=0;h<S;h++){let P;h===0&&M.$j&&!I&&(S===3||S===4)?P=o:P=s,u+=P.charAt(Math.floor(Math.random()*P.length))}let m;return I?m=`${I}-${u}`:m=u,d?(0,y.$jc)(d,m):m}e.$6f=w}),define(Ae[67],Re([1,0,20]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0,e.$Pr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const k=(0,y.$oc)(R),a=M[k.toLowerCase()];return a!==void 0?a:A(R)}e.$Qr=T;function A(R){const k=(0,y.$oc)(R);return C[k.toLowerCase()]}e.$Rr=A;function l(R){for(const k in C)if(C[k]===R)return k}e.$Sr=l;const D=/^(.+)\/(.+?)(;.+)?$/;function f(R,k){const a=D.exec(R);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:R}e.$Tr=f}),define(Ae[68],Re([1,0,26,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function C(D){return JSON.stringify(D,A)}e.$kh=C;function T(D){let f=JSON.parse(D);return f=l(f),f}e.$lh=T;function A(D,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(D,f=0){if(!D||f>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return M.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof y.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=l(D[R],f+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=l(D[R],f+1))}return D}e.$mh=l}),define(Ae[13],Re([1,0,9,22,2]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var T;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${T.vscodeRemoteResource}`}set(R,k,a){this.a[R]=k,this.b[R]=a}setConnectionToken(R,k){this.c[R]=k}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return y.$1(t),R}const k=R.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const b=this.b[k],$=this.c[k];let g=`path=${encodeURIComponent(R.path)}`;return typeof $=="string"&&(g+=`&${e.$8f}=${encodeURIComponent($)}`),C.URI.from({scheme:M.$p?this.d:T.vscodeRemoteResource,authority:`${a}:${b}`,path:this.f,query:g})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class l{static{this.a=e.$bg}asBrowserUri(R){const k=this.b(R,we);return this.uriToBrowserUri(k)}uriToBrowserUri(R){return R.scheme===T.vscodeRemote?e.$9f.rewrite(R):R.scheme===T.file&&(M.$n||M.$q&&M.$h.origin===`${T.vscodeFileResource}://${l.a}`)?R.with({scheme:T.vscodeFileResource,authority:R.authority||l.a,query:null,fragment:null}):R}asFileUri(R){const k=this.b(R,we);return this.uriToFileUri(k)}uriToFileUri(R){return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==l.a?R.authority:null,query:null,fragment:null}):R}b(R,k){return C.URI.isUri(R)?R:C.URI.parse(k.toUrl(R))}}e.$cg=new l;var D;(function(f){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(R.get("3"));const k="vscode-coi";function a($){let g;typeof $=="string"?g=new URL($).searchParams:$ instanceof URL?g=$.searchParams:C.URI.isUri($)&&(g=new URL($.toString(!0)).searchParams);const t=g?.get(k);if(t)return R.get(t)}f.getHeadersFromQuery=a;function b($,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(k,i):$[k]=i}f.addSearchParam=b})(D||(e.COI=D={}))}),define(Ae[23],Re([1,0,44,13,20,22,16,2]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(b){return(0,l.$wc)(b,!0)}e.$jg=D;class f{constructor($){this.a=$}compare($,g,t=!1){return $===g?0:(0,A.$Ue)(this.getComparisonKey($,t),this.getComparisonKey(g,t))}isEqual($,g,t=!1){return $===g?!0:!$||!g?!1:this.getComparisonKey($,t)===this.getComparisonKey(g,t)}getComparisonKey($,g=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,g,t=!1){if($.scheme===g.scheme){if($.scheme===M.Schemas.file)return y.$Xf(D($),D(g),this.a($))&&$.query===g.query&&(t||$.fragment===g.fragment);if((0,e.$Ag)($.authority,g.authority))return y.$Xf($.path,g.path,this.a($),"/")&&$.query===g.query&&(t||$.fragment===g.fragment)}return!1}joinPath($,...g){return l.URI.joinPath($,...g)}basenameOrAuthority($){return(0,e.$sg)($)||$.authority}basename($){return C.$gc.basename($.path)}extname($){return C.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let g;return $.scheme===M.Schemas.file?g=l.URI.file(C.$mc(D($))).path:(g=C.$gc.dirname($.path),$.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),g="/")),$.with({path:g})}normalizePath($){if(!$.path.length)return $;let g;return $.scheme===M.Schemas.file?g=l.URI.file(C.$hc(D($))).path:g=C.$gc.normalize($.path),$.with({path:g})}relativePath($,g){if($.scheme!==g.scheme||!(0,e.$Ag)($.authority,g.authority))return;if($.scheme===M.Schemas.file){const c=C.$lc(D($),D(g));return T.$j?y.$Rf(c):c}let t=$.path||"/";const i=g.path||"/";if(this.a($)){let c=0;for(const p=Math.min(t.length,i.length);c<p&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$gc.relative(t,i)}resolvePath($,g){if($.scheme===M.Schemas.file){const t=l.URI.file(C.$kc(D($),g));return $.with({authority:t.authority,path:t.path})}return g=y.$Sf(g),$.with({path:C.$gc.resolve($.path,g)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,g){return $===g||$!==void 0&&g!==void 0&&(0,A.$2e)($,g)}hasTrailingPathSeparator($,g=C.sep){if($.scheme===M.Schemas.file){const t=D($);return t.length>y.$Tf(t).length&&t[t.length-1]===g}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,g=C.sep){return(0,e.$Bg)($,g)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,g=C.sep){let t=!1;if($.scheme===M.Schemas.file){const i=D($);t=i!==void 0&&i.length===y.$Tf(i).length&&i[i.length-1]===g}else{g="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)($,g)?$.with({path:$.path+"/"}):$}}e.$kg=f,e.$lg=new f(()=>!1),e.$mg=new f(b=>b.scheme===M.Schemas.file?!T.$l:!0),e.$ng=new f(b=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(b,$){const g=[];for(let t=0;t<b.length;t++){const i=$(b[t]);b.some((c,p)=>p===t?!1:(0,e.$pg)(i,$(c)))||g.push(b[t])}return g}e.$Eg=R;var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function $(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(p=>{const[E,v]=p.split(":");E&&v&&t.set(E,v)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&t.set(b.META_DATA_MIME,c),t}b.parseMetaData=$})(k||(e.DataUri=k={}));function a(b,$,g){if($){let t=b.path;return t&&t[0]!==C.$gc.sep&&(t=C.$gc.sep+t),b.with({scheme:g,authority:$,path:t})}return b.with({scheme:g})}e.$Fg=a}),define(Ae[12],Re([1,0,19,9,5,6,23,22,120]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function f(Z){return!!Z&&typeof Z.then=="function"}e.$Gg=f;function R(Z){const ee=new y.$Xd,pe=Z(ee.token),$e=new Promise((he,De)=>{const ne=ee.token.onCancellationRequested(()=>{ne.dispose(),ee.dispose(),De(new M.$5)});Promise.resolve(pe).then(le=>{ne.dispose(),ee.dispose(),he(le)},le=>{ne.dispose(),ee.dispose(),De(le)})});return new class{cancel(){ee.cancel()}then(he,De){return $e.then(he,De)}catch(he){return this.then(void 0,he)}finally(he){return $e.finally(he)}}}e.$Hg=R;function k(Z,ee,pe){return new Promise(($e,he)=>{const De=ee.onCancellationRequested(()=>{De.dispose(),$e(pe)});Z.then($e,he).finally(()=>De.dispose())})}e.$Ig=k;function a(Z,ee){return new Promise((pe,$e)=>{const he=ee.onCancellationRequested(()=>{he.dispose(),$e(new M.$5)});Z.then(pe,$e).finally(()=>he.dispose())})}e.$Jg=a;async function b(Z){let ee=-1;const pe=Z.map(($e,he)=>$e.then(De=>(ee=he,De)));try{return await Promise.race(pe)}finally{Z.forEach(($e,he)=>{he!==ee&&$e.cancel()})}}e.$Kg=b;function $(Z,ee,pe){let $e;const he=setTimeout(()=>{$e?.(void 0),pe?.()},ee);return Promise.race([Z.finally(()=>clearTimeout(he)),new Promise(De=>$e=De)])}e.$Lg=$;function g(Z){return new Promise((ee,pe)=>{const $e=Z();f($e)?$e.then(ee,pe):ee($e)})}e.$Mg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const pe=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(pe,pe).then($e)})}return new Promise((pe,$e)=>{this.b.then(pe,$e)})}return this.a=ee(),new Promise((pe,$e)=>{this.a.then(he=>{this.a=null,pe(he)},he=>{this.a=null,$e(he)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$Og=i;class c{constructor(){this.a=new Map}queue(ee,pe){const he=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(ee)===he&&this.a.delete(ee)});return this.a.set(ee,he),he}}e.$Pg=c;const p=(Z,ee)=>{let pe=!0;const $e=setTimeout(()=>{pe=!1,ee()},Z);return{isTriggered:()=>pe,dispose:()=>{clearTimeout($e),pe=!1}}},E=Z=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Z())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class v{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,pe=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((he,De)=>{this.d=he,this.f=De}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=pe===D.$Kd?E($e):p(pe,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=v;class n{constructor(ee){this.a=new v(ee),this.b=new t}trigger(ee,pe){return this.a.trigger(()=>this.b.queue(ee),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=n;class r{constructor(){this.a=!1,this.b=new Promise((ee,pe)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=r;class s extends r{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$Tg=s;function o(Z,ee){return ee?new Promise((pe,$e)=>{const he=setTimeout(()=>{De.dispose(),pe()},Z),De=ee.onCancellationRequested(()=>{clearTimeout(he),De.dispose(),$e(new M.$5)})}):R(pe=>o(Z,pe))}e.$Ug=o;function w(Z,ee=0,pe){const $e=setTimeout(()=>{Z(),pe&&he.dispose()},ee),he=(0,T.$Qc)(()=>{clearTimeout($e),pe?.deleteAndLeak(he)});return pe?.add(he),he}e.$Vg=w;function d(Z){const ee=[];let pe=0;const $e=Z.length;function he(){return pe<$e?Z[pe++]():null}function De(ne){ne!=null&&ee.push(ne);const le=he();return le?le.then(De):Promise.resolve(ee)}return Promise.resolve(null).then(De)}e.$Wg=d;function I(Z,ee=$e=>!!$e,pe=null){let $e=0;const he=Z.length,De=()=>{if($e>=he)return Promise.resolve(pe);const ne=Z[$e++];return Promise.resolve(ne()).then(ie=>ee(ie)?Promise.resolve(ie):De())};return De()}e.$Xg=I;function S(Z,ee=$e=>!!$e,pe=null){if(Z.length===0)return Promise.resolve(pe);let $e=Z.length;const he=()=>{$e=-1;for(const De of Z)De.cancel?.()};return new Promise((De,ne)=>{for(const le of Z)le.then(ie=>{--$e>=0&&ee(ie)?(he(),De(ie)):$e===0&&De(pe)}).catch(ie=>{--$e>=0&&(he(),ne(ie))})})}e.$Yg=S;class u{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new C.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((pe,$e)=>{this.f.push({factory:ee,c:pe,e:$e}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const pe=ee.factory();pe.then(ee.c,ee.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=u;class m extends u{constructor(){super(1)}}e.$1g=m;class h{constructor(){this.a=new Ee,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$2g=h;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new fe;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,pe=A.$lg){const $e=pe.getComparisonKey(ee);let he=this.a.get($e);if(!he){he=new m;const De=this.f++,ne=C.Event.once(he.onDrained)(()=>{he?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$1c),this.d.set(De,ne),this.a.set($e,he)}return he}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class B{constructor(ee,pe){this.a=-1,typeof ee=="function"&&typeof pe=="number"&&this.setIfNotSet(ee,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},pe)}setIfNotSet(ee,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},pe))}}e.$4g=B;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,pe){this.cancel(),this.a=setInterval(()=>{ee()},pe)}}e.$5g=z;class j{constructor(ee,pe){this.b=-1,this.a=ee,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=j;class V{constructor(ee,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=ee,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=V;class N extends j{constructor(ee,pe){super(ee,pe),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$8g=N;class O extends T.$Sc{constructor(ee,pe){super(),this.g=ee,this.h=pe,this.a=[],this.b=this.B(new T.$Tc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const pe of ee)this.a.push(pe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=Z=>{(0,l.$B)(()=>{if(ee)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$0g=(Z,ee)=>{const pe=requestIdleCallback(Z,typeof ee=="number"?{timeout:ee}:void 0);let $e=!1;return{dispose(){$e||($e=!0,cancelIdleCallback(pe))}}}}();class se{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=se;async function X(Z,ee,pe){let $e;for(let he=0;he<pe;he++)try{return await Z()}catch(De){$e=De,await o(ee)}throw $e}e.$_g=X;class Ee{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,pe,$e){return this.a={taskId:ee,cancel:()=>$e?.(),promise:pe},pe.then(()=>this.d(ee),()=>this.d(ee)),pe}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let pe,$e;const he=new Promise((De,ne)=>{pe=De,$e=ne});this.b={run:ee,promise:he,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Ee;class Pe{constructor(ee,pe=()=>Date.now()){this.d=ee,this.f=pe,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$bh=Pe;var Se;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(Se||(Se={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,pe)=>{this.a=ee,this.b=pe})}complete(ee){return new Promise(pe=>{this.a(ee),this.d={outcome:0,value:ee},pe()})}error(ee){return new Promise(pe=>{this.b(ee),this.d={outcome:1,value:ee},pe()})}cancel(){return this.error(new M.$5)}}e.$ch=fe;var ye;(function(Z){async function ee($e){let he;const De=await Promise.all($e.map(ne=>ne.then(le=>le,le=>{he||(he=le)})));if(typeof he<"u")throw he;return De}Z.settled=ee;function pe($e){return new Promise(async(he,De)=>{try{await $e(he,De)}catch(ne){De(ne)}})}Z.withAsyncBody=pe})(ye||(e.Promises=ye={}));var ue;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(ue||(ue={}));class ae{static fromArray(ee){return new ae(pe=>{pe.emitMany(ee)})}static fromPromise(ee){return new ae(async pe=>{pe.emitMany(await ee)})}static fromPromises(ee){return new ae(async pe=>{await Promise.all(ee.map(async $e=>pe.emitOne(await $e)))})}static merge(ee){return new ae(async pe=>{await Promise.all(ee.map(async $e=>{for await(const he of $e)pe.emitOne(he)}))})}static{this.EMPTY=ae.fromArray([])}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new C.$Nd,queueMicrotask(async()=>{const pe={emitOne:$e=>this.g($e),emitMany:$e=>this.h($e),reject:$e=>this.k($e)};try{await Promise.resolve(ee(pe)),this.j()}catch($e){this.k($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,pe){return new ae(async $e=>{for await(const he of ee)$e.emitOne(pe(he))})}map(ee){return ae.map(this,ee)}static filter(ee,pe){return new ae(async $e=>{for await(const he of ee)pe(he)&&$e.emitOne(he)})}filter(ee){return ae.filter(this,ee)}static coalesce(ee){return ae.filter(ee,pe=>!!pe)}coalesce(){return ae.coalesce(this)}static async toPromise(ee){const pe=[];for await(const $e of ee)pe.push($e);return pe}toPromise(){return ae.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$dh=ae;class ve extends ae{constructor(ee,pe){super(pe),this.l=ee}cancel(){this.l.cancel()}}e.$eh=ve;function _(Z){const ee=new y.$Xd,pe=Z(ee.token);return new ve(ee,async $e=>{const he=ee.token.onCancellationRequested(()=>{he.dispose(),ee.dispose(),$e.reject(new M.$5)});try{for await(const De of pe){if(ee.token.isCancellationRequested)return;$e.emitOne(De)}he.dispose(),ee.dispose()}catch(De){he.dispose(),ee.dispose(),$e.reject(De)}})}e.$fh=_;class W{constructor(){this.a=new fe,this.b=new ae($e=>{if(ee){$e.reject(ee);return}return pe&&$e.emitMany(pe),this.d=he=>$e.reject(he),this.f=he=>$e.emitOne(he),this.a.p});let ee,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{ee||(ee=$e)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(ee){this.d(ee),this.a.complete()}emit(ee){this.f(ee)}}e.$gh=W}),define(Ae[38],Re([1,0,18,12,44,28,20,22,16]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function f(){return Object.create(null)}e.$rj=f,e.$sj="**",e.$tj="/";const R="[/\\\\]",k="[^/\\\\]",a=/\//g;function b(Ee,Pe){switch(Ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${Pe?`|${R}${k}+`:""})*?`}}function $(Ee,Pe){if(!Ee)return[];const Se=[];let fe=!1,ye=!1,ue="";for(const ae of Ee){switch(ae){case Pe:if(!fe&&!ye){Se.push(ue),ue="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}ue+=ae}return ue&&Se.push(ue),Se}e.$uj=$;function g(Ee){if(!Ee)return"";let Pe="";const Se=$(Ee,e.$tj);if(Se.every(fe=>fe===e.$sj))Pe=".*";else{let fe=!1;Se.forEach((ye,ue)=>{if(ye===e.$sj){if(fe)return;Pe+=b(2,ue===Se.length-1)}else{let ae=!1,ve="",_=!1,W="";for(const Z of ye){if(Z!=="}"&&ae){ve+=Z;continue}if(_&&(Z!=="]"||!W)){let ee;Z==="-"?ee=Z:(Z==="^"||Z==="!")&&!W?ee="^":Z===e.$tj?ee="":ee=(0,D.$Fe)(Z),W+=ee;continue}switch(Z){case"{":ae=!0;continue;case"[":_=!0;continue;case"}":{const pe=`(?:${$(ve,",").map($e=>g($e)).join("|")})`;Pe+=pe,ae=!1,ve="";break}case"]":{Pe+="["+W+"]",_=!1,W="";break}case"?":Pe+=k;continue;case"*":Pe+=b(1);continue;default:Pe+=(0,D.$Fe)(Z)}}ue<Se.length-1&&(Se[ue+1]!==e.$sj||ue+2<Se.length)&&(Pe+=R)}fe=ye===e.$sj})}return Pe}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.$Dc(1e4),r=function(){return!1},s=function(){return null};function o(Ee,Pe){if(!Ee)return s;let Se;typeof Ee!="string"?Se=Ee.pattern:Se=Ee,Se=Se.trim();const fe=`${Se}_${!!Pe.trimForExclusions}`;let ye=n.get(fe);if(ye)return w(ye,Ee);let ue;return t.test(Se)?ye=I(Se.substr(4),Se):(ue=i.exec(d(Se,Pe)))?ye=S(ue[1],Se):(Pe.trimForExclusions?p:c).test(Se)?ye=u(Se,Pe):(ue=E.exec(d(Se,Pe)))?ye=m(ue[1].substr(1),Se,!0):(ue=v.exec(d(Se,Pe)))?ye=m(ue[1],Se,!1):ye=h(Se),n.set(fe,ye),w(ye,Ee)}function w(Ee,Pe){if(typeof Pe=="string")return Ee;const Se=function(fe,ye){return(0,C.$Xf)(fe,Pe.base,!l.$l)?Ee((0,D.$Je)(fe.substr(Pe.base.length),A.sep),ye):null};return Se.allBasenames=Ee.allBasenames,Se.allPaths=Ee.allPaths,Se.basenames=Ee.basenames,Se.patterns=Ee.patterns,Se}function d(Ee,Pe){return Pe.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,Pe){return function(Se,fe){return typeof Se=="string"&&Se.endsWith(Ee)?Pe:null}}function S(Ee,Pe){const Se=`/${Ee}`,fe=`\\${Ee}`,ye=function(ae,ve){return typeof ae!="string"?null:ve?ve===Ee?Pe:null:ae===Ee||ae.endsWith(Se)||ae.endsWith(fe)?Pe:null},ue=[Ee];return ye.basenames=ue,ye.patterns=[Pe],ye.allBasenames=ue,ye}function u(Ee,Pe){const Se=se(Ee.slice(1,-1).split(",").map(ve=>o(ve,Pe)).filter(ve=>ve!==s),Ee),fe=Se.length;if(!fe)return s;if(fe===1)return Se[0];const ye=function(ve,_){for(let W=0,Z=Se.length;W<Z;W++)if(Se[W](ve,_))return Ee;return null},ue=Se.find(ve=>!!ve.allBasenames);ue&&(ye.allBasenames=ue.allBasenames);const ae=Se.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ae.length&&(ye.allPaths=ae),ye}function m(Ee,Pe,Se){const fe=A.sep===A.$gc.sep,ye=fe?Ee:Ee.replace(a,A.sep),ue=A.sep+ye,ae=A.$gc.sep+Ee;let ve;return Se?ve=function(_,W){return typeof _=="string"&&(_===ye||_.endsWith(ue)||!fe&&(_===Ee||_.endsWith(ae)))?Pe:null}:ve=function(_,W){return typeof _=="string"&&(_===ye||!fe&&_===Ee)?Pe:null},ve.allPaths=[(Se?"*/":"./")+Ee],ve}function h(Ee){try{const Pe=new RegExp(`^${g(Ee)}$`);return function(Se){return Pe.lastIndex=0,typeof Se=="string"&&Pe.test(Se)?Ee:null}}catch{return s}}function P(Ee,Pe,Se){return!Ee||typeof Pe!="string"?!1:B(Ee)(Pe,void 0,Se)}e.$vj=P;function B(Ee,Pe={}){if(!Ee)return r;if(typeof Ee=="string"||z(Ee)){const Se=o(Ee,Pe);if(Se===s)return r;const fe=function(ye,ue){return!!Se(ye,ue)};return Se.allBasenames&&(fe.allBasenames=Se.allBasenames),Se.allPaths&&(fe.allPaths=Se.allPaths),fe}return N(Ee,Pe)}e.$wj=B;function z(Ee){const Pe=Ee;return Pe?typeof Pe.base=="string"&&typeof Pe.pattern=="string":!1}e.$xj=z;function j(Ee){return Ee.allBasenames||[]}e.$yj=j;function V(Ee){return Ee.allPaths||[]}e.$zj=V;function N(Ee,Pe){const Se=se(Object.getOwnPropertyNames(Ee).map(ve=>O(ve,Ee[ve],Pe)).filter(ve=>ve!==s)),fe=Se.length;if(!fe)return s;if(!Se.some(ve=>!!ve.requiresSiblings)){if(fe===1)return Se[0];const ve=function(Z,ee){let pe;for(let $e=0,he=Se.length;$e<he;$e++){const De=Se[$e](Z,ee);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(pe||(pe=[]),pe.push(De))}return pe?(async()=>{for(const $e of pe){const he=await $e;if(typeof he=="string")return he}return null})():null},_=Se.find(Z=>!!Z.allBasenames);_&&(ve.allBasenames=_.allBasenames);const W=Se.reduce((Z,ee)=>ee.allPaths?Z.concat(ee.allPaths):Z,[]);return W.length&&(ve.allPaths=W),ve}const ye=function(ve,_,W){let Z,ee;for(let pe=0,$e=Se.length;pe<$e;pe++){const he=Se[pe];he.requiresSiblings&&W&&(_||(_=(0,A.$nc)(ve)),Z||(Z=_.substr(0,_.length-(0,A.$oc)(ve).length)));const De=he(ve,_,Z,W);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ee||(ee=[]),ee.push(De))}return ee?(async()=>{for(const pe of ee){const $e=await pe;if(typeof $e=="string")return $e}return null})():null},ue=Se.find(ve=>!!ve.allBasenames);ue&&(ye.allBasenames=ue.allBasenames);const ae=Se.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ae.length&&(ye.allPaths=ae),ye}function O(Ee,Pe,Se){if(Pe===!1)return s;const fe=o(Ee,Se);if(fe===s)return s;if(typeof Pe=="boolean")return fe;if(Pe){const ye=Pe.when;if(typeof ye=="string"){const ue=(ae,ve,_,W)=>{if(!W||!fe(ae,ve))return null;const Z=ye.replace("$(basename)",()=>_),ee=W(Z);return(0,M.$Gg)(ee)?ee.then(pe=>pe?Ee:null):ee?Ee:null};return ue.requiresSiblings=!0,ue}}return fe}function se(Ee,Pe){const Se=Ee.filter(ve=>!!ve.basenames);if(Se.length<2)return Ee;const fe=Se.reduce((ve,_)=>{const W=_.basenames;return W?ve.concat(W):ve},[]);let ye;if(Pe){ye=[];for(let ve=0,_=fe.length;ve<_;ve++)ye.push(Pe)}else ye=Se.reduce((ve,_)=>{const W=_.patterns;return W?ve.concat(W):ve},[]);const ue=function(ve,_){if(typeof ve!="string")return null;if(!_){let Z;for(Z=ve.length;Z>0;Z--){const ee=ve.charCodeAt(Z-1);if(ee===47||ee===92)break}_=ve.substr(Z)}const W=fe.indexOf(_);return W!==-1?ye[W]:null};ue.basenames=fe,ue.patterns=ye,ue.allBasenames=fe;const ae=Ee.filter(ve=>!ve.basenames);return ae.push(ue),ae}function X(Ee,Pe){return(0,y.$ub)(Ee,Pe,(Se,fe)=>typeof Se=="string"&&typeof fe=="string"?Se===fe:typeof Se!="string"&&typeof fe!="string"?Se.base===fe.base&&Se.pattern===fe.pattern:!1)}e.$Aj=X}),define(Ae[50],Re([1,0,9,121,23,16,2]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class D{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$7)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=a(this.supportThemeIcons?(0,M.$Wj)(i):i).replace(/([ \t]+)/g,(p,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,p){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(i,c){const p=new RegExp((0,T.$Fe)(c),"g");return i.replace(p,(E,v)=>i.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$3j=D;function f(t){return R(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$4j=f;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$5j=R;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$og)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$6j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=a;function b(t){return t.replace(/"/g,"&quot;")}e.$8j=b;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=$;function g(t){const i=[],c=t.split("|").map(E=>E.trim());t=c[0];const p=c[1];if(p){const E=/height=(\d+)/.exec(p),v=/width=(\d+)/.exec(p),n=E?E[1]:"",r=v?v[1]:"",s=isFinite(parseInt(r)),o=isFinite(parseInt(n));s&&i.push(`width="${r}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$0j=g}),define(Ae[90],Re([1,0,18,44,20,22,23,16]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function D(o,w){const{os:d,tildify:I,relative:S}=w;if(S){const h=f(o,S,d);if(typeof h=="string")return h}let u=o.fsPath;if(d===1&&!T.$j?u=u.replace(/\//g,"\\"):d!==1&&T.$j&&(u=u.replace(/\\/g,"/")),d!==1&&I?.userHome){const h=I.userHome.fsPath;let P;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$gc.sep)?P=I.userHome.with({path:o.path}).fsPath:P=o.fsPath,u=a(P,h,d)}return(d===1?C.$fc:C.$gc).normalize(R(u,d===1))}e.$rv=D;function f(o,w,d){const I=d===1?C.$fc:C.$gc,S=d===3?A.$lg:A.$ng,u=w.getWorkspace(),m=(0,y.$Ob)(u.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(C.$gc.sep)&&(o=m.uri.with({path:o.path}));const h=w.getWorkspaceFolder(o);if(!h)return;let P;if(S.isEqual(h.uri,o)?P="":P=S.relativePath(h.uri,o)??"",P&&(P=I.normalize(P)),u.folders.length>1&&!w.noPrefix){const B=h.name?h.name:S.basenameOrAuthority(h.uri);P=P?`${B} \u2022 ${P}`:B}return P}function R(o,w=T.$j){return(0,M.$2f)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$sv=R;let k=Object.create(null);function a(o,w,d=T.OS){if(d===1||!o||!w)return o;let I=k.original===w?k.normalized:void 0;I||(I=w,T.$j&&(I=(0,M.$Rf)(I)),I=`${(0,l.$Ke)(I,C.$gc.sep)}${C.$gc.sep}`,k={original:w,normalized:I});let S=o;return T.$j&&(S=(0,M.$Rf)(S)),(d===3?S.startsWith(I):(0,l.$3e)(S,I))?`~/${S.substr(I.length)}`:o}e.$tv=a;function b(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$uv=b;const $="\u2026",g="\\\\",t="~";function i(o,w=C.sep){const d=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){d[S]=`.${w}`;continue}if(!u){d[S]=u;continue}I=!0;let m="",h=u;h.indexOf(g)===0?(m=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length)):h.indexOf(w)===0?(m=h.substr(0,h.indexOf(w)+w.length),h=h.substr(h.indexOf(w)+w.length)):h.indexOf(t)===0&&(m=h.substr(0,h.indexOf(t)+t.length),h=h.substr(h.indexOf(t)+t.length));const P=h.split(w);for(let B=1;I&&B<=P.length;B++)for(let z=P.length-B;I&&z>=0;z--){I=!1;let j=P.slice(z,z+B).join(w);for(let V=0;!I&&V<o.length;V++)if(V!==S&&o[V]&&o[V].indexOf(j)>-1){const N=z+B===P.length,O=z>0&&o[V].indexOf(w)>-1?w+j:j,se=o[V].endsWith(O);I=!N||se}if(!I){let V="";(P[0].endsWith(":")||m!=="")&&(z===1&&(z=0,B++,j=P[0]+w+j),z>0&&(V=P[0]+w),V=m+V),z>0&&(V=V+$+w),V=V+j,z+B<P.length&&(V=V+w+$),d[S]=V}}I&&(d[S]=u)}return d}e.$vv=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function p(o,w=Object.create(null)){const d=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&d.push({value:S,type:c.TEXT}),S="",I=!0;else if(u==="}"&&I){const m=w[S];if(typeof m=="string")m.length&&d.push({value:m,type:c.VARIABLE});else if(m){const h=d[d.length-1];(!h||h.type!==c.SEPARATOR)&&d.push({value:m.label,type:c.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&d.push({value:S,type:c.TEXT}),d.filter((u,m)=>{if(u.type===c.SEPARATOR){const h=d[m-1],P=d[m+1];return[h,P].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.$wv=p;function E(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$k?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$xv=E;function v(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,""):T.$j?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$yv=v;function n(o){return o.replace(/&/g,"&&")}e.$zv=n;function r(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const d=s(o.substring(0,w));return{name:d.name,parentPath:d.parentPath+o.substring(w)}}}return s(o)}e.$Av=r;function s(o){const w=o.indexOf("/")!==-1?C.$gc:C.$fc,d=w.basename(o),I=w.dirname(o);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[132],Re([1,0,26,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function C(k){return k.toJSON()}class T{constructor(a){this.a=a}transformIncoming(a){const b=this.a.transformIncoming(a);return b===a?a:C(M.URI.from(b))}transformOutgoing(a){const b=this.a.transformOutgoing(a);return b===a?a:C(M.URI.from(b))}transformOutgoingURI(a){const b=this.a.transformOutgoing(a);return b===a?a:M.URI.from(b)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Lm=T,e.$Mm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,a,b){if(!k||b>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const g=A(k[$],a,b+1);g!==null&&(k[$]=g)}}return null}function l(k,a){const b=A(k,a,0);return b===null?k:b}e.$Nm=l;function D(k,a,b,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return b?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof y.$be)return null;for(const g in k)if(Object.hasOwnProperty.call(k,g)){const t=D(k[g],a,b,$+1);t!==null&&(k[g]=t)}}return null}function f(k,a){const b=D(k,a,!1,0);return b===null?k:b}e.$Om=f;function R(k,a){const b=D(k,a,!0,0);return b===null?k:b}e.$Pm=R}),define(Ae[133],Re([1,0,38,20]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=void 0;function C(T,A,l,D,f,R){if(Array.isArray(T)){let k=0;for(const a of T){const b=C(a,A,l,D,f,R);if(b===10)return b;b>k&&(k=b)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===l?10:0:0;if(T){const{language:k,pattern:a,scheme:b,hasAccessToAllModels:$,notebookType:g}=T;if(!D&&!$)return 0;g&&f&&(A=f);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(k)if(k===l)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(g)if(g===R)t=10;else if(g==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,M.$hc)(a.base)},i===A.fsPath||(0,y.$vj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$sE=C}),define(Ae[91],Re([1,0,26,22]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0=e.$V0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function T(k){for(let a=0,b=k.length;a<b;a+=4){const $=k[a+0],g=k[a+1],t=k[a+2],i=k[a+3];k[a+0]=i,k[a+1]=t,k[a+2]=g,k[a+3]=$}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||T(a),y.$be.wrap(a)}function l(k){const a=k.buffer;if(M.$D()||T(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const b=new Uint8Array(a.byteLength);return b.set(a),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function D(k){const a=new Uint32Array(f(k));let b=0;if(a[b++]=k.id,k.type==="full")a[b++]=1,a[b++]=k.data.length,a.set(k.data,b),b+=k.data.length;else{a[b++]=2,a[b++]=k.deltas.length;for(const $ of k.deltas)a[b++]=$.start,a[b++]=$.deleteCount,$.data?(a[b++]=$.data.length,a.set($.data,b),b+=$.data.length):a[b++]=0}return A(a)}e.$V0=D;function f(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const b of k.deltas)b.data&&(a+=b.data.length)}return a}function R(k){const a=l(k);let b=0;const $=a[b++];if(a[b++]===1){const c=a[b++],p=a.subarray(b,b+c);return b+=c,{id:$,type:"full",data:p}}const t=a[b++],i=[];for(let c=0;c<t;c++){const p=a[b++],E=a[b++],v=a[b++];let n;v>0&&(n=a.subarray(b,b+v),b+=v),i[c]={start:p,deleteCount:E,data:n}}return{id:$,type:"delta",deltas:i}}e.$W0=R}),define(Ae[134],Re([10,11]),function(we,e){return we.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(Q,be,Be,Oe){this.id=Q,this.name=be,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,be){return b(Q,be)}compute(Q,be,Be){return Be}}class a{constructor(Q,be){this.newValue=Q,this.didChange=be}}e.ApplyUpdateResult=a;function b(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new a(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Be=Array.isArray(Y)&&Array.isArray(Q)&&y.$ub(Y,Q);return new a(Q,!Be)}let be=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const Oe=b(Y[Be],Q[Be]);Oe.didChange&&(Y[Be]=Oe.newValue,be=!0)}return new a(Y,be)}class ${constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,be){return b(Q,be)}validate(Q){return this.defaultValue}}class g{constructor(Q,be,Be,Oe){this.id=Q,this.name=be,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,be){return b(Q,be)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,be,Be){return Be}}function t(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=t;class i extends g{constructor(Q,be,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(Q,be,Be,Oe)}validate(Q){return t(Q,this.defaultValue)}}function c(Y,Q,be,Be){if(typeof Y>"u")return Q;let Oe=parseInt(Y,10);return isNaN(Oe)?Q:(Oe=Math.max(be,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=c;class p extends g{static clampedInt(Q,be,Be,Oe){return c(Q,be,Be,Oe)}constructor(Q,be,Be,Oe,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Oe,nt.maximum=Xe),super(Q,be,Be,nt),this.minimum=Oe,this.maximum=Xe}validate(Q){return p.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function E(Y,Q,be,Be){if(typeof Y>"u")return Q;const Oe=v.float(Y,Q);return v.clamp(Oe,be,Be)}e.clampedFloat=E;class v extends g{static clamp(Q,be,Be){return Q<be?be:Q>Be?Be:Q}static float(Q,be){if(typeof Q=="number")return Q;if(typeof Q>"u")return be;const Be=parseFloat(Q);return isNaN(Be)?be:Be}constructor(Q,be,Be,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,be,Be,Xe),this.validationFn=Oe}validate(Q){return this.validationFn(v.float(Q,this.defaultValue))}}class n extends g{static string(Q,be){return typeof Q!="string"?be:Q}constructor(Q,be,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(Q,be,Be,Oe)}validate(Q){return n.string(Q,this.defaultValue)}}function r(Y,Q,be,Be){return typeof Y!="string"?Q:Be&&Y in Be?Be[Y]:be.indexOf(Y)===-1?Q:Y}e.stringSet=r;class s extends g{constructor(Q,be,Be,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Be),super(Q,be,Be,Xe),this.c=Oe}validate(Q){return r(Q,this.defaultValue,this.c)}}class o extends k{constructor(Q,be,Be,Oe,Xe,nt,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=Xe,ft.default=Oe),super(Q,be,Be,ft),this.c=Xe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function w(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,be,Be){return Be===0?Q.accessibilitySupport:Be}}class I extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{insertSpace:t(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function h(Y){switch(Y){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function P(Y){switch(Y){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class B extends ${constructor(){super(140)}compute(Q,be,Be){const Oe=["monaco-editor"];return be.get(39)&&Oe.push(be.get(39)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),be.get(73)==="default"?Oe.push("mouse-default"):be.get(73)==="copy"&&Oe.push("mouse-copy"),be.get(110)&&Oe.push("showUnused"),be.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class z extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,be,Be){return Be&&Q.emptySelectionClipboard}}class j extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{cursorMoveOnType:t(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(be.loop,this.defaultValue.loop)}}}class V extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?V.OFF:Q==="true"?V.ON:Q:Q?V.ON:V.OFF}}e.EditorFontLigatures=V;class N extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.TRANSLATE:Q:Q?N.TRANSLATE:N.OFF}compute(Q,be,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends ${constructor(){super(50)}compute(Q,be,Be){return Q.fontInfo}}class se extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const be=v.float(Q,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(be,6,100)}compute(Q,be,Be){return Q.fontInfo.fontSize}}class X extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(p.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class Ee extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...be},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...be},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...be},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{multiple:r(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??r(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??r(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??r(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??r(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??r(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Pe extends k{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),delay:p.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:t(be.sticky,this.defaultValue.sticky),hidingDelay:p.clampedInt(be.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(be.above,this.defaultValue.above)}}}var Se;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class fe extends ${constructor(){super(143)}compute(Q,be,Be){return fe.computeLayout(be,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const be=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,be-1));const Xe=(Be+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:be,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:nt}}static c(Q,be){const Be=Q.outerWidth,Oe=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=be.stableMinimapLayoutInput,ft=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,wt=Q.lineHeight,Pt=Q.typicalHalfwidthCharacterWidth,Zt=Q.scrollBeyondLastLine,Gt=Q.minimap.renderCharacters;let pt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const jt=Q.minimap.maxColumn,Nt=Q.minimap.size,Bt=Q.minimap.side,At=Q.verticalScrollbarWidth,Rt=Q.viewLineCount,Ot=Q.remainingWidth,Wt=Q.isViewportWrapping,Jt=Gt?2:3;let Vt=Math.floor(Xe*Oe);const Kt=Vt/Xe;let Mt=!1,ut=!1,dt=Jt*pt,Lt=pt/Xe,qt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:me,desiredRatio:H,minimapLineCount:Me}=fe.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Zt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Xe});if(Rt/Me>1)Mt=!0,ut=!0,pt=1,dt=1,Lt=pt/Xe;else{let Je=!1,Ke=pt+1;if(Nt==="fit"){const et=Math.ceil((Fe+Rt+me)*dt);Wt&&ft&&Ot<=be.stableFitRemainingWidth?(Je=!0,Ke=be.stableFitMaxMinimapScale):Je=et>Vt}if(Nt==="fill"||Je){Mt=!0;const et=pt;dt=Math.min(wt*Xe,Math.max(1,Math.floor(1/H))),Wt&&ft&&Ot<=be.stableFitRemainingWidth&&(Ke=be.stableFitMaxMinimapScale),pt=Math.min(Ke,Math.max(1,Math.floor(dt/Jt))),pt>et&&(qt=Math.min(2,pt/et)),Lt=pt/Xe/qt,Vt=Math.ceil(Math.max(Ce,Fe+Rt+me)*dt),Wt?(be.stableMinimapLayoutInput=Q,be.stableFitRemainingWidth=Ot,be.stableFitMaxMinimapScale=pt):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const kt=Math.floor(jt*Lt),at=Math.min(kt,Math.max(0,Math.floor((Ot-At-2)*Lt/(Pt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Xe*at);const Ht=vt/Xe;vt=Math.floor(vt*qt);const Ct=Gt?1:2,We=Bt==="left"?0:Be-at-At;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:at,minimapHeightIsEditorHeight:Mt,minimapIsSampling:ut,minimapScale:pt,minimapLineHeight:dt,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Kt}}static computeLayout(Q,be){const Be=be.outerWidth|0,Oe=be.outerHeight|0,Xe=be.lineHeight|0,nt=be.lineNumbersDigitCount|0,ft=be.typicalHalfwidthCharacterWidth,wt=be.maxDigitWidth,Pt=be.pixelRatio,Zt=be.viewLineCount,Gt=Q.get(135),pt=Gt==="inherit"?Q.get(134):Gt,jt=pt==="inherit"?Q.get(130):pt,Nt=Q.get(133),Bt=be.isDominatedByLongLines,At=Q.get(57),Rt=Q.get(67).renderType!==0,Ot=Q.get(68),Wt=Q.get(104),Jt=Q.get(83),Vt=Q.get(72),Kt=Q.get(102),Mt=Kt.verticalScrollbarSize,ut=Kt.verticalHasArrows,dt=Kt.arrowSize,Lt=Kt.horizontalScrollbarSize,qt=Q.get(43),kt=Q.get(109)!=="never";let at=Q.get(65);qt&&kt&&(at+=16);let vt=0;if(Rt){const zt=Math.max(nt,Ot);vt=Math.round(zt*wt)}let Ht=0;At&&(Ht=Xe*be.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Ht,Ce=We+vt,Fe=Ce+at;const me=Be-Ht-vt-at;let H=!1,Me=!1,je=-1;pt==="inherit"&&Bt?(H=!0,Me=!0):jt==="on"||jt==="bounded"?Me=!0:jt==="wordWrapColumn"&&(je=Nt);const Je=fe.c({outerWidth:Be,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:ft,pixelRatio:Pt,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Vt,verticalScrollbarWidth:Mt,viewLineCount:Zt,remainingWidth:me,isViewportWrapping:Me},be.memory||new R);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ct+=Je.minimapWidth,We+=Je.minimapWidth,Ce+=Je.minimapWidth,Fe+=Je.minimapWidth);const Ke=me-Je.minimapWidth,et=Math.max(1,Math.floor((Ke-Mt-2)/ft)),bt=ut?dt:0;return Me&&(je=Math.max(1,et),jt==="bounded"&&(je=Math.min(je,Nt))),{width:Be,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:be.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:vt,decorationsLeft:Ce,decorationsWidth:at,contentLeft:Fe,contentWidth:Ke,minimap:Je,viewportColumn:et,isWordWrapMinified:H,isViewportWrapping:Me,wrappingColumn:je,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:Lt,overviewRuler:{top:bt,width:Mt,height:Oe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=fe;class ye extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,be,Be){return be.get(2)===2?"advanced":Be}}class ue extends k{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:l.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class ae extends k{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(be.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(be.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(be.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return typeof be.enabled=="boolean"&&(be.enabled=be.enabled?"on":"off"),{enabled:r(be.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(be.fontFamily,this.defaultValue.fontFamily),padding:t(be.padding,this.defaultValue.padding)}}}class _ extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):p.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,be,Be){return Be<0?p.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class W extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>v.clamp(Q,0,150),{markdownDescription:l.localize(63,null)})}compute(Q,be,Be){return Q.fontInfo.lineHeight}}class Z extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Q.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),autohide:t(be.autohide,this.defaultValue.autohide),size:r(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(be.side,this.defaultValue.side,["right","left"]),showSlider:r(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(be.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(be.scale,1,1,3),maxColumn:p.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(Y){return Y==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class pe extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{top:p.clampedInt(be.top,0,0,1e3),bottom:p.clampedInt(be.bottom,0,0,1e3)}}}class $e extends k{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),cycle:t(be.cycle,this.defaultValue.cycle)}}}class he extends ${constructor(){super(141)}compute(Q,be,Be){return Q.pixelRatio}}class De extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},be=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:be,default:Q.strings,description:l.localize(82,null)},comments:{anyOf:be,default:Q.comments,description:l.localize(83,null)},other:{anyOf:be,default:Q.other,description:l.localize(84,null)}},default:Q,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Pt=Q?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:be,comments:Be,strings:Oe}=Q,Xe=["on","inline","off"];let nt,ft,wt;return typeof be=="boolean"?nt=be?"on":"off":nt=r(be,this.defaultValue.other,Xe),typeof Be=="boolean"?ft=Be?"on":"off":ft=r(Be,this.defaultValue.comments,Xe),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=r(Oe,this.defaultValue.strings,Xe),{other:nt,comments:ft,strings:wt}}}var ne;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Q){let be=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(be=4,Be=Q):Q==="interval"?be=3:Q==="relative"?be=2:Q==="on"?be=1:be=0),{renderType:be,renderFn:Be}}}function ie(Y){const Q=Y.get(97);return Q==="editable"?Y.get(90):Q!=="on"}e.filterValidationDecorations=ie;class oe extends k{constructor(){const Q=[],be={type:"number",description:l.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Q,description:l.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const be=[];for(const Be of Q)if(typeof Be=="number")be.push({column:p.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;be.push({column:p.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return be.sort((Be,Oe)=>Be.column-Oe.column),be}return this.defaultValue}}class ge extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q,Be=p.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=p.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(be.vertical,this.defaultValue.vertical),horizontal:Ie(be.horizontal,this.defaultValue.horizontal),useShadows:t(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:p.clampedInt(be.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:p.clampedInt(be.verticalSliderSize,Oe,0,1e3),scrollByPage:t(be.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Q,be){let Be=!1;be.allowedCharacters&&Q&&(M.$$m(Q.allowedCharacters,be.allowedCharacters)||(Q={...Q,allowedCharacters:be.allowedCharacters},Be=!0)),be.allowedLocales&&Q&&(M.$$m(Q.allowedLocales,be.allowedLocales)||(Q={...Q,allowedLocales:be.allowedLocales},Be=!0));const Oe=super.applyUpdate(Q,be);return Be?new a(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{nonBasicASCII:x(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,be){if(typeof Q!="object"||!Q)return be;const Be={};for(const[Oe,Xe]of Object.entries(Q))Xe===!0&&(Be[Oe]=!0);return Be}}class G extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),mode:r(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(be.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(be.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(be.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends k{constructor(){const Q={enabled:T.$3r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$3r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(be.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Q.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Q.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Q.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{bracketPairs:x(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,Q,be){const Be=be.indexOf(Y);return Be===-1?Q:be[Be]}class ce extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Q.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{insertMode:r(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(be.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(be.showIcons,this.defaultValue.showIcons),showStatusBar:t(be.showStatusBar,this.defaultValue.showStatusBar),preview:t(be.preview,this.defaultValue.preview),previewMode:r(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(be.showMethods,this.defaultValue.showMethods),showFunctions:t(be.showFunctions,this.defaultValue.showFunctions),showConstructors:t(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(be.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(be.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(be.showFields,this.defaultValue.showFields),showVariables:t(be.showVariables,this.defaultValue.showVariables),showClasses:t(be.showClasses,this.defaultValue.showClasses),showStructs:t(be.showStructs,this.defaultValue.showStructs),showInterfaces:t(be.showInterfaces,this.defaultValue.showInterfaces),showModules:t(be.showModules,this.defaultValue.showModules),showProperties:t(be.showProperties,this.defaultValue.showProperties),showEvents:t(be.showEvents,this.defaultValue.showEvents),showOperators:t(be.showOperators,this.defaultValue.showOperators),showUnits:t(be.showUnits,this.defaultValue.showUnits),showValues:t(be.showValues,this.defaultValue.showValues),showConstants:t(be.showConstants,this.defaultValue.showConstants),showEnums:t(be.showEnums,this.defaultValue.showEnums),showEnumMembers:t(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(be.showKeywords,this.defaultValue.showKeywords),showWords:t(be.showWords,this.defaultValue.showWords),showColors:t(be.showColors,this.defaultValue.showColors),showFiles:t(be.showFiles,this.defaultValue.showFiles),showReferences:t(be.showReferences,this.defaultValue.showReferences),showFolders:t(be.showFolders,this.defaultValue.showFolders),showTypeParameters:t(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(be.showSnippets,this.defaultValue.showSnippets),showUsers:t(be.showUsers,this.defaultValue.showUsers),showIssues:t(be.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,be,Be){return be.get(2)===2?0:Be}}class Ge extends ${constructor(){super(144)}compute(Q,be,Be){const Oe=be.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class xe extends k{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),showDropSelector:r(be.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends k{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const be=Q;return{enabled:t(be.enabled,this.defaultValue.enabled),showPasteSelector:r(be.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:_e,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var st;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new d),accessibilityPageSize:ze(new p(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new p(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new p(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new p(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new p(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new z),dropIntoEditor:ze(new xe),stickyScroll:ze(new ae),experimentalWhitespaceRendering:ze(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:l.localize(253,null)})),find:ze(new j),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new p(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new O),fontLigatures2:ze(new V),fontSize:ze(new se),fontWeight:ze(new X),fontVariations:ze(new N),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Pe),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>v.clamp(Y,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ue),lineDecorationsWidth:ze(new _),lineHeight:ze(new W),lineNumbers:ze(new le),lineNumbersMinChars:ze(new p(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new s(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new Z),mouseStyle:ze(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new p(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new p(82,"overviewRulerLanes",3,0,3)),padding:ze(new pe),pasteAs:ze(new Ye),parameterHints:ze(new $e),peekWidgetDefaultFocus:ze(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new p(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new ge),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new s(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new p(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new F),scrollBeyondLastColumn:ze(new p(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new ve),snippetSuggestions:ze(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new p(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new p(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new p(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new p(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new n(129,"wordSeparators",A.$4r,{description:l.localize(337,null)})),wordWrap:ze(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new p(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new he),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new fe),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new ye)}}),define(Ae[137],Re([10,11]),function(we,e){return we.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(we,e){return we.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(we,e){return we.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(we,e){return we.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(we,e){return we.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(we,e){return we.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(we,e){return we.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(we,e){return we.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(we,e){return we.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(we,e){return we.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(we,e){return we.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(we,e){return we.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(we,e){return we.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(we,e){return we.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(we,e){return we.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(we,e){return we.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var C;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(C||(e.TokenType=C={}));function T(...f){switch(f.length){case 1:return(0,M.localize)(0,null,f[0]);case 2:return(0,M.localize)(1,null,f[0],f[1]);case 3:return(0,M.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,a=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:R}),this.f.push(b)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),a=D.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,a=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(l);return}const $=this.c.charCodeAt(R);if(k)k=!1;else if($===47&&!a){R++;break}else $===91?a=!0:$===92?k=!0:$===93&&(a=!1);R++}for(;R<this.c.length&&D.a.has(this.c.charCodeAt(R));)R++;this.e=R;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=D}),define(Ae[169],Re([1,0,23,29,141,279]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||A.test(i)}e.$Lo=D;function f(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Mo=f;function R(i){if(!i)return null;const c=i.majorBase,p=i.majorMustEqual,E=i.minorBase;let v=i.minorMustEqual;const n=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(c===0||(v=!1),r=!1);let s=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,w,d,I]=o;s=Date.UTC(Number(w),Number(d)-1,Number(I))}}return{majorBase:c,majorMustEqual:p,minorBase:E,minorMustEqual:v,patchBase:n,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$No=R;function k(i,c,p){let E;typeof i=="string"?E=R(f(i)):E=i;let v;c instanceof Date?v=c.getTime():typeof c=="string"&&(v=new Date(c).getTime());let n;if(typeof p=="string"?n=R(f(p)):n=p,!E||!n)return!1;const r=E.majorBase,s=E.minorBase,o=E.patchBase;let w=n.majorBase,d=n.minorBase,I=n.patchBase;const S=n.notBefore;let u=n.majorMustEqual,m=n.minorMustEqual,h=n.patchMustEqual;return n.isMinimum?r>w?!0:r<w?!1:s>d?!0:s<d||v&&v<S?!1:o>=I:(r===1&&w===0&&(!u||!m||!h)&&(w=1,d=0,I=0,u=!0,m=!1,h=!1),r<w?!1:r>w?!u:s<d?!1:s>d?!m:o<I?!1:o>I?!h:!(v&&v<S))}e.$Oo=k;function a(i,c,p,E,v){const n=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return n.push([M.default.Error,C.localize(0,null)]),n;if(typeof E.name!="string")return n.push([M.default.Error,C.localize(1,null,"name")]),n;if(typeof E.version!="string")return n.push([M.default.Error,C.localize(2,null,"version")]),n;if(!E.engines)return n.push([M.default.Error,C.localize(3,null,"engines")]),n;if(typeof E.engines.vscode!="string")return n.push([M.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return n.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return n.push([M.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof E.main>"u"&&typeof E.browser>"u")return n.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&n.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return n.push([M.default.Error,C.localize(9,null,"main")]),n;{const o=(0,y.$vg)(p,E.main);(0,y.$pg)(o,p)||n.push([M.default.Warning,C.localize(10,null,o.path,p.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return n.push([M.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,y.$vg)(p,E.browser);(0,y.$pg)(o,p)||n.push([M.default.Warning,C.localize(12,null,o.path,p.path)])}}if(!T.valid(E.version))return n.push([M.default.Error,C.localize(13,null)]),n;const r=[];if(!b(i,c,E,v,r))for(const o of r)n.push([M.default.Error,o]);return n}e.$Po=a;function b(i,c,p,E,v){return E||typeof p.main>"u"&&typeof p.browser>"u"?!0:g(i,c,p.engines.vscode,v)}e.$Qo=b;function $(i,c,p){return i==="*"||g(c,p,i)}e.$Ro=$;function g(i,c,p,E=[]){const v=R(f(p));if(!v)return E.push(C.localize(14,null,p)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,p)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,p)),!1;return k(i,c,v)?!0:(E.push(C.localize(17,null,i,p)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,p=i.length;c<p;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class y{constructor(C,T=[],A=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Mh=y}),define(Ae[70],Re([1,0,69]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(l,D,f){D instanceof y.$Mh||(D=new y.$Mh(D,[],!!f)),M.push([l,D])}e.$wr=T;function A(){return M}e.$xr=A}),define(Ae[170],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class y{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$bq=y;class M{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const l=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(A);l.outgoing.set(D.key,D),D.incoming.set(l.key,l)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let l=this.a.get(A);return l||(l=new y(A,T),this.a.set(A,l)),l}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,l]of this.a)T.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const l=new Set([T]),D=this.c(A,l);if(D)return D}}c(T,A){for(const[l,D]of T.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const f=this.c(D,A);if(f)return f;A.delete(l)}}}e.$cq=M}),define(Ae[4],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(y||(e._util=y={})),e.$Oh=C("instantiationService");function M(A,l,D){l[y.DI_TARGET]===l?l[y.DI_DEPENDENCIES].push({id:A,index:D}):(l[y.DI_DEPENDENCIES]=[{id:A,index:D}],l[y.DI_TARGET]=l)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const l=function(D,f,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,D,R)};return l.toString=()=>A,y.serviceIds.set(A,l),l}e.$Ph=C;function T(A){return A}e.$Qh=T}),define(Ae[45],Re([1,0,15,2,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,C.$Ph)("configurationService");function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ki=T;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$li=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=D;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ni=f;function R(i,c){const p=Object.create(null);for(const E in i)k(p,E,i[E],c);return p}e.$oi=R;function k(i,c,p,E){const v=c.split("."),n=v.pop();let r=i;for(let s=0;s<v.length;s++){const o=v[s];let w=r[o];switch(typeof w){case"undefined":w=r[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${c} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(w)}`);return}r=w}if(typeof r=="object"&&r!==null)try{r[n]=p}catch{E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(r)}`)}e.$pi=k;function a(i,c){const p=c.split(".");b(i,p)}e.$qi=a;function b(i,c){const p=c.shift();if(c.length===0){delete i[p];return}if(Object.keys(i).indexOf(p)!==-1){const E=i[p];typeof E=="object"&&!Array.isArray(E)&&(b(E,c),Object.keys(E).length===0&&delete i[p])}}function $(i,c,p){function E(r,s){let o=r;for(const w of s){if(typeof o!="object"||o===null)return;o=o[w]}return o}const v=c.split("."),n=E(i,v);return typeof n>"u"?p:n}e.$ri=$;function g(i,c,p){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in i?y.$Af(i[E])&&y.$Af(c[E])?g(i[E],c[E],p):p&&(i[E]=c[E]):i[E]=c[E])})}e.$si=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$ti=t}),define(Ae[32],Re([1,0,22,16,168,4,138,9]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",y.$k),D.set("isLinux",y.$l),D.set("isWindows",y.$j),D.set("isWeb",y.$p),D.set("isMacNative",y.$k&&!y.$p),D.set("isEdge",y.$H),D.set("isFirefox",y.$F),D.set("isChrome",y.$E),D.set("isSafari",y.$G);function f(_,W){if(D.get(_)!==void 0)throw(0,l.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(_,W)}e.$Li=f;const R=Object.prototype.hasOwnProperty;var k;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),$=(0,A.localize)(1,null),g=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),p=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=a){this.k=W,this.d=new C.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const ee=this.D(),pe=ee.type===17?c:void 0;throw this.h.push({message:i,offset:ee.offset,lexeme:C.$Ki.getLexeme(ee),additionalInfo:pe}),v.c}return Z}catch(Z){if(Z!==v.c)throw Z;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const Z=this.o();W.push(Z)}return W.length===1?W[0]:n.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const Z=this.s();W.push(Z)}return W.length===1?W[0]:n.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const Z=this.l();return this.A(1,t),Z?.negate()}case 17:return this.z(),P.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const Z=this.l();return this.A(1,t),Z}case 17:{const Z=W.lexeme;if(this.z(),this.y(9)){const pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),pe.type!==10)throw this.B("REGEX",pe);const $e=pe.lexeme,he=$e.lastIndexOf("/"),De=he===$e.length-1?void 0:this.w($e.substring(he+1));let ne;try{ne=new RegExp($e.substring(1,he),De)}catch{throw this.B("REGEX",pe)}return O.create(Z,ne)}switch(pe.type){case 10:case 19:{const $e=[pe.lexeme];this.z();let he=this.D(),De=0;for(let ge=0;ge<pe.lexeme.length;ge++)pe.lexeme.charCodeAt(ge)===40?De++:pe.lexeme.charCodeAt(ge)===41&&De--;for(;!this.E()&&he.type!==15&&he.type!==16;){switch(he.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let ge=0;ge<he.lexeme.length;ge++)he.lexeme.charCodeAt(ge)===40?De++:pe.lexeme.charCodeAt(ge)===41&&De--}if(De<0)break;$e.push(C.$Ki.getLexeme(he)),this.z(),he=this.D()}const ne=$e.join(""),le=ne.lastIndexOf("/"),ie=le===ne.length-1?void 0:this.w(ne.substring(le+1));let oe;try{oe=new RegExp(ne.substring(1,le),ie)}catch{throw this.B("REGEX",pe)}return n.regex(Z,oe)}case 18:{const $e=pe.lexeme;this.z();let he=null;if(!(0,M.$Be)($e)){const De=$e.indexOf("/"),ne=$e.lastIndexOf("/");if(De!==ne&&De>=0){const le=$e.slice(De+1,ne),ie=$e[ne+1]==="i"?"i":"";try{he=new RegExp(le,ie)}catch{throw this.B("REGEX",pe)}}}if(he===null)throw this.B("REGEX",pe);return O.create(Z,he)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const pe=this.u();return n.notIn(Z,pe)}switch(this.D().type){case 3:{this.z();const pe=this.u();if(this.x().type===18)return n.equals(Z,pe);switch(pe){case"true":return n.has(Z);case"false":return n.not(Z);default:return n.equals(Z,pe)}}case 4:{this.z();const pe=this.u();if(this.x().type===18)return n.notEquals(Z,pe);switch(pe){case"true":return n.not(Z);case"false":return n.has(Z);default:return n.notEquals(Z,pe)}}case 5:return this.z(),V.create(Z,this.u());case 6:return this.z(),N.create(Z,this.u());case 7:return this.z(),z.create(Z,this.u());case 8:return this.z(),j.create(Z,this.u());case 13:return this.z(),n.in(Z,this.u());default:return n.has(Z)}}case 20:throw this.h.push({message:p,offset:W.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,Z){if(this.C(W))return this.z();throw this.B(Z,this.D())}B(W,Z,ee){const pe=(0,A.localize)(8,null,W,C.$Ki.getLexeme(Z)),$e=Z.offset,he=C.$Ki.getLexeme(Z);return this.h.push({message:pe,offset:$e,lexeme:he,additionalInfo:ee}),v.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=v;class n{static false(){return w.INSTANCE}static true(){return d.INSTANCE}static has(W){return I.create(W)}static equals(W,Z){return S.create(W,Z)}static notEquals(W,Z){return h.create(W,Z)}static regex(W,Z){return O.create(W,Z)}static in(W,Z){return u.create(W,Z)}static notIn(W,Z){return m.create(W,Z)}static not(W){return P.create(W)}static and(...W){return Ee.create(W,null,!0)}static or(...W){return Pe.create(W,null,!0)}static greater(W,Z){return z.create(W,Z)}static greaterEquals(W,Z){return j.create(W,Z)}static smaller(W,Z){return V.create(W,Z)}static smallerEquals(W,Z){return N.create(W,Z)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Ni=n;function r(_){const W=new v({regexParsingWithErrorRecovery:!1});return _.map(Z=>(W.parse(Z),W.lexingErrors.length>0?W.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,A.localize)(9,null,ee.additionalInfo):(0,A.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$Oi=r;function s(_,W){const Z=_?_.substituteConstants():void 0,ee=W?W.substituteConstants():void 0;return!Z&&!ee?!0:!Z||!ee?!1:Z.equals(ee)}e.$Pi=s;function o(_,W){return _.cmp(W)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return d.INSTANCE}}e.$Qi=w;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.$Ri=d;class I{static create(W,Z=null){const ee=D.get(W);return typeof ee=="boolean"?ee?d.INSTANCE:w.INSTANCE:new I(W,Z)}constructor(W,Z){this.key=W,this.c=Z,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:fe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=D.get(this.key);return typeof W=="boolean"?W?d.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Si=I;class S{static create(W,Z,ee=null){if(typeof Z=="boolean")return Z?I.create(W,ee):P.create(W,ee);const pe=D.get(W);return typeof pe=="boolean"?Z===(pe?"true":"false")?d.INSTANCE:w.INSTANCE:new S(W,Z,ee)}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const Z=W?"true":"false";return this.d===Z?d.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.$Ti=S;class u{static create(W,Z){return new u(W,Z)}constructor(W,Z){this.d=W,this.f=Z,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const Z=W.getValue(this.f),ee=W.getValue(this.d);return Array.isArray(Z)?Z.includes(ee):typeof ee=="string"&&typeof Z=="object"&&Z!==null?R.call(Z,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Ui=u;class m{static create(W,Z){return new m(W,Z)}constructor(W,Z){this.d=W,this.f=Z,this.type=11,this.c=u.create(W,Z)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=m;class h{static create(W,Z,ee=null){if(typeof Z=="boolean")return Z?P.create(W,ee):I.create(W,ee);const pe=D.get(W);return typeof pe=="boolean"?Z===(pe?"true":"false")?w.INSTANCE:d.INSTANCE:new h(W,Z,ee)}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const Z=W?"true":"false";return this.d===Z?w.INSTANCE:d.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wi=h;class P{static create(W,Z=null){const ee=D.get(W);return typeof ee=="boolean"?ee?w.INSTANCE:d.INSTANCE:new P(W,Z)}constructor(W,Z){this.c=W,this.d=Z,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:fe(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=D.get(this.c);return typeof W=="boolean"?W?w.INSTANCE:d.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Xi=P;function B(_,W){if(typeof _=="string"){const Z=parseFloat(_);isNaN(Z)||(_=Z)}return typeof _=="string"||typeof _=="number"?W(_):w.INSTANCE}class z{static create(W,Z,ee=null){return B(Z,pe=>new z(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Yi=z;class j{static create(W,Z,ee=null){return B(Z,pe=>new j(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Zi=j;class V{static create(W,Z,ee=null){return B(Z,pe=>new V(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$1i=V;class N{static create(W,Z,ee=null){return B(Z,pe=>new N(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$2i=N;class O{static create(W,Z){return new O(W,Z)}constructor(W,Z){this.d=W,this.f=Z,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const Z=this.f?this.f.source:"",ee=W.f?W.f.source:"";return Z<ee?-1:Z>ee?1:0}equals(W){if(W.type===this.type){const Z=this.f?this.f.source:"",ee=W.f?W.f.source:"";return this.d===W.d&&Z===ee}return!1}substituteConstants(){return this}evaluate(W){const Z=W.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=se.create(this)),this.c}}e.$3i=O;class se{static create(W){return new se(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new se(this.c.map(W))}negate(){return this.c}}e.$4i=se;function X(_){let W=null;for(let Z=0,ee=_.length;Z<ee;Z++){const pe=_[Z].substituteConstants();if(_[Z]!==pe&&W===null){W=[];for(let $e=0;$e<Z;$e++)W[$e]=_[$e]}W!==null&&(W[Z]=pe)}return W===null?_:W}class Ee{static create(W,Z,ee){return Ee.d(W,Z,ee)}constructor(W,Z){this.expr=W,this.c=Z,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const pe=o(this.expr[Z],W.expr[Z]);if(pe!==0)return pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(W.expr[Z]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:Ee.create(W,this.c,!1)}evaluate(W){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].evaluate(W))return!1;return!0}static d(W,Z,ee){const pe=[];let $e=!1;for(const he of W)if(he){if(he.type===1){$e=!0;continue}if(he.type===0)return w.INSTANCE;if(he.type===6){pe.push(...he.expr);continue}pe.push(he)}if(pe.length===0&&$e)return d.INSTANCE;if(pe.length!==0){if(pe.length===1)return pe[0];pe.sort(o);for(let he=1;he<pe.length;he++)pe[he-1].equals(pe[he])&&(pe.splice(he,1),he--);if(pe.length===1)return pe[0];for(;pe.length>1;){const he=pe[pe.length-1];if(he.type!==9)break;pe.pop();const De=pe.pop(),ne=pe.length===0,le=Pe.create(he.expr.map(ie=>Ee.create([ie,De],null,ee)),null,ne);le&&(pe.push(le),pe.sort(o))}if(pe.length===1)return pe[0];if(ee){for(let he=0;he<pe.length;he++)for(let De=he+1;De<pe.length;De++)if(pe[he].negate().equals(pe[De]))return w.INSTANCE;if(pe.length===1)return pe[0]}return new Ee(pe,Z)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const Z of this.expr)W.push(...Z.keys());return W}map(W){return new Ee(this.expr.map(Z=>Z.map(W)),null)}negate(){if(!this.c){const W=[];for(const Z of this.expr)W.push(Z.negate());this.c=Pe.create(W,this,!0)}return this.c}}e.$5i=Ee;class Pe{static create(W,Z,ee){return Pe.d(W,Z,ee)}constructor(W,Z){this.expr=W,this.c=Z,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const pe=o(this.expr[Z],W.expr[Z]);if(pe!==0)return pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(W.expr[Z]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:Pe.create(W,this.c,!1)}evaluate(W){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(this.expr[Z].evaluate(W))return!0;return!1}static d(W,Z,ee){let pe=[],$e=!1;if(W){for(let he=0,De=W.length;he<De;he++){const ne=W[he];if(ne){if(ne.type===0){$e=!0;continue}if(ne.type===1)return d.INSTANCE;if(ne.type===9){pe=pe.concat(ne.expr);continue}pe.push(ne)}}if(pe.length===0&&$e)return w.INSTANCE;pe.sort(o)}if(pe.length!==0){if(pe.length===1)return pe[0];for(let he=1;he<pe.length;he++)pe[he-1].equals(pe[he])&&(pe.splice(he,1),he--);if(pe.length===1)return pe[0];if(ee){for(let he=0;he<pe.length;he++)for(let De=he+1;De<pe.length;De++)if(pe[he].negate().equals(pe[De]))return d.INSTANCE;if(pe.length===1)return pe[0]}return new Pe(pe,Z)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const Z of this.expr)W.push(...Z.keys());return W}map(W){return new Pe(this.expr.map(Z=>Z.map(W)),null)}negate(){if(!this.c){const W=[];for(const Z of this.expr)W.push(Z.negate());for(;W.length>1;){const Z=W.shift(),ee=W.shift(),pe=[];for(const $e of ve(Z))for(const he of ve(ee))pe.push(Ee.create([$e,he],null,!1));W.unshift(Pe.create(pe,null,!1))}this.c=Pe.create(W,this,!0)}return this.c}}e.$6i=Pe;class Se extends I{static{this.d=[]}static all(){return Se.d.values()}constructor(W,Z,ee){super(W,null),this.f=Z,typeof ee=="object"?Se.d.push({...ee,key:W}):ee!==!0&&Se.d.push({key:W,description:ee,type:Z!=null?typeof Z:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return S.create(this.key,W)}notEqualsTo(W){return h.create(this.key,W)}}e.$7i=Se,e.$8i=(0,T.$Ph)("contextKeyService");function fe(_,W){return _<W?-1:_>W?1:0}function ye(_,W,Z,ee){return _<Z?-1:_>Z?1:W<ee?-1:W>ee?1:0}function ue(_,W){if(_.type===0||W.type===1)return!0;if(_.type===9)return W.type===9?ae(_.expr,W.expr):!1;if(W.type===9){for(const Z of W.expr)if(ue(_,Z))return!0;return!1}if(_.type===6){if(W.type===6)return ae(W.expr,_.expr);for(const Z of _.expr)if(ue(Z,W))return!0;return!1}return _.equals(W)}e.$9i=ue;function ae(_,W){let Z=0,ee=0;for(;Z<_.length&&ee<W.length;){const pe=_[Z].cmp(W[ee]);if(pe<0)return!1;pe===0&&Z++,ee++}return Z===_.length}function ve(_){return _.type===9?_.expr:[_]}}),define(Ae[171],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,y.$Ph)("environmentService"),e.$Xh=(0,y.$Qh)(e.$Wh)}),define(Ae[92],Re([1,0,140,4]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function C(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=C;function T(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=T;function A(i,c){switch(i){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function l(i,c){return c==="web"&&!i.includes("web")}e.$7n=l;function D(i,c,p){return l(c,p)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===p}e.$8n=D;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$9n=f;var R;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var k;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$0n=(0,M.$Ph)("extensionGalleryService");var $;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var g;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class t extends Error{constructor(c,p){super(c),this.code=p,this.name=p}}e.$$n=t,e.$_n=(0,M.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,M.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,M.$Ph)("IExtensionTipsService"),e.$eo=(0,y.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Ae[39],Re([1,0,49,20,16,15,2,142,4,22,13,42]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,D.$Ph)("fileService");function a(ue){return ue.create===!0}e.$_j=a;var b;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var $;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})($||(e.FilePermission=$={}));function g(ue){const ae=ue;return!!ae&&typeof ae.onDidChange=="function"}e.$ak=g;var t;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ue){return!!(ue.capabilities&2)}e.$bk=i;function c(ue){return!!(ue.capabilities&8)}e.$ck=c;function p(ue){return!!(ue.capabilities&131072)}e.$dk=p;function E(ue){return!!(ue.capabilities&4)}e.$ek=E;function v(ue){return!!(ue.capabilities&16)}e.$fk=v;function n(ue){return i(ue)?!!(ue.capabilities&16384):!1}e.$gk=n;function r(ue){return i(ue)?!!(ue.capabilities&32768):!1}e.$hk=r;function s(ue){return!!(ue.capabilities&65536)}e.$ik=s;function o(ue){return!!(ue.capabilities&2048)}e.$jk=o;var w;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class d extends Error{static create(ae,ve){const _=new d(ae.toString(),ve);return u(_,ve),_}constructor(ae,ve){super(ae),this.code=ve}}e.$kk=d;function I(ue,ae){return d.create(ue,ae)}e.$lk=I;function S(ue){return ue||I((0,l.localize)(0,null),w.Unknown)}e.$mk=S;function u(ue,ae){return ue.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ue}e.$nk=u;function m(ue){if(!ue)return w.Unknown;if(ue instanceof d)return ue.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!ae)return w.Unknown;switch(ae[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$ok=m;function h(ue){if(ue instanceof N)return ue.fileOperationResult;switch(m(ue)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$pk=h;var P;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class B{constructor(ae,ve,_){this.resource=ae,this.operation=ve,this.target=_}isOperation(ae){return this.operation===ae}}e.$qk=B;var z;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class j{static{this.a=null}constructor(ae,ve){this.c=ve,this.b=void 0,this.d=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawAdded.map(W=>[W,!0])),_}),this.f=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawUpdated.map(W=>[W,!0])),_}),this.g=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawDeleted.map(W=>[W,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of ae){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==j.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ae,...ve){return this.h(ae,{includeChildren:!1},...ve)}affects(ae,...ve){return this.h(ae,{includeChildren:!0},...ve)}h(ae,ve,..._){if(!ae)return!1;const W=_.length>0;return!!((!W||_.includes(1))&&(this.d.value.get(ae)||ve.includeChildren&&this.d.value.findSuperstr(ae))||(!W||_.includes(0))&&(this.f.value.get(ae)||ve.includeChildren&&this.f.value.findSuperstr(ae))||(!W||_.includes(2))&&(this.g.value.findSubstr(ae)||ve.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$rk=j;function V(ue,ae,ve){return!ue||!ae||ue===ae||ae.length>ue.length?!1:(ae.charAt(ae.length-1)!==M.sep&&(ae+=M.sep),ve?(0,C.$3e)(ue,ae):ue.indexOf(ae)===0)}e.$sk=V;class N extends Error{constructor(ae,ve,_){super(ae),this.fileOperationResult=ve,this.options=_}}e.$tk=N;class O extends N{constructor(ae,ve,_,W){super(ae,ve,W),this.fileOperationResult=ve,this.size=_}}e.$uk=O;class se extends N{constructor(ae,ve,_){super(ae,2,_),this.stat=ve}}e.$vk=se;var X;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Ee;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Dk="";function Pe(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}e.$Ek=Pe;async function Se(ue,ae){if(!ae.hasProvider(A.URI.from({scheme:ue.scheme})))return new Promise(ve=>{const _=ae.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ue.scheme&&W.added&&(_.dispose(),ve())})})}e.$Fk=Se;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(ae){return(0,T.$Cf)(ae)||(ae=0),ae<fe.KB?(0,l.localize)(1,null,ae.toFixed(0)):ae<fe.MB?(0,l.localize)(2,null,(ae/fe.KB).toFixed(2)):ae<fe.GB?(0,l.localize)(3,null,(ae/fe.MB).toFixed(2)):ae<fe.TB?(0,l.localize)(4,null,(ae/fe.GB).toFixed(2)):(0,l.localize)(5,null,(ae/fe.TB).toFixed(2))}}e.$Gk=fe;function ye(ue){const ae=typeof ue=="string"||ue?.scheme===R.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===R.Schemas.file?1024*fe.MB:ae?10*fe.MB:f.$p?50*fe.MB:1024*fe.MB}e.$Hk=ye}),define(Ae[71],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class y{constructor(...C){this.a=new Map;for(const[T,A]of C)this.set(T,A)}set(C,T){const A=this.a.get(C);return this.a.set(C,T),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Nh=y}),define(Ae[172],Re([1,0,12,9,6,69,170,4,71,173]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const R=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Nh,i=!1,c,p=R){this.f=t,this.g=i,this.h=c,this.i=p,this.o=new Set,this.f.set(l.$Oh,this),this._globalGraph=p?c?._globalGraph??new A.$cq(E=>E):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...i){const c=$.traceInvocation(this.i,t);let p=!1;try{return t({get:v=>{if(p)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(v,c);if(!n)throw new Error(`[invokeFunction] unknown service '${v}'`);return n}},...i)}finally{p=!0,c.stop()}}createInstance(t,...i){let c,p;return t instanceof T.$Mh?(c=$.traceCreation(this.i,t.ctor),p=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=$.traceCreation(this.i,t),p=this.j(t,i,c)),c.stop(),p}j(t,i=[],c){const p=l._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),E=[];for(const n of p){const r=this.m(n.id,c);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),E.push(r)}const v=p.length>0?p[0].index:i.length;if(i.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${i.length} static arguments`);const n=v-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,v)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof T.$Mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof T.$Mh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const p=new A.$cq(n=>n.id.toString());let E=0;const v=[{id:t,desc:i,_trace:c}];for(;v.length;){const n=v.pop();if(p.lookupOrInsertNode(n),E++>1e3)throw new k(p);for(const r of l._util.getServiceDependencies(n.desc.ctor)){const s=this.l(r.id);if(s||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),s instanceof T.$Mh){const o={id:r.id,desc:s,_trace:n._trace.branch(r.id,!0)};p.insertEdge(n,o),v.push(o)}}}for(;;){const n=p.roots();if(n.length===0){if(!p.isEmpty())throw new k(p);break}for(const{data:r}of n){if(this.l(r.id)instanceof T.$Mh){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}p.removeNode(r)}}return this.l(t)}s(t,i,c=[],p,E){if(this.f.get(t)instanceof T.$Mh)return this.t(t,i,c,p,E);if(this.h)return this.h.s(t,i,c,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],p,E){if(p){const v=new a(void 0,this.g,this,this.i);v.c=String(t);const n=new Map,r=new y.$$g(()=>{const s=v.j(i,c,E);for(const[o,w]of n){const d=s[o];if(typeof d=="function")for(const I of w)d.apply(s,I)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=n.get(o);return I||(I=new f.$2c,n.set(o,I)),(u,m,h)=>{const P=I.push([u,m,h]);return(0,C.$Qc)(P)}}if(o in s)return s[o];const w=r.value;let d=w[o];return typeof d!="function"||(d=d.bind(w),s[o]=d),d},set(s,o,w){return r.value[o]=w,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,c,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$dq=a;var b;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(b||(b={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new $(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function c(E,v){const n=[],r=new Array(E+1).join("	");for(const[s,o,w]of v.h)if(o&&w){i=!0,n.push(`${r}CREATES -> ${s}`);const d=c(E+1,w);d&&n.push(d)}else n.push(`${r}uses -> ${s}`);return n.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(p.join(`
`))}}e.$eq=$}),define(Ae[14],Re([1,0,37,5,93,6,28,22,23,15,2,32,4]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,a.$Ph)("logService"),e.$$i=(0,a.$Ph)("loggerService");function b(){return new Date().toISOString()}function $(u){return(0,f.$Cf)(u)}e.$_i=$;var g;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$aj=g.Info;function t(u,m,h){switch(m){case g.Trace:u.trace(h);break;case g.Debug:u.debug(h);break;case g.Info:u.info(h);break;case g.Warning:u.warn(h);break;case g.Error:u.error(h);break;case g.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function i(u,m=!1){let h="";for(let P=0;P<u.length;P++){let B=u[P];if(B instanceof Error&&(B=(0,y.$Ai)(B,m)),typeof B=="object")try{B=JSON.stringify(B)}catch{}h+=(P>0?" ":"")+B}return h}class c extends T.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new M.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==g.Off&&this.b<=m}}e.$cj=c;class p extends c{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...h){this.f(g.Trace)&&this.g(g.Trace,i([m,...h],!0))}debug(m,...h){this.f(g.Debug)&&this.g(g.Debug,i([m,...h]))}info(m,...h){this.f(g.Info)&&this.g(g.Info,i([m,...h]))}warn(m,...h){this.f(g.Warning)&&this.g(g.Warning,i([m,...h]))}error(m,...h){if(this.f(g.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(g.Error,i(P))}else this.g(g.Error,i([m,...h]))}flush(){}}e.$dj=p;class E extends c{constructor(m=e.$aj){super(),this.setLevel(m),this.g=!l.$j}trace(m,...h){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,m,...h):console.log(`[main ${b()}]`,m,...h))}debug(m,...h){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,m,...h):console.log(`[main ${b()}]`,m,...h))}info(m,...h){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,m,...h):console.log(`[main ${b()}]`,m,...h))}warn(m,...h){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,m,...h):console.warn(`[main ${b()}]`,m,...h))}error(m,...h){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,m,...h):console.error(`[main ${b()}]`,m,...h))}dispose(){}flush(){}}e.$ej=E;class v extends c{constructor(m=e.$aj,h=!0){super(),this.g=h,this.setLevel(m)}trace(m,...h){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...h):console.log(m,...h))}debug(m,...h){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...h):console.log(m,...h))}info(m,...h){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...h):console.log(m,...h))}warn(m,...h){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...h):console.log(m,...h))}error(m,...h){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...h):console.error(m,...h))}dispose(){}flush(){}}e.$fj=v;class n extends c{constructor(m,h=e.$aj){super(),this.g=m,this.setLevel(h)}trace(m,...h){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(m),...h])}debug(m,...h){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(m),...h])}info(m,...h){this.f(g.Info)&&this.g.log(g.Info,[this.h(m),...h])}warn(m,...h){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(m),...h])}error(m,...h){this.f(g.Error)&&this.g.log(g.Error,[this.h(m),...h])}h(m){return typeof m=="string"?m:(0,y.$Ai)(m,this.f(g.Trace))}dispose(){}flush(){}}e.$gj=n;class r extends c{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const h of this.g)h.setLevel(m);super.setLevel(m)}trace(m,...h){for(const P of this.g)P.trace(m,...h)}debug(m,...h){for(const P of this.g)P.debug(m,...h)}info(m,...h){for(const P of this.g)P.info(m,...h)}warn(m,...h){for(const P of this.g)P.warn(m,...h)}error(m,...h){for(const P of this.g)P.error(m,...h)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$hj=r;class s extends T.$Sc{constructor(m,h,P){if(super(),this.h=m,this.j=h,this.b=new A.$Ac,this.c=this.B(new M.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const B of P)this.b.set(B.resource,{logger:void 0,info:B})}m(m){return(0,f.$yf)(m)?[...this.b.values()].find(h=>h.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,h){const P=this.n(m),B=(0,f.$yf)(m)?m:h?.id??(0,C.$Di)(P.toString()).toString(16);let z=this.b.get(P)?.logger;const j=h?.logLevel==="always"?g.Trace:h?.logLevel;z||(z=this.s(P,j??this.getLogLevel(P)??this.h,{...h,id:B}));const V={logger:z,info:{resource:P,id:B,logLevel:j,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(V.info),this.b.set(P,V),z}n(m){return(0,f.$yf)(m)?(0,D.$vg)(this.j,`${m}.log`):m}setLogLevel(m,h){if(R.URI.isUri(m)){const P=m,B=h,z=this.b.get(P);z&&B!==z.info.logLevel&&(z.info.logLevel=B===this.h?void 0:B,z.logger?.setLevel(B),this.b.set(z.info.resource,z),this.f.fire([P,B]))}else{this.h=m;for(const[P,B]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,h){const P=this.m(m);P&&h!==!P.info.hidden&&(P.info.hidden=!h,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,h]))}getLogLevel(m){let h;return m&&(h=this.b.get(m)?.info.logLevel),h??this.h}registerLogger(m){const h=this.b.get(m.resource);h?h.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const h=this.b.get(m);h&&(h.logger&&h.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=s;class o{constructor(){this.onDidChangeLogLevel=new M.$Nd().event}setLevel(m){}getLevel(){return g.Info}trace(m,...h){}debug(m,...h){}info(m,...h){}warn(m,...h){}error(m,...h){}critical(m,...h){}dispose(){}flush(){}}e.$jj=o;class w extends o{}e.$kj=w;function d(u){if(u.verbose)return g.Trace;if(typeof u.logLevel=="string"){const m=S(u.logLevel.toLowerCase());if(m!==void 0)return m}return e.$aj}e.$lj=d;function I(u){switch(u){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$mj=I;function S(u){switch(u){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$nj=S,e.$oj=new k.$7i("logLevel",I(g.Info))}),define(Ae[174],Re([1,0,6,14]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;class C extends y.$Sc{constructor(A,l=[]){super(),this.a=new M.$hj([A,...l]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$EN=C}),define(Ae[94],Re([1,0,29,143,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function f($,g){return g-$}D.compare=f;const R=Object.create(null);R[D.Error]=(0,M.localize)(0,null),R[D.Warning]=(0,M.localize)(1,null),R[D.Info]=(0,M.localize)(2,null);function k($){return R[$]||""}D.toString=k;function a($){switch($){case y.default.Error:return D.Error;case y.default.Warning:return D.Warning;case y.default.Info:return D.Info;case y.default.Ignore:return D.Hint}}D.fromSeverity=a;function b($){switch($){case D.Error:return y.default.Error;case D.Warning:return y.default.Warning;case D.Info:return y.default.Info;case D.Hint:return y.default.Ignore}}D.toSeverity=b}(A||(e.MarkerSeverity=A={}));var l;(function(D){const f="";function R(a){return k(a,!0)}D.makeKey=R;function k(a,b){const $=[f];return a.source?$.push(a.source.replace("\xA6","\\\xA6")):$.push(f),a.code?typeof a.code=="string"?$.push(a.code.replace("\xA6","\\\xA6")):$.push(a.code.value.replace("\xA6","\\\xA6")):$.push(f),a.severity!==void 0&&a.severity!==null?$.push(A.toString(a.severity)):$.push(f),a.message&&b?$.push(a.message.replace("\xA6","\\\xA6")):$.push(f),a.startLineNumber!==void 0&&a.startLineNumber!==null?$.push(a.startLineNumber.toString()):$.push(f),a.startColumn!==void 0&&a.startColumn!==null?$.push(a.startColumn.toString()):$.push(f),a.endLineNumber!==void 0&&a.endLineNumber!==null?$.push(a.endLineNumber.toString()):$.push(f),a.endColumn!==void 0&&a.endColumn!==null?$.push(a.endColumn.toString()):$.push(f),$.push(f),$.join("\xA6")}D.makeKeyOptionalMessage=k})(l||(e.IMarkerData=l={})),e.$_s=(0,C.$Ph)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Zu=e.Severity=void 0,e.Severity=M.default,e.$Zu=(0,C.$Ph)("notificationService");var T;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class D{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$1u=D;class f{infinite(){}done(){}total(k){}worked(k){}}e.$2u=f}),define(Ae[95],Re([1,0,16,2,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=e.$eU=e.$dU=e.$cU=void 0,e.$cU=(0,C.$Ph)("openerService");function T(f,R){return M.URI.isUri(f)?(0,y.$2e)(f.scheme,R):(0,y.$3e)(f,R+":")}e.$dU=T;function A(f,...R){return R.some(k=>T(f,k))}e.$eU=A;function l(f,R){return f.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$fU=l;function D(f){let R;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return k&&(R={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},f=f.with({fragment:""})),{selection:R,uri:f}}e.$gU=D}),define(Ae[176],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,y.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(we,e,y,M){var C=arguments.length,T=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(we,e,y,M);else for(var l=we.length-1;l>=0;l--)(A=we[l])&&(T=(C<3?A(T):C>3?A(e,y,T):A(e,y))||T);return C>3&&T&&Object.defineProperty(e,y,T),T},Ve=this&&this.__param||function(we,e){return function(y,M){e(y,M,we)}};define(Ae[51],Re([1,0,12,19,6,4]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProgressLocation=e.$3u=void 0,e.$3u=(0,T.$Ph)("progressService");var A;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$4u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$5u=l;class D{get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const b=this.d;this.d=()=>{b?.(),a()}}):Promise.resolve()}}e.$6u=D;let f=class extends C.$Sc{constructor(a,b){super(),this.a=new y.$ch,b.withProgress(a,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,C.$Qc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$7u=f,e.$7u=f=qe([Ve(1,e.$3u)],f);class R extends C.$Sc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new C.$Rc)}start(a){this.stop();const b=++this.a,$=new M.$Xd;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,C.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Qc)(()=>$.cancel())),this.b.add((0,C.$Qc)(()=>this.c?this.c.done():void 0)),{id:b,token:$.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$8u=R,e.$9u=(0,T.$Ph)("editorProgressService")}),define(Ae[30],Re([1,0,52,15]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class C{constructor(){this.a=new Map}add(A,l){y.ok(M.$yf(A)),y.ok(M.$Af(l)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new C}),define(Ae[72],Re([1,0,5,30]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class T{constructor(){this.b=new y.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,f){this.a[C(D)]=f,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;M.$gn.add(e.$hn.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,15,137,45,72,30]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var f;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$ln={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const k=D.$gn.as(l.$hn.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Nd,this.onDidSchemaChange=this.i.event,this.j=new M.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const s=new Set;this.n(n,r,s),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const r=new Set;this.o(n,r),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const s=new Set;this.o(r,s),this.n(n,!1,s),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const s=[];for(const{overrides:o,source:w}of n)for(const d in o)if(r.add(d),e.$vn.test(d)){const I=this.a.get(d),S=I?.valuesSources??new Map;if(w)for(const P of Object.keys(o[d]))S.set(P,w);const u={...I?.value||{},...o[d]};this.a.set(d,{source:w,value:u,valuesSources:S});const m=(0,A.$ti)(d),h={type:"object",default:u,description:T.localize(1,null,m),$ref:e.$sn,defaultDefaultValue:u,source:C.$yf(w)?void 0:w,defaultValueSource:w};s.push(...g(d)),this.d[d]=h,this.b.properties[d]=h}else{this.a.set(d,{value:o[d],source:w});const I=this.d[d];I&&(this.w(d,I),this.r(d,I))}this.m(s)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:s,source:o}of n)for(const w in s){const d=this.a.get(w),I=C.$yf(o)?o:o?.id,S=C.$yf(d?.source)?d?.source:d?.source?.id;if(I===S)if(r.add(w),this.a.delete(w),e.$vn.test(w))delete this.d[w],delete this.b.properties[w];else{const u=this.d[w];u&&(this.w(w,u),this.r(w,u))}}this.u()}deltaConfiguration(n){let r=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,s){n.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,r){const s=o=>{if(o.properties)for(const w in o.properties){r.add(w);const d=this.d[w];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>s(w))};for(const o of n){s(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(n,r=!0,s,o,w=3,d){w=C.$Hf(n.scope)?w:n.scope;const I=n.properties;if(I)for(const u in I){const m=I[u];if(r&&p(u,m)){delete I[u];continue}if(m.source=s,m.defaultDefaultValue=I[u].default,this.w(u,m),e.$vn.test(u)?m.scope=void 0:(m.scope=C.$Hf(m.scope)?w:m.scope,m.restricted=C.$Hf(m.restricted)?!!o?.includes(u):m.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),d.add(u)}const S=n.allOf;if(S)for(const u of S)this.p(u,r,s,o,w,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=s=>{const o=s.properties;if(o)for(const d in o)this.r(d,o[d]);s.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$mn.properties[n]=r,r.scope){case 1:e.$nn.properties[n]=r;break;case 2:e.$on.properties[n]=r;break;case 6:e.$pn.properties[n]=r;break;case 3:e.$qn.properties[n]=r;break;case 4:e.$rn.properties[n]=r;break;case 5:e.$rn.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$mn.properties[n],r.scope){case 1:delete e.$nn.properties[n];break;case 2:delete e.$on.properties[n];break;case 6:delete e.$pn.properties[n];break;case 3:delete e.$qn.properties[n];break;case 4:case 5:delete e.$rn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,s={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$sn};this.w(r,s),e.$mn.properties[r]=s,e.$nn.properties[r]=s,e.$on.properties[r]=s,e.$pn.properties[r]=s,e.$qn.properties[r]=s,e.$rn.properties[r]=s}}v(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=n,e.$nn.patternProperties[e.$un]=n,e.$on.patternProperties[e.$un]=n,e.$pn.patternProperties[e.$un]=n,e.$qn.patternProperties[e.$un]=n,e.$rn.patternProperties[e.$un]=n,this.i.fire()}w(n,r){const s=this.a.get(n);let o=s?.value,w=s?.source;C.$Ff(o)&&(o=r.defaultDefaultValue,w=void 0),C.$Ff(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",$=new RegExp(b,"g");e.$un=`^(${b})+$`,e.$vn=new RegExp(e.$un);function g(v){const n=[];if(e.$vn.test(v)){let r=$.exec(v);for(;r?.length;){const s=r[1].trim();s&&n.push(s),r=$.exec(v)}}return(0,y.$Mb)(n)}e.$wn=g;function t(v){return v.reduce((n,r)=>`${n}[${r}]`,"")}e.$xn=t;function i(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=i;const c=new a;D.$gn.add(e.$ln.Configuration,c);function p(v,n){return v.trim()?e.$vn.test(v)?T.localize(7,null,v):c.getConfigurationProperties()[v]!==void 0?T.localize(8,null,v):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,v,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.$zn=p;function E(){const v=[],n=c.getConfigurationProperties();for(const r of Object.keys(n))v.push([r,n[r].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$An=E}),define(Ae[177],Re([1,0,18,5,115,6,28,24,15,2,45,96,30]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function b(r){return Object.isFrozen(r)?r:l.$8m(r)}class ${constructor(s={},o=[],w=[],d){this.b=s,this.c=o,this.d=w,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof $)return o;const w=new g("");return w.parseRaw(o),w.configurationModel});this.f=s.reduce((o,w)=>w===o?w:o.merge(w),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$ri)(this.contents,s):this.contents}inspect(s,o){const w=this.rawConfiguration.getValue(s),d=o?this.rawConfiguration.getOverrideValue(s,o):void 0,I=o?this.rawConfiguration.override(o).getValue(s):w;return{value:w,override:d,merged:I}}getOverrideValue(s,o){const w=this.i(o);return w?s?(0,R.$ri)(w,s):w:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const w of this.overrides)w.identifiers.includes(s)&&o.push(...w.keys);return y.$Mb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return y.$Mb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=l.$7m(this.contents),w=l.$7m(this.overrides),d=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of s)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[m]=w.filter(h=>y.$ub(h.identifiers,u.identifiers));m?(this.h(m.contents,u.contents),m.keys.push(...u.keys),m.keys=y.$Mb(m.keys)):w.push(l.$7m(u))}for(const u of S.keys)d.indexOf(u)===-1&&d.push(u)}return new $(o,d,w,I.every(S=>S instanceof $)?void 0:I)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const d of y.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[d];const S=o[d];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$7m(I),this.h(I,S)):I=S),w[d]=I}return new $(w,this.keys,this.overrides)}h(s,o){for(const w of Object.keys(o)){if(w in s&&D.$Af(s[w])&&D.$Af(o[w])){this.h(s[w],o[w]);continue}s[w]=l.$7m(o[w])}}i(s){let o=null,w=null;const d=I=>{I&&(w?this.h(w,I):w=l.$7m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?o=I.contents:I.identifiers.includes(s)&&d(I.contents);return d(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,R.$qi)(this.contents,s),k.$vn.test(s)&&this.overrides.splice(this.overrides.findIndex(w=>y.$ub(w.identifiers,(0,k.$wn)(s))),1))}j(s,o,w){(0,R.$pi)(this.contents,s,o,d=>console.error(d)),w=w||this.keys.indexOf(s)===-1,w&&this.keys.push(s),k.$vn.test(s)&&this.overrides.push({identifiers:(0,k.$wn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$oi)(this.contents[s],d=>console.error(d))})}}e.$Bn=$;class g{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!D.$Hf(s)){const w=this.g(s);this.parseRaw(w,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:w,keys:d,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(s,o);this.b=new $(w,d,I,u?[s]:void 0),this.c=S||[]}g(s){let o={},w=null,d=[];const I=[],S=[];function u(h){Array.isArray(d)?d.push(h):w!==null&&(d[w]=h)}const m={onObjectBegin:()=>{const h={};u(h),I.push(d),d=h,w=null},onObjectProperty:h=>{w=h},onObjectEnd:()=>{d=I.pop()},onArrayBegin:()=>{const h=[];u(h),I.push(d),d=h,w=null},onArrayEnd:()=>{d=I.pop()},onLiteralValue:u,onError:(h,P,B)=>{S.push({error:h,offset:P,length:B})}};if(s)try{C.$4m(s,m),o=d[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return o}h(s,o){const w=a.$gn.as(k.$ln.Configuration).getConfigurationProperties(),d=this.i(s,w,!0,o);s=d.raw;const I=(0,R.$oi)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),S=Object.keys(s),u=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:I,keys:S,overrides:u,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(s,o,w,d){let I=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const m in s)if(k.$vn.test(m)&&w){const h=this.i(s[m],o,!1,d);S[m]=h.raw,I=I||h.hasExcludedProperties,u.push(...h.restricted)}else{const h=o[m],P=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(m),!d.exclude?.includes(m)&&(d.include?.includes(m)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&h?.restricted))?S[m]=s[m]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(s,o){const w=[];for(const d of Object.keys(s))if(k.$vn.test(d)){const I={};for(const S in s[d])I[S]=s[d][S];w.push({identifiers:(0,k.$wn)(d),keys:Object.keys(I),contents:(0,R.$oi)(I,o)})}return w}}e.$Cn=g;class t extends T.$Sc{constructor(s,o,w,d){super(),this.c=s,this.f=o,this.g=d,this.b=this.B(new M.$Nd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=t;class i{constructor(s,o,w,d,I,S,u,m,h,P,B,z,j){this.a=s,this.b=o,this.c=w,this.overrideIdentifiers=d,this.d=I,this.f=S,this.g=u,this.h=m,this.i=h,this.j=P,this.k=B,this.l=z,this.m=j}get value(){return b(this.c)}n(s,o,w){const d=s.inspect(o,w);return{get value(){return b(d.value)},get override(){return b(d.override)},get merged(){return b(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,o,w,d,I=new $,S=new $,u=new A.$Ac,m=new $,h=new A.$Ac){this.c=s,this.d=o,this.f=w,this.g=d,this.h=I,this.i=S,this.j=u,this.l=m,this.m=h,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,o,w){return this.q(s,o,w).getValue(s)}updateValue(s,o,w={}){let d;w.resource?(d=this.m.get(w.resource),d||(d=new $,this.m.set(w.resource,d))):d=this.l,o===void 0?d.removeValue(s):d.setValue(s,o),w.resource||(this.a=null)}inspect(s,o,w){const d=this.q(s,o,w),I=this.u(o.resource,w),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const m of d.overrides)for(const h of m.identifiers)d.getOverrideValue(s,h)!==void 0&&u.add(h);return new i(s,o,d.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,S)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const w=[];if(!o){const{added:d,updated:I,removed:S}=v(this.c,s);o=[...d,...I,...S]}for(const d of o)for(const I of(0,k.$wn)(d)){const S=this.c.getKeysForOverrideIdentifier(I),u=s.getKeysForOverrideIdentifier(I),m=[...u.filter(h=>S.indexOf(h)===-1),...S.filter(h=>u.indexOf(h)===-1),...S.filter(h=>!l.$$m(this.c.override(I).getValue(h),s.override(I).getValue(h)))];w.push([I,m])}return this.updateDefaultConfiguration(s),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:w,removed:d}=v(this.d,s),I=[...o,...w,...d];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.applicationConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.localUserConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.remoteUserConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:w,removed:d,overrides:I}=v(this.workspaceConfiguration,s),S=[...o,...w,...d];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(s,o){const w=this.p.get(s),{added:d,updated:I,removed:S,overrides:u}=v(w,o),m=[...d,...I,...S];return(m.length||!w)&&this.updateFolderConfiguration(s,o),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:w,updated:d,removed:I,overrides:S}=v(o,void 0);return{keys:[...w,...d,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,w){let d=this.r(o,w);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(d=d.merge(this.d)),d}r({resource:s},o){let w=this.s();if(o&&s){const d=o.getFolder(s);d&&(w=this.t(d.uri)||w);const I=this.m.get(s);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const w=this.s(),d=this.j.get(s);d?(o=w.merge(d),this.b.set(s,o)):o=w}return o}u(s,o){if(o&&s){const w=o.getFolder(s);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:w,overrides:d,keys:I}=this.j.get(o);return s.push([o,{contents:w,overrides:d,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(w=>s.add(w))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>s.add(w))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(s).forEach(d=>o.add(d))),[...o.values()]}static parse(s){const o=this.x(s.defaults),w=this.x(s.policy),d=this.x(s.application),I=this.x(s.user),S=this.x(s.workspace),u=s.folders.reduce((m,h)=>(m.set(f.URI.revive(h[0]),this.x(h[1])),m),new A.$Ac);return new c(o,w,d,I,new $,S,u,new $,new A.$Ac)}static x(s){return new $(s.contents,s.keys,s.overrides)}}e.$En=c;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,o=new Map;for(const d of r)d.keys.forEach(I=>s.add(I)),d.overrides.forEach(([I,S])=>{const u=(0,A.$xc)(o,I,new Set);S.forEach(m=>u.add(m))});const w=[];return o.forEach((d,I)=>w.push([I,[...d.values()]])),{keys:[...s.values()],overrides:w}}e.$Fn=p;class E{constructor(s,o,w,d){this.change=s,this.f=o,this.g=w,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,o){const w=this.a+s,d=this.d.indexOf(w);if(d<0)return!1;const I=d+w.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,m=this.g.getValue(s,o,this.h);return!l.$$m(u,m)}return!0}}e.$Gn=E;function v(r,s){const{added:o,removed:w,updated:d}=n(s?.rawConfiguration,r?.rawConfiguration),I=[],S=r?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const m=u.filter(h=>!S.includes(h));for(const h of m)I.push([h,s.getKeysForOverrideIdentifier(h)])}if(r){const m=S.filter(h=>!u.includes(h));for(const h of m)I.push([h,r.getKeysForOverrideIdentifier(h)])}if(s&&r){for(const m of S)if(u.includes(m)){const h=n({contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});I.push([m,[...h.added,...h.removed,...h.updated]])}}return{added:o,removed:w,updated:d,overrides:I}}function n(r,s){const o=r?s?r.keys.filter(I=>s.keys.indexOf(I)===-1):[...r.keys]:[],w=s?r?s.keys.filter(I=>r.keys.indexOf(I)===-1):[...s.keys]:[],d=[];if(r&&s){for(const I of s.keys)if(r.keys.indexOf(I)!==-1){const S=(0,R.$ri)(s.contents,I),u=(0,R.$ri)(r.contents,I);l.$$m(S,u)||d.push(I)}}return{added:o,removed:w,updated:d}}}),define(Ae[97],Re([1,0,9,4]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,M.$Ph)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=T;class A{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class D extends y.$bb{static isNotAvailable(k){return k instanceof D&&k._code===l.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===l.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===l.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===l.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,a=l.Unknown,b){super(k),this._message=k,this._code=a,this._detail=b,this.isHandled=a===l.NotAvailable&&b===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Sk=D;function f(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$Tk=f}),define(Ae[53],Re([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function M(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$Uk=M;function C(f){if(!f)return;const R=f.indexOf("+");return R<0?f:f.substr(0,R)}e.$Vk=C;function T(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Wk=T;function A(f){const{host:R,port:k}=D(f);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.$Xk=A;function l(f,R){let{host:k,port:a}=D(f);return typeof a>"u"&&(a=R),{host:k,port:a}}e.$Yk=l;function D(f){const R=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=f.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=f.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:f,port:void 0}}}),define(Ae[21],Re([1,0,16,4,53]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function T(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$4l=T,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,p=typeof i=="string"?i:i.value;return y.$2e(c,p)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$6l=D;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$7l=f;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=R;function k(g){return a(g)}e.$9l=k;function a(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$0l=a;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$$l=b;function $(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Vk)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$_l=$,e.$am=(0,M.$Ph)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,21]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const D of A){const f=this.readActivationEvents(D);f.length>0&&(l[M.$6l.toKey(D.identifier)]=f)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const D in A.contributes){const f=this.a.get(D);if(!f)continue;const R=A.contributes[D],k=Array.isArray(R)?R:[R];try{f(k,l)}catch(a){(0,y.$1)(a)}}return l}}e.$UE=C,e.$VE=new C}),define(Ae[178],Re([1,0,22,73,36]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function T(D){if(y.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,f,R,k,a,b,$,g,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=$,i.sessionID=(0,C.$eg)()+Date.now(),i.commitHash=k,i.version=a,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$i)(y.$u),i["common.nodePlatform"]=M.$dc,i["common.nodeArch"]=R,i["common.product"]=t||"desktop",g&&(i["common.msftInternal"]=g);let c=0;const p=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),y.$m&&(i["common.snap"]="true");const E=T(f);return E&&(i["common.platformDetail"]=E),i}e.$ho=A;function l(D){const f=M.env.USERDNSDOMAIN;if(!f)return!1;const R=f.toLowerCase();return D.some(k=>R===k)}e.$io=l}),define(Ae[179],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,y.$Ph)("telemetryService"),e.$dl=(0,y.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var M;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[54],Re([1,0,24,15,5,45,53,178,179]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class f{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$jo=f;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=R,e.$lo=new R;class k{async publicLog(w,d,I){}async publicLogError(w,d,I){}}e.$mo=k,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.$mi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$qo=a;function b(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry)}e.$ro=b;function $(o,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$so=$;function g(o){const w=o.getValue(D.$kl),d=o.getValue(D.$ll);if(o.getValue(D.$ml)===!1||d===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=g;function t(o){const w={},d={},I={};p(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?d[S]=u:typeof u=="boolean"?d[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),w[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(w[S]=u)}return{properties:w,measurements:d}}e.$uo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const w=(0,A.$Vk)(o);return i.has(w)?w:"other"}e.$vo=c;function p(o,w,d=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],m=I?I+S:S;Array.isArray(u)?w[m]=(0,y.$_m)(u):u instanceof Date?w[m]=u.toISOString():(0,M.$Af)(u)?d<2?p(u,w,d+1,m+"."):w[m]=(0,y.$_m)(u):w[m]=u}}function E(o,w){const d=o.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,l.$io)(d)||I}e.$wo=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$xo=v;function n(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const I=[];for(const h of w)for(;;){const P=h.exec(o);if(!P)break;I.push([P.index,h.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(d="";;){const h=u.exec(o);if(!h)break;const P=I.some(([B,z])=>h.index<z&&B<u.lastIndex);!S.test(h[0])&&!P&&(d+=o.substring(m,h.index)+"<REDACTED: user-file-path>",m=u.lastIndex)}return m<o.length&&(d+=o.substr(m)),d}function r(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of w)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function s(o,w){return(0,y.$9m)(o,d=>{if(d instanceof f||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let I=d.replaceAll("%20"," ");I=n(I,w);for(const S of w)I=I.replace(S,"");return I=r(I),I}})}e.$yo=s}),define(Ae[180],Re([1,0,16,92,21,22,2,9,73,54]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function R(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,y.$We)(s.id,o.id)===0}e.$zo=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const w=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,w,d)}static parse(o){const w=k.exec(o);return w&&w[1]&&w[2]?new a({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,d="undefined"){this.version=w,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$Ao=a;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(s){const o=b.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$Bo=$;function g(s,o){return`${s}.${o}`}e.$Co=g;function t(s){return s.toLowerCase()}e.$Do=t;function i(s,o){return t(g(s??C.$2l,o))}e.$Eo=i;function c(s,o){const w=[],d=I=>{for(const S of w)if(S.some(u=>R(o(u),o(I))))return S;return null};for(const I of s){const S=d(I);S?S.push(I):w.push([I])}return w}e.$Fo=c;function p(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Go=p;function E(s){return{id:new f.$jo(s.identifier.id),name:new f.$jo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Ho=E,e.$Io=new C.$6l("pprice.better-merge");function v(s,o){const w=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const I=d.shift();if(I&&w.every(S=>!R(S.identifier,{id:I}))){const S=s.filter(u=>R(u.identifier,{id:I}));S.length===1&&(w.push(S[0]),d.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Jo=v;async function n(s,o){if(!T.$l)return!1;let w;try{w=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$0)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,o){const w=await n(s,o),d=(0,M.$6n)(w?"alpine":T.$u,D.$ec);return o.debug("ComputeTargetPlatform:",d),d}e.$Ko=r}),define(Ae[181],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;function y(D){return[...D.entries()]}e.$kr=y;function M(D){return D?[...D.entries()]:[]}e.$lr=M;function C(D){return new Map(D)}e.$mr=C;function T(D){return new Map(D??[])}e.$nr=T;function A(D){return Array.from(D.entries()).map(f=>[f[0],y(f[1].map),M(f[1].descriptionMap)])}e.$or=A;function l(D){return new Map(D.map(f=>[f[0],{map:C(f[1]),descriptionMap:T(f[2])}]))}e.$pr=l}),define(Ae[182],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,A=5){const l=T(D=>{const f=typeof D=="string"?D:D.data;let R=this.a.get(C);if(R){R.data.push(f);return}const k=setTimeout(()=>this.flushBuffer(C),A);R={data:[f],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),l.dispose()}},this.a.set(C,R)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$Skb=y}),define(Ae[183],Re([1,0,12,89,43,5,15,2,144,72,30]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.IconFontDefinition=e.IconContribution=e.$5v=void 0,e.$5v={IconContribution:"base.contributions.icons"};var k;(function(E){function v(n,r){let s=n.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=$.getIcon(s.id);if(!o)return;s=o.defaults}return s}E.getDefinition=v})(k||(e.IconContribution=k={}));var a;(function(E){function v(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}E.toJSONObject=v;function n(r){const s=o=>(0,A.$yf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,A.$yf)(o.format)&&(0,A.$yf)(o.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=n})(a||(e.IconFontDefinition=a={}));class b{constructor(){this.a=new T.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,n,r,s){const o=this.b[v];if(o){if(r&&!o.description){o.description=r,this.d.properties[v].markdownDescription=`${r} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=r),this.a.fire()}return o}const w={id:v,description:r,defaults:n,deprecationMessage:s};this.b[v]=w;const d={$ref:"#/definitions/icons"};return s&&(d.deprecationMessage=s),r&&(d.markdownDescription=`${r}: $(${v})`),this.d.properties[v]=d,this.e.enum.push(v),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const n=this.e.enum.indexOf(v);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,n){const r=this.f[v];return r||(this.f[v]=n,this.a.fire(),n)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,w)=>o.id.localeCompare(w.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(w=>!!w.description).sort(v))r.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of s.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(v))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const $=new b;R.$gn.add(e.$5v.IconContribution,$);function g(E,v,n,r){return $.registerIcon(E,v,n,r)}e.$6v=g;function t(){return $}e.$7v=t;function i(){const E=(0,M.$Sj)();for(const v in E){const n="\\"+E[v].toString(16);$.registerIcon(v,{fontCharacter:n})}}i(),e.$8v="vscode://schemas/icons";const c=R.$gn.as(f.$hn.JSONContribution);c.registerSchema(e.$8v,$.getIconSchema());const p=new y.$6g(()=>c.notifySchemaChanged(e.$8v),200);$.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.$9v=g("widget-close",M.$Uj.close,(0,D.localize)(2,null)),e.$0v=g("goto-previous-location",M.$Uj.arrowUp,(0,D.localize)(3,null)),e.$$v=g("goto-next-location",M.$Uj.arrowDown,(0,D.localize)(4,null)),e.$_v=C.ThemeIcon.modify(M.$Uj.sync,"spin"),e.$aw=C.ThemeIcon.modify(M.$Uj.loading,"spin")}),define(Ae[184],Re([1,0,5,45,4,14]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,C.$Ph)("tunnelService"),e.$$u=(0,C.$Ph)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function D(t){return!!t.forwardPort}e.$_u=D;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$av=R,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$bv.indexOf(t)>=0}e.$cv=k,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$dv.indexOf(t)>=0}e.$ev=a;function b(t,i,c,p){if(c===1)return!1;if(c===2&&a(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$fv=b;class ${constructor(i,c,p){this.remoteAddress=i,this.localAddress=c,this.b=p,this.a=new y.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=$;let g=class{constructor(i,c){this.j=i,this.k=c,this.a=new y.$Nd,this.onTunnelOpened=this.a.event,this.b=new y.$Nd,this.onTunnelClosed=this.b.event,this.c=new y.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const p of c){const E=Array.from(p.values());for(const v of E){const n=await v.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(p=>typeof p!="string"?p?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,p,E,v){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:p,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(a(i)||k(i))&&(i=e.$bv[0]);const p=this.r(i,c);if(p)return++p.refcount,p.value}openTunnel(i,c,p,E,v,n=!1,r,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${p} on local port ${v}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),E||(E=this.l),this.f&&this.i.has(p)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,c,p,E,v,n,r,s);return w?w.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,p),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,p);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(d);return(d.tunnelRemoteHost!==c||d.tunnelRemotePort!==p)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&d.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const p=c.get(i.tunnelRemotePort);p&&(p.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,p))}}}}async o(i,c,p){if(p.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const E=p.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),E}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const p=this.e.get(i);if(p&&p.has(c)){const E=p.get(c);E.refcount=0,await this.o(i,c,E)}}p(i,c,p){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:p})}async q(i,c){const p=this.e.get(i);if(p){const E=p.get(c),v=E?await E.value:void 0;(!v||typeof v=="string")&&p.delete(c),p.size===0&&this.e.delete(i)}}r(i,c){const p=[i];k(i)?(p.push(...e.$bv),p.push(...e.$dv)):a(i)&&p.push(...e.$dv);const E=p.map(v=>this.e.get(v));for(const v of E){const n=v?.get(c);if(n)return n}}canTunnel(i){return!!R(i)}t(i,c,p,E,v,n,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${p} on local port ${E}.`);const s=p;this.i.add(s);const o=E===void 0?p:E,w={elevationRequired:v?this.isPortPrivileged(o):!1},d={remoteAddress:{host:c,port:p},localAddressPort:E,privacy:n,public:n?n!==l.Private:void 0,protocol:r},I=i.forwardPort(d,w);return I?(this.p(c,p,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$hv=g,e.$hv=g=qe([Ve(0,T.$0i),Ve(1,M.$ji)],g)}),define(Ae[185],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$iv=void 0,e.$iv=(0,y.$Ph)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[186],Re([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0;function M(D){return D.scheme!==y.Schemas.file&&D.scheme!==y.Schemas.vscodeRemote}e.$PJ=M;function C(D){if(D.folders.length)return D.folders.every(f=>M(f.uri))?D.folders[0].uri:void 0;if(D.configuration&&M(D.configuration))return D.configuration}e.$QJ=C;function T(D){return C(D)?.scheme}e.$RJ=T;function A(D){return C(D)?.authority}e.$SJ=A;function l(D){return C(D)!==void 0}e.$TJ=l}),define(Ae[55],Re([1,0,145,20,49,23,2,4,13]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,l.$Ph)("contextService");function f(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Zh=f;function R(o){return typeof o?.id=="string"&&!f(o)&&!a(o)}e.$1h=R,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function k(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:w?e.$2h:e.$3h;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$4h=k;function a(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$5h=a;function b(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.$6h=b;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function g(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$7h=g;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$8h=t;class i{constructor(w,d,I,S,u){this.h=w,this.j=I,this.k=S,this.l=u,this.c=C.$Vh.forUris(this.l,()=>!0),this.folders=d}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Vh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=i;class c{constructor(w,d){this.raw=d,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,T.$vg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=c;function p(o){return new c({uri:o,index:0,name:(0,T.$rg)(o)},{uri:o.toString()})}e.$$h=p,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,y.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(o,w){return T.$mg.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$di=E;function v(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===D.Schemas.tmp}e.$ei=v,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$fi}e.$gi=n;function r(o,w){return!E(o,w)&&!v(o)}e.$hi=r;function s(o){return(typeof o=="string"?(0,M.$oc)(o):(0,T.$tg)(o))===e.$ai}e.$ii=s}),define(Ae[74],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$bcc=y}),define(Ae[40],Re([1,0,13,23,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class T{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$kg(l=>{const D=this.b.get(l.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(l,D){D===null?this.b.delete(l.scheme):this.b.set(l.scheme,D)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$dcc=T,e.$ecc=(0,C.$Ph)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=void 0,e.$xM=(0,y.$Ph)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;let A=class extends C.$EN{constructor(D,f,R){const k=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=R.remote.isRemote?(0,y.localize)(0,null):D?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(k,{name:a}))}};e.$mec=A,e.$mec=A=qe([Ve(1,M.$$i),Ve(2,T.$xM)],A)}),define(Ae[188],Re([1,0,12]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;class M{constructor(A,l,D){this.h=new Map,this.a=A,this.b=l,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$6g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of f.values())R.complete()}catch(R){for(const k of f.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let D=this.f[A];return typeof D>"u"&&(D=l),D}update(A,l){this.f[A]=l;const D=this.h.get(A);if(D!==void 0)return D.p;const f=new y.$ch;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$Gcc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$Hcc=C}),define(Ae[189],Re([1,0,5,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class C{constructor(A){this.c=A,this.a=new y.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,D,f){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(l.value,D,f);this.b.fire(k)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$6dc=C}),define(Ae[17],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0,e.$hM=(0,y.$Ph)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$iM=M}),define(Ae[190],Re([1,0,21,5]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class C{#e;constructor(A,l){this.b=new M.$Nd,this.onDidChange=this.b.event,this.a=y.$6l.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$Scc=C}),define(Ae[56],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0,e.$occ=(0,y.$Ph)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$pcc=M}),define(Ae[191],Re([1,0,26]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcb=e.$ycb=void 0;class M{constructor(){this.buffers=[]}add(D){let f=this.buffers.indexOf(D);return f<0&&(f=this.buffers.length,this.buffers.push(D)),f}}function C(l,D){if(D.serializeBuffersForPostMessage){const f=new M,k=JSON.stringify(l,(b,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add($)};if(ArrayBuffer.isView($)){const g=T($);if(g)return{$$vscode_array_buffer_reference$$:!0,index:f.add($.buffer),view:{type:g,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),a=f.buffers.map(b=>{const $=new Uint8Array(b);return y.$be.wrap($)});return{message:k,buffers:a}}else return{message:JSON.stringify(l),buffers:[]}}e.$ycb=C;function T(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,D){const f=D.map(a=>{const b=new ArrayBuffer(a.byteLength);return new Uint8Array(b).set(a.buffer),b}),R=D.length?(a,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const $=b,{index:g}=$,t=f[g];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(l,R),arrayBuffers:f}}e.$zcb=A}),define(Ae[99],Re([1,0,159,15,2,6,4,30,39,13,37,127,29]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=e.$fE=e.$eE=e.EditorsOrder=e.$dE=e.CloseDirection=e.$cE=e.$bE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.EditorInputCapabilities=e.$5D=e.SaveReason=e.Verbosity=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$SD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$UD="workbench.editor.sidebysideEditor",e.$VD="workbench.editors.textDiffEditor",e.$WD="workbench.editors.binaryResourceDiffEditor";var b;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var $;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function g(ae){const ve=ae;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$XD=g;function t(ae,ve,_){for(const W of _.visibleEditorPanes)if(W.group.id===ve&&ae.matches(W.input))return W.getViewState()}e.$YD=t;function i(ae){if(d(ae))return!1;const ve=ae;return C.URI.isUri(ve?.resource)}e.$ZD=i;function c(ae){if(d(ae))return!1;const ve=ae;return ve?.original!==void 0&&ve.modified!==void 0}e.$1D=c;function p(ae){if(d(ae)||c(ae))return!1;const ve=ae;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$2D=p;function E(ae){if(d(ae))return!1;const ve=ae;return ve?ve.resource===void 0||ve.resource.scheme===f.Schemas.untitled||ve.forceUntitled===!0:!1}e.$3D=E;function v(ae){if(d(ae))return!1;const ve=ae;return C.URI.isUri(ve?.base?.resource)&&C.URI.isUri(ve?.input1?.resource)&&C.URI.isUri(ve?.input2?.resource)&&C.URI.isUri(ve?.result?.resource)}e.$4D=v;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(ve,_){let W=this.a.get(ve);return W||(W={source:ve,label:_},this.a.set(ve,W)),W.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$5D=new s;var o;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad",ae[ae.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(o||(e.EditorInputCapabilities=o={}));class w extends T.$Sc{}e.$6D=w;function d(ae){return ae instanceof w}e.$7D=d;function I(ae){const ve=ae;return C.URI.isUri(ve?.preferredResource)}function S(ae){const ve=ae;return d(ve?.primary)&&d(ve?.secondary)}e.$8D=S;function u(ae){const ve=ae;return d(ve?.modified)&&d(ve?.original)}e.$9D=u;function m(ae,ve,_,W,Z){return ue(W,[(0,k.$zi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ee={..._,limits:{size:Number.MAX_VALUE}};ae.openEditor(ve,ee)}}),(0,k.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>Z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$0D=m;function h(ae){return d(ae?.editor)}e.$$D=h;function P(ae){const ve=ae;return h(ae)&&ve?.group!==void 0}e.$_D=P;function B(ae){const ve=ae;return typeof ve?.groupId=="number"&&d(ve.editor)}e.$aE=B;var z;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var j;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var V;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class N{getOriginalUri(ve,_){if(!ve)return;if(v(ve))return e.$cE.getOriginalUri(ve.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(ve);if(Z&&ee){if(_?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getOriginalUri(Z,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:_.filterByScheme});ve=_.supportSideBySide===V.PRIMARY?Z:ee}}if(c(ve)||p(ve)||v(ve))return;const W=I(ve)?ve.preferredResource:ve.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}a(ve){return S(ve)||p(ve)?{primary:ve.primary,secondary:ve.secondary}:u(ve)||c(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,_){if(!ve)return;if(v(ve))return e.$cE.getCanonicalUri(ve.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(ve);if(Z&&ee){if(_?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme});ve=_.supportSideBySide===V.PRIMARY?Z:ee}}if(c(ve)||p(ve)||v(ve))return;const W=ve.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}b(ve,_){if(Array.isArray(_)){if(_.some(W=>ve.scheme===W))return ve}else if(_===ve.scheme)return ve}}var O;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function se(ae,ve,_,W){if(!ae.isSticky(ve))return!1;switch(W.preventPinnedEditorClose){case"keyboardAndMouse":return _===O.MOUSE||_===O.KEYBOARD;case"mouse":return _===O.MOUSE;case"keyboard":return _===O.KEYBOARD}return!1}e.$bE=se,e.$cE=new N;var X;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(ve){const _=this.a=ve.get(A.$Oh);for(const[W,Z]of this.c)this.e(W,Z,_);this.c.clear()}e(ve,_,W){const Z=W.createInstance(_);this.d.set(ve,Z)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,M.$Jf)(this.b)}registerEditorSerializer(ve,_){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,_,this.a):this.c.set(ve,_),(0,T.$Qc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}l.$gn.add(e.$SD.EditorFactory,new Ee);async function Pe(ae,ve,_){return!ae||!ae.length?[]:await Promise.all(ae.map(async W=>{const Z=C.URI.revive(W.fileUri);if(!Z){_.info("Cannot resolve the path because it is not valid.",W);return}if(!await ve.canHandleResource(Z)){_.info("Cannot resolve the path because it cannot be handled",W);return}let pe=W.exists,$e=W.type;if(typeof pe!="boolean"||typeof $e!="number")try{$e=(await ve.stat(Z)).isDirectory?D.FileType.Directory:D.FileType.Unknown,pe=!0}catch(De){_.error(De),pe=!1}if(!pe&&W.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",W);return}if($e===D.FileType.Directory){_.info("Cannot resolve the path because it is a directory",W);return}const he={...W.options,pinned:!0};return pe?{resource:Z,options:he}:{resource:Z,options:he,forceUntitled:!0}}))}e.$dE=Pe;var Se;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Se||(e.EditorsOrder=Se={}));function fe(ae){const ve=ae;if(!ve)return!1;const _=ve;if(_.modified)return fe(_.modified);const W=ve;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.$eE=fe;function ye(ae){return(0,R.$Bi)(ae)}e.$fE=ye;function ue(ae,ve,_){const W=(0,R.$Ci)(ae,ve);return W.forceMessage=_?.forceMessage,W.forceSeverity=_?.forceSeverity,W.allowDialog=_?.allowDialog,W}e.$gE=ue}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=e.$qE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pE=e.$oE=e.ViewContentGroups=e.$nE=e.$mE=e.ViewContainerLocation=e.Extensions=e.$lE=e.$kE=e.$jE=void 0,e.$jE="views",e.$kE=(0,M.localize)(0,null),e.$lE=(0,k.$6v)("default-view-icon",R.$Uj.window,(0,M.localize)(1,null));var a;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var b;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$mE=[0,1,2];function $(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$nE=$;class g extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Rb)([...this.g.values()])}registerViewContainer(s,o,w){const d=this.get(s.id);if(d)return d;const I=s;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,o,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(s){for(const o of this.g.keys()){const w=this.g.get(o),d=w?.indexOf(s);if(d!==-1){w?.splice(d,1),w.length===0&&this.g.delete(o),this.f.fire({viewContainer:s,viewContainerLocation:o});return}}}get(s){return this.all.filter(o=>o.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(w=>w?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(o=>this.getViewContainerLocation(o)===s)}}l.$gn.add(a.ViewContainersRegistry,new g);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,s){const o=r.group??t.More,w=s.group??t.More;return o!==w?o.localeCompare(w):(r.order??5)-(s.order??5)}class c extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,o){this.registerViews2([{views:s,viewContainer:o}])}registerViews2(s){s.forEach(({views:o,viewContainer:w})=>this.r(o,w)),this.c.fire(s)}deregisterViews(s,o){const w=this.s(s,o);w.length&&this.f.fire({views:w,viewContainer:o})}moveViews(s,o){for(const w of this.m.keys())if(w!==o){const d=this.s(s,w);d.length&&(this.r(d,o),this.g.fire({views:d,from:w,to:o}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const o of this.j){const w=(this.m.get(o)||[]).filter(d=>d.id===s)[0];if(w)return w}return null}getViewContainer(s){for(const o of this.j)if((this.m.get(o)||[]).filter(d=>d.id===s)[0])return o;return null}registerViewWelcomeContent(s,o){return this.n.add(s,o),this.h.fire(s),(0,T.$Qc)(()=>{this.n.delete(s,o),this.h.fire(s)})}registerViewWelcomeContent2(s,o){const w=new Map;for(const[d,I]of o)this.n.add(s,I),w.set(d,(0,T.$Qc)(()=>{this.n.delete(s,I),this.h.fire(s)}));return this.h.fire(s),w}getViewWelcomeContent(s){const o=[];return this.n.forEach(s,w=>o.push(w)),o.sort(i)}r(s,o){let w=this.m.get(o);w||(w=[],this.m.set(o,w),this.j.push(o));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));w.push(d)}}s(s,o){const w=this.m.get(o);if(!w)return[];const d=[],I=[];for(const S of w)s.includes(S)?d.push(S):I.push(S);return d.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),d}}l.$gn.add(a.ViewsRegistry,new c),e.$oE=(0,C.$Ph)("viewsService"),e.$pE=(0,C.$Ph)("viewDescriptorService");var p;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(p||(e.ViewVisibilityState=p={}));var E;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(s,o){this.c=!1,this.d=!1,(0,f.$0m)(this,s),this.d=!!o,this.resolve=async w=>{if(o&&!this.c){const d=await o(w);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qE=v;class n extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$rE=n}),define(Ae[193],Re([1,0,2,41,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$QE=e.$PE=void 0;function T(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof y.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(M.$ts.isIRange)}e.$PE=T;function A(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(T)}e.$QE=A;var l;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(l||(e.InteractiveSessionVoteDirection=l={}));var D;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$RE=(0,C.$Ph)("IChatService")}),define(Ae[194],Re([1,0,5,12,161]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new y.$Nd,this.n=new y.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,D,f,R){const k={command:l};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof R=="number"){const a=setTimeout(()=>{clearTimeout(a);const b=this.f.get(k.seq);if(b){this.f.delete(k.seq);const $={type:"response",seq:0,request_seq:k.seq,success:!1,command:l,message:(0,C.localize)(0,null,R,l)};b($)}},R)}return f&&this.f.set(k.seq,f),k.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,D){return l.type!=="event"||D.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Ug)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const D=l,f=this.f.get(D.request_seq);f&&(this.f.delete(D.request_seq),f(D));break}}}}s(l,D){D.type=l,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((D,f)=>l.set(f,D)),await(0,M.$Ug)(500),l.forEach((D,f)=>{D({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$5cb=T}),define(Ae[195],Re([1,0,162,32,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$4G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$3G=e.MemoryRangeType=e.$2G=e.State=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF="workbench.view.debug",e.$1F="workbench.debug.variablesView",e.$2F="workbench.debug.watchExpressionsView",e.$3F="workbench.debug.callStackView",e.$4F="workbench.debug.loadedScriptsView",e.$5F="workbench.debug.breakPointsView",e.$6F="workbench.debug.disassemblyView",e.$7F="workbench.panel.repl",e.$8F="workbench.panel.repl.view",e.$9F=new M.$7i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$0F=new M.$7i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$$F=new M.$7i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$_F="debugUx",e.$aG=new M.$7i(e.$_F,"default",{type:"string",description:y.localize(3,null)}),e.$bG=new M.$7i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$cG=new M.$7i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$dG=new M.$7i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$eG=new M.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$fG=new M.$7i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$gG=new M.$7i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$hG=new M.$7i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$iG=new M.$7i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$jG=new M.$7i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$kG=new M.$7i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$lG=new M.$7i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$mG=new M.$7i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$nG=new M.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$oG=new M.$7i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$pG=new M.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$qG=new M.$7i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$rG=new M.$7i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$sG=new M.$7i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$tG=new M.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$uG=new M.$7i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$vG=new M.$7i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$wG=new M.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$xG=new M.$7i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$yG=new M.$7i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$zG=new M.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$AG=new M.$7i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$BG=new M.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$CG=new M.$7i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$DG=new M.$7i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$EG=new M.$7i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$FG=new M.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$GG=new M.$7i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$HG=new M.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$IG=new M.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$JG=new M.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$KG=new M.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$LG=new M.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$MG=new M.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$NG=new M.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$OG=new M.$7i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$PG=new M.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$QG=new M.$7i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$RG=new M.$7i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$SG=new M.$7i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$TG=new M.$7i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$UG=new M.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$VG=new M.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const T=a=>y.localize(51,null,a);e.$WG=T,e.$XG="editor.contrib.debug",e.$YG="editor.contrib.breakpoint",e.$ZG="debug",e.$1G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function l(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$2G=l;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$3G="vscode-debug-memory";var f;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var R;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$4G=(0,C.$Ph)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[196],Re([1,0,16,2,20,24,13,41,19,18]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=void 0;const R=/{([^}]+)}/g;function k(S,u,m){return S.replace(R,function(h,P){return u&&P.length>0&&P[0]!=="_"?h:m&&m.hasOwnProperty(P)?m[P]:h})}e.$oF=k;function a(S){const u={};for(const m of Object.keys(S))m.startsWith("!")||(u[m]=S[m]);return u}e.$pF=a;function b(S){return S.configuration.request==="attach"&&!$(S)&&(!S.parentSession||b(S.parentSession))}e.$qF=b;function $(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,y.$2e)(u,"extensionhost")||(0,y.$2e)(u,"pwa-extensionhost")?S:S.parentSession?$(S.parentSession):void 0}e.$rF=$;function g(S){return S.type&&(S.label||S.program||S.runtime)}e.$sF=g;function t(S,u,m){let h,P=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=B.exec(S);){const j=z.index+1,V=j+z[0].length;if(j<=u&&V>=m){h=z[0],P=j;break}}if(h){const j=/\w+/g;let V=null;for(;(V=j.exec(h))&&!(V.index+1+P+V[0].length>=m););V&&(h=h.substring(0,j.lastIndex))}return h?{start:P,end:P+h.length-1}:{start:0,end:0}}e.$tF=t;async function i(S,u,m,h){if(S.evaluatableExpressionProvider.has(u)){const P=S.evaluatableExpressionProvider.ordered(u),B=(0,f.$Hb)(await Promise.all(P.map(async z=>{try{return await z.provideEvaluatableExpression(u,m,h??D.CancellationToken.None)}catch{return}})));if(B.length>0){let z=B[0].expression;const j=B[0].range;return z||(z=u.getLineContent(m.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:z}}}else{const P=u.getLineContent(m.lineNumber),{start:B,end:z}=t(P,m.column,m.column),j=P.substring(B-1,z);return{matchingExpression:j,range:new l.$ts(m.lineNumber,B,m.lineNumber,B+j.length)}}return null}e.$uF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(S){return!!(S&&S.match(c))}e.$vF=p;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(p(S.path))return M.URI.parse(S.path);if((0,C.$ic)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return S.path}function n(S,u){const m=u?E:v,h=(0,T.$7m)(S);return s(h,(P,B)=>{P&&B&&(B.path=m(B))}),h}e.$wF=n;function r(S,u){const m=u?E:v,h=(0,T.$7m)(S);return s(h,(P,B)=>{!P&&B&&(B.path=m(B))}),h}e.$xF=r;function s(S,u){switch(S.type){case"event":{const m=S;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=S;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const m=S;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":m.body.sources.forEach(h=>u(!1,h));break;case"scopes":m.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":m.body?.instructions.forEach(P=>u(!1,P.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):w(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:w(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$yF=o;function w(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function d(S,u){const m=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await S.reloadConfiguration()}e.$zF=d;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$AF=I}),define(Ae[75],Re([1,0,26,38,66,67,13,20,22,32]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sI=e.$rI=e.$qI=e.$pI=e.CellStatusbarAlignment=e.$oI=e.$nI=e.$mI=e.NotebookEditorPriority=e.$lI=e.$kI=e.$jI=e.$iI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hI=e.$gI=e.$fI=e.$eI=e.CellKind=e.$dI=e.$cI=e.$bI=void 0,e.$bI="workbench.editor.notebook",e.$cI="workbench.editor.notebookTextDiffEditor",e.$dI="workbench.editor.interactive";var R;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(R||(e.CellKind=R={})),e.$eI=["application/json","application/javascript","text/html","image/svg+xml",T.$Pr.latex,T.$Pr.markdown,"image/png","image/jpeg",T.$Pr.text],e.$fI=[T.$Pr.latex,T.$Pr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Pr.text],e.$gI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hI="_notAvailable";var k;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var $;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var g;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var p;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const se=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${se.join("")}]+`),Ee=7;function Pe(ve,_){const W=_.toString(Ee),ee=`${W.length<se.length?se[W.length-1]:"z"}${W}s${(0,y.$ve)(y.$be.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:O.scheme,fragment:ee})}O.generate=Pe;function Se(ve){if(ve.scheme!==O.scheme)return;const _=ve.fragment.indexOf("s");if(_<0)return;const W=parseInt(ve.fragment.substring(0,_).replace(X,""),Ee),Z=(0,y.$ue)(ve.fragment.substring(_+1)).toString();if(!isNaN(W))return{handle:W,notebook:ve.with({scheme:Z,fragment:null})}}O.parse=Se;function fe(ve,_){return ve.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${ve.scheme!==A.Schemas.file?ve.scheme:""}`})}O.generateCellOutputUri=fe;function ye(ve){if(ve.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!_)return;const W=_[1]&&_[1]!==""?_[1]:void 0,Z=_[2];return{outputId:W,notebook:ve.with({scheme:Z||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=ye;function ue(ve,_,W){return O.generate(ve,_).with({scheme:W})}O.generateCellPropertyUri=ue;function ae(ve,_){if(ve.scheme===_)return O.parse(ve.with({scheme:O.scheme}))}O.parseCellPropertyUri=ae})(p||(e.CellUri=p={}));const E=O=>D.$j?O.replace(/\//g,"\\"):O;class v{constructor(se=[],X=e.$eI){this.e=X,this.d=[...new Set(se)].map(Ee=>({pattern:Ee,matches:M.$wj(E(Ee))}))}sort(se){const X=new Map(C.Iterable.map(se,Pe=>[Pe,E(Pe)]));let Ee=[];for(const{matches:Pe}of this.d)for(const[Se,fe]of X)if(Pe(fe)){Ee.push(Se),X.delete(Se);break}return X.size&&(Ee=Ee.concat([...X.keys()].sort((Pe,Se)=>this.e.indexOf(Pe)-this.e.indexOf(Se)))),Ee}prioritize(se,X){const Ee=this.f(se);if(Ee===-1){this.d.unshift({pattern:se,matches:M.$wj(E(se))});return}const Pe=new Set(X.map(fe=>this.f(fe,Ee)));Pe.delete(-1);const Se=Array.from(Pe).sort();this.d.splice(Ee+1,0,...Se.map(fe=>this.d[fe]));for(let fe=Se.length-1;fe>=0;fe--)this.d.splice(Se[fe],1)}toArray(){return this.d.map(se=>se.pattern)}f(se,X=this.d.length){const Ee=E(se);for(let Pe=0;Pe<X;Pe++)if(this.d[Pe].matches(Ee))return Pe;return-1}}e.$iI=v;function n(O,se,X,Ee=(Pe,Se)=>Pe===Se){const Pe=[];function Se(ue,ae,ve){if(ae===0&&ve.length===0)return;const _=Pe[Pe.length-1];_&&_.start+_.deleteCount===ue?(_.deleteCount+=ae,_.toInsert.push(...ve)):Pe.push({start:ue,deleteCount:ae,toInsert:ve})}let fe=0,ye=0;for(;;){if(fe===O.length){Se(fe,0,se.slice(ye));break}if(ye===se.length){Se(fe,O.length-fe,[]);break}const ue=O[fe],ae=se[ye];if(Ee(ue,ae)){fe+=1,ye+=1;continue}X(ae)?(Se(fe,1,[]),fe+=1):(Se(fe,0,[ae]),ye+=1)}return Pe}e.$jI=n,e.$kI=new f.$7i("notebookEditorCursorAtBoundary","none"),e.$lI=new f.$7i("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(O){const se=O;return!!((typeof se.include=="string"||M.$xj(se.include))&&(typeof se.exclude=="string"||M.$xj(se.exclude)))}e.$mI=s;function o(O,se,X){if(Array.isArray(O.viewType)&&O.viewType.indexOf(se)>=0||O.viewType===se)return!0;if(O.filenamePattern){const Ee=s(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,Pe=s(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(M.$vj(Ee,(0,l.$nc)(X.fsPath).toLowerCase()))return!(Pe&&M.$vj(Pe,(0,l.$nc)(X.fsPath).toLowerCase()))}return!1}e.$nI=o,e.$oI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class d{static{this.d="notebook/"}static create(se){return`${d.d}${se}`}static parse(se){if(se.startsWith(d.d))return se.substring(d.d.length)}}e.$pI=d;function I(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$qI=I;const S=new TextDecoder;function u(O){const se=[];let X=!1;for(const fe of O)(se.length===0||X)&&(se.push(fe),X=!0);let Ee=P(se);const Pe=y.$be.concat(se.map(fe=>y.$be.wrap(fe))),Se=N(Pe);return Ee=Ee||Se.byteLength!==Pe.byteLength,{data:Se,didCompression:Ee}}e.$rI=u,e.$sI=`${String.fromCharCode(27)}[A`;const m=e.$sI.split("").map(O=>O.charCodeAt(0)),h=10;function P(O){let se=!1;return O.forEach((X,Ee)=>{if(Ee===0||X.length<e.$sI.length)return;const Pe=O[Ee-1],Se=X.subarray(0,e.$sI.length);if(Se[0]===m[0]&&Se[1]===m[1]&&Se[2]===m[2]){const fe=Pe.lastIndexOf(h);if(fe===-1)return;se=!0,O[Ee-1]=Pe.subarray(0,fe),O[Ee]=X.subarray(e.$sI.length)}}),se}function B(O){let se=O;do O=se,se=O.replace(/[^\n]\x08/gm,"");while(se.length<O.length);return O}function z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const se=O.match(/^(.*)\r+/m)[1];let X=O.match(/\r+(.*)$/m)[1];X=X+se.slice(X.length,se.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return O}const j="\b".charCodeAt(0),V="\r".charCodeAt(0);function N(O){return!O.buffer.includes(j)&&!O.buffer.includes(V)?O:y.$be.fromString(z(B(S.decode(O.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,67,16,15,2,36,21,39,97,75]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$){"use strict";var g,t,i,c,p,E,v,n,r,s,o,w,d,I,S,u,m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$9L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.TestRunProfileKind=e.TestResultState=e.$PL=e.$OL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$NL=e.$ML=e.$LL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$KL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.ColorThemeKind=e.$EL=e.$DL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$CL=e.DebugConsoleMode=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$wL=e.$vL=e.FileChangeType=e.$uL=e.$tL=e.$sL=e.$rL=e.InlineCompletionTriggerKind=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.ConfigurationTarget=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$7K=e.ViewBadge=e.ProgressLocation=e.$6K=e.$5K=e.TaskScope=e.ShellQuoting=e.$4K=e.$3K=e.$2K=e.TaskPanelKind=e.TaskRevealKind=e.$1K=e.TerminalLocation=e.$ZK=e.$YK=e.$XK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$WK=e.$VK=e.$UK=e.$TK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$SK=e.StatusBarAlignment=e.ViewColumn=e.$RK=e.$QK=e.$PK=e.$OK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$NK=e.$MK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.LanguageStatusSeverity=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.CodeActionTriggerKind=e.$AK=e.$zK=e.SymbolTag=e.SymbolKind=e.$yK=e.DocumentHighlightKind=e.$xK=e.$wK=e.$vK=e.$uK=e.DiagnosticSeverity=e.DiagnosticTag=e.$tK=e.$sK=e.FileEditType=e.$rK=e.$qK=e.$pK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(U){return Object.assign(U,{apply:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const ke=re.length===1?[]:re[1];return Reflect.construct(U,ke,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const[ke,...He]=re;return Reflect.construct(U,He,ke.constructor)}}})}var B;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var z;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let j=g=class{static from(...L){let re=L;return new g(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iK=j,e.$iK=j=g=qe([P],j);let V=t=class{static Min(...L){if(L.length===0)throw new TypeError;let re=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isBefore(re)&&(re=He)}return re}static Max(...L){if(L.length===0)throw new TypeError;let re=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isAfter(re)&&(re=He)}return re}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:re,character:ke}=L;return typeof re=="number"&&typeof ke=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,re){if(L<0)throw(0,M.$7)("line must be non-negative");if(re<0)throw(0,M.$7)("character must be non-negative");this.c=L,this.e=re}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,re=0){if(L===null||re===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,re=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&re===0?this:new t(this.line+ke,this.character+re)}with(L,re=this.character){if(L===null||re===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,re=typeof L.character=="number"?L.character:this.character),ke===this.line&&re===this.character?this:new t(ke,re)}toJSON(){return{line:this.line,character:this.character}}};e.$jK=V,e.$jK=V=t=qe([P],V);let N=i=class{static isRange(L){return L instanceof i?!0:L?V.isPosition(L.start)&&V.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,re,ke,He){let Ze,ot;if(typeof L=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new V(L,re),ot=new V(ke,He)):V.isPosition(L)&&V.isPosition(re)&&(Ze=V.of(L),ot=V.of(re)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):V.isPosition(L)?!(V.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const re=V.Max(L.start,this.c),ke=V.Min(L.end,this.e);if(!re.isAfter(ke))return new i(re,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const re=V.Min(L.start,this.c),ke=V.Max(L.end,this.end);return new i(re,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,re=this.end){if(L===null||re===null)throw(0,M.$7)();let ke;return L?V.isPosition(L)?ke=L:(ke=L.start||this.start,re=L.end||this.end):ke=this.start,ke.isEqual(this.c)&&re.isEqual(this.end)?this:new i(ke,re)}toJSON(){return[this.start,this.end]}};e.$kK=N,e.$kK=N=i=qe([P],N);let O=c=class extends N{static isSelection(L){return L instanceof c?!0:L?N.isRange(L)&&V.isPosition(L.anchor)&&V.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,re,ke,He){let Ze,ot;if(typeof L=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new V(L,re),ot=new V(ke,He)):V.isPosition(L)&&V.isPosition(re)&&(Ze=V.of(L),ot=V.of(re)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lK=O,e.$lK=O=c=qe([P],O);const se=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$7)("connectionToken")};class X{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,re,ke){if(typeof L!="string"||L.length===0)throw(0,M.$7)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,M.$7)("port");typeof ke<"u"&&se(ke),this.host=L,this.port=Math.round(re),this.connectionToken=ke}}e.$mK=X;class Ee{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,re){this.makeConnection=L,this.connectionToken=re,typeof re<"u"&&se(re)}}e.$nK=Ee;class Pe extends Error{static NotAvailable(L,re){return new Pe(L,b.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(L){return new Pe(L,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,re=b.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L),this._message=L,this._code=re,this._detail=ke,Object.setPrototypeOf(this,Pe.prototype)}}e.$oK=Pe;var Se;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Se||(e.EndOfLine=Se={}));var fe;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let ye=p=class{static isTextEdit(L){return L instanceof p?!0:L?N.isRange(L)&&typeof L.newText=="string":!1}static replace(L,re){return new p(L,re)}static insert(L,re){return p.replace(new N(L,L),re)}static delete(L){return p.replace(L,"")}static setEndOfLine(L){const re=new p(new N(new V(0,0),new V(0,0)),"");return re.newEol=L,re}get range(){return this.c}set range(L){if(L&&!N.isRange(L))throw(0,M.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$7)("newEol");this.f=L}constructor(L,re){this.c=L,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pK=ye,e.$pK=ye=p=qe([P],ye);let ue=E=class{static isNotebookCellEdit(L){return L instanceof E?!0:L?xt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,re){return new E(L,re)}static insertCells(L,re){return new E(new xt(L,L),re)}static deleteCells(L){return new E(L,[])}static updateCellMetadata(L,re){const ke=new E(new xt(L,L),[]);return ke.newCellMetadata=re,ke}static updateNotebookMetadata(L){const re=new E(new xt(0,0),[]);return re.newNotebookMetadata=L,re}constructor(L,re){this.range=L,this.newCells=re}};e.$qK=ue,e.$qK=ue=E=qe([P],ue);class ae{static isSnippetTextEdit(L){return L instanceof ae?!0:L?N.isRange(L.range)&&W.isSnippetString(L.snippet):!1}static replace(L,re){return new ae(L,re)}static insert(L,re){return ae.replace(new N(L,L),re)}constructor(L,re){this.range=L,this.snippet=re}}e.$rK=ae;var ve;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,re,ke,He){this.c.push({_type:1,from:L,to:re,options:ke,metadata:He})}createFile(L,re,ke){this.c.push({_type:1,from:void 0,to:L,options:re,metadata:ke})}deleteFile(L,re,ke){this.c.push({_type:1,from:L,to:void 0,options:re,metadata:ke})}e(L,re,ke){this.c.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:re},notebookMetadata:re})}f(L,re,ke,He){const Ze=re.start,ot=re.end;(Ze!==ot||ke.length>0)&&this.c.push({_type:5,uri:L,index:Ze,count:ot-Ze,cells:ke,metadata:He})}g(L,re,ke,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:re,metadata:ke}})}replace(L,re,ke,He){this.c.push({_type:2,uri:L,edit:new ye(re,ke),metadata:He})}insert(L,re,ke,He){this.replace(L,new N(re,re),ke,He)}delete(L,re,ke){this.replace(L,re,"",ke)}has(L){return this.c.some(re=>re._type===2&&re.uri.toString()===L.toString())}set(L,re){if(re)for(const ke of re){if(!ke)continue;let He,Ze;Array.isArray(ke)?(He=ke[0],Ze=ke[1]):He=ke,ue.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ze):this.f(L,He.range,He.newCells,Ze):ae.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:L,edit:He,metadata:Ze})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[ke]=void 0);break}}(0,y.$Ib)(this.c)}}get(L){const re=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===L.toString()&&re.push(ke.edit);return re}entries(){const L=new T.$Ac;for(const re of this.c)if(re._type===2){let ke=L.get(re.uri);ke||(ke=[re.uri,[]],L.set(re.uri,ke)),ke[1].push(re.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sK=_,e.$sK=_=qe([P],_);let W=v=class{static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=v.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,re=this.e++){if(typeof L=="function"){const ke=new v;ke.e=this.e,L(ke),this.e=ke.e,L=ke.value}else L=v.c(L);return this.value+="${",this.value+=re,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,re=this.e++){const ke=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,re){if(typeof re=="function"){const ke=new v;ke.e=this.e,re(ke),this.e=ke.e,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$tK=W,e.$tK=W=v=qe([P],W);var Z;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let pe=n=class{static isLocation(L){return L instanceof n?!0:L?N.isRange(L.range)&&f.URI.isUri(L.uri):!1}constructor(L,re){if(this.uri=L,re)if(N.isRange(re))this.range=N.of(re);else if(V.isPosition(re))this.range=new N(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uK=pe,e.$uK=pe=n=qe([P],pe);let $e=class{static is(L){return L?typeof L.message=="string"&&L.location&&N.isRange(L.location.range)&&f.URI.isUri(L.location.uri):!1}constructor(L,re){this.location=L,this.message=re}static isEqual(L,re){return L===re?!0:!L||!re?!1:L.message===re.message&&L.location.range.isEqual(re.location.range)&&L.location.uri.toString()===re.location.uri.toString()}};e.$vK=$e,e.$vK=$e=qe([P],$e);let he=class{constructor(L,re,ke=ee.Error){if(!N.isRange(L))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=L,this.message=re,this.severity=ke}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,re){return L===re?!0:!L||!re?!1:L.message===re.message&&L.severity===re.severity&&L.code===re.code&&L.severity===re.severity&&L.source===re.source&&L.range.isEqual(re.range)&&(0,y.$ub)(L.tags,re.tags)&&(0,y.$ub)(L.relatedInformation,re.relatedInformation,$e.isEqual)}};e.$wK=he,e.$wK=he=qe([P],he);let De=class{constructor(L,re){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=re}};e.$xK=De,e.$xK=De=qe([P],De);var ne;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let le=class{constructor(L,re=ne.Text){this.range=L,this.kind=re}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$yK=le,e.$yK=le=qe([P],le);var ie;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var oe;(function(U){U[U.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let ge=r=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,re,ke,He,Ze){this.name=L,this.kind=re,this.containerName=Ze,typeof ke=="string"&&(this.containerName=ke),He instanceof pe?this.location=He:ke instanceof N&&(this.location=new pe(He,ke)),r.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$zK=ge,e.$zK=ge=r=qe([P],ge);let Ie=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(s.validate)}constructor(L,re,ke,He,Ze){this.name=L,this.detail=re,this.kind=ke,this.range=He,this.selectionRange=Ze,this.children=[],s.validate(this)}};e.$AK=Ie,e.$AK=Ie=s=qe([P],Ie);var F;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let K=class{constructor(L,re){this.title=L,this.kind=re}};e.$BK=K,e.$BK=K=qe([P],K);let G=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$CK=G,e.$CK=G=o=qe([P],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(L,re){if(this.range=L,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$DK=J,e.$DK=J=qe([P],J);class q{constructor(L,re,ke,He,Ze,ot){this.kind=L,this.name=re,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$EK=q;class x{constructor(L,re){this.fromRanges=re,this.from=L}}e.$FK=x;class ce{constructor(L,re){this.fromRanges=re,this.to=L}}e.$GK=ce;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ue=class{constructor(L,re){this.range=L,this.command=re}get isResolved(){return!!this.command}};e.$HK=Ue,e.$HK=Ue=qe([P],Ue);let Qe=w=class{#e;static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,re=!1){this.#e=new C.$3j(L,{supportThemeIcons:re})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,re){return this.#e.appendCodeblock(re??"",L),this}};e.$IK=Qe,e.$IK=Qe=w=qe([P],Qe);let Ge=class{constructor(L,re){this.label=L,this.documentation=re}};e.$JK=Ge,e.$JK=Ge=qe([P],Ge);let xe=class{constructor(L,re){this.label=L,this.documentation=re,this.parameters=[]}};e.$KK=xe,e.$KK=xe=qe([P],xe);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$LK=Ye,e.$LK=Ye=qe([P],Ye);var _e;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$MK=tt,e.$MK=tt=qe([P],tt);let ze=class{constructor(L,re,ke){this.position=L,this.label=re,this.kind=ke}};e.$NK=ze,e.$NK=ze=qe([P],ze);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let be=class{constructor(L,re){this.label=L,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$OK=be,e.$OK=be=qe([P],be);let Be=class{constructor(L=[],re=!1){this.items=L,this.isIncomplete=re}};e.$PK=Be,e.$PK=Be=qe([P],Be);let Oe=class{constructor(L,re,ke){this.insertText=L,this.range=re,this.command=ke}};e.$QK=Oe,e.$QK=Oe=qe([P],Oe);let Xe=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$RK=Xe,e.$RK=Xe=qe([P],Xe);var nt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ft;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function wt(U,L){return`${k.$6l.toKey(U)}.${L}`}e.$SK=wt;var Pt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Zt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var Gt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var pt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var jt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(U){function L(re){switch(re){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(U){function L(re){switch(re){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(L,re){if(re&&!f.URI.isUri(re))throw(0,M.$7)("target");if(!N.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.target=re}};e.$TK=At,e.$TK=At=qe([P],At);let Rt=class{constructor(L,re,ke,He){this.red=L,this.green=re,this.blue=ke,this.alpha=He}};e.$UK=Rt,e.$UK=Rt=qe([P],Rt);let Ot=class{constructor(L,re){if(re&&!(re instanceof Rt))throw(0,M.$7)("color");if(!N.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.color=re}};e.$VK=Ot,e.$VK=Ot=qe([P],Ot);let Wt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$7)("label");this.label=L}};e.$WK=Wt,e.$WK=Wt=qe([P],Wt);var Jt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Vt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var Kt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Kt||(e.TerminalExitReason=Kt={}));class Mt{constructor(L,re,ke){if(this.startIndex=L,this.length=re,this.tooltip=ke,typeof L!="number"||L<0)throw(0,M.$7)("startIndex");if(typeof re!="number"||re<1)throw(0,M.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$7)("tooltip")}}e.$XK=Mt;class ut{constructor(L){this.uri=L}}e.$YK=ut;class dt{constructor(L){this.terminalCommand=L}}e.$ZK=dt;var Lt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Lt||(e.TerminalLocation=Lt={}));class qt{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$7)("options")}}e.$1K=qt;var kt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var at;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(L){switch(L){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(L,re){if(this.label=re,typeof L!="string"||typeof re!="string")throw(0,M.$7)("name");this.c=L}get id(){return this.c}};e.$2K=vt,e.$2K=vt=d=qe([P],vt);function Ht(U){let L="";for(let re=0;re<U.length;re++)L+=U[re].replace(/,/g,",,")+",";return L}let Ct=class{constructor(L,re,ke){if(typeof L!="string")throw(0,M.$7)("process");this.e=[],this.c=L,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=ke):this.f=re)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const re of this.e)L.push(re);return Ht(L)}};e.$3K=Ct,e.$3K=Ct=qe([P],Ct);let We=class{constructor(L,re,ke){if(this.f=[],Array.isArray(re)){if(!L)throw(0,M.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L,this.f=re,this.g=ke}else{if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L,this.g=re}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)L.push(typeof re=="string"?re:re.value);return Ht(L)}};e.$4K=We,e.$4K=We=qe([P],We);var Ce;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Fe;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Fe||(e.TaskScope=Fe={}));class me{constructor(L){this.c=L}computeId(){return"customExecution"+(0,R.$eg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$5K=me;let H=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,re,ke,He,Ze,ot){this.j=!1,this.k=this.definition=L;let ht;typeof re=="string"?(this.m=this.name=re,this.t=this.source=ke,this.execution=He,ht=Ze,this.j=!0):re===Fe.Global||re===Fe.Workspace?(this.target=re,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,ht=ot):(this.target=re,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof me?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$7)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$7)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const re=this.k.type;(I.g===re||I.e===re||I.f===re||I.c===re)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$7)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$6K=H,e.$6K=H=I=qe([P],H);var Me;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var je;(function(U){function L(re){const ke=re;return(0,D.$Cf)(ke.value)?ke.tooltip&&!(0,D.$yf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}U.isViewBadge=L})(je||(e.ViewBadge=je={}));let Je=S=class{static isTreeItem(L,re){const ke=L;if(ke.checkboxState!==void 0){const He=(0,D.$Cf)(ke.checkboxState)?ke.checkboxState:(0,D.$Af)(ke.checkboxState)&&(0,D.$Cf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ze=!(0,D.$Cf)(ke.checkboxState)&&(0,D.$Af)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ze!==void 0&&!(0,D.$yf)(Ze))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(L instanceof S)return!0;if(ke.label!==void 0&&!(0,D.$yf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$yf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$yf)(ke.iconPath)&&!f.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$yf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$yf)(He.light)&&!f.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!f.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$yf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!f.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$yf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ke.None&&ke.collapsibleState>Ke.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$yf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(L,re=Ke.None){this.collapsibleState=re,f.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$7K=Je,e.$7K=Je=S=qe([P],Je);var Ke;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Ke||(e.TreeItemCollapsibleState=Ke={}));var et;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$8K=bt,e.$8K=bt=qe([P],bt);class zt extends bt{}e.$9K=zt;class Dt extends zt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$0K=Dt;class lt{constructor(L,re,ke,He){this.name=L,this.uri=re,this._itemId=ke,this.c=He}data(){return this.c()}}e.$$K=lt;let gt=class{#e=new Map;constructor(L){for(const[re,ke]of L??[]){const He=this.#e.get(this.#t(re));He?He.push(ke):this.#e.set(this.#t(re),[ke])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,re){this.#e.set(this.#t(L),[re])}forEach(L,re){for(const[ke,He]of this.#e)for(const Ze of He)L.call(re,Ze,ke,this)}*[Symbol.iterator](){for(const[L,re]of this.#e)for(const ke of re)yield[L,ke]}#t(L){return L.toLowerCase()}};e.$_K=gt,e.$_K=gt=qe([P],gt);let yt=class{constructor(L){this.insertText=L}};e.$aL=yt,e.$aL=yt=qe([P],yt);let mi=class{constructor(L,re){this.label=re,this.insertText=L}};e.$bL=mi,e.$bL=mi=qe([P],mi);let St=class{constructor(L,re){this.id=L,this.color=re}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$cL=St,e.$cL=St=qe([P],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(L){this.id=L}};e.$dL=Si,e.$dL=Si=qe([P],Si);var ui;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(L){this.c=L,this.e=f.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,re){if(typeof L!="string"&&(!L||!f.URI.isUri(L)&&!f.URI.isUri(L.uri)))throw(0,M.$7)("base");if(typeof re!="string")throw(0,M.$7)("pattern");typeof L=="string"?this.baseUri=f.URI.file(L):f.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eL=$i,e.$eL=$i=qe([P],$i);const It=new WeakMap;function fn(U,L){It.set(U,L)}e.$fL=fn;let ri=class{constructor(L,re,ke,He){this.enabled=typeof L=="boolean"?L:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$gL=ri,e.$gL=ri=qe([P],ri);let Et=class extends ri{constructor(L,re,ke,He,Ze){if(super(re,ke,He,Ze),L===null)throw(0,M.$7)("location");this.location=L}};e.$hL=Et,e.$hL=Et=qe([P],Et);let pi=class extends ri{constructor(L,re,ke,He,Ze){super(re,ke,He,Ze),this.functionName=L}};e.$iL=pi,e.$iL=pi=qe([P],pi);let vi=class extends ri{constructor(L,re,ke,He,Ze,ot,ht){if(super(He,Ze,ot,ht),!re)throw(0,M.$7)("dataId");this.label=L,this.dataId=re,this.canPersist=ke}};e.$jL=vi,e.$jL=vi=qe([P],vi);let si=class{constructor(L,re,ke){this.command=L,this.args=re||[],this.options=ke}};e.$kL=si,e.$kL=si=qe([P],si);let Ii=class{constructor(L,re){this.port=L,this.host=re}};e.$lL=Ii,e.$lL=Ii=qe([P],Ii);let Ci=class{constructor(L){this.path=L}};e.$mL=Ci,e.$mL=Ci=qe([P],Ci);let Ft=class{constructor(L){this.implementation=L}};e.$nL=Ft,e.$nL=Ft=qe([P],Ft);let bi=class{constructor(L,re,ke){this.session=L,this.threadId=re,this.frameId=ke}};e.$oL=bi,e.$oL=bi=qe([P],bi);let Pi=class{constructor(L,re){this.session=L,this.threadId=re}};e.$pL=Pi,e.$pL=Pi=qe([P],Pi);let oi=class{constructor(L,re){this.range=L,this.expression=re}};e.$qL=oi,e.$qL=oi=qe([P],oi);var li;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ct=class{constructor(L,re){this.range=L,this.text=re}};e.$rL=ct,e.$rL=ct=qe([P],ct);let Ai=class{constructor(L,re,ke=!0){this.range=L,this.variableName=re,this.caseSensitiveLookup=ke}};e.$sL=Ai,e.$sL=Ai=qe([P],Ai);let Yt=class{constructor(L,re){this.range=L,this.expression=re}};e.$tL=Yt,e.$tL=Yt=qe([P],Yt);let ii=class{constructor(L,re){this.frameId=L,this.stoppedLocation=re}};e.$uL=ii,e.$uL=ii=qe([P],ii);var Ri;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=u=class extends Error{static FileExists(L){return new u(L,a.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,a.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,a.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,a.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,re=a.FileSystemProviderErrorCode.Unknown,ke){super(f.URI.isUri(L)?L.toString(!0):L),this.code=ke?.name??"Unknown",(0,a.$nk)(this,re),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$vL=Mi,e.$vL=Mi=u=qe([P],Mi);let Fi=class{constructor(L,re,ke){this.start=L,this.end=re,this.kind=ke}};e.$wL=Fi,e.$wL=Fi=qe([P],Fi);var Xi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ti;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var Zi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Li;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var ai;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(L,re=[]){this.tokenTypes=L,this.tokenModifiers=re}}e.$xL=gn;function Ni(U){return typeof U>"u"||(0,D.$zf)(U)}class hi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let re=0,ke=L.tokenTypes.length;re<ke;re++)this.j.set(L.tokenTypes[re],re);for(let re=0,ke=L.tokenModifiers.length;re<ke;re++)this.k.set(L.tokenModifiers[re],re)}}push(L,re,ke,He,Ze){if(typeof L=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(L,re,ke,He,Ze);if(N.isRange(L)&&typeof re=="string"&&Ni(ke))return this.m(L,re,ke);throw(0,M.$7)()}m(L,re,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ze=L.start.character,ot=L.end.character-L.start.character,ht=this.j.get(re);let Ut=0;if(ke)for(const Xt of ke){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(He,Ze,ot,ht,Ut)}n(L,re,ke,He,Ze){if(this.f&&(L<this.c||L===this.c&&re<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let ot=L,ht=re;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=L,this.e=re}static o(L){const re=[],ke=L.length/5|0;for(let ht=0;ht<ke;ht++)re[ht]=ht;re.sort((ht,Ut)=>{const Xt=L[5*ht],ei=L[5*Ut];if(Xt===ei){const ti=L[5*ht+1],ni=L[5*Ut+1];return ti-ni}return Xt-ei});const He=new Uint32Array(L.length);let Ze=0,ot=0;for(let ht=0;ht<ke;ht++){const Ut=5*re[ht],Xt=L[Ut+0],ei=L[Ut+1],ti=L[Ut+2],ni=L[Ut+3],Ji=L[Ut+4],Cn=Xt-Ze,Tn=Cn===0?ei-ot:ei,Qi=5*ht;He[Qi+0]=Cn,He[Qi+1]=Tn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ze=Xt,ot=ei}return He}build(L){return this.f?new Oi(new Uint32Array(this.g),L):new Oi(hi.o(this.g),L)}}e.$yL=hi;class Oi{constructor(L,re){this.resultId=re,this.data=L}}e.$zL=Oi;class mn{constructor(L,re,ke){this.start=L,this.deleteCount=re,this.data=ke}}e.$AL=mn;class di{constructor(L,re){this.resultId=re,this.edits=L}}e.$BL=di;var Yi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$CL=zi,e.$CL=zi=qe([P],zi);var xi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(L){if(typeof L.badge=="string"){let re=(0,l.$_e)(L.badge,0);if(re<L.badge.length&&(re+=(0,l.$_e)(L.badge,re)),L.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!St.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,re,ke){this.badge=L,this.tooltip=re,this.color=ke}}e.$DL=$n;let Ui=class{constructor(L){this.kind=L}};e.$EL=Ui,e.$EL=Ui=qe([P],Ui);var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,re){if(L<0)throw(0,M.$7)("start must be positive");if(re<0)throw(0,M.$7)("end must be positive");L<=re?(this.c=L,this.e=re):(this.c=re,this.e=L)}with(L){let re=this.c,ke=this.e;return L.start!==void 0&&(re=L.start),L.end!==void 0&&(ke=L.end),re===this.c&&ke===this.e?this:new xt(re,ke)}}e.$FL=xt;class wi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(re=>wi.isNotebookCellData(re))}static isNotebookCellData(L){return!0}constructor(L,re,ke,He,Ze,ot,ht){this.kind=L,this.value=re,this.languageId=ke,this.mime=He,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=ht,wi.validate(this)}}e.$GL=wi;class pn{constructor(L){this.cells=L}}e.$HL=pn;class Qt{static isNotebookCellOutputItem(L){return L instanceof Qt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const re={name:L.name,message:L.message,stack:L.stack};return Qt.json(re,"application/vnd.code.notebook.error")}static stdout(L){return Qt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Qt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,re="application/octet-stream"){return new Qt(L,re)}static#e=new TextEncoder;static text(L,re=A.$Pr.text){const ke=Qt.#e.encode(String(L));return new Qt(ke,re)}static json(L,re="text/x-json"){const ke=JSON.stringify(L,void 0,"	");return Qt.text(ke,re)}constructor(L,re){this.data=L,this.mime=re;const ke=(0,A.$Tr)(re,!0);if(!ke)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$IL=Qt;class yi{static isNotebookCellOutput(L){return L instanceof yi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,re=!1){const ke=new Set,He=new Set;for(let Ze=0;Ze<L.length;Ze++){const ot=L[Ze],ht=(0,A.$Tr)(ot.mime);if(!ke.has(ht)||(0,$.$qI)(ht)){ke.add(ht);continue}He.add(Ze),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?L:L.filter((Ze,ot)=>!He.has(ot))}constructor(L,re,ke){this.items=yi.ensureUniqueMimeTypes(L,!0),typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=(0,R.$eg)(),this.metadata=re??ke)}}e.$JL=yi;var en;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(L,re){this.text=L,this.alignment=re}}e.$KL=rn;var Le;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Le||(e.NotebookControllerAffinity=Le={}));var _t;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(L,re=[]){this.uri=L,this.provides=(0,y.$3b)(re)}}e.$LL=sn;class mt{constructor(L){this.label=L}}e.$ML=mt;let ji=class{constructor(L,re){this.label=L,this.timestamp=re}};e.$NL=ji,e.$NL=ji=qe([P],ji);var on;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class Di{constructor(L,re){this.ranges=L,this.wordPattern=re}}e.$OL=Di;class vn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$PL=vn;var cn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let ki=class{constructor(L=void 0,re=void 0,ke=void 0,He=!1){this.include=L,this.exclude=re,this.profile=ke,this.continuous=He}};e.$QL=ki,e.$QL=ki=qe([P],ki);let Wi=m=class{static diff(L,re,ke){const He=new m(L);return He.expectedOutput=re,He.actualOutput=ke,He}constructor(L){this.message=L}};e.$RL=Wi,e.$RL=Wi=m=qe([P],Wi);let Vi=class{constructor(L){this.id=L}};e.$SL=Vi,e.$SL=Vi=qe([P],Vi);let ci=class{constructor(L,re){this.covered=L,this.total=re}};e.$TL=ci,e.$TL=ci=qe([P],ci);let Ki=h=class{static fromDetails(L,re){const ke=new ci(0,0),He=new ci(0,0),Ze=new ci(0,0);for(const ht of re)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ht.executionCount>0?1:0;const ot=new h(L,ke,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=re,ot}constructor(L,re,ke,He){this.uri=L,this.statementCoverage=re,this.branchCoverage=ke,this.functionCoverage=He}};e.$UL=Ki,e.$UL=Ki=h=qe([P],Ki);let qi=class{constructor(L,re,ke=[]){this.executionCount=L,this.location=re,this.branches=ke}};e.$VL=qi,e.$VL=qi=qe([P],qi);let Hi=class{constructor(L,re){this.executionCount=L,this.location=re}};e.$WL=Hi,e.$WL=Hi=qe([P],Hi);let Gi=class{constructor(L,re){this.executionCount=L,this.location=re}};e.$XL=Gi,e.$XL=Gi=qe([P],Gi);var ln;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class te{constructor(L,re,ke,He,Ze,ot){this.kind=L,this.name=re,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$YL=te;class de{constructor(L){this.uri=L}}e.$ZL=de;class Te{constructor(L,re){this.original=L,this.modified=re}}e.$1L=Te;class rt{constructor(L,re,ke,He){this.base=L,this.input1=re,this.input2=ke,this.result=He}}e.$2L=rt;class $t{constructor(L,re){this.uri=L,this.viewType=re}}e.$3L=$t;class Tt{constructor(L){this.viewType=L}}e.$4L=Tt;class Pn{constructor(L,re){this.uri=L,this.notebookType=re}}e.$5L=Pn;class An{constructor(L,re,ke){this.original=L,this.modified=re,this.notebookType=ke}}e.$6L=An;class Rn{constructor(){}}e.$7L=Rn;class Mn{constructor(L,re){this.uri=L,this.inputBoxUri=re}}e.$8L=Mn;var bn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(L,re){this.role=L,this.content=re}}e.$9L=Fn;var kn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[100],Re([1,0,52,13,16,280,136,7,18]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=void 0;const f=new Map;function R($,g){g?f.set($,g):f.delete($)}e.$jM=R;function k($){return f.get($)}class a extends T.$Vu{constructor(g,t,i,c,p,E,v,n){super(t,i,c,p),this.c=g,this.m=E,this.q=v,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,D.$ub)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===M.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,y.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,y.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,p=t.end.line,E=[];E.push(this.f[c].substring(t.start.character));for(let v=c+1;v<p;v++)E.push(this.f[v]);return E.push(this.f[p].substring(0,t.end.character)),E.join(i)}t(g){let t;if(g instanceof l.$jK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new l.$jK(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof l.$kK))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new l.$kK(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof l.$jK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const p=this.f[t].length;i<0?(i=0,c=!0):i>p&&(i=p,c=!0)}return c?new l.$jK(t,i):g}y(g,t){const i=this.x(g);if(!t)t=k(this.m);else if((0,C.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$8r)(i.character+1,(0,A.$6r)(t),this.f[i.line],0);if(c)return new l.$kK(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$kM=a;class b{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$kK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$kK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$lM=b}),define(Ae[197],Re([1,0,7,17,5]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;let T=class{constructor(l){this.a=new y.$EL(y.ColorThemeKind.Dark),this.b=new C.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(l){let D;switch(l){case"light":D=y.ColorThemeKind.Light;break;case"hcDark":D=y.ColorThemeKind.HighContrast;break;case"hcLight":D=y.ColorThemeKind.HighContrastLight;break;default:D=y.ColorThemeKind.Dark}this.a=new y.$EL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Odc=T,e.$Odc=T=qe([Ve(0,M.$hM)],T)}),define(Ae[198],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$uI=(0,y.$Ph)("INotebookExecutionService")}),define(Ae[46],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(T){T.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,l,D=A.parent){if(A._isRoot)return new C([l]);const f=[A.id];for(let R=D;R&&R.id!==l;R=R.parent)f.push(R.id);return f.push(l),new C(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$_I=C}),define(Ae[57],Re([1,0,2,41,46]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$fJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eJ=e.$dJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$bJ=e.$aJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$aJ=[2,4,8,16,32,64];const D=S=>"runId"in S;e.$bJ=D;var f;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$ts.lift(u.range),uri:y.URI.revive(u.uri)})})(f||(e.IRichLocation=f={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var k;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&f.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&f.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const a=(S,u)=>`${u?"s":"e"}${S}`;e.$cJ=a;var b;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&f.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&f.deserialize(u.location)})})(b||(e.ITestOutputMessage=b={}));var $;(function(S){S.serialize=u=>u.type===0?k.serialize(u):b.serialize(u),S.deserialize=u=>u.type===0?k.deserialize(u):b.deserialize(u)})($||(e.ITestMessage=$={}));var g;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(S,u)=>S+t+u;e.$dJ=i;const c=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$eJ=c;var p;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?M.$ts.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(p||(e.ITestItem=p={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:p.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$_I.root(u.item.extId),expand:u.expand,item:p.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var n;(function(S){S.serialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.uri!==void 0&&(m.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(m.range=u.item.range?.toJSON()),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}},S.deserialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.range!==void 0&&(m.range=u.item.range?M.$ts.lift(u.item.range):null),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}}})(n||(e.ITestItemUpdate=n={}));const r=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$fJ=r;var s;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var d;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:n.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:n.serialize(u.item)}:u})(d||(e.TestsDiffOp=d={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const m=this.o();for(const h of u)switch(h.op){case 0:this.j(v.deserialize(h.item),m);break;case 1:this.k(n.deserialize(h.item),m);break;case 3:this.l(h.itemId,m);break;case 5:this.m(h.itemId);break;case 4:this.updatePendingRoots(h.amount);break;case 6:this.c.set(h.tag.id,h.tag);break;case 7:this.c.delete(h.id);break}m.complete?.()}j(u,m){const h=C.$_I.parentId(u.item.extId)?.toString();let P;if(!h)P=this.p(u),this.f.add(P),this.d.set(u.item.extId,P);else if(this.d.has(h)){const B=this.d.get(h);B.children.add(u.item.extId),P=this.p(u,B),this.d.set(u.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return m.add?.(P),u.expand===2&&this.g++,P}k(u,m){const h=this.d.get(u.extId);if(h)return u.expand!==void 0&&(h.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.$fJ)(h,u),m.update?.(h),h}l(u,m){const h=this.d.get(u);if(!h)return;const P=C.$_I.parentId(h.item.extId)?.toString();P?this.d.get(P).children.delete(h.item.extId):this.f.delete(h);const B=[[u]];for(;B.length;)for(const z of B.pop()){const j=this.d.get(z);j&&(B.push(j.children),this.d.delete(z),m.remove?.(j,j!==h),j.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.$gJ=I}),define(Ae[76],Re([1,0,12,5,6,52,57,46]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestItemEventOp=void 0;var D;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const f=(c,p)=>c===p,k=Object.entries({range:(c,p)=>c===p?!0:!c||!p?!1:c.equalsRange(p),busy:f,label:f,description:f,error:f,sortText:f,tags:(c,p)=>!(c.length!==p.length||c.some(E=>!p.includes(E)))}),a=(c,p)=>{let E;for(const[v,n]of k)n(c[v],p[v])||(E?E[v]=p[v]:E={[v]:p[v]});return E};class b extends C.$Sc{get root(){return this.s.root}constructor(p){super(),this.s=p,this.f=this.B(new y.$6g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(p){this.h=p;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const p=this.m;return this.m=[],p}pushDiff(p){switch(p.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===p.uri){E.docv=p.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===p.item.extId){(0,A.$fJ)(E.item,p.item);return}if(E.op===0&&E.item.item.extId===p.item.extId){(0,A.$fJ)(E.item,p.item);return}}break}}this.m.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,E){const v=this.tree.get(p);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const n=this.L(v);return n.isOpen()?this.J(v,E-1):n.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const p of this.tree.values())this.s.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(p,E){switch(E.op){case 3:this.N(l.$_I.joinToString(p.fullId,E.id));break;case 0:this.y(E.item,p);break;case 5:for(const v of E.ops)this.u(p,v);break;case 1:this.z(E.new,E.old,p.fullId.toString());break;case 2:this.I(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:E.update}});break;case 6:this.w(p.actual.uri);break;default:(0,T.$4c)(E)}}w(p){p&&this.pushDiff({op:2,uri:p,docv:this.s.getDocumentVersion(p)})}y(p,E){const v=l.$_I.fromExtHostTestItem(p,this.root.id,E?.actual),n=this.s.getApiFor(p);n.parent&&n.parent!==E?.actual&&this.s.getChildren(n.parent).delete(p.id);let r=this.tree.get(v.toString());if(!r){r={fullId:v,actual:p,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},p.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(p,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(p)}}),this.H(p,r,E);return}if(r.actual===p){this.G(p,r,E);return}if(r.actual.uri?.toString()!==p.uri?.toString())return this.N(v.toString()),this.y(p,E);const s=this.s.getChildren(r.actual),o=r.actual,w=a(this.s.toITestItem(o),this.s.toITestItem(p));this.s.getApiFor(o).listener=void 0,r.actual=p,r.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(p.tags,o.tags,v.toString()),delete w.tags),this.u(r,{op:4,update:w})),this.H(p,r,E);for(const[d,I]of s)this.s.getChildren(p).get(I.id)||this.N(l.$_I.joinToString(v,I.id));this.w(r.actual.uri)}z(p,E,v){const n=new Set(E.map(r=>r.id));for(const r of p)n.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:v,item:{tags:p.map(r=>(0,A.$dJ)(this.s.controllerId,r.id))}}}),n.forEach(this.D,this)}C(p){const E=this.j.get(p.id);E?E.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$dJ)(this.s.controllerId,p.id)}}))}D(p){const E=this.j.get(p);E&&!--E.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,A.$dJ)(this.s.controllerId,p)}))}F(p,E){this.s.getApiFor(p).parent=E&&E.actual!==this.root?E.actual:void 0}G(p,E,v){this.F(p,v);const n=this.s.getApiFor(p);n.parent=v?.actual,n.listener=r=>this.u(E,r),this.I(E)}H(p,E,v){this.G(p,E,v);for(const[n,r]of this.s.getChildren(p))this.y(r,E)}I(p){let E;this.h?p.resolveBarrier?E=p.resolveBarrier.isOpen()?3:2:E=p.actual.canResolveChildren?1:0:E=0,E!==p.expand&&(p.expand=E,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:E}}),E===1&&p.expandLevels!==void 0&&this.L(p))}J(p,E){if(E<0)return;const v=[];for(const[n,r]of this.s.getChildren(p.actual)){const s=this.expand(l.$_I.joinToString(p.fullId,r.id),E);(0,y.$Gg)(s)&&v.push(s)}if(v.length)return Promise.all(v).then(()=>{})}L(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const r=new y.$Sg;return r.open(),r}p.expand=2,this.M(p);const E=p.resolveBarrier=new y.$Sg,v=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h(p.actual===this.root?void 0:p.actual)}catch(r){v(r)}return(0,y.$Gg)(n)?n.catch(v).then(()=>{E.open(),this.I(p)}):(E.open(),this.I(p)),p.resolveBarrier}M(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}N(p){const E=this.tree.get(p);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const v=[E];for(;v.length;){const n=v.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.D(r.id);this.tree.delete(n.fullId.toString());for(const[r,s]of this.s.getChildren(n.actual))v.push(this.tree.get(l.$_I.joinToString(n.fullId,s.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.$0L=b;class $ extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.$$L=$;class g extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$_L=g;class t extends Error{constructor(p,E,v){super(`TestItem with ID "${p}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$aM=t;const i=(c,p,E)=>{let v=new Map;return{get size(){return v.size},forEach(n,r){for(const s of v.values())n.call(r,s,this)},[Symbol.iterator](){return v.entries()},replace(n){const r=new Map,s=new Set(v.keys()),o={op:5,ops:[]};for(const w of n){if(!(w instanceof E))throw new g(w.id);const d=p(w).controllerId;if(d!==c.controllerId)throw new t(w.id,d,c.controllerId);if(r.has(w.id))throw new $(w.id);r.set(w.id,w),s.delete(w.id),o.ops.push({op:0,item:w})}for(const w of s.keys())o.ops.push({op:3,id:w});c.listener?.(o),v=r},add(n){if(!(n instanceof E))throw new g(n.id);v.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){v.delete(n)&&c.listener?.({op:3,id:n})},get(n){return v.get(n)},toJSON(){return Array.from(v.values())}}};e.$bM=i}),define(Ae[101],Re([1,0,76]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;const M=new WeakMap,C=(A,l)=>{const D={controllerId:l};return M.set(A,D),D};e.$cM=C;const T=A=>{const l=M.get(A);if(!l)throw new y.$_L(A?.id||"<unknown>");return l};e.$dM=T}),define(Ae[77],Re([1,0,13,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ob=e.$9ob=e.$8ob=e.$7ob=e.$6ob=void 0,e.$6ob="vscode-cdn.net",e.$7ob=`vscode-resource.${e.$6ob}`,e.$8ob=`'self' https://*.${e.$6ob}`;function C(l,D){return l.scheme===y.Schemas.http||l.scheme===y.Schemas.https?l:(D&&D.authority&&D.isRemote&&l.scheme===y.Schemas.file&&(l=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:D.authority,path:l.path})),M.URI.from({scheme:y.Schemas.https,authority:`${l.scheme}+${T(l.authority)}.${e.$7ob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$9ob=C;function T(l){return l.replace(/./g,D=>{const f=D.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?D:"-"+f.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(D,f)=>String.fromCharCode(parseInt(f,16)))}e.$0ob=A}),define(Ae[199],Re([1,0,5,6,77]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class T{constructor(l,D,f){this.d=l,this.e=D,this.f=f,this.a=0,this.b=new M.$Rc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,D,f,R,k){let a;for(const p of this.e.getVisibleTextEditors(!0))if(p.value===l){a=p;break}if(!a)throw new Error("not a visible editor");const b=this,$=this.a++,g=new y.$Nd,t=new y.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(p){return(0,C.$9ob)(p,b.f)}get cspSource(){return C.$8ob}set options(p){this.b=p,b.d.$setOptions($,p)}get options(){return this.b}set html(p){this.a=p,b.d.$setHtml($,p)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(p){return b.d.$postMessage($,p)}},c=new class{constructor(){this.editor=l,this.line=D,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has($)&&(b.c.delete($),b.d.$disposeEditorInset($),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset($,a.id,a.value.document.uri,D+1,f,R||{},k.identifier,k.extensionLocation),this.c.set($,{editor:l,inset:c,onDidReceiveMessage:g}),c}$onDidDispose(l){const D=this.c.get(l);D&&D.inset.dispose()}$onDidReceiveMessage(l,D){this.c.get(l)?.onDidReceiveMessage.fire(D)}}e.$mdc=T}),define(Ae[200],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.VariableKind=e.$6M=void 0,e.$6M=(0,y.$Ph)("configurationResolverService");var M;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$7M=C}),define(Ae[201],Re([1,0,20,73,15,24,22,90,165,200,16]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,$,g,t){this.h=new Map,this.a=b,this.b=$,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$j){const $=Object.create(null);return Object.keys(b).forEach(g=>{$[g.toLowerCase()]=b[g]}),$}return b}resolveWithEnvironment(b,$,g){return this.l({env:this.i(b),userHome:void 0},$?$.uri:void 0,g)}async resolveAsync(b,$){const g={env:await this.c,userHome:await this.g};return this.l(g,b?b.uri:void 0,$)}async j(b,$,g,t){const i=T.$7m($);A.$j&&i.windows?Object.keys(i.windows).forEach(p=>i[p]=i.windows[p]):A.$k&&i.osx?Object.keys(i.osx).forEach(p=>i[p]=i.osx[p]):A.$l&&i.linux&&Object.keys(i.linux).forEach(p=>i[p]=i.linux[p]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,b?b.uri:void 0,i,g,t)}async resolveAnyAsync(b,$,g){return this.j(b,$,g)}async resolveAnyMap(b,$,g){const t=new Map;return{newConfig:await this.j(b,$,g,t),resolvedVariables:t}}resolveWithInteractionReplace(b,$,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,$,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,$){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,$)}async l(b,$,g,t,i){if(C.$yf(g))return this.m(b,$,g,t,i);if(Array.isArray(g))return Promise.all(g.map(c=>this.l(b,$,c,t,i)));if(C.$Af(g)){const c=Object.create(null),p=await Promise.all(Object.keys(g).map(async E=>[await this.m(b,$,E,t,i),await this.l(b,$,g[E],t,i)]));for(const[E,v]of p)c[E]=v;return c}return g}m(b,$,g,t,i){return(0,R.$Te)(g,k.VARIABLE_REGEXP,async(c,p)=>{if(p.includes(k.VARIABLE_LHS))return c;let E=await this.o(b,c,p,$,t);return i?.set(p,E),E!==c&&C.$yf(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(b,$,E,t,i)),E})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,$,g,t,i){let c;const p=g.split(":");p.length>1&&(g=p[0],c=p[1]);const E=r=>{const s=this.a.getFilePath();if(s)return(0,l.$sv)(s);throw new f.$7M(r,(0,D.localize)(0,null,$))},v=r=>{const s=E(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$sv)(o)}throw new f.$7M(r,(0,D.localize)(1,null,$,y.$nc(s)))},n=r=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new f.$7M(r,(0,D.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$7M(r,(0,D.localize)(3,null,$)):new f.$7M(r,(0,D.localize)(4,null,$))};switch(g){case"env":if(c){if(b.env){const r=b.env[A.$j?c.toLowerCase():c];if(C.$yf(r))return r}return""}throw new f.$7M(f.VariableKind.Env,(0,D.localize)(5,null,$));case"config":if(c){const r=this.a.getConfigurationValue(t,c);if(C.$Hf(r))throw new f.$7M(f.VariableKind.Config,(0,D.localize)(6,null,$,c));if(C.$Af(r))throw new f.$7M(f.VariableKind.Config,(0,D.localize)(7,null,$,c));return r}throw new f.$7M(f.VariableKind.Config,(0,D.localize)(8,null,$));case"command":return this.p(f.VariableKind.Command,$,c,i,"command");case"input":return this.p(f.VariableKind.Input,$,c,i,"input");case"extensionInstallFolder":if(c){const r=await this.a.getExtension(c);if(!r)throw new f.$7M(f.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,$,c));return this.n(r.extensionLocation)}throw new f.$7M(f.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,$));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,l.$sv)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$sv)(this.n(n(f.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$sv)(y.$nc(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new f.$7M(f.VariableKind.UserHome,(0,D.localize)(11,null,$))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new f.$7M(f.VariableKind.LineNumber,(0,D.localize)(12,null,$))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new f.$7M(f.VariableKind.SelectedText,(0,D.localize)(13,null,$))}case"file":return E(f.VariableKind.File);case"fileWorkspaceFolder":return v(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?y.$lc(this.n(n(f.VariableKind.RelativeFile)),E(f.VariableKind.RelativeFile)):E(f.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.$mc(E(f.VariableKind.RelativeFileDirname));if(t||c){const s=y.$lc(this.n(n(f.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return y.$mc(E(f.VariableKind.FileDirname));case"fileExtname":return y.$oc(E(f.VariableKind.FileExtname));case"fileBasename":return y.$nc(E(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.$nc(E(f.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.$oc(r).length)}case"fileDirnameBasename":return y.$nc(y.$mc(E(f.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||$}case"execInstallFolder":{const r=this.a.getAppRoot();return r||$}case"pathSeparator":return y.sep;default:try{const r=c?`${g}:${c}`:g;return this.p(f.VariableKind.Unknown,$,r,i,void 0)}catch{return $}}}}p(b,$,g,t,i){if(g&&t){const c=i===void 0?t[g]:t[i+":"+g];if(typeof c=="string")return c;throw new f.$7M(b,(0,D.localize)(14,null,$))}return $}}e.$iN=k}),define(Ae[102],Re([1,0,4,99]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=e.$gC=e.OpenEditorContext=e.GroupsOrder=e.$fC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$eC=void 0,e.$eC=(0,y.$Ph)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var D;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function f($){const g=$;return(0,M.$7D)(g?.editor)&&(0,M.$7D)(g?.replacement)}e.$fC=f;var R;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a($){const g=$;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$gC=a;function b($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$hC=b}),define(Ae[202],Re([1,0,4,102]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=e.$kC=e.$jC=e.$iC=void 0,e.$iC=(0,y.$Ph)("editorService"),e.$jC=-1,e.$kC=-2;function C(T){const A=T;return typeof T=="number"||(0,M.$gC)(A)}e.$lC=C}),define(Ae[8],Re([1,0,18,26,122,203,50,28,116,68,67,24,15,2,41,78,94,101,99,75,46,57,202,7]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$gM=e.$fM=e.MarkdownString=e.$eM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ce){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:je,positionLineNumber:Je,positionColumn:Ke}=H,et=new r.$jK(Me-1,je-1),bt=new r.$jK(Je-1,Ke-1);return new r.$lK(et,bt)}Ce.to=Fe;function me(H){const{anchor:Me,active:je}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=me})(s||(e.Selection=s={}));var o;(function(Ce){function Fe(H){if(!H)return;const{start:Me,end:je}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Fe;function me(H){if(!H)return;const{startLineNumber:Me,startColumn:je,endLineNumber:Je,endColumn:Ke}=H;return new r.$kK(Me-1,je-1,Je-1,Ke-1)}Ce.to=me})(o||(e.Range=o={}));var w;(function(Ce){function Fe(me){switch(me){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ce.to=Fe})(w||(e.TokenType=w={}));var d;(function(Ce){function Fe(H){return new r.$jK(H.lineNumber-1,H.column-1)}Ce.to=Fe;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=me})(d||(e.Position=d={}));var I;(function(Ce){function Fe(Me,je,Je){return(0,y.$Hb)((0,y.$3b)(Me).map(Ke=>me(Ke,je,Je)))}Ce.from=Fe;function me(Me,je,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,je),pattern:st.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function H(Me,je){return je&&typeof Me=="string"?je.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Fe(H){switch(H){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ce.from=Fe;function me(H){switch(H){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Fe(H){let Me;return H.code&&((0,a.$yf)(H.code)||(0,a.$Cf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Me,severity:h.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(m.from),tags:Array.isArray(H.tags)?(0,y.$Hb)(H.tags.map(S.from)):void 0}}Ce.from=Fe;function me(H){const Me=new r.$wK(o.to(H),H.message,h.to(H.severity));return Me.source=H.source,Me.code=(0,a.$yf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(m.to),Me.tags=H.tags&&(0,y.$Hb)(H.tags.map(S.to)),Me}Ce.to=me})(u||(e.Diagnostic=u={}));var m;(function(Ce){function Fe(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Fe;function me(H){return new r.$vK(new r.$uK(H.resource,o.to(H)),H.message)}Ce.to=me})(m||(e.DiagnosticRelatedInformation=m={}));var h;(function(Ce){function Fe(H){switch(H){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Fe;function me(H){switch(H){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ce.to=me})(h||(e.DiagnosticSeverity=h={}));var P;(function(Ce){function Fe(H){return typeof H=="number"&&H>=r.ViewColumn.One?H-1:H===r.ViewColumn.Beside?n.$kC:n.$jC}Ce.from=Fe;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(P||(e.ViewColumn=P={}));function B(Ce){return typeof Ce.range<"u"}function z(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$eM=z;var j;(function(Ce){function Fe(Ke){return Ke.map(Ce.from)}Ce.fromMany=Fe;function me(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function H(Ke){let et;if(me(Ke)){const{language:lt,value:gt}=Ke;et={value:"```"+lt+`
`+gt+"\n```\n"}}else r.$IK.isMarkdownString(Ke)?et={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?et={value:Ke}:et={value:""};const bt=Object.create(null);et.uris=bt;const zt=lt=>{try{let gt=b.URI.parse(lt,!0);gt=gt.with({query:Me(gt.query,bt)}),bt[lt]=gt}catch{}return""},Dt=new D.marked.Renderer;return Dt.link=zt,Dt.image=lt=>typeof lt=="string"?zt(A.$0j(lt).href):"",(0,D.marked)(et.value,{renderer:Dt}),et}Ce.from=H;function Me(Ke,et){if(!Ke)return Ke;let bt;try{bt=(0,f.$lh)(Ke)}catch{}if(!bt)return Ke;let zt=!1;return bt=(0,k.$9m)(bt,Dt=>{if(b.URI.isUri(Dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[lt]=Dt,zt=!0,lt}else return}),zt?JSON.stringify(bt):Ke}function je(Ke){const et=new r.$IK(Ke.value,Ke.supportThemeIcons);return et.isTrusted=Ke.isTrusted,et.supportHtml=Ke.supportHtml,et.baseUri=Ke.baseUri?b.URI.from(Ke.baseUri):void 0,et}Ce.to=je;function Je(Ke){if(Ke)return typeof Ke=="string"?Ke:Ce.from(Ke)}Ce.fromStrict=Je})(j||(e.MarkdownString=j={}));function V(Ce){return z(Ce)?Ce.map(Fe=>({range:o.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?j.fromMany(Fe.hoverMessage):Fe.hoverMessage?j.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ce.map(Fe=>({range:o.from(Fe)}))}e.$fM=V;function N(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$gM=N;var O;(function(Ce){function Fe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?N(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Fe})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var se;(function(Ce){function Fe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?N(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?O.from(me.before):void 0,after:me.after?O.from(me.after):void 0}}Ce.from=Fe})(se||(e.ThemableDecorationRenderOptions=se={}));var X;(function(Ce){function Fe(me){if(typeof me>"u")return me;switch(me){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Fe})(X||(e.DecorationRangeBehavior=X={}));var Ee;(function(Ce){function Fe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?X.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?se.from(me.light):void 0,dark:me.dark?se.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?N(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?O.from(me.before):void 0,after:me.after?O.from(me.after):void 0}}Ce.from=Fe})(Ee||(e.DecorationRenderOptions=Ee={}));var Pe;(function(Ce){function Fe(H){return{text:H.newText,eol:H.newEol&&Ye.from(H.newEol),range:o.from(H.range)}}Ce.from=Fe;function me(H){const Me=new r.$pK(o.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Ye.to(H.eol),Me}Ce.to=me})(Pe||(e.TextEdit=Pe={}));var Se;(function(Ce){function Fe(H,Me){const je={edits:[]};if(H instanceof r.$sK){const Je=new l.$Bc;for(const Ke of H._allEntries())Ke._type===1&&b.URI.isUri(Ke.to)&&Ke.from===void 0&&Je.add(Ke.to);for(const Ke of H._allEntries())if(Ke._type===1){let et;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?et={type:"base64",value:(0,M.$ve)(M.$be.wrap(Ke.options.contents))}:et={type:"dataTransferItem",id:Ke.options.contents._itemId}),je.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:et},metadata:Ke.metadata})}else Ke._type===2?je.edits.push({resource:Ke.uri,textEdit:Pe.from(Ke.edit),versionId:Je.has(Ke.uri)?void 0:Me?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?je.edits.push({resource:Ke.uri,textEdit:{range:o.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Je.has(Ke.uri)?void 0:Me?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?je.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&je.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(ft.from)}})}return je}Ce.from=Fe;function me(H){const Me=new r.$sK,je=new l.$Ac;for(const Je of H.edits)if(Je.textEdit){const Ke=Je,et=b.URI.revive(Ke.resource),bt=o.to(Ke.textEdit.range),zt=Ke.textEdit.text,Dt=Ke.textEdit.insertAsSnippet;let lt;Dt?lt=r.$rK.replace(bt,new r.$tK(zt)):lt=r.$pK.replace(bt,zt);const gt=je.get(et);gt?gt.push(lt):je.set(et,[lt])}else Me.renameFile(b.URI.revive(Je.oldResource),b.URI.revive(Je.newResource),Je.options);for(const[Je,Ke]of je)Me.set(Je,Ke);return Me}Ce.to=me})(Se||(e.WorkspaceEdit=Se={}));var fe;(function(Ce){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function me(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ce.from=me;function H(Me){for(const je in Fe)if(Fe[je]===Me)return Number(je);return r.SymbolKind.Property}Ce.to=H})(fe||(e.SymbolKind=fe={}));var ye;(function(Ce){function Fe(H){switch(H){case r.SymbolTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return r.SymbolTag.Deprecated}}Ce.to=me})(ye||(e.SymbolTag=ye={}));var ue;(function(Ce){function Fe(H){return{name:H.name,kind:fe.from(H.kind),tags:H.tags&&H.tags.map(ye.from),containerName:H.containerName,location:Z.from(H.location)}}Ce.from=Fe;function me(H){const Me=new r.$zK(H.name,fe.to(H.kind),H.containerName,Z.to(H.location));return Me.tags=H.tags&&H.tags.map(ye.to),Me}Ce.to=me})(ue||(e.WorkspaceSymbol=ue={}));var ae;(function(Ce){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:fe.from(H.kind),tags:H.tags?.map(ye.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ce.from=Fe;function me(H){const Me=new r.$AK(H.name,H.detail,fe.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,y.$Lb)(H.tags)&&(Me.tags=H.tags.map(ye.to)),H.children&&(Me.children=H.children.map(me)),Me}Ce.to=me})(ae||(e.DocumentSymbol=ae={}));var ve;(function(Ce){function Fe(H){const Me=new r.$EK(fe.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,name:H.name,detail:H.detail,kind:fe.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ye.from)}}Ce.from=me})(ve||(e.CallHierarchyItem=ve={}));var _;(function(Ce){function Fe(me){return new r.$FK(ve.to(me.from),me.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(_||(e.CallHierarchyIncomingCall=_={}));var W;(function(Ce){function Fe(me){return new r.$GK(ve.to(me.to),me.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(W||(e.CallHierarchyOutgoingCall=W={}));var Z;(function(Ce){function Fe(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Fe;function me(H){return new r.$uK(b.URI.revive(H.uri),o.to(H.range))}Ce.to=me})(Z||(e.location=Z={}));var ee;(function(Ce){function Fe(H){const Me=H,je=H;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:je.uri,range:o.from(Me.targetRange?Me.targetRange:je.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Ce.from=Fe;function me(H){return{targetUri:b.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=me})(ee||(e.DefinitionLink=ee={}));var pe;(function(Ce){function Fe(H){return{range:o.from(H.range),contents:j.fromMany(H.contents)}}Ce.from=Fe;function me(H){return new r.$xK(H.contents.map(j.to),o.to(H.range))}Ce.to=me})(pe||(e.Hover=pe={}));var $e;(function(Ce){function Fe(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Fe;function me(H){return new r.$qL(o.to(H.range),H.expression)}Ce.to=me})($e||(e.EvaluatableExpression=$e={}));var he;(function(Ce){function Fe(H){if(H instanceof r.$rL)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof r.$sL)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof r.$tL)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Fe;function me(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=me})(he||(e.InlineValue=he={}));var De;(function(Ce){function Fe(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Fe;function me(H){return new r.$uL(H.frameId,o.to(H.stoppedLocation))}Ce.to=me})(De||(e.InlineValueContext=De={}));var ne;(function(Ce){function Fe(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Fe;function me(H){return new r.$yK(o.to(H.range),H.kind)}Ce.to=me})(ne||(e.DocumentHighlight=ne={}));var le;(function(Ce){function Fe(me){switch(me){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ce.to=Fe})(le||(e.CompletionTriggerKind=le={}));var ie;(function(Ce){function Fe(me){return{triggerKind:le.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Fe})(ie||(e.CompletionContext=ie={}));var oe;(function(Ce){function Fe(H){switch(H){case r.CompletionItemTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return r.CompletionItemTag.Deprecated}}Ce.to=me})(oe||(e.CompletionItemTag=oe={}));var ge;(function(Ce){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function me(je){return Fe.get(je)??9}Ce.from=me;const H=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(je){return H.get(je)??r.CompletionItemKind.Property}Ce.to=Me})(ge||(e.CompletionItemKind=ge={}));var Ie;(function(Ce){function Fe(me,H){const Me=new r.$OK(me.label);return Me.insertText=me.insertText,Me.kind=ge.to(me.kind),Me.tags=me.tags?.map(oe.to),Me.detail=me.detail,Me.documentation=A.$5j(me.documentation)?j.to(me.documentation):me.documentation,Me.sortText=me.sortText,Me.filterText=me.filterText,Me.preselect=me.preselect,Me.commitCharacters=me.commitCharacters,$.$ts.isIRange(me.range)?Me.range=o.to(me.range):typeof me.range=="object"&&(Me.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Me.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Me.insertText=new r.$tK(me.insertText):(Me.insertText=me.insertText,Me.textEdit=Me.range instanceof r.$kK?new r.$pK(Me.range,Me.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Me.additionalTextEdits=me.additionalTextEdits.map(je=>Pe.to(je))),Me.command=H&&me.command?H.fromInternal(me.command):void 0,Me}Ce.to=Fe})(Ie||(e.CompletionItem=Ie={}));var F;(function(Ce){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:j.fromStrict(H.documentation)}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$5j(H.documentation)?j.to(H.documentation):H.documentation}}Ce.to=me})(F||(e.ParameterInformation=F={}));var K;(function(Ce){function Fe(H){return{label:H.label,documentation:j.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(F.from):[],activeParameter:H.activeParameter}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$5j(H.documentation)?j.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(F.to):[],activeParameter:H.activeParameter}}Ce.to=me})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Fe;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=me})(G||(e.SignatureHelp=G={}));var J;(function(Ce){function Fe(me,H){const Me=new r.$NK(d.to(H.position),typeof H.label=="string"?H.label:H.label.map(q.to.bind(void 0,me)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(Pe.to),Me.tooltip=A.$5j(H.tooltip)?j.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Fe})(J||(e.InlayHint=J={}));var q;(function(Ce){function Fe(me,H){const Me=new r.$MK(H.label);return Me.tooltip=A.$5j(H.tooltip)?j.to(H.tooltip):H.tooltip,g.Command.is(H.command)&&(Me.command=me.fromInternal(H.command)),H.location&&(Me.location=Z.to(H.location)),Me}Ce.to=Fe})(q||(e.InlayHintLabelPart=q={}));var x;(function(Ce){function Fe(H){return H}Ce.from=Fe;function me(H){return H}Ce.to=me})(x||(e.InlayHintKind=x={}));var ce;(function(Ce){function Fe(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Fe;function me(H){let Me;if(H.url)try{Me=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new r.$TK(o.to(H.range),Me)}Ce.to=me})(ce||(e.DocumentLink=ce={}));var Ne;(function(Ce){function Fe(H){const Me=new r.$WK(H.label);return H.textEdit&&(Me.textEdit=Pe.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(je=>Pe.to(je))),Me}Ce.to=Fe;function me(H){return{label:H.label,textEdit:H.textEdit?Pe.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>Pe.from(Me)):void 0}}Ce.from=me})(Ne||(e.ColorPresentation=Ne={}));var Ue;(function(Ce){function Fe(H){return new r.$UK(H[0],H[1],H[2],H[3])}Ce.to=Fe;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=me})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Fe(H){return{range:o.from(H.range)}}Ce.from=Fe;function me(H){return new r.$DK(o.to(H.range))}Ce.to=me})(Qe||(e.SelectionRange=Qe={}));var Ge;(function(Ce){function Fe(me){switch(me){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ce.to=Fe})(Ge||(e.TextDocumentSaveReason=Ge={}));var xe;(function(Ce){function Fe(H){switch(H){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Fe;function me(H){switch(H){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ce.to=me})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Ye;(function(Ce){function Fe(H){if(H===r.EndOfLine.CRLF)return 1;if(H===r.EndOfLine.LF)return 0}Ce.from=Fe;function me(H){if(H===1)return r.EndOfLine.CRLF;if(H===0)return r.EndOfLine.LF}Ce.to=me})(Ye||(e.EndOfLine=Ye={}));var _e;(function(Ce){function Fe(me){if(typeof me=="object")return me.viewId;switch(me){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Fe;function me(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Fe(H){if(H)switch(H){case r.FoldingRangeKind.Comment:return g.$it.Comment;case r.FoldingRangeKind.Imports:return g.$it.Imports;case r.FoldingRangeKind.Region:return g.$it.Region}}Ce.from=Fe;function me(H){if(H)switch(H.value){case g.$it.Comment.value:return r.FoldingRangeKind.Comment;case g.$it.Imports.value:return r.FoldingRangeKind.Imports;case g.$it.Region.value:return r.FoldingRangeKind.Region}}Ce.to=me})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Fe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?c.$TD.id:void 0}}Ce.from=Fe})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Fe(je){return je instanceof r.$eL?je.toJSON():typeof je=="string"?je:me(je)||H(je)?new r.$eL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Fe;function me(je){const Je=je;return Je?b.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function H(je){const Je=je;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(je){return typeof je=="string"?je:new r.$eL(b.URI.revive(je.baseUri),je.pattern)}Ce.to=Me})(st||(e.GlobPattern=st={}));var Y;(function(Ce){function Fe(me){if(me){if(Array.isArray(me))return me.map(Fe);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Fe})(Y||(e.LanguageSelector=Y={}));var Q;(function(Ce){function Fe(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Je=>Je instanceof r.$kK)))}Ce.is=Fe;function me(H){return{documents:H.documents.map(Me=>Me.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Je=>o.from(Je))})))}}Ce.from=me})(Q||(e.MappedEditsContext=Q={}));var be;(function(Ce){function Fe(H){return{start:H.start,end:H.end}}Ce.from=Fe;function me(H){return new r.$FL(H.start,H.end)}Ce.to=me})(be||(e.NotebookRange=be={}));var Be;(function(Ce){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Fe;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=me})(Be||(e.NotebookCellExecutionSummary=Be={}));var Oe;(function(Ce){function Fe(me){if(me===p.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(me===p.NotebookCellExecutionState.Pending)return;if(me===p.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Fe})(Oe||(e.NotebookCellExecutionState=Oe={}));var Xe;(function(Ce){function Fe(H){switch(H){case r.NotebookCellKind.Markup:return p.CellKind.Markup;case r.NotebookCellKind.Code:default:return p.CellKind.Code}}Ce.from=Fe;function me(H){switch(H){case p.CellKind.Markup:return r.NotebookCellKind.Markup;case p.CellKind.Code:default:return r.NotebookCellKind.Code}}Ce.to=me})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Ce){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)r.$GL.validate(je),Me.cells.push(ft.from(je));return Me}Ce.from=Fe;function me(H){const Me=new r.$HL(H.cells.map(ft.to));return(0,a.$Lf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=me})(nt||(e.NotebookData=nt={}));var ft;(function(Ce){function Fe(H){return{cellKind:Xe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Be.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Pt.from):[]}}Ce.from=Fe;function me(H){return new r.$GL(Xe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Pt.to):void 0,H.metadata,H.internalMetadata?Be.to(H.internalMetadata):void 0)}Ce.to=me})(ft||(e.NotebookCellData=ft={}));var wt;(function(Ce){function Fe(H){return{mime:H.mime,valueBytes:M.$be.wrap(H.data)}}Ce.from=Fe;function me(H){return new r.$IL(H.valueBytes.buffer,H.mime)}Ce.to=me})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(Ce){function Fe(H){return{outputId:H.id,items:H.items.map(wt.from),metadata:H.metadata}}Ce.from=Fe;function me(H){const Me=H.items.map(wt.to);return new r.$JL(Me,H.outputId,H.metadata)}Ce.to=me})(Pt||(e.NotebookCellOutput=Pt={}));var Zt;(function(Ce){function Fe(Me){return H(Me)?{include:st.from(Me.include)??void 0,exclude:st.from(Me.exclude)??void 0}:st.from(Me)??void 0}Ce.from=Fe;function me(Me){return H(Me)?{include:st.to(Me.include),exclude:st.to(Me.exclude)}:st.to(Me)}Ce.to=me;function H(Me){const je=Me;return je?!(0,a.$Hf)(je.include)&&!(0,a.$Hf)(je.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Gt;(function(Ce){function Fe(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Me),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Fe})(Gt||(e.NotebookStatusBarItem=Gt={}));var pt;(function(Ce){function Fe(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(je,Me),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Fe})(pt||(e.NotebookKernelSourceAction=pt={}));var jt;(function(Ce){function Fe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Fe})(jt||(e.NotebookDocumentContentOptions=jt={}));var Nt;(function(Ce){function Fe(H){return{uri:H.uri,provides:H.provides}}Ce.from=Fe;function me(H){return new r.$LL(b.URI.revive(H.uri),H.provides)}Ce.to=me})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Ce){function Fe(H){return{message:j.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Fe;function me(H){const Me=new r.$RL(typeof H.message=="string"?H.message:j.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?Z.to(H.location):void 0,Me}Ce.to=me})(Bt||(e.TestMessage=Bt={}));var At;(function(Ce){Ce.namespace=v.$dJ,Ce.denamespace=v.$eJ})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Fe(H){const Me=(0,i.$dM)(H).controllerId;return{extId:E.$_I.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>At.namespace(Me,je.id)),range:$.$ts.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&j.fromStrict(H.error)||null}}Ce.from=Fe;function me(H){return{parent:void 0,error:void 0,id:E.$_I.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:je}=At.denamespace(Me);return new r.$SL(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=me})(Rt||(e.TestItem=Rt={})),function(Ce){function Fe(H){return{id:H.id}}Ce.from=Fe;function me(H){return new r.$SL(H.id)}Ce.to=me}(At||(e.TestTag=At={}));var Ot;(function(Ce){const Fe=(H,Me)=>{const je=[];for(const[Ke,et]of Me)E.$_I.compare(et.item.extId,Ke)===2&&(Me.delete(Ke),je.push(et));const Je={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(et=>et.type===0).map(Bt.to)})),children:je.map(Ke=>Fe(Ke,Me))};for(const Ke of Je.children)Ke.parent=Je;return Je};function me(H){const Me=[],je=new Map;for(const Je of H.items){je.set(Je.item.extId,Je);const Ke=E.$_I.root(Je.item.extId);H.request.targets.some(et=>et.controllerId===Ke&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:H.completedAt,results:Me.map(Je=>Fe(Je,je))}}Ce.to=me})(Ot||(e.TestResults=Ot={}));var Wt;(function(Ce){function Fe(je){return{covered:je.covered,total:je.covered}}function me(je){return"line"in je?d.from(je):o.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:me(je.location),type:1,branches:je.branches.length?je.branches.map(Je=>({count:Je.executionCount,location:Je.location&&me(Je.location)})):void 0}:{type:0,count:je.executionCount,location:me(je.location)}}Ce.fromDetailed=H;function Me(je){return{uri:je.uri,statement:Fe(je.statementCoverage),branch:je.branchCoverage&&Fe(je.branchCoverage),function:je.functionCoverage&&Fe(je.functionCoverage),details:je.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Ce){function Fe(me){switch(me){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ce.to=Fe})(Jt||(e.CodeActionTriggerKind=Jt={}));var Vt;(function(Ce){function Fe(H){const Me=new r.$YL(fe.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,kind:fe.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ye.from)}}Ce.from=me})(Vt||(e.TypeHierarchyItem=Vt={}));var Kt;(function(Ce){function Fe(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Fe})(Kt||(e.ViewBadge=Kt={}));var Mt;(function(Ce){function Fe(je,Je,Ke){const et=Je.fileData;return et?new r.$0K(new r.$$K(et.name,b.URI.revive(et.uri),et.id,(0,T.$db)(()=>Ke(et.id)))):je===R.$Pr.uriList&&Je.uriListData?new r.$9K(Me(Je.uriListData)):new r.$9K(Je.asString)}Ce.to=Fe;async function me(je,Je){const Ke=await Je.asString();if(je===R.$Pr.uriList)return{asString:Ke,fileData:void 0,uriListData:H(Ke)};const et=Je.asFile();return{asString:Ke,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=me;function H(je){return C.$3s.split(je).map(Je=>{if(Je.startsWith("#"))return Je;try{return b.URI.parse(Je)}catch{}return Je})}function Me(je){return C.$3s.create(je.map(Je=>typeof Je=="string"?Je:b.URI.revive(Je)))}})(Mt||(e.DataTransferItem=Mt={}));var ut;(function(Ce){function Fe(H,Me){const je=H.items.map(([Je,Ke])=>[Je,Mt.to(Je,Ke,Me)]);return new r.$_K(je)}Ce.toDataTransfer=Fe;async function me(H){const Me={items:[]},je=[];for(const[Je,Ke]of H)je.push((async()=>{Me.items.push([Je,await Mt.from(Je,Ke)])})());return await Promise.all(je),Me}Ce.from=me})(ut||(e.DataTransfer=ut={}));var dt;(function(Ce){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Fe;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=me})(dt||(e.ChatReplyFollowup=dt={}));var Lt;(function(Ce){function Fe(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:dt.from(me)}Ce.from=Fe})(Lt||(e.ChatFollowup=Lt={}));var qt;(function(Ce){function Fe(H){const Me=new r.$9L(kt.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Fe;function me(H){return{role:kt.from(H.role),content:H.content,name:H.name}}Ce.from=me})(qt||(e.ChatMessage=qt={}));var kt;(function(Ce){function Fe(H){switch(H){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ce.to=Fe;function me(H){switch(H){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ce.from=me})(kt||(e.ChatMessageRole=kt={}));var at;(function(Ce){function Fe(Me){const je={};for(const Je of Object.keys(Me))je[Je]=Me[Je].map(Ce.to);return je}Ce.objectTo=Fe;function me(Me){return{level:vt.to(Me.level),value:Me.value,description:Me.description}}Ce.to=me;function H(Me){return{level:vt.from(Me.level),value:Me.value,description:Me.description}}Ce.from=H})(at||(e.ChatVariable=at={}));var vt;(function(Ce){function Fe(H){switch(H){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ce.to=Fe;function me(H){switch(H){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ce.from=me})(vt||(e.ChatVariableLevel=vt={}));var Ht;(function(Ce){function Fe(me){switch(me){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Fe})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Ct;(function(Ce){function Fe(me){return"placeholder"in me&&"resolvedContent"in me?{placeholder:me.placeholder}:"responseId"in me?{requestId:me.responseId}:"content"in me?{content:"markdownContent"in me?me.markdownContent:typeof me.content=="string"?me.content:j.from(me.content)}:"documents"in me?{documents:me.documents.map(H=>({uri:H.uri,version:H.version,ranges:H.ranges.map(Me=>o.from(Me))}))}:"reference"in me?{reference:"uri"in me.reference?{uri:me.reference.uri,range:o.from(me.reference.range)}:me.reference}:"inlineReference"in me?{inlineReference:"uri"in me.inlineReference?{uri:me.inlineReference.uri,range:o.from(me.inlineReference.range)}:me.inlineReference,title:me.title}:me}Ce.from=Fe})(Ct||(e.ChatResponseProgress=Ct={}));var We;(function(Ce){function Fe(me,H,Me){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Me)}Ce.from=Fe})(We||(e.TerminalQuickFix=We={}))}),define(Ae[204],Re([1,0,2,9,7,8,173]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class l{constructor(f,R,k,a={timeout:1500,errors:3}){this.c=f,this.d=R,this.f=k,this.g=a,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(R,k,a)=>{const $={dispose:this.a.push([R,k,f])};return Array.isArray(a)&&a.push($),$}}async $participateInSave(f,R){const k=y.URI.revive(f);let a=!1;const b=setTimeout(()=>a=!0,this.g.timeout),$=[];try{for(const g of[...this.a]){if(a)break;const t=this.d.getDocument(k),i=await this.h(g,{document:t,reason:T.TextDocumentSaveReason.to(R)});$.push(i)}}finally{clearTimeout(b)}return $}h([f,R,k],a){const b=this.b.get(f);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(k,f,R,a).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const g=this.b.get(f);this.b.set(f,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,R,k,a){const b=[],$=Date.now(),{document:g,reason:t}=a,{version:i}=g,c=Object.freeze({document:g,reason:t,waitUntil(p){if(Object.isFrozen(b))throw(0,M.$8)("waitUntil can not be called async");b.push(Promise.resolve(p))}});try{R.apply(k,[c])}catch(p){return Promise.reject(p)}return Object.freeze(b),new Promise((p,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(v),p(n)}).catch(n=>{clearTimeout(v),E(n)})}).then(p=>{const E={edits:[]};for(const v of p)if(Array.isArray(v)&&v.every(n=>n instanceof C.$pK))for(const{newText:n,newEol:r,range:s}of v)E.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:s&&T.Range.from(s),text:n,eol:r&&T.EndOfLine.from(r)}});if(E.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$xcc=l}),define(Ae[205],Re([1,0,13,2,8,7,75]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=void 0;class l{constructor(k,a,b,$){this.start=k,this.deletedCount=a,this.deletedItems=b,this.items=$}asApiEvent(){return{range:new T.$FL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,b){this.notebook=k,this.h=a,this.j=b,this.handle=b.handle,this.uri=M.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime($){k.g=$},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(b)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,a,b){const $=b.map(C.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===k);if(g&&(a||(g.items.length=0),g.items.push(...$),g.items.length>1&&g.items.every(t=>A.$qI(t.mime)))){const t=new Map,i=[];g.items.forEach(c=>{let p;t.has(c.mime)?p=t.get(c.mime):(p=[],t.set(c.mime,p),i.push(c.mime)),p.push(c.data)}),g.items.length=0,i.forEach(c=>{const p=A.$rI(t.get(c));g.items.push({mime:c,data:p.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Kdc=D;class f{static{this.a=0}constructor(k,a,b,$,g){this.k=k,this.l=a,this.m=b,this.uri=$,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(b){return b=k.n(b),k.b[b].apiCell},getCells(b){return(b?k.p(b):k.b).map(g=>g.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,b){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:b});const $={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},g=[];for(const i of k.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const c=g[i],p=t.get(c.cell);if(p===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,E-1)}else $.cellChanges[p]={...$.cellChanges[p],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,b=k.end|0;return a<0&&(a=0),b>this.b.length&&(b=this.b.length),k.with({start:a,end:b})}p(k){k=this.o(k);const a=[];for(let b=k.start;b<k.end;b++)a.push(this.b[b]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,b){if(this.j)return;const $=[],g=[],t=[];if(k.reverse().forEach(i=>{const p=i[2].map(n=>{const r=new D(this,this.l,n);return a||g.push(D.asModelAddData(this.apiNotebook,n)),r}),E=new l(i[0],i[1],[],p),v=this.b.splice(i[0],i[1],...p);for(const n of v)t.push(n.uri),E.deletedItems.push(n.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),b)for(const i of $)b.push(i.asApiEvent())}s(k,a,b,$){const g=this.b.splice(k,a);this.b.splice(b,0,...g);const t=[new l(k,a,g.map(i=>i.apiCell),[]),new l(b,0,[],g)];for(const i of t)$.push(i.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,b,$){this.b[k].setOutputItems(a,b,$)}v(k,a){const b=this.b[k];b.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(b.uri,a)}w(k,a){const b=this.b[k];b.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Ldc=f}),define(Ae[206],Re([1,0,5,2,8,7]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class A{constructor(D,f,R,k={timeout:1500,errors:3}){this.b=D,this.c=f,this.d=R,this.f=k,this.a=new y.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(f,R,k)=>{const a=function($){f.call(R,$)};return a.extension=D,this.a.event(a,void 0,k)}}async $participateInSave(D,f,R){const k=M.URI.revive(D),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to(f)},R,async(g,t)=>{const i=Date.now(),c=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof T.$sK?b.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(b.length===0)return!0;const $={edits:[]};for(const g of b){const{edits:t}=C.WorkspaceEdit.from(g);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$_dc=A}),define(Ae[103],Re([1,0,9,8,7]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,D,f,R,k,a){this.id=l,this.f=D,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=a}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(D){this.selections=[D]},get selections(){return l.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$FL.isNotebookRange))throw(0,y.$7)("selections");l.a=D,l.g(D)},get visibleRanges(){return l.b},revealRange(D,f){l.f.$tryRevealRange(l.id,M.NotebookRange.from(D),f??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$Mdc=T}),define(Ae[207],Re([1,0,9,5,14,8]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;let A=class{constructor(D,f){this.c=D,this.d=f,this.a=new M.$Nd({onListenerError:y.$2}),this.b=new M.$Nd({onListenerError:y.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,f);const R=this.d.getEditorById(D);f.visibleRanges&&R._acceptVisibleRanges(f.visibleRanges.ranges.map(T.NotebookRange.to)),f.selections&&R._acceptSelections(f.selections.selections.map(T.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const f in D)this.d.getEditorById(f)._acceptViewColumn(T.ViewColumn.to(D[f]))}};e.$5dc=A,e.$5dc=A=qe([Ve(0,C.$0i)],A)}),define(Ae[208],Re([1,0,8,51,152,19,65,9]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,b,$){const g=this.b++,{title:t,location:i,cancellable:c}=b,p={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(g,{location:y.ProgressLocation.from(i),title:t,source:p,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(l.$2),this.d(g,$,!!c)}d(a,b,$){let g;$&&(g=new T.$Xd,this.c.set(a,g));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),g?.dispose()};let i;try{i=b(new R(this.a,a),$&&g?g.token:T.CancellationToken.None)}catch(c){throw t(a),c}return i.then(c=>t(a),c=>t(a)),i}$acceptProgressCanceled(a){const b=this.c.get(a);b&&(b.cancel(),this.c.delete(a))}}e.$9cc=D;function f(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class R extends M.$5u{constructor(a,b){super($=>this.throttledReport($)),this.c=a,this.d=b}throttledReport(a){this.c.$progressReport(this.d,a)}}qe([(0,A.$jh)(100,(k,a)=>f(k,a),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,41,101,46,76,57,8,2]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=e.$tM=void 0;const f=(p,E,v,n)=>{let r=E;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!v(r,s)){const o=r;r=s,p.listener?.(n(s,o))}}}},R=(p,E)=>p===E,k={range:(p,E)=>p===E?!0:!p||!E?!1:p.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(p,E)=>!(p.length!==E.length||p.some(v=>!E.find(n=>v.id===n.id)))},a=p=>E=>({op:4,update:p(E)}),b=(p,E)=>({range:(()=>{let v;const n=a(r=>({range:y.$ts.lift(l.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return v},set(r){p.listener?.({op:6}),k.range(v,r)||(v=r,p.listener?.(n(r)))}}})(),label:f(p,E,k.label,a(v=>({label:v}))),description:f(p,void 0,k.description,a(v=>({description:v}))),sortText:f(p,void 0,k.sortText,a(v=>({sortText:v}))),canResolveChildren:f(p,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:f(p,!1,k.busy,a(v=>({busy:v}))),error:f(p,void 0,k.error,a(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:f(p,[],k.tags,(v,n)=>({op:1,new:v.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),$=p=>{const E=C.$_I.fromString(p.extId),v=new t(E.controllerId,E.localId,p.label,D.URI.revive(p.uri)||void 0);return v.range=l.Range.to(p.range||void 0),v.description=p.description||void 0,v.sortText=p.sortText||void 0,v.tags=p.tags.map(n=>l.TestTag.to({id:(0,A.$eJ)(n).tagId})),v},g=p=>{let E;for(const v of p.tests){const n=$(v.item);(0,M.$dM)(n).parent=E,E=n}return E};e.$tM=g;class t{constructor(E,v,n,r){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const s=(0,M.$cM)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,T.$bM)(s,M.$dM,t),enumerable:!0,writable:!1},...b(s,n)})}}e.$uM=t;class i extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$vM=i;class c extends T.$0L{constructor(E,v,n){super({controllerId:E,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:M.$dM,getChildren:r=>r.children,root:new i(E,v),toITestItem:l.TestItem.from})}}e.$wM=c}),define(Ae[105],Re([1,0,52,9,88,8,7]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=void 0;class l{static{this.c=new C.$mM("TextEditorDecorationType")}constructor(a,b,$){const g=l.c.nextId();a.$registerTextEditorDecorationType(b.identifier,g,T.DecorationRenderOptions.from($)),this.value=Object.freeze({key:g,dispose(){a.$removeTextEditorDecorationType(g)}})}}e.$oM=l;class D{constructor(a,b){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,b){this.k();let $=null;if(a instanceof A.$jK)$=new A.$kK(a,a);else if(a instanceof A.$kK)$=a;else throw new Error("Unrecognized location");this.l($,b,!1)}insert(a,b){this.k(),this.l(new A.$kK(a,a),b,!0)}delete(a){this.k();let b=null;if(a instanceof A.$kK)b=a;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(a,b,$){const g=this.c.validateRange(a);this.g.push({range:g,text:b,forceMoveMarkers:$})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=a}}class f{constructor(a,b,$,g){this.c=a,this.d=b,this._accept($),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}m(a){const b=this.l(a);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}o(a){const b=this.n(a);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const b=this.p(a);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(a)})))}assign(a){const b={};let $=!1;if(typeof a.tabSize<"u"){const g=this.l(a.tabSize);g==="auto"?($=!0,b.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,$=!0,b.tabSize=g)}if(typeof a.indentSize<"u"){const g=this.n(a.indentSize);g==="tabSize"?($=!0,b.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,$=!0,b.indentSize=g)}if(typeof a.insertSpaces<"u"){const g=this.p(a.insertSpaces);g==="auto"?($=!0,b.insertSpaces=g):this.h!==g&&(this.h=g,$=!0,b.insertSpaces=g)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,$=!0,b.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,$=!0,b.lineNumbers=T.TextEditorLineNumbersStyle.from(a.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(a,b){b.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn($)})}}e.$pM=f;class R{constructor(a,b,$,g,t,i,c,p){this.id=a,this.j=b,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,$),this.e=c,this.f=p;const E=this;this.value=Object.freeze({get document(){return g.value},set document(v){throw new M.$9("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof A.$lK))throw(0,M.$7)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof A.$lK)))throw(0,M.$7)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$9("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$9("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(g.value,n);return v(r),E.m(r)},insertSnippet(v,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=E.c.map(o=>T.Range.from(o));else if(n instanceof A.$jK){const{lineNumber:o,column:w}=T.Position.from(n);s=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(n instanceof A.$kK)s=[T.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$kK)s.push(T.Range.from(o));else{const{lineNumber:w,column:d}=T.Position.from(o);s.push({startLineNumber:w,startColumn:d,endLineNumber:w,endColumn:d})}}return b.$tryInsertSnippet(a,g.value.version,v.value,s,r)},setDecorations(v,n){const r=n.length===0;r&&!E.h.has(v.key)||(r?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(T.$eM(n))return b.$trySetDecorations(a,v.key,T.$fM(n));{const s=new Array(4*n.length);for(let o=0,w=n.length;o<w;o++){const d=n[o];s[4*o]=d.start.line+1,s[4*o+1]=d.start.character+1,s[4*o+2]=d.end.line+1,s[4*o+3]=d.end.character+1}return b.$trySetDecorationsFast(a,v.key,s)}}))},revealRange(v,n){E.n(()=>b.$tryRevealRange(a,T.Range.from(v),n||A.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(a,T.ViewColumn.from(v))},hide(){b.$tryHideEditor(a)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,y.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,y.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,y.ok)(!this.g),this.f=a}_acceptSelections(a){(0,y.ok)(!this.g),this.c=a}async l(){const a=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const b=a.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const $=b.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(t=>({range:T.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?T.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$qM=R}),define(Ae[209],Re([1,0,4,171]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DJ=void 0,e.$DJ=(0,y.$Qh)(M.$Wh)}),define(Ae[106],Re([1,0,21,5,20,6]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p4b=e.$o4b=e.$n4b=e.$m4b=e.$l4b=e.$k4b=void 0;class A{constructor(i,c){this.versionId=i,this.removedDueToLooping=c}}e.$k4b=A;class l{static isHostExtension(i,c,p){if(c.getExtensionDescription(i))return!1;const E=p.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,c){this.j=i,this.c=new M.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort($),this.f=new y.$8l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const c=this.j.readActivationEvents(i);if(Array.isArray(c))for(let p of c)p==="onUri"&&(p=`onUri:${y.$6l.toKey(i.identifier)}`),this.h.has(p)||this.h.set(p,[]),this.h.get(p).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,c){this.e=g(this.e,c),this.e=this.e.concat(i);const p=l.l(this.e);return this.e=g(this.e,p.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,p)}static l(i){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,s){this.addNode(r),this.addNode(s),this.c.has(r)?this.c.get(r).push(s):this.c.set(r,[s])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,s){const o=c.getArcs(r);for(let w=0;w<o.length;w++)if(!s.has(o[w]))return!1;return!0}getNodes(){return this.e}},p=new y.$8l;for(const r of i)if(p.set(r.identifier,r),r.extensionDependencies)for(const s of r.extensionDependencies)c.addArc(y.$6l.toKey(r.identifier),y.$6l.toKey(s));const E=new Set;c.getNodes().filter(r=>c.getArcs(r).length===0).forEach(r=>E.add(r));const v=c.getNodes().filter(r=>!E.has(r));let n;do{n=!1;for(let r=0;r<v.length;r++){const s=v[r];c.hasOnlyGoodArcs(s,E)&&(v.splice(r,1),r--,E.add(s),n=!0)}}while(n);return v.map(r=>p.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const c=this.h.get(i);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const c=this.f.get(i);return c||void 0}getExtensionDescriptionByUUID(i){for(const c of this.g)if(c.uuid===i)return c}getExtensionDescriptionByIdOrUUID(i,c){return this.getExtensionDescription(i)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$l4b=l;class D{constructor(i,c){this.versionId=i,this.extensions=c}}e.$m4b=D,e.$n4b={readActivationEvents:t=>t.activationEvents};class f{constructor(i){this.d=new a,this.c=new l(i,[])}async acquireLock(i){const c=await this.d.acquire(i);return new R(this,c)}deltaExtensions(i,c,p){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,p)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,c){return this.c.getExtensionDescriptionByIdOrUUID(i,c)}}e.$o4b=f;class R extends T.$Sc{constructor(i,c){super(),this.f=i,this.c=!1,this.B(c)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$p4b=R;class k{constructor(i){this.name=i,this.promise=new Promise((c,p)=>{this.c=c})}resolve(i){this.c(i)}}class a{constructor(){this.c=[],this.d=!1}async acquire(i){const c=new k(i);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let c=!0;const p=setTimeout(()=>{c&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{c&&(clearTimeout(p),c=!1,this.d=!1,this.e())};i.resolve((0,T.$Qc)(E))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function $(t,i){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,p=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(c!==p)return c-p;const E=C.$gc.basename(t.extensionLocation.path),v=C.$gc.basename(i.extensionLocation.path);return E<v?-1:E>v?1:0}function g(t,i){const c=new y.$7l(i);return t.filter(p=>!c.has(p.identifier))}}),define(Ae[79],Re([1,0,26]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(f){const R=y.$be.alloc(1);switch(f){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$bm=A;function l(f,R){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$cm=l;var D;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,53,54,24,2,6,154]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=void 0;let b=class extends k.$Sc{constructor(i,c){super(),this.s=i,this.t=c,this.a=this.B(new M.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:D.$oo,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(p=>{(0,C.$_i)(p)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,p){const E=this.getTelemetryDetails(),v=new $(c,p,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(i,c,p){this.f=i,this.g=c,this.c=p??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Vk)((0,D.$vo)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.r.forEach((p,E)=>{const v=p.filter(n=>!n.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach(p=>{for(const E of p)E.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,c){const E=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!E)return this.r.delete(i.value),!1;let v=!1;for(const n of E)n.ignoreUnhandledExtHostErrors||(n.logError(c),v=!0);return v}};e.$yM=b,e.$yM=b=qe([Ve(0,T.$xM),Ve(1,C.$$i)],b);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,p,E,v,n,r){this.g=p,this.h=E,this.i=v,this.j=n,this.a=new M.$Nd,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,D.$yo)(c,[]),this.c&&(c=(0,f.$0m)(c,this.c)),this.b||(c=(0,f.$0m)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const p={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,D.$yo)(p,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(v,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$zM=$;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$AM=g,e.$BM=(0,y.$Ph)("IExtHostTelemetry")}),define(Ae[25],Re([1,0,5,2,180,98,21,4]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.ActivationKind=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.ExtensionHostStartup=e.$bF=e.$aF=e.$_E=e.$$E=void 0,e.$$E=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$_E="extensions.webWorker",e.$aF=(0,l.$Ph)("extensionService");class D{constructor(v){this.dependency=v}}e.$bF=D;var f;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,n,r){this.c=v,this.d=n.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$VE.createActivationEventsMap(this.d)}}set(v,n,r){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const s=[],o=[],w=[],d=[],I=k(this.d),S=k(n),u=(z,j)=>z.extensionLocation.toString()===j.extensionLocation.toString()||z.isBuiltin===j.isBuiltin||z.isUserBuiltin===j.isUserBuiltin||z.isUnderDevelopment===j.isUnderDevelopment;for(const z of this.d){const j=S.get(z.identifier);if(!j){s.push(z.identifier),I.delete(z.identifier);continue}if(!u(z,j)){s.push(z.identifier),I.delete(z.identifier);continue}}for(const z of n){const j=I.get(z.identifier);if(!j){o.push(z);continue}if(!u(j,z)){s.push(j.identifier),I.delete(j.identifier);continue}}const m=new A.$7l(this.e),h=new A.$7l(r);for(const z of this.e)h.has(z)||w.push(z);for(const z of r)m.has(z)||d.push(z);const P=T.$VE.createActivationEventsMap(o),B={versionId:v,toRemove:s,toAdd:o,addActivationEvents:P,myToRemove:w,myToAdd:d};return this.delta(B),B}delta(v){if(this.c>=v.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:s,myToAdd:o}=v,w=new A.$7l(n),d=new A.$7l(s);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)d.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of r)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const n of this.e)if(A.$6l.equals(n,v))return!0;return!1}}e.$cF=R;function k(E){const v=new A.$8l;for(const n of E)v.set(n.identifier,n);return v}function a(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$dF=a;function b(E,v){if(!a(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$eF=b;class ${constructor(v,n,r,s){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=s}}e.$fF=$;class g{constructor(v,n){this.description=v,this.value=n}}e.$gF=g;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Eo)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$hF=i;function c(E,v){return{identifier:new A.$6l((0,C.$Co)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$iF=c;class p{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$jF=p}),define(Ae[210],Re([1,0,9,106,21,25,14,12]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=e.$Bcc=e.$Acc=e.$zcc=e.$ycc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,c,p,E){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=p,this.activateResolvedTime=E}}e.$ycc=D;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zcc=f;class R{constructor(i,c,p,E,v,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=p,this.module=E,this.exports=v,this.subscriptions=n}}e.$Acc=R;class k extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Bcc=k;class a extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ccc=a;class b extends R{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,c,p,E){this.g=E,this.a=i,this.b=c,this.c=p,this.d=new C.$8l,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,p]of this.d)i.push(p.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const p=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(p.map(E=>({id:E.identifier,reason:{startup:c,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const p=this.a.getExtensionDescription(i);if(!p)throw new Error(`Extension '${i}' is not known`);return this.h([{id:p.identifier,reason:c}])}async h(i){const c=i.filter(p=>!this.isActivated(p.id)).map(p=>this.j(p));await Promise.all(c.map(p=>p.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const v=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(v));return this.c.onExtensionActivationError(i.id,v,new T.$bF(i.id.value)),n}const p=[],E=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const v of E){if(this.m(v))continue;const n=this.d.get(v);if(n){p.push(n);continue}if(this.l(v)){p.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(v);if(r){if(!r.main&&!r.browser)continue;p.push(this.j({id:r.identifier,reason:i.reason}));continue}const s=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${v}'`),w=this.k(i,c.displayName,[],new b(o));return this.c.onExtensionActivationError(c.identifier,o,new T.$bF(v)),w}return this.k(i,c.displayName,p,null)}k(i,c,p,E){const v=new g(i.id,c,i.reason,p,E,this.c,this.g);return this.d.set(i.id,v),v}l(i){return M.$l4b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$Dcc=$,e.$Dcc=$=qe([Ve(3,A.$0i)],$);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,p,E,v,n,r){this.c=i,this.d=c,this.f=p,this.g=E,this.h=v,this.j=n,this.k=r,this.a=new l.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);p.detail=c.value.activationFailedError,this.h=new b(p),this.j.onExtensionActivationError(this.c,p,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new b(c),this.b&&y.$4(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=qe([Ve(6,A.$0i)],g)}),define(Ae[211],Re([1,0,156,23,2,5,6,192,12,7,15,18,8,50,19,125,25]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;function i(E,v){if((0,R.$yf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let n;return Array.isArray(E.highlights)&&(n=E.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:E.label,highlights:n}}}class c extends A.$Sc{constructor(v,n,r){super(),this.f=v,this.g=n,this.h=r,this.a=new Map,this.b=new g.$L7;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(w=>s(w)?this.r(w):w):o})}registerTreeDataProvider(v,n,r){const s=this.createTreeView(v,{treeDataProvider:n},r);return{dispose:()=>s.dispose()}}createTreeView(v,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],w=!!n.dragAndDropController?.handleDrag,d=!!n.dragAndDropController?.handleDrop,I=this.m(v,n,r),S={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:d,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),m={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$eF)(r,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$eF)(r,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(h){(0,b.$5j)(h)&&(0,t.$eF)(r,"treeViewMarkdownMessage"),I.message=h},get title(){return I.title},set title(h){I.title=h},get description(){return I.description},set description(h){I.description=h},get badge(){return I.badge},set badge(h){h!==void 0&&f.ViewBadge.isViewBadge(h)?I.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(I.badge=void 0)},reveal:(h,P)=>I.reveal(h,P),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(m),m}$getChildren(v,n){const r=this.a.get(v);return r?r.getChildren(n):Promise.reject(new l.$rE(v))}async $handleDrop(v,n,r,s,o,w,d,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$rE(v));const u=a.DataTransfer.toDataTransfer(r,async m=>(await this.f.$resolveDropFileData(v,n,m)).buffer);return d===v&&I&&await this.j(u,S,I,o,w),S.onDrop(u,s,o)}async j(v,n,r,s,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((d,I)=>{d&&v.set(I,d)});else if(o&&n.handleDrag){const d=n.handleDrag(r,v,s);this.b.addDragOperationTransfer(o,d),await d}return v}async $handleDrag(v,n,r,s){const o=this.a.get(v);if(!o)return Promise.reject(new l.$rE(v));const w=await this.j(new f.$_K,o,n,s,r);if(!(!w||s.isCancellationRequested))return a.DataTransfer.from(w)}async $hasResolve(v){const n=this.a.get(v);if(!n)throw new l.$rE(v);return n.hasResolve}$resolve(v,n,r){const s=this.a.get(v);if(!s)throw new l.$rE(v);return s.resolveTreeItem(n,r)}$setExpanded(v,n,r){const s=this.a.get(v);if(!s)throw new l.$rE(v);s.setExpanded(n,r)}$setSelectionAndFocus(v,n,r){const s=this.a.get(v);if(!s)throw new l.$rE(v);s.setSelectionAndFocus(n,r)}$setVisible(v,n){const r=this.a.get(v);if(!r){if(!n)return;throw new l.$rE(v)}r.setVisible(n)}$changeCheckboxState(v,n){const r=this.a.get(v);if(!r)throw new l.$rE(v);r.setCheckboxState(n)}m(v,n,r){const s=this.B(new p(v,n,this.f,this.g.converter,this.h,r));return this.a.set(v,s),s}r(v){const n=this.a.get(v.$treeViewId);return n&&"$treeItemHandle"in v?n.getExtensionElement(v.$treeItemHandle):n&&"$focusedTreeItem"in v&&v.$focusedTreeItem?n.focusedElement:null}}e.$ddc=c;class p extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.$Hf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,n,r,s,o,w){if(super(),this.I=v,this.J=r,this.L=s,this.M=o,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Xd,w.contributes&&w.contributes.views)for(const u in w.contributes.views)for(const m of w.contributes.views[u])m.id===v&&(this.P=m.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let d,I;const S=T.Event.debounce(this.F.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(d||(d=new Promise(h=>I=h),this.G=this.G.then(()=>d)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const h=I;return d=null,this.$(m).then(()=>h())})),u&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const n=v?this.getExtensionElement(v):void 0;if(v&&!n)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let r=this.X(v);return r||(r=await this.Y(n)),r?r.map(s=>s.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,n){n=n||{select:!0,focus:!1};const r=(0,R.$Hf)(n.select)?!0:n.select,s=(0,R.$Hf)(n.focus)?!1:n.focus,o=(0,R.$Hf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(w=>this.W(v,w[w.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:w.map(I=>I.item)},{select:r,focus:s,expand:o})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:r,focus:s,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=a.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,n){const r=this.getExtensionElement(v);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(v,n){const r=!(0,k.$ub)(this.s,v);this.s=v;const s=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const n=(await Promise.all(v.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(v,n,r){const s=[];for(const o of v){const w=this.getExtensionElement(o);w&&s.push(w)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,n,r){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(s,v,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(v);if(r){const s=this.m.get(r);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,r,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(v){return this.U(v).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}U(v){const n=this.m.get(v);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(v))}W(v,n){const r=this.m.get(v);return r?Promise.resolve(r):(0,D.$Mg)(()=>this.f.getTreeItem(v)).then(s=>this.kb(v,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const w=this.m.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let n;if(typeof v=="string"){const r=this.getExtensionElement(v);n=r?this.m.get(r):void 0}else n=v;return n&&n.children||void 0}return this.h}async Y(v){this.rb(v);const n=new $.$Xd(this.Z.token);try{const r=v?this.m.get(v):void 0,s=await this.f.getChildren(v);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Hb)(s||[]).map(async w=>{const d=await this.f.getTreeItem(w);return d&&!n.token.isCancellationRequested?this.db(w,d,r):null}));return n.token.isCancellationRequested?void 0:(0,k.$Hb)(o)}finally{n.dispose()}}$(v){if(v.some(r=>!r))return this.Z.dispose(!0),this.Z=new $.$Xd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(v);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(v){const n=new Set,r=v.map(o=>this.m.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let w=o;for(;w&&w.parent&&r.findIndex(d=>w&&w.parent&&d&&d.item.handle===w.parent.item.handle)===-1;){const d=this.j.get(w.parent.item.handle);w=d?this.m.get(d):void 0}w&&!w.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const w=this.j.get(o);if(w){const d=this.m.get(w);d&&(!d.parent||!n.has(d.parent.item.handle))&&s.push(o)}}),s}bb(v){const n={};return Promise.all(v.map(r=>this.cb(r).then(s=>{s&&(n[r]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(v){const n=this.getExtensionElement(v);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,D.$Mg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,r.parent);return this.pb(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(v,n,r){const s=this.ib(v,n,r);if(n.id&&this.j.has(s.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(v,s),this.qb(s,r),s}eb(v){return f.$IK.isMarkdownString(v)?a.MarkdownString.from(v):v}fb(v,n){return n?{...this.L.toInternal(n,v),originalId:n.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let n,r,s;return typeof v.checkboxState=="number"?n=v.checkboxState:(n=v.checkboxState.state,r=v.checkboxState.tooltip,s=v.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}hb(v){if(!f.$7K.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,n,r){this.hb(n);const s=this.B(new A.$Rc),o=this.kb(v,n,r),w=this.lb(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:w,iconDark:this.mb(n)||w,themeIcon:this.jb(n),collapsibleState:(0,R.$Hf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(v){return v.iconPath instanceof f.$cL?v.iconPath:void 0}kb(v,{id:n,label:r,resourceUri:s},o,w){if(n)return`${p.b}/${n}`;const d=i(r,this.N),I=o?o.item.handle:p.a;let S=d?d.label:s?(0,M.$sg)(s):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,m=this.X(o)||[];let h,P=0;do{if(h=`${I}/${P}:${S}`,w||!this.j.has(h)||u===h)break;P++}while(P<=m.length);return h}lb(v){if(v.iconPath&&!(v.iconPath instanceof f.$cL))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof f.$cL)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,n){this.j.set(n.item.handle,v),this.m.set(v,n)}pb(v,n,r,s){this.j.delete(n.item.handle),this.m.delete(v),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(v,n);const o=this.X(s)||[],w=o.filter(d=>d.item.handle===r.item.handle)[0];w&&o.splice(o.indexOf(w),1,n)}qb(v,n){n?(n.children||(n.children=[]),n.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const n=this.m.get(v);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(v){const n=this.m.get(v);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}this.m.delete(v),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,166,9,29,92,72,30,21,212,176,98]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=void 0;const a=l.$gn.as(A.$hn.JSONContribution);class b{constructor(v,n,r){this.a=v,this.b=n,this.c=r}d(v,n){this.a({type:v,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$5E=b;class ${static a(v){const n=new D.$7l;for(let r=0,s=v.length;r<s;r++)n.add(v[r].description.identifier);return n}static compute(v,n){if(!v||!v.length)return new $(n,[]);if(!n||!n.length)return new $([],v);const r=this.a(v),s=this.a(n),o=n.filter(d=>!r.has(d.description.identifier)),w=v.filter(d=>!s.has(d.description.identifier));return new $(o,w)}constructor(v,n){this.added=v,this.removed=n}}e.$6E=$;class g{constructor(v,n){this.name=v,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=$.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$1)(v)}}}e.$7E=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$8E={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$5l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Xn}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Xn}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const n=new g(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,n),v.activationEventsGenerator&&k.$VE.register(v.extensionPoint,v.activationEventsGenerator),e.$8E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,a.registerSchema(i,e.$8E),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$9E=c;const p={ExtensionsRegistry:"ExtensionsRegistry"};l.$gn.add(p.ExtensionsRegistry,new c),e.$0E=l.$gn.as(p.ExtensionsRegistry),a.registerSchema(i,e.$8E),a.registerSchema(R.$qj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,163,15,24,213,32,5]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(a){function b($,g,t){if(!$)return;const i=M.$yf($.type)?$.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const p of $.required)M.$yf(p)&&c.push(p);return{extensionId:g.value,taskType:i,required:c,properties:$.properties?C.$7m($.properties):{},when:$.when?A.$Ni.deserialize($.when):void 0}}a.from=b})(f||(f={}));const R=T.$0E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,b)=>{for(const $ of a)$.type&&b.push(`onTaskType:${$.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new l.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,$)=>{R.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const p of c)this.a&&p.type&&this.a[p.type]&&delete this.a[p.type]}for(const i of t.added){const c=i.value;for(const p of c){const E=f.from(p,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const $ of this.all()){const g={type:"object",additionalProperties:!1};$.required.length>0&&(g.required=$.required.slice(0)),$.properties!==void 0?g.properties=C.$7m($.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[$.taskType]},b.push(g)}this.c={oneOf:b}}return this.c}}e.$OF=new k}),define(Ae[215],Re([1,0,164,15,23,24,32,214]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$YF=e.JsonSchemaVersion=e.ExecutionEngine=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$SF=e.ShellQuoting=e.$RF=e.$QF=e.$PF=void 0,e.$PF="settings",e.$QF=new A.$7i("taskRunning",!1,y.localize(0,null)),e.$RF={value:y.localize(1,null),original:"Tasks"};var D;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$SF="$customized",function(N){function O(se){if(!se)return N.Strong;switch(se.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(D||(e.ShellQuoting=D={}));var f;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function O(se){switch(se.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(R||(e.RevealKind=R={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(N){function O(se){switch(se.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(k||(e.RevealProblemKind=k={}));var a;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(a||(e.PanelKind=a={})),function(N){function O(se){switch(se.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}(a||(e.PanelKind=a={}));var b;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var $;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(N){function O(X){switch(X.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function se(X){switch(X){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=se}($||(e.RuntimeType=$={}));var g;(function(N){function O(se){return M.$yf(se)?se:se.value}N.value=O})(g||(e.CommandString=g={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(X){return X===N.Clean._id||X===N.Build._id||X===N.Rebuild._id||X===N.Test._id}N.is=O;function se(X){if(X!==void 0)return M.$yf(X)?O(X)?{_id:X,isDefault:!1}:void 0:X}N.from=se})(t||(e.TaskGroup=t={}));var i;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(se){switch(se){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(c||(e.TaskSourceKind=c={}));var p;(function(N){N.parallel="parallel",N.sequence="sequence"})(p||(e.DependsOrder=p={}));var E;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class n{constructor(O,se,X,Ee,Pe,Se){this._label="",this._id=O,se&&(this._label=se),X&&(this.type=X),this.runOptions=Ee,this.configurationProperties=Pe,this._source=Se}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,se=!1){if(O===void 0)return!1;if(M.$yf(O))return O===this._label||O===this.configurationProperties.identifier||se&&O===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$TF=n;class r extends n{constructor(O,se,X,Ee,Pe,Se,fe,ye){super(O,X,void 0,fe,ye,se),this.command={},this._source=se,this.hasDefinedMatchers=Se,Pe&&(this.command=Pe)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let se;switch(this.command?this.command.runtime:void 0){case $.Shell:se="shell";break;case $.Process:se="process";break;case $.CustomExecution:se="customExecution";break;case void 0:se="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:se,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$PF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let se=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(se+=this._source.kind);const X={type:e.$SF,folder:O,id:se};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$UF=r;class s extends n{constructor(O,se,X,Ee,Pe,Se,fe){super(O,X,Ee,Se,fe,se),this._source=se,this.configures=Pe}static is(O){return O instanceof s}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$PF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let se=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(se+=this._source.kind);const X={type:e.$SF,folder:O,id:se};return JSON.stringify(X)}}e.$VF=s;class o extends n{constructor(O,se,X,Ee,Pe,Se,fe,ye,ue){super(O,X,Ee,ye,ue,se),this.defines=Pe,this.hasDefinedMatchers=fe,this.command=Se,this.icon=ue.icon,this.hide=ue.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof o}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new o(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$WF=o;class w extends n{constructor(O,se,X,Ee,Pe,Se){super(O,X,Ee,Pe,Se,se),this._source=se}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new w(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$XF=w;var d;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(N){N._default=N.Terminal}(d||(e.ExecutionEngine=d={}));var I;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(O){this.c=new Map;for(let se=0;se<O.length;se++)this.c.set(O[se].uri.toString(),se)}compare(O,se){const X=O.getWorkspaceFolder(),Ee=se.getWorkspaceFolder();if(X&&Ee){let Pe=this.c.get(X.uri.toString());Pe=Pe===void 0?0:Pe+1;let Se=this.c.get(Ee.uri.toString());return Se=Se===void 0?0:Se+1,Pe===Se?O._label.localeCompare(se._label):Pe-Se}else return!X&&Ee?-1:X&&!Ee?1:0}}e.$YF=S;var u;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(u||(e.TaskEventKind=u={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var h;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(h||(e.TaskRunSource=h={}));var P;(function(N){function O(ye){return{taskId:ye._id,taskName:ye.configurationProperties.name,runType:ye.configurationProperties.isBackground?"background":"singleRun",group:ye.configurationProperties.group,__task:ye}}function se(ye,ue,ae){return{...O(ye),kind:"start",terminalId:ue,resolvedVariables:ae}}N.start=se;function X(ye,ue,ae){return{...O(ye),kind:"processStarted",terminalId:ue,processId:ae}}N.processStarted=X;function Ee(ye,ue,ae){return{...O(ye),kind:"processEnded",terminalId:ue,exitCode:ae}}N.processEnded=Ee;function Pe(ye,ue,ae){return{...O(ye),kind:"terminated",exitReason:ae,terminalId:ue}}N.terminated=Pe;function Se(ye,ue,ae){return{...O(ue),kind:ye,terminalId:ae}}N.general=Se;function fe(){return{kind:"changed"}}N.changed=fe})(P||(e.TaskEvent=P={}));var B;(function(N){function O(X){const Ee=Object.keys(X).sort();let Pe="";for(const Se of Ee){let fe=X[Se];fe instanceof Object?fe=O(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),Pe+=Se+","+fe+","}return Pe}function se(X){const Pe={_key:O(X),type:X.taskType};return Object.assign(Pe,X),Pe}N.create=se})(B||(e.KeyedTaskIdentifier=B={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(z||(e.TaskSettingId=z={}));var j;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var V;(function(N){function O(se,X){const Ee=l.$OF.get(se.type);if(Ee===void 0){const ye=T.$7m(se);return delete ye._key,B.create(ye)}const Pe=Object.create(null);Pe.type=Ee.taskType;const Se=new Set;Ee.required.forEach(ye=>Se.add(ye));const fe=Ee.properties;for(const ye of Object.keys(fe)){const ue=se[ye];if(ue!=null)Pe[ye]=ue;else if(Se.has(ye)){const ae=fe[ye];if(ae.default!==void 0)Pe[ye]=T.$7m(ae.default);else switch(ae.type){case"boolean":Pe[ye]=!1;break;case"number":case"integer":Pe[ye]=0;break;case"string":Pe[ye]="";break;default:X.error(y.localize(2,null,JSON.stringify(se,void 0,0),ye));return}}}return B.create(Pe)}N.createTaskIdentifier=O})(V||(e.TaskDefinition=V={}))}),define(Ae[216],Re([1,0,9]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r4b=e.$q4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$1)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$q4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$r4b=C}),define(Ae[47],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=void 0;class y{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++y.count}}e.$nv=y;const M=[];function C(l){const D=new y(l);return M[D.nid]=D,D}e.$ov=C;function T(l){return M[l].sid}e.$pv=T;class A{constructor(D){this.value=D}}e.$qv=A}),define(Ae[3],Re([1,0,47]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var D;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var f;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var R;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$fK=k;var a;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var b;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var $;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$gK={MainThreadAuthentication:(0,y.$ov)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$ov)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$ov)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$ov)("MainThreadChatAgents"),MainThreadChatAgents2:(0,y.$ov)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$ov)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$ov)("MainThreadClipboard"),MainThreadCommands:(0,y.$ov)("MainThreadCommands"),MainThreadComments:(0,y.$ov)("MainThreadComments"),MainThreadConfiguration:(0,y.$ov)("MainThreadConfiguration"),MainThreadConsole:(0,y.$ov)("MainThreadConsole"),MainThreadDebugService:(0,y.$ov)("MainThreadDebugService"),MainThreadDecorations:(0,y.$ov)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$ov)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$ov)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$ov)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$ov)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$ov)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$ov)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$ov)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$ov)("MainThreadErrors"),MainThreadTreeViews:(0,y.$ov)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$ov)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$ov)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$ov)("MainThreadLanguages"),MainThreadLogger:(0,y.$ov)("MainThreadLogger"),MainThreadMessageService:(0,y.$ov)("MainThreadMessageService"),MainThreadOutputService:(0,y.$ov)("MainThreadOutputService"),MainThreadProgress:(0,y.$ov)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$ov)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$ov)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$ov)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$ov)("MainThreadSecretState"),MainThreadStorage:(0,y.$ov)("MainThreadStorage"),MainThreadSpeech:(0,y.$ov)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$ov)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$ov)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$ov)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$ov)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$ov)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$ov)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$ov)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$ov)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$ov)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$ov)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$ov)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$ov)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$ov)("MainThreadExtensionService"),MainThreadSCM:(0,y.$ov)("MainThreadSCM"),MainThreadSearch:(0,y.$ov)("MainThreadSearch"),MainThreadShare:(0,y.$ov)("MainThreadShare"),MainThreadTask:(0,y.$ov)("MainThreadTask"),MainThreadWindow:(0,y.$ov)("MainThreadWindow"),MainThreadLabelService:(0,y.$ov)("MainThreadLabelService"),MainThreadNotebook:(0,y.$ov)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$ov)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$ov)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$ov)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$ov)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$ov)("MainThreadInteractive"),MainThreadChat:(0,y.$ov)("MainThreadChat"),MainThreadInlineChat:(0,y.$ov)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$ov)("MainThreadTheming"),MainThreadTunnelService:(0,y.$ov)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$ov)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$ov)("MainThreadTimeline"),MainThreadTesting:(0,y.$ov)("MainThreadTesting"),MainThreadLocalization:(0,y.$ov)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$ov)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$ov)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$ov)("MainThreadIssueReporter")},e.$hK={ExtHostCommands:(0,y.$ov)("ExtHostCommands"),ExtHostConfiguration:(0,y.$ov)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$ov)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$ov)("ExtHostDebugService"),ExtHostDecorations:(0,y.$ov)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$ov)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$ov)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$ov)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$ov)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$ov)("ExtHostEditors"),ExtHostTreeViews:(0,y.$ov)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$ov)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$ov)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$ov)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$ov)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$ov)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$ov)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$ov)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$ov)("ExtHostStatusBar"),ExtHostShare:(0,y.$ov)("ExtHostShare"),ExtHostExtensionService:(0,y.$ov)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$ov)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$ov)("ExtHostTerminalService"),ExtHostSCM:(0,y.$ov)("ExtHostSCM"),ExtHostSearch:(0,y.$ov)("ExtHostSearch"),ExtHostTask:(0,y.$ov)("ExtHostTask"),ExtHostWorkspace:(0,y.$ov)("ExtHostWorkspace"),ExtHostWindow:(0,y.$ov)("ExtHostWindow"),ExtHostWebviews:(0,y.$ov)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$ov)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$ov)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$ov)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$ov)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$ov)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$ov)("ExtHostProgress"),ExtHostComments:(0,y.$ov)("ExtHostComments"),ExtHostSecretState:(0,y.$ov)("ExtHostSecretState"),ExtHostStorage:(0,y.$ov)("ExtHostStorage"),ExtHostUrls:(0,y.$ov)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$ov)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$ov)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$ov)("ExtHostOutputService"),ExtHosLabelService:(0,y.$ov)("ExtHostLabelService"),ExtHostNotebook:(0,y.$ov)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$ov)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$ov)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$ov)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$ov)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$ov)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$ov)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$ov)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$ov)("ExtHostChat"),ExtHostChatAgents:(0,y.$ov)("ExtHostChatAgents"),ExtHostChatAgents2:(0,y.$ov)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$ov)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$ov)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$ov)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$ov)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$ov)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$ov)("ExtHostTheming"),ExtHostTunnelService:(0,y.$ov)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$ov)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$ov)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$ov)("ExtHostTimeline"),ExtHostTesting:(0,y.$ov)("ExtHostTesting"),ExtHostTelemetry:(0,y.$ov)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$ov)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$ov)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$gK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,D){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,D)??[]}getRelatedInformation(A,l,D){return this.c.$getAiRelatedInformation(l,D)}registerRelatedInformationProvider(A,l,D){const f=this.b;return this.b++,this.a.set(f,D),this.c.$registerAiRelatedInformationProvider(f,l),new M.$iK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$fec=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=e.$hcc=void 0,e.$hcc=(0,y.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(D,f){this.c=f,this.a=new Set,this.b=D.getProxy(C.$gK.MainThreadTelemetry)}report(D,f,R){const k=this.d(D,f);this.a.has(k)||(this.a.add(k),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:D}))}d(D,f){return`${D}-${f.identifier.value}`}};e.$icc=A,e.$icc=A=qe([Ve(0,T.$hM),Ve(1,M.$0i)],A),e.$jcc=Object.freeze(new class{report(l,D,f){}})}),define(Ae[218],Re([1,0,5,3,7,21]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new y.$Nd,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=f.getProxy(M.$gK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,R,k,a={}){const b=T.$6l.toKey(f.identifier),$=[...k].sort().join(" ");return await this.f.getOrCreate(`${b} ${R} ${$}`,async()=>{await this.a.$ensureProvider(R);const g=f.displayName||f.name;return this.a.$getSession(R,k,b,g,a)})}async getSessions(f,R,k){const a=T.$6l.toKey(f.identifier),b=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${b}`,async()=>{await this.a.$ensureProvider(R);const $=f.displayName||f.name;return this.a.$getSessions(R,k,a,$)})}async removeSession(f,R){const k=this.b.get(f);return k?k.provider.removeSession(R):this.a.$removeSession(f,R)}registerAuthenticationProvider(f,R,k,a){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:R,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===f)||this.c.push({id:f,label:R});const b=k.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(f,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(f,R,a?.supportsMultipleAccounts??!1),new C.$iK(()=>{b.dispose(),this.b.delete(f);const $=this.c.findIndex(g=>g.id===f);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,R,k){const a=this.b.get(f);if(a)return Promise.resolve(a.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,R){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,R){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,R){return this.d.fire({provider:{id:f,label:R}}),Promise.resolve()}}e.$Pdc=A;class l{constructor(){this.a=new Map}getOrCreate(f,R){const k=this.a.get(f);if(k)return k;const a=R().finally(()=>this.a.delete(f));return this.a.set(f,a),a}}}),define(Ae[219],Re([1,0,3,17,8]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;let T=class{constructor(l,D){this.a=l.getProxy(y.$gK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>D.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,D,f){const R=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,f?.isRefactoring??!1)}};e.$Vdc=T,e.$Vdc=T=qe([Ve(0,M.$hM)],T)}),define(Ae[220],Re([1,0,12,5,66,6,59,146,3,8]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class R{static{this.a=0}constructor(b,$){this.extension=b,this.provider=$,this.handle=R.a++}}class k{static{this.a=0}constructor(b,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new M.$Nd,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(D.$gK.MainThreadChat)}registerChatProvider(b,$,g){const t=new R(b,g);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,T.$Qc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,$){const g=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===b)??0;typeof g=="number"&&this.g.$transferChatSession(g,$)}sendInteractiveRequestToProvider(b,$){this.g.$sendRequestToProvider(b,$)}async $prepareChat(b,$,g){const t=this.b.get(b);if(!t)return;const i=await t.provider.prepareSession($,g);if(!i)return;const c=k.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(b,$){const g=this.b.get(b);if(!g||!g.provider.provideWelcomeMessage)return;const t=await g.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>f.ChatReplyFollowup.from(c)))}async $provideFollowups(b,$,g){const t=this.b.get(b);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,g))?.map(p=>f.ChatFollowup.from(p))}async $provideSampleQuestions(b,$){const g=this.b.get(b);if(!g||!g.provider.provideSampleQuestions)return;const t=await g.provider.provideSampleQuestions($);if(t)return t?.map(i=>f.ChatReplyFollowup.from(i))}$removeRequest(b,$,g){const t=this.b.get(b);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,g)}async $provideReply(b,$,g,t){const i=this.b.get(b);if(!i)return;const c=this.d.get($);if(!c)return;const p={session:c,message:g.message,variables:{}};if(g.variables)for(const o of Object.keys(g.variables))p.variables[o]=g.variables[o].map(f.ChatVariable.to);const E=A.$Jd.create(!1);let v;const n={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const w=f.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const d=Promise.all([this.g.$acceptResponseProgress(b,$,w),o.resolvedContent]);(0,y.$Ig)(d,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(b,$,u,S??void 0)})}else this.g.$acceptResponseProgress(b,$,w)}};let r;try{r=await i.provider.provideResponseWithProgress(p,n,t),r||(r={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has($)){const o=c.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const s={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(b,$,g){const t=this.b.get(b);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,g))?.map(p=>({...p,kind:f.CompletionItemKind.from(p.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$0dc=k}),define(Ae[221],Re([1,0,12,6,51,3,8,7]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class D{static{this.a=0}constructor(k,a,b){this.d=a,this.e=b,this.b=new Map,this.c=k.getProxy(T.$gK.MainThreadChatAgents)}registerAgent(k,a,b,$){const g=D.a++;return this.b.set(g,{extension:k,agent:b}),this.c.$registerAgent(g,a,$),(0,M.$Qc)(()=>{this.c.$unregisterAgent(g),this.b.delete(g)})}async $invokeAgent(k,a,b,$,g){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const p=new y.$ch;g.onCancellationRequested(()=>p.complete()),setTimeout(()=>p.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,p.p);const E=t.agent({role:l.ChatMessageRole.User,content:b},{history:$.history.map(A.ChatMessage.to)},new C.$5u(v=>{c(),this.c.$handleProgressChunk(a,{content:f(v.message)?v.message:v.message.value})}),g);try{return await(0,y.$Ig)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(r=>A.ChatFollowup.from(r))}}),g)}finally{i=!0,p.complete()}}}e.$hec=D;function f(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Ae[222],Re([1,0,12,19,37,5,15,51,3,8,7,193,25]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class b{static{this.a=0}constructor(t,i,c){this.h=i,this.i=c,this.b=new Map,this.g=new Map,this.d=t.getProxy(D.$gK.MainThreadChatAgents2)}createChatAgent(t,i,c){const p=b.a++,E=new $(t,i,this.d,p,c);return this.b.set(p,E),this.d.$registerAgent(p,i,{}),E.apiAgent}async $invokeAgent(t,i,c,p,E,v){const n=this.b.get(t);if(!n)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let r=!1;function s(){if(r)throw new Error("Only valid while executing the command")}const o=new y.$ch;v.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.h.allowListExtensionWhile(n.extension.identifier,o.p);const w=p.command?await n.validateSlashCommand(p.command):void 0;try{const d=n.invoke({prompt:p.message,variables:f.ChatVariable.objectTo(p.variables),slashCommand:w},{history:E.history.map(f.ChatMessage.to)},new l.$5u(I=>{s();const S=f.ChatResponseProgress.from(I);this.d.$handleProgressChunk(c,S)}),v);return await(0,y.$Ig)(Promise.resolve(d).then(I=>{if(I)return this.g.set(i,I),{errorDetails:I.errorDetails};this.g.delete(i)}),v)}catch(d){return this.i.error(d,n.extension),{errorDetails:{message:(0,C.$Ai)(d)}}}finally{r=!0,o.complete()}}$releaseSession(t){this.g.delete(t)}async $provideSlashCommands(t,i){const c=this.b.get(t);return c?c.provideSlashCommand(i):[]}$provideFollowups(t,i,c){const p=this.b.get(t);if(!p)return Promise.resolve([]);const E=this.g.get(i);return E?p.provideFollowups(E,c):Promise.resolve([])}$acceptFeedback(t,i,c){const p=this.b.get(t);if(!p)return;const E=this.g.get(i);if(!E)return;let v;switch(c){case k.InteractiveSessionVoteDirection.Down:v=R.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:v=R.ChatAgentResultFeedbackKind.Helpful;break}p.acceptFeedback(Object.freeze({result:E,kind:v}))}$acceptAction(t,i,c){const p=this.b.get(t);if(!p)return;const E=this.g.get(i);E&&c.action.kind!=="vote"&&p.acceptAction(Object.freeze({action:c.action,result:E}))}}e.$iec=b;class ${constructor(t,i,c,p,E){this.extension=t,this.m=i,this.n=c,this.o=p,this.q=E,this.k=new T.$Nd,this.l=new T.$Nd}acceptFeedback(t){this.k.fire(t)}acceptAction(t){this.l.fire(t)}async validateSlashCommand(t){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,A.$If)(this.b));const i=this.b.find(c=>c.name===t);if(!i)throw new Error(`Unknown slashCommand: ${t}`);return i}async provideSlashCommand(t){if(!this.a)return[];const i=await this.a.provideSlashCommands(t);return i?(this.b=i,i.map(c=>({name:c.name,description:c.description}))):[]}async provideFollowups(t,i){if(!this.d)return[];const c=await this.d.provideFollowups(t,i);return c?c.map(p=>f.ChatFollowup.from(p)):[]}get apiAgent(){let t=!1,i=!1;const c=()=>{t||i||(i=!0,queueMicrotask(()=>{this.n.$updateAgent(this.o,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j}),i=!1}))},p=this;return{get name(){return p.m},get description(){return p.g??""},set description(E){p.g=E,c()},get fullName(){return p.h??p.extension.displayName??p.extension.name},set fullName(E){p.h=E,c()},get iconPath(){return p.i},set iconPath(E){p.i=E,c()},get slashCommandProvider(){return p.a},set slashCommandProvider(E){p.a=E,c()},get followupProvider(){return p.d},set followupProvider(E){p.d=E,c()},get isDefault(){return(0,a.$eF)(p.extension,"defaultChatAgent"),p.j},set isDefault(E){(0,a.$eF)(p.extension,"defaultChatAgent"),p.j=E,c()},get onDidReceiveFeedback(){return p.k.event},onDidPerformAction:(0,a.$dF)(this.extension,"chatAgents2Additions")?this.l.event:void 0,dispose(){t=!0,p.a=void 0,p.d=void 0,p.k.dispose(),p.n.$unregisterAgent(p.o)}}}invoke(t,i,c,p){return this.q(t,i,c,p)}}}),define(Ae[223],Re([1,0,19,6,3,8,51,21,12,5]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class R{constructor($,g){this.stream=new D.$gh,this.stream=g??new D.$gh;const t=this;this.apiObj={option:$,response:t.stream.asyncIterable}}}class k{constructor($,g){this.a=new f.$Nd,this.b=new Map,this.c=new D.$gh,this.d=!1;const t=this;this.apiObject={result:$,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){g.cancel()}},$.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.complete();else this.c.complete()})}handleFragment($){if(this.d)return;let g=this.b.get($.index);g||(this.b.size===0?g=new R($.index,this.c):g=new R($.index),this.b.set($.index,g),this.a.fire(g.apiObj)),g.stream.emit($.part)}}class a{static{this.a=1}constructor($,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new l.$8l,this.b=$.getProxy(C.$gK.MainThreadChatProvider)}registerProvider($,g,t,i){const c=a.a++;return this.c.set(c,{extension:$,provider:t}),this.b.$registerProvider(c,g,{extension:$,displayName:i.name??$.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(c),this.c.delete(c)})}async $provideChatResponse($,g,t,i,c){const p=this.c.get($);if(!p)return;const E=new A.$6u(async v=>{if(c.isCancellationRequested){this.d.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(g,{index:v.index,part:v.part})});return p.provider.provideChatResponse(t.map(T.ChatMessage.to),i,E,c)}allowListExtensionWhile($,g){this.f.set($,g),g.finally(()=>this.f.delete($))}async requestChatResponseProvider($,g){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has($)},makeRequest(i,c,p){if(!t.f.has($))throw new Error("Access to chat has been revoked");const E=new y.$Xd(p),v=Math.random()*1e6|0,n=t.b.$fetchResponse($,g,v,i.map(T.ChatMessage.from),c??{},E.token),r=new k(n,E);return t.e.set(v,{res:r}),n.finally(()=>{t.e.delete(v)}),r.apiObject}}}async $handleResponseFragment($,g){const t=this.e.get($);t&&t.res.handleFragment(g)}}e.$cec=a}),define(Ae[224],Re([1,0,6,3,9,8]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class A{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(M.$gK.MainThreadChatVariables)}async $resolveVariable(D,f,R){const k=this.b.get(D);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:f},R);if(a)return a.map(T.ChatVariable.from)}catch(a){(0,C.$2)(a)}}registerVariableResolver(D,f,R,k){const a=A.a++;return this.b.set(a,{extension:D.identifier,data:{name:f,description:R},resolver:k}),this.c.$registerVariable(a,{name:f,description:R}),(0,y.$Qc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$eec=A}),define(Ae[225],Re([1,0,3]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class M{constructor(T){const A=T.getProxy(y.$gK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$mcc=M}),define(Ae[31],Re([1,0,15,7,8,24,3,18,14,68,41,281,2,6,4,17,104,26,47,37,59,54,58]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0;let r=class{#e;#t;#i;constructor(S,u,m){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$gK.MainThreadCommands),this.d=u,this.#i=m,this.#t=S.getProxy(A.$gK.MainThreadTelemetry),this.converter=new s(this,h=>{const P=this.c.get(h);return P?.result===w.Void?P:void 0},u),this.f=[{processArgument(h){return(0,f.$mh)(h)}},{processArgument(h){return(0,T.$9m)(h,function(P){if(R.$ts.isIRange(P))return C.Range.to(P);if(k.$ss.isIPosition(P))return C.Position.to(P);if(R.$ts.isIRange(P.range)&&a.URI.isUri(P.uri))return C.location.to(P);if(P instanceof i.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...m)=>{const h=S.args.map((B,z)=>{if(!B.validate(m[z]))throw new Error(`Invalid argument '${B.name}' when running '${S.id}', received: ${typeof m[z]=="object"?JSON.stringify(m[z],null,"	"):m[z]} `);return B.convert(m[z])}),P=await this.executeCommand(S.internalId,...h);return S.result.convert(P,m,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$iK(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,m,h,P,B){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:m,thisArg:h,metadata:P,extension:B}),S&&this.#e.$registerCommand(u),new M.$iK(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,m){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let h=!1;const P=(0,T.$9m)(u,function(B){if(B instanceof M.$jK)return C.Position.from(B);if(B instanceof M.$kK)return C.Range.from(B);if(B instanceof M.$uK)return C.location.from(B);if(M.$FL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return h=!0,i.$be.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return h=!0,i.$be.wrap(B);if(B instanceof i.$be)return h=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(S,h?new c.$qv(P):P,m);return(0,f.$mh)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(S,u,!1);throw B}}}async h(S,u,m){const h=this.b.get(S);if(!h)throw new Error("Unknown command");const{callback:P,thisArg:B,metadata:z}=h;if(z?.args)for(let V=0;V<z.args.length;V++)try{(0,y.$Pf)(u[V],z.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${z.args[V].name}' - ${z.args[V].description}`)}const j=E.$Jd.create();try{return await P.apply(B,u)}catch(V){if(S===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...u);N&&(S=N.command)}if(this.d.error(V,S,h.extension?.identifier),!m)throw V;if(h.extension?.identifier){const N=this.#i.onExtensionError(h.extension.identifier,V);this.d.trace("forwarded error to extension?",N,h.extension?.identifier)}throw new class extends Error{constructor(){super((0,p.$Ai)(V)),this.id=S,this.source=h.extension?.displayName??h.extension?.name}}}finally{this.j(h,S,j.elapsed())}}j(S,u,m){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$jo(u),duration:m})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const m=this.b.get(S);return m?(u=u.map(h=>this.f.reduce((P,B)=>B.processArgument(P,m.extension?.identifier),h)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(m=>m[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,m]of this.b){const{metadata:h}=m;h&&(S[u]=h)}return Promise.resolve(S)}};e.$CM=r,e.$CM=r=qe([Ve(0,g.$hM),Ve(1,D.$0i),Ve(2,n.$BM)],r),e.$DM=(0,$.$Ph)("IExtHostCommands");class s{constructor(S,u,m){this.d=S,this.f=u,this.g=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const m={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return m;const h=this.f(S.command);if(h)m.id=h.internalId,m.arguments=h.args.map((P,B)=>P.convert(S.arguments&&S.arguments[B]));else if((0,l.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),u.add((0,b.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return m}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$EM=s;class o{static{this.Uri=new o("uri","Uri of a text document",S=>a.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$jK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$kK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$lK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(m=>S.validate(m)),u=>u.map(m=>S.convert(m)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$EK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$YL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$uM,C.TestItem.from)}constructor(S,u,m,h){this.name=S,this.description=u,this.validate=m,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$FM=o;class w{static{this.Void=new w("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$GM=w;class d{constructor(S,u,m,h,P){this.id=S,this.internalId=u,this.description=m,this.args=h,this.result=P}}e.$HM=d}),define(Ae[226],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;const a=[new f.$HM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of DocumentHighlight-instances.",$(R.DocumentHighlight.to))),new f.$HM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$FM.Uri],new f.$GM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Kb)(t))return;class c extends k.$zK{static to(E){const v=new c(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new k.$uK(i[0],R.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=R.Range.to(E.selectionRange),v.children=E.children?E.children.map(c.to):[],v}}return t.map(c.to)})),new f.$HM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$FM.Uri,new f.$FM("options","Formatting options",t=>!0,t=>t)],new f.$GM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$HM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$FM.Uri,f.$FM.Range,new f.$FM("options","Formatting options",t=>!0,t=>t)],new f.$GM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$HM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$FM.Uri,f.$FM.Position,new f.$FM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$FM("options","Formatting options",t=>!0,t=>t)],new f.$GM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$HM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$HM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$HM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$HM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$HM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of Location-instances.",$(R.location.to))),new f.$HM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of Hover-instances.",$(R.Hover.to))),new f.$HM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$FM.Uri,new f.$FM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$jK.isPosition(i)),t=>t.map(R.Position.from))],new f.$GM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const p of i.reverse())c=new k.$DK(R.Range.to(p),c);return c}))),new f.$HM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$FM.String.with("query","Search string")],new f.$GM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new f.$HM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new f.$HM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$FM.CallHierarchyItem],new f.$GM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new f.$HM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$FM.CallHierarchyItem],new f.$GM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new f.$HM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new f.$HM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$FM.Uri,f.$FM.Position,f.$FM.String.with("newName","The new symbol name")],new f.$GM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new f.$HM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$FM.Uri,f.$FM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$GM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new f.$HM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$FM.Uri],new f.$GM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$xL(t.tokenTypes,t.tokenModifiers)})),new f.$HM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$FM.Uri],new f.$GM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$W0)(t);if(i.type==="full")return new k.$zL(i.data,void 0)})),new f.$HM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$FM.Uri,f.$FM.Range.optional()],new f.$GM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$xL(t.tokenTypes,t.tokenModifiers)})),new f.$HM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$FM.Uri,f.$FM.Range],new f.$GM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$W0)(t);if(i.type==="full")return new k.$zL(i.data,void 0)})),new f.$HM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$FM.Uri,f.$FM.Position,f.$FM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$FM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$GM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new k.$PK([]);const p=t.suggestions.map(E=>R.CompletionItem.to(E,c));return new k.$PK(p,t.incomplete)})),new f.$HM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$FM.Uri,f.$FM.Position,f.$FM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$GM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new f.$HM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$FM.Uri,f.$FM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$GM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>$(p=>new k.$HK(R.Range.to(p.range),p.command&&c.fromInternal(p.command)))(t))),new f.$HM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$FM.Uri,new f.$FM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$kK.isRange(t),t=>k.$lK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),f.$FM.String.with("kind","Code action kind to return code actions for").optional(),f.$FM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$GM("A promise that resolves to an array of Command-instances.",(t,i,c)=>$(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(p.command)}else{const E=new k.$BK(p.title,p.kind?new k.$CK(p.kind):void 0);return p.edit&&(E.edit=R.WorkspaceEdit.to(p.edit)),p.command&&(E.command=c.fromInternal(p.command)),E.isPreferred=p.isPreferred,E}})(t))),new f.$HM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$FM.Uri],new f.$GM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$VK(R.Range.to(i.range),R.Color.to(i.color))):[])),new f.$HM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$FM("color","The color to show and insert",t=>t instanceof k.$UK,R.Color.from),new f.$FM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new f.$GM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new f.$HM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$FM.Uri,f.$FM.Range],new f.$GM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(R.InlayHint.to.bind(void 0,c)))),new f.$HM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$FM.Uri],new f.$GM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new f.$HM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$GM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new f.$HM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$FM.Uri,f.$FM.Range,new f.$FM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$kK,t=>R.InlineValueContext.from(t))],new f.$GM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new f.$HM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$FM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$eU)(t,M.Schemas.http,M.Schemas.https),t=>t),new f.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),f.$FM.String.with("label","").optional()],f.$GM.Void),new f.$HM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$FM.Uri.with("resource","Resource to open"),f.$FM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],f.$GM.Void),new f.$HM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$FM.Uri.with("left","Left-hand side resource of the diff editor"),f.$FM.Uri.with("right","Right-hand side resource of the diff editor"),f.$FM.String.with("title","Human readable title for the diff editor").optional(),new f.$FM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],f.$GM.Void),new f.$HM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$FM.Uri,f.$FM.Position],new f.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$HM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$FM.TypeHierarchyItem],new f.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$HM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$FM.TypeHierarchyItem],new f.$GM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$HM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$FM.TestItem],f.$GM.Void),new f.$HM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$FM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$GM.Void),new f.$HM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$FM.String.with("name","The context key name"),new f.$FM("value","The context key value",()=>!0,t=>t)],f.$GM.Void),new f.$HM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$FM.Uri,f.$FM.StringArray,new f.$FM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new f.$GM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class b{static register(i){a.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Oi)}}e.$lcc=b;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const c of t)T.$et(c)?i.push(R.DefinitionLink.to(c)):i.push(R.location.to(c));return i}}),define(Ae[227],Re([1,0,12,65,5,6,2,78,21,8,7,3,25]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;function b($,g,t){const i=$.getProxy(k.$gK.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$8l,g.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const I=this.b.get(d.handle);return I?I.value:d}else if(d&&d.$mid===7){const I=this.b.get(d.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.commentThreadHandle);return S?S.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);return S?d.$mid===8?S.value:{thread:S.value,text:d.text}:d}else if(d&&d.$mid===10){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.commentUniqueId,m=S.getCommentByUniqueId(u);return m||d}else if(d&&d.$mid===11){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.text,m=d.commentUniqueId,h=S.getCommentByUniqueId(m);return h?(typeof h.body=="string"?h.body=u:h.body=new R.$IK(u),h):d}return d}})}createCommentController(d,I,S){const u=c.a++,m=new E(d,u,I,S);this.b.set(m.handle,m);const h=this.c.get(d.identifier)||[];return h.push(m),this.c.set(d.identifier,h),m.value}async $createCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(d,I){this.b.get(d)?.$deleteCommentThread(I)}$provideCommentingRanges(d,I,S){const u=this.b.get(d);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(A.URI.revive(I));return(0,y.$Mg)(async()=>{const h=await u.commentingRangeProvider.provideCommentingRanges(m,S);let P;return Array.isArray(h)?P={ranges:h,fileComments:!1}:h?P={ranges:h.ranges||[],fileComments:h.fileComments||!1}:P=h??void 0,P}).then(h=>{let P;return h&&(P={ranges:h.ranges.map(B=>f.Range.from(B)),fileComments:h.fileComments}),P})}$toggleReaction(d,I,S,u,m){const h=this.b.get(d);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,y.$Mg)(()=>{const P=h.getCommentThread(I);if(P){const B=P.getCommentByUniqueId(u.uniqueIdInThread);if(h!==void 0&&B&&h.reactionHandler)return h.reactionHandler(B,r(m))}return Promise.resolve(void 0)})}}class p{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,I,S,u,m,h,P,B){this.m=I,this.n=S,this.o=u,this.p=m,this.q=h,this.extensionDescription=P,this.r=B,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Tc,this.l.value=new T.$Rc,this.n===void 0&&(this.n=`${d}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,f.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(j){z.range=j},get comments(){return z.comments},set comments(j){z.comments=j},get collapsibleState(){return z.collapsibleState},set collapsibleState(j){z.collapsibleState=j},get canReply(){return z.canReply},set canReply(j){z.canReply=j},get contextValue(){return z.contextValue},set contextValue(j){z.contextValue=j},get label(){return z.label},set label(j){z.label=j},get state(){return z.state},set state(j){z.state=j},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Rc);const d=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};d("range")&&(I.range=f.Range.from(this.p)),d("label")&&(I.label=this.label),d("contextValue")&&(I.contextValue=this.contextValue??null),d("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),d("collapsibleState")&&(I.collapseState=s(this.g)),d("canReply")&&(I.canReply=this.canReply),d("state")&&(I.state=o(this.h)),d("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(d){for(const I of this.k){const S=I[0],u=I[1];if(d===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}qe([(0,M.$ih)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,I,S,u){this.f=d,this.g=I,this.h=S,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,S,u,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,P,B){return m.createCommentThread(h,P,B).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,I,S){I===void 0&&(0,a.$eF)(this.f,"fileComments");const u=new p(this.id,this.handle,void 0,d,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(d,I){const S=new p(this.id,this.handle,void 0,A.URI.revive(d),f.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(d,I){const S=this.a.get(d);S&&(S.range=f.Range.to(I))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function v(w,d,I,S){let u=I.get(d);return u||(u=++w.commentHandle,I.set(d,u)),d.state!==void 0&&(0,a.$eF)(S,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:u,body:typeof d.body=="string"?d.body:f.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(m=>n(m)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function n(w){return{label:w.label,iconPath:w.iconPath?f.$gM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function r(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function s(w){if(w!==void 0)switch(w){case R.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case R.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$ncc=b}),define(Ae[228],Re([1,0,24,3,27,17]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;let A=class{constructor(R,k){this.a=R.getProxy(M.$gK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,k){const a=this,b=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){a.e(R,k,b,arguments)}})}e(R,k,a,b){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(b,this.b)}),this.c&&this.f(R,a,b)}};e.$lec=A,e.$lec=A=qe([Ve(0,T.$hM),Ve(1,C.$xM)],A);const l=1e5;function D(f,R){const k=[];if(f.length)for(let a=0;a<f.length;a++){let b=f[a];if(typeof b>"u")b="undefined";else if(b instanceof Error){const $=b;$.stack?b=$.stack:b=$.toString()}k.push(b)}if(R){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,y.$_m)(k);return a.length>l?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,16,20,25]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0;let b=class{static{a=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(M.$gK.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=a.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(i,null);return}const E=(0,D.$3b)(p);if(E.length<=a.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(s=>({uri:s,rank:(0,f.$Ge)(s.path,"/")})),n=(0,D.$zb)(v,(s,o)=>s.rank-o.rank||(0,f.$Ue)(s.uri.path,o.uri.path)),r=[];e:for(const s of n){let o;for(const w of s){const d=(0,R.$mc)(w.uri.path);if(o!==d&&(o=d,r.push(w.uri)>=a.d))break e}}this.g.$onDidChange(i,r)});return new C.$iK(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const c=Object.create(null),{provider:p,extensionDescription:E}=this.f.get(g);return await Promise.all(t.map(async v=>{try{const{uri:n,id:r}=v,s=await Promise.resolve(p.provideFileDecoration(y.URI.revive(n),i));if(!s)return;try{C.$DL.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.$eF)(E,"codiconDecoration"),c[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$odc=b,e.$odc=b=a=qe([Ve(0,A.$hM),Ve(1,l.$0i)],b),e.$pdc=(0,T.$Ph)("IExtHostDecorations")}),define(Ae[229],Re([1,0,147,94,2,3,7,8,5,14,28,40]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0;class b{#e;#t;#i;constructor(t,i,c,p,E,v,n,r){this.d=t,this.e=i,this.f=c,this.g=p,this.h=E,this.c=!1,this.f=Math.max(p,c),this.#i=new R.$Ac(s=>v.getComparisonKey(s)),this.#e=n,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let v;t=[...t].sort(b.k);for(const n of t){const[r,s]=n;if((!v||r.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=r,c.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const o=this.#i.get(r);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const p=[];let E=0;for(const v of c){let n=[];const r=this.#i.get(v);if(r)if(r.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of r)if(w.severity===s[o]&&n.push({...l.Diagnostic.from(w),modelVersionId:this.h(v)})===this.g)break e;n.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,r.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(s=>({...l.Diagnostic.from(s),modelVersionId:this.h(v)}));if(p.push([v,n]),E+=n.length,E>this.f)break}this.#e.$changeMany(this.e,p)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,p]of this)t.call(i,c,p,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$fcc=b;let $=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const i=new R.$Ac;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,p){this.j=i,this.k=c,this.l=p,this.g=new Map,this.h=new D.$Rd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(T.$gK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:p,h:E,j:v,k:n,l:r}=this,s=new class{$changeMany(d,I){p.$changeMany(d,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,d,I.length===0?"CLEARING":I)}$clear(d){p.$clear(d),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,d)}dispose(){p.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a.c++;while(c.has(o))}return new class extends b{constructor(){super(i,o,a.e,a.d,d=>r.getDocument(d)?.version,n.extUri,s,E),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const p of this.g.values())p.forEach((E,v)=>{let n=i.get(E.toString());typeof n>"u"&&(n=c.length,i.set(E.toString(),n),c.push([E,[]])),c[n][1]=c[n][1].concat(...v)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,p=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$gcc=$,e.$gcc=$=a=qe([Ve(1,f.$0i),Ve(2,k.$ecc)],$)}),define(Ae[230],Re([1,0,2,3,25]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class T{constructor(l){this.a=l.getProxy(M.$gK.MainThreadDialogs)}showOpenDialog(l,D){return D?.allowUIResources&&(0,C.$eF)(l,"showLocal"),this.a.$showOpenDialog(D).then(f=>f?f.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(D=>D?y.URI.revive(D):void 0)}}e.$vcc=T}),define(Ae[231],Re([1,0,9,2,7,3,13,19,16]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class f{static{this.a=0}constructor(k,a,b){this.d=a,this.e=b,this.b=new Map,this.c=k.getProxy(T.$gK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const b=f.a++;this.b.set(b,a),this.c.$registerTextContentProvider(b,k);let $;return typeof a.onDidChange=="function"&&($=a.onDidChange(g=>{if(g.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const c=(0,D.$Pe)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(g,t)},y.$1)})),new C.$iK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(k,a){const b=this.b.get(k);return b?Promise.resolve(b.provideTextDocumentContent(M.URI.revive(a),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$wcc=f}),define(Ae[232],Re([1,0,5,6,2,3,100,8,15,24,7,9]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=void 0;class a{constructor($,g){this.a=new y.$Nd({onListenerError:k.$2}),this.b=new y.$Nd({onListenerError:k.$2}),this.c=new y.$Nd({onListenerError:k.$2}),this.d=new y.$Nd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Rc,this.h=new Map,this.f=$.getProxy(T.$gK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const g=this.g.getDocument($);if(g)return g}getDocument($){const g=this.getDocumentData($);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return g.document}ensureDocumentData($){const g=this.g.getDocument($);if(g)return Promise.resolve(g);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const c=C.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(c))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(g=>C.URI.revive(g))}$acceptModelLanguageChanged($,g){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved($){const g=C.URI.revive($),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,g){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,g,t){const i=C.URI.revive($),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(g);let p;g.isUndoing?p=R.TextDocumentChangeReason.Undo:g.isRedoing&&(p=R.TextDocumentChangeReason.Redo),this.c.fire((0,f.$8m)({document:c.document,contentChanges:g.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:p}))}setWordDefinitionFor($,g){(0,A.$jM)($,g)}}e.$ccc=a}),define(Ae[60],Re([1,0,52,5,6,2,4,3,100,17,105,8,14,28,13,66,42]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new M.$Nd,this.e=new M.$Nd,this.f=new M.$Nd,this.g=new M.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],n=[],r=[];if(E.removedDocuments)for(const s of E.removedDocuments){const o=T.URI.revive(s),w=this.c.get(o);w?.unref()&&(this.c.delete(o),v.push(w.value))}if(E.addedDocuments)for(const s of E.addedDocuments){const o=T.URI.revive(s.uri);let w=this.c.get(o);if(w&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new D.$kM(this.h.getProxy(l.$gK.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,w),n.push(w.value)),w.ref()}if(E.removedEditors)for(const s of E.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&r.push(o)}if(E.addedEditors)for(const s of E.addedEditors){const o=T.URI.revive(s.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const w=this.c.get(o).value,d=new R.$qM(s.id,this.h.getProxy(l.$gK.MainThreadTextEditors),this.i,new t.$V(()=>w.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(I=>k.Range.to(I)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,d)}E.newActiveEditor!==void 0&&(y.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Nc)(v),(0,C.$Nc)(r),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(n),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return g.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$rM=c,e.$rM=c=qe([Ve(0,f.$hM),Ve(1,a.$0i)],c),e.$sM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,15,233]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=e.$tdc=void 0,e.$tdc=(0,A.$Ph)("IExtHostEditorTabs");class k{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$ZL(C.URI.revive(this.b.input.uri));case 2:return new l.$1L(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$2L(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$3L(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$4L(this.b.input.viewType);case 4:return new l.$5L(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$6L(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$7L;case 9:return new l.$8L(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new T.$Nd,this.c=new T.$Nd,this.e=[],this.a=t.getProxy(M.$gK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,f.$Jf)(t.e.find(E=>E.groupId===c)?.apiObject)},close:async(c,p)=>{const E=Array.isArray(c)?c:[c];return E.length?$(E[0])?this.j(E,p):this.i(E,p):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),c=new Set(t.map(s=>s.groupId)),p=(0,R.$K)(i,c),E=this.e.filter(s=>p.removed.includes(s.groupId)).map(s=>s.apiObject),v=[],n=[];this.e=t.map(s=>{const o=new a(s,()=>this.d);return p.added.includes(o.groupId)?v.push(o.apiObject):n.push(o.apiObject),o});const r=(0,f.$Jf)(t.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:v,closed:E,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(p=>p.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const p of t){const E=this.g(p);if(!E)throw new Error("Tab close: Invalid tab not found!");c.push(E.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const p of t){const E=this.h(p);if(!E)throw new Error("Group close: Invalid group not found!");c.push(E.groupId)}return this.a.$closeGroup(c,i)}};e.$udc=b,e.$udc=b=qe([Ve(0,D.$hM)],b);function $(g){return g.tabs!==void 0}}),define(Ae[234],Re([1,0,3,7]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$gK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const R=await f.provideEmbeddingVector(l,D);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,l,D){const f=this.b;return this.b++,this.a.set(f,D),this.c.$registerAiEmbeddingVectorProvider(l,f),new M.$iK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$gec=C}),define(Ae[235],Re([1,0,2,3,6,7,8,282,16,26,25,50]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class a{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,c,p=14,E=14;for(const v of g){let n=i?(0,D.$4e)(i,v):0;for(n===0?c=1:c=E;n<v.length;n++)n+1===v.length?(p=E,E=9):E+=1,t.push([c,v.toUpperCase().charCodeAt(n),E]),t.push([c,v.toLowerCase().charCodeAt(n),E]),c=E;i=v,E=p}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$YY(t)}}provideDocumentLinks(g){this.c();const t=[],i=l.$ZY.computeLinks({getLineContent(c){return g.lineAt(c-1).text},getLineCount(){return g.lineCount}},this.b);for(const c of i){const p=A.DocumentLink.to(c);p.target&&t.push(p)}return t}}class b{constructor(g,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(M.$gK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,c={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const p=this.h++;this.b.add(t),this.d.add(t),this.c.set(p,i);let E=2;c.isCaseSensitive&&(E+=1024),c.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$eF)(g,"fsChunks"),E+=4);let v;c.isReadonly&&(0,k.$5j)(c.isReadonly)&&((0,R.$eF)(g,"readonlyMessage"),v={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(p,t,E,v).catch(r=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=i.onDidChangeFile(r=>{const s=[];for(const o of r){const{uri:w,type:d}=o;if(w.scheme!==t)continue;let I;switch(d){case T.FileChangeType.Changed:I=0;break;case T.FileChangeType.Created:I=1;break;case T.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:w,type:I})}this.a.$onFileSystemChange(p,s)});return(0,C.$Qc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:c,size:p,permissions:E}=g;return{type:t,ctime:i,mtime:c,size:p,permissions:E}}$stat(g,t){return Promise.resolve(this.l(g).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(y.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(y.URI.revive(t))).then(i=>f.$be.wrap(i))}$writeFile(g,t,i,c){return Promise.resolve(this.l(g).writeFile(y.URI.revive(t),i.buffer,c))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(y.URI.revive(t),i))}$rename(g,t,i,c){return Promise.resolve(this.l(g).rename(y.URI.revive(t),y.URI.revive(i),c))}$copy(g,t,i,c){const p=this.l(g);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(y.URI.revive(t),y.URI.revive(i),c))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(y.URI.revive(t)))}$watch(g,t,i,c){const p=this.l(g).watch(y.URI.revive(i),c);this.f.set(t,p)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const c=this.l(g);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(y.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,c){const p=this.l(g);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const E=f.$be.alloc(c);return Promise.resolve(p.read(t,i,E.buffer,0,c)).then(v=>E.slice(0,v))}$write(g,t,i,c){const p=this.l(g);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(t,i,c.buffer,0,c.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$3cc=b}),define(Ae[62],Re([1,0,3,39,7,26,4,17,40,6,12,23,13]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0;let $=b=class{constructor(t,i){this.b=new Map,this.c=new R.$3g,this.a=t.getProxy(y.$gK.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(p){try{let E;const v=c.b.get(p.scheme);return v?(await c.a.$ensureActivation(p.scheme),E=await v.impl.stat(p)):E=await c.a.$stat(p),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){b.e(E)}},async readDirectory(p){try{const E=c.b.get(p.scheme);return E?(await c.a.$ensureActivation(p.scheme),(await E.impl.readDirectory(p)).slice()):await c.a.$readdir(p)}catch(E){return b.e(E)}},async createDirectory(p){try{const E=c.b.get(p.scheme);return E&&!E.isReadonly?(await c.a.$ensureActivation(p.scheme),await c.d(E.impl,E.extUri,p)):await c.a.$mkdir(p)}catch(E){return b.e(E)}},async readFile(p){try{const E=c.b.get(p.scheme);return E?(await c.a.$ensureActivation(p.scheme),(await E.impl.readFile(p)).slice()):(await c.a.$readFile(p)).buffer}catch(E){return b.e(E)}},async writeFile(p,E){try{const v=c.b.get(p.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(p.scheme),await c.d(v.impl,v.extUri,v.extUri.dirname(p)),await c.c.queueFor(p).queue(()=>Promise.resolve(v.impl.writeFile(p,E,{create:!0,overwrite:!0})))):await c.a.$writeFile(p,T.$be.wrap(E))}catch(v){return b.e(v)}},async delete(p,E){try{const v=c.b.get(p.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(p.scheme),await v.impl.delete(p,{recursive:!1,...E})):await c.a.$delete(p,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return b.e(v)}},async rename(p,E,v){try{return await c.a.$rename(p,E,{overwrite:!1,...v})}catch(n){return b.e(n)}},async copy(p,E,v){try{return await c.a.$copy(p,E,{overwrite:!1,...v})}catch(n){return b.e(n)}},isWritableFileSystem(p){const E=i.getCapabilities(p);if(typeof E=="number")return!(E&2048)}})}async d(t,i,c){const p=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&M.FileType.Directory))throw C.$vL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$ok(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;p.push(i.basename(c)),c=i.dirname(c)}for(let E=p.length-1;E>=0;E--){c=i.joinPath(c,p[E]);try{await t.createDirectory(c)}catch(v){if(M.$ok(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$vL)throw t;if(t instanceof M.$kk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$vL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$vL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$vL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$vL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$vL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$vL.Unavailable(t.message);default:throw new C.$vL(t.message,t.name)}if(!(t instanceof Error))throw new C.$vL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$vL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$vL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$vL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$vL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$vL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$vL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$vL.Unavailable(t.message);default:throw new C.$vL(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?k.$lg:k.$ng,isReadonly:!!c?.isReadonly}),(0,f.$Qc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$lg}};e.$Icc=$,e.$Icc=$=b=qe([Ve(0,l.$hM),Ve(1,D.$ecc)],$),e.$Jcc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(Ae[236],Re([1,0,5,38,2,3,8,7,42]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,$,g,t,i,c){this.a=Math.random(),this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.h=0,c?.ignoreCreateEvents&&(this.h+=1),c?.ignoreChangeEvents&&(this.h+=2),c?.ignoreDeleteEvents&&(this.h+=4);const p=(0,M.$wj)(i),E=typeof i=="string",v=t(n=>{if(!(typeof n.session=="number"&&n.session!==this.a)){if(!c?.ignoreCreateEvents)for(const r of n.created){const s=C.URI.revive(r);p(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.b.fire(s)}if(!c?.ignoreChangeEvents)for(const r of n.changed){const s=C.URI.revive(r);p(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.c.fire(s)}if(!c?.ignoreDeleteEvents)for(const r of n.deleted){const s=C.URI.revive(r);p(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=l.$iK.from(this.i(b,g,i,c),this.b,this.c,this.d,v)}i(b,$,g,t){const i=l.$iK.from();if(typeof g=="string")return i;const c=b.getProxy(T.$gK.MainThreadFileSystemEventService);let p=!1;return(g.pattern.includes(M.$sj)||g.pattern.includes(M.$tj))&&(p=!0),c.$watch($.identifier.value,this.a,g.baseUri,{recursive:p,excludes:t?.excludes??[]}),l.$iK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(b){this.a=b,this.session=this.a.session,this.b=new D.$V(()=>this.a.created.map(C.URI.revive)),this.c=new D.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new D.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(b,$,g){this.j=b,this.k=$,this.l=g,this.a=new y.$Nd,this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.g=new y.$Pd,this.h=new y.$Pd,this.i=new y.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,$,g,t){return new f(this.j,b,$,this.a.event,A.GlobPattern.from(g),t)}$onFileEvent(b){this.a.fire(new R(b))}$onDidRunFileOperation(b,$){switch(b){case 2:this.b.fire(Object.freeze({files:$.map(g=>({oldUri:C.URI.revive(g.source),newUri:C.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(g=>C.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(g=>C.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,$){return(g,t,i)=>{const c=function(E){g.call(t,E)};return c.extension=b,$.event(c,void 0,i)}}async $onWillRunFileOperation(b,$,g,t){switch(b){case 2:return await this.n(this.g,{files:$.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},g,t);case 1:return await this.n(this.i,{files:$.map(i=>C.URI.revive(i.target))},g,t);case 0:case 3:return await this.n(this.h,{files:$.map(i=>C.URI.revive(i.target))},g,t)}}async n(b,$,g,t){const i=new Set,c=[];if(await b.fireAsync($,t,async(E,v)=>{const n=Date.now(),r=await Promise.resolve(E);r instanceof l.$sK&&(c.push([v.extension,r]),i.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-n>g&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const p={edits:[]};for(const[,E]of c){const{edits:v}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});p.edits=p.edits.concat(v)}return{edit:p,extensionNames:Array.from(i)}}}e.$4cc=k}),define(Ae[237],Re([1,0,6,2,3,8,7,31,12]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class f{static{this.a=0}constructor(b,$){this.extension=b,this.provider=$,this.handle=f.a++}}class R{constructor(b){this.session=b,this.responses=[]}}class k{static{this.a=0}constructor(b,$,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(C.$gK.MainThreadInlineChat),$.registerApiCommand(new l.$HM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$FM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?T.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?T.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?T.Position.from(i.position):void 0}})],l.$GM.Void))}registerProvider(b,$,g){const t=new f(b,$);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g.label,b.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,$,g,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this.f.getDocument(M.URI.revive($)),p=T.Selection.to(g),E=await i.provider.prepareInteractiveEditorSession({document:c,selection:p},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(p))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=k.a++;return this.d.set(v,new R(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:T.Range.from(E.wholeRange),message:E.message}}async $provideResponse(b,$,g,t){const i=this.b.get(b);if(!i)return;const c=this.d.get($.id);if(!c)return;const p={prompt:g.prompt,selection:T.Selection.to(g.selection),wholeRange:T.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let E=!1;const v={report:async d=>{if(!g.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:d.message,edits:d.edits?.map(T.TextEdit.from),slashCommand:d.slashCommand?.command})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(c.session,p,v,t));let r;try{r=await(0,D.$Ig)(n,t)}finally{E=!0}if(!r)return;const s=c.responses.push(r)-1,o={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(k.h(r))return{...o,id:s,type:"message",message:T.MarkdownString.from(r.contents)};const{edits:w}=r;return w instanceof A.$sK?{...o,id:s,type:"bulkEdit",edits:T.WorkspaceEdit.from(w)}:{...o,id:s,type:"editorEdit",edits:w.map(T.TextEdit.from)}}$handleFeedback(b,$,g,t){const i=this.b.get(b),c=this.d.get($),p=c?.responses[g];if(i&&p){const E=T.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(c.session,p,E)}}$releaseSession(b,$){}static h(b){return typeof b=="object"&&typeof b.contents=="object"}}e.$$dc=k}),define(Ae[238],Re([1,0,2,31]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class C{constructor(A,l,D,f,R){this.a=l,this.b=D,this.c=f;const k=new M.$HM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$FM("showOptions","Show Options",a=>!0,a=>a),new M.$FM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$FM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$FM("title","Interactive editor title",a=>!0,a=>a)],new M.$GM("Notebook and input URI",a=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const b=this.a.getEditorById(a.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(a.notebookUri),inputUri:y.URI.revive(a.inputUri),notebookEditor:b.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:y.URI.revive(a.notebookUri),inputUri:y.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,l,D,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$7dc=C}),define(Ae[239],Re([1,0,3,7]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$gK.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const f=await D.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,l){const D=A.identifier.value;return this.a.set(D,l),this.b.$registerIssueUriRequestHandler(D),new M.$iK(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$aec=C}),define(Ae[240],Re([1,0,6,3]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$gK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,y.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$ndc=C}),define(Ae[241],Re([1,0,2,24,8,7,78,3,16,41,18,15,283,19,21,6,91,88,74,59,9,12,25,149]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class s{constructor(F,K){this.d=F,this.e=K}async provideDocumentSymbols(F,K){const G=this.d.getDocument(F),J=await this.e.provideDocumentSymbols(G,K);if(!(0,R.$Kb)(J))return J[0]instanceof T.$AK?J.map(C.DocumentSymbol.from):s.f(J)}static f(F){F=F.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const K=[],G=[];for(const J of F){const q={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:J.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),K.push(q);break}const x=G[G.length-1];if(f.$ts.containsRange(x.range,q.range)&&!f.$ts.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,K,G){this.g=F,this.h=K,this.j=G,this.e=new c.$bcc("CodeLens"),this.f=new Map}async provideCodeLenses(F,K){const G=this.g.getDocument(F),J=await this.j.provideCodeLenses(G,K);if(!J||K.isCancellationRequested)return;const q=this.e.add(J),x=new g.$Rc;this.f.set(q,x);const ce={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ce.lenses.push({cacheId:[q,Ne],range:C.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ce}async resolveCodeLens(F,K){const G=F.cacheId&&this.e.get(...F.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,K),J||(J=G),K.isCancellationRequested)return;const q=F.cacheId&&this.f.get(F.cacheId[0]);if(q)return F.command=this.h.toInternal(J.command??o.d,q),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function w(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class d{constructor(F,K){this.d=F,this.e=K}async provideDefinition(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideDefinition(J,q,G);return w(x)}}class I{constructor(F,K){this.d=F,this.e=K}async provideDeclaration(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideDeclaration(J,q,G);return w(x)}}class S{constructor(F,K){this.d=F,this.e=K}async provideImplementation(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideImplementation(J,q,G);return w(x)}}class u{constructor(F,K){this.d=F,this.e=K}async provideTypeDefinition(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideTypeDefinition(J,q,G);return w(x)}}class m{constructor(F,K){this.d=F,this.e=K}async provideHover(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideHover(J,q,G);if(!(!x||(0,R.$Kb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new T.$kK(q,q)),C.Hover.from(x)}}class h{constructor(F,K){this.d=F,this.e=K}async provideEvaluatableExpression(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return C.EvaluatableExpression.from(x)}}class P{constructor(F,K){this.d=F,this.e=K}async provideInlineValues(F,K,G,J){const q=this.d.getDocument(F),x=await this.e.provideInlineValues(q,C.Range.to(K),C.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ce=>C.InlineValue.from(ce))}}class B{constructor(F,K){this.d=F,this.e=K}async provideDocumentHighlights(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class z{constructor(F,K){this.d=F,this.e=K}async provideLinkedEditingRanges(F,K,G){const J=this.d.getDocument(F),q=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Hb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class j{constructor(F,K){this.d=F,this.e=K}async provideReferences(F,K,G,J){const q=this.d.getDocument(F),x=C.Position.to(K),ce=await this.e.provideReferences(q,x,G,J);if(Array.isArray(ce))return ce.map(C.location.from)}}class V{static{this.d=1e3}constructor(F,K,G,J,q,x,ce){this.g=F,this.h=K,this.j=G,this.k=J,this.l=q,this.m=x,this.n=ce,this.e=new c.$bcc("CodeAction"),this.f=new Map}async provideCodeActions(F,K,G,J){const q=this.g.getDocument(F),x=a.$vs.isISelection(K)?C.Selection.to(K):C.Range.to(K),ce=[];for(const Ye of this.j.getDiagnostics(F))if(x.intersection(Ye.range)&&ce.push(Ye)>V.d)break;const Ne={diagnostics:ce,only:G.only?new T.$CK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(q,x,Ne,J);if(!(0,R.$Lb)(Ue)||J.isCancellationRequested)return;const Qe=this.e.add(Ue),Ge=new g.$Rc;this.f.set(Qe,Ge);const xe=[];for(let Ye=0;Ye<Ue.length;Ye++){const _e=Ue[Ye];_e&&(V.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Ge)})):(Ne.only&&(_e.kind?Ne.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Qe,Ye],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Ge),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,n.$dF)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Qe,actions:xe}}async resolveCodeAction(F,K){const[G,J]=F,q=this.e.get(G,J);if(!q||V.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,K)??q;let ce;x.edit&&(ce=C.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const Ue=this.f.get(G);Ue&&(Ne=this.h.toInternal(x.command,Ue))}return{edit:ce,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class N{static toInternalProviderId(F,K){return F+"."+K}constructor(F,K,G,J,q){this.d=F,this.e=K,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(F,K,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(F),x=K.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new E.$$});if(await this.f.prepareDocumentPaste(q,x,ce,J),J.isCancellationRequested)return;const Ne=Array.from(ce).filter(([,Ue])=>!(Ue instanceof T.$9K));return C.DataTransfer.from(Ne)}async providePasteEdits(F,K,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ce=G.map(Qe=>C.Range.to(Qe)),Ne=C.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ce,Ne,q);if(Ue)return{label:Ue.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:N.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class O{constructor(F,K){this.d=F,this.e=K}async provideDocumentFormattingEdits(F,K,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentFormattingEdits(J,K,G);if(Array.isArray(q))return q.map(C.TextEdit.from)}}class se{constructor(F,K){this.d=F,this.e=K}async provideDocumentRangeFormattingEdits(F,K,G,J){const q=this.d.getDocument(F),x=C.Range.to(K),ce=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,K,G,J){(0,k.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(F),x=K.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class X{constructor(F,K){this.d=F,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,K,G,J,q){const x=this.d.getDocument(F),ce=C.Position.to(K),Ne=await this.e.provideOnTypeFormattingEdits(x,ce,G,J,q);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class Ee{constructor(F,K){this.e=F,this.f=K,this.d=new c.$bcc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,K){const G=await this.e.provideWorkspaceSymbols(F,K);if(!(0,R.$Lb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ce=G[x];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}q.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(F,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this.d.get(...F.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,K);return J&&(0,M.$0m)(F,C.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Pe{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,K,G){this.d=F,this.e=K,this.f=G}async provideRenameEdits(F,K,G,J){const q=this.d.getDocument(F),x=C.Position.to(K);try{const ce=await this.e.provideRenameEdits(q,x,G,J);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ne=Pe.g(ce);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(F),q=C.Position.to(K);try{const x=await this.e.prepareRename(J,q,G);let ce,Ne;if(T.$kK.isRange(x)?(ce=x,Ne=J.getText(x)):(0,k.$Af)(x)&&(ce=x.range,Ne=x.placeholder),!ce||!Ne)return;if(ce.start.line>q.line||ce.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ne}}catch(x){const ce=Pe.g(x);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Se{constructor(F,K){this.resultId=F,this.tokens=K}}class fe{constructor(F,K){this.f=F,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,K,G){const J=this.f.getDocument(F),q=K!==0?this.d.get(K):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(K),x?(x=fe.h(x),this.o(fe.n(q,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return fe.j(F)?fe.k(F)?F:new T.$zL(new Uint32Array(F.data),F.resultId):fe.l(F)?fe.m(F)?F:new T.$BL(F.edits.map(K=>new T.$AL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const K of F.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(F,K){if(!fe.j(K)||!F||!F.tokens)return K;const G=F.tokens,J=G.length,q=K.data,x=q.length;let ce=0;const Ne=Math.min(J,x);for(;ce<Ne&&G[ce]===q[ce];)ce++;if(ce===J&&ce===x)return new T.$BL([],K.resultId);let Ue=0;const Qe=Ne-ce;for(;Ue<Qe&&G[J-Ue-1]===q[x-Ue-1];)Ue++;return new T.$BL([{start:ce,deleteCount:J-ce-Ue,data:q.subarray(ce,x-Ue)}],K.resultId)}o(F,K){if(fe.j(F)){const G=this.e++;return this.d.set(G,new Se(F.resultId,F.data)),(0,t.$V0)({id:G,type:"full",data:F.data})}if(fe.l(F)){const G=this.e++;return fe.j(K)?this.d.set(G,new Se(K.resultId,K.data)):this.d.set(G,new Se(F.resultId)),(0,t.$V0)({id:G,type:"delta",deltas:(F.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class ye{constructor(F,K){this.d=F,this.e=K}async provideDocumentRangeSemanticTokens(F,K,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentRangeSemanticTokens(J,C.Range.to(K),G);return q?this.f(q):null}f(F){return(0,t.$V0)({id:0,type:"full",data:F.data})}}class ue{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,K,G,J,q){this.f=F,this.g=K,this.h=G,this.j=J,this.k=q,this.d=new c.$bcc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,K,G,J){const q=this.f.getDocument(F),x=C.Position.to(K),ce=q.getWordRangeAtPosition(x)||new T.$kK(x,x),Ne=ce.with({end:x}),Ue=new p.$Jd,Qe=await this.h.provideCompletionItems(q,x,J,C.CompletionContext.to(G));if(!Qe||J.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new T.$PK(Qe):Qe,xe=ue.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new g.$Rc;this.e.set(xe,Ye);const _e=[],it={x:xe,b:_e,a:{replace:C.Range.from(ce),insert:C.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],st=this.l(ze,[xe,tt],Ne,ce);_e.push(st)}return it}async resolveCompletionItem(F,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...F);if(!G)return;const J=this.l(G,F),q=await this.h.resolveCompletionItem(G,K);if(!q)return;const x=this.l(q,F);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,M.$$m)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,K,G,J){const q=this.e.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,q),ce={x:K,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=F.textEdit.newText):typeof F.insertText=="string"?ce.h=F.insertText:F.insertText instanceof T.$tK&&(ce.h=F.insertText.value,ce.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),T.$kK.isRange(Ne)?ce.j=C.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ce.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),ce}}class ae{async provideInlineCompletions(F,K,G,J){}disposeCompletions(F){}handleDidShowCompletionItem(F,K,G){}handlePartialAccept(F,K,G){}}class ve extends ae{constructor(F,K,G,J){super(),this.f=F,this.g=K,this.h=G,this.j=J,this.d=new _,this.e=(0,n.$dF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$dF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,K,G,J){const q=this.g.getDocument(F),x=C.Position.to(K),ce=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ce||J.isCancellationRequested)return;const Ne=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ye,_e)=>{let it;Ye.command&&(Ge||(Ge=new g.$Rc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(Ge||(Ge=new g.$Rc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,K,G){const J=this.d.get(F)?.items[K];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(F,K,G){const J=this.d.get(F)?.items[K];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const K=this.e++;return this.d.set(K,F),K}disposeReferenceId(F){const K=this.d.get(F);return this.d.delete(F),K}get(F){return this.d.get(F)}}class W{constructor(F,K){this.e=F,this.f=K,this.d=new c.$bcc("SignatureHelp")}async provideSignatureHelp(F,K,G,J){const q=this.e.getDocument(F),x=C.Position.to(K),ce=this.g(G),Ne=await this.f.provideSignatureHelp(q,x,J,ce);if(Ne){const Ue=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:Ue}}}g(F){let K;if(F.activeSignatureHelp){const G=C.SignatureHelp.to(F.activeSignatureHelp),J=this.d.get(F.activeSignatureHelp.id,0);J?(K=J,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...F,activeSignatureHelp:K}}releaseSignatureHelp(F){this.d.delete(F)}}class Z{constructor(F,K,G,J,q){this.f=F,this.g=K,this.h=G,this.j=J,this.k=q,this.d=new c.$bcc("InlayHints"),this.e=new Map}async provideInlayHints(F,K,G){const J=this.f.getDocument(F),q=C.Range.to(K),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(x);this.e.set(ce,new g.$Rc);const Ne={hints:[],cacheId:ce};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Ne.hints.push(this.m(x[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Ne}async resolveInlayHint(F,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.h.resolveInlayHint(G,K);if(J&&this.l(J))return this.m(J,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,K){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(K&&!K.contains(F.position))}m(F,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?J.label=F.label:J.label=F.label.map(q=>{const x={label:q.value};return x.tooltip=C.MarkdownString.fromStrict(q.tooltip),T.$uK.isLocation(q.location)&&(x.location=C.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class ee{constructor(F,K){this.e=F,this.f=K,this.d=new c.$bcc("DocumentLink")}async provideLinks(F,K){const G=this.e.getDocument(F),J=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(J)||J.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ee.g).map(C.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ce=0;ce<J.length;ce++){if(!ee.g(J[ce]))continue;const Ne=C.DocumentLink.from(J[ce]);Ne.cacheId=[q,ce],x.links.push(Ne)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.f.resolveDocumentLink(G,K);if(!(!J||!ee.g(J)))return C.DocumentLink.from(J)}releaseLinks(F){this.d.delete(F)}}class pe{constructor(F,K){this.d=F,this.e=K}async provideColors(F,K){const G=this.d.getDocument(F),J=await this.e.provideDocumentColors(G,K);return Array.isArray(J)?J.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,K,G){const J=this.d.getDocument(F),q=C.Range.to(K.range),x=C.Color.to(K.color),ce=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class $e{constructor(F,K){this.d=F,this.e=K}async provideFoldingRanges(F,K,G){const J=this.d.getDocument(F),q=await this.e.provideFoldingRanges(J,K,G);if(Array.isArray(q))return q.map(C.FoldingRange.from)}}class he{constructor(F,K,G){this.d=F,this.e=K,this.f=G}async provideSelectionRanges(F,K,G){const J=this.d.getDocument(F),q=K.map(C.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,R.$Lb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ne=0;Ne<q.length;Ne++){const Ue=[];ce.push(Ue);let Qe=q[Ne],Ge=x[Ne];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ce}}class De{constructor(F,K){this.f=F,this.g=K,this.d=new i.$mM(""),this.e=new Map}async prepareSession(F,K,G){const J=this.f.getDocument(F),q=C.Position.to(K),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideCallsTo(F,K,G){const J=this.j(F,K);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(F,K,G){const J=this.j(F,K);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(F){this.e.delete(F)}h(F,K){const G=this.e.get(F),J=C.CallHierarchyItem.from(K,F,G.size.toString(36));return G.set(J._itemId,K),J}j(F,K){return this.e.get(F)?.get(K)}}class ne{constructor(F,K){this.f=F,this.g=K,this.d=new i.$mM(""),this.e=new Map}async prepareSession(F,K,G){const J=this.f.getDocument(F),q=C.Position.to(K),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideSupertypes(F,K,G){const J=this.j(F,K);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(F,x))}async provideSubtypes(F,K,G){const J=this.j(F,K);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,K){const G=this.e.get(F),J=C.TypeHierarchyItem.from(K,F,G.size.toString(36));return G.set(J._itemId,K),J}j(F,K){return this.e.get(F)?.get(K)}}class le{static toInternalProviderId(F,K){return F+"."+K}constructor(F,K,G,J,q){this.d=F,this.e=K,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(F,K,G,J,q){const x=this.e.getDocument(K),ce=C.Position.to(G),Ne=C.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ce,Ne,q);if(Ue)return{label:Ue.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class ie{constructor(F,K){this.d=F,this.e=K}async provideMappedEdits(F,K,G,J){const q=y.URI.revive(F),x=this.d.getDocument(q),ce=G.documents.map(Qe=>Qe.map(Ge=>({uri:y.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(xe=>C.Range.to(xe))}))),Ne={documents:ce,selections:ce[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,K,Ne,J);return Ue?C.WorkspaceEdit.from(Ue):null}}class oe{constructor(F,K){this.adapter=F,this.extension=K}}class ge{static{this.d=0}constructor(F,K,G,J,q,x,ce,Ne){this.g=K,this.h=G,this.j=J,this.k=q,this.l=x,this.m=ce,this.n=Ne,this.f=new Map,this.e=F.getProxy(l.$gK.MainThreadLanguageFeatures)}o(F,K){return C.DocumentSelector.from(F,this.g,K)}p(F){return new T.$iK(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ge.d++}async s(F,K,G,J,q,x=!1){const ce=this.f.get(F);if(!ce||!(ce.adapter instanceof K))return J;const Ne=Date.now();x||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,E.$4)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,v.$Jg)(Ue,q):Ue}t(F,K){const G=this.q();return this.f.set(G,new oe(F,K)),G}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,K,G,J){const q=this.t(new s(this.h,G),F),x=J&&J.label||ge.u(F);return this.e.$registerDocumentSymbolProvider(q,this.o(K,F),x),this.p(q)}$provideDocumentSymbols(F,K,G){return this.s(F,s,J=>J.provideDocumentSymbols(y.URI.revive(K),G),void 0,G)}registerCodeLensProvider(F,K,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new oe(new o(this.h,this.j.converter,G),F)),this.e.$registerCodeLensSupport(J,this.o(K,F),q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=T.$iK.from(x,ce)}return x}$provideCodeLenses(F,K,G){return this.s(F,o,J=>J.provideCodeLenses(y.URI.revive(K),G),void 0,G)}$resolveCodeLens(F,K,G){return this.s(F,o,J=>J.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(F,K){this.s(F,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(F,K,G){const J=this.t(new d(this.h,G),F);return this.e.$registerDefinitionSupport(J,this.o(K,F)),this.p(J)}$provideDefinition(F,K,G,J){return this.s(F,d,q=>q.provideDefinition(y.URI.revive(K),G,J),[],J)}registerDeclarationProvider(F,K,G){const J=this.t(new I(this.h,G),F);return this.e.$registerDeclarationSupport(J,this.o(K,F)),this.p(J)}$provideDeclaration(F,K,G,J){return this.s(F,I,q=>q.provideDeclaration(y.URI.revive(K),G,J),[],J)}registerImplementationProvider(F,K,G){const J=this.t(new S(this.h,G),F);return this.e.$registerImplementationSupport(J,this.o(K,F)),this.p(J)}$provideImplementation(F,K,G,J){return this.s(F,S,q=>q.provideImplementation(y.URI.revive(K),G,J),[],J)}registerTypeDefinitionProvider(F,K,G){const J=this.t(new u(this.h,G),F);return this.e.$registerTypeDefinitionSupport(J,this.o(K,F)),this.p(J)}$provideTypeDefinition(F,K,G,J){return this.s(F,u,q=>q.provideTypeDefinition(y.URI.revive(K),G,J),[],J)}registerHoverProvider(F,K,G,J){const q=this.t(new m(this.h,G),F);return this.e.$registerHoverProvider(q,this.o(K,F)),this.p(q)}$provideHover(F,K,G,J){return this.s(F,m,q=>q.provideHover(y.URI.revive(K),G,J),void 0,J)}registerEvaluatableExpressionProvider(F,K,G,J){const q=this.t(new h(this.h,G),F);return this.e.$registerEvaluatableExpressionProvider(q,this.o(K,F)),this.p(q)}$provideEvaluatableExpression(F,K,G,J){return this.s(F,h,q=>q.provideEvaluatableExpression(y.URI.revive(K),G,J),void 0,J)}registerInlineValuesProvider(F,K,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new P(this.h,G),F);this.e.$registerInlineValuesProvider(x,this.o(K,F),q);let ce=this.p(x);if(q!==void 0){const Ne=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ce=T.$iK.from(ce,Ne)}return ce}$provideInlineValues(F,K,G,J,q){return this.s(F,P,x=>x.provideInlineValues(y.URI.revive(K),G,J,q),void 0,q)}registerDocumentHighlightProvider(F,K,G){const J=this.t(new B(this.h,G),F);return this.e.$registerDocumentHighlightProvider(J,this.o(K,F)),this.p(J)}$provideDocumentHighlights(F,K,G,J){return this.s(F,B,q=>q.provideDocumentHighlights(y.URI.revive(K),G,J),void 0,J)}registerLinkedEditingRangeProvider(F,K,G){const J=this.t(new z(this.h,G),F);return this.e.$registerLinkedEditingRangeProvider(J,this.o(K,F)),this.p(J)}$provideLinkedEditingRanges(F,K,G,J){return this.s(F,z,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(K),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?ge.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(F,K,G){const J=this.t(new j(this.h,G),F);return this.e.$registerReferenceSupport(J,this.o(K,F)),this.p(J)}$provideReferences(F,K,G,J,q){return this.s(F,j,x=>x.provideReferences(y.URI.revive(K),G,J,q),void 0,q)}registerCodeActionProvider(F,K,G,J){const q=new g.$Rc,x=this.t(new V(this.h,this.j.converter,this.k,G,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(K,F),{providedKinds:J?.providedCodeActionKinds?.map(ce=>ce.value),documentation:J?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,q)}))},ge.u(F),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(F,K,G,J,q){return this.s(F,V,x=>x.provideCodeActions(y.URI.revive(K),G,J,q),void 0,q)}$resolveCodeAction(F,K,G){return this.s(F,V,J=>J.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(F,K){this.s(F,V,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(F,K,G){const J=this.t(new O(this.h,G),F);return this.e.$registerDocumentFormattingSupport(J,this.o(K,F),F.identifier,F.displayName||F.name),this.p(J)}$provideDocumentFormattingEdits(F,K,G,J){return this.s(F,O,q=>q.provideDocumentFormattingEdits(y.URI.revive(K),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(F,K,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new se(this.h,G),F);return this.e.$registerRangeFormattingSupport(q,this.o(K,F),F.identifier,F.displayName||F.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(F,K,G,J,q){return this.s(F,se,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(K),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(F,K,G,J,q){return this.s(F,se,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(K),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(F,K,G,J){const q=this.t(new X(this.h,G),F);return this.e.$registerOnTypeFormattingSupport(q,this.o(K,F),J,F.identifier),this.p(q)}$provideOnTypeFormattingEdits(F,K,G,J,q,x){return this.s(F,X,ce=>ce.provideOnTypeFormattingEdits(y.URI.revive(K),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(F,K){const G=this.t(new Ee(K,this.l),F);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(F,K,G){return this.s(F,Ee,J=>J.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,K,G){return this.s(F,Ee,J=>J.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(F,K){this.s(F,Ee,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(F,K,G){const J=this.t(new Pe(this.h,G,this.l),F);return this.e.$registerRenameSupport(J,this.o(K,F),Pe.supportsResolving(G)),this.p(J)}$provideRenameEdits(F,K,G,J,q){return this.s(F,Pe,x=>x.provideRenameEdits(y.URI.revive(K),G,J,q),void 0,q)}$resolveRenameLocation(F,K,G,J){return this.s(F,Pe,q=>q.resolveRenameLocation(y.URI.revive(K),G,J),void 0,J)}registerDocumentSemanticTokensProvider(F,K,G,J){const q=this.t(new fe(this.h,G),F),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(K,F),J,x);let ce=this.p(q);if(x){const Ne=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ce=T.$iK.from(ce,Ne)}return ce}$provideDocumentSemanticTokens(F,K,G,J){return this.s(F,fe,q=>q.provideDocumentSemanticTokens(y.URI.revive(K),G,J),null,J)}$releaseDocumentSemanticTokens(F,K){this.s(F,fe,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,K,G,J){const q=this.t(new ye(this.h,G),F);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(K,F),J),this.p(q)}$provideDocumentRangeSemanticTokens(F,K,G,J){return this.s(F,ye,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(K),G,J),null,J)}registerCompletionItemProvider(F,K,G,J){const q=this.t(new ue(this.h,this.j.converter,G,this.m,F),F);return this.e.$registerCompletionsProvider(q,this.o(K,F),J,ue.supportsResolving(G),F.identifier),this.p(q)}$provideCompletionItems(F,K,G,J,q){return this.s(F,ue,x=>x.provideCompletionItems(y.URI.revive(K),G,J,q),void 0,q)}$resolveCompletionItem(F,K,G){return this.s(F,ue,J=>J.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(F,K){this.s(F,ue,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(F,K,G,J){const q=new ve(F,this.h,G,this.j.converter),x=this.t(q,F);return this.e.$registerInlineCompletionsSupport(x,this.o(K,F),q.supportsHandleEvents,$.$6l.toKey(F.identifier.value),J?.yieldTo?.map(ce=>$.$6l.toKey(ce))||[]),this.p(x)}$provideInlineCompletions(F,K,G,J,q){return this.s(F,ae,x=>x.provideInlineCompletions(y.URI.revive(K),G,J,q),void 0,q)}$handleInlineCompletionDidShow(F,K,G,J){this.s(F,ae,async q=>{q.handleDidShowCompletionItem(K,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,K,G,J){this.s(F,ae,async q=>{q.handlePartialAccept(K,G,J)},void 0,void 0)}$freeInlineCompletionsList(F,K){this.s(F,ae,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(F,K,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new W(this.h,G),F);return this.e.$registerSignatureHelpProvider(x,this.o(K,F),q),this.p(x)}$provideSignatureHelp(F,K,G,J,q){return this.s(F,W,x=>x.provideSignatureHelp(y.URI.revive(K),G,J,q),void 0,q)}$releaseSignatureHelp(F,K){this.s(F,W,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(F,K,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new Z(this.h,this.j.converter,G,this.l,F),F);this.e.$registerInlayHintsProvider(q,this.o(K,F),typeof G.resolveInlayHint=="function",J,ge.u(F));let x=this.p(q);if(J!==void 0){const ce=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=T.$iK.from(x,ce)}return x}$provideInlayHints(F,K,G,J){return this.s(F,Z,q=>q.provideInlayHints(y.URI.revive(K),G,J),void 0,J)}$resolveInlayHint(F,K,G){return this.s(F,Z,J=>J.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(F,K){this.s(F,Z,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(F,K,G){const J=this.t(new ee(this.h,G),F);return this.e.$registerDocumentLinkProvider(J,this.o(K,F),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(F,K,G){return this.s(F,ee,J=>J.provideLinks(y.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(F,K,G){return this.s(F,ee,J=>J.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(F,K){this.s(F,ee,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(F,K,G){const J=this.t(new pe(this.h,G),F);return this.e.$registerDocumentColorProvider(J,this.o(K,F)),this.p(J)}$provideDocumentColors(F,K,G){return this.s(F,pe,J=>J.provideColors(y.URI.revive(K),G),[],G)}$provideColorPresentations(F,K,G,J){return this.s(F,pe,q=>q.provideColorPresentations(y.URI.revive(K),G,J),void 0,J)}registerFoldingRangeProvider(F,K,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new oe(new $e(this.h,G),F)),this.e.$registerFoldingRangeProvider(J,this.o(K,F),F.identifier,q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=T.$iK.from(x,ce)}return x}$provideFoldingRanges(F,K,G,J){return this.s(F,$e,q=>q.provideFoldingRanges(y.URI.revive(K),G,J),void 0,J)}registerSelectionRangeProvider(F,K,G){const J=this.t(new he(this.h,G,this.l),F);return this.e.$registerSelectionRangeProvider(J,this.o(K,F)),this.p(J)}$provideSelectionRanges(F,K,G,J){return this.s(F,he,q=>q.provideSelectionRanges(y.URI.revive(K),G,J),[],J)}registerCallHierarchyProvider(F,K,G){const J=this.t(new De(this.h,G),F);return this.e.$registerCallHierarchyProvider(J,this.o(K,F)),this.p(J)}$prepareCallHierarchy(F,K,G,J){return this.s(F,De,q=>Promise.resolve(q.prepareSession(y.URI.revive(K),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(F,K,G,J){return this.s(F,De,q=>q.provideCallsTo(K,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(F,K,G,J){return this.s(F,De,q=>q.provideCallsFrom(K,G,J),void 0,J)}$releaseCallHierarchy(F,K){this.s(F,De,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(F,K,G){const J=this.t(new ne(this.h,G),F);return this.e.$registerTypeHierarchyProvider(J,this.o(K,F)),this.p(J)}$prepareTypeHierarchy(F,K,G,J){return this.s(F,ne,q=>Promise.resolve(q.prepareSession(y.URI.revive(K),G,J)),void 0,J)}$provideTypeHierarchySupertypes(F,K,G,J){return this.s(F,ne,q=>q.provideSupertypes(K,G,J),void 0,J)}$provideTypeHierarchySubtypes(F,K,G,J){return this.s(F,ne,q=>q.provideSubtypes(K,G,J),void 0,J)}$releaseTypeHierarchy(F,K){this.s(F,ne,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(F,K,G,J){const q=this.q();this.f.set(q,new oe(new le(this.e,this.h,G,q,F),F));const x=(0,n.$dF)(F,"dropMetadata")&&J?le.toInternalProviderId(F.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(K,F),x,(0,n.$dF)(F,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(F,K,G,J,q,x){return this.s(F,le,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(K,y.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(F,K,G){const J=this.t(new ie(this.h,G),F);return this.e.$registerMappedEditsProvider(J,this.o(K,F)),this.p(J)}$provideMappedEdits(F,K,G,J,q){return this.s(F,ie,x=>Promise.resolve(x.provideMappedEdits(K,G,J,q)),null,q)}registerDocumentPasteEditProvider(F,K,G,J){const q=this.q();this.f.set(q,new oe(new N(this.e,this.h,G,q,F),F));const x=N.toInternalProviderId(F.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(K,F),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(F,K,G,J,q){return this.s(F,N,x=>x.prepareDocumentPaste(y.URI.revive(K),G,J,q),void 0,q)}$providePasteEdits(F,K,G,J,q,x){return this.s(F,N,ce=>ce.providePasteEdits(K,y.URI.revive(G),J,q,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:ge.w(F.decreaseIndentPattern),increaseIndentPattern:ge.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ge.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ge.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ge.w(F.beforeText),afterText:F.afterText?ge.w(F.afterText):void 0,previousLineText:F.previousLineText?ge.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ge.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(K=>T.SyntaxTokenType.toString(K)):void 0}}static D(F){return F.map(ge.C)}setLanguageConfiguration(F,K,G){const{wordPattern:J}=G;if(J&&(0,D.$Oe)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(K,J):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ge.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ge.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ge.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?ge.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,K,x),this.p(q)}$setWordDefinitions(F){for(const K of F)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$kcc=ge}),define(Ae[242],Re([1,0,3,8,7,29,12,6,25]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;class f{constructor(k,a,b,$){this.c=a,this.d=b,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$gK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,a){await this.a.$changeLanguage(k,a);const b=this.c.getDocumentData(k);if(!b)throw new Error(`document '${k.toString()}' NOT found`);return b.document}async tokenAtPosition(k,a){const b=k.version,$=M.Position.from(a),g=await this.a.$tokensAtPosition(k.uri,$),t={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(a)??new C.$kK(a.line,a.character,a.line,a.character)};if(!g)return t;const i={range:M.Range.to(g.range),type:M.TokenType.to(g.type)};return!i.range.contains(a)||b!==k.version?t:i}createLanguageStatusItem(k,a,b){const $=this.f++,g=this.a,t=this.g,i=`${k.identifier.value}/${a}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);t.add(i);const c={selector:b,id:a,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const E=new l.$Rc,v=()=>{if(p?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${a}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}p=(0,A.$Vg)(()=>{E.clear(),this.a.$setLanguageStatus($,{id:i,name:c.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===C.LanguageStatusSeverity.Error?T.default.Error:c.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:c.command&&this.d.toInternal(c.command,E),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},n={dispose(){E.dispose(),p?.dispose(),g.$removeLanguageStatus($),t.delete(i)},get id(){return c.id},get name(){return c.name},set name(r){c.name=r,v()},get selector(){return c.selector},set selector(r){c.selector=r,v()},get text(){return c.text},set text(r){c.text=r,v()},set text2(r){(0,D.$eF)(k,"languageStatusText"),c.text=r,v()},get text2(){return(0,D.$eF)(k,"languageStatusText"),c.text},get detail(){return c.detail},set detail(r){c.detail=r,v()},get severity(){return c.severity},set severity(r){c.severity=r,v()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(r){c.accessibilityInformation=r,v()},get command(){return c.command},set command(r){c.command=r,v()},get busy(){return c.busy},set busy(r){c.busy=r,v()}};return v(),n}}e.$5cc=f}),define(Ae[81],Re([1,0,22,16,2,4,14,3,27,17]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=void 0;let R=class{constructor(a,b,$){this.f=$,this.d=new Map,this.a=b.getProxy(l.$gK.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===y.$g}getMessage(a,b){const{message:$,args:g,comment:t}=b;if(this.c)return(0,M.$De)($,g??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$De)(c??$,g??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let b;const $=await this.g(a);if(!$){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents($),t=JSON.parse(g);b=a.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${a.identifier.value} from ${$}: ${g.message}`);return}b&&this.d.set(a.identifier.value,{contents:b,uri:$})}async g(a){if(a.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(b)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Tcc=R,e.$Tcc=R=qe([Ve(0,D.$xM),Ve(1,f.$hM),Ve(2,A.$0i)],R),e.$Ucc=(0,T.$Ph)("IExtHostLocalizationService")}),define(Ae[243],Re([1,0,14,3,27,17,2,68]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;let D=class extends y.$ij{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(b=>(0,l.$mh)(b))),this.r=k.getProxy(M.$gK.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(A.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,b){return new f(this.r,k,a,b)}};e.$kec=D,e.$kec=D=qe([Ve(0,T.$hM),Ve(1,C.$xM)],D);class f extends y.$dj{constructor(k,a,b,$){super($?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(a,$).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const b=[[k,a]];this.m?this.u(b):this.n.push(...b)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,26]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=void 0,e.$Vcc=(0,M.$Ph)("IExtHostManagedSockets");let l=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$gK.MainThreadManagedSockets)}setFactory(k,a){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,b=await this.c.makeConnection(),$=new C.$Rc;return this.d.set(a,new f(a,b,$)),$.add((0,C.$Qc)(()=>this.d.delete(a))),$.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),$.dispose()})),$.add(b.onDidClose(g=>{this.a.$onDidManagedSocketClose(a,g?.stack??g?.message),$.dispose()})),$.add(b.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(a,A.$be.wrap(g)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Wcc=l,e.$Wcc=l=qe([Ve(0,T.$hM)],l);class D{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class f extends C.$Sc{constructor(k,a,b){super(),this.socketId=k,this.actual=a,this.B(b)}}}),define(Ae[244],Re([1,0,3,14,25]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;function T(l){return l&&l.title}let A=class{constructor(D,f){this.b=f,this.a=D.getProxy(y.$gK.MainThreadMessageService)}showMessage(D,f,R,k,a){const b={source:{identifier:D.identifier,label:D.displayName||D.name}};let $;typeof k=="string"||T(k)?$=[k,...a]:(b.modal=k?.modal,b.useCustom=k?.useCustom,b.detail=k?.detail,$=a),b.useCustom&&(0,C.$eF)(D,"resolvers");const g=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:p}=i;g.push({title:c,isCloseAffordance:!!p,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,R,b,g).then(t=>{if(typeof t=="number")return $[t]})}};e.$6cc=A,e.$6cc=A=qe([Ve(1,M.$0i)],A)}),define(Ae[245],Re([1,0,151,26,5,6,28,16,15,2,39,74,3,31,8,7,47,205,103,9,24,13]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,w,d,I){this.q=w,this.r=d,this.s=I,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new C.$Nd({onListenerError:p.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Nd({onListenerError:p.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Nd({onListenerError:p.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Nd({onListenerError:p.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$bcc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(a.$gK.MainThreadNotebook),this.c=s.getProxy(a.$gK.MainThreadNotebookDocuments),this.d=s.getProxy(a.$gK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,m=S.cell.handle,P=this.g.get(u)?.getCell(m);if(P)return P.apiCell}if(S&&S.$mid===14){const u=S.uri,m=this.g.get(u);if(m)return m.apiNotebook}return S}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,w]of this.h)if(w.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const w=this.g.get(s);if(!w&&!o)throw new Error(`NO notebook document for '${s}'`);return w}static t(s,o){if(!o)return;const w=o.filenamePattern.map(d=>$.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,w){const d=n.a++,I=typeof w.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(d,w),this.b.$registerNotebookCellStatusBarItemProvider(d,I,o);let S;return I!==void 0&&(S=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new g.$iK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,I),S?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&$.NotebookData.from(s.content)});return f.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(s),d=this.g.get(f.URI.revive(w));return(0,D.$Jf)(d?.apiNotebook)}async showNotebookDocument(s,o){f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let w;typeof o=="object"?w={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,w),I=d&&this.h.get(d)?.apiEditor;if(I)return I;throw d?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,w,d){const I=this.f.get(s),S=f.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const m=u.getCellFromIndex(w);if(!m)return;const h=await I.provideCellStatusBarItems(m.apiCell,d);if(!h)return;const P=new T.$Rc,B=this.p.add([P]),j=(Array.isArray(h)?h:[h]).map(V=>$.NotebookStatusBarItem.from(V,this.i,P));return{cacheId:B,items:j}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,w,d,I){if((0,l.$Be)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:w,options:d}),this.b.$registerNotebookSerializer(S,{id:s.identifier,location:s.extensionLocation},o,$.NotebookDocumentContentOptions.from(d),n.t(s,I)),(0,T.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(s,o,w){const d=this.w.get(s);if(!d)throw new Error("NO serializer found");const I=await d.serializer.deserializeNotebook(o.buffer,w);return new t.$qv($.NotebookData.from(I))}async $notebookToData(s,o,w){const d=this.w.get(s);if(!d)throw new Error("NO serializer found");const I=await d.serializer.serializeNotebook($.NotebookData.to(o.value),w);return M.$be.wrap(I)}async $saveNotebook(s,o,w,d,I){const S=f.URI.revive(o),u=this.w.get(s);if(!u)throw new Error("NO serializer found");const m=this.g.get(S);if(!m)throw new Error("Document NOT found");if(m.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$tk((0,y.localize)(0,null,this.y(S)),6);await this.x(S,d);const h={metadata:(0,E.$cn)(m.apiNotebook.metadata,V=>!(u.options?.transientDocumentMetadata??{})[V]),cells:[]};for(const V of m.apiNotebook.getCells()){const N=new g.$GL(V.kind,V.document.getText(),V.document.languageId,V.mime,u.options?.transientOutputs?[]:[...V.outputs],V.metadata,V.executionSummary);N.metadata=(0,E.$cn)(V.metadata,O=>!(u.options?.transientCellMetadata??{})[O]),h.cells.push(N)}const P=await u.serializer.serializeNotebook(h,I);await this.s.value.writeFile(S,P);const B=this.s.getFileSystemProviderExtUri(S.scheme),z=await this.s.value.stat(S);return{name:B.basename(S),isFile:(z.type&R.FileType.File)!==0,isDirectory:(z.type&R.FileType.Directory)!==0,isSymbolicLink:(z.type&R.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((z.permissions??0)&R.FilePermission.Locked),etag:R.$Ek({mtime:z.mtime,size:z.size}),children:void 0}}async x(s,o){const w=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Dk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==R.$Ek({mtime:o.mtime,size:w.size}))throw new R.$tk((0,y.localize)(1,null),3,o)}y(s){return s.scheme===v.Schemas.file?s.fsPath:s.toString()}z(s,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const d=new c.$Mdc(o,this.d,s,w.visibleRanges.map($.NotebookRange.to),w.selections.map($.NotebookRange.to),typeof w.viewColumn=="number"?$.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,d)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const w of s.value.removedDocuments){const d=f.URI.revive(w),I=this.g.get(d);I&&(I.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===d.toString()&&this.h.delete(S.id)}if(s.value.addedDocuments){const w=[];for(const d of s.value.addedDocuments){const I=f.URI.revive(d.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new i.$Ldc(this.c,this.q,this.r,I,d);w.push(...d.cells.map(u=>i.$Kdc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(S.apiNotebook)}}if(s.value.addedEditors)for(const w of s.value.addedEditors){if(this.h.has(w.id))return;const d=f.URI.revive(w.documentUri),I=this.g.get(d);I&&this.z(I,w.id,w)}const o=[];if(s.value.removedEditors)for(const w of s.value.removedEditors){const d=this.h.get(w);d&&(this.h.delete(w),this.k?.id===d.id&&(this.k=void 0),o.push(d))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const w=new Set;this.l.forEach(d=>w.add(d.id));for(const d of this.h.values()){const I=w.has(d.id);d._acceptVisibility(I)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=b.$FM.String.with("notebookType","A notebook type"),w=new b.$HM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new b.$FM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$be.wrap(I))],new b.$GM("Notebook Data",I=>$.NotebookData.to(I.value))),d=new b.$HM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new b.$FM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$qv($.NotebookData.from(I)))],new b.$GM("Bytes",I=>I.buffer));s.registerApiCommand(w),s.registerApiCommand(d)}}e.$Ndc=n}),define(Ae[246],Re([1,0,18,12,19,5,6,28,2,21,14,3,31,8,7,77,198,25,47]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0;let p=class{constructor(d,I,S,u,m){this.l=I,this.m=S,this.n=u,this.o=m,this.b=new l.$Ac,this.c=new l.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new T.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=d.getProxy(k.$gK.MainThreadNotebookKernels);const h=new a.$HM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$FM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const B=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:B}}else if(P&&"notebookEditor"in P){const B=this.m.getIdByEditor(P.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return P})],a.$GM.Void);this.n.registerApiCommand(h)}createNotebookController(d,I,S,u,m,h){for(const ye of this.i.values())if(ye.controller.id===I&&f.$6l.equals(d.identifier,ye.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const P=this.j++,B=this;this.o.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${I}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${d.identifier}'`);let j=!1;const V=new T.$Nd,N=new T.$Nd,O={id:o(d.identifier,I),notebookType:S,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:u||d.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let se=m??z,X;this.a.$addKernel(P,O).catch(ye=>{console.log(ye),j=!0});let Ee=0;const Pe=()=>{if(j)return;const ye=++Ee;Promise.resolve().then(()=>{ye===Ee&&this.a.$updateKernel(P,O)})},Se=new l.$Ac,fe={get id(){return I},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return O.label},set label(ye){O.label=ye??d.displayName??d.name,Pe()},get detail(){return O.detail??""},set detail(ye){O.detail=ye,Pe()},get description(){return O.description??""},set description(ye){O.description=ye,Pe()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ye){O.supportedLanguages=ye,Pe()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ye){O.supportsExecutionOrder=ye,Pe()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(ye){se=ye??z},get interruptHandler(){return X},set interruptHandler(ye){X=ye,O.supportsInterrupt=!!ye,Pe()},createNotebookCellExecution(ye){if(j)throw new Error("notebook controller is DISPOSED");if(!Se.has(ye.notebook.uri))throw B.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Se.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.notebook.uri.toString()}`);return B._createNotebookCellExecution(ye,o(d.identifier,this.id))},createNotebookExecution(ye){if((0,i.$eF)(d,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!Se.has(ye.uri))throw B.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Se.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.uri.toString()}`);return B._createNotebookExecution(ye,o(d.identifier,this.id))},dispose:()=>{j||(this.o.trace(`NotebookController[${P}], DISPOSED`),j=!0,this.i.delete(P),V.dispose(),N.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ye,ue){ue===$.NotebookControllerAffinity2.Hidden&&(0,i.$eF)(d,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(P,ye.uri,ue)},onDidReceiveMessage:N.event,postMessage(ye,ue){return(0,i.$eF)(d,"notebookMessaging"),B.a.$postMessage(P,ue&&B.m.getIdByEditor(ue),ye)},asWebviewUri(ye){return(0,i.$eF)(d,"notebookMessaging"),(0,g.$9ob)(ye,B.l.remote)}};return this.i.set(P,{extensionId:d.identifier,controller:fe,onDidReceiveMessage:N,onDidChangeSelection:V,associatedNotebooks:Se}),fe}getIdByController(d){for(const[I,S]of this.i)if(S.controller===d)return o(S.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const m={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,m),m}registerKernelSourceActionProvider(d,I,S){const u=this.h++,m=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,h=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let P;return m!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),h.a.$removeKernelSourceActionProvider(u,u),P?.dispose()}}}async $provideKernelSourceActions(d,I){const S=this.g.get(d);if(S){const u=new A.$Rc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(h=>b.NotebookKernelSourceAction.from(h,this.n.converter,u))}return[]}$acceptNotebookAssociation(d,I,S){const u=this.i.get(d);if(u){const m=this.m.getNotebookDocument(D.URI.revive(I));S?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${d}] ASSOCIATE notebook`,m.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:m.apiNotebook})}}async $executeCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I)),h=[];for(const P of S){const B=m.getCell(P);B&&h.push(B.apiCell)}try{this.o.trace(`NotebookController[${d}] EXECUTE cells`,m.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,m.apiNotebook,u.controller)}catch(P){this.o.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const h of S){const P=m.getCell(h);P&&this.b.get(P.uri)?.cancel()}if(u.controller.interruptHandler){const h=this.c.get(m.uri);S.length&&Array.isArray(h)&&h.length&&h.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:S}))}$cellExecutionChanged(d,I,S){const m=this.m.getNotebookDocument(D.URI.revive(d)).getCell(I);if(m){const h=S?b.NotebookCellExecutionState.to(S):$.NotebookCellExecutionState.Idle;h!==void 0&&this.k.fire({cell:m.apiCell,state:h})}}_createNotebookCellExecution(d,I){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new v(I,u,this.a);this.b.set(u.uri,m);const h=m.onDidChangeState(()=>{m.state===E.Resolved&&(m.dispose(),h.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(d,I){const S=this.m.getNotebookDocument(d.uri),u=d.getCells().find(P=>{const B=S.getCellFromApiCell(P);return B&&this.b.has(B.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const m=new r(I,S,this.a),h=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),h.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[m,h]),m.asApiObject()}};e.$2dc=p,e.$2dc=p=qe([Ve(4,R.$0i)],p);var E;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(E||(E={}));class v extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Xd),this.h=new s(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const I=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new c.$qv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let I=this.m;if(d&&(I=this.m.notebook.getCellFromApiCell(d)),!I)throw new Error("INVALID cell");return I.handle}y(d){return d.map(I=>{const S=$.$JL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?b.NotebookCellOutput.from(I):b.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(d,I,S){const u=this.w(I),m=this.y((0,y.$3b)(d));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:m})}async C(d,I,S){return d=$.$JL.ensureUniqueMimeTypes((0,y.$3b)(d),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:d.map(b.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(S){d.j=S,d.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(S){if(d.f===E.Resolved||d.f===E.Started)throw new Error("Cannot call start again");d.f=E.Started,d.c.fire(),d.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(d.f===E.Resolved)throw new Error("Cannot call resolve twice");d.f=E.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new c.$qv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return d.t(),d.z([],S,!1)},appendOutput(S,u){return d.t(),d.z(S,u,!0)},replaceOutput(S,u){return d.t(),d.z(S,u,!1)},appendOutputItems(S,u){return d.t(),d.C(S,u,!0)},replaceOutputItems(S,u){return d.t(),d.C(S,u,!1)}})}}var n;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(n||(n={}));class r extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.h=I,this.j=S,this.b=r.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$Xd),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(d,I){this.e=d,this.f=I,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$ch,this.b=Date.now(),(0,M.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>d.complete())}}function o(w,d){return`${w.value}/${d}`}e.$3dc=o}),define(Ae[247],Re([1,0,5,3,103]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class T{constructor(l,D){this.c=D,this.a=new Map,this.b=l.getProxy(M.$gK.MainThreadNotebookRenderers)}$postRendererMessage(l,D,f){const R=this.c.getEditorById(l);this.a.get(D)?.fire({editor:R.apiEditor,message:f})}createRendererMessaging(l,D){if(!l.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,k,a)=>this.d(D).event(R,k,a),postMessage:(R,k)=>{C.$Mdc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const a=k&&C.$Mdc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,D,R)}}}d(l){let D=this.a.get(l);return D||(D=new y.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(l)}}),this.a.set(l,D),D)}}e.$4dc=T}),define(Ae[248],Re([1,0,6,15,2,25,3]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class l{constructor(f){this.b=new Map,this.a=f.getProxy(A.$gK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,R,k){if((0,T.$eF)(f,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,f.identifier.value),(0,y.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(f,R,k,a){const b=this.b.get(f);if(!b)throw new Error(`Unknown handler with id: ${f}`);return b.saveProfile(R,k,a)}async $readProfile(f,R,k){const a=this.b.get(f);if(!a)throw new Error(`Unknown handler with id: ${f}`);return a.readProfile((0,M.$yf)(R)?R:C.URI.revive(R),k)}}e.$8dc=l}),define(Ae[249],Re([1,0,2,3,12,8]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class A{static{this.a=0}constructor(D,f){this.d=f,this.c=new Map,this.b=D.getProxy(M.$gK.MainThreadQuickDiff)}$provideOriginalResource(D,f,R){const k=y.URI.revive(f),a=this.c.get(D);return a?(0,C.$Mg)(()=>a.provideOriginalResource(k,R)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(D,f,R,k){const a=A.a++;return this.c.set(a,f),this.b.$registerQuickDiffProvider(a,T.DocumentSelector.from(D,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$9dc=A}),define(Ae[250],Re([1,0,19,5,6,3,2,7,9,18,29,43,25,8]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;function $(g,t,i){const c=g.getProxy(T.$gK.MainThreadQuickOpen);class p{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,m=y.CancellationToken.None){this.c=void 0;const h=Promise.resolve(S),P=++this.f,B=c.$show(P,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},m),z={},j=B.then(()=>z);return Promise.race([j,h]).then(V=>{if(V===z)return;const N=(0,a.$dF)(I,"quickPickItemTooltip");return h.then(O=>{const se=[];for(let X=0;X<O.length;X++){const Ee=O[X];if(typeof Ee=="string")se.push({label:Ee,handle:X});else if(Ee.kind===l.QuickPickItemKind.Separator)se.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!N&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Pe=Ee.iconPath?s(Ee.iconPath):void 0;se.push({label:Ee.label,iconPath:Pe?.iconPath,iconClass:Pe?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:N?b.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:X})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=X=>{u.onDidSelectItem(O[X])}),c.$setItems(P,se),B.then(X=>{if(typeof X=="number")return O[X];if(Array.isArray(X))return X.map(Ee=>O[Ee])})})}).then(void 0,V=>{if(!(0,D.$4)(V))return c.$setError(P,V),Promise.reject(V)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=y.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,D.$4)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=R.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=y.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(h=>h.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new w(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const m=this.e.get(I);m instanceof o&&m._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Nd,this.q=new M.$Nd,this.r=new M.$Nd,this.s=new M.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const m=S===l.$CL.Back?-1:u;this.o.set(m,S)}),this.z({buttons:I.map((S,u)=>({...s(S.iconPath),tooltip:S.tooltip,handle:S===l.$CL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function v(d){if(d instanceof l.$cL)return{id:d.id};const I=r(d),S=n(d);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function n(d){return typeof d=="object"&&"light"in d?d.light:d}function r(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const I=v(d);let S,u;return"id"in I?u=k.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Nd,this.L=[],this.M=new M.$Nd,this.N=new M.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((m,h)=>{this.C.set(h,m),this.D.set(m,h)});const S=(0,a.$dF)(this.O,"quickPickItemTooltip"),u=[];for(let m=0;m<I.length;m++){const h=I[m];if(h.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:h.label});else{h.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=h.iconPath?s(h.iconPath):void 0;u.push({handle:m,label:h.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:S?b.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((B,z)=>({...s(B.iconPath),tooltip:B.tooltip,handle:z}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,f.$Hb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,f.$Hb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const m=u.buttons[S];m&&this.N.fire({button:m,item:u})}}class w extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:R.default.Error}):this.z({validationMessage:I.message,severity:I.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new p(t,i)}e.$0cc=$}),define(Ae[251],Re([1,0,2,5,65,6,12,3,18,131,14,21,43,8,25,13]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0;function i(m){if(m)return typeof m.iconPath=="string"?y.URI.file(m.iconPath):y.URI.isUri(m.iconPath)||a.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function c(m){if(m.icon){if(y.URI.isUri(m.icon))return m.icon;if(a.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const h=m.icon;return{light:h.light,dark:h.dark}}}else return}function p(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const P=typeof m.iconPath=="string"?m.iconPath:y.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,B=typeof h.iconPath=="string"?h.iconPath:y.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,f.$rq)(P,B)}function E(m,h){let P=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(P=p(m,h),P!==0)return P;if(m.light&&h.light)P=p(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(P!==0)return P;if(m.dark&&h.dark)P=p(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return P}function v(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let P=0;P<m.arguments.length;P++){const B=m.arguments[P],z=h.arguments[P];if(B!==z)return B<z?-1:1}return 0}function n(m,h){let P=(0,f.$rq)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(P!==0)return P;if(m.command&&h.command)P=v(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(P!==0)return P;if(m.decorations&&h.decorations)P=E(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return P}function r(m,h){for(let P=0;P<m.length;P++)if(m[P]!==h[P])return!1;return!0}function s(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?r(m.arguments,h.arguments):m.arguments===h.arguments)}function o(m,h){return(0,D.$ub)(m,h,s)}function w(m,h){return m===h?!0:!m||!h?!1:m.id===h.id&&m.label===h.label&&m.upstream?.id===h.upstream?.id&&m.upstream?.label===h.upstream?.label}class d{#e;#t;get value(){return this.d}set value(h){h=h??"",this.#e.$setInputBoxValue(this.l,h),this.n(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){this.#e.$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,$.$eF)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,$.$eF)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,this.#e.$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,this.#e.$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,this.#e.$setInputBoxVisibility(this.l,h))}get document(){return(0,$.$eF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(h,P,B,z,j){this.k=h,this.l=z,this.m=j,this.d="",this.e=new M.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=B}showValidationMessage(h,P){(0,$.$eF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,h,P)}$onInputBoxValueChange(h){this.n(h)}n(h){this.d=h,this.e.fire(h)}}e.$$cc=d;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,P,B,z,j){this.q=h,this.s=P,this.t=B,this.u=z,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,P){const B=this.h.get(h);return B?(0,A.$Mg)(()=>this.s.executeCommand(B.command,...B.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(n),B=(0,D.$Db)(this.o,h,n).map(V=>{const N=V.toInsert.map(O=>{const se=this.e++;this.g.set(se,O);const X=O.resourceUri;let Ee;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Z=new T.$Rc;Ee=this.s.converter.toInternal(O.command,Z),this.j.set(se,Z)}else this.h.set(se,O.command);const Pe=i(O.decorations),Se=O.decorations&&i(O.decorations.light)||Pe,fe=O.decorations&&i(O.decorations.dark)||Pe,ye=[Se,fe],ue=O.decorations&&O.decorations.tooltip||"",ae=O.decorations&&!!O.decorations.strikeThrough,ve=O.decorations&&!!O.decorations.faded,_=O.contextValue||"";return{rawResource:[se,X,ye,ue,ae,ve,_,Ee],handle:se}});return{start:V.start,deleteCount:V.deleteCount,toInsert:N}}),z=B.map(({start:V,deleteCount:N,toInsert:O})=>[V,N,O.map(se=>se.rawResource)]),j=B.reverse();for(const{start:V,deleteCount:N,toInsert:O}of j){const se=O.map(Ee=>Ee.handle),X=this.n.splice(V,N,...se);for(const Ee of X)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=h,z}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,this.#e.$updateSourceControl(this.x,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let P;(0,$.$dF)(this.y,"quickDiffProvider")&&(P=h?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!h,quickDiffLabel:P})}get historyProvider(){return(0,$.$eF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(h){(0,$.$eF)(this.y,"scmHistoryProvider"),this.j=h,this.k.value=new T.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!h}),h&&(this.k.value.add(h.onDidChangeCurrentHistoryItemGroup(()=>{w(this.l,h?.currentHistoryItemGroup)||(this.l=h?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(h.onDidChangeActionButton(()=>{(0,$.$eF)(this.y,"scmActionButton"),this.m.value=new T.$Rc;const P=h.actionButton!==void 0?{command:this.z.converter.toInternal(h.actionButton.command,this.m.value),description:h.actionButton.description,enabled:h.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(h){h!==this.n&&(this.n=h,this.#e.$updateSourceControl(this.x,{commitTemplate:h}))}get acceptInputCommand(){return this.p}set acceptInputCommand(h){this.o.value=new T.$Rc,this.p=h;const P=this.z.converter.toInternal(h,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,$.$eF)(this.y,"scmActionButton"),this.s}set actionButton(h){(0,$.$eF)(this.y,"scmActionButton"),this.q.value=new T.$Rc,this.s=h;const P=h!==void 0?{command:this.z.converter.toInternal(h.command,this.q.value),secondaryCommands:h.secondaryCommands?.map(B=>B.map(z=>this.z.converter.toInternal(z,this.q.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(h){if(this.u&&h&&o(this.u,h))return;this.t.value=new T.$Rc,this.u=h;const P=(h||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(h,P,B,z,j,V,N){this.y=h,this.z=z,this.A=j,this.B=V,this.C=N,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Tc,this.m=new T.$Tc,this.n=void 0,this.o=new T.$Tc,this.p=void 0,this.q=new T.$Tc,this.t=new T.$Tc,this.u=void 0,this.v=!1,this.w=new M.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=B;const O=y.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${j}/scm${this.x}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new d(h,P,this.#e,this.x,O),this.#e.$registerSourceControl(this.x,j,V,N,O)}createResourceGroup(h,P){const B=new I(this.#e,this.z,this.x,h,P),z=M.Event.once(B.onDidDispose)(()=>this.D.delete(B));return this.D.set(B,z),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const h=[],P=[];for(const[B,z]of this.D){z.dispose();const j=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});M.Event.once(B.onDidDispose)(()=>{this.E.delete(B),j.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),h.push([B.handle,B.id,B.label,B.features]);const V=B._takeResourceStateSnapshot();V.length>0&&P.push([B.handle,V]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,h,P),this.D.clear()}eventuallyUpdateResourceStates(){const h=[];this.E.forEach(P=>{const B=P._takeResourceStateSnapshot();B.length!==0&&h.push([P.handle,B])}),h.length>0&&this.#e.$spliceResourceStates(this.x,h),this.E.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.v=h,this.w.fire(h)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,C.$ih)(100)],S.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.$ih)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(h,P,B,z){this.l=P,this.m=B,this.n=z,this.g=new Map,this.h=new k.$8l,this.j=new M.$Nd,this.e=h.getProxy(l.$gK.MainThreadSCM),this.f=h.getProxy(l.$gK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const V=this.g.get(j.sourceControlHandle);if(!V)return j;const N=V.getResourceGroup(j.groupHandle);return N?N.getResourceState(j.handle):j}else if(j&&j.$mid===4){const V=this.g.get(j.sourceControlHandle);return V?V.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const V=this.g.get(j.handle);return V||j}return j}})}createSourceControl(h,P,B,z){this.n.trace("ExtHostSCM#createSourceControl",h.identifier.value,P,B,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const j=t.d++,V=new S(h,this.m,this.e,this.l,P,B,z);this.g.set(j,V);const N=this.h.get(h.identifier)||[];return N.push(V),this.h.set(h.identifier,N),V}getLastInputBox(h){this.n.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const P=this.h.get(h.identifier),B=P&&P[P.length-1];return B&&B.inputBox}$provideOriginalResource(h,P,B){const z=y.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",h,z.toString());const j=this.g.get(h);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>j.quickDiffProvider.provideOriginalResource(z,B)).then(V=>V||null)}$onInputBoxValueChange(h,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",h);const B=this.g.get(h);return B&&B.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(h,P,B,z){this.n.trace("ExtHostSCM#$executeResourceCommand",h,P,B);const j=this.g.get(h);if(!j)return Promise.resolve(void 0);const V=j.getResourceGroup(P);return V?V.$executeResourceCommand(B,z):Promise.resolve(void 0)}$validateInput(h,P,B){this.n.trace("ExtHostSCM#$validateInput",h);const z=this.g.get(h);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>z.inputBox.validateInput(P,B)).then(j=>{if(!j)return Promise.resolve(void 0);const V=b.MarkdownString.fromStrict(j.message);return V?Promise.resolve([V,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(h,P,B){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupBase(P,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(h,P,B,z){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,B,z)??void 0}async $provideHistoryItems(h,P,B,z){return(await this.g.get(h)?.historyProvider?.provideHistoryItems(P,B,z))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:c(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(h,P,B){return await this.g.get(h)?.historyProvider?.provideHistoryItemChanges(P,B)??void 0}};e.$_cc=u,e.$_cc=u=t=qe([Ve(3,R.$0i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0;class T{constructor(l){this.b=new M.$Nd,this.onDidChangePassword=this.b.event,this.a=l.getProxy(y.$gK.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,D){return this.a.$getPassword(l,D)}store(l,D,f){return this.a.$setPassword(l,D,f)}delete(l,D){return this.a.$deletePassword(l,D)}}e.$Qcc=T,e.$Rcc=(0,C.$Ph)("IExtHostSecretState")}),define(Ae[252],Re([1,0,3,8,2]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class T{static{this.a=0}constructor(l,D){this.d=D,this.c=new Map,this.b=l.getProxy(y.$gK.MainThreadShare)}async $provideShare(l,D,f){return await this.c.get(l)?.provideShare({selection:M.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},f)??void 0}registerShareProvider(l,D){const f=T.a++;return this.c.set(f,D),this.b.$registerShareProvider(f,M.DocumentSelector.from(l,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$bec=T}),define(Ae[253],Re([1,0,19,6,3]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class T{static{this.a=1}constructor(l){this.c=new Map,this.d=new Map,this.b=l.getProxy(C.$gK.MainThreadSpeech)}async $createSpeechToTextSession(l,D){const f=this.c.get(l);if(!f)return;const R=new M.$Rc,k=new y.$Xd;this.d.set(D,k);const a=R.add(f.provideSpeechToTextSession(k.token));R.add(a.onDidChange(b=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,b)})),R.add(k.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(l){this.d.get(l)?.dispose(!0),this.d.delete(l)}registerProvider(l,D,f){const R=T.a++;return this.c.set(R,f),this.b.$registerProvider(R,D,{extension:l,displayName:l.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$dec=T}),define(Ae[254],Re([1,0,7,3,153,6,8,15]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$dL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$dL("statusBarItem.warningForeground")]])}#e;#t;constructor(a,b,$,g,t,i=y.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new T.$Rc,this.#e=a,this.#t=b,t&&g){this.c=(0,y.$SK)(g.identifier,t);const p=$.get(this.c);p&&(i=p.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=p.priority,this.j=!0,this.name=p.name,this.text=p.text,this.tooltip=p.tooltip,this.command=p.command,this.accessibilityInformation=p.accessibilityInformation)}else this.c=String(D.a++);this.e=g,this.f=t,this.g=i,this.h=this.u(c)}u(a){if((0,l.$Cf)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new T.$Rc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let b;this.m?b=this.m:b=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=D.b.get(this.o.id));const g=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,b,this.k,g,this.r?.internal,$,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$adc=D;class f{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const b={message:a};return this.b.unshift(b),this.c(),new y.$iK(()=>{const $=this.b.indexOf(b);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(a,b){this.e=new Map,this.a=a.getProxy(M.$gK.MainThreadStatusBar),this.b=b,this.c=new f(this)}$acceptStaticEntries(a){for(const b of a)this.e.set(b.entryId,b)}createStatusBarEntry(a,b,$,g){return new D(this.a,this.b,this.e,a,b,$,g)}setStatusBarMessage(a,b){const $=this.c.setMessage(a);let g;return typeof b=="number"?g=setTimeout(()=>$.dispose(),b):typeof b<"u"&&b.then(()=>$.dispose(),()=>$.dispose()),new y.$iK(()=>{$.dispose(),clearTimeout(g)})}}e.$bdc=R}),define(Ae[84],Re([1,0,3,5,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class T{constructor(l,D){this.c=D,this.b=new M.$Nd,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(y.$gK.MainThreadStorage)}registerExtensionStorageKeysToSync(l,D){this.a.$registerExtensionStorageKeysToSync(l,D)}async initializeExtensionStorage(l,D,f){const R=await this.a.$initializeExtensionStorage(l,D);let k;return R&&(k=this.d(l,D,R)),k||f}setValue(l,D,f){return this.a.$setValue(l,D,f)}$acceptValue(l,D,f){const R=this.d(l,D,f);R&&this.b.fire({shared:l,key:D,value:R})}d(l,D,f){try{return JSON.parse(f)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${l}): ${R}`)}}}e.$Ecc=T,e.$Fcc=(0,C.$Ph)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0,e.$Kcc=(0,y.$Ph)("IExtensionStoragePaths");let l=class{constructor(f,R,k){this.d=R,this.f=k,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,R=await this.g(f);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Lcc=l,e.$Lcc=l=qe([Ve(0,M.$xM),Ve(1,C.$0i),Ve(2,T.$Jcc)],l)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,19,36,182,43,12,8,31]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=e.$Ncc=e.$Mcc=void 0,e.$Mcc=(0,C.$Ph)("IExtHostTerminalService");class p{constructor(u,m,h,P){this.l=u,this._id=m,this.m=h,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(z,j=!0){B.q(),B.l.$sendText(B._id,z,j)},show(z){B.q(),B.l.$show(B._id,z)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:w(u.iconPath)??void 0,color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(u.location,m?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,m,h,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:h,color:g.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.$Ncc=p;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new y.$Nd,this.onProcessData=this.a.event,this.b=new y.$Nd,this.d=new y.$Nd,this.onDidChangeProperty=this.d.event,this.f=new y.$Nd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,n=class extends l.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,m,h){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Nd,this.onDidChangeShell=this.N.event,this.O=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=h.getProxy(M.$gK.MainThreadTerminalService),this.y=new $.$Skb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:P=>{const B=z=>{const j=z;return this.W(j.instanceId)?.value};switch(P?.$mid){case 15:return B(P);default:{if(Array.isArray(P))for(let z=0;z<P.length&&P[z].$mid===15;z++)P[z]=B(P[z]);return P}}}}),this.B({dispose:()=>{for(const[P,B]of this.g)B.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,m){const h=new p(this.a,(0,b.$eg)(),u,u.name),P=new E(u.pty);return h.createExtensionTerminal(u.location,this.R(u,m).resolvedExtHostIdentifier,w(u.iconPath),d(u.color)).then(B=>{const z=this.S(B,P);this.h[B]=z}),this.f.push(h),h.value}R(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const P=this.f.find(B=>B.value===h);P&&(m.resolvedExtHostIdentifier=P._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const P=new E(m),B=this.S(u,P);this.h[u]=B}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const h=this.W(u);h&&(this.b=h,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const h=this.W(u);h&&this.O.fire({terminal:h.value,data:m})}async $acceptTerminalDimensions(u,m,h){const P=this.W(u);P&&P.setDimensions(m,h)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(u,m){const h=this.W(u);h&&this.P.fire({terminal:h.value,...m})}async $acceptTerminalMaximumDimensions(u,m,h){this.g.get(u)?.resize(m,h)}async $acceptTerminalTitleChange(u,m){const h=this.W(u);h&&(h.name=m)}async $acceptTerminalClosed(u,m,h){const P=this.Y(this.f,u);if(P!==null){const B=this.f.splice(P,1)[0];B.setExitStatus(m,h),this.H.fire(B.value)}}$acceptTerminalOpened(u,m,h,P){if(m){const j=this.Y(this.f,m);if(j!==null){this.f[j]._id=u,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const B={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:T.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new p(this.a,u,B,h);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(u,m){this.W(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const h=this.W(u);if(!h)return{message:(0,f.localize)(0,null,u)};h.isOpen||await new Promise(B=>{const z=this.onDidOpenTerminal(async j=>{j===h.value&&(z.dispose(),B())})});const P=this.g.get(u);P?P.startSendingEvents(m):this.j[u]={initialDimensions:m}}S(u,m){const h=new l.$Rc;h.add(m.onProcessReady(B=>this.a.$sendProcessReady(u,B.pid,B.cwd,B.windowsPty))),h.add(m.onDidChangeProperty(B=>this.a.$sendProcessProperty(u,B))),this.y.startBuffering(u,m.onProcessData),h.add(m.onProcessExit(B=>this.U(u,B))),this.g.set(u,m);const P=this.j[u];return P&&m instanceof E&&(m.startSendingEvents(P.initialDimensions),delete this.j[u]),h}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.W(u);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(u,m){this.W(u)?.setSelection(m)}$acceptProcessResize(u,m,h){try{this.g.get(u)?.resize(m,h)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new D.$iK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,h){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,h),this.a.$registerProfileProvider(m,u.identifier.value),new D.$iK(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,h){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,h),this.a.$registerQuickFixProvider(u,m),new D.$iK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const h=new a.$Xd().token;if(h.isCancellationRequested)return;const P=this.D.get(u);if(!P)return;const B=await P.provideTerminalQuickFixes(m,h);if(B===null||Array.isArray(B)&&B.length===0)return;const z=new l.$Rc;if(this.w.value=z,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,z):void 0;const j=[];for(const V of B){const N=i.TerminalQuickFix.from(V,this.Q.converter,z);N&&j.push(N)}return j}async $createContributedProfileTerminal(u,m){const h=new a.$Xd().token;let P=await this.C.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(u,m){const h=this.W(u);if(!h)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const B=new a.$Xd;this.G.set(u,B);const z=[],j={terminal:h.value,line:m},V=[];for(const se of this.z)V.push(t.Promises.withAsyncBody(async X=>{B.token.onCancellationRequested(()=>X({provider:se,links:[]}));const Ee=await se.provideTerminalLinks(j,B.token)||[];B.token.isCancellationRequested||X({provider:se,links:Ee})}));const N=await Promise.all(V);if(B.token.isCancellationRequested)return[];const O=new Map;for(const se of N)se&&se.links.length>0&&z.push(...se.links.map(X=>{const Ee={id:v++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return O.set(Ee.id,{provider:se.provider,link:X}),Ee}));return this.F.set(u,O),z}$activateLink(u,m){const h=this.F.get(u)?.get(m);h&&h.provider.handleTerminalLink(h.link)}U(u,m){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const h=this.h[u];h&&(h.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}W(u){return this.X(this.f,u)}X(u,m){const h=this.Y(u,m);return h!==null?u[h]:null}Y(u,m){const h=u.findIndex(P=>P._id===m);return h===-1?null:h}getEnvironmentVariableCollection(u){let m=this.n.get(u.identifier.value);return m||(m=new r,this.$(u.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(u,m){const h=(0,k.$kr)(m.map),P=(0,k.$lr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,h.length===0?void 0:h,P)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const h=m[0],P=new r(m[1]);this.$(h,P)})}$acceptDefaultProfile(u,m){const h=this.s;this.s=u,this.u=m,h?.path!==u.path&&this.N.fire(u.path)}$(u,m){this.n.set(u,m),m.onDidChangeCollection(()=>{this.Z(u,m)})}};e.$Occ=n,e.$Occ=n=qe([Ve(1,c.$DM),Ve(2,A.$hM)],n);class r{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Nd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const m=this.h(u);let h=this.a.get(m);return h||(h=new s(this,u),this.a.set(m,h),h.onDidChangeCollection(()=>this.d.fire())),h}replace(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Replace,options:h??{applyAtProcessCreation:!0},scope:P})}append(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Append,options:h??{applyAtProcessCreation:!0},scope:P})}prepend(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Prepend,options:h??{applyAtProcessCreation:!0},scope:P})}f(u,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const h=this.g(u,m.scope),P=this.map.get(h),B=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==B.applyAtProcessCreation||P.options?.applyAtShellIntegration!==B.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const z=this.g(u,m.scope),j={variable:u,...m,options:B};this.map.set(z,j),this.d.fire()}}get(u,m){const h=this.g(u,m),P=this.map.get(h);return P?I(P):void 0}g(u,m){const h=this.h(m);return h.length?`${u}:::${h}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const m=new Map;for(const[h,P]of this.map)this.h(P.scope)===this.h(u)&&m.set(P.variable,I(P));return m}delete(u,m){const h=this.g(u,m);this.map.delete(h),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[m,h]of this.map)h.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,m){const h=this.h(m),P=this.descriptionMap.get(h);if(!P||P.description!==u){let B;typeof u=="string"?B=u:B=u?.value.split(`

`)[0];const z={description:B,scope:m};this.descriptionMap.set(h,z),this.d.fire()}}getDescription(u){const m=this.h(u);return this.descriptionMap.get(m)?.description}k(u){const m=this.h(u);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,m){this.b=u,this.d=m,this.a=new y.$Nd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,m,h){this.b.replace(u,m,h,this.d)}append(u,m,h){this.b.append(u,m,h,this.d)}prepend(u,m,h){this.b.prepend(u,m,h,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,m){this.b.getVariableMap(this.d).forEach((h,P)=>u.call(m,P,h,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(u,m){super(!1,u,m)}createTerminal(u,m,h){throw new R.$_}createTerminalFromOptions(u,m){throw new R.$_}};e.$Pcc=o,e.$Pcc=o=qe([Ve(0,c.$DM),Ve(1,A.$hM)],o);function w(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function d(S){return g.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[255],Re([1,0,284,12,26,19,5,203,93,6,24,15,36,3,17,104,8,7,46,76,57]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=e.$Xdc=e.$Wdc=void 0;let v=class{constructor(z,j,V){this.j=V,this.c=new A.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=z.getProxy(b.$gK.MainThreadTesting),this.h=new m(this.f),this.g=new o(this.f),j.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const O=N,se=O.tests[O.tests.length-1].item.extId;return this.d.get(c.$_I.root(se))?.collection.tree.get(se)?.actual??(0,g.$tM)(N)}case 18:{const{extId:O,message:se}=N;return{test:this.d.get(c.$_I.root(O))?.collection.tree.get(O)?.actual,message:t.TestMessage.to(se)}}default:return N}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await j.executeCommand("_testing.getExplorerSelection"),O=se=>{const X=this.d.get(c.$_I.root(se));if(X)return c.$_I.isRoot(se)?X.controller:X.collection.tree.get(se)?.actual};return{include:N?.include.map(O).filter(k.$Gf)||[],exclude:N?.exclude.map(O).filter(k.$Gf)||[]}})}createTestController(z,j,V,N){if(this.d.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const O=new f.$Rc,se=O.add(new g.$wM(j,V,this.j));se.root.label=V;const X=new Map,Ee=this.f,Pe={items:se.root.children,get label(){return V},set label(fe){V=fe,se.root.label=fe,Ee.$updateController(j,{label:V})},get refreshHandler(){return N},set refreshHandler(fe){N=fe,Ee.$updateController(j,{canRefresh:!!fe})},get id(){return j},createRunProfile:(fe,ye,ue,ae,ve,_)=>{let W=(0,D.$Di)(fe);for(;X.has(W);)W++;return new h(this.f,X,j,W,fe,ye,ue,ae,ve,_)},createTestItem(fe,ye,ue){return new g.$uM(j,fe,ye,ue)},createTestRun:(fe,ye,ue=!0)=>this.g.createTestRun(z,j,se,fe,ye,ue),invalidateTestResults:fe=>{if(fe===void 0)this.f.$markTestRetired(void 0);else{const ye=fe instanceof Array?fe:[fe];this.f.$markTestRetired(ye.map(ue=>c.$_I.fromExtHostTestItem(ue,j).toString()))}},set resolveHandler(fe){se.resolveHandler=fe},get resolveHandler(){return se.resolveHandler},dispose:()=>{O.dispose()}};Ee.$registerTestController(j,V,!!N),O.add((0,f.$Qc)(()=>Ee.$unregisterTestController(j)));const Se={controller:Pe,collection:se,profiles:X,extension:z};return this.d.set(j,Se),O.add((0,f.$Qc)(()=>this.d.delete(j))),O.add(se.onDidGenerateDiff(fe=>Ee.$publishDiff(j,fe.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.h.checkout()}async runTests(z,j=T.CancellationToken.None){const V=w(z);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.d.get(V.controllerId);if(!N)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:z.include?.map(O=>c.$_I.fromExtHostTestItem(O,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:P[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:z.exclude?.map(O=>O.id)},j)}$syncTests(){for(const{collection:z}of this.d.values())z.flushDiff();return Promise.resolve()}$provideFileCoverage(z,j,V){return(0,y.$rb)(this.g.trackers,O=>O.id===z?O.getCoverage(j):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(z,j,V,N){return(0,y.$rb)(this.g.trackers,se=>se.id===z?se.getCoverage(j):void 0)?.resolveFileCoverage(V,N)??Promise.resolve([])}$configureRunProfile(z,j){this.d.get(z)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(z,j){await this.d.get(z)?.controller.refreshHandler?.(j)}$publishTestResults(z){this.results=Object.freeze(z.map(j=>(0,R.$8m)(t.TestResults.to(j))).concat(this.results).sort((j,V)=>V.completedAt-j.completedAt).slice(0,32)),this.c.fire()}async $expandTest(z,j){const V=this.d.get(c.$_I.fromString(z).controllerId)?.collection;V&&(await V.expand(z,j<0?1/0:j),V.flushDiff())}$acceptDiff(z){this.h.applyDiff(z.map(E.TestsDiffOp.deserialize))}async $runControllerTests(z,j){return Promise.all(z.map(V=>this.k(V,!1,j)))}async $startContinuousRun(z,j){const V=new T.$Xd(j),N=await Promise.all(z.map(O=>this.k(O,!0,V.token)));return!j.isCancellationRequested&&!N.some(O=>O.error)&&await new Promise(O=>j.onCancellationRequested(O)),V.dispose(!0),N}async k(z,j,V){const N=this.d.get(z.controllerId);if(!N)return{};const{collection:O,profiles:se,extension:X}=N,Ee=se.get(z.profileId);if(!Ee)return{};const Pe=z.testIds.map(ue=>O.tree.get(ue)).filter(k.$Gf),Se=z.excludeExtIds.map(ue=>N.collection.tree.get(ue)).filter(k.$Gf).filter(ue=>Pe.some(ae=>ae.fullId.compare(ue.fullId)===2));if(!Pe.length)return{};const fe=new i.$QL(Pe.some(ue=>ue.actual instanceof g.$vM)?void 0:Pe.map(ue=>ue.actual),Se.map(ue=>ue.actual),Ee,j),ye=(0,E.$bJ)(z)&&this.g.prepareForMainThreadTestRun(fe,d.fromInternal(z,N.collection),X,V);try{return await Ee.runHandler(fe,V),{}}catch(ue){return{error:String(ue)}}finally{ye&&(ye.hasRunningTasks&&!V.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(z){z===void 0?this.g.cancelAllRuns():this.g.cancelRunById(z)}};e.$Wdc=v,e.$Wdc=v=qe([Ve(0,$.$hM)],v);const n=1e4;var r;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(r||(r={}));class s extends f.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(z,j,V){super(),this.m=z,this.s=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Nd),this.onEnd=this.j.event,this.h=this.B(new T.$Xd(V));const N=this.B(new M.$6g(()=>this.u(),n));this.B(this.h.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(z){return this.f.get(z)?.coverage}createRun(z){const j=this.m.id,V=this.m.controllerId,N=(0,a.$eg)(),O=new I(this.s,j,N),se=Se=>(fe,...ye)=>{if(Ee){console.warn(`Setting the state of test "${fe.id}" is a no-op after the run ends.`);return}this.m.isIncluded(fe)&&(this.y(fe),Se(fe,...ye))},X=(Se,fe)=>{const ye=fe instanceof Array?fe.map(t.TestMessage.from):[t.TestMessage.from(fe)];if(Se.uri&&Se.range){const ue={range:t.Range.from(Se.range),uri:Se.uri};for(const ae of ye)ae.location=ae.location||ue}this.s.$appendTestMessagesInRun(j,N,c.$_I.fromExtHostTestItem(Se,V).toString(),ye)};let Ee=!1;const Pe={isPersisted:this.m.isPersisted,token:this.h.token,name:z,get coverageProvider(){return O.coverageProvider},set coverageProvider(Se){O.coverageProvider=Se},enqueued:se(Se=>{this.s.$updateTestStateInRun(j,N,c.$_I.fromExtHostTestItem(Se,V).toString(),1)}),skipped:se(Se=>{this.s.$updateTestStateInRun(j,N,c.$_I.fromExtHostTestItem(Se,V).toString(),5)}),started:se(Se=>{this.s.$updateTestStateInRun(j,N,c.$_I.fromExtHostTestItem(Se,V).toString(),2)}),errored:se((Se,fe,ye)=>{X(Se,fe),this.s.$updateTestStateInRun(j,N,c.$_I.fromExtHostTestItem(Se,V).toString(),6,ye)}),failed:se((Se,fe,ye)=>{X(Se,fe),this.s.$updateTestStateInRun(j,N,c.$_I.fromExtHostTestItem(Se,V).toString(),4,ye)}),passed:se((Se,fe)=>{this.s.$updateTestStateInRun(j,N,c.$_I.fromExtHostTestItem(Se,this.m.controllerId).toString(),3,fe)}),appendOutput:(Se,fe,ye)=>{Ee||(ye&&(this.m.isIncluded(ye)?this.y(ye):ye=void 0),this.s.$appendOutputToRun(j,N,C.$be.fromString(Se),fe&&t.location.from(fe),ye&&c.$_I.fromExtHostTestItem(ye,V).toString()))},end:()=>{Ee||(Ee=!0,this.s.$finishedTestRunTask(j,N),this.f.delete(N),this.f.size||this.w())}};return this.f.set(N,{run:Pe,coverage:O}),this.s.$startedTestRunTask(j,{id:N,name:z,running:!0}),Pe}u(){for(const{run:z}of this.f.values())z.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(z){if(!(z instanceof g.$uM))throw new p.$_L(z.id);if(this.g.has(c.$_I.fromExtHostTestItem(z,this.m.controllerId).toString()))return;const j=[],V=this.m.colllection.root;for(;;){const N=t.TestItem.from(z);if(j.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),z===V))break;z=z.parent||V}this.s.$addTestsToRun(this.m.controllerId,this.m.id,j)}dispose(){this.w(),super.dispose()}}class o{get trackers(){return this.c.values()}constructor(z){this.d=z,this.c=new Map}prepareForMainThreadTestRun(z,j,V,N){return this.f(z,j,V,N)}cancelRunById(z){for(const j of this.c.values())if(j.id===z){j.cancel();return}}cancelAllRuns(){for(const z of this.c.values())z.cancel()}createTestRun(z,j,V,N,O,se){const X=this.c.get(N);if(X)return X.createRun(O);const Ee=d.fromPublic(j,V,N,se),Pe=w(N);this.d.$startedExtensionTestRun({controllerId:j,continuous:!!N.continuous,profile:Pe&&{group:P[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(fe=>c.$_I.fromExtHostTestItem(fe,V.root.id).toString())??[],id:Ee.id,include:N.include?.map(fe=>c.$_I.fromExtHostTestItem(fe,V.root.id).toString())??[V.root.id],persist:se});const Se=this.f(N,Ee,z);return A.Event.once(Se.onEnd)(()=>{this.d.$finishedExtensionTestRun(Ee.id),Se.dispose()}),Se.createRun(O)}f(z,j,V,N){const O=new s(j,this.d,N);return this.c.set(z,O),A.Event.once(O.onEnd)(()=>this.c.delete(z)),O}}e.$Xdc=o;const w=B=>{if(B.profile){if(!(B.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class d{static fromPublic(z,j,V,N){return new d(z,(0,a.$eg)(),V.include?.map(O=>c.$_I.fromExtHostTestItem(O,z).toString())??[z],V.exclude?.map(O=>c.$_I.fromExtHostTestItem(O,z).toString())??[],N,j)}static fromInternal(z,j){return new d(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,j)}constructor(z,j,V,N,O,se){this.controllerId=z,this.id=j,this.isPersisted=O,this.colllection=se,this.c=V.map(X=>X+"\0"),this.d=N.map(X=>X+"\0")}isIncluded(z){const j=c.$_I.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const V of this.d)if(j===V||j.startsWith(V))return!1;for(const V of this.c)if(j===V||j.startsWith(V))return!0;return!1}}e.$Ydc=d;class I{set coverageProvider(z){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");z&&(this.c=z,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(z,j,V){this.f=z,this.g=j,this.h=V}async provideFileCoverage(z){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(z))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.d=void 0,j}}async resolveFileCoverage(z,j){const V=await this.d;let N=V?.[z];return!this.c||!V||!N?[]:(N.detailedCoverage||(N=V[z]=await this.c.resolveFileCoverage?.(N,j)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class S{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(z){this.h=z,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(z){this.c.add(z)}update(z){Object.assign(z.revived,t.TestItem.toPlain(z.item)),this.c.has(z)||this.d.add(z)}remove(z){if(this.c.has(z)){this.c.delete(z);return}this.d.delete(z);const j=c.$_I.parentId(z.item.extId);if(j&&this.g.has(j.toString())){this.g.add(z.item.extId);return}this.f.add(z)}getChangeEvent(){const{c:z,d:j,f:V}=this;return{get added(){return[...z].map(N=>N.revived)},get updated(){return[...j].map(N=>N.revived)},get removed(){return[...V].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class u extends E.$gJ{constructor(){super(...arguments),this.q=new A.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(z){return this.d.get(z)}getMirroredTestDataByReference(z){return this.d.get(z.id)}p(z,j){return{...z,revived:t.TestItem.toPlain(z.item),depth:j?j.depth+1:0,children:new Set}}o(){return new S(this.q)}}class m{constructor(z){this.d=z}checkout(){this.c||(this.c=this.f());const z=this.c;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(j=>j.revived)},dispose:(0,l.$db)(()=>{--z.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(z){return this.c?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.c?.tests.apply(z)}f(){const z=new u;return this.d.$subscribeToDiffs(),{observers:0,tests:z}}}class h{#e;#t;get label(){return this.d}set label(z){z!==this.d&&(this.d=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(z){z!==this.g&&(this.g=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:z}))}get isDefault(){return this.f}set isDefault(z){z!==this.f&&(this.f=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:z?t.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.c}set configureHandler(z){z!==this.c&&(this.c=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!z}))}constructor(z,j,V,N,O,se,X,Ee=!1,Pe=void 0,Se=!1){this.controllerId=V,this.profileId=N,this.d=O,this.kind=se,this.runHandler=X,this.f=Ee,this._tag=Pe,this.g=Se,this.#e=z,this.#t=j,j.set(N,this);const fe=P[se];if(typeof fe!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:V,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:O,group:fe,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:Se})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Zdc=h;const P={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[256],Re([1,0,18,9,5,3,105,8,7]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class f{constructor(k,a){this.i=a,this.a=new C.$Nd({onListenerError:M.$2}),this.b=new C.$Nd({onListenerError:M.$2}),this.c=new C.$Nd({onListenerError:M.$2}),this.d=new C.$Nd({onListenerError:M.$2}),this.f=new C.$Nd({onListenerError:M.$2}),this.g=new C.$Nd({onListenerError:M.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(T.$gK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(b=>b.value)}async showTextDocument(k,a,b){let $;typeof a=="number"?$={position:l.ViewColumn.from(a),preserveFocus:b}:typeof a=="object"?$={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?l.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:$={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(k.uri,$),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new A.$oM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const b=this.i.getEditor(k);if(!b)throw new Error("unknown text editor");if(a.options&&b._acceptOptions(a.options),a.selections){const $=a.selections.selections.map(l.Selection.to);b._acceptSelections($)}if(a.visibleRanges){const $=y.$Hb(a.visibleRanges.map(l.Range.to));b._acceptVisibleRanges($)}if(a.options&&this.b.fire({textEditor:b.value,options:{...a.options,lineNumbers:l.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const $=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),g=a.selections.selections.map(l.Selection.to);this.a.fire({textEditor:b.value,selections:g,kind:$})}if(a.visibleRanges){const $=y.$Hb(a.visibleRanges.map(l.Range.to));this.c.fire({textEditor:b.value,visibleRanges:$})}}$acceptEditorPositionData(k){for(const a in k){const b=this.i.getEditor(a);if(!b)throw new Error("Unknown text editor");const $=l.ViewColumn.to(k[a]);b.value.viewColumn!==$&&(b._acceptViewColumn($),this.d.fire({textEditor:b.value,viewColumn:$}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$cdc=f}),define(Ae[257],Re([1,0,2,4,3,6,7,8,21,15]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0,e.$Qdc=(0,M.$Ph)("IExtHostTimeline");class R{constructor(b,$){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$gK.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&D.$6l.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:y.URI.revive(g.uri);return this.c.get(g.source)?.get(k(i))?.get(g.handle)}else return;return g}})}async $getTimeline(b,$,g,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive($),g,t)}registerTimelineProvider(b,$,g,t){const i=new T.$Rc,c=this.d($.id,t,i).bind(this);let p;$.onDidChange&&(p=$.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:$.id}),this));const E=this.c;return this.f({...$,scheme:b,onDidChange:void 0,async provideTimeline(v,n,r){n?.resetCache&&(i.clear(),E.get($.id)?.clear());const s=await $.provideTimeline(v,n,r);if(s==null)return;const o=c(v,n);return{...s,source:$.id,items:s.items.map(o)}},dispose(){for(const v of E.values())v.get($.id)?.clear();p?.dispose(),i.dispose()}},g)}d(b,$,g){return(t,i)=>{let c;if(i?.cacheResults){let p=this.c.get(b);p===void 0&&(p=new Map,this.c.set(b,p));const E=k(t);c=p.get(E),c===void 0&&(c=new Map,p.set(E,c))}return p=>{const{iconPath:E,...v}=p,n=`${b}|${p.id??p.timestamp}`;c?.set(n,p);let r,s,o;p.iconPath&&(E instanceof A.$cL?o={id:E.id,color:E.color}:y.URI.isUri(E)?(r=E,s=E):{light:r,dark:s}=E);let w;return A.$IK.isMarkdownString(v.tooltip)?w=l.MarkdownString.from(v.tooltip):(0,f.$yf)(v.tooltip)?w=v.tooltip:A.$IK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.MarkdownString.from(v.detail)):(0,f.$yf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=v.detail),{...v,id:v.id??void 0,handle:n,source:b,command:p.command?$.toInternal(p.command,g):void 0,icon:r,iconDark:s,themeIcon:o,tooltip:w,accessibilityInformation:p.accessibilityInformation}}}}f(b,$){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:$}),(0,T.$Qc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Rdc=R;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,19,5,6,157,4,14,184,3,27,17,7]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6vb=e.$5vb=e.TunnelDtoConverter=void 0;class b extends D.$gv{}var $;(function(t){function i(p){return{remoteAddress:p.remoteAddress,localAddress:p.localAddress,public:!!p.public,privacy:p.privacy??(p.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:p.protocol}}t.fromApiTunnel=i;function c(p){return{remoteAddress:{host:p.tunnelRemoteHost,port:p.tunnelRemotePort},localAddress:p.localAddress,public:p.privacy!==D.TunnelPrivacyId.ConstantPrivate&&p.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:p.privacy,protocol:p.protocol}}t.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$5vb=(0,A.$Ph)("IExtHostTunnelService");let g=class extends C.$Sc{constructor(i,c,p){super(),this.s=p,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$gK.MainThreadTunnelService)}async openTunnel(i,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const p=await this.a.$openTunnel(c,i.displayName);if(p){const E=new b(p.remoteAddress,p.localAddress,()=>this.a.$closeTunnel(p.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,c){const p=this.u();return this.r.set(p,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,p),new a.$iK(()=>{this.r.delete(p),this.a.$unregisterPortsAttributesProvider(p)})}async $providePortAttributes(i,c,p,E,v){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(c.map(async w=>{let d;try{d=await o.provider.providePortAttributes({port:w,pid:p,commandLine:E},v)}catch{d=await o.provider.providePortAttributes(w,p,E,v)}return{providedAttributes:d,port:w}})))}const r=n.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await i.provideTunnel(E,v,new y.$Xd().token)??void 0;const p=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(p),Promise.resolve((0,C.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const p=i.tunnelFactory??(c?this.w(c):void 0);if(p){this.b=p;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const v=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const p=this.g.get(i.host);p.has(i.port)&&(c&&p.get(i.port).disposeListener.dispose(),await p.get(i.port).tunnel.dispose(),p.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const p=this.b(i,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),p!==void 0){const E=await p;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:v}),$.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(p){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),p instanceof Error)return p.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),p=i.filter((E,v)=>c[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${p.map(E=>E.port).join(", ")}`),p}};e.$6vb=g,e.$6vb=g=qe([Ve(0,k.$hM),Ve(1,R.$xM),Ve(2,l.$0i)],g)}),define(Ae[258],Re([1,0,6,13,2,3]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(T.$gK.MainThreadUriOpeners)}registerExternalUriOpener(D,f,R,k){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const a=k.schemes.find(b=>!A.a.has(b));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(f,R),this.b.$registerUriOpener(f,k.schemes,D,k.label),(0,y.$Qc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(D,f,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const a=C.URI.revive(f);return k.canOpenExternalUri(a,R)}async $openUri(D,f,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(C.URI.revive(f.resolvedUri),{sourceUri:C.URI.revive(f.sourceUri)},R)}}e.$1dc=A}),define(Ae[259],Re([1,0,3,2,6,9,21]),function(we,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;class l{static{this.a=0}constructor(f){this.c=new A.$7l,this.d=new Map,this.b=f.getProxy(y.$gK.MainThreadUrls)}registerUriHandler(f,R){const k=f.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=l.a++;return this.c.add(k),this.d.set(a,R),this.b.$registerUriHandler(a,k,f.displayName||f.name),(0,C.$Qc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(f,R){const k=this.d.get(f);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(a){(0,T.$1)(a)}return Promise.resolve(void 0)}async createAppUri(f){return M.URI.revive(await this.b.$createAppUri(f))}}e.$edc=l}),define(Ae[64],Re([1,0,5,6,13,24,2,169,191,77,3]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=e.$hdc=e.$gdc=e.$fdc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,v,n,r,s,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Nd,this._onDidDispose=this.#h.event,this.#e=E,this.#t=v,this.#r=n,this.#l=r,this.#u=s,this.#n=o,this.#c=a(o),this.#d=b(o),this.#i=w}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,f.$9ob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+f.$8ob}return f.$8ob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),T.$$m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,D.$ycb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,w,d,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(d)}),u=(0,f.$9ob)(S,{isRemote:v,authority:n}).toString();return`${s}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,w,d,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(d)}),u=(0,f.$9ob)(S,{isRemote:v,authority:n}).toString();return`${s}${u}${I}`})}}e.$fdc=k;function a(p){try{const E=(0,l.$No)((0,l.$Mo)(p.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$gdc=a;function b(p){try{const E=(0,l.$No)((0,l.$Mo)(p.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends M.$Sc{constructor(E,v,n,r,s){super(),this.c=v,this.f=n,this.g=r,this.h=s,this.b=new Map,this.a=E.getProxy(R.$gK.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,n){const r=this.j(E);if(r){const{message:s}=(0,D.$zcb)(v,n.value);r._onMessageEmitter.fire(s)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,n){const r=new k(E,this.a,i(v),this.c,this.f,n,this.h);this.b.set(E,r);const s=r._onDidDispose(()=>{s.dispose(),this.deleteWebview(E)});return r}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$hdc=$;function g(p){return{id:p.identifier,location:p.extensionLocation}}e.$idc=g;function t(p,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||c(p,E)}}e.$jdc=t;function i(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(E=>A.URI.from(E))}}function c(p,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),p.extensionLocation]}}),define(Ae[260],Re([1,0,19,93,6,13,23,2,8,64,74,3,7]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class b{constructor(r,s){this.document=r,this.b=s,this.a=1,this.c=new R.$bcc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,s){await this.f(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.f(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=v(this.document.uri)+this.a++;return(0,A.$vg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const s=this.c.get(r,0);if(!s)throw new Error("No edit found");return s}}class ${constructor(){this.a=new Map}get(r,s){return this.a.get(this.b(r,s))}add(r,s,o){const w=this.b(r,s.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const d=new b(s,o);return this.a.set(w,d),d}delete(r,s){const o=this.b(r,s.uri);this.a.delete(o)}b(r,s){return`${r}@@@${s}`}}var g;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(r,s,o){return this.b(0,r,s,o)}addCustomProvider(r,s,o){return this.b(1,r,s,o)}get(r){return this.a.get(r)}b(r,s,o,w){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:r,extension:o,provider:w}),new a.$iK(()=>this.a.delete(s))}}class i{constructor(r,s,o,w,d){this.d=s,this.f=o,this.g=w,this.h=d,this.b=new t,this.c=new $,this.a=r.getProxy(k.$gK.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,o,w){const d=new C.$Rc;return p(o)?(d.add(this.b.addTextProvider(s,r,o)),this.a.$registerTextEditorProvider((0,f.$idc)(r),s,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$gdc)(r))):(d.add(this.b.addCustomProvider(s,r,o)),c(o)&&d.add(o.onDidChangeCustomDocument(I=>{const S=this.i(s,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,s,u,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,f.$idc)(r),s,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,f.$gdc)(r))),a.$iK.from(d,new a.$iK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,o,w,d){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const S=l.URI.revive(r),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:w?.buffer},d);let m;return c(I.provider)&&this.f&&(m=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,u,m),{editable:c(I.provider)}}async $disposeCustomDocument(r,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const w=l.URI.revive(r),{document:d}=this.i(s,w);this.c.delete(s,d),d.dispose()}async $resolveCustomEditor(r,s,o,w,d,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=D.ViewColumn.to(d),m=this.g.createNewWebview(s,w.contentOptions,S.extension),h=this.h.createNewWebviewPanel(s,o,w.title,u,w.options,m,w.active),P=l.URI.revive(r);switch(S.type){case 1:{const{document:B}=this.i(o,P);return S.provider.resolveCustomEditor(B,h,I)}case 0:{const B=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(B,h,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,o){this.i(s,r).disposeEdits(o)}async $onMoveCustomEditor(r,s,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this.h.getWebviewPanel(r);if(!d)throw new Error("No webview found");const I=l.URI.revive(s),S=this.d.getDocument(I);await w.provider.moveCustomTextEditor(S,d,y.CancellationToken.None)}async $undo(r,s,o,w){return this.i(s,r).undo(o,w)}async $redo(r,s,o,w){return this.i(s,r).redo(o,w)}async $revert(r,s,o){const w=this.i(s,r);await this.j(s).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(r,s,o){const w=this.i(s,r);await this.j(s).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(r,s,o,w){const d=this.i(s,r);return this.j(s).saveCustomDocumentAs(d.document,l.URI.revive(o),w)}async $backup(r,s,o){const w=this.i(s,r),I=await this.j(s).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(I),I.id}i(r,s){const o=this.c.get(r,l.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$Udc=i;function c(n){return!!n.onDidChangeCustomDocument}function p(n){return typeof n.resolveCustomTextEditor=="function"}function E(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function v(n){const r=n.scheme===T.Schemas.file||n.scheme===T.Schemas.untitled?n.fsPath:n.toString();return(0,M.$Di)(r)+""}}),define(Ae[261],Re([1,0,5,6,2,36,8,64,3,7]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class R extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,g,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new y.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=g,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!g})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Sc{static c(){return(0,T.$eg)()}constructor($,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(D.$gK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,g,t,i,c={}){const p=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from(p),preserveFocus:typeof i=="object"&&!!i.preserveFocus},v=(0,l.$gdc)($),n=k.c();this.f.$createWebviewPanel((0,l.$idc)($),n,g,{title:t,panelOptions:a(c),webviewOptions:(0,l.$jdc)($,this.m,c),serializeBuffersForPostMessage:v},E);const r=this.j.createNewWebview(n,c,$);return this.createNewWebviewPanel(n,g,t,p,c,r,!0)}$onDidChangeWebviewPanelViewStates($){const g=Object.keys($);g.sort((t,i)=>{const c=$[t],p=$[i];return c.active?1:p.active?-1:+c.visible-+p.visible});for(const t of g){const i=this.getWebviewPanel(t);if(!i)continue;const c=$[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:$}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,l.$gdc)($)}),new f.$iK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel($,g,t,i){const c=this.h.get(g);if(!c)throw new Error(`No serializer found for '${g}'`);const{serializer:p,extension:E}=c,v=this.j.createNewWebview($,t.webviewOptions,E),n=this.createNewWebviewPanel($,g,t.title,i,t.panelOptions,v,t.active);await p.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel($,g,t,i,c,p,E){const v=new R($,this.f,p,{viewType:g,title:t,viewColumn:i,panelOptions:c,active:E});return this.g.set($,v),v}getWebviewPanel($){return this.g.get($)}}e.$Tdc=k;function a(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[262],Re([1,0,5,6,64,8,3,7]),function(we,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class D extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,b,$,g,t){super(),this.#u=!1,this.#a=this.B(new y.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$Nd),this.onDidDispose=this.#c.event,this.#i=b,this.#s=$,this.#e=k,this.#t=a,this.#l=g,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=T.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$gK.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,b,$){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:b,extension:k}),this.a.$registerWebviewViewProvider((0,C.$idc)(k),a,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$gdc)(k)}),new l.$iK(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,b,$,g){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:c}=t,p=this.d.createNewWebview(k,{},c),E=new D(k,this.a,a,b,p,!0);this.c.set(k,E),await i.resolveWebviewView(E,{state:$},g)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$Sdc=f}),define(Ae[108],Re([1,0,5,3,2,13,16,4,17,25]),function(we,e,y,M,C,T,A,l,D,f){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(b){const $=this.d;return{get focused(){return $.focused},get active(){return(0,f.$eF)(b,"windowActivity"),$.active}}}constructor(b){this.c=new y.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=b.getProxy(M.$gK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:g})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,$){$!==this.d[b]&&(this.d={...this.d,[b]:$},this.c.fire(this.d))}openUri(b,$){let g;if(typeof b=="string"){g=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Be)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,g,$)}async asExternalUri(b,$){if((0,A.$Be)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(b,$);return C.URI.from(g)}};e.$kdc=k,e.$kdc=k=R=qe([Ve(0,D.$hM)],k),e.$ldc=(0,l.$Ph)("IExtHostWindow")}),define(Ae[263],Re([1,0,228,27,17]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;let T=class extends y.$lec{constructor(l,D){super(l,D)}f(l,D,f){D.apply(console,f)}};e.$sgc=T,e.$sgc=T=qe([Ve(0,C.$hM),Ve(1,M.$xM)],T)}),define(Ae[264],Re([1,0,12,26,19,9,5,6,132,216,47]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$u4b=e.ResponsiveState=e.RequestInitiator=e.$t4b=e.$s4b=void 0;function a(h,P){try{return JSON.stringify(h,P)}catch{return"null"}}const b="$$ref$$",$={[b]:-1};class g{constructor(P,B){this.jsonString=P,this.referencedBuffers=B}}function t(h,P=null,B=!1){const z=[];return{jsonString:(B?a:JSON.stringify)(h,(V,N)=>{if(typeof N>"u")return $;if(typeof N=="object"){if(N instanceof M.$be){const O=z.push(N)-1;return{[b]:O}}if(P)return P(V,N)}return N}),referencedBuffers:z}}e.$s4b=t;function i(h,P,B){return JSON.parse(h,(z,j)=>{if(j){const V=j[b];if(typeof V=="number")return P[V];if(B&&j.$mid===1)return B.transformIncoming(j)}return j})}e.$t4b=i;function c(h,P){return JSON.stringify(h,P)}function p(h){return h?(P,B)=>B&&B.$mid===1?h.transformOutgoing(B):B:null}var E;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const n=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends l.$Sc{static{k=r}static{this.a=3*1e3}constructor(P,B=null,z=null){super(),this[k]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=B,this.g=z,this.h=p(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,V=R.$nv.count;j<V;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$6g(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const B=this.w[P];delete this.w[P],B.resolveErr(T.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,D.$Om)(P,this.g):P}getProxy(P){const{nid:B,sid:z}=P;return this.s[B]||(this.s[B]=this.J(B,z)),this.s[B]}J(P,B){const z={get:(j,V)=>(typeof V=="string"&&!j[V]&&V.charCodeAt(0)===36&&(j[V]=(...N)=>this.U(P,V,N)),V===s?B:j[V])};return new Proxy(Object.create(null),z)}set(P,B){return this.m[P.nid]=B,B}assertRegistered(P){for(let B=0,z=P.length;B<z;B++){const j=P[B];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(P){if(this.j)return;const B=P.byteLength,z=d.read(P,0),j=z.readUInt8(),V=z.readUInt32();switch(j){case 1:case 2:{let{rpcId:N,method:O,args:se}=S.deserializeRequestJSONArgs(z);this.g&&(se=(0,D.$Om)(se,this.g)),this.M(B,V,N,O,se,j===2);break}case 3:case 4:{let{rpcId:N,method:O,args:se}=S.deserializeRequestMixedArgs(z);this.g&&(se=(0,D.$Om)(se,this.g)),this.M(B,V,N,O,se,j===4);break}case 5:{this.f?.logIncoming(B,V,0,"ack"),this.G(V);break}case 6:{this.N(B,V);break}case 7:{this.O(B,V,void 0);break}case 9:{let N=S.deserializeReplyOKJSON(z);this.g&&(N=(0,D.$Om)(N,this.g)),this.O(B,V,N);break}case 10:{const N=S.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(B,V,N);break}case 8:{const N=S.deserializeReplyOKVSBuffer(z);this.O(B,V,N);break}case 11:{let N=S.deserializeReplyErrError(z);this.g&&(N=(0,D.$Om)(N,this.g)),this.P(B,V,N);break}case 12:{this.P(B,V,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,B,z,j,V,N){this.f?.logIncoming(P,B,1,`receiveRequest ${(0,R.$pv)(z)}.${j}(`,V);const O=String(B);let se,X;if(N){const Pe=new C.$Xd;V.push(Pe.token),se=this.Q(z,j,V),X=()=>Pe.cancel()}else se=this.Q(z,j,V),X=n;this.u[O]=X;const Ee=S.serializeAcknowledged(B);this.f?.logOutgoing(Ee.byteLength,B,1,"ack"),this.c.send(Ee),se.then(Pe=>{delete this.u[O];const Se=S.serializeReplyOK(B,Pe,this.h);this.f?.logOutgoing(Se.byteLength,B,1,"reply:",Pe),this.c.send(Se)},Pe=>{delete this.u[O];const Se=S.serializeReplyErr(B,Pe);this.f?.logOutgoing(Se.byteLength,B,1,"replyErr:",Pe),this.c.send(Se)})}N(P,B){this.f?.logIncoming(P,B,1,"receiveCancel");const z=String(B);this.u[z]?.()}O(P,B,z){this.f?.logIncoming(P,B,0,"receiveReply:",z);const j=String(B);if(!this.w.hasOwnProperty(j))return;const V=this.w[j];delete this.w[j],V.resolveOk(z)}P(P,B,z){this.f?.logIncoming(P,B,0,"receiveReplyErr:",z);const j=String(B);if(!this.w.hasOwnProperty(j))return;const V=this.w[j];delete this.w[j];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),V.resolveErr(N)}Q(P,B,z){try{return Promise.resolve(this.S(P,B,z))}catch(j){return Promise.reject(j)}}S(P,B,z){const j=this.m[P];if(!j)throw new Error("Unknown actor "+(0,R.$pv)(P));const V=j[B];if(typeof V!="function")throw new Error("Unknown method "+B+" on actor "+(0,R.$pv)(P));return V.apply(j,z)}U(P,B,z){if(this.j)return new f.$r4b;let j=null;if(z.length>0&&C.CancellationToken.isCancellationToken(z[z.length-1])&&(j=z.pop()),j&&j.isCancellationRequested)return Promise.reject(T.$6());const V=S.serializeRequestArguments(z,this.h),N=++this.t,O=String(N),se=new f.$q4b,X=new l.$Rc;j&&X.add(j.onCancellationRequested(()=>{const Pe=S.serializeCancel(N);this.f?.logOutgoing(Pe.byteLength,N,0,"cancel"),this.c.send(S.serializeCancel(N))})),this.w[O]=new w(se,X),this.F(N);const Ee=S.serializeRequest(N,P,B,V,!!j);return this.f?.logOutgoing(Ee.byteLength,N,0,`request: ${(0,R.$pv)(P)}.${B}(`,z),this.c.send(Ee),se}}e.$u4b=o;class w{constructor(P,B){this.a=P,this.b=B}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,B,z){const j=new d(M.$be.alloc(z+1+4),0);return j.writeUInt8(P),j.writeUInt32(B),j}static read(P,B){return new d(P,B)}get buffer(){return this.a}constructor(P,B){this.a=P,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+P);return this.b+=P,B}static sizeMixedArray(P){let B=0;B+=1;for(let z=0,j=P.length;z<j;z++){const V=P[z];switch(B+=1,V.type){case 1:B+=this.sizeLongString(V.value);break;case 2:B+=this.sizeVSBuffer(V.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(V.value);for(let N=0;N<V.buffers.length;++N)B+=this.sizeVSBuffer(V.buffers[N]);break;case 4:break}}return B}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let B=0,z=P.length;B<z;B++){const j=P[B];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let V=0;V<j.buffers.length;++V)this.writeBuffer(j.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const B=new Array(P);for(let z=0;z<P;z++)switch(this.readUInt8()){case 1:B[z]=this.readLongString();break;case 2:B[z]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),N=this.readLongString(),O=[];for(let se=0;se<V;++se)O.push(this.readVSBuffer());B[z]=new R.$qv(i(N,O,null));break}case 4:B[z]=void 0;break}return B}}var I;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(I||(I={}));class S{static a(P){for(let B=0,z=P.length;B<z;B++)if(P[B]instanceof M.$be||P[B]instanceof R.$qv||typeof P[B]>"u")return!0;return!1}static serializeRequestArguments(P,B){if(this.a(P)){const z=[];for(let j=0,V=P.length;j<V;j++){const N=P[j];if(N instanceof M.$be)z[j]={type:2,value:N};else if(typeof N>"u")z[j]={type:4};else if(N instanceof R.$qv){const{jsonString:O,referencedBuffers:se}=t(N.value,B);z[j]={type:3,value:M.$be.fromString(O),buffers:se}}else z[j]={type:1,value:M.$be.fromString(c(N,B))}}return{type:1,args:z}}return{type:0,args:c(P,B)}}static serializeRequest(P,B,z,j,V){switch(j.type){case 0:return this.b(P,B,z,j.args,V);case 1:return this.c(P,B,z,j.args,V)}}static b(P,B,z,j,V){const N=M.$be.fromString(z),O=M.$be.fromString(j);let se=0;se+=d.sizeUInt8(),se+=d.sizeShortString(N),se+=d.sizeLongString(O);const X=d.alloc(V?2:1,P,se);return X.writeUInt8(B),X.writeShortString(N),X.writeLongString(O),X.buffer}static deserializeRequestJSONArgs(P){const B=P.readUInt8(),z=P.readShortString(),j=P.readLongString();return{rpcId:B,method:z,args:JSON.parse(j)}}static c(P,B,z,j,V){const N=M.$be.fromString(z);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(N),O+=d.sizeMixedArray(j);const se=d.alloc(V?4:3,P,O);return se.writeUInt8(B),se.writeShortString(N),se.writeMixedArray(j),se.buffer}static deserializeRequestMixedArgs(P){const B=P.readUInt8(),z=P.readShortString(),j=P.readMixedArray(),V=new Array(j.length);for(let N=0,O=j.length;N<O;N++){const se=j[N];typeof se=="string"?V[N]=JSON.parse(se):V[N]=se}return{rpcId:B,method:z,args:V}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,B,z){if(typeof B>"u")return this.d(P);if(B instanceof M.$be)return this.e(P,B);if(B instanceof R.$qv){const{jsonString:j,referencedBuffers:V}=t(B.value,z,!0);return this.g(P,j,V)}else return this.f(P,a(B,z))}static d(P){return d.alloc(7,P,0).buffer}static e(P,B){let z=0;z+=d.sizeVSBuffer(B);const j=d.alloc(8,P,z);return j.writeVSBuffer(B),j.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,B){const z=M.$be.fromString(B);let j=0;j+=d.sizeLongString(z);const V=d.alloc(9,P,j);return V.writeLongString(z),V.buffer}static g(P,B,z){const j=M.$be.fromString(B);let V=0;V+=d.sizeUInt32,V+=d.sizeLongString(j);for(const O of z)V+=d.sizeVSBuffer(O);const N=d.alloc(10,P,V);N.writeUInt32(z.length),N.writeLongString(j);for(const O of z)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(P){const B=P.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(P,B){const z=P.readUInt32(),j=P.readLongString(),V=[];for(let N=0;N<z;++N)V.push(P.readVSBuffer());return new R.$qv(i(j,V,B))}static serializeReplyErr(P,B){const z=B?a(T.$3(B),null):void 0;if(typeof z!="string")return this.h(P);const j=M.$be.fromString(z);let V=0;V+=d.sizeLongString(j);const N=d.alloc(11,P,V);return N.writeLongString(j),N.buffer}static deserializeReplyErrError(P){const B=P.readLongString();return JSON.parse(B)}static h(P){return d.alloc(12,P,0).buffer}}var u;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(m||(m={}))}),define(Ae[265],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;const y=function(T){const A=l=>{globalThis.removeEventListener("message",A);const D=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,R){D.postMessage(f,R)}},onmessage:{get(){return D.onmessage},set(f){D.onmessage=f}}}),D.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(T,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${y})('${A}'))`,f=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(f),k=new MessageChannel,a=R,b={type:"_newWorker",id:a,port:k.port2,url:R,options:l};T(b,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{T({type:"_terminateWorker",id:a}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set($){k.port1.onmessage=$}},onmessageerror:{get(){return k.port1.onmessageerror},set($){k.port1.onmessageerror=$}}}),k.port1.addEventListener("messageerror",$=>{const g=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(g)}),k.port1.addEventListener("message",$=>{const g=new MessageEvent("message",{data:$.data});this.dispatchEvent(g)}),k.port1.start()}}e.$ugc=M}),define(Ae[266],Re([1,0,5,30,32,4]),function(we,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.OutputChannelUpdateMode=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=void 0,e.$rJ="text/x-code-output",e.$sJ="output",e.$tJ="Log",e.$uJ="text/x-code-log-output",e.$vJ="log",e.$wJ="workbench.panel.output",e.$xJ=new C.$7i("inOutput",!1),e.$yJ=new C.$7i("activeLogOutput",!1),e.$zJ=new C.$7i("outputView.scrollLock",!1),e.$AJ=(0,T.$Ph)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$BJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new y.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(R=>f.push(R)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}M.$gn.add(e.$BJ.OutputChannels,new l),e.$CJ=new C.$7i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,21,14,266,62,27,40,129,26,15,39,5,6]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=void 0;class i extends A.$dj{get disposed(){return this.n}constructor(v,n,r,s,o){super(),this.id=v,this.name=n,this.r=r,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const n=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(v,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:n))}hide(){this.s.$close(this.id)}g(v,n){this.m+=a.$be.fromString(n).byteLength,(0,A.log)(this.r,v,n),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends i{appendLine(v){this.append(v)}}let p=class{constructor(v,n,r,s,o,w){this.i=n,this.j=r,this.k=s,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(y.$gK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(v,n,r){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,b.$yf)(n)?n:void 0;if((0,b.$yf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const d=this.i.environment.extensionLogLevel?.find(([S])=>T.$6l.equals(r.identifier,S))?.[1];d&&(w=(0,A.$nj)(d));const I=s?this.o(v,w,r):this.n(v,o,r);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),s?this.r(v,w??this.m.getLevel(),I):this.q(v,I)}async n(v,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(v,o,n,r.identifier.value);return new i(d,v,w,this.a,r)}async o(v,n,r){const s=await this.p(r),o=v.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(s,`${o}.log`),d=`${r.identifier.value}.${o}`,I=this.l.createLogger(w,{id:d,name:v,logLevel:n,extensionId:r.identifier.value});return new c(d,v,I,this.a,r)}p(v){let n=this.d.get(v.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(s){if((0,$.$ok)(s)!==$.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return n}q(v,n){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return v},append(o){s(),n.then(w=>w.append(o))},appendLine(o){s(),n.then(w=>w.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(w=>w.replace(o))},show(o,w){s(),n.then(d=>d.show(o,w))},hide(){s(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}r(v,n,r){const s=new t.$Rc,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},w=s.add(new g.$Nd);function d(I){n=I,w.fire(I)}return r.then(I=>{s.add(I),I.logLevel!==n&&d(I.logLevel),s.add(I.onDidChangeLogLevel(S=>d(S)))}),{...this.q(v,r),get logLevel(){return n},onDidChangeLogLevel:w.event,trace(I,...S){o(),r.then(u=>u.trace(I,...S))},debug(I,...S){o(),r.then(u=>u.debug(I,...S))},info(I,...S){o(),r.then(u=>u.info(I,...S))},warn(I,...S){o(),r.then(u=>u.warn(I,...S))},error(I,...S){o(),r.then(u=>u.error(I,...S))},dispose(){s.dispose()}}}};e.$7cc=p,e.$7cc=p=qe([Ve(0,C.$hM),Ve(1,f.$xM),Ve(2,D.$Jcc),Ve(3,R.$ecc),Ve(4,A.$$i),Ve(5,A.$0i)],p),e.$8cc=(0,M.$Ph)("IExtHostOutputService")}),define(Ae[267],Re([1,0,4,12]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,y.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let l=0;l<this.maxSampleCount;l++){const D=await C.getRoundTripTime();if(D===void 0)return;T=Math.min(T,D/2),await(0,M.$Ug)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((l,D)=>l+D,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((l,D)=>l+D,0)/this.average.length,high:(()=>typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[268],Re([1,0,44,13,20,22,23,2,4,186,55,209,267]),function(we,e,y,M,C,T,A,l,D,f,R,k,a){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=void 0,e.$UJ=(0,D.$Ph)("pathService");let $=b=class{constructor(t,i,c,p){this.d=t,this.e=i,this.f=c,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(p=>this.h(t,p,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,y.$Vf)(c??(0,A.$sg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const c=(0,f.$RJ)(i.getWorkspace());if(c)return c;const p=i.getWorkspace().folders[0];if(p)return p.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$fc:C.$gc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const p=t.indexOf("/",2);p===-1?(i=t.substring(2),t="/"):(i=t.substring(2,p),t=t.substring(p)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$VJ=$,e.$VJ=$=b=qe([Ve(1,a.$tm),Ve(2,k.$DJ),Ve(3,R.$Yh)],$)}),define(Ae[110],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$CI=e.$BI=void 0;class y{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new y(0,0)}with(A){return new y(0,0)}}e.$BI=y;class M{constructor(A,l,D,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,l),this.end=new y(D,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$CI=M;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[48],Re([1,0,18,38,24,44,16,4,20,9,110,12]),function(we,e,y,M,C,T,A,l,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.SearchErrorCode=e.$RI=e.$QI=e.SearchSortOrder=e.ViewMode=e.$PI=e.$OI=e.$NI=e.$MI=e.SearchCompletionExitCode=e.$LI=e.$KI=e.$JI=e.QueryType=e.SearchProviderType=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$DI="workbench.view.search",e.$EI="workbench.panel.search",e.$FI="workbench.view.search",e.$GI="search-result",e.$HI="search.exclude";const a="\u27EA ",b=" characters skipped \u27EB",$=(a.length+b.length+5)*2;e.$II=(0,l.$Ph)("searchService");var g;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(fe){return!!fe.preview}e.$JI=i;function c(fe){return!!fe.resource}e.$KI=c;function p(fe){return!!fe.message}e.$LI=p;var E;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(ye){this.resource=ye,this.results=[]}}e.$MI=v;class n{constructor(ye,ue,ae,ve){this.ranges=ue,this.webviewIndex=ve;const _=Array.isArray(ue)?ue:[ue];if(ae&&ae.matchLines===1&&r(_)){ye=(0,A.$rf)(ye,ae.matchLines);let W="",Z=0,ee=0;const pe=Math.floor(ae.charsPerLine/5),$e=[];for(const he of _){const De=Math.max(he.startColumn-pe,0),ne=he.startColumn+ae.charsPerLine;if(De>ee+pe+$){const le=a+(De-ee)+b;W+=le+ye.slice(De,ne),Z+=De-(ee+le.length)}else W+=ye.slice(ee,ne);$e.push(new o(0,he.startColumn-Z,he.endColumn-Z)),ee=ne}this.preview={text:W,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const W=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ye,matches:(0,y.$2b)(ue,Z=>new s(Z.startLineNumber-W,Z.startColumn,Z.endLineNumber-W,Z.endColumn))}}}}e.$NI=n;function r(fe){const ye=fe[0].startLineNumber;for(const ue of fe)if(ue.startLineNumber!==ye||ue.endLineNumber!==ye)return!1;return!0}class s{constructor(ye,ue,ae,ve){this.startLineNumber=ye,this.startColumn=ue,this.endLineNumber=ae,this.endColumn=ve}}e.$OI=s;class o extends s{constructor(ye,ue,ae){super(ye,ue,ye,ae)}}e.$PI=o;var w;(function(fe){fe.List="list",fe.Tree="tree"})(w||(e.ViewMode=w={}));var d;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function I(fe,ye=!0){const ue=fe&&fe.files&&fe.files.exclude,ae=ye&&fe&&fe.search&&fe.search.exclude;if(!ue&&!ae)return;if(!ue||!ae)return ue||ae;let ve=Object.create(null);return ve=C.$0m(ve,C.$7m(ue)),ve=C.$0m(ve,C.$7m(ae),!0),ve}e.$QI=I;function S(fe,ye){return fe.excludePattern&&M.$vj(fe.excludePattern,ye)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&M.$vj(fe.includePattern,ye)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(ue=>{const ae=ue.folder.fsPath;if(T.$Xf(ye,ae)){const ve=D.$lc(ae,ye);return!ue.includePattern||!!M.$vj(ue.includePattern,ve)}else return!1}):!1:!0}e.$RI=S;var u;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class m extends Error{constructor(ye,ue){super(ye),this.code=ue}}e.$SI=m;function h(fe){const ye=fe.message;if((0,f.$4)(fe))return new m(ye,u.canceled);try{const ue=JSON.parse(ye);return new m(ue.message,ue.code)}catch{return new m(ye,u.other)}}e.$TI=h;function P(fe){const ye={message:fe.message,code:fe.code};return new Error(JSON.stringify(ye))}e.$UI=P;function B(fe){return fe.type==="error"?!0:fe.type==="success"}e.$VI=B;function z(fe){return fe.type==="success"}e.$WI=z;function j(fe){return!!fe.path}e.$XI=j;function V(fe,ye){const ue=fe.searchPath?fe.searchPath:fe.relativePath;return(0,A.$of)(ue,ye)}e.$YI=V;class N{constructor(ye){this.path=ye,this.results=[]}addMatch(ye){this.results.push(ye)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$ZI=N;function O(fe,ye){const ue={...fe||{},...ye||{}};return Object.keys(ue).filter(ae=>{const ve=ue[ae];return typeof ve=="boolean"&&ve})}e.$1I=O;class se{constructor(ye,ue){this.c=null,this.a={...ye.excludePattern||{},...ue.excludePattern||{}},this.b=M.$wj(this.a);let ae=ye.includePattern;ue.includePattern&&(ae?ae={...ae,...ue.includePattern}:ae=ue.includePattern),ae&&(this.c=M.$wj(ae))}matchesExcludesSync(ye,ue,ae){return!!(this.b&&this.b(ye,ue,ae))}includedInQuerySync(ye,ue,ae){return!(this.b&&this.b(ye,ue,ae)||this.c&&!this.c(ye,ue,ae))}includedInQuery(ye,ue,ae){const ve=this.b(ye,ue,ae),_=()=>this.c?!!this.c(ye,ue,ae):!0;return(0,k.$Gg)(ve)?ve.then(W=>W?!1:_()):_()}hasSiblingExcludeClauses(){return X(this.a)}}e.$2I=se;function X(fe){for(const ye in fe)if(typeof fe[ye]!="boolean")return!0;return!1}function Ee(fe){if(!fe)return;let ye;return ue=>(ye||(ye=(fe()||Promise.resolve([])).then(ae=>ae?Se(ae):{})),ye.then(ae=>!!ae[ue]))}e.$3I=Ee;function Pe(fe){if(!fe)return;let ye;return ue=>{if(!ye){const ae=fe();ye=ae?Se(ae):{}}return!!ye[ue]}}e.$4I=Pe;function Se(fe){const ye={};for(const ue of fe)ye[ue]=!0;return ye}}),define(Ae[33],Re([1,0,18,12,19,5,6,49,13,117,23,16,2,158,4,14,175,55,40,27,17,8,7,56,48,3]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=e.$qcc=void 0;function w(B,z,j){return new R.$kg(V=>u(V,j)).isEqual(B,z)}function d(B,z,j){return w(B.uri,z.uri,j)?0:(0,k.$Ue)(B.uri.toString(),z.uri.toString())}function I(B,z,j){return B.index!==z.index?B.index<z.index?-1:1:w(B.uri,z.uri,j)?(0,k.$Ue)(B.name,z.name):(0,k.$Ue)(B.uri.toString(),z.uri.toString())}function S(B,z,j,V){const N=B.slice(0).sort((se,X)=>j(se,X,V)),O=z.slice(0).sort((se,X)=>j(se,X,V));return(0,y.$Eb)(N,O,(se,X)=>j(se,X,V))}function u(B,z){const j=z.getCapabilities(B.scheme);return!(j&&j&1024)}class m extends i.$9h{static toExtHostWorkspace(z,j,V,N){if(!z)return{workspace:null,added:[],removed:[]};const{id:O,name:se,folders:X,configuration:Ee,transient:Pe,isUntitled:Se}=z,fe=[],ye=j;j?X.forEach((_,W)=>{const Z=a.URI.revive(_.uri),ee=m.o(V||j,Z,N);ee?(ee.name=_.name,ee.index=_.index,fe.push(ee)):fe.push({uri:Z,name:_.name,index:W})}):fe.push(...X.map(({uri:_,name:W,index:Z})=>({uri:a.URI.revive(_),name:W,index:Z}))),fe.sort((_,W)=>_.index<W.index?-1:1);const ue=new m(O,se,fe,!!Pe,Ee?a.URI.revive(Ee):null,!!Se,_=>u(_,N)),{added:ae,removed:ve}=S(ye?ye.workspaceFolders:[],ue.workspaceFolders,d,N);return{workspace:ue,added:ae,removed:ve}}static o(z,j,V){for(let N=0;N<z.folders.length;N++){const O=z.workspaceFolders[N];if(w(O.uri,j,V))return O}}constructor(z,j,V,N,O,se,X){super(z,V.map(Ee=>new i.$0h(Ee)),N,O,X),this.t=j,this.u=se,this.q=[],this.s=l.$Vh.forUris(X),V.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,j){return j&&this.s.get(z)&&(z=(0,R.$ug)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let h=class{constructor(z,j,V,N,O){this.c=new T.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new T.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$Pd,this.B=new Map,this.h=N,this.s=V,this.t=O,this.j=new f.$Ql,this.k=new M.$Sg,this.o=z.getProxy(o.$gK.MainThreadWorkspace),this.q=z.getProxy(o.$gK.MainThreadMessageService);const se=j.workspace;this.l=se?new m(se.id,se.name,[],!!se.transient,se.configuration?a.URI.revive(se.configuration):null,!!se.isUntitled,X=>u(X,V)):void 0}$initializeWorkspace(z,j){this.v=j,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,j,V,...N){const O=[];if(Array.isArray(N)&&N.forEach(Se=>{a.URI.isUri(Se.uri)&&!O.some(fe=>w(fe.uri,Se.uri,this.s))&&O.push({uri:Se.uri,name:Se.name||(0,R.$rg)(Se.uri)})}),this.n||[j,V].some(Se=>typeof Se!="number"||Se<0)||V===0&&O.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(j+V>se.length)return!1;const X=se.slice(0);X.splice(j,V,...O.map(Se=>({uri:Se.uri,name:Se.name||(0,R.$rg)(Se.uri),index:void 0})));for(let Se=0;Se<X.length;Se++){const fe=X[Se];if(X.some((ye,ue)=>ue!==Se&&w(fe.uri,ye.uri,this.s)))return!1}X.forEach((Se,fe)=>Se.index=fe);const{added:Ee,removed:Pe}=S(se,X,I,this.s);if(Ee.length===0&&Pe.length===0)return!1;if(this.o){const Se=z.displayName||z.name;this.o.$updateWorkspaceFolders(Se,j,V,O).then(void 0,fe=>{this.n=void 0;const ye={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Se,fe.toString()),ye,[])})}return this.y(X),!0}getWorkspaceFolder(z,j){if(this.x)return this.x.getWorkspaceFolder(z,j)}async getWorkspaceFolder2(z,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,j)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,j){let V,N="";if(typeof z=="string"?(V=a.URI.file(z),N=z):typeof z<"u"&&(V=z,N=z.fsPath),!V)return N;const O=this.getWorkspaceFolder(V,!0);if(!O)return N;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let se=(0,R.$xg)(O.uri,V);return j&&O.name&&(se=`${O.name}/${se}`),se}y(z){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:j,added:V,removed:N}=m.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:V,removed:N}))}findFiles(z,j,V,N,O=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let se;if(j===null?se=!1:j&&(typeof j=="string"?se=j:se=j.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Ee}=P(v.GlobPattern.from(z));return this.o.$startFileSearch(X??null,Ee??null,se??null,V??null,O).then(Pe=>Array.isArray(Pe)?Pe.map(Se=>a.URI.revive(Se)):[])}async findTextInFiles(z,j,V,N,O=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),X=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Ee,folder:Pe}=P(v.GlobPattern.from(j.include)),Se=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,fe={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:X,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Ee,excludePattern:Se},ye=!1;if(this.u[se]=ue=>{if(ye)return;const ae=a.URI.revive(ue.resource);ue.results.forEach(ve=>{(0,s.$JI)(ve)?V({uri:ae,preview:{text:ve.preview.text,matches:(0,y.$2b)(ve.preview.matches,_=>new n.$kK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,y.$2b)(ve.ranges,_=>new n.$kK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):V({uri:ae,text:ve.text,lineNumber:ve.lineNumber})})},O.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(z,Pe??null,fe,se,O);return delete this.u[se],ue||{}}catch(ue){throw delete this.u[se],ue}}$handleTextSearchResult(z,j){this.u[j]?.(z)}async save(z){const j=await this.o.$save(z,{saveAs:!1});return a.URI.revive(j)}async saveAs(z){const j=await this.o.$save(z,{saveAs:!0});return a.URI.revive(j)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,j){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,j);const V=this.t.transformOutgoingScheme(z),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,V),(0,A.$Qc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(z,j){this.h.info("Getting edit session identifier for workspaceFolder",z);const V=await this.resolveWorkspaceFolder(a.URI.revive(z));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const N=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!N),!N)return;const O=await N.provideEditSessionIdentity(V,j);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(z,j,V,N){this.h.info("Getting edit session identifier for workspaceFolder",z);const O=await this.resolveWorkspaceFolder(a.URI.revive(z));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const se=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!se),!se)return;const X=await se.provideEditSessionIdentityMatch?.(j,V,N);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(z){return(j,V,N)=>{const O=function(X){j.call(V,X)};return O.extension=z,this.A.event(O,void 0,N)}}async $onWillCreateEditSessionIdentity(z,j,V){const N=await this.resolveWorkspaceFolder(a.URI.revive(z));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},j,async(O,se)=>{const X=Date.now();await Promise.resolve(O),Date.now()-X>V&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(z,j){if(this.B.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.B.set(z,j);const V=this.t.transformOutgoingScheme(z),N=this.z++;return this.o.$registerCanonicalUriProvider(N,V),(0,A.$Qc)(()=>{this.B.delete(z),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(z,j,V){const N=this.B.get(z.scheme);if(!N)return;const O=await N.provideCanonicalUri?.(a.URI.revive(z),j,V);if(O)return O}async $provideCanonicalUri(z,j,V){return this.provideCanonicalUri(a.URI.revive(z),{targetScheme:j},V)}};e.$qcc=h,e.$qcc=h=qe([Ve(0,E.$hM),Ve(1,p.$xM),Ve(2,c.$ecc),Ve(3,g.$0i),Ve(4,r.$occ)],h),e.$rcc=(0,$.$Ph)("IExtHostWorkspace");function P(B){let z,j;return B&&(typeof B=="string"?z=B:(z=B.pattern,j=a.URI.revive(B.baseUri))),{includePattern:z,folder:j}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,15,12,4,17,14,2]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=e.$scc=void 0;function g(r,s){if(s){const o=s.split(".");let w=r;for(let d=0;w&&d<o.length;d++)w=w[o[d]];return w}}function t(r){return r instanceof $.URI}function i(r){return r&&r.uri instanceof $.URI&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function p(r){return r&&r.uri instanceof $.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function E(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(c(r))return{overrideIdentifier:r.languageId};if(p(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,o,w){this.a=s.getProxy(T.$gK.MainThreadConfiguration),this.c=o,this.b=w,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(s,o))}};e.$scc=v,e.$scc=v=qe([Ve(0,a.$hM),Ve(1,C.$rcc),Ve(2,b.$0i)],v);class n{constructor(s,o,w,d){this.a=new M.$Nd,this.b=s,this.f=d,this.c=o,this.e=l.$En.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$En.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(s,o,w){const d=E(o)||{},I=this.g(s?g(this.e.getValue(void 0,d,this.c.workspace),s):this.e.getValue(void 0,d,this.c.workspace));s&&this.h(s,d,w?.identifier);function S(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(m){return typeof g(I,m)<"u"},get:(m,h)=>{this.h(s?`${s}.${m}`:m,d,w?.identifier);let P=g(I,m);if(typeof P>"u")P=h;else{let B;const z=(j,V)=>{if((0,f.$Af)(j)){let N;const O=()=>{B=B||(0,y.$7m)(I),N=N||g(B,V)};return new Proxy(j,{get:(se,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return O(),()=>N;if(B)return N=N||g(B,V),N[X];const Ee=se[X];return typeof X=="string"?z(Ee,`${V}.${X}`):Ee},set:(se,X,Ee)=>(O(),N&&(N[X]=Ee),!0),deleteProperty:(se,X)=>(O(),N&&delete N[X],!0),defineProperty:(se,X,Ee)=>(O(),N&&Object.defineProperty(N,X,Ee),!0)})}return Array.isArray(j)?(0,y.$7m)(j):j};P=z(P,m)}return P},update:(m,h,P,B)=>{m=s?`${s}.${m}`:m;const z=S(P);return h!==void 0?this.b.$updateConfigurationOption(z,m,h,d,B):this.b.$removeConfigurationOption(z,m,d,B)},inspect:m=>{m=s?`${s}.${m}`:m;const h=this.e.inspect(m,d,this.c.workspace);if(h)return{key:m,defaultValue:(0,y.$7m)(h.policy?.value??h.default?.value),globalValue:(0,y.$7m)(h.user?.value??h.application?.value),workspaceValue:(0,y.$7m)(h.workspace?.value),workspaceFolderValue:(0,y.$7m)(h.workspaceFolder?.value),defaultLanguageValue:(0,y.$7m)(h.default?.override),globalLanguageValue:(0,y.$7m)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,y.$7m)(h.workspace?.override),workspaceFolderLanguageValue:(0,y.$7m)(h.workspaceFolder?.override),languageIds:(0,y.$7m)(h.overrideIdentifiers)}}};return typeof I=="object"&&(0,y.$0m)(u,I,!1),Object.freeze(u)}g(s){const o=w=>(0,f.$Af)(w)?new Proxy(w,{get:(d,I)=>o(d[I]),set:(d,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(d,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(d,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(s)}h(s,o,w){const d=D.$vn.test(s)?4:this.d.get(s),I=w?`[${w.value}] `:"";if(d===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const w=new l.$Gn(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,I)=>w.affectsConfiguration(d,E(I))})}k(s){return s.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$tcc=n,e.$ucc=(0,k.$Ph)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,19,63,17,27,4,13,22,14,80,215,9]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=e.$qdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(z){function j(N){if(N!=null)return N}z.from=j;function V(N){if(N!=null)return N}z.to=V})(v||(v={}));var n;(function(z){function j(N){if(N!=null)return N}z.from=j;function V(N){if(N!=null)return N}z.to=V})(n||(n={}));var r;(function(z){function j(N){if(N!=null)return N}z.from=j;function V(N){if(N!=null)return N}z.to=V})(r||(r={}));var s;(function(z){function j(O){if(O){const se=O;return se&&!!se.process}else return!1}z.is=j;function V(O){if(O==null)return;const se={process:O.process,args:O.args};return O.options&&(se.options=r.from(O.options)),se}z.from=V;function N(O){if(O!=null)return new A.$3K(O.process,O.args,O.options)}z.to=N})(s||(s={}));var o;(function(z){function j(N){if(N!=null)return N}z.from=j;function V(N){if(N!=null)return N}z.to=V})(o||(o={}));var w;(function(z){function j(O){if(O){const se=O;return se&&(!!se.commandLine||!!se.command)}else return!1}z.is=j;function V(O){if(O==null)return;const se={};return O.commandLine!==void 0?se.commandLine=O.commandLine:(se.command=O.command,se.args=O.args),O.options&&(se.options=o.from(O.options)),se}z.from=V;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$4K(O.commandLine,O.options):new A.$4K(O.command,O.args?O.args:[],O.options)}z.to=N})(w||(w={}));var d;(function(z){function j(O){if(O){const se=O;return se&&se.customExecution==="customExecution"}else return!1}z.is=j;function V(O){return{customExecution:"customExecution"}}z.from=V;function N(O,se){return se.get(O)}z.to=N})(d||(e.CustomExecutionDTO=d={}));var I;(function(z){function j(V,N){let O;return V.scope!==void 0&&typeof V.scope!="number"?O=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=p.$PF),{id:V._id,workspaceFolder:O}}z.from=j})(I||(e.TaskHandleDTO=I={}));var S;(function(z){function j(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}z.from=j})(S||(S={}));var u;(function(z){function j(O,se){if(O==null)return[];const X=[];for(const Ee of O){const Pe=V(Ee,se);Pe&&X.push(Pe)}return X}z.fromMany=j;function V(O,se){if(O==null)return;let X;O.execution instanceof A.$3K?X=s.from(O.execution):O.execution instanceof A.$4K?X=w.from(O.execution):O.execution&&O.execution instanceof A.$5K&&(X=d.from(O.execution));const Ee=v.from(O.definition);let Pe;return O.scope?typeof O.scope=="number"?Pe=O.scope:Pe=O.scope.uri:Pe=A.TaskScope.Workspace,!Ee||!Pe?void 0:{_id:O._id,definition:Ee,name:O.name,source:{extensionId:se.identifier.value,label:O.source,scope:Pe},execution:X,isBackground:O.isBackground,group:S.from(O.group),presentationOptions:n.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=V;async function N(O,se,X){if(O==null)return;let Ee;s.is(O.execution)?Ee=s.to(O.execution):w.is(O.execution)?Ee=w.to(O.execution):d.is(O.execution)&&(Ee=d.to(O._id,X));const Pe=v.to(O.definition);let Se;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Se=O.source.scope:Se=await se.resolveWorkspaceFolder(y.URI.revive(O.source.scope)):Se=A.TaskScope.Workspace),!Pe||!Se)return;const fe=new A.$6K(Pe,Se,O.name,O.source.label,Ee,O.problemMatchers);return O.isBackground!==void 0&&(fe.isBackground=O.isBackground),O.group!==void 0&&(fe.group=A.$2K.from(O.group._id),fe.group&&O.group.isDefault&&(fe.group=new A.$2K(fe.group.id,fe.group.label),O.group.isDefault===!0&&(fe.group.isDefault=O.group.isDefault))),O.presentationOptions&&(fe.presentationOptions=n.to(O.presentationOptions)),O._id&&(fe._id=O._id),O.detail&&(fe.detail=O.detail),fe}z.to=N})(u||(e.TaskDTO=u={}));var m;(function(z){function j(N){return N}z.from=j;function V(N){if(N)return Object.assign(Object.create(null),N)}z.to=V})(m||(m={}));class h{#e;constructor(j,V,N){this._id=V,this.a=N,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let P=class{constructor(j,V,N,O,se,X,Ee,Pe){this.q=new C.$Nd,this.r=new C.$Nd,this.s=new C.$Nd,this.t=new C.$Nd,this.a=j.getProxy(T.$gK.MainThreadTask),this.b=N,this.c=O,this.d=se,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=Pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,V,N){if(!N)return new A.$iK(()=>{});const O=this.w();return this.j.set(O,{type:V,provider:N,extension:j}),this.a.$registerTaskProvider(O,V),new A.$iK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(j,V){this.a.$registerTaskSystem(j,V)}fetchTasks(j){return this.a.$fetchTasks(m.from(j)).then(async V=>{const N=[];for(const O of V){const se=await u.to(O,this.b,this.m);se&&N.push(se)}return N})}get taskExecutions(){const j=[];return this.k.forEach(V=>j.push(V)),j}terminateTask(j){if(!(j instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,V,N){const O=this.m.get(j.id);O&&(this.o.set(j.id,O),this.e.attachPtyToTerminal(V,await O.callback(N))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const V=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:V})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const V=await this.y(j.id);this.s.fire({execution:V,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const V=await this.y(j.id);this.t.fire({execution:V,exitCode:j.exitCode})}$provideTasks(j,V){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));const O=[],se=(0,M.$Mg)(()=>N.provider.provideTasks(R.CancellationToken.None)).then(X=>this.u(V,O,N,X));return new Promise(X=>{se.then(Ee=>{Promise.all(O).then(()=>{X(Ee)})})})}async $resolveTask(j,V){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));if(V.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await u.to(V,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const se=await N.provider.resolveTask(O,R.CancellationToken.None);if(!se)return;this.z(se,N);const X=u.from(se,N.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(se.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(X.execution)&&await this.x(X,se,!0),await this.v(X)}w(){return this.h++}async x(j,V,N){const O=await this.a.$createTaskId(j);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,V.execution)),this.m.set(O,V.execution)}async y(j,V){if(typeof j=="string"){const se=this.l.get(j);if(!se)throw new E.$bb("Unexpected: The specified task is missing an execution");return se}const N=this.l.get(j.id);if(N)return N;const O=new Promise((se,X)=>{function Ee(Pe,Se,fe){fe?se(new h(Pe,Se.id,fe)):X("Unexpected: Task does not exist.")}V?Ee(this,j,V):u.to(j.task,this.b,this.m).then(Pe=>Ee(this,j,Pe))});return this.l.set(j.id,O),O.then(se=>(this.k.set(j.id,se),se),se=>Promise.reject(se))}z(j,V){j._deprecated&&this.g.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$qdc=P,e.$qdc=P=qe([Ve(0,a.$hM),Ve(1,b.$xM),Ve(2,l.$rcc),Ve(3,D.$sM),Ve(4,f.$ucc),Ve(5,k.$Mcc),Ve(6,i.$0i),Ve(7,c.$hcc)],P);let B=class extends P{constructor(j,V,N,O,se,X,Ee,Pe){super(j,V,N,O,se,X,Ee,Pe),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(j,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const N=u.from(V,j);if(N===void 0)throw new Error("Task is not valid");if(d.is(N.execution))await this.x(N,V,!1);else throw new E.$_;const O=await this.y(await this.a.$getTaskExecution(N),V);return this.a.$executeTask(N).catch(se=>{throw new Error(se)}),O}u(j,V,N,O){const se=[];if(O)for(const X of O){this.z(X,N),(!X.definition||!j[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=u.from(X,N.extension);Ee&&d.is(Ee.execution)?(se.push(Ee),V.push(this.x(Ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:se,extension:N.extension}}async v(j){if(d.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,V,N){}};e.$rdc=B,e.$rdc=B=qe([Ve(0,a.$hM),Ve(1,b.$xM),Ve(2,l.$rcc),Ve(3,D.$sM),Ve(4,f.$ucc),Ve(5,k.$Mcc),Ve(6,i.$0i),Ve(7,c.$hcc)],B),e.$sdc=(0,$.$Ph)("IExtHostTask")}),define(Ae[269],Re([1,0,20,19,37,38,23,59,48]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class f{constructor(a,b,$){this.k=a,this.l=b,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&T.$wj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&T.$wj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const b=this.k.folderQueries||[];return new Promise(($,g)=>{const t=i=>{this.f++,a(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),p=y.$nc(c);this.j&&this.j(c,p)||this.v(t,{base:i,basename:p})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,C.$Ai)(i)))})})}async p(a,b){const $=new M.$Xd,g=this.q(a),t=this.r(),i=new D.$2I(this.k,a),c=!i.hasSiblingExcludeClauses();let p;try{this.h.add($),p=l.$Jd.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,$.token),v=p.elapsed(),n=l.$Jd.create();return this.g&&!this.e||(E&&E.forEach(r=>{const s=y.$gc.relative(a.folder.path,r.path);if(c){const o=y.$nc(r.path);this.v(b,{base:a.folder,relativePath:s,basename:o});return}this.s(t,a.folder,s,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:v,postProcessTime:n.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(a){const b=(0,D.$1I)(this.k.includePattern,a.includePattern),$=(0,D.$1I)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:$,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},b,$,g){if($===this.a){const i=y.$nc(this.a);this.v(g,{base:b,relativePath:this.a,basename:i})}function t(i){const c=y.$nc(i),p=y.$mc(i);let E=a[p];E||(E=a[p]=[],t(p)),E.push({base:b,relativePath:i,basename:c})}t($)}u({rootEntries:a,pathToEntries:b},$,g){const t=this,i=this.a;function c(p){const E=(0,D.$4I)(()=>p.map(v=>v.basename));for(let v=0,n=p.length;v<n;v++){const r=p[v],{relativePath:s,basename:o}=r;if($.matchesExcludesSync(s,o,i!==o?E:void 0))continue;const w=b[s];if(w)c(w);else{if(s===i)continue;t.v(g,r)}if(t.e)break}}c(a)}v(a,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(b))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,b,$,g){const t=this.c(a.cacheKey),i=new f(a,b,t&&t.token);let c=0;const p=E=>{c+=E.length,$(E.map(v=>this.d(v)))};return this.e(i,R.a,p,g).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:E.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Xd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$vg(a.base,a.relativePath)}:{resource:a.base}}e(a,b,$,g){const t=g.onCancellationRequested(()=>{a.cancel()}),i=p=>{p&&(c.push(p),b>0&&c.length>=b&&($(c),c=[]))};let c=[];return a.search(i).then(p=>(c.length&&$(c),t.dispose(),p),p=>(c.length&&$(c),t.dispose(),Promise.reject(p)))}}e.$Cdc=R}),define(Ae[270],Re([1,0,18,233,38,90,28,13,20,23,16,15,2,285,167,45,14,55,102,268,48]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=void 0;let v=class{constructor(m,h,P,B,z){this.a=m,this.b=h,this.c=P,this.d=B,this.e=z}text(m,h,P={}){m=this.f(m,P);const B=this.a.getValue(),z=h&&h.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.h(h?.map(i.$$h),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:B.search.usePCRE2||z||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,h){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const B={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,h)&&(B.isCaseSensitive=!0),this.k(m)&&(B.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),B}file(m,h={}){return{...this.h(m,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(m,h){return m?(m=Array.isArray(m)?m.map(w):w(m),h?this.parseSearchPaths(m):{pattern:r(...Array.isArray(m)?m:[m])}):{}}h(m=[],h={}){const P=this.g(h.includePattern,h.expandPatterns),B=this.g(h.excludePattern,h.expandPatterns),z=m.length>1,j=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,h,B)):m.map(O=>this.r(O,h,B,z))).filter(O=>!!O),V={_reason:h._reason,folderQueries:j,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:B.pattern,includePattern:P.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const O=y.$Hb(y.$Rb(this.c.groups.map(Ee=>Ee.editors.map(Pe=>Pe.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const se=O.filter(Ee=>(0,E.$RI)(V,Ee.fsPath)),X=this.i(se);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...V,...X}}const N=h.extraFileResources&&h.extraFileResources.filter(O=>(0,E.$RI)(V,O.fsPath));return V.extraFileResources=N&&N.length?N:void 0,V}i(m){const h=[],P=new A.$Ac,B={};let z=!1;return m.forEach(j=>{if(j.scheme===l.Schemas.walkThrough)return;if((0,f.$zg)(j)){const N=this.b.getWorkspaceFolder(j)?.uri??j.with({path:D.$mc(j.fsPath)});let O=P.get(N);O||(z=!0,O={folder:N,includePattern:{}},h.push(O),P.set(N,O));const se=D.$lc(N.fsPath,j.fsPath);(0,k.$Jf)(O.includePattern)[se.replace(/\\/g,"/")]=!0}else j.fsPath&&(z=!0,B[j.fsPath]=!0)}),{folderQueries:h,includePattern:B,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(m,h){if(h.isSmartCase){if(m.isRegExp){if(R.$pf(m.pattern,!0))return!0}else if(R.$pf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,b.$uB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const h=X=>D.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),B=(Array.isArray(m)?m:s(m)).map(X=>{const Ee=this.e.resolvedUserHome;return Ee?(0,T.$uv)(X,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):X}),z=M.$J(B,X=>h(X)?"searchPaths":"exprSegments"),j=(z.exprSegments||[]).map(X=>R.$Ke(X,"/")).map(X=>R.$Ke(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),V={},N=this.m(z.searchPaths||[]);N&&N.length&&(V.searchPaths=N);const O=y.$Rb(j),se=r(...O);return se&&(V.pattern=se),V}l(m,h){return h.disregardExcludeSettings?void 0:(0,E.$QI)(m,!h.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const h=m.flatMap(B=>{let{pathPortion:z,globPortion:j}=n(B);return j&&(j=d(j)),this.n(z).flatMap(N=>this.o(N,j))}),P=new Map;return h.forEach(B=>{const z=B.searchPath.toString(),j=P.get(z);j?B.pattern&&(j.pattern=j.pattern||{},j.pattern[B.pattern]=!0):P.set(z,{searchPath:B.searchPath,pattern:B.pattern?r(B.pattern):void 0})}),Array.from(P.values())}n(m){if(D.$ic(m)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==l.Schemas.file?[{searchPath:h[0].uri.with({path:m})}]:[{searchPath:a.URI.file(D.$hc(m))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(m=w(m),m.startsWith("../")||m===".."){const B=D.$gc.resolve(h.path,m);return[{searchPath:h.with({path:B})}]}const P=d(m);return[{searchPath:h,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const h=m.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(z=>{const j=h.match(new RegExp(`^${R.$Fe(z.name)}(?:/(.*)|$)`));return j?{match:j,folder:z}:null}).filter(k.$Gf);if(B.length)return B.map(z=>{const j=z.match[1];return{searchPath:z.folder.uri,pattern:j&&d(j)}});{const z=m.match(/\.[\/\\](.+)[\/\\]?/),j=z?z[1]:m,V=$.localize(0,null,j);throw new Error(V)}}}}o(m,h){const P=m.pattern&&h?`${m.pattern}/${h}`:m.pattern||h,B=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&B.push({searchPath:m.searchPath,pattern:P+"/**"}),B}q(m,h,P){const B=this.r((0,i.$$h)(m.searchPath),h,P,!1);return B?{...B,includePattern:m.pattern}:null}r(m,h,P,B){let z;const j=a.URI.isUri(m)?m:m.uri;if(P.searchPaths){const X=P.searchPaths.filter(Ee=>(0,f.$og)(Ee.searchPath,j))[0];if(X&&!X.pattern)return null;X&&(z=X.pattern)}const V=this.a.getValue({resource:j}),O={...this.l(V,h)||{},...z||{}},se=a.URI.isUri(m)?(0,f.$sg)(m):m.name;return{folder:j,folderName:B?se:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!V.search.followSymlinks}}};e.$WJ=v,e.$WJ=v=qe([Ve(0,g.$ji),Ve(1,i.$Yh),Ve(2,c.$eC),Ve(3,t.$0i),Ve(4,p.$UJ)],v);function n(u){const m=u.match(/[\*\{\}\(\)\[\]\?]/);if(m){const h=m.index,P=u.substr(0,h).match(/[/|\\][^/\\]*$/);if(P){let B=u.substr(0,P.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:u.substr((P.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((m,h)=>(m[h]=!0,m),Object.create(null)):void 0}function s(u){return C.$uj(u,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function w(u){return u.replace(/\\/g,"/")}function d(u){return w(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,m){u=y.$Mb(u,B=>B.toString());const h=[],P=m.getWorkspace();return u&&u.forEach(B=>{let z;if(m.getWorkbenchState()===2)z=(0,f.$xg)(P.folders[0].uri,B),z&&z!=="."&&(z="./"+z);else{const j=m.getWorkspaceFolder(B);if(j){const V=j.name;if(P.folders.filter(O=>O.name===V).length===1){const O=(0,f.$xg)(j.uri,B);O===""?z=`./${j.name}`:z=`./${j.name}/${O}`}else z=B.fsPath}}z&&h.push(I(z))}),h}e.$XJ=S}),define(Ae[271],Re([1,0,23,2,19,9,4,270,48,55]),function(we,e,y,M,C,T,A,l,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlb=e.$ylb=void 0;const R=7e3;function k(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],p=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||g.forceUsingSearch?p.push(w):c.push(w)}if(c.length===0&&p.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,w)=>{E=o}),n=o=>E({activationEvent:o}),r=Promise.all(c.map(o=>a(g,o,n))).then(()=>{}),s=b(g,t.identifier,p,n);return Promise.all([r,s]).then(()=>{E(void 0)}),v}e.$ylb=k;async function a(g,t,i){for(const c of g.folders)if(await g.exists(y.$vg(M.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function b(g,t,i,c){if(i.length===0)return Promise.resolve(void 0);const p=new C.$Xd,E=g.checkExists(g.folders,i,p.token),v=setTimeout(async()=>{p.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let n=!1;try{n=await E}catch(r){T.$4(r)||T.$1(r)}p.dispose(),clearTimeout(v),n&&c(`workspaceContains:${i.join(",")}`)}function $(g,t,i,c){const p=g.get(A.$Oh),E=g.get(D.$II),n=p.createInstance(l.$WJ).file(t.map(r=>(0,f.$$h)(M.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(n,c).then(r=>!!r.limitHit,r=>T.$4(r)?!1:Promise.reject(r))}e.$zlb=$}),define(Ae[35],Re([1,0,148,20,87,23,12,6,49,2,14,3,34,210,84,33,25,106,9,21,26,188,7,97,4,27,85,17,71,86,63,5,271,83,190,13,81,59,22,82]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n,r,s,o,w,d,I,S,u,m,h,P,B,z,j,V,N,O){"use strict";var se;Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=e.$Zcc=e.$Ycc=e.$Xcc=void 0,e.$Xcc=(0,s.$Ph)("IHostUtils");let X=se=class extends l.$Sc{constructor(_,W,Z,ee,pe,$e,he,De,ne,le,ie,oe){super(),this.X=oe,this.a=this.B(new m.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=Z,this.f=he,this.j=ee,this.m=pe,this.s=$e,this.t=ne,this.u=le,this.w=ie,this.y=this.g.getProxy(k.$gK.MainThreadWorkspace),this.z=this.g.getProxy(k.$gK.MainThreadTelemetry),this.C=this.g.getProxy(k.$gK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new ae(this.f.extensions.activationEvents),this.L=new i.$l4b(this.I,this.f.extensions.allExtensions);const ge=new p.$7l(this.f.extensions.myExtensions);this.J=new i.$l4b(this.I,ye(this.L,ge)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Se(this.J)}`)),this.M=new $.$Ecc(this.g,this.s),this.N=new P.$Qcc(this.g),this.O=De,this.h=_.createChild(new I.$Nh([$.$Fcc,this.M],[P.$Rcc,this.N])),this.P=this.B(new b.$Dcc(this.J,this.L,{onExtensionActivationError:(Ie,F,K)=>{this.C.$onExtensionActivationError(Ie,c.$3(F),K)},actualActivateExtension:async(Ie,F)=>{if(i.$l4b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,F),new b.$Ccc;const K=this.J.getExtensionDescription(Ie);return this.db(K,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){c.$1(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.cb(pe))}catch{}await Promise.all(_)}terminate(_,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(ee=>{this.s.error(ee)}),this.g.dispose();const Z=this.Y();Promise.race([(0,A.$Ug)(5e3),Z]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const W=await this.C.$getExtension(_);return W&&{...W,identifier:new p.$6l(W.identifier.value),extensionLocation:f.URI.revive(W.extensionLocation)}}Z(_,W){return this.P.activateByEvent(_,W)}$(_,W){return this.P.activateById(_,W)}activateByIdWithErrors(_,W){return this.$(_,W).then(()=>{const Z=this.P.getActivatedExtension(_);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===z.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(_.fsPath);return f.URI.file(W)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ue(_))),this.Q}async bb(_){const W=D.$Vh.forUris(Z=>T.$mg.ignorePathCasing(Z));return await Promise.all(_.map(async Z=>{if(this.ub(Z)){const ee=await this.ab(Z.extensionLocation);W.set(ee,Z)}})),W}cb(_){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return W;const Z=this.P.getActivatedExtension(_);if(!Z)return W;try{typeof Z.module.deactivate=="function"&&(W=Promise.resolve(Z.module.deactivate()).then(void 0,ee=>(this.s.error(ee),Promise.resolve(void 0))))}catch(ee){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(ee)}try{(0,l.$Nc)(Z.subscriptions)}catch(ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(ee)}return W}async db(_,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,W).then(Z=>{const ee=Z.activationTimes;return this.C.$onDidActivateExtension(_.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,W),this.eb(_,W,"success",ee),Z},Z=>{throw this.eb(_,W,"failure"),Z})}eb(_,W,Z,ee){const pe=Pe(_,W);this.z.$publicLog2("extensionActivationTimes",{...pe,...ee||{},outcome:Z})}fb(_,W){const Z=Pe(_,W);this.z.$publicLog2("activatePlugin",Z);const ee=this.ub(_);if(!ee)return Promise.resolve(new b.$Bcc(b.$ycc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${_.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const pe=new b.$zcc(W.startup);return Promise.all([this.vb(_,(0,T.$vg)(_.extensionLocation,ee),pe),this.gb(_)]).then($e=>(C.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),se.hb(this.s,_.identifier,$e[0],$e[1],pe))).then($e=>(C.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),$e))}gb(_){const W=new v.$Hcc(_,this.M),Z=new v.$Gcc(_.identifier.value,!1,this.M),ee=new B.$Scc(_,this.N),pe=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,$e=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([W.whenReady,Z.whenReady,this.O.whenReady]).then(()=>{const he=this;let De,ne;const le=(0,t.$dF)(_,"ipc")?this.f.messagePorts?.get(p.$6l.toKey(_.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:Z,secrets:ee,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ie){return M.$jc(_.extensionLocation.fsPath,ie)},get storagePath(){return he.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return he.O.globalValue(_).fsPath},get logPath(){return M.$jc(he.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return f.URI.joinPath(he.f.logsLocation,_.identifier.value)},get storageUri(){return he.O.workspaceValue(_)},get globalStorageUri(){return he.O.globalValue(_)},get extensionMode(){return pe},get extension(){return De===void 0&&(De=new fe(he,_.identifier,_,$e,!1)),De},get extensionRuntime(){return(0,t.$eF)(_,"extensionRuntime"),he.extensionRuntime},get environmentVariableCollection(){return he.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!ne){if(!le)return;const ie=m.Event.buffer(m.Event.fromDOMEventEmitter(le,"message",oe=>oe.data));le.start(),ne={onDidReceiveMessage:ie,postMessage:le.postMessage.bind(le)}}return ne}})})}static hb(_,W,Z,ee,pe){return Z=Z||{activate:void 0,deactivate:void 0},this.ib(_,W,Z,ee,pe).then($e=>new b.$Acc(!1,null,pe.build(),Z,$e,ee.subscriptions))}static ib(_,W,Z,ee,pe){if(typeof Z.activate=="function")try{pe.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${W.value}`);const $e=typeof global=="object"?global:self,he=Z.activate.apply($e,[ee]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(he).then(De=>(pe.activateResolveStop(),De))}catch($e){return Promise.reject($e)}else return Promise.resolve(Z)}jb(_,W){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:W}).then(void 0,Z=>{this.s.error(Z)})}kb(_,W=0){const ee=Date.now();(0,N.$B)(()=>{for(let pe=W;pe<_.length;pe+=1){const $e=_[pe];for(const he of $e.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ee>50){this.kb(_,pe);break}else this.jb($e,he)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(_=>{const W=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.J.getAllExtensionDescriptions();if(W)this.kb(Z);else for(const ee of Z)if(ee.activationEvents)for(const pe of ee.activationEvents)pe==="onStartupFinished"&&this.jb(ee,pe)})}mb(){const _=this.Z("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.nb($e.added)));const W=this.j.workspace?this.j.workspace.folders:[],Z=this.nb(W),ee=this.pb(),pe=Promise.all([ee,_,Z]).then(()=>{});return Promise.race([pe,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),pe}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(_,W))).then(()=>{})}async ob(_,W){if(this.isActivated(W.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ee={logService:this.s,folders:_.map($e=>$e.uri),forceUsingSearch:Z||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,he,De)=>this.y.$checkExists($e,he,De)},pe=await(0,h.$ylb)(ee,W);if(pe)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:pe.activationEvent}).then(void 0,$e=>this.s.error($e))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:W}=this.f.environment;if(!_||!W)throw new Error(y.localize(0,null));const Z=await this.vb(null,W,new b.$zcc(!1));if(!Z||typeof Z.run!="function")throw new Error(y.localize(1,null,W.toString()));return new Promise((ee,pe)=>{const $e=(ne,le)=>{ne?(N.$t&&this.s.error("Test runner called back with error",ne),pe(ne)):(N.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),ee(typeof le=="number"&&le>0?1:0))},he=(0,T.$jg)(W),De=Z.run(he,$e);De&&De.then&&De.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),ee(0)}).catch(ne=>{N.$t&&this.s.error("Test runner finished with error",ne),pe(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,W){return this.R[_]=W,(0,l.$Qc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:W}=await this.sb(_);return W?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const W=_.indexOf("+");if(W===-1)throw new n.$oK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Z=_.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.R[Z]}}async $resolveAuthority(_,W){const Z=V.$Jd.create(!1),ee=()=>`[resolveAuthority(${(0,r.$Tk)(_)},${W})][${Z.elapsed()}ms] `,pe=J=>this.s.info(`${ee()}${J}`),$e=J=>this.s.warn(`${ee()}${J}`),he=(J,q=void 0)=>this.s.error(`${ee()}${J}`,q),De=J=>{if(J instanceof n.$oK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},ne=async J=>{pe(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw he(`no resolver for ${x}`),new n.$oK(`No remote extension installed to resolve ${x}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},le=_.split(/@|%40/g).reverse();pe(`activating remote resolvers ${le.join(" -> ")}`);let ie;try{ie=await Promise.all(le.map(ne)).catch(async J=>{if(!(J instanceof n.$oK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return $e(`resolving nested authorities failed: ${J.message}`),[await ne(_)]})}catch(J){return De(J)}const oe=new A.$5g;oe.cancelAndSet(()=>pe("waiting..."),1e3);let ge,Ie;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ce}]of ie.entries())try{if(J===ie.length-1)pe("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${q}`),ge=await x.resolve(ce,{resolveAttempt:W,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${q}`),pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$nK.isManagedResolvedAuthority(ge)?ge:void 0));else{if(pe(`invoking resolveExecServer() for ${ce}`),C.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ce,{resolveAttempt:W,execServer:Ie}),!Ie)throw new n.$oK(`Exec server was not available for ${ce}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return C.mark(`code/extHost/didResolveAuthorityError/${q}`),he("returned an error",Ne),oe.dispose(),De(Ne)}oe.dispose();const F={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures},K={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};pe(`returned ${n.$nK.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let G;if(n.$nK.isManagedResolvedAuthority(ge)){const J=W;this.X.setFactory(J,ge.makeConnection),G={authority:_,connectTo:new r.$Qk(J),connectionToken:ge.connectionToken}}else G={authority:_,connectTo:new r.$Rk(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:F}}}async $getCanonicalURI(_,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Tk)(_)})`);const{resolver:Z}=await this.sb(_);if(!Z)return null;const ee=f.URI.revive(W);if(typeof Z.getCanonicalURI>"u")return ee;const pe=await(0,A.$Mg)(()=>Z.getCanonicalURI(ee));return pe||ee}$startExtensionHost(_){_.toAdd.forEach(ee=>ee.extensionLocation=f.URI.revive(ee.extensionLocation));const{globalRegistry:W,myExtensions:Z}=Ee(this.I,this.L,this.J,_);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(Z),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Se(this.J)}`)),this.rb()}$activateByEvent(_,W){return W===1?this.D.wait().then(Z=>this.Z(_,!1)):this.G.wait().then(Z=>this.Z(_,!1))}async $activate(_,W){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,W),!0):!1}async $deltaExtensions(_){_.toAdd.forEach($e=>$e.extensionLocation=f.URI.revive($e.extensionLocation));const{globalRegistry:W,myExtensions:Z}=Ee(this.I,this.L,this.J,_),ee=await this.bb(Z);return(await this.getExtensionPathIndex()).setSearchTree(ee),this.L.set(W.getAllExtensionDescriptions()),this.J.set(Z),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const W=E.$be.alloc(_),Z=Math.random()%256;for(let ee=0;ee<_;ee++)W.writeUInt8(Z,ee);return W}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$Ycc=X,e.$Ycc=X=se=qe([Ve(0,s.$Oh),Ve(1,e.$Xcc),Ve(2,d.$hM),Ve(3,g.$rcc),Ve(4,a.$ucc),Ve(5,R.$0i),Ve(6,o.$xM),Ve(7,w.$Kcc),Ve(8,S.$5vb),Ve(9,u.$Mcc),Ve(10,j.$Ucc),Ve(11,O.$Vcc)],X);function Ee(ve,_,W,Z){ve.addActivationEvents(Z.addActivationEvents);const ee=new i.$l4b(ve,_.getAllExtensionDescriptions());ee.deltaExtensions(Z.toAdd,Z.toRemove);const pe=new p.$7l(W.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of Z.myToRemove)pe.delete(he);for(const he of Z.myToAdd)pe.add(he);const $e=ye(ee,pe);return{globalRegistry:ee,myExtensions:$e}}function Pe(ve,_){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function Se(ve){return ve.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$Zcc=(0,s.$Ph)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(_,W,Z,ee,pe){this.#e=_,this.#t=W,this.#i=Z.identifier,this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=M.$hc((0,T.$jg)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ee,this.isFromDifferentExtensionHost=pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$1cc=fe;function ye(ve,_){return ve.getAllExtensionDescriptions().filter(W=>_.has(W.identifier))}class ue{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$2cc=ue;class ae{constructor(_){this.a=new p.$8l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const W of Object.keys(_))this.a.set(W,_[W])}}}),define(Ae[272],Re([1,0,87,2,3,34,25,21,17,27,4,35,14,16]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let g=class{constructor(E,v,n,r,s,o,w){this.c=E,this.d=v,this.e=n,this.f=r,this.g=s,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new i(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$nec=g,e.$nec=g=qe([Ve(2,R.$Oh),Ve(3,T.$ucc),Ve(4,k.$Zcc),Ve(5,f.$xM),Ve(6,a.$0i)],g);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const v=(0,b.$Fe)(this.c(E.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,n,r,s]=v,o=$.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+s}c(E){return E.replace(/\\/g,"/")}};t=$=qe([Ve(0,f.$xM)],t);class i{constructor(E,v,n,r,s){this.c=E,this.d=v,this.e=n,this.f=r,this.g=s,this.nodeModuleName="vscode",this.a=new l.$8l}load(E,v){const n=this.d.findSubstr(v);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((s,o)=>r+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$$E,this.e,this.f)}return this.b}}let c=class{constructor(E,v,n){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$gK.MainThreadTelemetry);const r=n.getProxy(C.$gK.MainThreadWindow);this.c=(s,o)=>{const w=M.URI.parse(s);return o?this.g(s,o):w.scheme==="http"||w.scheme==="https"?r.$openUri(w,s,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?r.$openUri(w,s,{}):this.g(s,o)}}load(E,v,n){const r=this.e.findSubstr(v);return r&&(this.a=r.identifier.value,this.h()),this.b=n(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=qe([Ve(2,D.$hM)],c)}),define(Ae[112],Re([1,0,42,6,20,73,4,60,61,35,7,33,201,34]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0,e.$vdc=(0,A.$Ph)("IExtHostVariableResolverProvider");class $ extends a.$iN{constructor(i,c,p,E,v,n,r){function s(){if(p){const o=p.activeEditor();if(o)return o.document.uri;const w=E.tabGroups.all.find(d=>d.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof R.$1L||w.input instanceof R.$6L)return w.input.modified;if(w.input instanceof R.$ZL||w.input instanceof R.$5L||w.input instanceof R.$3L)return w.input.uri}}}super({getFolderUri:o=>{const w=n.folders.filter(d=>d.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,w)=>v.getConfiguration(void 0,o).get(w),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=s();if(o){const w=c.getWorkspaceFolder(o);if(w)return C.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(p){const o=p.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(p){const o=p.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(T.env))}}let g=class extends M.$Sc{constructor(i,c,p,E,v){super(),this.b=i,this.c=c,this.g=p,this.h=E,this.j=v,this.a=new y.$V(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$wdc=g,e.$wdc=g=qe([Ve(0,f.$Zcc),Ve(1,k.$rcc),Ve(2,l.$sM),Ve(3,b.$ucc),Ve(4,D.$tdc)],g)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,194,196,34,112]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=e.$zdc=e.$ydc=e.$xdc=void 0,e.$xdc=(0,T.$Ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,o,w,d,I){this.E=s,this.F=o,this.G=w,this.H=d,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Nd,this.n=new M.$Nd,this.o=new M.$Nd,this.u=new M.$Nd,this.k=r.getProxy(A.$gK.MainThreadDebugService),this.y=new M.$Nd,this.A=new M.$Nd,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(r,s){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,d="?";return s&&(w+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),w+=`${d}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const s=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const d of w)(0,b.$sF)(d)&&s.push(d.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(d=>{const I=d.id;return this.w.has(I)?!1:(this.w.set(I,d),!0)});this.U(s,[],[]);const o=[],w=new Map;for(const d of s)if(d instanceof R.$hL){let I=w.get(d.location.uri.toString());I||(I={type:"sourceMulti",uri:d.location.uri,lines:[]},w.set(d.location.uri.toString(),I),o.push(I)),I.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$iL&&o.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const s=r.filter(I=>this.w.delete(I.id));this.U([],s,[]);const o=s.filter(I=>I instanceof R.$hL).map(I=>I.id),w=s.filter(I=>I instanceof R.$iL).map(I=>I.id),d=s.filter(I=>I instanceof R.$jL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,w,d)}startDebugging(r,s,o){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,o){if(!s)return new R.$iK(()=>{});const w=this.d++;return this.f.push({type:r,handle:w,provider:s}),this.k.$registerDebugConfigurationProvider(r,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,w),new R.$iK(()=>{this.f=this.f.filter(d=>d.provider!==s),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(r,s,o){if(!o)return new R.$iK(()=>{});if(!this.Q(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:s,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,w),new R.$iK(()=>{this.h=this.h.filter(d=>d.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new R.$iK(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:s}),new R.$iK(()=>{this.j=this.j.filter(w=>w.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let o;const w=await this.W(r);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(r,s){if(r.type==="implementation")return new E(r.implementation)}L(){}async $startDASession(r,s){const o=this,w=await this.V(s);return this.S(this.N(w.type),w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(d),S=this.K(I,w);if(!S)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const u=S;return this.B.set(r,u),this.R(w).then(m=>(m&&this.C.set(r,m),u.onMessage(async h=>{if(h.type==="request"&&h.command==="handshake"){const P=h,B={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(P.arguments.value);B.body={signature:z},u.sendResponse(B)}else throw new Error("no signer")}catch(z){B.success=!1,B.message=z.message,u.sendResponse(B)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(h),h=(0,b.$xF)(h,!0),o.k.$acceptDAMessage(r,h)}),u.onError(h=>{m&&m.onError&&m.onError(h),this.k.$acceptDAError(r,h.name,h.message,h.stack)}),u.onExit(h=>{m&&m.onExit&&m.onExit(h??void 0,void 0),this.k.$acceptDAExit(r,h??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),u.startSession()))})}$sendDAMessage(r,s){s=(0,b.$wF)(s,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.C.get(r);this.C.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],o=[],w=[];if(r.added)for(const d of r.added){const I=d.id;if(I&&!this.w.has(I)){let S;if(d.type==="function")S=new R.$iL(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")S=new R.$jL(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const u=C.URI.revive(d.uri);S=new R.$hL(new R.$uK(u,new R.$jK(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$fL)(S,I),this.w.set(I,S),s.push(S)}}if(r.removed)for(const d of r.removed){const I=this.w.get(d);I&&(this.w.delete(d),o.push(I))}if(r.changed){for(const d of r.changed)if(d.id){const I=this.w.get(d.id);if(I){if(I instanceof R.$iL&&d.type==="function"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.functionName=d.functionName}else if(I instanceof R.$hL&&d.type==="source"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.location=new R.$uK(C.URI.revive(d.uri),new R.$jK(d.line,d.character))}w.push(I)}}}this.U(s,o,w)}async $acceptStackFrameFocus(r){let s;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new R.$pL(o,r.threadId):s=new R.$oL(o,r.threadId,r.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(r,s,o){return(0,y.$Mg)(async()=>{const w=this.P(r);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(s);return w.provideDebugConfigurations(d,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(r,s,o,w){return(0,y.$Mg)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return d.resolveDebugConfiguration(I,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,o,w){return(0,y.$Mg)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return d.resolveDebugConfigurationWithSubstitutedVariables(I,o,w)})}async $provideDebugAdapter(r,s){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(s);return this.S(o,w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(r){const s=await this.V(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.V(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.V(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const w={session:await this.V(r),event:s.event,body:s.body};this.u.fire(w)}M(r){if(r instanceof R.$kL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$lL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$mL)return{type:"pipeServer",path:r.path};if(r instanceof R.$nL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const s=this.h.filter(o=>o.type===r);if(s.length>0)return s[0].factory}O(r){const s=this.h.filter(o=>o.handle===r);if(s.length>0)return s[0].factory}P(r){const s=this.f.filter(o=>o.handle===r);if(s.length>0)return s[0].provider}Q(r,s){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===s)return!0}}return!1}R(r){const o=r.configuration.type,w=this.j.filter(d=>d.type===o||d.type==="*").map(d=>(0,y.$Mg)(()=>d.factory.createDebugAdapterTracker(r)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(d=>{const I=d.filter(S=>!!S);if(I.length>0)return new p(I)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(r,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$lL(o));if(r){const d=await this.F.getExtensionRegistry();return(0,y.$Mg)(()=>r.createDebugAdapterDescriptor(s,this.T(s,d))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,w))}T(r,s){}U(r,s,o){(r.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:s,changed:o}))}async V(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const o=await this.W(r.folderUri),w=r.parent?this.l.get(r.parent):void 0;s=new i(this.k,r.id,r.type,r.name,o,r.configuration,w),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(r){if(r){const s=C.URI.revive(r);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$ydc=t,e.$ydc=t=qe([Ve(0,f.$hM),Ve(1,k.$rcc),Ve(2,D.$Zcc),Ve(3,$.$ucc),Ve(4,l.$tdc),Ve(5,g.$vdc)],t);class i{constructor(r,s,o,w,d,I,S){this.d=r,this.f=s,this.g=o,this.h=w,this.i=d,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$zdc=i;class c{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$Adc=c;class p{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(o=>o.onExit?o.onExit(r,s):void 0)}}class E extends a.$5cb{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(r,s,o,w,d,I){super(r,s,o,w,d,I)}};e.$Bdc=v,e.$Bdc=v=qe([Ve(0,f.$hM),Ve(1,k.$rcc),Ve(2,D.$Zcc),Ve(3,$.$ucc),Ve(4,l.$tdc),Ve(5,g.$vdc)],v)}),define(Ae[273],Re([1,0,9,87,2,3,264,14,70,71,27,172,17,56,35,58]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=void 0;class t{static async installEarlyHandler(p){Error.stackTraceLimit=100;const E=p.get(l.$0i),n=p.get(a.$hM).getProxy(T.$gK.MainThreadErrors);y.setUnexpectedErrorHandler(r=>{E.error(r);const s=y.$3(r);n.$onUnexpectedError(s)})}static async installFullHandler(p){const E=p.get(l.$0i),v=p.get(a.$hM),n=p.get($.$Zcc),r=p.get(g.$BM),s=v.getProxy(T.$gK.MainThreadExtensionService),o=v.getProxy(T.$gK.MainThreadErrors),w=await n.getExtensionPathIndex(),d=new WeakMap;function I(m,h){if(d.has(m))return d.get(m).stack;let P="",B,z;for(const V of h)P+=`
	at ${V.toString()}`,z=V.getFileName(),!B&&z&&(B=w.findSubstr(C.URI.file(z)));const j=`${m.name||"Error"}: ${m.message||""}${P}`;return d.set(m,{extensionIdentifier:B?.identifier,stack:j}),j}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){if(m===I||!m||m[S]){u=m||I;return}u=function(h,P){return I(h,P),m.call(Error,h,P)},Object.assign(u,{[S]:!0})}}),y.setUnexpectedErrorHandler(m=>{E.error(m);const h=y.$3(m),P=d.get(m);if(!P?.extensionIdentifier){o.$onUnexpectedError(h);return}s.$onExtensionRuntimeError(P.extensionIdentifier,h);const B=r.onExtensionError(P.extensionIdentifier,m);E.trace("forwarded error to extension?",B,P)})}}e.$oec=t;class i{constructor(p,E,v,n,r){this.a=v,this.b=new A.$u4b(p,null,n),E=i.e(E,this.b);const s=new f.$Nh(...(0,D.$xr)());s.set(R.$xM,{_serviceBrand:void 0,...E,messagePorts:r}),s.set(a.$hM,new a.$iM(this.b)),s.set(b.$occ,new b.$pcc(n)),s.set($.$Xcc,v);const o=new k.$dq(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(l.$0i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(w=>w.get($.$Zcc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(p){const E=this.b.getProxy(T.$gK.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(p))}terminate(p){this.c.terminate(p)}static e(p,E){p.extensions.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(E.transformIncomingURIs(n.extensionLocation))}),p.environment.appRoot=C.URI.revive(E.transformIncomingURIs(p.environment.appRoot));const v=p.environment.extensionDevelopmentLocationURI;return v&&(p.environment.extensionDevelopmentLocationURI=v.map(n=>C.URI.revive(E.transformIncomingURIs(n)))),p.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(p.environment.workspaceStorageHome)),p.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(p.environment.extensionTelemetryLogResource)),p.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(p.nlsBaseUrl)),p.logsLocation=C.URI.revive(E.transformIncomingURIs(p.logsLocation)),p.workspace=E.transformIncomingURIs(p.workspace),p}}e.$pec=i}),define(Ae[274],Re([1,0,18,12,19,37,13,20,23,2,48]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=e.$Edc=e.$Ddc=void 0;class k{constructor(c,p,E,v){this.d=c,this.e=p,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(c,p){const E=this.d.folderQueries||[],v=new C.$Xd(p);return new Promise((n,r)=>{this.a=new b(c);let s=!1;const o=(w,d)=>{if(!s&&!this.b){const I=this.h(w);g(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,v.cancel(),w=this.j(w,this.d.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!g(w))&&this.a.add(w,d)}};Promise.all(E.map((w,d)=>this.k(w,I=>o(I,d),v.token))).then(w=>{v.dispose(),this.a.flush();const d=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||d,messages:(0,y.$Rb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{v.dispose();const d=(0,T.$Ai)(w);r(new Error(d))})})}h(c){return g(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,p){const E=Array.isArray(c.ranges)?c.ranges:[c.ranges],v=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:E.slice(0,p),preview:{matches:v.slice(0,p),text:c.preview.text},uri:c.uri}}async k(c,p,E){const v=new R.$2I(this.d,c),n=[],r={report:w=>{if(!this.l(w))return;const d=c.folder.scheme===A.Schemas.file?(0,R.$3I)(()=>this.f.readdir(D.$ug(w.uri))):void 0,I=D.$xg(c.folder,w.uri);if(I){const S=v.includedInQuery(I,l.$nc(I),d);(0,M.$Gg)(S)?n.push(S.then(u=>{u&&p(w)})):S&&p(w)}}},s=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),s,r,E);return n.length&&await Promise.all(n),o}l(c){if(g(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const p=(0,R.$1I)(this.d.includePattern,c.includePattern),E=(0,R.$1I)(this.d.excludePattern,c.excludePattern),v={folder:f.URI.from(c.folder),excludes:E,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$Ddc=k;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,p=>this.g(p))}add(c,p){this.d&&(this.b!==p||!D.$og(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=p,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$Edc=b;function $(i){return g(i)?{preview:{matches:(0,y.$2b)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,y.$2b)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$Fdc=g;class t{static{this.a=4e3}static{this.b=50}constructor(c,p){this.g=c,this.h=p,this.c=0,this.d=[],this.e=0}addItem(c,p){c&&this.j(c,p)}addItems(c,p){c&&this.k(c,p)}j(c,p){this.d.push(c),this.e+=p,this.l()}k(c,p){this.d=this.d.concat(c),this.e+=p,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Gdc=t}),define(Ae[114],Re([1,0,6,3,4,269,17,56,14,2,274]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=e.$Hdc=void 0,e.$Hdc=(0,C.$Ph)("IExtHostSearch");let k=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(M.$gK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$Cdc}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,y.$Qc)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,y.$Qc)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,c){const p=a(i),E=this.h.get(g);if(E)return this.j.fileSearch(p,E,v=>{this.c.$handleFileMatch(g,t,v.map(n=>n.resource))},c);throw new Error("unknown provider: "+g)}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,c){const p=this.e.get(g);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const E=a(i);return this.q(E,p).search(n=>this.c.$handleTextMatch(g,t,n),c)}$enableExtensionHostSearch(){}q(g,t){return new R.$Ddc(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Idc=k,e.$Idc=k=qe([Ve(0,A.$hM),Ve(1,l.$occ),Ve(2,D.$0i)],k);function a($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(b),extraFileResources:$.extraFileResources&&$.extraFileResources.map(g=>f.URI.revive(g))}}e.$Jdc=a;function b($){return{...$,folder:f.URI.revive($.folder)}}}),define(Ae[275],Re([1,0,19,9,5,29,2,135,286,124,133,39,3,79,226,225,31,227,34,229,230,231,204,232,60,35,235,236,241,242,244,109,208,250,251,254,84,63,256,211,8,7,54,259,64,108,33,21,199,240,53,107,111,113,114,14,56,17,27,245,197,86,80,218,257,85,62,262,260,261,219,40,255,258,83,61,58,246,110,247,13,95,207,189,238,6,25,195,81,185,248,249,220,237,206,239,82,252,223,253,224,217,234,221,222]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n,r,s,o,w,d,I,S,u,m,h,P,B,z,j,V,N,O,se,X,Ee,Pe,Se,fe,ye,ue,ae,ve,_,W,Z,ee,pe,$e,he,De,ne,le,ie,oe,ge,Ie,F,K,G,J,q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze,st,Y,Q,be,Be,Oe,Xe,nt,ft,wt,Pt,Zt,Gt,pt,jt,Nt,Bt,At,Rt,Ot,Wt,Jt,Vt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;function Mt(ut){const dt=ut.get(ne.$xM),Lt=ut.get(Ne.$ecc),qt=ut.get(G.$Jcc),kt=ut.get(o.$Zcc),at=ut.get(ye.$rcc),vt=ut.get(Ye.$BM),Ht=ut.get(c.$ucc),Ct=ut.get(he.$occ),We=ut.get(De.$hM),Ce=ut.get(j.$Fcc),Fe=ut.get(K.$Kcc),me=ut.get($e.$$i),H=ut.get($e.$0i),Me=ut.get(oe.$5vb),je=ut.get(ge.$hcc),Je=ut.get(fe.$ldc),Ke=ut.get(Ge.$Rcc),et=ut.get(xe.$tdc),bt=ut.get(Nt.$Vcc);We.set(a.$hK.ExtHostFileSystemInfo,Lt),We.set(a.$hK.ExtHostLogLevelServiceShape,me),We.set(a.$hK.ExtHostWorkspace,at),We.set(a.$hK.ExtHostConfiguration,Ht),We.set(a.$hK.ExtHostExtensionService,kt),We.set(a.$hK.ExtHostStorage,Ce),We.set(a.$hK.ExtHostTunnelService,Me),We.set(a.$hK.ExtHostWindow,Je),We.set(a.$hK.ExtHostSecretState,Ke),We.set(a.$hK.ExtHostTelemetry,vt),We.set(a.$hK.ExtHostEditorTabs,et),We.set(a.$hK.ExtHostManagedSockets,bt);const zt=We.set(a.$hK.ExtHostDecorations,ut.get(W.$pdc)),Dt=We.set(a.$hK.ExtHostDocumentsAndEditors,ut.get(s.$sM)),lt=We.set(a.$hK.ExtHostCommands,ut.get(t.$DM)),gt=We.set(a.$hK.ExtHostTerminalService,ut.get(V.$Mcc)),yt=We.set(a.$hK.ExtHostDebugService,ut.get(ee.$xdc)),mi=We.set(a.$hK.ExtHostSearch,ut.get(pe.$Hdc)),St=We.set(a.$hK.ExtHostTask,ut.get(Z.$sdc)),Si=We.set(a.$hK.ExtHostOutputService,ut.get(m.$8cc)),ui=We.set(a.$hK.ExtHostLocalization,ut.get(nt.$Ucc)),$i=We.set(a.$hK.ExtHostUrls,new Pe.$edc(We)),It=We.set(a.$hK.ExtHostDocuments,new r.$ccc(We,Dt)),fn=We.set(a.$hK.ExtHostDocumentContentProviders,new v.$wcc(We,Dt,H)),ri=We.set(a.$hK.ExtHostDocumentSaveParticipant,new n.$xcc(H,It,We.getProxy(a.$gK.MainThreadBulkEdits))),Et=We.set(a.$hK.ExtHostNotebook,new le.$Ndc(We,lt,Dt,It,qt)),pi=We.set(a.$hK.ExtHostNotebookDocuments,new Q.$6dc(Et)),vi=We.set(a.$hK.ExtHostNotebookEditors,new Y.$5dc(H,Et)),si=We.set(a.$hK.ExtHostNotebookKernels,new _e.$2dc(We,dt,Et,lt,H)),Ii=We.set(a.$hK.ExtHostNotebookRenderers,new tt.$4dc(We,Et)),Ci=We.set(a.$hK.ExtHostNotebookDocumentSaveParticipant,new pt.$_dc(H,Et,We.getProxy(a.$gK.MainThreadBulkEdits))),Ft=We.set(a.$hK.ExtHostEditors,new N.$cdc(We,Dt)),bi=We.set(a.$hK.ExtHostTreeViews,new O.$ddc(We.getProxy(a.$gK.MainThreadTreeViews),lt,H)),Pi=We.set(a.$hK.ExtHostEditorInsets,new ae.$mdc(We.getProxy(a.$gK.MainThreadEditorInsets),Ft,dt.remote)),oi=We.set(a.$hK.ExtHostDiagnostics,new p.$gcc(We,H,Lt,Dt)),li=We.set(a.$hK.ExtHostLanguages,new S.$5cc(We,It,lt.converter,Ct)),ct=We.set(a.$hK.ExtHostLanguageFeatures,new I.$kcc(We,Ct,It,lt,oi,H,je,vt)),Ai=We.set(a.$hK.ExtHostFileSystem,new w.$3cc(We,ct)),Yt=We.set(a.$hK.ExtHostFileSystemEventService,new d.$4cc(We,H,Dt)),ii=We.set(a.$hK.ExtHostQuickOpen,(0,P.$0cc)(We,at,lt)),Ri=We.set(a.$hK.ExtHostSCM,new B.$_cc(We,lt,It,H)),Mi=We.set(a.$hK.ExtHostQuickDiff,new Pt.$9dc(We,Ct)),Fi=We.set(a.$hK.ExtHostShare,new Bt.$bec(We,Ct)),Xi=We.set(a.$hK.ExtHostComments,(0,i.$ncc)(We,lt,It)),Ti=We.set(a.$hK.ExtHostProgress,new h.$9cc(We.getProxy(a.$gK.MainThreadProgress))),Zi=We.set(a.$hK.ExtHosLabelService,new ve.$ndc(We)),Li=We.set(a.$hK.ExtHostTheming,new ie.$Odc(We)),ai=We.set(a.$hK.ExtHostAuthentication,new Ie.$Pdc(We)),gn=We.set(a.$hK.ExtHostTimeline,new F.$Rdc(We,lt)),Ni=We.set(a.$hK.ExtHostWebviews,new Se.$hdc(We,dt.remote,at,H,je)),hi=We.set(a.$hK.ExtHostWebviewPanels,new x.$Tdc(We,Ni,at)),Oi=We.set(a.$hK.ExtHostCustomEditors,new q.$Udc(We,It,Fe,Ni,hi)),mn=We.set(a.$hK.ExtHostWebviewViews,new J.$Sdc(We,Ni)),di=We.set(a.$hK.ExtHostTesting,new Ue.$Wdc(We,lt,Dt)),Yi=We.set(a.$hK.ExtHostUriOpeners,new Qe.$1dc(We)),zi=We.set(a.$hK.ExtHostProfileContentHandlers,new wt.$8dc(We));We.set(a.$hK.ExtHostInteractive,new be.$7dc(We,Et,Dt,lt,H));const xi=We.set(a.$hK.ExtHostInlineChat,new Gt.$$dc(We,lt,It,H)),fi=We.set(a.$hK.ExtHostChatProvider,new At.$cec(We,H)),_i=We.set(a.$hK.ExtHostChatAgents,new Vt.$hec(We,fi,H)),$n=We.set(a.$hK.ExtHostChatAgents2,new Kt.$iec(We,fi,H)),Ui=We.set(a.$hK.ExtHostChatVariables,new Ot.$eec(We)),gi=We.set(a.$hK.ExtHostChat,new Zt.$0dc(We,H)),xt=We.set(a.$hK.ExtHostAiRelatedInformation,new Wt.$fec(We)),wi=We.set(a.$hK.ExtHostAiEmbeddingVector,new Jt.$gec(We)),pn=We.set(a.$hK.ExtHostIssueReporter,new jt.$aec(We)),Qt=We.set(a.$hK.ExtHostStatusBar,new z.$bdc(We,lt.converter)),yi=We.set(a.$hK.ExtHostSpeech,new Rt.$dec(We)),en=Object.values(a.$hK);We.assertRegistered(en);const tn=new ce.$Vdc(We,Dt),nn=new g.$mcc(We),Ei=new u.$6cc(We,H),rn=new E.$vcc(We);return $.$lcc.register(lt),function(Le,_t,sn){const mt=function(){let te=!Le.isUnderDevelopment;function de(){te||(H.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")de();else{const $t=rt;typeof $t.scheme>"u"&&de(),typeof $t.exclusive=="boolean"&&(0,Oe.$eF)(Le,"documentFiltersExclusive")}return rt}}(),ji={getSession(te,de,Te){return ai.getSession(Le,te,de,Te)},getSessions(te,de){return(0,Oe.$eF)(Le,"authGetSessions"),ai.getSessions(Le,te,de)},async hasSession(te,de){return(0,Oe.$eF)(Le,"authSession"),!!await ai.getSession(Le,te,de,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,rt){return ai.registerAuthenticationProvider(te,de,Te,rt)}},on={registerCommand(te,de,Te){return lt.registerCommand(!0,te,de,Te,void 0,Le)},registerTextEditorCommand(te,de,Te){return lt.registerCommand(!0,te,(...rt)=>{const $t=Ft.getActiveTextEditor();if(!$t){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return $t.edit(Tt=>{de.apply(Te,[$t,Tt,...rt])}).then(Tt=>{Tt||H.warn("Edits from command "+te+" were not applied.")},Tt=>{H.warn("An error occurred while running command "+te,Tt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,de,Te)=>((0,Oe.$eF)(Le,"diffCommand"),lt.registerCommand(!0,te,async(...rt)=>{const $t=Dt.activeEditor(!0);if(!$t){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation($t.id);de.apply(Te,[Tt,...rt])},void 0,void 0,Le)),executeCommand(te,...de){return lt.executeCommand(te,...de)},getCommands(te=!1){return lt.getCommands(te)}},Bi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$eF)(Le,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$eF)(Le,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$AM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ye.$zM.validateSender(te),vt.instantiateLogger(Le,te,de)},openExternal(te,de){return Je.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return $i.createAppUri(te);try{return await Je.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(de){if((0,st.$dU)(te,ze.Schemas.http)||(0,st.$dU)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,_.$Vk)(dt.remote.authority)},get remoteAuthority(){return(0,Oe.$eF)(Le,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$eF)(Le,"handleIssueUri"),pn.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Oe.$eF)(Le,"resolvers"),dt.quality},get appCommit(){return(0,Oe.$eF)(Le,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(te,de,Te){return di.createTestController(Le,te,de,Te)},createTestObserver(){return(0,Oe.$eF)(Le,"testObserver"),di.createTestObserver()},runTests(te){return(0,Oe.$eF)(Le,"testObserver"),di.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$eF)(Le,"testObserver"),di.onResultsChanged},get testResults(){return(0,Oe.$eF)(Le,"testObserver"),di.results}},Di=dt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,vn={getExtension(te,de){(0,Oe.$dF)(Le,"extensionsAny")||(de=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$1cc(kt,Le.identifier,Te,Di,!1);if(de){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$1cc(kt,Le.identifier,rt,Di,!0)}},get all(){const te=[];for(const de of _t.mine.getAllExtensionDescriptions())te.push(new o.$1cc(kt,Le.identifier,de,Di,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$eF)(Le,"extensionsAny");const te=new ue.$7l(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);de.push(new o.$1cc(kt,Le.identifier,Te,Di,rt))}return de},get onDidChange(){return(0,Oe.$dF)(Le,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(te,de){return li.changeLanguage(te.uri,de)},match(te,de){const Te=It.getDocumentData(de.uri)?.notebook;return(0,R.$sE)(se.LanguageSelector.from(te),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Le,mt(te),de,Te)},registerDocumentPasteEditProvider(te,de,Te){return(0,Oe.$eF)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,mt(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Le,mt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Le,mt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Le,mt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Le,mt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Le,mt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Le,mt(te),de,Le.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Le,mt(te),de,Le.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Le,mt(te),de,Le.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Le,mt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Le,mt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Le,mt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Le,mt(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Le,mt(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Le,mt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Le,mt(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Le,mt(te),de,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Le,mt(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Le,mt(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Le,mt(te),de,Te):ct.registerSignatureHelpProvider(Le,mt(te),de,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Le,mt(te),de,Te)},registerInlineCompletionItemProvider(te,de,Te){return de.handleDidShowCompletionItem&&(0,Oe.$eF)(Le,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$eF)(Le,"inlineCompletionsAdditions"),Te&&(0,Oe.$eF)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,mt(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Le,mt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Le,mt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Le,mt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Le,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Le,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Le,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Le,te,de),getTokenInformationAtPosition(te,de){return(0,Oe.$eF)(Le,"tokenInformation"),li.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Le,te,de)},createLanguageStatusItem(te,de){return li.createLanguageStatusItem(Le,te,de)},registerDocumentDropEditProvider(te,de,Te){return ct.registerDocumentOnDropEditProvider(Le,te,de,(0,Oe.$dF)(Le,"dropMetadata")?Te:void 0)}},un={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,de,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Ft.showTextDocument(rt,de,Te)},createTextEditorDecorationType(te){return Ft.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,de,Te){return Ft.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Ft.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Ft.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Ft.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Ft.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Ft.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return gt.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return gt.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return gt.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Oe.$eF)(Le,"terminalDimensions"),gt.onDidChangeTerminalDimensions(te,de,Te)},onDidChangeTerminalState(te,de,Te){return gt.onDidChangeTerminalState(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Oe.$eF)(Le,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(te,de,Te)},onDidExecuteTerminalCommand(te,de,Te){return(0,Oe.$eF)(Le,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(te,de,Te)},get state(){return Je.getState(Le)},onDidChangeWindowState(te,de,Te){return Je.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return Ei.showMessage(Le,T.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Ei.showMessage(Le,T.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Ei.showMessage(Le,T.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return ii.showQuickPick(Le,te,de,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return rn.showOpenDialog(Le,te)},showSaveDialog(te){return rn.showSaveDialog(te)},createStatusBarItem(te,de,Te){let rt,$t,Tt;return typeof te=="string"?(rt=te,$t=de,Tt=Te):($t=te,Tt=de),Qt.createStatusBarEntry(Le,rt,$t,Tt)},setStatusBarMessage(te,de){return Qt.setStatusBarMessage(te,de)},withScmProgress(te){return je.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ti.withProgress(Le,{location:X.ProgressLocation.SourceControl},(de,Te)=>te({report(rt){}}))},withProgress(te,de){return Ti.withProgress(Le,te,de)},createOutputChannel(te,de){return Si.createOutputChannel(te,de,Le)},createWebviewPanel(te,de,Te,rt){return hi.createWebviewPanel(Le,te,de,Te,rt)},createWebviewTextEditorInset(te,de,Te,rt){return(0,Oe.$eF)(Le,"editorInsets"),Pi.createWebviewEditorInset(te,de,Te,rt,Le)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):gt.createTerminalFromOptions(te):gt.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return gt.registerProfileProvider(Le,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Oe.$eF)(Le,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(te,Le.identifier.value,de)},registerTreeDataProvider(te,de){return bi.registerTreeDataProvider(te,de,Le)},createTreeView(te,de){return bi.createTreeView(te,de,Le)},registerWebviewPanelSerializer:(te,de)=>hi.registerWebviewPanelSerializer(Le,te,de),registerCustomEditorProvider:(te,de,Te={})=>Oi.registerCustomEditorProvider(Le,te,de,Te),registerFileDecorationProvider(te){return zt.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return $i.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Li.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return mn.registerWebviewViewProvider(Le,te,de,Te?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return Et.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return vi.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return vi.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return Et.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Oe.$eF)(Le,"externalUriOpener"),Yi.registerExternalUriOpener(Le.identifier,te,de,Te)},registerProfileContentHandler(te,de){return(0,Oe.$eF)(Le,"profileContentHandlers"),zi.registrProfileContentHandler(Le,te,de)},registerQuickDiffProvider(te,de,Te,rt){return(0,Oe.$eF)(Le,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),de,Te,rt)},get tabGroups(){return et.tabGroups},registerShareProvider(te,de){return(0,Oe.$eF)(Le,"shareProvider"),Fi.registerShareProvider(mt(te),de)}},ki={get rootPath(){return je.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return at.getWorkspaceFolder(te)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(te){throw new M.$9("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,de,...Te)=>at.updateWorkspaceFolders(Le,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return at.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>at.getRelativePath(te,de),findFiles:(te,de,Te,rt)=>at.findFiles(te,de,Te,Le.identifier,rt),findTextInFiles:(te,de,Te,rt)=>{(0,Oe.$eF)(Le,"findTextInFiles");let $t,Tt;return typeof de=="object"?($t=de,Tt=Te):($t={},Tt=de,rt=Te),at.findTextInFiles(te,$t||{},Tt,Le.identifier,rt)},save:te=>((0,Oe.$eF)(Le,"saveEditor"),at.save(te)),saveAs:te=>((0,Oe.$eF)(Le,"saveEditor"),at.saveAs(te)),saveAll:te=>at.saveAll(te),applyEdit(te,de){return tn.applyWorkspaceEdit(te,Le,de)},createFileSystemWatcher:(te,de,Te,rt)=>{let $t;return typeof de=="boolean"?$t={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!rt}:de&&((0,Oe.$eF)(Le,"createFileSystemWatcher"),$t=de),Yt.createFileSystemWatcher(at,Le,te,$t)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then($t=>$t.document))},onDidOpenTextDocument:(te,de,Te)=>It.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>It.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>It.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>It.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>ri.getOnWillSaveTextDocumentEvent(Le)(te,de,Te),get notebookDocuments(){return Et.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Te;if(A.URI.isUri(te))Te=te,await Et.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await Et.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,de,Te){return pi.onDidSaveNotebookDocument(te,de,Te)},onDidChangeNotebookDocument(te,de,Te){return pi.onDidChangeNotebookDocument(te,de,Te)},onWillSaveNotebookDocument(te,de,Te){return Ci.getOnWillSaveNotebookDocumentEvent(Le)(te,de,Te)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Te,rt){return Et.registerNotebookSerializer(Le,te,de,Te,(0,Oe.$dF)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Te)=>sn.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,sn.getConfiguration(te,de,Le)},registerTextDocumentContentProvider(te,de){return fn.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(je.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Le,te,de)),registerFileSystemProvider(te,de,Te){return(0,Be.$Pc)(Ai.registerFileSystemProvider(Le,te,de,Te),qt.addFileSystemProvider(te,de,Te))},get fs(){return qt.value},registerFileSearchProvider:(te,de)=>((0,Oe.$eF)(Le,"fileSearchProvider"),mi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Oe.$eF)(Le,"textSearchProvider"),mi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Oe.$eF)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Oe.$eF)(Le,"resolvers"),Zi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$eF)(Le,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Te)=>Yt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Yt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Yt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Yt.getOnWillCreateFileEvent(Le)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Yt.getOnWillDeleteFileEvent(Le)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Yt.getOnWillRenameFileEvent(Le)(te,de,Te),openTunnel:te=>((0,Oe.$eF)(Le,"tunnels"),Me.openTunnel(Le,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Oe.$eF)(Le,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Oe.$eF)(Le,"tunnels"),Me.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Oe.$eF)(Le,"portsAttributes"),Me.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Oe.$eF)(Le,"tunnelFactory"),Me.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Oe.$eF)(Le,"timeline"),gn.registerTimelineProvider(te,de,Le.identifier,lt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:te=>((0,Oe.$eF)(Le,"workspaceTrust"),at.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>at.onDidGrantWorkspaceTrust(te,de,Te),registerEditSessionIdentityProvider:(te,de)=>((0,Oe.$eF)(Le,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Te)=>((0,Oe.$eF)(Le,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(Le)(te,de,Te)),registerCanonicalUriProvider:(te,de)=>((0,Oe.$eF)(Le,"canonicalUriProvider"),at.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Te)=>((0,Oe.$eF)(Le,"canonicalUriProvider"),at.provideCanonicalUri(te,de,Te))},Wi={get inputBox(){return je.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Le)},createSourceControl(te,de,Te){return Ri.createSourceControl(Le,te,de,Te)}},Vi={createCommentController(te,de){return Xi.createCommentController(Le,te,de)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(te,de,Te){return yt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return yt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return yt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return yt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return yt.onDidChangeBreakpoints(te,de,Te)},onDidChangeStackFrameFocus(te,de,Te){return(0,Oe.$eF)(Le,"debugFocus"),yt.onDidChangeStackFrameFocus(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return yt.registerDebugConfigurationProvider(te,de,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return yt.registerDebugAdapterDescriptorFactory(Le,te,de)},registerDebugAdapterTrackerFactory(te,de){return yt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?yt.startDebugging(te,de,{parentSession:Te}):yt.startDebugging(te,de,Te||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,de){return yt.asDebugSourceUri(te,de)}},Ki={registerTaskProvider:(te,de)=>St.registerTaskProvider(Le,te,de),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Le,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,de,Te)=>St.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>St.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>St.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>St.onDidEndTaskProcess(te,de,Te)},qi={createNotebookController(te,de,Te,rt,$t){return si.createNotebookController(Le,te,de,Te,rt,(0,Oe.$dF)(Le,"notebookMessaging")?$t:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>Et.registerNotebookCellStatusBarItemProvider(Le,te,de),createRendererMessaging(te){return Ii.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$eF)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,de){return(0,Oe.$eF)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,te,de)},onDidChangeNotebookCellExecutionState(te,de,Te){return(0,Oe.$eF)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,de,Te)}},Hi={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return ui.getMessage(Le.identifier.value,{message:de,args:Te})}return ui.getMessage(Le.identifier.value,te[0])},get bundle(){return ui.getBundle(Le.identifier.value)},get uri(){return ui.getBundleUri(Le.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Oe.$eF)(Le,"interactive"),xi.registerProvider(Le,te,de={label:de?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,de){return(0,Oe.$eF)(Le,"interactive"),gi.registerChatProvider(Le,te,de)},sendInteractiveRequestToProvider(te,de){return(0,Oe.$eF)(Le,"interactive"),gi.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Oe.$eF)(Le,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(te,de){return(0,Oe.$eF)(Le,"interactive"),gi.transferChatSession(te,de)}},ln={getRelatedInformation(te,de){return(0,Oe.$eF)(Le,"aiRelatedInformation"),xt.getRelatedInformation(Le,te,de)},registerRelatedInformationProvider(te,de){return(0,Oe.$eF)(Le,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Le,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Oe.$eF)(Le,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Le,te,de)}},hn={registerChatResponseProvider(te,de,Te){return(0,Oe.$eF)(Le,"chatProvider"),fi.registerProvider(Le.identifier,te,de,Te)},requestChatAccess(te){return(0,Oe.$eF)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,de,Te){return(0,Oe.$eF)(Le,"chatVariables"),Ui.registerVariableResolver(Le,te,de,Te)},registerMappedEditsProvider(te,de){return(0,Oe.$eF)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,de)},createChatAgent(te,de){return(0,Oe.$eF)(Le,"chatAgents2"),$n.createChatAgent(Le,te,de)},registerAgent(te,de,Te){return(0,Oe.$eF)(Le,"chatAgents"),_i.registerAgent(Le.identifier,te,de,Te)}},dn={registerSpeechProvider(te,de){return(0,Oe.$eF)(Le,"speech"),yi.registerProvider(Le.identifier,te,de)}};return{version:dt.version,ai:ln,authentication:ji,commands:on,comments:Vi,chat:hn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:qi,scm:Wi,speech:dn,tasks:Ki,tests:an,window:un,workspace:ki,Breakpoint:X.$gL,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatAgentResultFeedbackKind:X.ChatAgentResultFeedbackKind,ChatMessage:X.$9L,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$FK,CallHierarchyItem:X.$EK,CallHierarchyOutgoingCall:X.$GK,CancellationError:M.$5,CancellationTokenSource:y.$Xd,CandidatePortSource:a.CandidatePortSource,CodeAction:X.$BK,CodeActionKind:X.$CK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$HK,Color:X.$UK,ColorInformation:X.$VK,ColorPresentation:X.$WK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$OK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$PK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$5K,DebugAdapterExecutable:X.$kL,DebugAdapterInlineImplementation:X.$nL,DebugAdapterNamedPipeServer:X.$mL,DebugAdapterServer:X.$lL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$wK,DiagnosticRelatedInformation:X.$vK,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$iK,DocumentHighlight:X.$yK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$TK,DocumentSymbol:X.$AK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$qL,InlineValueText:X.$rL,InlineValueVariableLookup:X.$sL,InlineValueEvaluatableExpression:X.$tL,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$Nd,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$DL,FileDecoration2:X.$DL,FileSystemError:X.$vL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:X.$wL,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$iL,InlineCompletionItem:X.$QK,InlineCompletionList:X.$RK,Hover:X.$xK,IndentAction:f.IndentAction,Location:X.$uK,MarkdownString:X.$IK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:X.$JK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$jK,ProcessExecution:X.$3K,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$CL,Range:X.$kK,RelativePattern:X.$eL,Selection:X.$lK,SelectionRange:X.$DK,SemanticTokens:X.$zL,SemanticTokensBuilder:X.$yL,SemanticTokensEdit:X.$AL,SemanticTokensEdits:X.$BL,SemanticTokensLegend:X.$xL,ShellExecution:X.$4K,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$LK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$KK,SnippetString:X.$tK,SourceBreakpoint:X.$hL,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$zK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$6K,TaskGroup:X.$2K,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$XK,TerminalQuickFixExecuteTerminalCommand:X.$ZK,TerminalQuickFixOpener:X.$YK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$1K,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$pK,SnippetTextEdit:X.$rK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$dL,ThemeIcon:X.$cL,TreeItem:X.$7K,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$YL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$sK,DocumentDropEdit:X.$aL,DocumentPasteEdit:X.$bL,InlayHint:X.$NK,InlayHintLabelPart:X.$MK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$oK,ResolvedAuthority:X.$mK,ManagedResolvedAuthority:X.$nK,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$NL,NotebookRange:X.$FL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$GL,NotebookData:X.$HL,NotebookRendererScript:X.$LL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$JL,NotebookCellOutputItem:X.$IL,NotebookCellStatusBarItem:X.$KL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$qK,NotebookKernelSourceAction:X.$ML,PortAttributes:X.$PL,LinkedEditingRanges:X.$OL,TestResultState:X.TestResultState,TestRunRequest:X.$QL,TestMessage:X.$RL,TestMessage2:X.$RL,TestTag:X.$SL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$_K,DataTransferItem:X.$8K,CoveredCount:X.$TL,FileCoverage:X.$UL,StatementCoverage:X.$VL,BranchCoverage:X.$WL,FunctionCoverage:X.$XL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$ZL,TabInputTextDiff:X.$1L,TabInputTextMerge:X.$2L,TabInputCustom:X.$3L,TabInputNotebook:X.$5L,TabInputNotebookDiff:X.$6L,TabInputWebview:X.$4L,TabInputTerminal:X.$7L,TabInputInteractiveWindow:X.$8L,TelemetryTrustedValue:Ee.$jo,LogLevel:$e.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$oL,ThreadFocus:X.$pL,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus}}}e.$jec=Mt}),define(Ae[276],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,58,61,243,14,112,81,82]),function(we,e,y,M,C,T,A,l,D,f,R,k,a,b,$,g,t,i,c,p,E,v,n,r,s,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$wr)(o.$Ucc,o.$Tcc,1),(0,y.$wr)(r.$$i,n.$kec,1),(0,y.$wr)(g.$hcc,g.$icc,1),(0,y.$wr)(l.$DM,l.$CM,0),(0,y.$wr)(A.$ucc,A.$scc,0),(0,y.$wr)(i.$Jcc,i.$Icc,0),(0,y.$wr)(k.$xdc,k.$Bdc,0),(0,y.$wr)(T.$pdc,T.$odc,0),(0,y.$wr)(D.$sM,D.$rM,0),(0,y.$wr)(w.$Vcc,w.$Wcc,0),(0,y.$wr)(c.$ecc,c.$dcc,0),(0,y.$wr)(M.$8cc,M.$7cc,1),(0,y.$wr)(a.$Hdc,a.$Idc,0),(0,y.$wr)(b.$Fcc,b.$Ecc,0),(0,y.$wr)(R.$sdc,R.$rdc,0),(0,y.$wr)(f.$Mcc,f.$Pcc,0),(0,y.$wr)($.$5vb,$.$6vb,0),(0,y.$wr)(t.$ldc,t.$kdc,0),(0,y.$wr)(C.$rcc,C.$qcc,0),(0,y.$wr)(p.$Rcc,p.$Qcc,0),(0,y.$wr)(E.$BM,E.$yM,0),(0,y.$wr)(v.$tdc,v.$udc,0),(0,y.$wr)(s.$vdc,s.$wdc,0)}),define(Ae[277],Re([1,0,275,35,2,272,7,12,263]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class f extends T.$nec{j(){}getModule(b,$){for(const g of this.b){const t=g(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$Ycc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$sgc);const b=this.h.invokeFunction(y.$jec);this.r=this.h.createInstance(f,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,$,g){$=$.with({path:k($.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri($)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const p=await c.text(),E=`${$.toString(!0)}#vscode-extension`,v=`${p}
//# sourceURL=${E}`;let n;try{n=new Function("module","exports","require",v)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${$.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const r={},s={exports:r},o=w=>{const d=this.r.getModule(w,$);if(d===void 0)throw new Error(`Cannot load module '${w}'`);return d};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,r,o),s.exports!==r?s.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+b;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Ug)(10)}}e.$tgc=R;function k(a,b){return a.endsWith(b)?a:a+b}}),define(Ae[278],Re([1,0,69,70,14,35,187,85,277]),function(we,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$wr)(C.$0i,new y.$Mh(A.$mec,[!0],!0)),(0,M.$wr)(T.$Zcc,D.$tgc,0),(0,M.$wr)(l.$Kcc,l.$Lcc,0)}),define(Ae[287],Re([1,0,26,5,79,273,265,20,87,13,2,276,278]),function(we,e,y,M,C,T,A,l,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const $=fetch.bind(self);function g(n){self.fetch=async function(r,s){return r instanceof Request||b(String(r))&&(r=(await n(R.URI.parse(String(r)))).toString(!0)),$(r,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,s,o,w,d){(async()=>(b(s.toString())&&(s=(await n(R.URI.parse(s.toString()))).toString(!0)),super.open(r,s,o??!0,w,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,s){if(/^file:/i.test(r.toString()))r=f.$cg.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(u){function m(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const h=fetch.bind(self);self.fetch=function(B,z){return B instanceof Request?h(B,z):h(m(B),z)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,z,j,V,N){return super.open(B,m(z),j??!0,V,N)}};const P=importScripts.bind(self);self.importScripts=(...B)=>{P(...B.map(m))},P(u)}.toString()}('${r}'))`;s=s||{},s.name=s.name||l.$nc(r.toString());const d=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(d);return new n(I,s)}}else self.Worker=class extends A.$ugc{constructor(n,r){super(a,n,{name:l.$nc(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class i{constructor(){const r=new MessageChannel,s=new M.$Nd;let o=!1;a(r.port2,[r.port2]),r.port1.onmessage=w=>{const{data:d}=w;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const I=y.$be.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$cm)(I,2)){o=!0,p("received terminate message from renderer");return}s.fire(I)},this.protocol={onMessage:s.event,send:w=>{if(!o){const d=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);r.port1.postMessage(d,[d])}}}}}function c(n){return new Promise(r=>{const s=n.onMessage(o=>{s.dispose();const w=JSON.parse(o.toString());n.send((0,C.$bm)(0)),r({protocol:n,initData:w})});n.send((0,C.$bm)(1))})}let p=n=>k();function E(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function v(){D.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(r){E(r)&&c(n.protocol).then(s=>{D.mark("code/extHost/didWaitForInitData");const o=new T.$pec(s.protocol,s.initData,t,null,r.data);g(w=>o.asBrowserUri(w)),p=w=>o.terminate(w)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f1c3b1dcf85e3b6ddb24b7dce0e4b122e8ce6233/core/vs/workbench/api/worker/extensionHostWorker.js.map
